/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["require","exports","vs/base/common/platform","vs/base/common/path","vs/base/common/charCode","vs/base/common/errors","vs/base/common/extpath","vs/base/common/strings","vs/base/common/uri","vs/base/common/async","vs/base/common/functional","vs/base/common/lazy","vs/base/common/map","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/cancellation","vs/base/common/process","vs/base/common/resources","fs","os","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/arrays","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/symbols","vs/base/common/types","vs/base/common/uint","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/server/node/server.cli","vs/base/common/network","vs/base/node/pfs","vs/base/node/terminalEncoding","child_process","vs/nls!vs/platform/environment/node/argv","vs/platform/environment/node/argv","vs/platform/environment/node/stdin","vs/platform/environment/node/wait","util","minimist","vs/server/node/server.cli","url","http"],pe=function(le){for(var e=[],f=0,t=le.length;f<t;f++)e[f]=Ee[le[f]];return e};define(Ee[20],pe([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=f,e.findLastIdx=t,e.findLastMonotonous=w,e.findLastIdxMonotonous=T,e.findFirstMonotonous=ie,e.findFirstIdxMonotonousOrArrLen=Q,e.findFirstIdxMonotonous=B,e.findFirstMax=j,e.findLastMax=x,e.findFirstMin=W,e.findMaxIdx=te,e.mapFindFirst=M;function f(l,h){const v=t(l,h);if(v!==-1)return l[v]}function t(l,h,v=l.length-1){for(let F=v;F>=0;F--){const z=l[F];if(h(z))return F}return-1}function w(l,h){const v=T(l,h);return v===-1?void 0:l[v]}function T(l,h,v=0,F=l.length){let z=v,ne=F;for(;z<ne;){const O=Math.floor((z+ne)/2);h(l[O])?z=O+1:ne=O}return z-1}function ie(l,h){const v=Q(l,h);return v===l.length?void 0:l[v]}function Q(l,h,v=0,F=l.length){let z=v,ne=F;for(;z<ne;){const O=Math.floor((z+ne)/2);h(l[O])?ne=O:z=O+1}return z}function B(l,h,v=0,F=l.length){const z=Q(l,h,v,F);return z===l.length?-1:z}class I{static{this.assertInvariants=!1}constructor(h){this._array=h,this._findLastMonotonousLastIdx=0}findLastMonotonous(h){if(I.assertInvariants){if(this._prevFindLastPredicate){for(const F of this._array)if(this._prevFindLastPredicate(F)&&!h(F))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=h}const v=T(this._array,h,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=v+1,v===-1?void 0:this._array[v]}}e.MonotonousArray=I;function j(l,h){if(l.length===0)return;let v=l[0];for(let F=1;F<l.length;F++){const z=l[F];h(z,v)>0&&(v=z)}return v}function x(l,h){if(l.length===0)return;let v=l[0];for(let F=1;F<l.length;F++){const z=l[F];h(z,v)>=0&&(v=z)}return v}function W(l,h){return j(l,(v,F)=>-h(v,F))}function te(l,h){if(l.length===0)return-1;let v=0;for(let F=1;F<l.length;F++){const z=l[F];h(z,l[v])>0&&(v=F)}return v}function M(l,h){for(const v of l){const F=h(v);if(F!==void 0)return F}}}),define(Ee[4],pe([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var f;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(f||(e.CharCode=f={}))}),define(Ee[21],pe([0,1]),function(le,e){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.SetWithKey=void 0,e.groupBy=t,e.diffSets=w,e.diffMaps=T,e.intersection=ie;function t(B,I){const j=Object.create(null);for(const x of B){const W=I(x);let te=j[W];te||(te=j[W]=[]),te.push(x)}return j}function w(B,I){const j=[],x=[];for(const W of B)I.has(W)||j.push(W);for(const W of I)B.has(W)||x.push(W);return{removed:j,added:x}}function T(B,I){const j=[],x=[];for(const[W,te]of B)I.has(W)||j.push(te);for(const[W,te]of I)B.has(W)||x.push(te);return{removed:j,added:x}}function ie(B,I){const j=new Set;for(const x of I)B.has(x)&&j.add(x);return j}class Q{static{f=Symbol.toStringTag}constructor(I,j){this.toKey=j,this._map=new Map,this[f]="SetWithKey";for(const x of I)this.add(x)}get size(){return this._map.size}add(I){const j=this.toKey(I);return this._map.set(j,I),this}delete(I){return this._map.delete(this.toKey(I))}has(I){return this._map.has(this.toKey(I))}*entries(){for(const I of this._map.values())yield[I,I]}keys(){return this.values()}*values(){for(const I of this._map.values())yield I}clear(){this._map.clear()}forEach(I,j){this._map.forEach(x=>I.call(j,x,x,this))}[Symbol.iterator](){return this.values()}}e.SetWithKey=Q}),define(Ee[5],pe([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=t,e.isSigPipeError=w,e.onUnexpectedError=T,e.onUnexpectedExternalError=ie,e.transformErrorForSerialization=Q,e.transformErrorFromSerialization=B,e.isCancellationError=j,e.canceled=W,e.illegalArgument=te,e.illegalState=M,e.getErrorMessage=h;class f{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?ne.isErrorNoTelemetry(i)?new ne(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(u=>{u(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=f,e.errorHandler=new f;function t(n){e.errorHandler.setUnexpectedErrorHandler(n)}function w(n){if(!n||typeof n!="object")return!1;const i=n;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function T(n){j(n)||e.errorHandler.onUnexpectedError(n)}function ie(n){j(n)||e.errorHandler.onUnexpectedExternalError(n)}function Q(n){if(n instanceof Error){const{name:i,message:u}=n,_=n.stacktrace||n.stack;return{$isError:!0,name:i,message:u,stack:_,noTelemetry:ne.isErrorNoTelemetry(n)}}return n}function B(n){let i;return n.noTelemetry?i=new ne:(i=new Error,i.name=n.name),i.message=n.message,i.stack=n.stack,i}const I="Canceled";function j(n){return n instanceof x?!0:n instanceof Error&&n.name===I&&n.message===I}class x extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=x;function W(){const n=new Error(I);return n.name=n.message,n}function te(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}function M(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}class l extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=l;function h(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}class v extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=v;class F extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=F;class z extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=z;class ne extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof ne)return i;const u=new ne;return u.message=i.message,u.stack=i.stack,u}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=ne;class O extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,O.prototype)}}e.BugIndicatingError=O}),define(Ee[22],pe([0,1,5,20]),function(le,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=w,e.tail2=T,e.equals=ie,e.removeFastWithoutKeepingOrder=Q,e.binarySearch=B,e.binarySearch2=I,e.quickSelect=j,e.groupBy=x,e.groupAdjacentBy=W,e.forEachAdjacent=te,e.forEachWithNeighbors=M,e.sortedDiff=l,e.delta=h,e.top=v,e.topAsync=F,e.coalesce=ne,e.coalesceInPlace=O,e.move=n,e.isFalsyOrEmpty=i,e.isNonEmptyArray=u,e.distinct=_,e.uniqueFilter=A,e.firstOrDefault=c,e.lastOrDefault=d,e.commonPrefixLength=s,e.range=m,e.index=R,e.insert=U,e.remove=a,e.arrayInsert=q,e.shuffle=H,e.pushToStart=K,e.pushToEnd=S,e.pushMany=J,e.mapArrayOrNot=P,e.asArray=y,e.getRandomElement=G,e.insertInto=V,e.splice=Z,e.compareBy=ge,e.tieBreakComparators=ye,e.reverseOrder=ce;function w(p,L=0){return p[p.length-(1+L)]}function T(p){if(p.length===0)throw new Error("Invalid tail call");return[p.slice(0,p.length-1),p[p.length-1]]}function ie(p,L,D=(g,r)=>g===r){if(p===L)return!0;if(!p||!L||p.length!==L.length)return!1;for(let g=0,r=p.length;g<r;g++)if(!D(p[g],L[g]))return!1;return!0}function Q(p,L){const D=p.length-1;L<D&&(p[L]=p[D]),p.pop()}function B(p,L,D){return I(p.length,g=>D(p[g],L))}function I(p,L){let D=0,g=p-1;for(;D<=g;){const r=(D+g)/2|0,b=L(r);if(b<0)D=r+1;else if(b>0)g=r-1;else return r}return-(D+1)}function j(p,L,D){if(p=p|0,p>=L.length)throw new TypeError("invalid index");const g=L[Math.floor(L.length*Math.random())],r=[],b=[],N=[];for(const $ of L){const oe=D($,g);oe<0?r.push($):oe>0?b.push($):N.push($)}return p<r.length?j(p,r,D):p<r.length+N.length?N[0]:j(p-(r.length+N.length),b,D)}function x(p,L){const D=[];let g;for(const r of p.slice(0).sort(L))!g||L(g[0],r)!==0?(g=[r],D.push(g)):g.push(r);return D}function*W(p,L){let D,g;for(const r of p)g!==void 0&&L(g,r)?D.push(r):(D&&(yield D),D=[r]),g=r;D&&(yield D)}function te(p,L){for(let D=0;D<=p.length;D++)L(D===0?void 0:p[D-1],D===p.length?void 0:p[D])}function M(p,L){for(let D=0;D<p.length;D++)L(D===0?void 0:p[D-1],p[D],D+1===p.length?void 0:p[D+1])}function l(p,L,D){const g=[];function r($,oe,ve){if(oe===0&&ve.length===0)return;const ee=g[g.length-1];ee&&ee.start+ee.deleteCount===$?(ee.deleteCount+=oe,ee.toInsert.push(...ve)):g.push({start:$,deleteCount:oe,toInsert:ve})}let b=0,N=0;for(;;){if(b===p.length){r(b,0,L.slice(N));break}if(N===L.length){r(b,p.length-b,[]);break}const $=p[b],oe=L[N],ve=D($,oe);ve===0?(b+=1,N+=1):ve<0?(r(b,1,[]),b+=1):ve>0&&(r(b,0,[oe]),N+=1)}return g}function h(p,L,D){const g=l(p,L,D),r=[],b=[];for(const N of g)r.push(...p.slice(N.start,N.start+N.deleteCount)),b.push(...N.toInsert);return{removed:r,added:b}}function v(p,L,D){if(D===0)return[];const g=p.slice(0,D).sort(L);return z(p,L,g,D,p.length),g}function F(p,L,D,g,r){return D===0?Promise.resolve([]):new Promise((b,N)=>{(async()=>{const $=p.length,oe=p.slice(0,D).sort(L);for(let ve=D,ee=Math.min(D+g,$);ve<$;ve=ee,ee=Math.min(ee+g,$)){if(ve>D&&await new Promise(C=>setTimeout(C)),r&&r.isCancellationRequested)throw new f.CancellationError;z(p,L,oe,ve,ee)}return oe})().then(b,N)})}function z(p,L,D,g,r){for(const b=D.length;g<r;g++){const N=p[g];if(L(N,D[b-1])<0){D.pop();const $=(0,t.findFirstIdxMonotonousOrArrLen)(D,oe=>L(N,oe)<0);D.splice($,0,N)}}}function ne(p){return p.filter(L=>!!L)}function O(p){let L=0;for(let D=0;D<p.length;D++)p[D]&&(p[L]=p[D],L+=1);p.length=L}function n(p,L,D){p.splice(D,0,p.splice(L,1)[0])}function i(p){return!Array.isArray(p)||p.length===0}function u(p){return Array.isArray(p)&&p.length>0}function _(p,L=D=>D){const D=new Set;return p.filter(g=>{const r=L(g);return D.has(r)?!1:(D.add(r),!0)})}function A(p){const L=new Set;return D=>{const g=p(D);return L.has(g)?!1:(L.add(g),!0)}}function c(p,L){return p.length>0?p[0]:L}function d(p,L){return p.length>0?p[p.length-1]:L}function s(p,L,D=(g,r)=>g===r){let g=0;for(let r=0,b=Math.min(p.length,L.length);r<b&&D(p[r],L[r]);r++)g++;return g}function m(p,L){let D=typeof L=="number"?p:0;typeof L=="number"?D=p:(D=0,L=p);const g=[];if(D<=L)for(let r=D;r<L;r++)g.push(r);else for(let r=D;r>L;r--)g.push(r);return g}function R(p,L,D){return p.reduce((g,r)=>(g[L(r)]=D?D(r):r,g),Object.create(null))}function U(p,L){return p.push(L),()=>a(p,L)}function a(p,L){const D=p.indexOf(L);if(D>-1)return p.splice(D,1),L}function q(p,L,D){const g=p.slice(0,L),r=p.slice(L);return g.concat(D,r)}function H(p,L){let D;if(typeof L=="number"){let g=L;D=()=>{const r=Math.sin(g++)*179426549;return r-Math.floor(r)}}else D=Math.random;for(let g=p.length-1;g>0;g-=1){const r=Math.floor(D()*(g+1)),b=p[g];p[g]=p[r],p[r]=b}}function K(p,L){const D=p.indexOf(L);D>-1&&(p.splice(D,1),p.unshift(L))}function S(p,L){const D=p.indexOf(L);D>-1&&(p.splice(D,1),p.push(L))}function J(p,L){for(const D of L)p.push(D)}function P(p,L){return Array.isArray(p)?p.map(L):L(p)}function y(p){return Array.isArray(p)?p:[p]}function G(p){return p[Math.floor(Math.random()*p.length)]}function V(p,L,D){const g=Y(p,L),r=p.length,b=D.length;p.length=r+b;for(let N=r-1;N>=g;N--)p[N+b]=p[N];for(let N=0;N<b;N++)p[N+g]=D[N]}function Z(p,L,D,g){const r=Y(p,L);let b=p.splice(r,D);return b===void 0&&(b=[]),V(p,r,g),b}function Y(p,L){return L<0?Math.max(L+p.length,0):Math.min(L,p.length)}var se;(function(p){function L(b){return b<0}p.isLessThan=L;function D(b){return b<=0}p.isLessThanOrEqual=D;function g(b){return b>0}p.isGreaterThan=g;function r(b){return b===0}p.isNeitherLessOrGreaterThan=r,p.greaterThan=1,p.lessThan=-1,p.neitherLessOrGreaterThan=0})(se||(e.CompareResult=se={}));function ge(p,L){return(D,g)=>L(p(D),p(g))}function ye(...p){return(L,D)=>{for(const g of p){const r=g(L,D);if(!se.isNeitherLessOrGreaterThan(r))return r}return se.neitherLessOrGreaterThan}}const Le=(p,L)=>p-L;e.numberComparator=Le;const Ie=(p,L)=>(0,e.numberComparator)(p?1:0,L?1:0);e.booleanComparator=Ie;function ce(p){return(L,D)=>-p(L,D)}class we{constructor(L){this.items=L,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(L){let D=this.firstIdx;for(;D<this.items.length&&L(this.items[D]);)D++;const g=D===this.firstIdx?null:this.items.slice(this.firstIdx,D);return this.firstIdx=D,g}takeFromEndWhile(L){let D=this.lastIdx;for(;D>=0&&L(this.items[D]);)D--;const g=D===this.lastIdx?null:this.items.slice(D+1,this.lastIdx+1);return this.lastIdx=D,g}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const L=this.items[this.firstIdx];return this.firstIdx++,L}removeLast(){const L=this.items[this.lastIdx];return this.lastIdx--,L}takeCount(L){const D=this.items.slice(this.firstIdx,this.firstIdx+L);return this.firstIdx+=L,D}}e.ArrayQueue=we;class _e{static{this.empty=new _e(L=>{})}constructor(L){this.iterate=L}forEach(L){this.iterate(D=>(L(D),!0))}toArray(){const L=[];return this.iterate(D=>(L.push(D),!0)),L}filter(L){return new _e(D=>this.iterate(g=>L(g)?D(g):!0))}map(L){return new _e(D=>this.iterate(g=>D(L(g))))}some(L){let D=!1;return this.iterate(g=>(D=L(g),!D)),D}findFirst(L){let D;return this.iterate(g=>L(g)?(D=g,!1):!0),D}findLast(L){let D;return this.iterate(g=>(L(g)&&(D=g),!0)),D}findLastMaxBy(L){let D,g=!0;return this.iterate(r=>((g||se.isGreaterThan(L(r,D)))&&(g=!1,D=r),!0)),D}}e.CallbackIterable=_e;class be{constructor(L){this._indexMap=L}static createSortPermutation(L,D){const g=Array.from(L.keys()).sort((r,b)=>D(L[r],L[b]));return new be(g)}apply(L){return L.map((D,g)=>L[this._indexMap[g]])}inverse(){const L=this._indexMap.slice();for(let D=0;D<this._indexMap.length;D++)L[this._indexMap[D]]=D;return new be(L)}}e.Permutation=be}),define(Ee[10],pe([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=f;function f(t,w){const T=this;let ie=!1,Q;return function(){if(ie)return Q;if(ie=!0,w)try{Q=t.apply(T,arguments)}finally{w()}else Q=t.apply(T,arguments);return Q}}}),define(Ee[23],pe([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var f;(function(t){function w(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}t.is=w;const T=Object.freeze([]);function ie(){return T}t.empty=ie;function*Q(i){yield i}t.single=Q;function B(i){return w(i)?i:Q(i)}t.wrap=B;function I(i){return i||T}t.from=I;function*j(i){for(let u=i.length-1;u>=0;u--)yield i[u]}t.reverse=j;function x(i){return!i||i[Symbol.iterator]().next().done===!0}t.isEmpty=x;function W(i){return i[Symbol.iterator]().next().value}t.first=W;function te(i,u){let _=0;for(const A of i)if(u(A,_++))return!0;return!1}t.some=te;function M(i,u){for(const _ of i)if(u(_))return _}t.find=M;function*l(i,u){for(const _ of i)u(_)&&(yield _)}t.filter=l;function*h(i,u){let _=0;for(const A of i)yield u(A,_++)}t.map=h;function*v(i,u){let _=0;for(const A of i)yield*u(A,_++)}t.flatMap=v;function*F(...i){for(const u of i)yield*u}t.concat=F;function z(i,u,_){let A=_;for(const c of i)A=u(A,c);return A}t.reduce=z;function*ne(i,u,_=i.length){for(u<0&&(u+=i.length),_<0?_+=i.length:_>i.length&&(_=i.length);u<_;u++)yield i[u]}t.slice=ne;function O(i,u=Number.POSITIVE_INFINITY){const _=[];if(u===0)return[_,i];const A=i[Symbol.iterator]();for(let c=0;c<u;c++){const d=A.next();if(d.done)return[_,t.empty()];_.push(d.value)}return[_,{[Symbol.iterator](){return A}}]}t.consume=O;async function n(i){const u=[];for await(const _ of i)u.push(_);return Promise.resolve(u)}t.asyncToArray=n})(f||(e.Iterable=f={}))}),define(Ee[11],pe([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class f{constructor(w){this.executor=w,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(w){this._error=w}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=f}),define(Ee[24],pe([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class f{static{this.Undefined=new f(void 0)}constructor(T){this.element=T,this.next=f.Undefined,this.prev=f.Undefined}}class t{constructor(){this._first=f.Undefined,this._last=f.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===f.Undefined}clear(){let T=this._first;for(;T!==f.Undefined;){const ie=T.next;T.prev=f.Undefined,T.next=f.Undefined,T=ie}this._first=f.Undefined,this._last=f.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,ie){const Q=new f(T);if(this._first===f.Undefined)this._first=Q,this._last=Q;else if(ie){const I=this._last;this._last=Q,Q.prev=I,I.next=Q}else{const I=this._first;this._first=Q,Q.next=I,I.prev=Q}this._size+=1;let B=!1;return()=>{B||(B=!0,this._remove(Q))}}shift(){if(this._first!==f.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==f.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==f.Undefined&&T.next!==f.Undefined){const ie=T.prev;ie.next=T.next,T.next.prev=ie}else T.prev===f.Undefined&&T.next===f.Undefined?(this._first=f.Undefined,this._last=f.Undefined):T.next===f.Undefined?(this._last=this._last.prev,this._last.next=f.Undefined):T.prev===f.Undefined&&(this._first=this._first.next,this._first.prev=f.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==f.Undefined;)yield T.element,T=T.next}}e.LinkedList=t}),define(Ee[12],pe([0,1]),function(le,e){"use strict";var f,t,w;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=T,e.mapToString=ie,e.setToString=Q,e.mapsStrictEqualIgnoreOrder=ne;function T(O,n,i){let u=O.get(n);return u===void 0&&(u=i,O.set(n,u)),u}function ie(O){const n=[];return O.forEach((i,u)=>{n.push(`${u} => ${i}`)}),`Map(${O.size}) {${n.join(", ")}}`}function Q(O){const n=[];return O.forEach(i=>{n.push(i)}),`Set(${O.size}) {${n.join(", ")}}`}class B{constructor(n,i){this.uri=n,this.value=i}}function I(O){return Array.isArray(O)}class j{static{this.defaultToKey=n=>n.toString()}constructor(n,i){if(this[f]="ResourceMap",n instanceof j)this.map=new Map(n.map),this.toKey=i??j.defaultToKey;else if(I(n)){this.map=new Map,this.toKey=i??j.defaultToKey;for(const[u,_]of n)this.set(u,_)}else this.map=new Map,this.toKey=n??j.defaultToKey}set(n,i){return this.map.set(this.toKey(n),new B(n,i)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,i){typeof i<"u"&&(n=n.bind(i));for(const[u,_]of this.map)n(_.value,_.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(f=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=j;class x{constructor(n,i){this[t]="ResourceSet",!n||typeof n=="function"?this._map=new j(n):(this._map=new j(i),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,i){this._map.forEach((u,_)=>n.call(i,_,_,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=x;var W;(function(O){O[O.None=0]="None",O[O.AsOld=1]="AsOld",O[O.AsNew=2]="AsNew"})(W||(e.Touch=W={}));class te{constructor(){this[w]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,i=W.None){const u=this._map.get(n);if(u)return i!==W.None&&this.touch(u,i),u.value}set(n,i,u=W.None){let _=this._map.get(n);if(_)_.value=i,u!==W.None&&this.touch(_,u);else{switch(_={key:n,value:i,next:void 0,previous:void 0},u){case W.None:this.addItemLast(_);break;case W.AsOld:this.addItemFirst(_);break;case W.AsNew:this.addItemLast(_);break;default:this.addItemLast(_);break}this._map.set(n,_),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const i=this._map.get(n);if(i)return this._map.delete(n),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,i){const u=this._state;let _=this._head;for(;_;){if(i?n.bind(i)(_.value,_.key,this):n(_.value,_.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");_=_.next}}keys(){const n=this,i=this._state;let u=this._head;const _={[Symbol.iterator](){return _},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(u){const A={value:u.key,done:!1};return u=u.next,A}else return{value:void 0,done:!0}}};return _}values(){const n=this,i=this._state;let u=this._head;const _={[Symbol.iterator](){return _},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(u){const A={value:u.value,done:!1};return u=u.next,A}else return{value:void 0,done:!0}}};return _}entries(){const n=this,i=this._state;let u=this._head;const _={[Symbol.iterator](){return _},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(u){const A={value:[u.key,u.value],done:!1};return u=u.next,A}else return{value:void 0,done:!0}}};return _}[(w=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this._head,u=this.size;for(;i&&u>n;)this._map.delete(i.key),i=i.next,u--;this._head=i,this._size=u,i&&(i.previous=void 0),this._state++}trimNew(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this._tail,u=this.size;for(;i&&u>n;)this._map.delete(i.key),i=i.previous,u--;this._tail=i,this._size=u,i&&(i.next=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const i=n.next,u=n.previous;if(!i||!u)throw new Error("Invalid list");i.previous=u,u.next=i}n.next=void 0,n.previous=void 0,this._state++}touch(n,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==W.AsOld&&i!==W.AsNew)){if(i===W.AsOld){if(n===this._head)return;const u=n.next,_=n.previous;n===this._tail?(_.next=void 0,this._tail=_):(u.previous=_,_.next=u),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(i===W.AsNew){if(n===this._tail)return;const u=n.next,_=n.previous;n===this._head?(u.previous=void 0,this._head=u):(u.previous=_,_.next=u),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((i,u)=>{n.push([u,i])}),n}fromJSON(n){this.clear();for(const[i,u]of n)this.set(i,u)}}e.LinkedMap=te;class M extends te{constructor(n,i=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,i=W.AsNew){return super.get(n,i)}peek(n){return super.get(n,W.None)}set(n,i){return super.set(n,i,W.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class l extends M{constructor(n,i=1){super(n,i)}trim(n){this.trimOld(n)}set(n,i){return super.set(n,i),this.checkTrim(),this}}e.LRUCache=l;class h extends M{constructor(n,i=1){super(n,i)}trim(n){this.trimNew(n)}set(n,i){return this._limit<=this.size&&!this.has(n)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(n,i),this}}e.MRUCache=h;class v{constructor(){this.map=new Map}add(n){return this.map.set(n,(this.map.get(n)||0)+1),this}delete(n){let i=this.map.get(n)||0;return i===0?!1:(i--,i===0?this.map.delete(n):this.map.set(n,i),!0)}has(n){return this.map.has(n)}}e.CounterSet=v;class F{constructor(n){if(this._m1=new Map,this._m2=new Map,n)for(const[i,u]of n)this.set(i,u)}clear(){this._m1.clear(),this._m2.clear()}set(n,i){this._m1.set(n,i),this._m2.set(i,n)}get(n){return this._m1.get(n)}getKey(n){return this._m2.get(n)}delete(n){const i=this._m1.get(n);return i===void 0?!1:(this._m1.delete(n),this._m2.delete(i),!0)}forEach(n,i){this._m1.forEach((u,_)=>{n.call(i,u,_,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=F;class z{constructor(){this.map=new Map}add(n,i){let u=this.map.get(n);u||(u=new Set,this.map.set(n,u)),u.add(i)}delete(n,i){const u=this.map.get(n);u&&(u.delete(i),u.size===0&&this.map.delete(n))}forEach(n,i){const u=this.map.get(n);u&&u.forEach(i)}get(n){const i=this.map.get(n);return i||new Set}}e.SetMap=z;function ne(O,n){if(O===n)return!0;if(O.size!==n.size)return!1;for(const[i,u]of O)if(!n.has(i)||n.get(i)!==u)return!1;for(const[i]of n)if(!O.has(i))return!1;return!0}}),define(Ee[13],pe([0,1,22,21,12,10,23]),function(le,e,f,t,w,T,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=j,e.trackDisposable=x,e.markAsDisposed=W,e.markAsSingleton=l,e.isDisposable=h,e.dispose=v,e.disposeIfDisposable=F,e.combinedDisposable=z,e.toDisposable=ne,e.disposeOnReturn=m;const Q=!1;let B=null;class I{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(a){let q=this.livingDisposables.get(a);return q||(q={parent:null,source:null,isSingleton:!1,value:a,idx:I.idx++},this.livingDisposables.set(a,q)),q}trackDisposable(a){const q=this.getDisposableData(a);q.source||(q.source=new Error().stack)}setParent(a,q){const H=this.getDisposableData(a);H.parent=q}markAsDisposed(a){this.livingDisposables.delete(a)}markAsSingleton(a){this.getDisposableData(a).isSingleton=!0}getRootParent(a,q){const H=q.get(a);if(H)return H;const K=a.parent?this.getRootParent(this.getDisposableData(a.parent),q):a;return q.set(a,K),K}getTrackedDisposables(){const a=new Map;return[...this.livingDisposables.entries()].filter(([,H])=>H.source!==null&&!this.getRootParent(H,a).isSingleton).flatMap(([H])=>H)}computeLeakingDisposables(a=10,q){let H;if(q)H=q;else{const y=new Map,G=[...this.livingDisposables.values()].filter(Z=>Z.source!==null&&!this.getRootParent(Z,y).isSingleton);if(G.length===0)return;const V=new Set(G.map(Z=>Z.value));if(H=G.filter(Z=>!(Z.parent&&V.has(Z.parent))),H.length===0)throw new Error("There are cyclic diposable chains!")}if(!H)return;function K(y){function G(Z,Y){for(;Z.length>0&&Y.some(se=>typeof se=="string"?se===Z[0]:Z[0].match(se));)Z.shift()}const V=y.source.split(`
`).map(Z=>Z.trim().replace("at ","")).filter(Z=>Z!=="");return G(V,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),V.reverse()}const S=new w.SetMap;for(const y of H){const G=K(y);for(let V=0;V<=G.length;V++)S.add(G.slice(0,V).join(`
`),y)}H.sort((0,f.compareBy)(y=>y.idx,f.numberComparator));let J="",P=0;for(const y of H.slice(0,a)){P++;const G=K(y),V=[];for(let Z=0;Z<G.length;Z++){let Y=G[Z];Y=`(shared with ${S.get(G.slice(0,Z+1).join(`
`)).size}/${H.length} leaks) at ${Y}`;const ge=S.get(G.slice(0,Z).join(`
`)),ye=(0,t.groupBy)([...ge].map(Le=>K(Le)[Z]),Le=>Le);delete ye[G[Z]];for(const[Le,Ie]of Object.entries(ye))V.unshift(`    - stacktraces of ${Ie.length} other leaks continue with ${Le}`);V.unshift(Y)}J+=`


==================== Leaking disposable ${P}/${H.length}: ${y.value.constructor.name} ====================
${V.join(`
`)}
============================================================

`}return H.length>a&&(J+=`


... and ${H.length-a} more leaking disposables

`),{leaks:H,details:J}}}e.DisposableTracker=I;function j(U){B=U}if(Q){const U="__is_disposable_tracked__";j(new class{trackDisposable(a){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[U]||console.log(q)},3e3)}setParent(a,q){if(a&&a!==n.None)try{a[U]=!0}catch{}}markAsDisposed(a){if(a&&a!==n.None)try{a[U]=!0}catch{}}markAsSingleton(a){}})}function x(U){return B?.trackDisposable(U),U}function W(U){B?.markAsDisposed(U)}function te(U,a){B?.setParent(U,a)}function M(U,a){if(B)for(const q of U)B.setParent(q,a)}function l(U){return B?.markAsSingleton(U),U}function h(U){return typeof U=="object"&&U!==null&&typeof U.dispose=="function"&&U.dispose.length===0}function v(U){if(ie.Iterable.is(U)){const a=[];for(const q of U)if(q)try{q.dispose()}catch(H){a.push(H)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(U)?[]:U}else if(U)return U.dispose(),U}function F(U){for(const a of U)h(a)&&a.dispose();return[]}function z(...U){const a=ne(()=>v(U));return M(U,a),a}function ne(U){const a=x({dispose:(0,T.createSingleCallFunction)(()=>{W(a),U()})});return a}class O{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,x(this)}dispose(){this._isDisposed||(W(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{v(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return te(a,this),this._isDisposed?O.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}delete(a){if(a){if(a===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(a),a.dispose()}}deleteAndLeak(a){a&&this._toDispose.has(a)&&(this._toDispose.delete(a),te(a,null))}}e.DisposableStore=O;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new O,x(this),te(this._store,this)}dispose(){W(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=n;class i{constructor(){this._isDisposed=!1,x(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&te(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,W(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&te(a,null),a}}e.MutableDisposable=i;class u{constructor(a){this._disposable=new i,this._isDisposed=!1,this._disposable.value=a}get value(){return this._disposable.value}set value(a){this._isDisposed||a===this._disposable.value||(this._disposable.value=a)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=u;class _{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=_;class A{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,x(this)}set(a){let q=a;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,W(this))},this}}e.SafeDisposable=A;class c{constructor(){this.references=new Map}acquire(a,...q){let H=this.references.get(a);H||(H={counter:0,object:this.createReferencedObject(a,...q)},this.references.set(a,H));const{object:K}=H,S=(0,T.createSingleCallFunction)(()=>{--H.counter===0&&(this.destroyReferencedObject(a,H.object),this.references.delete(a))});return H.counter++,{object:K,dispose:S}}}e.ReferenceCollection=c;class d{constructor(a){this.referenceCollection=a}async acquire(a,...q){const H=this.referenceCollection.acquire(a,...q);try{return{object:await H.object,dispose:()=>H.dispose()}}catch(K){throw H.dispose(),K}}}e.AsyncReferenceCollection=d;class s{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=s;function m(U){const a=new O;try{U(a)}finally{a.dispose()}}class R{constructor(){this._store=new Map,this._isDisposed=!1,x(this)}dispose(){W(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{v(this._store.values())}finally{this._store.clear()}}has(a){return this._store.has(a)}get size(){return this._store.size}get(a){return this._store.get(a)}set(a,q,H=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),H||this._store.get(a)?.dispose(),this._store.set(a,q)}deleteAndDispose(a){this._store.get(a)?.dispose(),this._store.delete(a)}deleteAndLeak(a){const q=this._store.get(a);return this._store.delete(a),q}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=R}),define(Ee[25],pe([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var f;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(f||(e.MarshalledId=f={}))}),define(Ee[26],pe([0,1,12]),function(le,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=w,e.normalizeNFD=ie;const t=new f.LRUCache(1e4);function w(I){return B(I,"NFC",t)}const T=new f.LRUCache(1e4);function ie(I){return B(I,"NFD",T)}const Q=/[^\u0000-\u0080]/;function B(I,j,x){if(!I)return I;const W=x.get(I);if(W)return W;let te;return Q.test(I)?te=I.normalize(j):te=I,x.set(I,te),te}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(j){return ie(j).replace(I,"")}}()}),define(Ee[27],pe([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const f=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(T){return new t(T)}constructor(T){this._now=f&&T===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=t}),define(Ee[14],pe([0,1,5,10,13,24,27]),function(le,e,f,t,w,T,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.ListenerRefusalError=e.ListenerLeakError=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=te;const Q=!1,B=!1,I=!1;var j;(function(K){K.None=()=>w.Disposable.None;function S(ee){if(I){const{onDidAddListener:C}=ee,ae=l.create();let re=0;ee.onDidAddListener=()=>{++re===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ae.print()),C?.()}}}function J(ee,C){return Le(ee,()=>{},0,void 0,!0,void 0,C)}K.defer=J;function P(ee){return(C,ae=null,re)=>{let fe=!1,he;return he=ee(Ae=>{if(!fe)return he?he.dispose():fe=!0,C.call(ae,Ae)},null,re),fe&&he.dispose(),he}}K.once=P;function y(ee,C,ae){return ge((re,fe=null,he)=>ee(Ae=>re.call(fe,C(Ae)),null,he),ae)}K.map=y;function G(ee,C,ae){return ge((re,fe=null,he)=>ee(Ae=>{C(Ae),re.call(fe,Ae)},null,he),ae)}K.forEach=G;function V(ee,C,ae){return ge((re,fe=null,he)=>ee(Ae=>C(Ae)&&re.call(fe,Ae),null,he),ae)}K.filter=V;function Z(ee){return ee}K.signal=Z;function Y(...ee){return(C,ae=null,re)=>{const fe=(0,w.combinedDisposable)(...ee.map(he=>he(Ae=>C.call(ae,Ae))));return ye(fe,re)}}K.any=Y;function se(ee,C,ae,re){let fe=ae;return y(ee,he=>(fe=C(fe,he),fe),re)}K.reduce=se;function ge(ee,C){let ae;const re={onWillAddFirstListener(){ae=ee(fe.fire,fe)},onDidRemoveLastListener(){ae?.dispose()}};C||S(re);const fe=new i(re);return C?.add(fe),fe.event}function ye(ee,C){return C instanceof Array?C.push(ee):C&&C.add(ee),ee}function Le(ee,C,ae=100,re=!1,fe=!1,he,Ae){let Re,De,Be,We=0,de;const Se={leakWarningThreshold:he,onWillAddFirstListener(){Re=ee(Ge=>{We++,De=C(De,Ge),re&&!Be&&(qe.fire(De),De=void 0),de=()=>{const Ke=De;De=void 0,Be=void 0,(!re||We>1)&&qe.fire(Ke),We=0},typeof ae=="number"?(clearTimeout(Be),Be=setTimeout(de,ae)):Be===void 0&&(Be=0,queueMicrotask(de))})},onWillRemoveListener(){fe&&We>0&&de?.()},onDidRemoveLastListener(){de=void 0,Re.dispose()}};Ae||S(Se);const qe=new i(Se);return Ae?.add(qe),qe.event}K.debounce=Le;function Ie(ee,C=0,ae){return K.debounce(ee,(re,fe)=>re?(re.push(fe),re):[fe],C,void 0,!0,void 0,ae)}K.accumulate=Ie;function ce(ee,C=(re,fe)=>re===fe,ae){let re=!0,fe;return V(ee,he=>{const Ae=re||!C(he,fe);return re=!1,fe=he,Ae},ae)}K.latch=ce;function we(ee,C,ae){return[K.filter(ee,C,ae),K.filter(ee,re=>!C(re),ae)]}K.split=we;function _e(ee,C=!1,ae=[],re){let fe=ae.slice(),he=ee(De=>{fe?fe.push(De):Re.fire(De)});re&&re.add(he);const Ae=()=>{fe?.forEach(De=>Re.fire(De)),fe=null},Re=new i({onWillAddFirstListener(){he||(he=ee(De=>Re.fire(De)),re&&re.add(he))},onDidAddFirstListener(){fe&&(C?setTimeout(Ae):Ae())},onDidRemoveLastListener(){he&&he.dispose(),he=null}});return re&&re.add(Re),Re.event}K.buffer=_e;function be(ee,C){return(re,fe,he)=>{const Ae=C(new L);return ee(function(Re){const De=Ae.evaluate(Re);De!==p&&re.call(fe,De)},void 0,he)}}K.chain=be;const p=Symbol("HaltChainable");class L{constructor(){this.steps=[]}map(C){return this.steps.push(C),this}forEach(C){return this.steps.push(ae=>(C(ae),ae)),this}filter(C){return this.steps.push(ae=>C(ae)?ae:p),this}reduce(C,ae){let re=ae;return this.steps.push(fe=>(re=C(re,fe),re)),this}latch(C=(ae,re)=>ae===re){let ae=!0,re;return this.steps.push(fe=>{const he=ae||!C(fe,re);return ae=!1,re=fe,he?fe:p}),this}evaluate(C){for(const ae of this.steps)if(C=ae(C),C===p)break;return C}}function D(ee,C,ae=re=>re){const re=(...Re)=>Ae.fire(ae(...Re)),fe=()=>ee.on(C,re),he=()=>ee.removeListener(C,re),Ae=new i({onWillAddFirstListener:fe,onDidRemoveLastListener:he});return Ae.event}K.fromNodeEventEmitter=D;function g(ee,C,ae=re=>re){const re=(...Re)=>Ae.fire(ae(...Re)),fe=()=>ee.addEventListener(C,re),he=()=>ee.removeEventListener(C,re),Ae=new i({onWillAddFirstListener:fe,onDidRemoveLastListener:he});return Ae.event}K.fromDOMEventEmitter=g;function r(ee){return new Promise(C=>P(ee)(C))}K.toPromise=r;function b(ee){const C=new i;return ee.then(ae=>{C.fire(ae)},()=>{C.fire(void 0)}).finally(()=>{C.dispose()}),C.event}K.fromPromise=b;function N(ee,C,ae){return C(ae),ee(re=>C(re))}K.runAndSubscribe=N;class ${constructor(C,ae){this._observable=C,this._counter=0,this._hasChanged=!1;const re={onWillAddFirstListener:()=>{C.addObserver(this)},onDidRemoveLastListener:()=>{C.removeObserver(this)}};ae||S(re),this.emitter=new i(re),ae&&ae.add(this.emitter)}beginUpdate(C){this._counter++}handlePossibleChange(C){}handleChange(C,ae){this._hasChanged=!0}endUpdate(C){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function oe(ee,C){return new $(ee,C).emitter.event}K.fromObservable=oe;function ve(ee){return(C,ae,re)=>{let fe=0,he=!1;const Ae={beginUpdate(){fe++},endUpdate(){fe--,fe===0&&(ee.reportChanges(),he&&(he=!1,C.call(ae)))},handlePossibleChange(){},handleChange(){he=!0}};ee.addObserver(Ae),ee.reportChanges();const Re={dispose(){ee.removeObserver(Ae)}};return re instanceof w.DisposableStore?re.add(Re):Array.isArray(re)&&re.push(Re),Re}}K.fromObservableLight=ve})(j||(e.Event=j={}));class x{static{this.all=new Set}static{this._idPool=0}constructor(S){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${S}_${x._idPool++}`,x.all.add(this)}start(S){this._stopWatch=new ie.StopWatch,this.listenerCount=S}stop(){if(this._stopWatch){const S=this._stopWatch.elapsed();this.durations.push(S),this.elapsedOverall+=S,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=x;let W=-1;function te(K){const S=W;return W=K,{dispose(){W=S}}}class M{static{this._idPool=1}constructor(S,J,P=(M._idPool++).toString(16).padStart(3,"0")){this._errorHandler=S,this.threshold=J,this.name=P,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(S,J){const P=this.threshold;if(P<=0||J<P)return;this._stacks||(this._stacks=new Map);const y=this._stacks.get(S.value)||0;if(this._stacks.set(S.value,y+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=P*.5;const[G,V]=this.getMostFrequentStack(),Z=`[${this.name}] potential listener LEAK detected, having ${J} listeners already. MOST frequent listener (${V}):`;console.warn(Z),console.warn(G);const Y=new h(Z,G);this._errorHandler(Y)}return()=>{const G=this._stacks.get(S.value)||0;this._stacks.set(S.value,G-1)}}getMostFrequentStack(){if(!this._stacks)return;let S,J=0;for(const[P,y]of this._stacks)(!S||J<y)&&(S=[P,y],J=y);return S}}class l{static create(){const S=new Error;return new l(S.stack??"")}constructor(S){this.value=S}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h extends Error{constructor(S,J){super(S),this.name="ListenerLeakError",this.stack=J}}e.ListenerLeakError=h;class v extends Error{constructor(S,J){super(S),this.name="ListenerRefusalError",this.stack=J}}e.ListenerRefusalError=v;let F=0;class z{constructor(S){this.value=S,this.id=F++}}const ne=2,O=(K,S)=>{if(K instanceof z)S(K);else for(let J=0;J<K.length;J++){const P=K[J];P&&S(P)}};let n;if(Q){const K=[];setInterval(()=>{K.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(K.join(`
`)),K.length=0)},3e3),n=new FinalizationRegistry(S=>{typeof S=="string"&&K.push(S)})}class i{constructor(S){this._size=0,this._options=S,this._leakageMon=W>0||this._options?.leakWarningThreshold?new M(S?.onListenerError??f.onUnexpectedError,this._options?.leakWarningThreshold??W):void 0,this._perfMon=this._options?._profName?new x(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(B){const S=this._listeners;queueMicrotask(()=>{O(S,J=>J.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(S,J,P)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const Y=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(Y);const se=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],ge=new v(`${Y}. HINT: Stack shows most frequent listener (${se[1]}-times)`,se[0]);return(this._options?.onListenerError||f.onUnexpectedError)(ge),w.Disposable.None}if(this._disposed)return w.Disposable.None;J&&(S=S.bind(J));const y=new z(S);let G,V;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(y.stack=l.create(),G=this._leakageMon.check(y.stack,this._size+1)),B&&(y.stack=V??l.create()),this._listeners?this._listeners instanceof z?(this._deliveryQueue??=new _,this._listeners=[this._listeners,y]):this._listeners.push(y):(this._options?.onWillAddFirstListener?.(this),this._listeners=y,this._options?.onDidAddFirstListener?.(this)),this._size++;const Z=(0,w.toDisposable)(()=>{n?.unregister(Z),G?.(),this._removeListener(y)});if(P instanceof w.DisposableStore?P.add(Z):Array.isArray(P)&&P.push(Z),n){const Y=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),se=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(Y);n.register(Z,se?.[2]??Y,Z)}return Z},this._event}_removeListener(S){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const J=this._listeners,P=J.indexOf(S);if(P===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,J[P]=void 0;const y=this._deliveryQueue.current===this;if(this._size*ne<=J.length){let G=0;for(let V=0;V<J.length;V++)J[V]?J[G++]=J[V]:y&&(this._deliveryQueue.end--,G<this._deliveryQueue.i&&this._deliveryQueue.i--);J.length=G}}_deliver(S,J){if(!S)return;const P=this._options?.onListenerError||f.onUnexpectedError;if(!P){S.value(J);return}try{S.value(J)}catch(y){P(y)}}_deliverQueue(S){const J=S.current._listeners;for(;S.i<S.end;)this._deliver(J[S.i++],S.value);S.reset()}fire(S){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof z)this._deliver(this._listeners,S);else{const J=this._deliveryQueue;J.enqueue(this,S,this._listeners.length),this._deliverQueue(J)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=i;const u=()=>new _;e.createEventDeliveryQueue=u;class _{constructor(){this.i=-1,this.end=0}enqueue(S,J,P){this.i=0,this.end=P,this.current=S,this.value=J}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class A extends i{async fireAsync(S,J,P){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList),O(this._listeners,y=>this._asyncDeliveryQueue.push([y.value,S]));this._asyncDeliveryQueue.size>0&&!J.isCancellationRequested;){const[y,G]=this._asyncDeliveryQueue.shift(),V=[],Z={...G,token:J,waitUntil:Y=>{if(Object.isFrozen(V))throw new Error("waitUntil can NOT be called asynchronous");P&&(Y=P(Y,y)),V.push(Y)}};try{y(Z)}catch(Y){(0,f.onUnexpectedError)(Y);continue}Object.freeze(V),await Promise.allSettled(V).then(Y=>{for(const se of Y)se.status==="rejected"&&(0,f.onUnexpectedError)(se.reason)})}}}e.AsyncEmitter=A;class c extends i{get isPaused(){return this._isPaused!==0}constructor(S){super(S),this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=S?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const S=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(S))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(S){this._size&&(this._isPaused!==0?this._eventQueue.push(S):super.fire(S))}}e.PauseableEmitter=c;class d extends c{constructor(S){super(S),this._delay=S.delay??100}fire(S){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(S)}}e.DebounceEmitter=d;class s extends i{constructor(S){super(S),this._queuedEvents=[],this._mergeFn=S?.merge}fire(S){this.hasListeners()&&(this._queuedEvents.push(S),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(J=>super.fire(J)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=s;class m{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new i({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(S){const J={event:S,listener:null};this.events.push(J),this.hasListeners&&this.hook(J);const P=()=>{this.hasListeners&&this.unhook(J);const y=this.events.indexOf(J);this.events.splice(y,1)};return(0,w.toDisposable)((0,t.createSingleCallFunction)(P))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(S=>this.hook(S))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(S=>this.unhook(S))}hook(S){S.listener=S.event(J=>this.emitter.fire(J))}unhook(S){S.listener?.dispose(),S.listener=null}dispose(){this.emitter.dispose();for(const S of this.events)S.listener?.dispose();this.events=[]}}e.EventMultiplexer=m;class R{constructor(S,J,P,y){this._store=new w.DisposableStore;const G=this._store.add(new m),V=this._store.add(new w.DisposableMap);function Z(Y){V.set(Y,G.add(y(Y)))}for(const Y of S)Z(Y);this._store.add(J(Y=>{Z(Y)})),this._store.add(P(Y=>{V.deleteAndDispose(Y)})),this.event=G.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=R;class U{constructor(){this.data=[]}wrapEvent(S,J,P){return(y,G,V)=>S(Z=>{const Y=this.data[this.data.length-1];if(!J){Y?Y.buffers.push(()=>y.call(G,Z)):y.call(G,Z);return}const se=Y;if(!se){y.call(G,J(P,Z));return}se.items??=[],se.items.push(Z),se.buffers.length===0&&Y.buffers.push(()=>{se.reducedResult??=P?se.items.reduce(J,P):se.items.reduce(J),y.call(G,se.reducedResult)})},void 0,V)}bufferEvents(S){const J={buffers:new Array};this.data.push(J);const P=S();return this.data.pop(),J.buffers.forEach(y=>y()),P}}e.EventBufferer=U;class a{constructor(){this.listening=!1,this.inputEvent=j.None,this.inputEventListener=w.Disposable.None,this.emitter=new i({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(S){this.inputEvent=S,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=S(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=a;class q{static const(S){return new H(S)}constructor(S){this._value=S,this._onDidChange=new i,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(S){S!==this._value&&(this._value=S,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=q;class H{constructor(S){this.value=S,this.onDidChange=j.None}}}),define(Ee[15],pe([0,1,14]),function(le,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=Q;const t=Object.freeze(function(B,I){const j=setTimeout(B.bind(I),0);return{dispose(){clearTimeout(j)}}});var w;(function(B){function I(j){return j===B.None||j===B.Cancelled||j instanceof T?!0:!j||typeof j!="object"?!1:typeof j.isCancellationRequested=="boolean"&&typeof j.onCancellationRequested=="function"}B.isCancellationToken=I,B.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:f.Event.None}),B.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(w||(e.CancellationToken=w={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new f.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class ie{constructor(I){this._token=void 0,this._parentListener=void 0,this._parentListener=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=w.Cancelled}dispose(I=!1){I&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=w.None}}e.CancellationTokenSource=ie;function Q(B){const I=new ie;return B.add({dispose(){I.cancel()}}),I.token}}),define(Ee[28],pe([0,1,15]),function(le,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=w;class t{constructor(B){this.task=B,this.result=null}get(){if(this.result)return this.result;const B=new f.CancellationTokenSource,I=this.task(B.token);return this.result={promise:I,dispose:()=>{this.result=null,B.cancel(),B.dispose()}},this.result}}e.Cache=t;function w(Q){return Q}class T{constructor(B,I){this.lastCache=void 0,this.lastArgKey=void 0,typeof B=="function"?(this._fn=B,this._computeKey=w):(this._fn=I,this._computeKey=B.getCacheKey)}get(B){const I=this._computeKey(B);return this.lastArgKey!==I&&(this.lastArgKey=I,this.lastCache=this._fn(B)),this.lastCache}}e.LRUCachedFunction=T;class ie{get cachedValues(){return this._map}constructor(B,I){this._map=new Map,this._map2=new Map,typeof B=="function"?(this._fn=B,this._computeKey=w):(this._fn=I,this._computeKey=B.getCacheKey)}get(B){const I=this._computeKey(B);if(this._map2.has(I))return this._map2.get(I);const j=this._fn(B);return this._map.set(B,j),this._map2.set(I,j),j}}e.CachedFunction=ie}),define(Ee[29],pe([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ee[30],pe([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=f,e.isStringArray=t,e.isObject=w,e.isTypedArray=T,e.isNumber=ie,e.isIterable=Q,e.isBoolean=B,e.isUndefined=I,e.isDefined=j,e.isUndefinedOrNull=x,e.assertType=W,e.assertIsDefined=te,e.assertAllDefined=M,e.isEmptyObject=h,e.isFunction=v,e.areFunctions=F,e.validateConstraints=z,e.validateConstraint=ne;function f(O){return typeof O=="string"}function t(O){return Array.isArray(O)&&O.every(n=>f(n))}function w(O){return typeof O=="object"&&O!==null&&!Array.isArray(O)&&!(O instanceof RegExp)&&!(O instanceof Date)}function T(O){const n=Object.getPrototypeOf(Uint8Array);return typeof O=="object"&&O instanceof n}function ie(O){return typeof O=="number"&&!isNaN(O)}function Q(O){return!!O&&typeof O[Symbol.iterator]=="function"}function B(O){return O===!0||O===!1}function I(O){return typeof O>"u"}function j(O){return!x(O)}function x(O){return I(O)||O===null}function W(O,n){if(!O)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function te(O){if(x(O))throw new Error("Assertion Failed: argument is undefined or null");return O}function M(...O){const n=[];for(let i=0;i<O.length;i++){const u=O[i];if(x(u))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);n.push(u)}return n}const l=Object.prototype.hasOwnProperty;function h(O){if(!w(O))return!1;for(const n in O)if(l.call(O,n))return!1;return!0}function v(O){return typeof O=="function"}function F(...O){return O.length>0&&O.every(v)}function z(O,n){const i=Math.min(O.length,n.length);for(let u=0;u<i;u++)ne(O[u],n[u])}function ne(O,n){if(f(n)){if(typeof O!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(v(n)){try{if(O instanceof n)return}catch{}if(!x(O)&&O.constructor===n||n.length===1&&n.call(void 0,O)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(Ee[31],pe([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.toUint8=t,e.toUint32=w;var f;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(f||(e.Constants=f={}));function t(T){return T<0?0:T>f.MAX_UINT_8?f.MAX_UINT_8:T|0}function w(T){return T<0?0:T>f.MAX_UINT_32?f.MAX_UINT_32:T|0}}),define(Ee[7],pe([0,1,28,4,11,31]),function(le,e,f,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=ie,e.format=B,e.format2=j,e.htmlAttributeEncodeValue=x,e.escape=W,e.escapeRegExpCharacters=te,e.count=M,e.truncate=l,e.truncateMiddle=h,e.trim=v,e.ltrim=F,e.rtrim=z,e.convertSimple2RegExpPattern=ne,e.stripWildcards=O,e.createRegExp=n,e.regExpLeadsToEndlessLoop=i,e.splitLines=u,e.splitLinesIncludeSeparators=_,e.firstNonWhitespaceIndex=A,e.getLeadingWhitespace=c,e.lastNonWhitespaceIndex=d,e.replaceAsync=s,e.compare=m,e.compareSubstring=R,e.compareIgnoreCase=U,e.compareSubstringIgnoreCase=a,e.isAsciiDigit=q,e.isLowerAsciiLetter=H,e.isUpperAsciiLetter=K,e.equalsIgnoreCase=S,e.startsWithIgnoreCase=J,e.commonPrefixLength=P,e.commonSuffixLength=y,e.isHighSurrogate=G,e.isLowSurrogate=V,e.computeCodePoint=Z,e.getNextCodePoint=Y,e.nextCharLength=Le,e.prevCharLength=Ie,e.getCharContainingOffset=ce,e.charCount=we,e.containsRTL=p,e.isBasicASCII=D,e.containsUnusualLineTerminators=g,e.isFullWidthCharacter=r,e.isEmojiImprecise=b,e.lcut=N,e.forAnsiStringParts=oe,e.removeAnsiEscapeCodes=ve,e.removeAnsiEscapeCodesFromPrompt=C,e.startsWithUTF8BOM=ae,e.stripUTF8BOM=re,e.fuzzyContains=fe,e.containsUppercaseCharacter=he,e.uppercaseFirstLetter=Ae,e.getNLines=Re,e.singleLetterHash=De,e.getGraphemeBreakType=Be,e.getLeftDeleteOffset=Ge;function ie(o){return!o||typeof o!="string"?!0:o.trim().length===0}const Q=/{(\d+)}/g;function B(o,...E){return E.length===0?o:o.replace(Q,function(k,X){const ue=parseInt(X,10);return isNaN(ue)||ue<0||ue>=E.length?k:E[ue]})}const I=/{([^}]+)}/g;function j(o,E){return Object.keys(E).length===0?o:o.replace(I,(k,X)=>E[X]??k)}function x(o){return o.replace(/[<>"'&]/g,E=>{switch(E){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return E})}function W(o){return o.replace(/[<>&]/g,function(E){switch(E){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return E}})}function te(o){return o.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function M(o,E){let k=0,X=o.indexOf(E);for(;X!==-1;)k++,X=o.indexOf(E,X+E.length);return k}function l(o,E,k="\u2026"){return o.length<=E?o:`${o.substr(0,E)}${k}`}function h(o,E,k="\u2026"){if(o.length<=E)return o;const X=Math.ceil(E/2)-k.length/2,ue=Math.floor(E/2)-k.length/2;return`${o.substr(0,X)}${k}${o.substr(o.length-ue)}`}function v(o,E=" "){const k=F(o,E);return z(k,E)}function F(o,E){if(!o||!E)return o;const k=E.length;if(k===0||o.length===0)return o;let X=0;for(;o.indexOf(E,X)===X;)X=X+k;return o.substring(X)}function z(o,E){if(!o||!E)return o;const k=E.length,X=o.length;if(k===0||X===0)return o;let ue=X,me=-1;for(;me=o.lastIndexOf(E,ue-1),!(me===-1||me+k!==ue);){if(me===0)return"";ue=me}return o.substring(0,ue)}function ne(o){return o.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function O(o){return o.replace(/\*/g,"")}function n(o,E,k={}){if(!o)throw new Error("Cannot create regex from empty string");E||(o=te(o)),k.wholeWord&&(/\B/.test(o.charAt(0))||(o="\\b"+o),/\B/.test(o.charAt(o.length-1))||(o=o+"\\b"));let X="";return k.global&&(X+="g"),k.matchCase||(X+="i"),k.multiline&&(X+="m"),k.unicode&&(X+="u"),new RegExp(o,X)}function i(o){return o.source==="^"||o.source==="^$"||o.source==="$"||o.source==="^\\s*$"?!1:!!(o.exec("")&&o.lastIndex===0)}function u(o){return o.split(/\r\n|\r|\n/)}function _(o){const E=[],k=o.split(/(\r\n|\r|\n)/);for(let X=0;X<Math.ceil(k.length/2);X++)E.push(k[2*X]+(k[2*X+1]??""));return E}function A(o){for(let E=0,k=o.length;E<k;E++){const X=o.charCodeAt(E);if(X!==t.CharCode.Space&&X!==t.CharCode.Tab)return E}return-1}function c(o,E=0,k=o.length){for(let X=E;X<k;X++){const ue=o.charCodeAt(X);if(ue!==t.CharCode.Space&&ue!==t.CharCode.Tab)return o.substring(E,X)}return o.substring(E,k)}function d(o,E=o.length-1){for(let k=E;k>=0;k--){const X=o.charCodeAt(k);if(X!==t.CharCode.Space&&X!==t.CharCode.Tab)return k}return-1}function s(o,E,k){const X=[];let ue=0;for(const me of o.matchAll(E)){if(X.push(o.slice(ue,me.index)),me.index===void 0)throw new Error("match.index should be defined");ue=me.index+me[0].length,X.push(k(me[0],...me.slice(1),me.index,o,me.groups))}return X.push(o.slice(ue)),Promise.all(X).then(me=>me.join(""))}function m(o,E){return o<E?-1:o>E?1:0}function R(o,E,k=0,X=o.length,ue=0,me=E.length){for(;k<X&&ue<me;k++,ue++){const Pe=o.charCodeAt(k),Me=E.charCodeAt(ue);if(Pe<Me)return-1;if(Pe>Me)return 1}const Te=X-k,Ne=me-ue;return Te<Ne?-1:Te>Ne?1:0}function U(o,E){return a(o,E,0,o.length,0,E.length)}function a(o,E,k=0,X=o.length,ue=0,me=E.length){for(;k<X&&ue<me;k++,ue++){let Pe=o.charCodeAt(k),Me=E.charCodeAt(ue);if(Pe===Me)continue;if(Pe>=128||Me>=128)return R(o.toLowerCase(),E.toLowerCase(),k,X,ue,me);H(Pe)&&(Pe-=32),H(Me)&&(Me-=32);const Ue=Pe-Me;if(Ue!==0)return Ue}const Te=X-k,Ne=me-ue;return Te<Ne?-1:Te>Ne?1:0}function q(o){return o>=t.CharCode.Digit0&&o<=t.CharCode.Digit9}function H(o){return o>=t.CharCode.a&&o<=t.CharCode.z}function K(o){return o>=t.CharCode.A&&o<=t.CharCode.Z}function S(o,E){return o.length===E.length&&a(o,E)===0}function J(o,E){const k=E.length;return E.length>o.length?!1:a(o,E,0,k)===0}function P(o,E){const k=Math.min(o.length,E.length);let X;for(X=0;X<k;X++)if(o.charCodeAt(X)!==E.charCodeAt(X))return X;return k}function y(o,E){const k=Math.min(o.length,E.length);let X;const ue=o.length-1,me=E.length-1;for(X=0;X<k;X++)if(o.charCodeAt(ue-X)!==E.charCodeAt(me-X))return X;return k}function G(o){return 55296<=o&&o<=56319}function V(o){return 56320<=o&&o<=57343}function Z(o,E){return(o-55296<<10)+(E-56320)+65536}function Y(o,E,k){const X=o.charCodeAt(k);if(G(X)&&k+1<E){const ue=o.charCodeAt(k+1);if(V(ue))return Z(X,ue)}return X}function se(o,E){const k=o.charCodeAt(E-1);if(V(k)&&E>1){const X=o.charCodeAt(E-2);if(G(X))return Z(X,k)}return k}class ge{get offset(){return this._offset}constructor(E,k=0){this._str=E,this._len=E.length,this._offset=k}setOffset(E){this._offset=E}prevCodePoint(){const E=se(this._str,this._offset);return this._offset-=E>=T.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,E}nextCodePoint(){const E=Y(this._str,this._len,this._offset);return this._offset+=E>=T.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,E}eol(){return this._offset>=this._len}}e.CodePointIterator=ge;class ye{get offset(){return this._iterator.offset}constructor(E,k=0){this._iterator=new ge(E,k)}nextGraphemeLength(){const E=Se.getInstance(),k=this._iterator,X=k.offset;let ue=E.getGraphemeBreakType(k.nextCodePoint());for(;!k.eol();){const me=k.offset,Te=E.getGraphemeBreakType(k.nextCodePoint());if(We(ue,Te)){k.setOffset(me);break}ue=Te}return k.offset-X}prevGraphemeLength(){const E=Se.getInstance(),k=this._iterator,X=k.offset;let ue=E.getGraphemeBreakType(k.prevCodePoint());for(;k.offset>0;){const me=k.offset,Te=E.getGraphemeBreakType(k.prevCodePoint());if(We(Te,ue)){k.setOffset(me);break}ue=Te}return X-k.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ye;function Le(o,E){return new ye(o,E).nextGraphemeLength()}function Ie(o,E){return new ye(o,E).prevGraphemeLength()}function ce(o,E){E>0&&V(o.charCodeAt(E))&&E--;const k=E+Le(o,E);return[k-Ie(o,k),k]}function we(o){const E=new ye(o);let k=0;for(;!E.eol();)k++,E.nextGraphemeLength();return k}let _e;function be(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function p(o){return _e||(_e=be()),_e.test(o)}const L=/^[\t\n\r\x20-\x7E]*$/;function D(o){return L.test(o)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function g(o){return e.UNUSUAL_LINE_TERMINATORS.test(o)}function r(o){return o>=11904&&o<=55215||o>=63744&&o<=64255||o>=65281&&o<=65374}function b(o){return o>=127462&&o<=127487||o===8986||o===8987||o===9200||o===9203||o>=9728&&o<=10175||o===11088||o===11093||o>=127744&&o<=128591||o>=128640&&o<=128764||o>=128992&&o<=129008||o>=129280&&o<=129535||o>=129648&&o<=129782}function N(o,E,k=""){const X=o.trimStart();if(X.length<E)return X;const ue=/\b/g;let me=0;for(;ue.test(X)&&!(X.length-ue.lastIndex<E);)me=ue.lastIndex,ue.lastIndex+=1;return me===0?X:k+X.substring(me).trimStart()}const $=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*oe(o){let E=0;for(const k of o.matchAll($))E!==k.index&&(yield{isCode:!1,str:o.substring(E,k.index)}),yield{isCode:!0,str:k[0]},E=k.index+k[0].length;E!==o.length&&(yield{isCode:!1,str:o.substring(E)})}function ve(o){return o&&(o=o.replace($,"")),o}const ee=/\\\[.*?\\\]/g;function C(o){return ve(o).replace(ee,"")}e.UTF8_BOM_CHARACTER=String.fromCharCode(t.CharCode.UTF8_BOM);function ae(o){return!!(o&&o.length>0&&o.charCodeAt(0)===t.CharCode.UTF8_BOM)}function re(o){return ae(o)?o.substr(1):o}function fe(o,E){if(!o||!E||o.length<E.length)return!1;const k=E.length,X=o.toLowerCase();let ue=0,me=-1;for(;ue<k;){const Te=X.indexOf(E[ue],me+1);if(Te<0)return!1;me=Te,ue++}return!0}function he(o,E=!1){return o?(E&&(o=o.replace(/\\./g,"")),o.toLowerCase()!==o):!1}function Ae(o){return o.charAt(0).toUpperCase()+o.slice(1)}function Re(o,E=1){if(E===0)return"";let k=-1;do k=o.indexOf(`
`,k+1),E--;while(E>0&&k>=0);return k===-1?o:(o[k-1]==="\r"&&k--,o.substr(0,k))}function De(o){const E=t.CharCode.Z-t.CharCode.A+1;return o=o%(2*E),o<E?String.fromCharCode(t.CharCode.a+o):String.fromCharCode(t.CharCode.A+o-E)}function Be(o){return Se.getInstance().getGraphemeBreakType(o)}function We(o,E){return o===de.Other?E!==de.Extend&&E!==de.SpacingMark:o===de.CR&&E===de.LF?!1:o===de.Control||o===de.CR||o===de.LF||E===de.Control||E===de.CR||E===de.LF?!0:!(o===de.L&&(E===de.L||E===de.V||E===de.LV||E===de.LVT)||(o===de.LV||o===de.V)&&(E===de.V||E===de.T)||(o===de.LVT||o===de.T)&&E===de.T||E===de.Extend||E===de.ZWJ||E===de.SpacingMark||o===de.Prepend||o===de.ZWJ&&E===de.Extended_Pictographic||o===de.Regional_Indicator&&E===de.Regional_Indicator)}var de;(function(o){o[o.Other=0]="Other",o[o.Prepend=1]="Prepend",o[o.CR=2]="CR",o[o.LF=3]="LF",o[o.Control=4]="Control",o[o.Extend=5]="Extend",o[o.Regional_Indicator=6]="Regional_Indicator",o[o.SpacingMark=7]="SpacingMark",o[o.L=8]="L",o[o.V=9]="V",o[o.T=10]="T",o[o.LV=11]="LV",o[o.LVT=12]="LVT",o[o.ZWJ=13]="ZWJ",o[o.Extended_Pictographic=14]="Extended_Pictographic"})(de||(e.GraphemeBreakType=de={}));class Se{static{this._INSTANCE=null}static getInstance(){return Se._INSTANCE||(Se._INSTANCE=new Se),Se._INSTANCE}constructor(){this._data=qe()}getGraphemeBreakType(E){if(E<32)return E===t.CharCode.LineFeed?de.LF:E===t.CharCode.CarriageReturn?de.CR:de.Control;if(E<127)return de.Other;const k=this._data,X=k.length/3;let ue=1;for(;ue<=X;)if(E<k[3*ue])ue=2*ue;else if(E>k[3*ue+1])ue=2*ue+1;else return k[3*ue+2];return de.Other}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(o,E){if(o===0)return 0;const k=Ke(o,E);if(k!==void 0)return k;const X=new ge(E,o);return X.prevCodePoint(),X.offset}function Ke(o,E){const k=new ge(E,o);let X=k.prevCodePoint();for(;Ze(X)||X===je.emojiVariantSelector||X===je.enclosingKeyCap;){if(k.offset===0)return;X=k.prevCodePoint()}if(!b(X))return;let ue=k.offset;return ue>0&&k.prevCodePoint()===je.zwj&&(ue=k.offset),ue}function Ze(o){return 127995<=o&&o<=127999}var je;(function(o){o[o.zwj=8205]="zwj",o[o.emojiVariantSelector=65039]="emojiVariantSelector",o[o.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.noBreakWhitespace="\xA0";class ze{static{this.ambiguousCharacterData=new w.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new f.LRUCachedFunction({getCacheKey:JSON.stringify},E=>{function k(Ue){const Fe=new Map;for(let ke=0;ke<Ue.length;ke+=2)Fe.set(Ue[ke],Ue[ke+1]);return Fe}function X(Ue,Fe){const ke=new Map(Ue);for(const[He,Ve]of Fe)ke.set(He,Ve);return ke}function ue(Ue,Fe){if(!Ue)return Fe;const ke=new Map;for(const[He,Ve]of Ue)Fe.has(He)&&ke.set(He,Ve);return ke}const me=this.ambiguousCharacterData.value;let Te=E.filter(Ue=>!Ue.startsWith("_")&&Ue in me);Te.length===0&&(Te=["_default"]);let Ne;for(const Ue of Te){const Fe=k(me[Ue]);Ne=ue(Ne,Fe)}const Pe=k(me._common),Me=X(Pe,Ne);return new ze(Me)})}static getInstance(E){return ze.cache.get(Array.from(E))}static{this._locales=new w.Lazy(()=>Object.keys(ze.ambiguousCharacterData.value).filter(E=>!E.startsWith("_")))}static getLocales(){return ze._locales.value}constructor(E){this.confusableDictionary=E}isAmbiguous(E){return this.confusableDictionary.has(E)}containsAmbiguousCharacter(E){for(let k=0;k<E.length;k++){const X=E.codePointAt(k);if(typeof X=="number"&&this.isAmbiguous(X))return!0}return!1}getPrimaryConfusable(E){return this.confusableDictionary.get(E)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ze;class $e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set($e.getRawData())),this._data}static isInvisibleCharacter(E){return $e.getData().has(E)}static containsInvisibleCharacter(E){for(let k=0;k<E.length;k++){const X=E.codePointAt(k);if(typeof X=="number"&&$e.isInvisibleCharacter(X))return!0}return!1}static get codePoints(){return $e.getData()}}e.InvisibleCharacters=$e}),define(Ee[32],pe([33,34]),function(le,e){return le.create("vs/base/common/platform",e)});var Qe=this&&this.__createBinding||(Object.create?function(le,e,f,t){t===void 0&&(t=f);var w=Object.getOwnPropertyDescriptor(e,f);(!w||("get"in w?!e.__esModule:w.writable||w.configurable))&&(w={enumerable:!0,get:function(){return e[f]}}),Object.defineProperty(le,t,w)}:function(le,e,f,t){t===void 0&&(t=f),le[t]=e[f]}),Xe=this&&this.__setModuleDefault||(Object.create?function(le,e){Object.defineProperty(le,"default",{enumerable:!0,value:e})}:function(le,e){le.default=e}),Oe=this&&this.__importStar||function(le){if(le&&le.__esModule)return le;var e={};if(le!=null)for(var f in le)f!=="default"&&Object.prototype.hasOwnProperty.call(le,f)&&Qe(e,le,f);return Xe(e,le),e};define(Ee[2],pe([0,1,32]),function(le,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=i,e.isLittleEndian=s,e.isBigSurOrNewer=m,f=Oe(f),e.LANGUAGE_DEFAULT="en";let t=!1,w=!1,T=!1,ie=!1,Q=!1,B=!1,I=!1,j=!1,x=!1,W=!1,te,M=e.LANGUAGE_DEFAULT,l=e.LANGUAGE_DEFAULT,h,v;const F=globalThis;let z;typeof F.vscode<"u"&&typeof F.vscode.process<"u"?z=F.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(z=process);const ne=typeof z?.versions?.electron=="string",O=ne&&z?.type==="renderer";if(typeof z=="object"){t=z.platform==="win32",w=z.platform==="darwin",T=z.platform==="linux",ie=T&&!!z.env.SNAP&&!!z.env.SNAP_REVISION,I=ne,x=!!z.env.CI||!!z.env.BUILD_ARTIFACTSTAGINGDIRECTORY,te=e.LANGUAGE_DEFAULT,M=e.LANGUAGE_DEFAULT;const R=z.env.VSCODE_NLS_CONFIG;if(R)try{const U=JSON.parse(R),a=U.availableLanguages["*"];te=U.locale,l=U.osLocale,M=a||e.LANGUAGE_DEFAULT,h=U._translationsConfigFile}catch{}Q=!0}else typeof navigator=="object"&&!O?(v=navigator.userAgent,t=v.indexOf("Windows")>=0,w=v.indexOf("Macintosh")>=0,j=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=v.indexOf("Linux")>=0,W=v?.indexOf("Mobi")>=0,B=!0,te=f.getConfiguredDefaultLocale(f.localize(0,null))||e.LANGUAGE_DEFAULT,M=te,l=navigator.language):console.error("Unable to resolve platform.");var n;(function(R){R[R.Web=0]="Web",R[R.Mac=1]="Mac",R[R.Linux=2]="Linux",R[R.Windows=3]="Windows"})(n||(e.Platform=n={}));function i(R){switch(R){case n.Web:return"Web";case n.Mac:return"Mac";case n.Linux:return"Linux";case n.Windows:return"Windows"}}let u=n.Web;w?u=n.Mac:t?u=n.Windows:T&&(u=n.Linux),e.isWindows=t,e.isMacintosh=w,e.isLinux=T,e.isLinuxSnap=ie,e.isNative=Q,e.isElectron=I,e.isWeb=B,e.isWebWorker=B&&typeof F.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?F.origin:void 0,e.isIOS=j,e.isMobile=W,e.isCI=x,e.platform=u,e.userAgent=v,e.language=M;var _;(function(R){function U(){return e.language}R.value=U;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}R.isDefaultVariant=a;function q(){return e.language==="en"}R.isDefault=q})(_||(e.Language=_={})),e.locale=te,e.platformLocale=l,e.translationsConfigFile=h,e.setTimeout0IsFaster=typeof F.postMessage=="function"&&!F.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const R=[];F.addEventListener("message",a=>{if(a.data&&a.data.vscodeScheduleAsyncWork)for(let q=0,H=R.length;q<H;q++){const K=R[q];if(K.id===a.data.vscodeScheduleAsyncWork){R.splice(q,1),K.callback();return}}});let U=0;return a=>{const q=++U;R.push({id:q,callback:a}),F.postMessage({vscodeScheduleAsyncWork:q},"*")}}return R=>setTimeout(R)})();var A;(function(R){R[R.Windows=1]="Windows",R[R.Macintosh=2]="Macintosh",R[R.Linux=3]="Linux"})(A||(e.OperatingSystem=A={})),e.OS=w||j?A.Macintosh:t?A.Windows:A.Linux;let c=!0,d=!1;function s(){if(!d){d=!0;const R=new Uint8Array(2);R[0]=1,R[1]=2,c=new Uint16Array(R.buffer)[0]===513}return c}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function m(R){return parseFloat(R)>=20}}),define(Ee[16],pe([0,1,2]),function(le,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;const w=globalThis.vscode;if(typeof w<"u"&&typeof w.process<"u"){const T=w.process;t={get platform(){return T.platform},get arch(){return T.arch},get env(){return T.env},cwd(){return T.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return f.isWindows?"win32":f.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(Ee[3],pe([0,1,16]),function(le,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0,f=Oe(f);const t=65,w=97,T=90,ie=122,Q=46,B=47,I=92,j=58,x=63;class W extends Error{constructor(i,u,_){let A;typeof u=="string"&&u.indexOf("not ")===0?(A="must not be",u=u.replace(/^not /,"")):A="must be";const c=i.indexOf(".")!==-1?"property":"argument";let d=`The "${i}" ${c} ${A} of type ${u}`;d+=`. Received type ${typeof _}`,super(d),this.code="ERR_INVALID_ARG_TYPE"}}function te(n,i){if(n===null||typeof n!="object")throw new W(i,"Object",n)}function M(n,i){if(typeof n!="string")throw new W(i,"string",n)}const l=f.platform==="win32";function h(n){return n===B||n===I}function v(n){return n===B}function F(n){return n>=t&&n<=T||n>=w&&n<=ie}function z(n,i,u,_){let A="",c=0,d=-1,s=0,m=0;for(let R=0;R<=n.length;++R){if(R<n.length)m=n.charCodeAt(R);else{if(_(m))break;m=B}if(_(m)){if(!(d===R-1||s===1))if(s===2){if(A.length<2||c!==2||A.charCodeAt(A.length-1)!==Q||A.charCodeAt(A.length-2)!==Q){if(A.length>2){const U=A.lastIndexOf(u);U===-1?(A="",c=0):(A=A.slice(0,U),c=A.length-1-A.lastIndexOf(u)),d=R,s=0;continue}else if(A.length!==0){A="",c=0,d=R,s=0;continue}}i&&(A+=A.length>0?`${u}..`:"..",c=2)}else A.length>0?A+=`${u}${n.slice(d+1,R)}`:A=n.slice(d+1,R),c=R-d-1;d=R,s=0}else m===Q&&s!==-1?++s:s=-1}return A}function ne(n,i){te(i,"pathObject");const u=i.dir||i.root,_=i.base||`${i.name||""}${i.ext||""}`;return u?u===i.root?`${u}${_}`:`${u}${n}${_}`:_}e.win32={resolve(...n){let i="",u="",_=!1;for(let A=n.length-1;A>=-1;A--){let c;if(A>=0){if(c=n[A],M(c,"path"),c.length===0)continue}else i.length===0?c=f.cwd():(c=f.env[`=${i}`]||f.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==i.toLowerCase()&&c.charCodeAt(2)===I)&&(c=`${i}\\`));const d=c.length;let s=0,m="",R=!1;const U=c.charCodeAt(0);if(d===1)h(U)&&(s=1,R=!0);else if(h(U))if(R=!0,h(c.charCodeAt(1))){let a=2,q=a;for(;a<d&&!h(c.charCodeAt(a));)a++;if(a<d&&a!==q){const H=c.slice(q,a);for(q=a;a<d&&h(c.charCodeAt(a));)a++;if(a<d&&a!==q){for(q=a;a<d&&!h(c.charCodeAt(a));)a++;(a===d||a!==q)&&(m=`\\\\${H}\\${c.slice(q,a)}`,s=a)}}}else s=1;else F(U)&&c.charCodeAt(1)===j&&(m=c.slice(0,2),s=2,d>2&&h(c.charCodeAt(2))&&(R=!0,s=3));if(m.length>0)if(i.length>0){if(m.toLowerCase()!==i.toLowerCase())continue}else i=m;if(_){if(i.length>0)break}else if(u=`${c.slice(s)}\\${u}`,_=R,R&&i.length>0)break}return u=z(u,!_,"\\",h),_?`${i}\\${u}`:`${i}${u}`||"."},normalize(n){M(n,"path");const i=n.length;if(i===0)return".";let u=0,_,A=!1;const c=n.charCodeAt(0);if(i===1)return v(c)?"\\":n;if(h(c))if(A=!0,h(n.charCodeAt(1))){let s=2,m=s;for(;s<i&&!h(n.charCodeAt(s));)s++;if(s<i&&s!==m){const R=n.slice(m,s);for(m=s;s<i&&h(n.charCodeAt(s));)s++;if(s<i&&s!==m){for(m=s;s<i&&!h(n.charCodeAt(s));)s++;if(s===i)return`\\\\${R}\\${n.slice(m)}\\`;s!==m&&(_=`\\\\${R}\\${n.slice(m,s)}`,u=s)}}}else u=1;else F(c)&&n.charCodeAt(1)===j&&(_=n.slice(0,2),u=2,i>2&&h(n.charCodeAt(2))&&(A=!0,u=3));let d=u<i?z(n.slice(u),!A,"\\",h):"";return d.length===0&&!A&&(d="."),d.length>0&&h(n.charCodeAt(i-1))&&(d+="\\"),_===void 0?A?`\\${d}`:d:A?`${_}\\${d}`:`${_}${d}`},isAbsolute(n){M(n,"path");const i=n.length;if(i===0)return!1;const u=n.charCodeAt(0);return h(u)||i>2&&F(u)&&n.charCodeAt(1)===j&&h(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let i,u;for(let c=0;c<n.length;++c){const d=n[c];M(d,"path"),d.length>0&&(i===void 0?i=u=d:i+=`\\${d}`)}if(i===void 0)return".";let _=!0,A=0;if(typeof u=="string"&&h(u.charCodeAt(0))){++A;const c=u.length;c>1&&h(u.charCodeAt(1))&&(++A,c>2&&(h(u.charCodeAt(2))?++A:_=!1))}if(_){for(;A<i.length&&h(i.charCodeAt(A));)A++;A>=2&&(i=`\\${i.slice(A)}`)}return e.win32.normalize(i)},relative(n,i){if(M(n,"from"),M(i,"to"),n===i)return"";const u=e.win32.resolve(n),_=e.win32.resolve(i);if(u===_||(n=u.toLowerCase(),i=_.toLowerCase(),n===i))return"";let A=0;for(;A<n.length&&n.charCodeAt(A)===I;)A++;let c=n.length;for(;c-1>A&&n.charCodeAt(c-1)===I;)c--;const d=c-A;let s=0;for(;s<i.length&&i.charCodeAt(s)===I;)s++;let m=i.length;for(;m-1>s&&i.charCodeAt(m-1)===I;)m--;const R=m-s,U=d<R?d:R;let a=-1,q=0;for(;q<U;q++){const K=n.charCodeAt(A+q);if(K!==i.charCodeAt(s+q))break;K===I&&(a=q)}if(q!==U){if(a===-1)return _}else{if(R>U){if(i.charCodeAt(s+q)===I)return _.slice(s+q+1);if(q===2)return _.slice(s+q)}d>U&&(n.charCodeAt(A+q)===I?a=q:q===2&&(a=3)),a===-1&&(a=0)}let H="";for(q=A+a+1;q<=c;++q)(q===c||n.charCodeAt(q)===I)&&(H+=H.length===0?"..":"\\..");return s+=a,H.length>0?`${H}${_.slice(s,m)}`:(_.charCodeAt(s)===I&&++s,_.slice(s,m))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const i=e.win32.resolve(n);if(i.length<=2)return n;if(i.charCodeAt(0)===I){if(i.charCodeAt(1)===I){const u=i.charCodeAt(2);if(u!==x&&u!==Q)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(F(i.charCodeAt(0))&&i.charCodeAt(1)===j&&i.charCodeAt(2)===I)return`\\\\?\\${i}`;return n},dirname(n){M(n,"path");const i=n.length;if(i===0)return".";let u=-1,_=0;const A=n.charCodeAt(0);if(i===1)return h(A)?n:".";if(h(A)){if(u=_=1,h(n.charCodeAt(1))){let s=2,m=s;for(;s<i&&!h(n.charCodeAt(s));)s++;if(s<i&&s!==m){for(m=s;s<i&&h(n.charCodeAt(s));)s++;if(s<i&&s!==m){for(m=s;s<i&&!h(n.charCodeAt(s));)s++;if(s===i)return n;s!==m&&(u=_=s+1)}}}}else F(A)&&n.charCodeAt(1)===j&&(u=i>2&&h(n.charCodeAt(2))?3:2,_=u);let c=-1,d=!0;for(let s=i-1;s>=_;--s)if(h(n.charCodeAt(s))){if(!d){c=s;break}}else d=!1;if(c===-1){if(u===-1)return".";c=u}return n.slice(0,c)},basename(n,i){i!==void 0&&M(i,"ext"),M(n,"path");let u=0,_=-1,A=!0,c;if(n.length>=2&&F(n.charCodeAt(0))&&n.charCodeAt(1)===j&&(u=2),i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let d=i.length-1,s=-1;for(c=n.length-1;c>=u;--c){const m=n.charCodeAt(c);if(h(m)){if(!A){u=c+1;break}}else s===-1&&(A=!1,s=c+1),d>=0&&(m===i.charCodeAt(d)?--d===-1&&(_=c):(d=-1,_=s))}return u===_?_=s:_===-1&&(_=n.length),n.slice(u,_)}for(c=n.length-1;c>=u;--c)if(h(n.charCodeAt(c))){if(!A){u=c+1;break}}else _===-1&&(A=!1,_=c+1);return _===-1?"":n.slice(u,_)},extname(n){M(n,"path");let i=0,u=-1,_=0,A=-1,c=!0,d=0;n.length>=2&&n.charCodeAt(1)===j&&F(n.charCodeAt(0))&&(i=_=2);for(let s=n.length-1;s>=i;--s){const m=n.charCodeAt(s);if(h(m)){if(!c){_=s+1;break}continue}A===-1&&(c=!1,A=s+1),m===Q?u===-1?u=s:d!==1&&(d=1):u!==-1&&(d=-1)}return u===-1||A===-1||d===0||d===1&&u===A-1&&u===_+1?"":n.slice(u,A)},format:ne.bind(null,"\\"),parse(n){M(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const u=n.length;let _=0,A=n.charCodeAt(0);if(u===1)return h(A)?(i.root=i.dir=n,i):(i.base=i.name=n,i);if(h(A)){if(_=1,h(n.charCodeAt(1))){let a=2,q=a;for(;a<u&&!h(n.charCodeAt(a));)a++;if(a<u&&a!==q){for(q=a;a<u&&h(n.charCodeAt(a));)a++;if(a<u&&a!==q){for(q=a;a<u&&!h(n.charCodeAt(a));)a++;a===u?_=a:a!==q&&(_=a+1)}}}}else if(F(A)&&n.charCodeAt(1)===j){if(u<=2)return i.root=i.dir=n,i;if(_=2,h(n.charCodeAt(2))){if(u===3)return i.root=i.dir=n,i;_=3}}_>0&&(i.root=n.slice(0,_));let c=-1,d=_,s=-1,m=!0,R=n.length-1,U=0;for(;R>=_;--R){if(A=n.charCodeAt(R),h(A)){if(!m){d=R+1;break}continue}s===-1&&(m=!1,s=R+1),A===Q?c===-1?c=R:U!==1&&(U=1):c!==-1&&(U=-1)}return s!==-1&&(c===-1||U===0||U===1&&c===s-1&&c===d+1?i.base=i.name=n.slice(d,s):(i.name=n.slice(d,c),i.base=n.slice(d,s),i.ext=n.slice(c,s))),d>0&&d!==_?i.dir=n.slice(0,d-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const O=(()=>{if(l){const n=/\\/g;return()=>{const i=f.cwd().replace(n,"/");return i.slice(i.indexOf("/"))}}return()=>f.cwd()})();e.posix={resolve(...n){let i="",u=!1;for(let _=n.length-1;_>=-1&&!u;_--){const A=_>=0?n[_]:O();M(A,"path"),A.length!==0&&(i=`${A}/${i}`,u=A.charCodeAt(0)===B)}return i=z(i,!u,"/",v),u?`/${i}`:i.length>0?i:"."},normalize(n){if(M(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===B,u=n.charCodeAt(n.length-1)===B;return n=z(n,!i,"/",v),n.length===0?i?"/":u?"./":".":(u&&(n+="/"),i?`/${n}`:n)},isAbsolute(n){return M(n,"path"),n.length>0&&n.charCodeAt(0)===B},join(...n){if(n.length===0)return".";let i;for(let u=0;u<n.length;++u){const _=n[u];M(_,"path"),_.length>0&&(i===void 0?i=_:i+=`/${_}`)}return i===void 0?".":e.posix.normalize(i)},relative(n,i){if(M(n,"from"),M(i,"to"),n===i||(n=e.posix.resolve(n),i=e.posix.resolve(i),n===i))return"";const u=1,_=n.length,A=_-u,c=1,d=i.length-c,s=A<d?A:d;let m=-1,R=0;for(;R<s;R++){const a=n.charCodeAt(u+R);if(a!==i.charCodeAt(c+R))break;a===B&&(m=R)}if(R===s)if(d>s){if(i.charCodeAt(c+R)===B)return i.slice(c+R+1);if(R===0)return i.slice(c+R)}else A>s&&(n.charCodeAt(u+R)===B?m=R:R===0&&(m=0));let U="";for(R=u+m+1;R<=_;++R)(R===_||n.charCodeAt(R)===B)&&(U+=U.length===0?"..":"/..");return`${U}${i.slice(c+m)}`},toNamespacedPath(n){return n},dirname(n){if(M(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===B;let u=-1,_=!0;for(let A=n.length-1;A>=1;--A)if(n.charCodeAt(A)===B){if(!_){u=A;break}}else _=!1;return u===-1?i?"/":".":i&&u===1?"//":n.slice(0,u)},basename(n,i){i!==void 0&&M(i,"ext"),M(n,"path");let u=0,_=-1,A=!0,c;if(i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let d=i.length-1,s=-1;for(c=n.length-1;c>=0;--c){const m=n.charCodeAt(c);if(m===B){if(!A){u=c+1;break}}else s===-1&&(A=!1,s=c+1),d>=0&&(m===i.charCodeAt(d)?--d===-1&&(_=c):(d=-1,_=s))}return u===_?_=s:_===-1&&(_=n.length),n.slice(u,_)}for(c=n.length-1;c>=0;--c)if(n.charCodeAt(c)===B){if(!A){u=c+1;break}}else _===-1&&(A=!1,_=c+1);return _===-1?"":n.slice(u,_)},extname(n){M(n,"path");let i=-1,u=0,_=-1,A=!0,c=0;for(let d=n.length-1;d>=0;--d){const s=n.charCodeAt(d);if(s===B){if(!A){u=d+1;break}continue}_===-1&&(A=!1,_=d+1),s===Q?i===-1?i=d:c!==1&&(c=1):i!==-1&&(c=-1)}return i===-1||_===-1||c===0||c===1&&i===_-1&&i===u+1?"":n.slice(i,_)},format:ne.bind(null,"/"),parse(n){M(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const u=n.charCodeAt(0)===B;let _;u?(i.root="/",_=1):_=0;let A=-1,c=0,d=-1,s=!0,m=n.length-1,R=0;for(;m>=_;--m){const U=n.charCodeAt(m);if(U===B){if(!s){c=m+1;break}continue}d===-1&&(s=!1,d=m+1),U===Q?A===-1?A=m:R!==1&&(R=1):A!==-1&&(R=-1)}if(d!==-1){const U=c===0&&u?1:c;A===-1||R===0||R===1&&A===d-1&&A===c+1?i.base=i.name=n.slice(U,d):(i.name=n.slice(U,A),i.base=n.slice(U,d),i.ext=n.slice(A,d))}return c>0?i.dir=n.slice(0,c-1):u&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=l?e.win32.normalize:e.posix.normalize,e.isAbsolute=l?e.win32.isAbsolute:e.posix.isAbsolute,e.join=l?e.win32.join:e.posix.join,e.resolve=l?e.win32.resolve:e.posix.resolve,e.relative=l?e.win32.relative:e.posix.relative,e.dirname=l?e.win32.dirname:e.posix.dirname,e.basename=l?e.win32.basename:e.posix.basename,e.extname=l?e.win32.extname:e.posix.extname,e.format=l?e.win32.format:e.posix.format,e.parse=l?e.win32.parse:e.posix.parse,e.toNamespacedPath=l?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=l?e.win32.sep:e.posix.sep,e.delimiter=l?e.win32.delimiter:e.posix.delimiter}),define(Ee[6],pe([0,1,4,3,2,7,30]),function(le,e,f,t,w,T,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=Q,e.toSlashes=B,e.toPosixPath=I,e.getRoot=j,e.isUNC=x,e.isValidBasename=l,e.isEqual=h,e.isEqualOrParent=v,e.isWindowsDriveLetter=F,e.sanitizeFilePath=z,e.removeTrailingPathSeparator=ne,e.isRootOrDriveLetter=O,e.hasDriveLetter=n,e.getDriveLetter=i,e.indexOfPath=u,e.parseLineAndColumnAware=_,e.randomPath=d;function Q(s){return s===f.CharCode.Slash||s===f.CharCode.Backslash}function B(s){return s.replace(/[\\/]/g,t.posix.sep)}function I(s){return s.indexOf("/")===-1&&(s=B(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}function j(s,m=t.posix.sep){if(!s)return"";const R=s.length,U=s.charCodeAt(0);if(Q(U)){if(Q(s.charCodeAt(1))&&!Q(s.charCodeAt(2))){let q=3;const H=q;for(;q<R&&!Q(s.charCodeAt(q));q++);if(H!==q&&!Q(s.charCodeAt(q+1))){for(q+=1;q<R;q++)if(Q(s.charCodeAt(q)))return s.slice(0,q+1).replace(/[\\/]/g,m)}}return m}else if(F(U)&&s.charCodeAt(1)===f.CharCode.Colon)return Q(s.charCodeAt(2))?s.slice(0,2)+m:s.slice(0,2);let a=s.indexOf("://");if(a!==-1){for(a+=3;a<R;a++)if(Q(s.charCodeAt(a)))return s.slice(0,a+1)}return""}function x(s){if(!w.isWindows||!s||s.length<5)return!1;let m=s.charCodeAt(0);if(m!==f.CharCode.Backslash||(m=s.charCodeAt(1),m!==f.CharCode.Backslash))return!1;let R=2;const U=R;for(;R<s.length&&(m=s.charCodeAt(R),m!==f.CharCode.Backslash);R++);return!(U===R||(m=s.charCodeAt(R+1),isNaN(m)||m===f.CharCode.Backslash))}const W=/[\\/:\*\?"<>\|]/g,te=/[/]/g,M=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(s,m=w.isWindows){const R=m?W:te;return!(!s||s.length===0||/^\s+$/.test(s)||(R.lastIndex=0,R.test(s))||m&&M.test(s)||s==="."||s===".."||m&&s[s.length-1]==="."||m&&s.length!==s.trim().length||s.length>255)}function h(s,m,R){const U=s===m;return!R||U?U:!s||!m?!1:(0,T.equalsIgnoreCase)(s,m)}function v(s,m,R,U=t.sep){if(s===m)return!0;if(!s||!m||m.length>s.length)return!1;if(R){if(!(0,T.startsWithIgnoreCase)(s,m))return!1;if(m.length===s.length)return!0;let q=m.length;return m.charAt(m.length-1)===U&&q--,s.charAt(q)===U}return m.charAt(m.length-1)!==U&&(m+=U),s.indexOf(m)===0}function F(s){return s>=f.CharCode.A&&s<=f.CharCode.Z||s>=f.CharCode.a&&s<=f.CharCode.z}function z(s,m){return w.isWindows&&s.endsWith(":")&&(s+=t.sep),(0,t.isAbsolute)(s)||(s=(0,t.join)(m,s)),s=(0,t.normalize)(s),ne(s)}function ne(s){return w.isWindows?(s=(0,T.rtrim)(s,t.sep),s.endsWith(":")&&(s+=t.sep)):(s=(0,T.rtrim)(s,t.sep),s||(s=t.sep)),s}function O(s){const m=(0,t.normalize)(s);return w.isWindows?s.length>3?!1:n(m)&&(s.length===2||m.charCodeAt(2)===f.CharCode.Backslash):m===t.posix.sep}function n(s,m=w.isWindows){return m?F(s.charCodeAt(0))&&s.charCodeAt(1)===f.CharCode.Colon:!1}function i(s,m=w.isWindows){return n(s,m)?s[0]:void 0}function u(s,m,R){return m.length>s.length?-1:s===m?0:(R&&(s=s.toLowerCase(),m=m.toLowerCase()),s.indexOf(m))}function _(s){const m=s.split(":");let R,U,a;for(const q of m){const H=Number(q);(0,ie.isNumber)(H)?U===void 0?U=H:a===void 0&&(a=H):R=R?[R,q].join(":"):q}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:U!==void 0?U:void 0,column:a!==void 0?a:U!==void 0?1:void 0}}const A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",c="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function d(s,m,R=8){let U="";for(let q=0;q<R;q++){let H;q===0&&w.isWindows&&!m&&(R===3||R===4)?H=c:H=A,U+=H.charAt(Math.floor(Math.random()*H.length))}let a;return m?a=`${m}-${U}`:a=U,s?(0,t.join)(s,a):a}}),define(Ee[8],pe([0,1,4,25,3,2]),function(le,e,f,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=h,e.uriToFsPath=n,w=Oe(w);const ie=/^\w[\w\d+.-]*$/,Q=/^\//,B=/^\/\//;function I(c,d){if(!c.scheme&&d)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${c.authority}", path: "${c.path}", query: "${c.query}", fragment: "${c.fragment}"}`);if(c.scheme&&!ie.test(c.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(c.path){if(c.authority){if(!Q.test(c.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(B.test(c.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function j(c,d){return!c&&!d?"file":c}function x(c,d){switch(c){case"https":case"http":case"file":d?d[0]!==te&&(d=te+d):d=te;break}return d}const W="",te="/",M=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(d){return d instanceof l?!0:d?typeof d.authority=="string"&&typeof d.fragment=="string"&&typeof d.path=="string"&&typeof d.query=="string"&&typeof d.scheme=="string"&&typeof d.fsPath=="string"&&typeof d.with=="function"&&typeof d.toString=="function":!1}constructor(d,s,m,R,U,a=!1){typeof d=="object"?(this.scheme=d.scheme||W,this.authority=d.authority||W,this.path=d.path||W,this.query=d.query||W,this.fragment=d.fragment||W):(this.scheme=j(d,a),this.authority=s||W,this.path=x(this.scheme,m||W),this.query=R||W,this.fragment=U||W,I(this,a))}get fsPath(){return n(this,!1)}with(d){if(!d)return this;let{scheme:s,authority:m,path:R,query:U,fragment:a}=d;return s===void 0?s=this.scheme:s===null&&(s=W),m===void 0?m=this.authority:m===null&&(m=W),R===void 0?R=this.path:R===null&&(R=W),U===void 0?U=this.query:U===null&&(U=W),a===void 0?a=this.fragment:a===null&&(a=W),s===this.scheme&&m===this.authority&&R===this.path&&U===this.query&&a===this.fragment?this:new F(s,m,R,U,a)}static parse(d,s=!1){const m=M.exec(d);return m?new F(m[2]||W,A(m[4]||W),A(m[5]||W),A(m[7]||W),A(m[9]||W),s):new F(W,W,W,W,W)}static file(d){let s=W;if(T.isWindows&&(d=d.replace(/\\/g,te)),d[0]===te&&d[1]===te){const m=d.indexOf(te,2);m===-1?(s=d.substring(2),d=te):(s=d.substring(2,m),d=d.substring(m)||te)}return new F("file",s,d,W,W)}static from(d,s){return new F(d.scheme,d.authority,d.path,d.query,d.fragment,s)}static joinPath(d,...s){if(!d.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return T.isWindows&&d.scheme==="file"?m=l.file(w.win32.join(n(d,!0),...s)).path:m=w.posix.join(d.path,...s),d.with({path:m})}toString(d=!1){return i(this,d)}toJSON(){return this}static revive(d){if(d){if(d instanceof l)return d;{const s=new F(d);return s._formatted=d.external??null,s._fsPath=d._sep===v?d.fsPath??null:null,s}}else return d}}e.URI=l;function h(c){return!c||typeof c!="object"?!1:typeof c.scheme=="string"&&(typeof c.authority=="string"||typeof c.authority>"u")&&(typeof c.path=="string"||typeof c.path>"u")&&(typeof c.query=="string"||typeof c.query>"u")&&(typeof c.fragment=="string"||typeof c.fragment>"u")}const v=T.isWindows?1:void 0;class F extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(d=!1){return d?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const d={$mid:t.MarshalledId.Uri};return this._fsPath&&(d.fsPath=this._fsPath,d._sep=v),this._formatted&&(d.external=this._formatted),this.path&&(d.path=this.path),this.scheme&&(d.scheme=this.scheme),this.authority&&(d.authority=this.authority),this.query&&(d.query=this.query),this.fragment&&(d.fragment=this.fragment),d}}const z={[f.CharCode.Colon]:"%3A",[f.CharCode.Slash]:"%2F",[f.CharCode.QuestionMark]:"%3F",[f.CharCode.Hash]:"%23",[f.CharCode.OpenSquareBracket]:"%5B",[f.CharCode.CloseSquareBracket]:"%5D",[f.CharCode.AtSign]:"%40",[f.CharCode.ExclamationMark]:"%21",[f.CharCode.DollarSign]:"%24",[f.CharCode.Ampersand]:"%26",[f.CharCode.SingleQuote]:"%27",[f.CharCode.OpenParen]:"%28",[f.CharCode.CloseParen]:"%29",[f.CharCode.Asterisk]:"%2A",[f.CharCode.Plus]:"%2B",[f.CharCode.Comma]:"%2C",[f.CharCode.Semicolon]:"%3B",[f.CharCode.Equals]:"%3D",[f.CharCode.Space]:"%20"};function ne(c,d,s){let m,R=-1;for(let U=0;U<c.length;U++){const a=c.charCodeAt(U);if(a>=f.CharCode.a&&a<=f.CharCode.z||a>=f.CharCode.A&&a<=f.CharCode.Z||a>=f.CharCode.Digit0&&a<=f.CharCode.Digit9||a===f.CharCode.Dash||a===f.CharCode.Period||a===f.CharCode.Underline||a===f.CharCode.Tilde||d&&a===f.CharCode.Slash||s&&a===f.CharCode.OpenSquareBracket||s&&a===f.CharCode.CloseSquareBracket||s&&a===f.CharCode.Colon)R!==-1&&(m+=encodeURIComponent(c.substring(R,U)),R=-1),m!==void 0&&(m+=c.charAt(U));else{m===void 0&&(m=c.substr(0,U));const q=z[a];q!==void 0?(R!==-1&&(m+=encodeURIComponent(c.substring(R,U)),R=-1),m+=q):R===-1&&(R=U)}}return R!==-1&&(m+=encodeURIComponent(c.substring(R))),m!==void 0?m:c}function O(c){let d;for(let s=0;s<c.length;s++){const m=c.charCodeAt(s);m===f.CharCode.Hash||m===f.CharCode.QuestionMark?(d===void 0&&(d=c.substr(0,s)),d+=z[m]):d!==void 0&&(d+=c[s])}return d!==void 0?d:c}function n(c,d){let s;return c.authority&&c.path.length>1&&c.scheme==="file"?s=`//${c.authority}${c.path}`:c.path.charCodeAt(0)===f.CharCode.Slash&&(c.path.charCodeAt(1)>=f.CharCode.A&&c.path.charCodeAt(1)<=f.CharCode.Z||c.path.charCodeAt(1)>=f.CharCode.a&&c.path.charCodeAt(1)<=f.CharCode.z)&&c.path.charCodeAt(2)===f.CharCode.Colon?d?s=c.path.substr(1):s=c.path[1].toLowerCase()+c.path.substr(2):s=c.path,T.isWindows&&(s=s.replace(/\//g,"\\")),s}function i(c,d){const s=d?O:ne;let m="",{scheme:R,authority:U,path:a,query:q,fragment:H}=c;if(R&&(m+=R,m+=":"),(U||R==="file")&&(m+=te,m+=te),U){let K=U.indexOf("@");if(K!==-1){const S=U.substr(0,K);U=U.substr(K+1),K=S.lastIndexOf(":"),K===-1?m+=s(S,!1,!1):(m+=s(S.substr(0,K),!1,!1),m+=":",m+=s(S.substr(K+1),!1,!0)),m+="@"}U=U.toLowerCase(),K=U.lastIndexOf(":"),K===-1?m+=s(U,!1,!0):(m+=s(U.substr(0,K),!1,!0),m+=U.substr(K))}if(a){if(a.length>=3&&a.charCodeAt(0)===f.CharCode.Slash&&a.charCodeAt(2)===f.CharCode.Colon){const K=a.charCodeAt(1);K>=f.CharCode.A&&K<=f.CharCode.Z&&(a=`/${String.fromCharCode(K+32)}:${a.substr(3)}`)}else if(a.length>=2&&a.charCodeAt(1)===f.CharCode.Colon){const K=a.charCodeAt(0);K>=f.CharCode.A&&K<=f.CharCode.Z&&(a=`${String.fromCharCode(K+32)}:${a.substr(2)}`)}m+=s(a,!0,!1)}return q&&(m+="?",m+=s(q,!1,!1)),H&&(m+="#",m+=d?H:ne(H,!1,!1)),m}function u(c){try{return decodeURIComponent(c)}catch{return c.length>3?c.substr(0,3)+u(c.substr(3)):c}}const _=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function A(c){return c.match(_)?c.replace(_,d=>u(d)):c}}),define(Ee[35],pe([0,1,5,2,7,8,3]),function(le,e,f,t,w,T,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=B,e.matchesSomeScheme=I,e.getServerRootPath=x,f=Oe(f),t=Oe(t),ie=Oe(ie);var Q;(function(M){M.inMemory="inmemory",M.vscode="vscode",M.internal="private",M.walkThrough="walkThrough",M.walkThroughSnippet="walkThroughSnippet",M.http="http",M.https="https",M.file="file",M.mailto="mailto",M.untitled="untitled",M.data="data",M.command="command",M.vscodeRemote="vscode-remote",M.vscodeRemoteResource="vscode-remote-resource",M.vscodeManagedRemoteResource="vscode-managed-remote-resource",M.vscodeUserData="vscode-userdata",M.vscodeCustomEditor="vscode-custom-editor",M.vscodeNotebookCell="vscode-notebook-cell",M.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",M.vscodeNotebookCellOutput="vscode-notebook-cell-output",M.vscodeInteractiveInput="vscode-interactive-input",M.vscodeSettings="vscode-settings",M.vscodeWorkspaceTrust="vscode-workspace-trust",M.vscodeTerminal="vscode-terminal",M.vscodeChatCodeBlock="vscode-chat-code-block",M.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",M.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",M.vscodeChatSesssion="vscode-chat-editor",M.webviewPanel="webview-panel",M.vscodeWebview="vscode-webview",M.extension="extension",M.vscodeFileResource="vscode-file",M.tmp="tmp",M.vsls="vsls",M.vscodeSourceControl="vscode-scm",M.commentsInput="comment",M.codeSetting="code-setting"})(Q||(e.Schemas=Q={}));function B(M,l){return T.URI.isUri(M)?(0,w.equalsIgnoreCase)(M.scheme,l):(0,w.startsWithIgnoreCase)(M,l+":")}function I(M,...l){return l.some(h=>B(M,h))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class j{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(l){this._preferredWebSchema=l}setDelegate(l){this._delegate=l}setServerRootPath(l,h){this._serverRootPath=x(l,h)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return ie.posix.join(this._serverRootPath,Q.vscodeRemoteResource)}set(l,h,v){this._hosts[l]=h,this._ports[l]=v}setConnectionToken(l,h){this._connectionTokens[l]=h}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(l){if(this._delegate)try{return this._delegate(l)}catch(O){return f.onUnexpectedError(O),l}const h=l.authority;let v=this._hosts[h];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const F=this._ports[h],z=this._connectionTokens[h];let ne=`path=${encodeURIComponent(l.path)}`;return typeof z=="string"&&(ne+=`&${e.connectionTokenQueryName}=${encodeURIComponent(z)}`),T.URI.from({scheme:t.isWeb?this._preferredWebSchema:Q.vscodeRemoteResource,authority:`${v}:${F}`,path:this._remoteResourcesPath,query:ne})}}e.RemoteAuthorities=new j;function x(M,l){return ie.posix.join(l??"/",`${M.quality??"oss"}-${M.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class W{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(l){const h=this.toUri(l,le);return this.uriToBrowserUri(h)}uriToBrowserUri(l){return l.scheme===Q.vscodeRemote?e.RemoteAuthorities.rewrite(l):l.scheme===Q.file&&(t.isNative||t.webWorkerOrigin===`${Q.vscodeFileResource}://${W.FALLBACK_AUTHORITY}`)?l.with({scheme:Q.vscodeFileResource,authority:l.authority||W.FALLBACK_AUTHORITY,query:null,fragment:null}):l}asFileUri(l){const h=this.toUri(l,le);return this.uriToFileUri(h)}uriToFileUri(l){return l.scheme===Q.vscodeFileResource?l.with({scheme:Q.file,authority:l.authority!==W.FALLBACK_AUTHORITY?l.authority:null,query:null,fragment:null}):l}toUri(l,h){return T.URI.isUri(l)?l:T.URI.parse(h.toUrl(l))}}e.FileAccess=new W;var te;(function(M){const l=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);M.CoopAndCoep=Object.freeze(l.get("3"));const h="vscode-coi";function v(z){let ne;typeof z=="string"?ne=new URL(z).searchParams:z instanceof URL?ne=z.searchParams:T.URI.isUri(z)&&(ne=new URL(z.toString(!0)).searchParams);const O=ne?.get(h);if(O)return l.get(O)}M.getHeadersFromQuery=v;function F(z,ne,O){if(!globalThis.crossOriginIsolated)return;const n=ne&&O?"3":O?"2":"1";z instanceof URLSearchParams?z.set(h,n):z[h]=n}M.addSearchParam=F})(te||(e.COI=te={}))}),define(Ee[17],pe([0,1,4,6,35,3,2,7,8]),function(le,e,f,t,w,T,ie,Q,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=I,e.distinctParents=x,e.toLocalResource=te,t=Oe(t),T=Oe(T);function I(M){return(0,B.uriToFsPath)(M,!0)}class j{constructor(l){this._ignorePathCasing=l}compare(l,h,v=!1){return l===h?0:(0,Q.compare)(this.getComparisonKey(l,v),this.getComparisonKey(h,v))}isEqual(l,h,v=!1){return l===h?!0:!l||!h?!1:this.getComparisonKey(l,v)===this.getComparisonKey(h,v)}getComparisonKey(l,h=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,h,v=!1){if(l.scheme===h.scheme){if(l.scheme===w.Schemas.file)return t.isEqualOrParent(I(l),I(h),this._ignorePathCasing(l))&&l.query===h.query&&(v||l.fragment===h.fragment);if((0,e.isEqualAuthority)(l.authority,h.authority))return t.isEqualOrParent(l.path,h.path,this._ignorePathCasing(l),"/")&&l.query===h.query&&(v||l.fragment===h.fragment)}return!1}joinPath(l,...h){return B.URI.joinPath(l,...h)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return T.posix.basename(l.path)}extname(l){return T.posix.extname(l.path)}dirname(l){if(l.path.length===0)return l;let h;return l.scheme===w.Schemas.file?h=B.URI.file(T.dirname(I(l))).path:(h=T.posix.dirname(l.path),l.authority&&h.length&&h.charCodeAt(0)!==f.CharCode.Slash&&(console.error(`dirname("${l.toString})) resulted in a relative path`),h="/")),l.with({path:h})}normalizePath(l){if(!l.path.length)return l;let h;return l.scheme===w.Schemas.file?h=B.URI.file(T.normalize(I(l))).path:h=T.posix.normalize(l.path),l.with({path:h})}relativePath(l,h){if(l.scheme!==h.scheme||!(0,e.isEqualAuthority)(l.authority,h.authority))return;if(l.scheme===w.Schemas.file){const z=T.relative(I(l),I(h));return ie.isWindows?t.toSlashes(z):z}let v=l.path||"/";const F=h.path||"/";if(this._ignorePathCasing(l)){let z=0;for(const ne=Math.min(v.length,F.length);z<ne&&!(v.charCodeAt(z)!==F.charCodeAt(z)&&v.charAt(z).toLowerCase()!==F.charAt(z).toLowerCase());z++);v=F.substr(0,z)+v.substr(z)}return T.posix.relative(v,F)}resolvePath(l,h){if(l.scheme===w.Schemas.file){const v=B.URI.file(T.resolve(I(l),h));return l.with({authority:v.authority,path:v.path})}return h=t.toPosixPath(h),l.with({path:T.posix.resolve(l.path,h)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,h){return l===h||l!==void 0&&h!==void 0&&(0,Q.equalsIgnoreCase)(l,h)}hasTrailingPathSeparator(l,h=T.sep){if(l.scheme===w.Schemas.file){const v=I(l);return v.length>t.getRoot(v).length&&v[v.length-1]===h}else{const v=l.path;return v.length>1&&v.charCodeAt(v.length-1)===f.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,h=T.sep){return(0,e.hasTrailingPathSeparator)(l,h)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,h=T.sep){let v=!1;if(l.scheme===w.Schemas.file){const F=I(l);v=F!==void 0&&F.length===t.getRoot(F).length&&F[F.length-1]===h}else{h="/";const F=l.path;v=F.length===1&&F.charCodeAt(F.length-1)===f.CharCode.Slash}return!v&&!(0,e.hasTrailingPathSeparator)(l,h)?l.with({path:l.path+"/"}):l}}e.ExtUri=j,e.extUri=new j(()=>!1),e.extUriBiasedIgnorePathCase=new j(M=>M.scheme===w.Schemas.file?!ie.isLinux:!0),e.extUriIgnorePathCase=new j(M=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function x(M,l){const h=[];for(let v=0;v<M.length;v++){const F=l(M[v]);M.some((z,ne)=>ne===v?!1:(0,e.isEqualOrParent)(F,l(z)))||h.push(M[v])}return h}var W;(function(M){M.META_DATA_LABEL="label",M.META_DATA_DESCRIPTION="description",M.META_DATA_SIZE="size",M.META_DATA_MIME="mime";function l(h){const v=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(ne=>{const[O,n]=ne.split(":");O&&n&&v.set(O,n)});const z=h.path.substring(0,h.path.indexOf(";"));return z&&v.set(M.META_DATA_MIME,z),v}M.parseMetaData=l})(W||(e.DataUri=W={}));function te(M,l,h){if(l){let v=M.path;return v&&v[0]!==T.posix.sep&&(v=T.posix.sep+v),M.with({scheme:h,authority:l,path:v})}return M.with({scheme:h})}}),define(Ee[9],pe([0,1,15,5,14,13,17,2,29,11]),function(le,e,f,t,w,T,ie,Q,B,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=j,e.createCancelablePromise=x,e.raceCancellation=W,e.raceCancellationError=te,e.raceCancellablePromises=M,e.raceTimeout=l,e.asPromise=h,e.promiseWithResolvers=v,e.timeout=c,e.disposableTimeout=d,e.sequence=s,e.first=m,e.firstParallel=R,e.retry=Y,e.createCancelableAsyncIterable=L;function j(g){return!!g&&typeof g.then=="function"}function x(g){const r=new f.CancellationTokenSource,b=g(r.token),N=new Promise(($,oe)=>{const ve=r.token.onCancellationRequested(()=>{ve.dispose(),oe(new t.CancellationError)});Promise.resolve(b).then(ee=>{ve.dispose(),r.dispose(),$(ee)},ee=>{ve.dispose(),r.dispose(),oe(ee)})});return new class{cancel(){r.cancel(),r.dispose()}then($,oe){return N.then($,oe)}catch($){return this.then(void 0,$)}finally($){return N.finally($)}}}function W(g,r,b){return new Promise((N,$)=>{const oe=r.onCancellationRequested(()=>{oe.dispose(),N(b)});g.then(N,$).finally(()=>oe.dispose())})}function te(g,r){return new Promise((b,N)=>{const $=r.onCancellationRequested(()=>{$.dispose(),N(new t.CancellationError)});g.then(b,N).finally(()=>$.dispose())})}async function M(g){let r=-1;const b=g.map((N,$)=>N.then(oe=>(r=$,oe)));try{return await Promise.race(b)}finally{g.forEach((N,$)=>{$!==r&&N.cancel()})}}function l(g,r,b){let N;const $=setTimeout(()=>{N?.(void 0),b?.()},r);return Promise.race([g.finally(()=>clearTimeout($)),new Promise(oe=>N=oe)])}function h(g){return new Promise((r,b)=>{const N=g();j(N)?N.then(r,b):r(N)})}function v(){let g,r;return{promise:new Promise((N,$)=>{g=N,r=$}),resolve:g,reject:r}}class F{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(r){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=r,!this.queuedPromise){const b=()=>{if(this.queuedPromise=null,this.isDisposed)return;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then(b,b).then(N)})}return new Promise((b,N)=>{this.queuedPromise.then(b,N)})}return this.activePromise=r(),new Promise((b,N)=>{this.activePromise.then($=>{this.activePromise=null,b($)},$=>{this.activePromise=null,N($)})})}dispose(){this.isDisposed=!0}}e.Throttler=F;class z{constructor(){this.current=Promise.resolve(null)}queue(r){return this.current=this.current.then(()=>r(),()=>r())}}e.Sequencer=z;class ne{constructor(){this.promiseMap=new Map}queue(r,b){const $=(this.promiseMap.get(r)??Promise.resolve()).catch(()=>{}).then(b).finally(()=>{this.promiseMap.get(r)===$&&this.promiseMap.delete(r)});return this.promiseMap.set(r,$),$}}e.SequencerByKey=ne;const O=(g,r)=>{let b=!0;const N=setTimeout(()=>{b=!1,r()},g);return{isTriggered:()=>b,dispose:()=>{clearTimeout(N),b=!1}}},n=g=>{let r=!0;return queueMicrotask(()=>{r&&(r=!1,g())}),{isTriggered:()=>r,dispose:()=>{r=!1}}};class i{constructor(r){this.defaultDelay=r,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(r,b=this.defaultDelay){this.task=r,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise(($,oe)=>{this.doResolve=$,this.doReject=oe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const $=this.task;return this.task=null,$()}}));const N=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=b===B.MicrotaskDelay?n(N):O(b,N),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=i;class u{constructor(r){this.delayer=new i(r),this.throttler=new F}trigger(r,b){return this.delayer.trigger(()=>this.throttler.queue(r),b)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=u;class _{constructor(){this._isOpen=!1,this._promise=new Promise((r,b)=>{this._completePromise=r})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=_;class A extends _{constructor(r){super(),this._timeout=setTimeout(()=>this.open(),r)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=A;function c(g,r){return r?new Promise((b,N)=>{const $=setTimeout(()=>{oe.dispose(),b()},g),oe=r.onCancellationRequested(()=>{clearTimeout($),oe.dispose(),N(new t.CancellationError)})}):x(b=>c(g,b))}function d(g,r=0,b){const N=setTimeout(()=>{g(),b&&$.dispose()},r),$=(0,T.toDisposable)(()=>{clearTimeout(N),b?.deleteAndLeak($)});return b?.add($),$}function s(g){const r=[];let b=0;const N=g.length;function $(){return b<N?g[b++]():null}function oe(ve){ve!=null&&r.push(ve);const ee=$();return ee?ee.then(oe):Promise.resolve(r)}return Promise.resolve(null).then(oe)}function m(g,r=N=>!!N,b=null){let N=0;const $=g.length,oe=()=>{if(N>=$)return Promise.resolve(b);const ve=g[N++];return Promise.resolve(ve()).then(C=>r(C)?Promise.resolve(C):oe())};return oe()}function R(g,r=N=>!!N,b=null){if(g.length===0)return Promise.resolve(b);let N=g.length;const $=()=>{N=-1;for(const oe of g)oe.cancel?.()};return new Promise((oe,ve)=>{for(const ee of g)ee.then(C=>{--N>=0&&r(C)?($(),oe(C)):N===0&&oe(b)}).catch(C=>{--N>=0&&($(),ve(C))})})}class U{constructor(r){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=r,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new w.Emitter}whenIdle(){return this.size>0?w.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(r){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((b,N)=>{this.outstandingPromises.push({factory:r,c:b,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const r=this.outstandingPromises.shift();this.runningPromises++;const b=r.factory();b.then(r.c,r.e),b.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=U;class a extends U{constructor(){super(1)}}e.Queue=a;class q{constructor(){this.sequentializer=new se,this.tasks=0}queue(r){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,r())):this.sequentializer.run(this.tasks++,r())}}e.LimitedQueue=q;class H{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const r=new Le;return this.drainers.add(r),r.p}isDrained(){for(const[,r]of this.queues)if(r.size>0)return!1;return!0}queueSize(r,b=ie.extUri){const N=b.getComparisonKey(r);return this.queues.get(N)?.size??0}queueFor(r,b,N=ie.extUri){const $=N.getComparisonKey(r);let oe=this.queues.get($);if(!oe){oe=new a;const ve=this.drainListenerCount++,ee=w.Event.once(oe.onDrained)(()=>{oe?.dispose(),this.queues.delete($),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(ve),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new T.DisposableMap),this.drainListeners.set(ve,ee),this.queues.set($,oe)}return oe.queue(b)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const r of this.drainers)r.complete();this.drainers.clear()}dispose(){for(const[,r]of this.queues)r.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=H;class K{constructor(r,b){this._isDisposed=!1,this._token=-1,typeof r=="function"&&typeof b=="number"&&this.setIfNotSet(r,b)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(r,b){if(this._isDisposed)throw new t.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,r()},b)}setIfNotSet(r,b){if(this._isDisposed)throw new t.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,r()},b))}}e.TimeoutTimer=K;class S{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(r,b,N=globalThis){if(this.isDisposed)throw new t.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const $=N.setInterval(()=>{r()},b);this.disposable=(0,T.toDisposable)(()=>{N.clearInterval($),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=S;class J{constructor(r,b){this.timeoutToken=-1,this.runner=r,this.timeout=b,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(r=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,r)}get delay(){return this.timeout}set delay(r){this.timeout=r}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=J;class P{constructor(r,b){b%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${b}ms is not a multiple of 1000ms.`),this.runner=r,this.timeout=b,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(r=this.timeout){r%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${r}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(r/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=P;class y extends J{constructor(r,b){super(r,b),this.units=[]}work(r){this.units.push(r),this.isScheduled()||this.schedule()}doRun(){const r=this.units;this.units=[],this.runner?.(r)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=y;class G extends T.Disposable{constructor(r,b){super(),this.options=r,this.handler=b,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(r){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+r.length>this.options.maxBufferedWork)return!1}else if(this.pending+r.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const b of r)this.pendingWork.push(b);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new J(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=G,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(g,r)=>{(0,Q.setTimeout0)(()=>{if(b)return;const N=Date.now()+15;r(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,N-Date.now())}}))});let b=!1;return{dispose(){b||(b=!0)}}}:e._runWhenIdle=(g,r,b)=>{const N=g.requestIdleCallback(r,typeof b=="number"?{timeout:b}:void 0);let $=!1;return{dispose(){$||($=!0,g.cancelIdleCallback(N))}}},e.runWhenGlobalIdle=g=>(0,e._runWhenIdle)(globalThis,g)}();class V{constructor(r,b){this._didRun=!1,this._executor=()=>{try{this._value=b()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(r,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=V;class Z extends V{constructor(r){super(globalThis,r)}}e.GlobalIdleValue=Z;async function Y(g,r,b){let N;for(let $=0;$<b;$++)try{return await g()}catch(oe){N=oe,await c(r)}throw N}class se{isRunning(r){return typeof r=="number"?this._running?.taskId===r:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(r,b,N){return this._running={taskId:r,cancel:()=>N?.(),promise:b},b.then(()=>this.doneRunning(r),()=>this.doneRunning(r)),b}doneRunning(r){this._running&&r===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const r=this._queued;this._queued=void 0,r.run().then(r.promiseResolve,r.promiseReject)}}queue(r){if(this._queued)this._queued.run=r;else{const{promise:b,resolve:N,reject:$}=v();this._queued={run:r,promise:b,promiseResolve:N,promiseReject:$}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=se;class ge{constructor(r,b=()=>Date.now()){this.interval=r,this.nowFn=b,this.lastIncrementTime=0,this.value=0}increment(){const r=this.nowFn();return r-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=r,this.value=0),this.value++,this.value}}e.IntervalCounter=ge;var ye;(function(g){g[g.Resolved=0]="Resolved",g[g.Rejected=1]="Rejected"})(ye||(ye={}));class Le{get isRejected(){return this.outcome?.outcome===ye.Rejected}get isResolved(){return this.outcome?.outcome===ye.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===ye.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((r,b)=>{this.completeCallback=r,this.errorCallback=b})}complete(r){return new Promise(b=>{this.completeCallback(r),this.outcome={outcome:ye.Resolved,value:r},b()})}error(r){return new Promise(b=>{this.errorCallback(r),this.outcome={outcome:ye.Rejected,value:r},b()})}cancel(){return this.error(new t.CancellationError)}}e.DeferredPromise=Le;var Ie;(function(g){async function r(N){let $;const oe=await Promise.all(N.map(ve=>ve.then(ee=>ee,ee=>{$||($=ee)})));if(typeof $<"u")throw $;return oe}g.settled=r;function b(N){return new Promise(async($,oe)=>{try{await N($,oe)}catch(ve){oe(ve)}})}g.withAsyncBody=b})(Ie||(e.Promises=Ie={}));class ce{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(r){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=r.then(b=>(this._value=b,this._isResolved=!0,b),b=>{throw this._error=b,this._isResolved=!0,b})}requireValue(){if(!this._isResolved)throw new t.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=ce;class we{constructor(r){this._compute=r,this._promise=new I.Lazy(()=>new ce(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=we;var _e;(function(g){g[g.Initial=0]="Initial",g[g.DoneOK=1]="DoneOK",g[g.DoneError=2]="DoneError"})(_e||(_e={}));class be{static fromArray(r){return new be(b=>{b.emitMany(r)})}static fromPromise(r){return new be(async b=>{b.emitMany(await r)})}static fromPromises(r){return new be(async b=>{await Promise.all(r.map(async N=>b.emitOne(await N)))})}static merge(r){return new be(async b=>{await Promise.all(r.map(async N=>{for await(const $ of N)b.emitOne($)}))})}static{this.EMPTY=be.fromArray([])}constructor(r,b){this._state=_e.Initial,this._results=[],this._error=null,this._onReturn=b,this._onStateChanged=new w.Emitter,queueMicrotask(async()=>{const N={emitOne:$=>this.emitOne($),emitMany:$=>this.emitMany($),reject:$=>this.reject($)};try{await Promise.resolve(r(N)),this.resolve()}catch($){this.reject($)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}[Symbol.asyncIterator](){let r=0;return{next:async()=>{do{if(this._state===_e.DoneError)throw this._error;if(r<this._results.length)return{done:!1,value:this._results[r++]};if(this._state===_e.DoneOK)return{done:!0,value:void 0};await w.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(r,b){return new be(async N=>{for await(const $ of r)N.emitOne(b($))})}map(r){return be.map(this,r)}static filter(r,b){return new be(async N=>{for await(const $ of r)b($)&&N.emitOne($)})}filter(r){return be.filter(this,r)}static coalesce(r){return be.filter(r,b=>!!b)}coalesce(){return be.coalesce(this)}static async toPromise(r){const b=[];for await(const N of r)b.push(N);return b}toPromise(){return be.toPromise(this)}emitOne(r){this._state===_e.Initial&&(this._results.push(r),this._onStateChanged.fire())}emitMany(r){this._state===_e.Initial&&(this._results=this._results.concat(r),this._onStateChanged.fire())}resolve(){this._state===_e.Initial&&(this._state=_e.DoneOK,this._onStateChanged.fire())}reject(r){this._state===_e.Initial&&(this._state=_e.DoneError,this._error=r,this._onStateChanged.fire())}}e.AsyncIterableObject=be;class p extends be{constructor(r,b){super(b),this._source=r}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=p;function L(g){const r=new f.CancellationTokenSource,b=g(r.token);return new p(r,async N=>{const $=r.token.onCancellationRequested(()=>{$.dispose(),r.dispose(),N.reject(new t.CancellationError)});try{for await(const oe of b){if(r.token.isCancellationRequested)return;N.emitOne(oe)}$.dispose(),r.dispose()}catch(oe){$.dispose(),r.dispose(),N.reject(oe)}})}class D{constructor(r){this._deferred=new Le,this._asyncIterable=new be($=>{if(b){$.reject(b);return}return N&&$.emitMany(N),this._errorFn=oe=>$.reject(oe),this._emitFn=oe=>$.emitOne(oe),this._deferred.p},r);let b,N;this._emitFn=$=>{N||(N=[]),N.push($)},this._errorFn=$=>{b||(b=$)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(r){this._errorFn(r),this._deferred.complete()}emitOne(r){this._emitFn(r)}}e.AsyncIterableSource=D}),define(Ee[36],pe([0,1,18,19,43,9,6,26,3,2,17,8]),function(le,e,f,t,w,T,ie,Q,B,I,j,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=h,e.readdirSync=z,e.whenDeleted=n,e.configureFlushOnWrite=c,e.writeFileSync=s,f=Oe(f);var W;(function(P){P[P.UNLINK=0]="UNLINK",P[P.MOVE=1]="MOVE"})(W||(e.RimRafMode=W={}));async function te(P,y=W.UNLINK,G){if((0,ie.isRootOrDriveLetter)(P))throw new Error("rimraf - will refuse to recursively delete root");return y===W.UNLINK?l(P):M(P,G)}async function M(P,y=(0,ie.randomPath)((0,t.tmpdir)())){try{try{await f.promises.rename(P,y)}catch(G){return G.code==="ENOENT"?void 0:l(P)}l(y).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function l(P){return f.promises.rm(P,{recursive:!0,force:!0,maxRetries:3})}function h(P){if((0,ie.isRootOrDriveLetter)(P))throw new Error("rimraf - will refuse to recursively delete root");f.rmSync(P,{recursive:!0,force:!0,maxRetries:3})}async function v(P,y){return ne(await(y?F(P):f.promises.readdir(P)))}async function F(P){try{return await f.promises.readdir(P,{withFileTypes:!0})}catch(V){console.warn("[node.js fs] readdir with filetypes failed with error: ",V)}const y=[],G=await v(P);for(const V of G){let Z=!1,Y=!1,se=!1;try{const ge=await e.Promises.lstat((0,B.join)(P,V));Z=ge.isFile(),Y=ge.isDirectory(),se=ge.isSymbolicLink()}catch(ge){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ge)}y.push({name:V,isFile:()=>Z,isDirectory:()=>Y,isSymbolicLink:()=>se})}return y}function z(P){return ne(f.readdirSync(P))}function ne(P){return P.map(y=>typeof y=="string"?I.isMacintosh?(0,Q.normalizeNFC)(y):y:(y.name=I.isMacintosh?(0,Q.normalizeNFC)(y.name):y.name,y))}async function O(P){const y=await v(P),G=[];for(const V of y)await i.existsDirectory((0,B.join)(P,V))&&G.push(V);return G}function n(P,y=1e3){return new Promise(G=>{let V=!1;const Z=setInterval(()=>{V||(V=!0,f.access(P,Y=>{V=!1,Y&&(clearInterval(Z),G(void 0))}))},y)})}var i;(function(P){async function y(Z){let Y;try{if(Y=await e.Promises.lstat(Z),!Y.isSymbolicLink())return{stat:Y}}catch{}try{return{stat:await e.Promises.stat(Z),symbolicLink:Y?.isSymbolicLink()?{dangling:!1}:void 0}}catch(se){if(se.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};if(I.isWindows&&se.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Z)),symbolicLink:{dangling:!1}}}catch(ge){if(ge.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};throw ge}throw se}}P.stat=y;async function G(Z){try{const{stat:Y,symbolicLink:se}=await P.stat(Z);return Y.isFile()&&se?.dangling!==!0}catch{}return!1}P.existsFile=G;async function V(Z){try{const{stat:Y,symbolicLink:se}=await P.stat(Z);return Y.isDirectory()&&se?.dangling!==!0}catch{}return!1}P.existsDirectory=V})(i||(e.SymlinkSupport=i={}));const u=new T.ResourceQueue;function _(P,y,G){return u.queueFor(x.URI.file(P),()=>{const V=m(G);return new Promise((Z,Y)=>d(P,y,V,se=>se?Y(se):Z()))},j.extUriBiasedIgnorePathCase)}let A=!0;function c(P){A=P}function d(P,y,G,V){if(!A)return f.writeFile(P,y,{mode:G.mode,flag:G.flag},V);f.open(P,G.flag,G.mode,(Z,Y)=>{if(Z)return V(Z);f.writeFile(Y,y,se=>{if(se)return f.close(Y,()=>V(se));f.fdatasync(Y,ge=>(ge&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ge),c(!1)),f.close(Y,ye=>V(ye))))})})}function s(P,y,G){const V=m(G);if(!A)return f.writeFileSync(P,y,{mode:V.mode,flag:V.flag});const Z=f.openSync(P,V.flag,V.mode);try{f.writeFileSync(Z,y);try{f.fdatasyncSync(Z)}catch(Y){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Y),c(!1)}}finally{f.closeSync(Z)}}function m(P){return P?{mode:typeof P.mode=="number"?P.mode:438,flag:typeof P.flag=="string"?P.flag:"w"}:{mode:438,flag:"w"}}async function R(P,y,G=6e4){if(P!==y)try{I.isWindows&&typeof G=="number"?await U(P,y,Date.now(),G):await f.promises.rename(P,y)}catch(V){if(P.toLowerCase()!==y.toLowerCase()&&V.code==="EXDEV"||P.endsWith("."))await a(P,y,{preserveSymlinks:!1}),await te(P,W.MOVE);else throw V}}async function U(P,y,G,V,Z=0){try{return await f.promises.rename(P,y)}catch(Y){if(Y.code!=="EACCES"&&Y.code!=="EPERM"&&Y.code!=="EBUSY")throw Y;if(Date.now()-G>=V)throw console.error(`[node.js fs] rename failed after ${Z} retries with error: ${Y}`),Y;if(Z===0){let se=!1;try{const{stat:ge}=await i.stat(y);ge.isFile()||(se=!0)}catch{}if(se)throw Y}return await(0,T.timeout)(Math.min(100,Z*10)),U(P,y,G,V,Z+1)}}async function a(P,y,G){return H(P,y,{root:{source:P,target:y},options:G,handledSourcePaths:new Set})}const q=511;async function H(P,y,G){if(G.handledSourcePaths.has(P))return;G.handledSourcePaths.add(P);const{stat:V,symbolicLink:Z}=await i.stat(P);if(Z){if(G.options.preserveSymlinks)try{return await J(P,y,G)}catch{}if(Z.dangling)return}return V.isDirectory()?K(P,y,V.mode&q,G):S(P,y,V.mode&q)}async function K(P,y,G,V){await e.Promises.mkdir(y,{recursive:!0,mode:G});const Z=await v(P);for(const Y of Z)await H((0,B.join)(P,Y),(0,B.join)(y,Y),V)}async function S(P,y,G){await e.Promises.copyFile(P,y),await e.Promises.chmod(y,G)}async function J(P,y,G){let V=await e.Promises.readlink(P);(0,ie.isEqualOrParent)(V,G.root.source,!I.isLinux)&&(V=(0,B.join)(G.root.target,V.substr(G.root.source.length+1))),await e.Promises.symlink(V,y)}e.Promises=new class{get access(){return f.promises.access}get stat(){return f.promises.stat}get lstat(){return f.promises.lstat}get utimes(){return f.promises.utimes}get read(){return(P,y,G,V,Z)=>new Promise((Y,se)=>{f.read(P,y,G,V,Z,(ge,ye,Le)=>ge?se(ge):Y({bytesRead:ye,buffer:Le}))})}get readFile(){return f.promises.readFile}get write(){return(P,y,G,V,Z)=>new Promise((Y,se)=>{f.write(P,y,G,V,Z,(ge,ye,Le)=>ge?se(ge):Y({bytesWritten:ye,buffer:Le}))})}get appendFile(){return f.promises.appendFile}get fdatasync(){return(0,w.promisify)(f.fdatasync)}get truncate(){return f.promises.truncate}get copyFile(){return f.promises.copyFile}get open(){return(0,w.promisify)(f.open)}get close(){return(0,w.promisify)(f.close)}get symlink(){return f.promises.symlink}get readlink(){return f.promises.readlink}get chmod(){return f.promises.chmod}get mkdir(){return f.promises.mkdir}get unlink(){return f.promises.unlink}get rmdir(){return f.promises.rmdir}get realpath(){return(0,w.promisify)(f.realpath)}async exists(P){try{return await e.Promises.access(P),!0}catch{return!1}}get readdir(){return v}get readDirsInDir(){return O}get writeFile(){return _}get rm(){return te}get rename(){return R}get copy(){return a}}}),define(Ee[37],pe([0,1,38,2]),function(le,e,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveTerminalEncoding=B;const w={437:"cp437",850:"cp850",852:"cp852",855:"cp855",857:"cp857",860:"cp860",861:"cp861",863:"cp863",865:"cp865",866:"cp866",869:"cp869",936:"cp936",1252:"cp1252"};function T(I){const j=I.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return ie[j]||j}const ie={ibm866:"cp866",big5:"cp950"},Q="utf8";async function B(I){let j;const x=process.env.VSCODE_CLI_ENCODING;x?(I&&console.log(`Found VSCODE_CLI_ENCODING variable: ${x}`),j=Promise.resolve(x)):t.isWindows?j=new Promise(te=>{I&&console.log('Running "chcp" to detect terminal encoding...'),(0,f.exec)("chcp",(M,l,h)=>{if(l){I&&console.log(`Output from "chcp" command is: ${l}`);const v=Object.keys(w);for(const F of v)if(l.indexOf(F)>=0)return te(w[F])}return te(void 0)})}):j=new Promise(te=>{I&&console.log('Running "locale charmap" to detect terminal encoding...'),(0,f.exec)("locale charmap",(M,l,h)=>te(l))});const W=await j;return I&&console.log(`Detected raw terminal encoding: ${W}`),!W||W.toLowerCase()==="utf-8"||W.toLowerCase()===Q?Q:T(W)}}),define(Ee[39],pe([33,34]),function(le,e){return le.create("vs/platform/environment/node/argv",e)});var Ye=this&&this.__importDefault||function(le){return le&&le.__esModule?le:{default:le}};define(Ee[40],pe([0,1,44,2,39]),function(le,e,f,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0,e.parseArgs=Q,e.formatOptions=I,e.buildHelpMessage=te,e.buildVersionMessage=M,f=Ye(f);const T={o:(0,w.localize)(0,null),e:(0,w.localize)(1,null),t:(0,w.localize)(2,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,w.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,w.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,w.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,w.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,w.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,w.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,w.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,w.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,w.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,w.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,w.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,w.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,w.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,w.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,w.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,w.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,w.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,w.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,w.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,w.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,w.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,w.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,w.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,w.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,w.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,w.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,w.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,w.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,w.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,w.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,w.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,w.localize)(34,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,w.localize)(35,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,w.localize)(36,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,w.localize)(37,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,w.localize)(38,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const ie={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function Q(l,h,v=ie){const F=l.find(c=>c.length>0&&c[0]!=="-"),z={},ne=["_"],O=[],n={};let i;for(const c in h){const d=h[c];d.type==="subcommand"?c===F&&(i=d):(d.alias&&(z[c]=d.alias),d.type==="string"||d.type==="string[]"?(ne.push(c),d.deprecates&&ne.push(...d.deprecates)):d.type==="boolean"&&(O.push(c),d.deprecates&&O.push(...d.deprecates)),d.global&&(n[c]=d))}if(i&&F){const c=n;for(const R in i.options)c[R]=i.options[R];const d=l.filter(R=>R!==F),s=v.getSubcommandReporter?v.getSubcommandReporter(F):void 0,m=Q(d,c,s);return{[F]:m,_:[]}}const u=(0,f.default)(l,{string:ne,boolean:O,alias:z}),_={},A=u;_._=u._.map(c=>String(c)).filter(c=>c.length>0),delete A._;for(const c in h){const d=h[c];if(d.type==="subcommand")continue;d.alias&&delete A[d.alias];let s=A[c];if(d.deprecates)for(const m of d.deprecates)A.hasOwnProperty(m)&&(s||(s=A[m],s&&v.onDeprecatedOption(m,d.deprecationMessage||(0,w.localize)(39,null,c))),delete A[m]);if(typeof s<"u"){if(d.type==="string[]"){if(Array.isArray(s)||(s=[s]),!d.allowEmptyValue){const m=s.filter(R=>R.length>0);m.length!==s.length&&(v.onEmptyValue(c),s=m.length>0?m:void 0)}}else d.type==="string"&&(Array.isArray(s)?(s=s.pop(),v.onMultipleValues(c,s)):!s&&!d.allowEmptyValue&&(v.onEmptyValue(c),s=void 0));_[c]=s,d.deprecationMessage&&v.onDeprecatedOption(c,d.deprecationMessage)}delete A[c]}for(const c in A)v.onUnknownOption(c);return _}function B(l,h){let v="";return h.args&&(Array.isArray(h.args)?v=` <${h.args.join("> <")}>`:v=` <${h.args}>`),h.alias?`-${h.alias} --${l}${v}`:`--${l}${v}`}function I(l,h){const v=[];for(const F in l){const z=l[F],ne=B(F,z);v.push([ne,z.description])}return j(v,h)}function j(l,h){const F=l.reduce((O,n)=>Math.max(O,n[0].length),12)+2+1;if(h-F<25)return l.reduce((O,n)=>O.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const z=h-F-1,ne=[];for(const O of l){const n=O[0],i=W(O[1],z),u=x(F-n.length-2);ne.push("  "+n+u+i[0]);for(let _=1;_<i.length;_++)ne.push(x(F)+i[_])}return ne}function x(l){return" ".repeat(l)}function W(l,h){const v=[];for(;l.length;){const F=l.length<h?l.length:l.lastIndexOf(" ",h),z=l.slice(0,F).trim();l=l.slice(F),v.push(z)}return v}function te(l,h,v,F,z){const ne=process.stdout.isTTY&&process.stdout.columns||80,O=z?.noInputFiles!==!0?`[${(0,w.localize)(40,null)}...]`:"",n=[`${l} ${v}`];n.push(""),n.push(`${(0,w.localize)(41,null)}: ${h} [${(0,w.localize)(42,null)}]${O}`),n.push(""),z?.noPipe!==!0&&(t.isWindows?n.push((0,w.localize)(43,null,h)):n.push((0,w.localize)(44,null,h)),n.push(""));const i={},u=[];for(const _ in F){const A=F[_];if(A.type==="subcommand")A.description&&u.push({command:_,description:A.description});else if(A.description&&A.cat){let c=i[A.cat];c||(i[A.cat]=c={}),c[_]=A}}for(const _ in i){const A=_,c=i[A];c&&(n.push(T[A]),n.push(...I(c,ne)),n.push(""))}return u.length&&(n.push((0,w.localize)(45,null)),n.push(...j(u.map(_=>[_.command,_.description]),ne)),n.push("")),n.join(`
`)}function M(l,h){return`${l||(0,w.localize)(46,null)}
${h||(0,w.localize)(47,null)}
${process.arch}`}}),define(Ee[41],pe([0,1,19,9,6,36,37]),function(le,e,f,t,w,T,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasStdinWithoutTty=Q,e.stdinDataListener=B,e.getStdinFilePath=I,e.readFromStdin=j;function Q(){try{return!process.stdin.isTTY}catch{}return!1}function B(x){return new Promise(W=>{const te=()=>W(!0);setTimeout(()=>{process.stdin.removeListener("data",te),W(!1)},x),process.stdin.once("data",te)})}function I(){return(0,w.randomPath)((0,f.tmpdir)(),"code-stdin",3)}async function j(x,W,te){let[M,l]=await Promise.all([(0,ie.resolveTerminalEncoding)(W),new Promise((F,z)=>{le(["@vscode/iconv-lite-umd"],F,z)}).then(Oe),T.Promises.appendFile(x,"")]);l.encodingExists(M)||(console.log(`Unsupported terminal encoding: ${M}, falling back to UTF-8.`),M="utf8");const h=new t.Queue,v=l.getDecoder(M);process.stdin.on("data",F=>{const z=v.write(F);h.queue(()=>T.Promises.appendFile(x,z))}),process.stdin.on("end",()=>{const F=v.end();h.queue(async()=>{try{typeof F=="string"&&await T.Promises.appendFile(x,F)}finally{te?.()}})})}}),define(Ee[42],pe([0,1,18,19,6]),function(le,e,f,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=T;function T(ie){const Q=(0,w.randomPath)((0,t.tmpdir)());try{return(0,f.writeFileSync)(Q,""),ie&&console.log(`Marker file for --wait created: ${Q}`),Q}catch(B){ie&&console.error(`Failed to create marker file for --wait: ${B}`);return}}}),define(Ee[45],pe([0,1,18,46,38,47,16,3,40,42,41,9]),function(le,e,f,t,w,T,ie,Q,B,I,j,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=z,f=Oe(f),t=Oe(t),w=Oe(w),T=Oe(T);const W=H=>{switch(H){case"user-data-dir":case"extensions-dir":case"export-default-configuration":case"install-source":case"enable-smoke-test-driver":case"extensions-download-dir":case"builtin-extensions-dir":case"telemetry":return!1;default:return!0}},te=H=>{switch(H){case"version":case"help":case"folder-uri":case"file-uri":case"add":case"diff":case"merge":case"wait":case"goto":case"reuse-window":case"new-window":case"status":case"install-extension":case"uninstall-extension":case"update-extensions":case"list-extensions":case"force":case"show-versions":case"category":case"verbose":case"remote":case"locate-shell-integration-path":return!0;default:return!1}},M=process.env.VSCODE_IPC_HOOK_CLI,l=process.env.VSCODE_CLIENT_COMMAND,h=process.env.VSCODE_CLIENT_COMMAND_CWD,v=process.env.VSCODE_CLI_AUTHORITY,F=process.env.VSCODE_STDIN_FILE_PATH;async function z(H,K){if(!M&&!l){console.log("Command is only available in WSL or inside a Visual Studio Code terminal.");return}const S={...B.OPTIONS,gitCredential:{type:"string"},openExternal:{type:"boolean"}},J=l?W:te;for(const ce in B.OPTIONS){const we=ce;J(we)||delete S[we]}M&&(S.openExternal={type:"boolean"});const P={onMultipleValues:(ce,we)=>{console.error(`Option '${ce}' can only be defined once. Using value ${we}.`)},onEmptyValue:ce=>{console.error(`Ignoring option '${ce}': Value must not be empty.`)},onUnknownOption:ce=>{console.error(`Ignoring option '${ce}': not supported for ${H.executableName}.`)},onDeprecatedOption:(ce,we)=>{console.warn(`Option '${ce}' is deprecated: ${we}`)}},y=(0,B.parseArgs)(K,S,P),G=v?s:ce=>ce,V=!!y.verbose;if(y.help){console.log((0,B.buildHelpMessage)(H.productName,H.executableName,H.version,S));return}if(y.version){console.log((0,B.buildVersionMessage)(H.version,H.commit));return}if(y["locate-shell-integration-path"]){let ce;switch(y["locate-shell-integration-path"]){case"bash":ce="shellIntegration-bash.sh";break;case"pwsh":ce="shellIntegration.ps1";break;case"zsh":ce="shellIntegration-rc.zsh";break;case"fish":ce="fish_xdg_data/fish/vendor_conf.d/shellIntegration.fish";break;default:throw new Error("Error using --locate-shell-integration-path: Invalid shell type")}console.log((0,Q.resolve)(__dirname,"../..","workbench","contrib","terminal","browser","media",ce));return}if(M&&y.openExternal){n(y._,V);return}let Z=y.remote;(Z==="local"||Z==="false"||Z==="")&&(Z=null);const Y=(y["folder-uri"]||[]).map(G);y["folder-uri"]=Y;const se=(y["file-uri"]||[]).map(G);y["file-uri"]=se;const ge=y._;let ye=!1;for(const ce of ge)ce==="-"?ye=!0:d(ce,G,Y,se);y._=[];let Le;if(ye&&(0,j.hasStdinWithoutTty)())try{let ce=F;if(!ce){ce=(0,j.getStdinFilePath)();const we=new x.DeferredPromise;await(0,j.readFromStdin)(ce,V,()=>we.complete()),y.wait||(Le=we.p)}d(ce,G,Y,se),y["skip-add-to-recently-opened"]=!0,console.log(`Reading from stdin via: ${ce}`)}catch(ce){console.log(`Failed to create file to read via stdin: ${ce.toString()}`)}y.extensionDevelopmentPath&&(y.extensionDevelopmentPath=y.extensionDevelopmentPath.map(ce=>G(c(ce).href))),y.extensionTestsPath&&(y.extensionTestsPath=G(c(y.extensionTestsPath).href));const Ie=y["crash-reporter-directory"];if(Ie!==void 0&&!Ie.match(/^([a-zA-Z]:[\\\/])/)){console.log(`The crash reporter directory '${Ie}' must be an absolute Windows path (e.g. c:/crashes)`);return}if(l){if(y["install-extension"]!==void 0||y["uninstall-extension"]!==void 0||y["list-extensions"]||y["update-extensions"]){const _e=[];y["install-extension"]?.forEach(p=>_e.push("--install-extension",p)),y["uninstall-extension"]?.forEach(p=>_e.push("--uninstall-extension",p)),["list-extensions","force","show-versions","category"].forEach(p=>{const L=y[p];L!==void 0&&_e.push(`--${p}=${L}`)}),y["update-extensions"]&&_e.push("--update-extensions"),w.fork((0,Q.join)(__dirname,"../../../server-main.js"),_e,{stdio:"inherit"}).on("error",p=>console.log(p));return}const ce=[];for(const _e in y){const be=y[_e];if(typeof be=="boolean")be&&ce.push("--"+_e);else if(Array.isArray(be))for(const p of be)ce.push(`--${_e}=${p.toString()}`);else be&&ce.push(`--${_e}=${be.toString()}`)}Z!==null&&ce.push(`--remote=${Z||v}`);const we=(0,Q.extname)(l);if(we===".bat"||we===".cmd"){const _e=h||(0,ie.cwd)();V&&console.log(`Invoking: cmd.exe /C ${l} ${ce.join(" ")} in ${_e}`),w.spawn("cmd.exe",["/C",l,...ce],{stdio:"inherit",cwd:_e})}else{const _e=(0,Q.dirname)(l),be={...process.env,ELECTRON_RUN_AS_NODE:"1"};if(ce.unshift("resources/app/out/cli.js"),V&&console.log(`Invoking: cd "${_e}" && ELECTRON_RUN_AS_NODE=1 "${l}" "${ce.join('" "')}"`),ne()){V&&console.log("Using pipes for output.");const p=w.spawn(l,ce,{cwd:_e,env:be,stdio:["inherit","pipe","pipe"]});p.stdout.on("data",L=>process.stdout.write(L)),p.stderr.on("data",L=>process.stderr.write(L))}else w.spawn(l,ce,{cwd:_e,env:be,stdio:"inherit"})}}else{if(y.status){i({type:"status"},V).then(we=>{console.log(we)}).catch(we=>{console.error("Error when requesting status:",we)});return}if(y["install-extension"]!==void 0||y["uninstall-extension"]!==void 0||y["list-extensions"]||y["update-extensions"]){i({type:"extensionManagement",list:y["list-extensions"]?{showVersions:y["show-versions"],category:y.category}:void 0,install:u(y["install-extension"]),uninstall:u(y["uninstall-extension"]),force:y.force},V).then(we=>{console.log(we)}).catch(we=>{console.error("Error when invoking the extension management command:",we)});return}let ce;if(y.wait){if(!se.length){console.log("At least one file must be provided to wait for.");return}ce=(0,I.createWaitMarkerFileSync)(V)}i({type:"open",fileURIs:se,folderURIs:Y,diffMode:y.diff,mergeMode:y.merge,addMode:y.add,gotoLineMode:y.goto,forceReuseWindow:y["reuse-window"],forceNewWindow:y["new-window"],waitMarkerFilePath:ce,remoteAuthority:Z},V).catch(we=>{console.error("Error when invoking the open command:",we)}),ce&&O(ce),Le&&await Le}}function ne(){if(process.env.WSL_DISTRO_NAME)try{return w.execSync("uname -r",{encoding:"utf8"}).includes("-microsoft-")}catch{}return!1}async function O(H){for(;f.existsSync(H);)await new Promise(K=>setTimeout(K,1e3))}function n(H,K){const S=[];for(const J of H)try{/^(http|https|file):\/\//.test(J)?S.push(t.parse(J).href):S.push(c(J).href)}catch{console.log(`Invalid url: ${J}`)}S.length&&i({type:"openExternal",uris:S},K).catch(J=>{console.error("Error when invoking the open external command:",J)})}function i(H,K){return K&&console.log(JSON.stringify(H,null,"  ")),new Promise((S,J)=>{const P=JSON.stringify(H);if(!M){console.log("Message "+P),S("");return}const y={socketPath:M,path:"/",method:"POST",headers:{"content-type":"application/json",accept:"application/json"}},G=T.request(y,V=>{if(V.headers["content-type"]!=="application/json"){J("Error in response: Invalid content type: Expected 'application/json', is: "+V.headers["content-type"]);return}const Z=[];V.setEncoding("utf8"),V.on("data",Y=>{Z.push(Y)}),V.on("error",Y=>_("Error in response.",Y)),V.on("end",()=>{const Y=Z.join("");try{const se=JSON.parse(Y);V.statusCode===200?S(se):J(se)}catch{J("Error in response: Unable to parse response as JSON: "+Y)}})});G.on("error",V=>_("Error in request.",V)),G.write(P),G.end()})}function u(H){return H?.map(K=>/\.vsix$/i.test(K)?c(K).href:K)}function _(H,K){console.error("Unable to connect to VSCodium server: "+H),console.error(K),process.exit(1)}const A=process.env.PWD||(0,ie.cwd)();function c(H){return H=H.trim(),H=(0,Q.resolve)(A,H),t.pathToFileURL(H)}function d(H,K,S,J){const P=c(H),y=K(P.href);try{const G=f.lstatSync(f.realpathSync(H));G.isFile()?J.push(y):G.isDirectory()?S.push(y):H==="/dev/null"&&J.push(y)}catch(G){G.code==="ENOENT"?J.push(y):console.log(`Problem accessing file ${H}. Ignoring file`,G)}}function s(H){return H.replace(/^file:\/\//,"vscode-remote://"+v)}const[,,m,R,U,a,...q]=process.argv;z({productName:m,version:R,commit:U,executableName:a},q).then(null,H=>{console.error(H.message||H.stack||H)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/8512cb3341b26a5dba985a9a17eed8d7c3362886/core/vs/server/node/server.cli.js.map
