/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/base/node/pfs","vs/base/common/map","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","fs","os","vs/base/common/process","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/charCode","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/iterator","vs/platform/telemetry/common/telemetryUtils","vs/platform/contextkey/common/contextkey","vs/base/common/json","vs/base/common/performance","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stopwatch","vs/editor/common/core/range","vs/base/common/marshalling","vs/base/parts/ipc/common/ipc","vs/platform/files/common/watcher","vs/platform/terminal/common/terminal","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/stream","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uriIpc","child_process","vs/base/parts/ipc/common/ipc.net","vs/platform/product/common/product","vs/base/common/semver/semver","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/lazy","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/mime","vs/base/common/processes","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/platform/extensions/common/extensionValidator","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/common/themables","path","net","vs/editor/common/core/position","vs/base/common/glob","vs/base/node/zip","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/node/extensionSignatureVerificationService","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/storage/common/storage","vs/server/node/serverConnectionToken","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/assert","vs/base/common/normalization","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/encodedTokenAttributes","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/environmentService","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/terminalEnvironment","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/contrib/terminal/common/remote/terminal","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/collections","vs/base/common/equals","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/skipList","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/common/labels","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/config/editorOptions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/chat/common/languageModels","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","fs/promises","readline","util","minimist","assert","https","http","vs/server/node/server.main"],Ie=function(se){for(var e=[],i=0,r=se.length;i<r;i++)e[i]=ye[se[i]];return e};define(ye[104],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.LoaderEventType=e.isESM=void 0,e.isESM=!1;var i;(function(w){w[w.LoaderAvailable=1]="LoaderAvailable",w[w.BeginLoadingScript=10]="BeginLoadingScript",w[w.EndLoadingScriptOK=11]="EndLoadingScriptOK",w[w.EndLoadingScriptError=12]="EndLoadingScriptError",w[w.BeginInvokeFactory=21]="BeginInvokeFactory",w[w.EndInvokeFactory=22]="EndInvokeFactory",w[w.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",w[w.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",w[w.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",w[w.NodeEndNativeRequire=34]="NodeEndNativeRequire",w[w.CachedDataFound=60]="CachedDataFound",w[w.CachedDataMissed=61]="CachedDataMissed",w[w.CachedDataRejected=62]="CachedDataRejected",w[w.CachedDataCreated=63]="CachedDataCreated"})(i||(e.LoaderEventType=i={}));class r{static get(){const C=new Map,R=new Map,_=new Map,b=new Map;function o(a,f){a.has(f.detail)||a.set(f.detail,-f.timestamp)}function D(a,f){const m=a.get(f.detail);m&&(m>=0||a.set(f.detail,m+f.timestamp))}let y=[];typeof se=="function"&&typeof se.getStats=="function"&&(y=se.getStats().slice(0).sort((a,f)=>a.timestamp-f.timestamp));for(const a of y)switch(a.type){case i.BeginLoadingScript:o(C,a);break;case i.EndLoadingScriptOK:case i.EndLoadingScriptError:D(C,a);break;case i.BeginInvokeFactory:o(R,a);break;case i.EndInvokeFactory:D(R,a);break;case i.NodeBeginNativeRequire:o(_,a);break;case i.NodeEndNativeRequire:D(_,a);break;case i.NodeBeginEvaluatingScript:o(b,a);break;case i.NodeEndEvaluatingScript:D(b,a);break}let d=0;_.forEach(a=>d+=a);function E(a){const f=[];return a.forEach((m,p)=>f.push([p,m])),f}return{amdLoad:E(C),amdInvoke:E(R),nodeRequire:E(_),nodeEval:E(b),nodeRequireTotal:d}}static toMarkdownTable(C,R){let _="";const b=[];return C.forEach((o,D)=>{b[D]=o.length}),R.forEach(o=>{o.forEach((D,y)=>{typeof D>"u"&&(D=o[y]="-");const d=D.toString().length;b[y]=Math.max(d,b[y])})}),C.forEach((o,D)=>{_+=`| ${o+" ".repeat(b[D]-o.toString().length)} `}),_+=`|
`,C.forEach((o,D)=>{_+=`| ${"-".repeat(b[D])} `}),_+=`|
`,R.forEach(o=>{o.forEach((D,y)=>{typeof D<"u"&&(_+=`| ${D+" ".repeat(b[y]-D.toString().length)} `)}),_+=`|
`}),_}}e.LoaderStats=r}),define(ye[105],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=i,e.findLastIdx=r,e.findLastMonotonous=w,e.findLastIdxMonotonous=C,e.findFirstMonotonous=R,e.findFirstIdxMonotonousOrArrLen=_,e.findFirstIdxMonotonous=b,e.findFirstMax=D,e.findLastMax=y,e.findFirstMin=d,e.findMaxIdx=E,e.mapFindFirst=a;function i(f,m){const p=r(f,m);if(p!==-1)return f[p]}function r(f,m,p=f.length-1){for(let S=p;S>=0;S--){const g=f[S];if(m(g))return S}return-1}function w(f,m){const p=C(f,m);return p===-1?void 0:f[p]}function C(f,m,p=0,S=f.length){let g=p,v=S;for(;g<v;){const t=Math.floor((g+v)/2);m(f[t])?g=t+1:v=t}return g-1}function R(f,m){const p=_(f,m);return p===f.length?void 0:f[p]}function _(f,m,p=0,S=f.length){let g=p,v=S;for(;g<v;){const t=Math.floor((g+v)/2);m(f[t])?v=t:g=t+1}return g}function b(f,m,p=0,S=f.length){const g=_(f,m,p,S);return g===f.length?-1:g}class o{static{this.assertInvariants=!1}constructor(m){this._array=m,this._findLastMonotonousLastIdx=0}findLastMonotonous(m){if(o.assertInvariants){if(this._prevFindLastPredicate){for(const S of this._array)if(this._prevFindLastPredicate(S)&&!m(S))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=m}const p=C(this._array,m,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=p+1,p===-1?void 0:this._array[p]}}e.MonotonousArray=o;function D(f,m){if(f.length===0)return;let p=f[0];for(let S=1;S<f.length;S++){const g=f[S];m(g,p)>0&&(p=g)}return p}function y(f,m){if(f.length===0)return;let p=f[0];for(let S=1;S<f.length;S++){const g=f[S];m(g,p)>=0&&(p=g)}return p}function d(f,m){return D(f,(p,S)=>-m(p,S))}function E(f,m){if(f.length===0)return-1;let p=0;for(let S=1;S<f.length;S++){const g=f[S];m(g,f[p])>0&&(p=S)}return p}function a(f,m){for(const p of f){const S=m(p);if(S!==void 0)return S}}}),define(ye[35],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var i;(function(r){r[r.Null=0]="Null",r[r.Backspace=8]="Backspace",r[r.Tab=9]="Tab",r[r.LineFeed=10]="LineFeed",r[r.CarriageReturn=13]="CarriageReturn",r[r.Space=32]="Space",r[r.ExclamationMark=33]="ExclamationMark",r[r.DoubleQuote=34]="DoubleQuote",r[r.Hash=35]="Hash",r[r.DollarSign=36]="DollarSign",r[r.PercentSign=37]="PercentSign",r[r.Ampersand=38]="Ampersand",r[r.SingleQuote=39]="SingleQuote",r[r.OpenParen=40]="OpenParen",r[r.CloseParen=41]="CloseParen",r[r.Asterisk=42]="Asterisk",r[r.Plus=43]="Plus",r[r.Comma=44]="Comma",r[r.Dash=45]="Dash",r[r.Period=46]="Period",r[r.Slash=47]="Slash",r[r.Digit0=48]="Digit0",r[r.Digit1=49]="Digit1",r[r.Digit2=50]="Digit2",r[r.Digit3=51]="Digit3",r[r.Digit4=52]="Digit4",r[r.Digit5=53]="Digit5",r[r.Digit6=54]="Digit6",r[r.Digit7=55]="Digit7",r[r.Digit8=56]="Digit8",r[r.Digit9=57]="Digit9",r[r.Colon=58]="Colon",r[r.Semicolon=59]="Semicolon",r[r.LessThan=60]="LessThan",r[r.Equals=61]="Equals",r[r.GreaterThan=62]="GreaterThan",r[r.QuestionMark=63]="QuestionMark",r[r.AtSign=64]="AtSign",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.OpenSquareBracket=91]="OpenSquareBracket",r[r.Backslash=92]="Backslash",r[r.CloseSquareBracket=93]="CloseSquareBracket",r[r.Caret=94]="Caret",r[r.Underline=95]="Underline",r[r.BackTick=96]="BackTick",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.OpenCurlyBrace=123]="OpenCurlyBrace",r[r.Pipe=124]="Pipe",r[r.CloseCurlyBrace=125]="CloseCurlyBrace",r[r.Tilde=126]="Tilde",r[r.NoBreakSpace=160]="NoBreakSpace",r[r.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",r[r.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",r[r.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",r[r.U_Combining_Tilde=771]="U_Combining_Tilde",r[r.U_Combining_Macron=772]="U_Combining_Macron",r[r.U_Combining_Overline=773]="U_Combining_Overline",r[r.U_Combining_Breve=774]="U_Combining_Breve",r[r.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",r[r.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",r[r.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",r[r.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",r[r.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",r[r.U_Combining_Caron=780]="U_Combining_Caron",r[r.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",r[r.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",r[r.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",r[r.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",r[r.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",r[r.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",r[r.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",r[r.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",r[r.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",r[r.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",r[r.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",r[r.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",r[r.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",r[r.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",r[r.U_Combining_Horn=795]="U_Combining_Horn",r[r.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",r[r.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",r[r.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",r[r.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",r[r.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",r[r.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",r[r.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",r[r.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",r[r.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",r[r.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",r[r.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",r[r.U_Combining_Cedilla=807]="U_Combining_Cedilla",r[r.U_Combining_Ogonek=808]="U_Combining_Ogonek",r[r.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",r[r.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",r[r.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",r[r.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",r[r.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",r[r.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",r[r.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",r[r.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",r[r.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",r[r.U_Combining_Low_Line=818]="U_Combining_Low_Line",r[r.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",r[r.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",r[r.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",r[r.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",r[r.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",r[r.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",r[r.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",r[r.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",r[r.U_Combining_Square_Below=827]="U_Combining_Square_Below",r[r.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",r[r.U_Combining_X_Above=829]="U_Combining_X_Above",r[r.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",r[r.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",r[r.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",r[r.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",r[r.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",r[r.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",r[r.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",r[r.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",r[r.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",r[r.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",r[r.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",r[r.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",r[r.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",r[r.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",r[r.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",r[r.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",r[r.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",r[r.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",r[r.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",r[r.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",r[r.U_Combining_Fermata=850]="U_Combining_Fermata",r[r.U_Combining_X_Below=851]="U_Combining_X_Below",r[r.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",r[r.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",r[r.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",r[r.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",r[r.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",r[r.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",r[r.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",r[r.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",r[r.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",r[r.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",r[r.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",r[r.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",r[r.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",r[r.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",r[r.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",r[r.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",r[r.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",r[r.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",r[r.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",r[r.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",r[r.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",r[r.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",r[r.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",r[r.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",r[r.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",r[r.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",r[r.LINE_SEPARATOR=8232]="LINE_SEPARATOR",r[r.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",r[r.NEXT_LINE=133]="NEXT_LINE",r[r.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",r[r.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",r[r.U_DIAERESIS=168]="U_DIAERESIS",r[r.U_MACRON=175]="U_MACRON",r[r.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",r[r.U_CEDILLA=184]="U_CEDILLA",r[r.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",r[r.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",r[r.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",r[r.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",r[r.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",r[r.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",r[r.U_BREVE=728]="U_BREVE",r[r.U_DOT_ABOVE=729]="U_DOT_ABOVE",r[r.U_RING_ABOVE=730]="U_RING_ABOVE",r[r.U_OGONEK=731]="U_OGONEK",r[r.U_SMALL_TILDE=732]="U_SMALL_TILDE",r[r.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",r[r.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",r[r.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",r[r.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",r[r.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",r[r.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",r[r.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",r[r.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",r[r.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",r[r.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",r[r.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",r[r.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",r[r.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",r[r.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",r[r.U_GREEK_TONOS=900]="U_GREEK_TONOS",r[r.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",r[r.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",r[r.U_GREEK_PSILI=8127]="U_GREEK_PSILI",r[r.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",r[r.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",r[r.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",r[r.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",r[r.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",r[r.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",r[r.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",r[r.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",r[r.U_GREEK_VARIA=8175]="U_GREEK_VARIA",r[r.U_GREEK_OXIA=8189]="U_GREEK_OXIA",r[r.U_GREEK_DASIA=8190]="U_GREEK_DASIA",r[r.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",r[r.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",r[r.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",r[r.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",r[r.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",r[r.U_OVERLINE=8254]="U_OVERLINE",r[r.UTF8_BOM=65279]="UTF8_BOM",r[r.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",r[r.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(i||(e.CharCode=i={}))}),define(ye[157],Ie([1,0]),function(se,e){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.SetWithKey=void 0,e.groupBy=r,e.diffSets=w,e.diffMaps=C,e.intersection=R;function r(b,o){const D=Object.create(null);for(const y of b){const d=o(y);let E=D[d];E||(E=D[d]=[]),E.push(y)}return D}function w(b,o){const D=[],y=[];for(const d of b)o.has(d)||D.push(d);for(const d of o)b.has(d)||y.push(d);return{removed:D,added:y}}function C(b,o){const D=[],y=[];for(const[d,E]of b)o.has(d)||D.push(E);for(const[d,E]of o)b.has(d)||y.push(E);return{removed:D,added:y}}function R(b,o){const D=new Set;for(const y of o)b.has(y)&&D.add(y);return D}class _{static{i=Symbol.toStringTag}constructor(o,D){this.toKey=D,this._map=new Map,this[i]="SetWithKey";for(const y of o)this.add(y)}get size(){return this._map.size}add(o){const D=this.toKey(o);return this._map.set(D,o),this}delete(o){return this._map.delete(this.toKey(o))}has(o){return this._map.has(this.toKey(o))}*entries(){for(const o of this._map.values())yield[o,o]}keys(){return this.values()}*values(){for(const o of this._map.values())yield o}clear(){this._map.clear()}forEach(o,D){this._map.forEach(y=>o.call(D,y,y,this))}[Symbol.iterator](){return this.values()}}e.SetWithKey=_}),define(ye[78],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=r,e.debounce=w,e.throttle=C;function i(R){return(_,b,o)=>{let D=null,y=null;if(typeof o.value=="function"?(D="value",y=o.value):typeof o.get=="function"&&(D="get",y=o.get),!y)throw new Error("not supported");o[D]=R(y,b)}}function r(R,_,b){let o=null,D=null;if(typeof b.value=="function"?(o="value",D=b.value,D.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(o="get",D=b.get),!D)throw new Error("not supported");const y=`$memoize$${_}`;b[o]=function(...d){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:D.apply(this,d)}),this[y]}}function w(R,_,b){return i((o,D)=>{const y=`$debounce$${D}`,d=`$debounce$result$${D}`;return function(...E){this[d]||(this[d]=b?b():void 0),clearTimeout(this[y]),_&&(this[d]=_(this[d],...E),E=[this[d]]),this[y]=setTimeout(()=>{o.apply(this,E),this[d]=b?b():void 0},R)}})}function C(R,_,b){return i((o,D)=>{const y=`$throttle$timer$${D}`,d=`$throttle$result$${D}`,E=`$throttle$lastRun$${D}`,a=`$throttle$pending$${D}`;return function(...f){if(this[d]||(this[d]=b?b():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),_&&(this[d]=_(this[d],...f)),this[a])return;const m=this[E]+R;m<=Date.now()?(this[E]=Date.now(),o.apply(this,[this[d]]),this[d]=b?b():void 0):(this[a]=!0,this[y]=setTimeout(()=>{this[a]=!1,this[E]=Date.now(),o.apply(this,[this[d]]),this[d]=b?b():void 0},m-Date.now()))}})}}),define(ye[10],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=r,e.isSigPipeError=w,e.onUnexpectedError=C,e.onUnexpectedExternalError=R,e.transformErrorForSerialization=_,e.transformErrorFromSerialization=b,e.isCancellationError=D,e.canceled=d,e.illegalArgument=E,e.illegalState=a,e.getErrorMessage=m;class i{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?v.isErrorNoTelemetry(n)?new v(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(h=>{h(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=i,e.errorHandler=new i;function r(l){e.errorHandler.setUnexpectedErrorHandler(l)}function w(l){if(!l||typeof l!="object")return!1;const n=l;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function C(l){D(l)||e.errorHandler.onUnexpectedError(l)}function R(l){D(l)||e.errorHandler.onUnexpectedExternalError(l)}function _(l){if(l instanceof Error){const{name:n,message:h}=l,s=l.stacktrace||l.stack;return{$isError:!0,name:n,message:h,stack:s,noTelemetry:v.isErrorNoTelemetry(l)}}return l}function b(l){let n;return l.noTelemetry?n=new v:(n=new Error,n.name=l.name),n.message=l.message,n.stack=l.stack,n}const o="Canceled";function D(l){return l instanceof y?!0:l instanceof Error&&l.name===o&&l.message===o}class y extends Error{constructor(){super(o),this.name=this.message}}e.CancellationError=y;function d(){const l=new Error(o);return l.name=l.message,l}function E(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}function a(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}class f extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=f;function m(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}class p extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=p;class S extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=S;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=g;class v extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof v)return n;const h=new v;return h.message=n.message,h.stack=n.stack,h}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=v;class t extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,t.prototype)}}e.BugIndicatingError=t}),define(ye[18],Ie([1,0,10,105]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=w,e.tail2=C,e.equals=R,e.removeFastWithoutKeepingOrder=_,e.binarySearch=b,e.binarySearch2=o,e.quickSelect=D,e.groupBy=y,e.groupAdjacentBy=d,e.forEachAdjacent=E,e.forEachWithNeighbors=a,e.sortedDiff=f,e.delta=m,e.top=p,e.topAsync=S,e.coalesce=v,e.coalesceInPlace=t,e.move=l,e.isFalsyOrEmpty=n,e.isNonEmptyArray=h,e.distinct=s,e.uniqueFilter=c,e.firstOrDefault=u,e.lastOrDefault=I,e.commonPrefixLength=T,e.range=A,e.index=O,e.insert=k,e.remove=P,e.arrayInsert=B,e.shuffle=Y,e.pushToStart=X,e.pushToEnd=re,e.pushMany=te,e.mapArrayOrNot=Z,e.asArray=fe,e.getRandomElement=K,e.insertInto=ae,e.splice=x,e.compareBy=le,e.tieBreakComparators=ve,e.reverseOrder=J;function w($,U=0){return $[$.length-(1+U)]}function C($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}function R($,U,q=(G,F)=>G===F){if($===U)return!0;if(!$||!U||$.length!==U.length)return!1;for(let G=0,F=$.length;G<F;G++)if(!q($[G],U[G]))return!1;return!0}function _($,U){const q=$.length-1;U<q&&($[U]=$[q]),$.pop()}function b($,U,q){return o($.length,G=>q($[G],U))}function o($,U){let q=0,G=$-1;for(;q<=G;){const F=(q+G)/2|0,V=U(F);if(V<0)q=F+1;else if(V>0)G=F-1;else return F}return-(q+1)}function D($,U,q){if($=$|0,$>=U.length)throw new TypeError("invalid index");const G=U[Math.floor(U.length*Math.random())],F=[],V=[],oe=[];for(const de of U){const Ce=q(de,G);Ce<0?F.push(de):Ce>0?V.push(de):oe.push(de)}return $<F.length?D($,F,q):$<F.length+oe.length?oe[0]:D($-(F.length+oe.length),V,q)}function y($,U){const q=[];let G;for(const F of $.slice(0).sort(U))!G||U(G[0],F)!==0?(G=[F],q.push(G)):G.push(F);return q}function*d($,U){let q,G;for(const F of $)G!==void 0&&U(G,F)?q.push(F):(q&&(yield q),q=[F]),G=F;q&&(yield q)}function E($,U){for(let q=0;q<=$.length;q++)U(q===0?void 0:$[q-1],q===$.length?void 0:$[q])}function a($,U){for(let q=0;q<$.length;q++)U(q===0?void 0:$[q-1],$[q],q+1===$.length?void 0:$[q+1])}function f($,U,q){const G=[];function F(de,Ce,Ne){if(Ce===0&&Ne.length===0)return;const ge=G[G.length-1];ge&&ge.start+ge.deleteCount===de?(ge.deleteCount+=Ce,ge.toInsert.push(...Ne)):G.push({start:de,deleteCount:Ce,toInsert:Ne})}let V=0,oe=0;for(;;){if(V===$.length){F(V,0,U.slice(oe));break}if(oe===U.length){F(V,$.length-V,[]);break}const de=$[V],Ce=U[oe],Ne=q(de,Ce);Ne===0?(V+=1,oe+=1):Ne<0?(F(V,1,[]),V+=1):Ne>0&&(F(V,0,[Ce]),oe+=1)}return G}function m($,U,q){const G=f($,U,q),F=[],V=[];for(const oe of G)F.push(...$.slice(oe.start,oe.start+oe.deleteCount)),V.push(...oe.toInsert);return{removed:F,added:V}}function p($,U,q){if(q===0)return[];const G=$.slice(0,q).sort(U);return g($,U,G,q,$.length),G}function S($,U,q,G,F){return q===0?Promise.resolve([]):new Promise((V,oe)=>{(async()=>{const de=$.length,Ce=$.slice(0,q).sort(U);for(let Ne=q,ge=Math.min(q+G,de);Ne<de;Ne=ge,ge=Math.min(ge+G,de)){if(Ne>q&&await new Promise(pe=>setTimeout(pe)),F&&F.isCancellationRequested)throw new i.CancellationError;g($,U,Ce,Ne,ge)}return Ce})().then(V,oe)})}function g($,U,q,G,F){for(const V=q.length;G<F;G++){const oe=$[G];if(U(oe,q[V-1])<0){q.pop();const de=(0,r.findFirstIdxMonotonousOrArrLen)(q,Ce=>U(oe,Ce)<0);q.splice(de,0,oe)}}}function v($){return $.filter(U=>!!U)}function t($){let U=0;for(let q=0;q<$.length;q++)$[q]&&($[U]=$[q],U+=1);$.length=U}function l($,U,q){$.splice(q,0,$.splice(U,1)[0])}function n($){return!Array.isArray($)||$.length===0}function h($){return Array.isArray($)&&$.length>0}function s($,U=q=>q){const q=new Set;return $.filter(G=>{const F=U(G);return q.has(F)?!1:(q.add(F),!0)})}function c($){const U=new Set;return q=>{const G=$(q);return U.has(G)?!1:(U.add(G),!0)}}function u($,U){return $.length>0?$[0]:U}function I($,U){return $.length>0?$[$.length-1]:U}function T($,U,q=(G,F)=>G===F){let G=0;for(let F=0,V=Math.min($.length,U.length);F<V&&q($[F],U[F]);F++)G++;return G}function A($,U){let q=typeof U=="number"?$:0;typeof U=="number"?q=$:(q=0,U=$);const G=[];if(q<=U)for(let F=q;F<U;F++)G.push(F);else for(let F=q;F>U;F--)G.push(F);return G}function O($,U,q){return $.reduce((G,F)=>(G[U(F)]=q?q(F):F,G),Object.create(null))}function k($,U){return $.push(U),()=>P($,U)}function P($,U){const q=$.indexOf(U);if(q>-1)return $.splice(q,1),U}function B($,U,q){const G=$.slice(0,U),F=$.slice(U);return G.concat(q,F)}function Y($,U){let q;if(typeof U=="number"){let G=U;q=()=>{const F=Math.sin(G++)*179426549;return F-Math.floor(F)}}else q=Math.random;for(let G=$.length-1;G>0;G-=1){const F=Math.floor(q()*(G+1)),V=$[G];$[G]=$[F],$[F]=V}}function X($,U){const q=$.indexOf(U);q>-1&&($.splice(q,1),$.unshift(U))}function re($,U){const q=$.indexOf(U);q>-1&&($.splice(q,1),$.push(U))}function te($,U){for(const q of U)$.push(q)}function Z($,U){return Array.isArray($)?$.map(U):U($)}function fe($){return Array.isArray($)?$:[$]}function K($){return $[Math.floor(Math.random()*$.length)]}function ae($,U,q){const G=z($,U),F=$.length,V=q.length;$.length=F+V;for(let oe=F-1;oe>=G;oe--)$[oe+V]=$[oe];for(let oe=0;oe<V;oe++)$[oe+G]=q[oe]}function x($,U,q,G){const F=z($,U);let V=$.splice(F,q);return V===void 0&&(V=[]),ae($,F,G),V}function z($,U){return U<0?Math.max(U+$.length,0):Math.min(U,$.length)}var ne;(function($){function U(V){return V<0}$.isLessThan=U;function q(V){return V<=0}$.isLessThanOrEqual=q;function G(V){return V>0}$.isGreaterThan=G;function F(V){return V===0}$.isNeitherLessOrGreaterThan=F,$.greaterThan=1,$.lessThan=-1,$.neitherLessOrGreaterThan=0})(ne||(e.CompareResult=ne={}));function le($,U){return(q,G)=>U($(q),$(G))}function ve(...$){return(U,q)=>{for(const G of $){const F=G(U,q);if(!ne.isNeitherLessOrGreaterThan(F))return F}return ne.neitherLessOrGreaterThan}}const H=($,U)=>$-U;e.numberComparator=H;const ce=($,U)=>(0,e.numberComparator)($?1:0,U?1:0);e.booleanComparator=ce;function J($){return(U,q)=>-$(U,q)}class W{constructor(U){this.items=U,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(U){let q=this.firstIdx;for(;q<this.items.length&&U(this.items[q]);)q++;const G=q===this.firstIdx?null:this.items.slice(this.firstIdx,q);return this.firstIdx=q,G}takeFromEndWhile(U){let q=this.lastIdx;for(;q>=0&&U(this.items[q]);)q--;const G=q===this.lastIdx?null:this.items.slice(q+1,this.lastIdx+1);return this.lastIdx=q,G}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const U=this.items[this.firstIdx];return this.firstIdx++,U}removeLast(){const U=this.items[this.lastIdx];return this.lastIdx--,U}takeCount(U){const q=this.items.slice(this.firstIdx,this.firstIdx+U);return this.firstIdx+=U,q}}e.ArrayQueue=W;class L{static{this.empty=new L(U=>{})}constructor(U){this.iterate=U}forEach(U){this.iterate(q=>(U(q),!0))}toArray(){const U=[];return this.iterate(q=>(U.push(q),!0)),U}filter(U){return new L(q=>this.iterate(G=>U(G)?q(G):!0))}map(U){return new L(q=>this.iterate(G=>q(U(G))))}some(U){let q=!1;return this.iterate(G=>(q=U(G),!q)),q}findFirst(U){let q;return this.iterate(G=>U(G)?(q=G,!1):!0),q}findLast(U){let q;return this.iterate(G=>(U(G)&&(q=G),!0)),q}findLastMaxBy(U){let q,G=!0;return this.iterate(F=>((G||ne.isGreaterThan(U(F,q)))&&(G=!1,q=F),!0)),q}}e.CallbackIterable=L;class Q{constructor(U){this._indexMap=U}static createSortPermutation(U,q){const G=Array.from(U.keys()).sort((F,V)=>q(U[F],U[V]));return new Q(G)}apply(U){return U.map((q,G)=>U[this._indexMap[G]])}inverse(){const U=this._indexMap.slice();for(let q=0;q<this._indexMap.length;q++)U[this._indexMap[q]]=q;return new Q(U)}}e.Permutation=Q}),define(ye[106],Ie([1,0,10]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=r,e.assertNever=w,e.assert=C,e.softAssert=R,e.assertFn=_,e.checkAdjacentItems=b;function r(o,D){if(!o)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}function w(o,D="Unreachable"){throw new Error(D)}function C(o,D="unexpected state"){if(!o)throw new i.BugIndicatingError(`Assertion Failed: ${D}`)}function R(o){o||(0,i.onUnexpectedError)(new i.BugIndicatingError("Soft Assertion Failed"))}function _(o){if(!o()){debugger;o(),(0,i.onUnexpectedError)(new i.BugIndicatingError("Assertion Failed"))}}function b(o,D){let y=0;for(;y<o.length-1;){const d=o[y],E=o[y+1];if(!D(d,E))return!1;y++}return!0}});var Tn=this&&this.__createBinding||(Object.create?function(se,e,i,r){r===void 0&&(r=i);var w=Object.getOwnPropertyDescriptor(e,i);(!w||("get"in w?!e.__esModule:w.writable||w.configurable))&&(w={enumerable:!0,get:function(){return e[i]}}),Object.defineProperty(se,r,w)}:function(se,e,i,r){r===void 0&&(r=i),se[r]=e[i]}),Rn=this&&this.__setModuleDefault||(Object.create?function(se,e){Object.defineProperty(se,"default",{enumerable:!0,value:e})}:function(se,e){se.default=e}),Be=this&&this.__importStar||function(se){if(se&&se.__esModule)return se;var e={};if(se!=null)for(var i in se)i!=="default"&&Object.prototype.hasOwnProperty.call(se,i)&&Tn(e,se,i);return Rn(e,se),e};define(ye[158],Ie([1,0,18]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.strictEquals=void 0,e.itemsEquals=w,e.jsonStringifyEquals=C,e.itemEquals=R,e.equalsIfDefined=_,e.structuralEquals=b,e.getStructuralKey=o,i=Be(i);const r=(E,a)=>E===a;e.strictEquals=r;function w(E=e.strictEquals){return(a,f)=>i.equals(a,f,E)}function C(){return(E,a)=>JSON.stringify(E)===JSON.stringify(a)}function R(){return(E,a)=>E.equals(a)}function _(E,a,f){if(f!==void 0){const m=E;return m==null||a===void 0||a===null?a===m:f(m,a)}else{const m=E;return(p,S)=>p==null||S===void 0||S===null?S===p:m(p,S)}}function b(E,a){if(E===a)return!0;if(Array.isArray(E)&&Array.isArray(a)){if(E.length!==a.length)return!1;for(let f=0;f<E.length;f++)if(!b(E[f],a[f]))return!1;return!0}if(E&&typeof E=="object"&&a&&typeof a=="object"&&Object.getPrototypeOf(E)===Object.prototype&&Object.getPrototypeOf(a)===Object.prototype){const f=E,m=a,p=Object.keys(f),S=Object.keys(m),g=new Set(S);if(p.length!==S.length)return!1;for(const v of p)if(!g.has(v)||!b(f[v],m[v]))return!1;return!0}return!1}function o(E){return JSON.stringify(d(E))}let D=0;const y=new WeakMap;function d(E){if(Array.isArray(E))return E.map(d);if(E&&typeof E=="object")if(Object.getPrototypeOf(E)===Object.prototype){const a=E,f=Object.create(null);for(const m of Object.keys(a).sort())f[m]=d(a[m]);return f}else{let a=y.get(E);return a===void 0&&(a=D++,y.set(E,a)),a+"----2b76a038c20c4bcc"}return E}}),define(ye[79],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=i;function i(r,w){const C=this;let R=!1,_;return function(){if(R)return _;if(R=!0,w)try{_=r.apply(C,arguments)}finally{w()}else _=r.apply(C,arguments);return _}}}),define(ye[40],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var i;(function(r){function w(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}r.is=w;const C=Object.freeze([]);function R(){return C}r.empty=R;function*_(n){yield n}r.single=_;function b(n){return w(n)?n:_(n)}r.wrap=b;function o(n){return n||C}r.from=o;function*D(n){for(let h=n.length-1;h>=0;h--)yield n[h]}r.reverse=D;function y(n){return!n||n[Symbol.iterator]().next().done===!0}r.isEmpty=y;function d(n){return n[Symbol.iterator]().next().value}r.first=d;function E(n,h){let s=0;for(const c of n)if(h(c,s++))return!0;return!1}r.some=E;function a(n,h){for(const s of n)if(h(s))return s}r.find=a;function*f(n,h){for(const s of n)h(s)&&(yield s)}r.filter=f;function*m(n,h){let s=0;for(const c of n)yield h(c,s++)}r.map=m;function*p(n,h){let s=0;for(const c of n)yield*h(c,s++)}r.flatMap=p;function*S(...n){for(const h of n)yield*h}r.concat=S;function g(n,h,s){let c=s;for(const u of n)c=h(c,u);return c}r.reduce=g;function*v(n,h,s=n.length){for(h<0&&(h+=n.length),s<0?s+=n.length:s>n.length&&(s=n.length);h<s;h++)yield n[h]}r.slice=v;function t(n,h=Number.POSITIVE_INFINITY){const s=[];if(h===0)return[s,n];const c=n[Symbol.iterator]();for(let u=0;u<h;u++){const I=c.next();if(I.done)return[s,r.empty()];s.push(I.value)}return[s,{[Symbol.iterator](){return c}}]}r.consume=t;async function l(n){const h=[];for await(const s of n)h.push(s);return Promise.resolve(h)}r.asyncToArray=l})(i||(e.Iterable=i={}))}),define(ye[43],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=R,e.getLocation=y,e.parse=d,e.parseTree=E,e.findNodeAtLocation=a,e.getNodePath=f,e.getNodeValue=m,e.contains=p,e.findNodeAtOffset=S,e.visit=g,e.getNodeType=v;var i;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(i||(e.ScanError=i={}));var r;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(r||(e.SyntaxKind=r={}));var w;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(w||(e.ParseErrorCode=w={}));var C;(function(t){t.DEFAULT={allowTrailingComma:!0}})(C||(e.ParseOptions=C={}));function R(t,l=!1){let n=0;const h=t.length;let s="",c=0,u=r.Unknown,I=i.None;function T(X){let re=0,te=0;for(;re<X;){const Z=t.charCodeAt(n);if(Z>=D._0&&Z<=D._9)te=te*16+Z-D._0;else if(Z>=D.A&&Z<=D.F)te=te*16+Z-D.A+10;else if(Z>=D.a&&Z<=D.f)te=te*16+Z-D.a+10;else break;n++,re++}return re<X&&(te=-1),te}function A(X){n=X,s="",c=0,u=r.Unknown,I=i.None}function O(){const X=n;if(t.charCodeAt(n)===D._0)n++;else for(n++;n<t.length&&o(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===D.dot)if(n++,n<t.length&&o(t.charCodeAt(n)))for(n++;n<t.length&&o(t.charCodeAt(n));)n++;else return I=i.UnexpectedEndOfNumber,t.substring(X,n);let re=n;if(n<t.length&&(t.charCodeAt(n)===D.E||t.charCodeAt(n)===D.e))if(n++,(n<t.length&&t.charCodeAt(n)===D.plus||t.charCodeAt(n)===D.minus)&&n++,n<t.length&&o(t.charCodeAt(n))){for(n++;n<t.length&&o(t.charCodeAt(n));)n++;re=n}else I=i.UnexpectedEndOfNumber;return t.substring(X,re)}function k(){let X="",re=n;for(;;){if(n>=h){X+=t.substring(re,n),I=i.UnexpectedEndOfString;break}const te=t.charCodeAt(n);if(te===D.doubleQuote){X+=t.substring(re,n),n++;break}if(te===D.backslash){if(X+=t.substring(re,n),n++,n>=h){I=i.UnexpectedEndOfString;break}switch(t.charCodeAt(n++)){case D.doubleQuote:X+='"';break;case D.backslash:X+="\\";break;case D.slash:X+="/";break;case D.b:X+="\b";break;case D.f:X+="\f";break;case D.n:X+=`
`;break;case D.r:X+="\r";break;case D.t:X+="	";break;case D.u:{const fe=T(4);fe>=0?X+=String.fromCharCode(fe):I=i.InvalidUnicode;break}default:I=i.InvalidEscapeCharacter}re=n;continue}if(te>=0&&te<=31)if(b(te)){X+=t.substring(re,n),I=i.UnexpectedEndOfString;break}else I=i.InvalidCharacter;n++}return X}function P(){if(s="",I=i.None,c=n,n>=h)return c=h,u=r.EOF;let X=t.charCodeAt(n);if(_(X)){do n++,s+=String.fromCharCode(X),X=t.charCodeAt(n);while(_(X));return u=r.Trivia}if(b(X))return n++,s+=String.fromCharCode(X),X===D.carriageReturn&&t.charCodeAt(n)===D.lineFeed&&(n++,s+=`
`),u=r.LineBreakTrivia;switch(X){case D.openBrace:return n++,u=r.OpenBraceToken;case D.closeBrace:return n++,u=r.CloseBraceToken;case D.openBracket:return n++,u=r.OpenBracketToken;case D.closeBracket:return n++,u=r.CloseBracketToken;case D.colon:return n++,u=r.ColonToken;case D.comma:return n++,u=r.CommaToken;case D.doubleQuote:return n++,s=k(),u=r.StringLiteral;case D.slash:{const re=n-1;if(t.charCodeAt(n+1)===D.slash){for(n+=2;n<h&&!b(t.charCodeAt(n));)n++;return s=t.substring(re,n),u=r.LineCommentTrivia}if(t.charCodeAt(n+1)===D.asterisk){n+=2;const te=h-1;let Z=!1;for(;n<te;){if(t.charCodeAt(n)===D.asterisk&&t.charCodeAt(n+1)===D.slash){n+=2,Z=!0;break}n++}return Z||(n++,I=i.UnexpectedEndOfComment),s=t.substring(re,n),u=r.BlockCommentTrivia}return s+=String.fromCharCode(X),n++,u=r.Unknown}case D.minus:if(s+=String.fromCharCode(X),n++,n===h||!o(t.charCodeAt(n)))return u=r.Unknown;case D._0:case D._1:case D._2:case D._3:case D._4:case D._5:case D._6:case D._7:case D._8:case D._9:return s+=O(),u=r.NumericLiteral;default:for(;n<h&&B(X);)n++,X=t.charCodeAt(n);if(c!==n){switch(s=t.substring(c,n),s){case"true":return u=r.TrueKeyword;case"false":return u=r.FalseKeyword;case"null":return u=r.NullKeyword}return u=r.Unknown}return s+=String.fromCharCode(X),n++,u=r.Unknown}}function B(X){if(_(X)||b(X))return!1;switch(X){case D.closeBrace:case D.closeBracket:case D.openBrace:case D.openBracket:case D.doubleQuote:case D.colon:case D.comma:case D.slash:return!1}return!0}function Y(){let X;do X=P();while(X>=r.LineCommentTrivia&&X<=r.Trivia);return X}return{setPosition:A,getPosition:()=>n,scan:l?Y:P,getToken:()=>u,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>n-c,getTokenError:()=>I}}function _(t){return t===D.space||t===D.tab||t===D.verticalTab||t===D.formFeed||t===D.nonBreakingSpace||t===D.ogham||t>=D.enQuad&&t<=D.zeroWidthSpace||t===D.narrowNoBreakSpace||t===D.mathematicalSpace||t===D.ideographicSpace||t===D.byteOrderMark}function b(t){return t===D.lineFeed||t===D.carriageReturn||t===D.lineSeparator||t===D.paragraphSeparator}function o(t){return t>=D._0&&t<=D._9}var D;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(D||(D={}));function y(t,l){const n=[],h=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function I(T,A,O,k){c.value=T,c.offset=A,c.length=O,c.type=k,c.colonOffset=void 0,s=c}try{g(t,{onObjectBegin:(T,A)=>{if(l<=T)throw h;s=void 0,u=l>T,n.push("")},onObjectProperty:(T,A,O)=>{if(l<A||(I(T,A,O,"property"),n[n.length-1]=T,l<=A+O))throw h},onObjectEnd:(T,A)=>{if(l<=T)throw h;s=void 0,n.pop()},onArrayBegin:(T,A)=>{if(l<=T)throw h;s=void 0,n.push(0)},onArrayEnd:(T,A)=>{if(l<=T)throw h;s=void 0,n.pop()},onLiteralValue:(T,A,O)=>{if(l<A||(I(T,A,O,v(T)),l<=A+O))throw h},onSeparator:(T,A,O)=>{if(l<=A)throw h;if(T===":"&&s&&s.type==="property")s.colonOffset=A,u=!1,s=void 0;else if(T===","){const k=n[n.length-1];typeof k=="number"?n[n.length-1]=k+1:(u=!0,n[n.length-1]=""),s=void 0}}})}catch(T){if(T!==h)throw T}return{path:n,previousNode:s,isAtPropertyKey:u,matches:T=>{let A=0;for(let O=0;A<T.length&&O<n.length;O++)if(T[A]===n[O]||T[A]==="*")A++;else if(T[A]!=="**")return!1;return A===T.length}}}function d(t,l=[],n=C.DEFAULT){let h=null,s=[];const c=[];function u(T){Array.isArray(s)?s.push(T):h!==null&&(s[h]=T)}return g(t,{onObjectBegin:()=>{const T={};u(T),c.push(s),s=T,h=null},onObjectProperty:T=>{h=T},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const T=[];u(T),c.push(s),s=T,h=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:u,onError:(T,A,O)=>{l.push({error:T,offset:A,length:O})}},n),s[0]}function E(t,l=[],n=C.DEFAULT){let h={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(T){h.type==="property"&&(h.length=T-h.offset,h=h.parent)}function c(T){return h.children.push(T),T}g(t,{onObjectBegin:T=>{h=c({type:"object",offset:T,length:-1,parent:h,children:[]})},onObjectProperty:(T,A,O)=>{h=c({type:"property",offset:A,length:-1,parent:h,children:[]}),h.children.push({type:"string",value:T,offset:A,length:O,parent:h})},onObjectEnd:(T,A)=>{h.length=T+A-h.offset,h=h.parent,s(T+A)},onArrayBegin:(T,A)=>{h=c({type:"array",offset:T,length:-1,parent:h,children:[]})},onArrayEnd:(T,A)=>{h.length=T+A-h.offset,h=h.parent,s(T+A)},onLiteralValue:(T,A,O)=>{c({type:v(T),offset:A,length:O,parent:h,value:T}),s(A+O)},onSeparator:(T,A,O)=>{h.type==="property"&&(T===":"?h.colonOffset=A:T===","&&s(A))},onError:(T,A,O)=>{l.push({error:T,offset:A,length:O})}},n);const I=h.children[0];return I&&delete I.parent,I}function a(t,l){if(!t)return;let n=t;for(const h of l)if(typeof h=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const c of n.children)if(Array.isArray(c.children)&&c.children[0].value===h){n=c.children[1],s=!0;break}if(!s)return}else{const s=h;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}function f(t){if(!t.parent||!t.parent.children)return[];const l=f(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;l.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&l.push(n)}return l}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const l=Object.create(null);for(const n of t.children){const h=n.children[1];h&&(l[n.children[0].value]=m(h))}return l}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function p(t,l,n=!1){return l>=t.offset&&l<t.offset+t.length||n&&l===t.offset+t.length}function S(t,l,n=!1){if(p(t,l,n)){const h=t.children;if(Array.isArray(h))for(let s=0;s<h.length&&h[s].offset<=l;s++){const c=S(h[s],l,n);if(c)return c}return t}}function g(t,l,n=C.DEFAULT){const h=R(t,!1);function s(le){return le?()=>le(h.getTokenOffset(),h.getTokenLength()):()=>!0}function c(le){return le?ve=>le(ve,h.getTokenOffset(),h.getTokenLength()):()=>!0}const u=s(l.onObjectBegin),I=c(l.onObjectProperty),T=s(l.onObjectEnd),A=s(l.onArrayBegin),O=s(l.onArrayEnd),k=c(l.onLiteralValue),P=c(l.onSeparator),B=s(l.onComment),Y=c(l.onError),X=n&&n.disallowComments,re=n&&n.allowTrailingComma;function te(){for(;;){const le=h.scan();switch(h.getTokenError()){case i.InvalidUnicode:Z(w.InvalidUnicode);break;case i.InvalidEscapeCharacter:Z(w.InvalidEscapeCharacter);break;case i.UnexpectedEndOfNumber:Z(w.UnexpectedEndOfNumber);break;case i.UnexpectedEndOfComment:X||Z(w.UnexpectedEndOfComment);break;case i.UnexpectedEndOfString:Z(w.UnexpectedEndOfString);break;case i.InvalidCharacter:Z(w.InvalidCharacter);break}switch(le){case r.LineCommentTrivia:case r.BlockCommentTrivia:X?Z(w.InvalidCommentToken):B();break;case r.Unknown:Z(w.InvalidSymbol);break;case r.Trivia:case r.LineBreakTrivia:break;default:return le}}}function Z(le,ve=[],H=[]){if(Y(le),ve.length+H.length>0){let ce=h.getToken();for(;ce!==r.EOF;){if(ve.indexOf(ce)!==-1){te();break}else if(H.indexOf(ce)!==-1)break;ce=te()}}}function fe(le){const ve=h.getTokenValue();return le?k(ve):I(ve),te(),!0}function K(){switch(h.getToken()){case r.NumericLiteral:{let le=0;try{le=JSON.parse(h.getTokenValue()),typeof le!="number"&&(Z(w.InvalidNumberFormat),le=0)}catch{Z(w.InvalidNumberFormat)}k(le);break}case r.NullKeyword:k(null);break;case r.TrueKeyword:k(!0);break;case r.FalseKeyword:k(!1);break;default:return!1}return te(),!0}function ae(){return h.getToken()!==r.StringLiteral?(Z(w.PropertyNameExpected,[],[r.CloseBraceToken,r.CommaToken]),!1):(fe(!1),h.getToken()===r.ColonToken?(P(":"),te(),ne()||Z(w.ValueExpected,[],[r.CloseBraceToken,r.CommaToken])):Z(w.ColonExpected,[],[r.CloseBraceToken,r.CommaToken]),!0)}function x(){u(),te();let le=!1;for(;h.getToken()!==r.CloseBraceToken&&h.getToken()!==r.EOF;){if(h.getToken()===r.CommaToken){if(le||Z(w.ValueExpected,[],[]),P(","),te(),h.getToken()===r.CloseBraceToken&&re)break}else le&&Z(w.CommaExpected,[],[]);ae()||Z(w.ValueExpected,[],[r.CloseBraceToken,r.CommaToken]),le=!0}return T(),h.getToken()!==r.CloseBraceToken?Z(w.CloseBraceExpected,[r.CloseBraceToken],[]):te(),!0}function z(){A(),te();let le=!1;for(;h.getToken()!==r.CloseBracketToken&&h.getToken()!==r.EOF;){if(h.getToken()===r.CommaToken){if(le||Z(w.ValueExpected,[],[]),P(","),te(),h.getToken()===r.CloseBracketToken&&re)break}else le&&Z(w.CommaExpected,[],[]);ne()||Z(w.ValueExpected,[],[r.CloseBracketToken,r.CommaToken]),le=!0}return O(),h.getToken()!==r.CloseBracketToken?Z(w.CloseBracketExpected,[r.CloseBracketToken],[]):te(),!0}function ne(){switch(h.getToken()){case r.OpenBracketToken:return z();case r.OpenBraceToken:return x();case r.StringLiteral:return fe(!0);default:return K()}}return te(),h.getToken()===r.EOF?n.allowEmptyContent?!0:(Z(w.ValueExpected,[],[]),!1):ne()?(h.getToken()!==r.EOF&&Z(w.EndOfFileExpected,[],[]),!0):(Z(w.ValueExpected,[],[]),!1)}function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ye[159],Ie([1,0,43]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.format=r,e.toFormattedString=w,e.getEOL=_,e.isEOL=b;function r(o,D,y){let d,E,a,f,m;if(D){for(f=D.offset,m=f+D.length,a=f;a>0&&!b(o,a-1);)a--;let I=m;for(;I<o.length&&!b(o,I);)I++;E=o.substring(a,I),d=R(E,y)}else E=o,d=0,a=0,f=0,m=o.length;const p=_(y,o);let S=!1,g=0,v;y.insertSpaces?v=C(" ",y.tabSize||4):v="	";const t=(0,i.createScanner)(E,!1);let l=!1;function n(){return p+C(v,d+g)}function h(){let I=t.scan();for(S=!1;I===i.SyntaxKind.Trivia||I===i.SyntaxKind.LineBreakTrivia;)S=S||I===i.SyntaxKind.LineBreakTrivia,I=t.scan();return l=I===i.SyntaxKind.Unknown||t.getTokenError()!==i.ScanError.None,I}const s=[];function c(I,T,A){!l&&T<m&&A>f&&o.substring(T,A)!==I&&s.push({offset:T,length:A-T,content:I})}let u=h();if(u!==i.SyntaxKind.EOF){const I=t.getTokenOffset()+a,T=C(v,d);c(T,a,I)}for(;u!==i.SyntaxKind.EOF;){let I=t.getTokenOffset()+t.getTokenLength()+a,T=h(),A="";for(;!S&&(T===i.SyntaxKind.LineCommentTrivia||T===i.SyntaxKind.BlockCommentTrivia);){const k=t.getTokenOffset()+a;c(" ",I,k),I=t.getTokenOffset()+t.getTokenLength()+a,A=T===i.SyntaxKind.LineCommentTrivia?n():"",T=h()}if(T===i.SyntaxKind.CloseBraceToken)u!==i.SyntaxKind.OpenBraceToken&&(g--,A=n());else if(T===i.SyntaxKind.CloseBracketToken)u!==i.SyntaxKind.OpenBracketToken&&(g--,A=n());else{switch(u){case i.SyntaxKind.OpenBracketToken:case i.SyntaxKind.OpenBraceToken:g++,A=n();break;case i.SyntaxKind.CommaToken:case i.SyntaxKind.LineCommentTrivia:A=n();break;case i.SyntaxKind.BlockCommentTrivia:S?A=n():A=" ";break;case i.SyntaxKind.ColonToken:A=" ";break;case i.SyntaxKind.StringLiteral:if(T===i.SyntaxKind.ColonToken){A="";break}case i.SyntaxKind.NullKeyword:case i.SyntaxKind.TrueKeyword:case i.SyntaxKind.FalseKeyword:case i.SyntaxKind.NumericLiteral:case i.SyntaxKind.CloseBraceToken:case i.SyntaxKind.CloseBracketToken:T===i.SyntaxKind.LineCommentTrivia||T===i.SyntaxKind.BlockCommentTrivia?A=" ":T!==i.SyntaxKind.CommaToken&&T!==i.SyntaxKind.EOF&&(l=!0);break;case i.SyntaxKind.Unknown:l=!0;break}S&&(T===i.SyntaxKind.LineCommentTrivia||T===i.SyntaxKind.BlockCommentTrivia)&&(A=n())}const O=t.getTokenOffset()+a;c(A,I,O),u=T}return s}function w(o,D){const y=JSON.stringify(o,void 0,D.insertSpaces?D.tabSize||4:"	");return D.eol!==void 0?y.replace(/\r\n|\r|\n/g,D.eol):y}function C(o,D){let y="";for(let d=0;d<D;d++)y+=o;return y}function R(o,D){let y=0,d=0;const E=D.tabSize||4;for(;y<o.length;){const a=o.charAt(y);if(a===" ")d++;else if(a==="	")d+=E;else break;y++}return Math.floor(d/E)}function _(o,D){for(let y=0;y<D.length;y++){const d=D.charAt(y);if(d==="\r")return y+1<D.length&&D.charAt(y+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return o&&o.eol||`
`}function b(o,D){return`\r
`.indexOf(o.charAt(D))!==-1}}),define(ye[160],Ie([1,0,43,159]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeProperty=w,e.setProperty=C,e.withFormatting=R,e.applyEdit=_,e.applyEdits=b;function w(o,D,y){return C(o,D,void 0,y)}function C(o,D,y,d,E){const a=D.slice(),f=[],m=(0,i.parseTree)(o,f);let p,S;for(;a.length>0&&(S=a.pop(),p=(0,i.findNodeAtLocation)(m,a),p===void 0&&y!==void 0);)typeof S=="string"?y={[S]:y}:y=[y];if(p)if(p.type==="object"&&typeof S=="string"&&Array.isArray(p.children)){const g=(0,i.findNodeAtLocation)(p,[S]);if(g!==void 0)if(y===void 0){if(!g.parent)throw new Error("Malformed AST");const v=p.children.indexOf(g.parent);let t,l=g.parent.offset+g.parent.length;if(v>0){const n=p.children[v-1];t=n.offset+n.length}else t=p.offset+1,p.children.length>1&&(l=p.children[1].offset);return R(o,{offset:t,length:l-t,content:""},d)}else return R(o,{offset:g.offset,length:g.length,content:JSON.stringify(y)},d);else{if(y===void 0)return[];const v=`${JSON.stringify(S)}: ${JSON.stringify(y)}`,t=E?E(p.children.map(n=>n.children[0].value)):p.children.length;let l;if(t>0){const n=p.children[t-1];l={offset:n.offset+n.length,length:0,content:","+v}}else p.children.length===0?l={offset:p.offset+1,length:0,content:v}:l={offset:p.offset+1,length:0,content:v+","};return R(o,l,d)}}else if(p.type==="array"&&typeof S=="number"&&Array.isArray(p.children))if(y!==void 0){const g=`${JSON.stringify(y)}`;let v;if(p.children.length===0||S===0)v={offset:p.offset+1,length:0,content:p.children.length===0?g:g+","};else{const t=S===-1||S>p.children.length?p.children.length:S,l=p.children[t-1];v={offset:l.offset+l.length,length:0,content:","+g}}return R(o,v,d)}else{const g=S,v=p.children[g];let t;if(p.children.length===1)t={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===g){const l=p.children[g-1],n=l.offset+l.length,h=p.offset+p.length;t={offset:n,length:h-2-n,content:""}}else t={offset:v.offset,length:p.children[g+1].offset-v.offset,content:""};return R(o,t,d)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${p.type}`);else return y===void 0?[]:R(o,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(y)},d)}function R(o,D,y){let d=_(o,D),E=D.offset,a=D.offset+D.content.length;if(D.length===0||D.content.length===0){for(;E>0&&!(0,r.isEOL)(d,E-1);)E--;for(;a<d.length&&!(0,r.isEOL)(d,a);)a++}const f=(0,r.format)(d,{offset:E,length:a-E},y);for(let p=f.length-1;p>=0;p--){const S=f[p];d=_(d,S),E=Math.min(E,S.offset),a=Math.max(a,S.offset+S.length),a+=S.content.length-S.length}const m=o.length-(d.length-a)-E;return[{offset:E,length:m,content:d.substring(E,a)}]}function _(o,D){return o.substring(0,D.offset)+D.content+o.substring(D.offset+D.length)}function b(o,D){const y=D.slice(0).sort((E,a)=>{const f=E.offset-a.offset;return f===0?E.length-a.length:f});let d=o.length;for(let E=y.length-1;E>=0;E--){const a=y[E];if(a.offset+a.length<=d)o=_(o,a);else throw new Error("Overlapping edit");d=a.offset}return o}}),define(ye[65],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class i{constructor(w){this.executor=w,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(w){this._error=w}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=i}),define(ye[80],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class i{static{this.Undefined=new i(void 0)}constructor(C){this.element=C,this.next=i.Undefined,this.prev=i.Undefined}}class r{constructor(){this._first=i.Undefined,this._last=i.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===i.Undefined}clear(){let C=this._first;for(;C!==i.Undefined;){const R=C.next;C.prev=i.Undefined,C.next=i.Undefined,C=R}this._first=i.Undefined,this._last=i.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,R){const _=new i(C);if(this._first===i.Undefined)this._first=_,this._last=_;else if(R){const o=this._last;this._last=_,_.prev=o,o.next=_}else{const o=this._first;this._first=_,_.next=o,o.prev=_}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(_))}}shift(){if(this._first!==i.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==i.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==i.Undefined&&C.next!==i.Undefined){const R=C.prev;R.next=C.next,C.next.prev=R}else C.prev===i.Undefined&&C.next===i.Undefined?(this._first=i.Undefined,this._last=i.Undefined):C.next===i.Undefined?(this._last=this._last.prev,this._last.next=i.Undefined):C.prev===i.Undefined&&(this._first=this._first.next,this._first.prev=i.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==i.Undefined;)yield C.element,C=C.next}}e.LinkedList=r}),define(ye[26],Ie([1,0]),function(se,e){"use strict";var i,r,w;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=C,e.mapToString=R,e.setToString=_,e.mapsStrictEqualIgnoreOrder=v;function C(t,l,n){let h=t.get(l);return h===void 0&&(h=n,t.set(l,h)),h}function R(t){const l=[];return t.forEach((n,h)=>{l.push(`${h} => ${n}`)}),`Map(${t.size}) {${l.join(", ")}}`}function _(t){const l=[];return t.forEach(n=>{l.push(n)}),`Set(${t.size}) {${l.join(", ")}}`}class b{constructor(l,n){this.uri=l,this.value=n}}function o(t){return Array.isArray(t)}class D{static{this.defaultToKey=l=>l.toString()}constructor(l,n){if(this[i]="ResourceMap",l instanceof D)this.map=new Map(l.map),this.toKey=n??D.defaultToKey;else if(o(l)){this.map=new Map,this.toKey=n??D.defaultToKey;for(const[h,s]of l)this.set(h,s)}else this.map=new Map,this.toKey=l??D.defaultToKey}set(l,n){return this.map.set(this.toKey(l),new b(l,n)),this}get(l){return this.map.get(this.toKey(l))?.value}has(l){return this.map.has(this.toKey(l))}get size(){return this.map.size}clear(){this.map.clear()}delete(l){return this.map.delete(this.toKey(l))}forEach(l,n){typeof n<"u"&&(l=l.bind(n));for(const[h,s]of this.map)l(s.value,s.uri,this)}*values(){for(const l of this.map.values())yield l.value}*keys(){for(const l of this.map.values())yield l.uri}*entries(){for(const l of this.map.values())yield[l.uri,l.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,l]of this.map)yield[l.uri,l.value]}}e.ResourceMap=D;class y{constructor(l,n){this[r]="ResourceSet",!l||typeof l=="function"?this._map=new D(l):(this._map=new D(n),l.forEach(this.add,this))}get size(){return this._map.size}add(l){return this._map.set(l,l),this}clear(){this._map.clear()}delete(l){return this._map.delete(l)}forEach(l,n){this._map.forEach((h,s)=>l.call(n,s,s,this))}has(l){return this._map.has(l)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=y;var d;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(d||(e.Touch=d={}));class E{constructor(){this[w]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(l){return this._map.has(l)}get(l,n=d.None){const h=this._map.get(l);if(h)return n!==d.None&&this.touch(h,n),h.value}set(l,n,h=d.None){let s=this._map.get(l);if(s)s.value=n,h!==d.None&&this.touch(s,h);else{switch(s={key:l,value:n,next:void 0,previous:void 0},h){case d.None:this.addItemLast(s);break;case d.AsOld:this.addItemFirst(s);break;case d.AsNew:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(l,s),this._size++}return this}delete(l){return!!this.remove(l)}remove(l){const n=this._map.get(l);if(n)return this._map.delete(l),this.removeItem(n),this._size--,n.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const l=this._head;return this._map.delete(l.key),this.removeItem(l),this._size--,l.value}forEach(l,n){const h=this._state;let s=this._head;for(;s;){if(n?l.bind(n)(s.value,s.key,this):l(s.value,s.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const l=this,n=this._state;let h=this._head;const s={[Symbol.iterator](){return s},next(){if(l._state!==n)throw new Error("LinkedMap got modified during iteration.");if(h){const c={value:h.key,done:!1};return h=h.next,c}else return{value:void 0,done:!0}}};return s}values(){const l=this,n=this._state;let h=this._head;const s={[Symbol.iterator](){return s},next(){if(l._state!==n)throw new Error("LinkedMap got modified during iteration.");if(h){const c={value:h.value,done:!1};return h=h.next,c}else return{value:void 0,done:!0}}};return s}entries(){const l=this,n=this._state;let h=this._head;const s={[Symbol.iterator](){return s},next(){if(l._state!==n)throw new Error("LinkedMap got modified during iteration.");if(h){const c={value:[h.key,h.value],done:!1};return h=h.next,c}else return{value:void 0,done:!0}}};return s}[(w=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(l){if(l>=this.size)return;if(l===0){this.clear();return}let n=this._head,h=this.size;for(;n&&h>l;)this._map.delete(n.key),n=n.next,h--;this._head=n,this._size=h,n&&(n.previous=void 0),this._state++}trimNew(l){if(l>=this.size)return;if(l===0){this.clear();return}let n=this._tail,h=this.size;for(;n&&h>l;)this._map.delete(n.key),n=n.previous,h--;this._tail=n,this._size=h,n&&(n.next=void 0),this._state++}addItemFirst(l){if(!this._head&&!this._tail)this._tail=l;else if(this._head)l.next=this._head,this._head.previous=l;else throw new Error("Invalid list");this._head=l,this._state++}addItemLast(l){if(!this._head&&!this._tail)this._head=l;else if(this._tail)l.previous=this._tail,this._tail.next=l;else throw new Error("Invalid list");this._tail=l,this._state++}removeItem(l){if(l===this._head&&l===this._tail)this._head=void 0,this._tail=void 0;else if(l===this._head){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this._head=l.next}else if(l===this._tail){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this._tail=l.previous}else{const n=l.next,h=l.previous;if(!n||!h)throw new Error("Invalid list");n.previous=h,h.next=n}l.next=void 0,l.previous=void 0,this._state++}touch(l,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==d.AsOld&&n!==d.AsNew)){if(n===d.AsOld){if(l===this._head)return;const h=l.next,s=l.previous;l===this._tail?(s.next=void 0,this._tail=s):(h.previous=s,s.next=h),l.previous=void 0,l.next=this._head,this._head.previous=l,this._head=l,this._state++}else if(n===d.AsNew){if(l===this._tail)return;const h=l.next,s=l.previous;l===this._head?(h.previous=void 0,this._head=h):(h.previous=s,s.next=h),l.next=void 0,l.previous=this._tail,this._tail.next=l,this._tail=l,this._state++}}}toJSON(){const l=[];return this.forEach((n,h)=>{l.push([h,n])}),l}fromJSON(l){this.clear();for(const[n,h]of l)this.set(n,h)}}e.LinkedMap=E;class a extends E{constructor(l,n=1){super(),this._limit=l,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(l){this._limit=l,this.checkTrim()}get ratio(){return this._ratio}set ratio(l){this._ratio=Math.min(Math.max(0,l),1),this.checkTrim()}get(l,n=d.AsNew){return super.get(l,n)}peek(l){return super.get(l,d.None)}set(l,n){return super.set(l,n,d.AsNew),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class f extends a{constructor(l,n=1){super(l,n)}trim(l){this.trimOld(l)}set(l,n){return super.set(l,n),this.checkTrim(),this}}e.LRUCache=f;class m extends a{constructor(l,n=1){super(l,n)}trim(l){this.trimNew(l)}set(l,n){return this._limit<=this.size&&!this.has(l)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(l,n),this}}e.MRUCache=m;class p{constructor(){this.map=new Map}add(l){return this.map.set(l,(this.map.get(l)||0)+1),this}delete(l){let n=this.map.get(l)||0;return n===0?!1:(n--,n===0?this.map.delete(l):this.map.set(l,n),!0)}has(l){return this.map.has(l)}}e.CounterSet=p;class S{constructor(l){if(this._m1=new Map,this._m2=new Map,l)for(const[n,h]of l)this.set(n,h)}clear(){this._m1.clear(),this._m2.clear()}set(l,n){this._m1.set(l,n),this._m2.set(n,l)}get(l){return this._m1.get(l)}getKey(l){return this._m2.get(l)}delete(l){const n=this._m1.get(l);return n===void 0?!1:(this._m1.delete(l),this._m2.delete(n),!0)}forEach(l,n){this._m1.forEach((h,s)=>{l.call(n,h,s,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=S;class g{constructor(){this.map=new Map}add(l,n){let h=this.map.get(l);h||(h=new Set,this.map.set(l,h)),h.add(n)}delete(l,n){const h=this.map.get(l);h&&(h.delete(n),h.size===0&&this.map.delete(l))}forEach(l,n){const h=this.map.get(l);h&&h.forEach(n)}get(l){const n=this.map.get(l);return n||new Set}}e.SetMap=g;function v(t,l){if(t===l)return!0;if(t.size!==l.size)return!1;for(const[n,h]of t)if(!l.has(n)||l.get(n)!==h)return!1;for(const[n]of l)if(!t.has(n))return!1;return!0}}),define(ye[2],Ie([1,0,18,157,26,79,40]),function(se,e,i,r,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=D,e.trackDisposable=y,e.markAsDisposed=d,e.markAsSingleton=f,e.isDisposable=m,e.dispose=p,e.disposeIfDisposable=S,e.combinedDisposable=g,e.toDisposable=v,e.disposeOnReturn=A;const _=!1;let b=null;class o{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(P){let B=this.livingDisposables.get(P);return B||(B={parent:null,source:null,isSingleton:!1,value:P,idx:o.idx++},this.livingDisposables.set(P,B)),B}trackDisposable(P){const B=this.getDisposableData(P);B.source||(B.source=new Error().stack)}setParent(P,B){const Y=this.getDisposableData(P);Y.parent=B}markAsDisposed(P){this.livingDisposables.delete(P)}markAsSingleton(P){this.getDisposableData(P).isSingleton=!0}getRootParent(P,B){const Y=B.get(P);if(Y)return Y;const X=P.parent?this.getRootParent(this.getDisposableData(P.parent),B):P;return B.set(P,X),X}getTrackedDisposables(){const P=new Map;return[...this.livingDisposables.entries()].filter(([,Y])=>Y.source!==null&&!this.getRootParent(Y,P).isSingleton).flatMap(([Y])=>Y)}computeLeakingDisposables(P=10,B){let Y;if(B)Y=B;else{const fe=new Map,K=[...this.livingDisposables.values()].filter(x=>x.source!==null&&!this.getRootParent(x,fe).isSingleton);if(K.length===0)return;const ae=new Set(K.map(x=>x.value));if(Y=K.filter(x=>!(x.parent&&ae.has(x.parent))),Y.length===0)throw new Error("There are cyclic diposable chains!")}if(!Y)return;function X(fe){function K(x,z){for(;x.length>0&&z.some(ne=>typeof ne=="string"?ne===x[0]:x[0].match(ne));)x.shift()}const ae=fe.source.split(`
`).map(x=>x.trim().replace("at ","")).filter(x=>x!=="");return K(ae,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ae.reverse()}const re=new w.SetMap;for(const fe of Y){const K=X(fe);for(let ae=0;ae<=K.length;ae++)re.add(K.slice(0,ae).join(`
`),fe)}Y.sort((0,i.compareBy)(fe=>fe.idx,i.numberComparator));let te="",Z=0;for(const fe of Y.slice(0,P)){Z++;const K=X(fe),ae=[];for(let x=0;x<K.length;x++){let z=K[x];z=`(shared with ${re.get(K.slice(0,x+1).join(`
`)).size}/${Y.length} leaks) at ${z}`;const le=re.get(K.slice(0,x).join(`
`)),ve=(0,r.groupBy)([...le].map(H=>X(H)[x]),H=>H);delete ve[K[x]];for(const[H,ce]of Object.entries(ve))ae.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${H}`);ae.unshift(z)}te+=`


==================== Leaking disposable ${Z}/${Y.length}: ${fe.value.constructor.name} ====================
${ae.join(`
`)}
============================================================

`}return Y.length>P&&(te+=`


... and ${Y.length-P} more leaking disposables

`),{leaks:Y,details:te}}}e.DisposableTracker=o;function D(k){b=k}if(_){const k="__is_disposable_tracked__";D(new class{trackDisposable(P){const B=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[k]||console.log(B)},3e3)}setParent(P,B){if(P&&P!==l.None)try{P[k]=!0}catch{}}markAsDisposed(P){if(P&&P!==l.None)try{P[k]=!0}catch{}}markAsSingleton(P){}})}function y(k){return b?.trackDisposable(k),k}function d(k){b?.markAsDisposed(k)}function E(k,P){b?.setParent(k,P)}function a(k,P){if(b)for(const B of k)b.setParent(B,P)}function f(k){return b?.markAsSingleton(k),k}function m(k){return typeof k=="object"&&k!==null&&typeof k.dispose=="function"&&k.dispose.length===0}function p(k){if(R.Iterable.is(k)){const P=[];for(const B of k)if(B)try{B.dispose()}catch(Y){P.push(Y)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}function S(k){for(const P of k)m(P)&&P.dispose();return[]}function g(...k){const P=v(()=>p(k));return a(k,P),P}function v(k){const P=y({dispose:(0,C.createSingleCallFunction)(()=>{d(P),k()})});return P}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(d(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{p(this._toDispose)}finally{this._toDispose.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return E(P,this),this._isDisposed?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(P),P.dispose()}}deleteAndLeak(P){P&&this._toDispose.has(P)&&(this._toDispose.delete(P),E(P,null))}}e.DisposableStore=t;class l{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new t,y(this),E(this._store,this)}dispose(){d(this),this._store.dispose()}_register(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(P)}}e.Disposable=l;class n{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(P){this._isDisposed||P===this._value||(this._value?.dispose(),P&&E(P,this),this._value=P)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,d(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const P=this._value;return this._value=void 0,P&&E(P,null),P}}e.MutableDisposable=n;class h{constructor(P){this._disposable=new n,this._isDisposed=!1,this._disposable.value=P}get value(){return this._disposable.value}set value(P){this._isDisposed||P===this._disposable.value||(this._disposable.value=P)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=h;class s{constructor(P){this._disposable=P,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=s;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(P){let B=P;return this.unset=()=>B=void 0,this.isset=()=>B!==void 0,this.dispose=()=>{B&&(B(),B=void 0,d(this))},this}}e.SafeDisposable=c;class u{constructor(){this.references=new Map}acquire(P,...B){let Y=this.references.get(P);Y||(Y={counter:0,object:this.createReferencedObject(P,...B)},this.references.set(P,Y));const{object:X}=Y,re=(0,C.createSingleCallFunction)(()=>{--Y.counter===0&&(this.destroyReferencedObject(P,Y.object),this.references.delete(P))});return Y.counter++,{object:X,dispose:re}}}e.ReferenceCollection=u;class I{constructor(P){this.referenceCollection=P}async acquire(P,...B){const Y=this.referenceCollection.acquire(P,...B);try{return{object:await Y.object,dispose:()=>Y.dispose()}}catch(X){throw Y.dispose(),X}}}e.AsyncReferenceCollection=I;class T{constructor(P){this.object=P}dispose(){}}e.ImmortalReference=T;function A(k){const P=new t;try{k(P)}finally{P.dispose()}}class O{constructor(){this._store=new Map,this._isDisposed=!1,y(this)}dispose(){d(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{p(this._store.values())}finally{this._store.clear()}}has(P){return this._store.has(P)}get size(){return this._store.size}get(P){return this._store.get(P)}set(P,B,Y=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Y||this._store.get(P)?.dispose(),this._store.set(P,B)}deleteAndDispose(P){this._store.get(P)?.dispose(),this._store.delete(P)}deleteAndLeak(P){const B=this._store.get(P);return this._store.delete(P),B}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=O}),function(se,e){typeof define=="function"&&define.amd?define(ye[161],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(se=typeof globalThis<"u"?globalThis:se||self,e(se.marked={}))}(this,function(se){"use strict";function e(U,q){for(var G=0;G<q.length;G++){var F=q[G];F.enumerable=F.enumerable||!1,F.configurable=!0,"value"in F&&(F.writable=!0),Object.defineProperty(U,F.key,F)}}function i(U,q,G){return q&&e(U.prototype,q),G&&e(U,G),Object.defineProperty(U,"prototype",{writable:!1}),U}function r(U,q){if(U){if(typeof U=="string")return w(U,q);var G=Object.prototype.toString.call(U).slice(8,-1);if(G==="Object"&&U.constructor&&(G=U.constructor.name),G==="Map"||G==="Set")return Array.from(U);if(G==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(G))return w(U,q)}}function w(U,q){(q==null||q>U.length)&&(q=U.length);for(var G=0,F=new Array(q);G<q;G++)F[G]=U[G];return F}function C(U,q){var G=typeof Symbol<"u"&&U[Symbol.iterator]||U["@@iterator"];if(G)return(G=G.call(U)).next.bind(G);if(Array.isArray(U)||(G=r(U))||q&&U&&typeof U.length=="number"){G&&(U=G);var F=0;return function(){return F>=U.length?{done:!0}:{done:!1,value:U[F++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}se.defaults=R();function _(U){se.defaults=U}var b=/[&<>"']/,o=/[&<>"']/g,D=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,d={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(q){return d[q]};function a(U,q){if(q){if(b.test(U))return U.replace(o,E)}else if(D.test(U))return U.replace(y,E);return U}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(U){return U.replace(f,function(q,G){return G=G.toLowerCase(),G==="colon"?":":G.charAt(0)==="#"?G.charAt(1)==="x"?String.fromCharCode(parseInt(G.substring(2),16)):String.fromCharCode(+G.substring(1)):""})}var p=/(^|[^\[])\^/g;function S(U,q){U=typeof U=="string"?U:U.source,q=q||"";var G={replace:function(V,oe){return oe=oe.source||oe,oe=oe.replace(p,"$1"),U=U.replace(V,oe),G},getRegex:function(){return new RegExp(U,q)}};return G}var g=/[^\w:]/g,v=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(U,q,G){if(U){var F;try{F=decodeURIComponent(m(G)).replace(g,"").toLowerCase()}catch{return null}if(F.indexOf("javascript:")===0||F.indexOf("vbscript:")===0||F.indexOf("data:")===0)return null}q&&!v.test(G)&&(G=c(q,G));try{G=encodeURI(G).replace(/%25/g,"%")}catch{return null}return G}var l={},n=/^[^:]+:\/*[^/]*$/,h=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(U,q){l[" "+U]||(n.test(U)?l[" "+U]=U+"/":l[" "+U]=A(U,"/",!0)),U=l[" "+U];var G=U.indexOf(":")===-1;return q.substring(0,2)==="//"?G?q:U.replace(h,"$1")+q:q.charAt(0)==="/"?G?q:U.replace(s,"$1")+q:U+q}var u={exec:function(){}};function I(U){for(var q=1,G,F;q<arguments.length;q++){G=arguments[q];for(F in G)Object.prototype.hasOwnProperty.call(G,F)&&(U[F]=G[F])}return U}function T(U,q){var G=U.replace(/\|/g,function(oe,de,Ce){for(var Ne=!1,ge=de;--ge>=0&&Ce[ge]==="\\";)Ne=!Ne;return Ne?"|":" |"}),F=G.split(/ \|/),V=0;if(F[0].trim()||F.shift(),F.length>0&&!F[F.length-1].trim()&&F.pop(),F.length>q)F.splice(q);else for(;F.length<q;)F.push("");for(;V<F.length;V++)F[V]=F[V].trim().replace(/\\\|/g,"|");return F}function A(U,q,G){var F=U.length;if(F===0)return"";for(var V=0;V<F;){var oe=U.charAt(F-V-1);if(oe===q&&!G)V++;else if(oe!==q&&G)V++;else break}return U.slice(0,F-V)}function O(U,q){if(U.indexOf(q[1])===-1)return-1;for(var G=U.length,F=0,V=0;V<G;V++)if(U[V]==="\\")V++;else if(U[V]===q[0])F++;else if(U[V]===q[1]&&(F--,F<0))return V;return-1}function k(U){U&&U.sanitize&&!U.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(U,q){if(q<1)return"";for(var G="";q>1;)q&1&&(G+=U),q>>=1,U+=U;return G+U}function B(U,q,G,F){var V=q.href,oe=q.title?a(q.title):null,de=U[1].replace(/\\([\[\]])/g,"$1");if(U[0].charAt(0)!=="!"){F.state.inLink=!0;var Ce={type:"link",raw:G,href:V,title:oe,text:de,tokens:F.inlineTokens(de)};return F.state.inLink=!1,Ce}return{type:"image",raw:G,href:V,title:oe,text:a(de)}}function Y(U,q){var G=U.match(/^(\s+)(?:```)/);if(G===null)return q;var F=G[1];return q.split(`
`).map(function(V){var oe=V.match(/^\s+/);if(oe===null)return V;var de=oe[0];return de.length>=F.length?V.slice(F.length):V}).join(`
`)}var X=function(){function U(G){this.options=G||se.defaults}var q=U.prototype;return q.space=function(F){var V=this.rules.block.newline.exec(F);if(V&&V[0].length>0)return{type:"space",raw:V[0]}},q.code=function(F){var V=this.rules.block.code.exec(F);if(V){var oe=V[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:V[0],codeBlockStyle:"indented",text:this.options.pedantic?oe:A(oe,`
`)}}},q.fences=function(F){var V=this.rules.block.fences.exec(F);if(V){var oe=V[0],de=Y(oe,V[3]||"");return{type:"code",raw:oe,lang:V[2]?V[2].trim():V[2],text:de}}},q.heading=function(F){var V=this.rules.block.heading.exec(F);if(V){var oe=V[2].trim();if(/#$/.test(oe)){var de=A(oe,"#");(this.options.pedantic||!de||/ $/.test(de))&&(oe=de.trim())}return{type:"heading",raw:V[0],depth:V[1].length,text:oe,tokens:this.lexer.inline(oe)}}},q.hr=function(F){var V=this.rules.block.hr.exec(F);if(V)return{type:"hr",raw:V[0]}},q.blockquote=function(F){var V=this.rules.block.blockquote.exec(F);if(V){var oe=V[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:V[0],tokens:this.lexer.blockTokens(oe,[]),text:oe}}},q.list=function(F){var V=this.rules.block.list.exec(F);if(V){var oe,de,Ce,Ne,ge,pe,Te,Le,he,De,Re,xe,Ve=V[1].trim(),Xe=Ve.length>1,je={type:"list",raw:"",ordered:Xe,start:Xe?+Ve.slice(0,-1):"",loose:!1,items:[]};Ve=Xe?"\\d{1,9}\\"+Ve.slice(-1):"\\"+Ve,this.options.pedantic&&(Ve=Xe?Ve:"[*+-]");for(var qe=new RegExp("^( {0,3}"+Ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");F&&(xe=!1,!(!(V=qe.exec(F))||this.rules.block.hr.test(F)));){if(oe=V[0],F=F.substring(oe.length),Le=V[2].split(`
`,1)[0],he=F.split(`
`,1)[0],this.options.pedantic?(Ne=2,Re=Le.trimLeft()):(Ne=V[2].search(/[^ ]/),Ne=Ne>4?1:Ne,Re=Le.slice(Ne),Ne+=V[1].length),pe=!1,!Le&&/^ *$/.test(he)&&(oe+=he+`
`,F=F.substring(he.length+1),xe=!0),!xe)for(var Je=new RegExp("^ {0,"+Math.min(3,Ne-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),st=new RegExp("^ {0,"+Math.min(3,Ne-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),lt=new RegExp("^ {0,"+Math.min(3,Ne-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,Ne-1)+"}#");F&&(De=F.split(`
`,1)[0],Le=De,this.options.pedantic&&(Le=Le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(lt.test(Le)||rt.test(Le)||Je.test(Le)||st.test(F)));){if(Le.search(/[^ ]/)>=Ne||!Le.trim())Re+=`
`+Le.slice(Ne);else if(!pe)Re+=`
`+Le;else break;!pe&&!Le.trim()&&(pe=!0),oe+=De+`
`,F=F.substring(De.length+1)}je.loose||(Te?je.loose=!0:/\n *\n *$/.test(oe)&&(Te=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(Re),de&&(Ce=de[0]!=="[ ] ",Re=Re.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:oe,task:!!de,checked:Ce,loose:!1,text:Re}),je.raw+=oe}je.items[je.items.length-1].raw=oe.trimRight(),je.items[je.items.length-1].text=Re.trimRight(),je.raw=je.raw.trimRight();var it=je.items.length;for(ge=0;ge<it;ge++){this.lexer.state.top=!1,je.items[ge].tokens=this.lexer.blockTokens(je.items[ge].text,[]);var tt=je.items[ge].tokens.filter(function(Qe){return Qe.type==="space"}),et=tt.every(function(Qe){for(var Ee=Qe.raw.split(""),Oe=0,Fe=C(Ee),be;!(be=Fe()).done;){var Ae=be.value;if(Ae===`
`&&(Oe+=1),Oe>1)return!0}return!1});!je.loose&&tt.length&&et&&(je.loose=!0,je.items[ge].loose=!0)}return je}},q.html=function(F){var V=this.rules.block.html.exec(F);if(V){var oe={type:"html",raw:V[0],pre:!this.options.sanitizer&&(V[1]==="pre"||V[1]==="script"||V[1]==="style"),text:V[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(V[0]):a(V[0]);oe.type="paragraph",oe.text=de,oe.tokens=this.lexer.inline(de)}return oe}},q.def=function(F){var V=this.rules.block.def.exec(F);if(V){V[3]&&(V[3]=V[3].substring(1,V[3].length-1));var oe=V[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:oe,raw:V[0],href:V[2],title:V[3]}}},q.table=function(F){var V=this.rules.block.table.exec(F);if(V){var oe={type:"table",header:T(V[1]).map(function(Te){return{text:Te}}),align:V[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:V[3]&&V[3].trim()?V[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(oe.header.length===oe.align.length){oe.raw=V[0];var de=oe.align.length,Ce,Ne,ge,pe;for(Ce=0;Ce<de;Ce++)/^ *-+: *$/.test(oe.align[Ce])?oe.align[Ce]="right":/^ *:-+: *$/.test(oe.align[Ce])?oe.align[Ce]="center":/^ *:-+ *$/.test(oe.align[Ce])?oe.align[Ce]="left":oe.align[Ce]=null;for(de=oe.rows.length,Ce=0;Ce<de;Ce++)oe.rows[Ce]=T(oe.rows[Ce],oe.header.length).map(function(Te){return{text:Te}});for(de=oe.header.length,Ne=0;Ne<de;Ne++)oe.header[Ne].tokens=this.lexer.inline(oe.header[Ne].text);for(de=oe.rows.length,Ne=0;Ne<de;Ne++)for(pe=oe.rows[Ne],ge=0;ge<pe.length;ge++)pe[ge].tokens=this.lexer.inline(pe[ge].text);return oe}}},q.lheading=function(F){var V=this.rules.block.lheading.exec(F);if(V)return{type:"heading",raw:V[0],depth:V[2].charAt(0)==="="?1:2,text:V[1],tokens:this.lexer.inline(V[1])}},q.paragraph=function(F){var V=this.rules.block.paragraph.exec(F);if(V){var oe=V[1].charAt(V[1].length-1)===`
`?V[1].slice(0,-1):V[1];return{type:"paragraph",raw:V[0],text:oe,tokens:this.lexer.inline(oe)}}},q.text=function(F){var V=this.rules.block.text.exec(F);if(V)return{type:"text",raw:V[0],text:V[0],tokens:this.lexer.inline(V[0])}},q.escape=function(F){var V=this.rules.inline.escape.exec(F);if(V)return{type:"escape",raw:V[0],text:a(V[1])}},q.tag=function(F){var V=this.rules.inline.tag.exec(F);if(V)return!this.lexer.state.inLink&&/^<a /i.test(V[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(V[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(V[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(V[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:V[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(V[0]):a(V[0]):V[0]}},q.link=function(F){var V=this.rules.inline.link.exec(F);if(V){var oe=V[2].trim();if(!this.options.pedantic&&/^</.test(oe)){if(!/>$/.test(oe))return;var de=A(oe.slice(0,-1),"\\");if((oe.length-de.length)%2===0)return}else{var Ce=O(V[2],"()");if(Ce>-1){var Ne=V[0].indexOf("!")===0?5:4,ge=Ne+V[1].length+Ce;V[2]=V[2].substring(0,Ce),V[0]=V[0].substring(0,ge).trim(),V[3]=""}}var pe=V[2],Te="";if(this.options.pedantic){var Le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(pe);Le&&(pe=Le[1],Te=Le[3])}else Te=V[3]?V[3].slice(1,-1):"";return pe=pe.trim(),/^</.test(pe)&&(this.options.pedantic&&!/>$/.test(oe)?pe=pe.slice(1):pe=pe.slice(1,-1)),B(V,{href:pe&&pe.replace(this.rules.inline._escapes,"$1"),title:Te&&Te.replace(this.rules.inline._escapes,"$1")},V[0],this.lexer)}},q.reflink=function(F,V){var oe;if((oe=this.rules.inline.reflink.exec(F))||(oe=this.rules.inline.nolink.exec(F))){var de=(oe[2]||oe[1]).replace(/\s+/g," ");if(de=V[de.toLowerCase()],!de||!de.href){var Ce=oe[0].charAt(0);return{type:"text",raw:Ce,text:Ce}}return B(oe,de,oe[0],this.lexer)}},q.emStrong=function(F,V,oe){oe===void 0&&(oe="");var de=this.rules.inline.emStrong.lDelim.exec(F);if(de&&!(de[3]&&oe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ce=de[1]||de[2]||"";if(!Ce||Ce&&(oe===""||this.rules.inline.punctuation.exec(oe))){var Ne=de[0].length-1,ge,pe,Te=Ne,Le=0,he=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(he.lastIndex=0,V=V.slice(-1*F.length+Ne);(de=he.exec(V))!=null;)if(ge=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!ge){if(pe=ge.length,de[3]||de[4]){Te+=pe;continue}else if((de[5]||de[6])&&Ne%3&&!((Ne+pe)%3)){Le+=pe;continue}if(Te-=pe,!(Te>0)){if(pe=Math.min(pe,pe+Te+Le),Math.min(Ne,pe)%2){var De=F.slice(1,Ne+de.index+pe);return{type:"em",raw:F.slice(0,Ne+de.index+pe+1),text:De,tokens:this.lexer.inlineTokens(De)}}var Re=F.slice(2,Ne+de.index+pe-1);return{type:"strong",raw:F.slice(0,Ne+de.index+pe+1),text:Re,tokens:this.lexer.inlineTokens(Re)}}}}}},q.codespan=function(F){var V=this.rules.inline.code.exec(F);if(V){var oe=V[2].replace(/\n/g," "),de=/[^ ]/.test(oe),Ce=/^ /.test(oe)&&/ $/.test(oe);return de&&Ce&&(oe=oe.substring(1,oe.length-1)),oe=a(oe,!0),{type:"codespan",raw:V[0],text:oe}}},q.br=function(F){var V=this.rules.inline.br.exec(F);if(V)return{type:"br",raw:V[0]}},q.del=function(F){var V=this.rules.inline.del.exec(F);if(V)return{type:"del",raw:V[0],text:V[2],tokens:this.lexer.inlineTokens(V[2])}},q.autolink=function(F,V){var oe=this.rules.inline.autolink.exec(F);if(oe){var de,Ce;return oe[2]==="@"?(de=a(this.options.mangle?V(oe[1]):oe[1]),Ce="mailto:"+de):(de=a(oe[1]),Ce=de),{type:"link",raw:oe[0],text:de,href:Ce,tokens:[{type:"text",raw:de,text:de}]}}},q.url=function(F,V){var oe;if(oe=this.rules.inline.url.exec(F)){var de,Ce;if(oe[2]==="@")de=a(this.options.mangle?V(oe[0]):oe[0]),Ce="mailto:"+de;else{var Ne;do Ne=oe[0],oe[0]=this.rules.inline._backpedal.exec(oe[0])[0];while(Ne!==oe[0]);de=a(oe[0]),oe[1]==="www."?Ce="http://"+de:Ce=de}return{type:"link",raw:oe[0],text:de,href:Ce,tokens:[{type:"text",raw:de,text:de}]}}},q.inlineText=function(F,V){var oe=this.rules.inline.text.exec(F);if(oe){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):a(oe[0]):oe[0]:de=a(this.options.smartypants?V(oe[0]):oe[0]),{type:"text",raw:oe[0],text:de}}},U}(),re={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};re._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,re._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,re.def=S(re.def).replace("label",re._label).replace("title",re._title).getRegex(),re.bullet=/(?:[*+-]|\d{1,9}[.)])/,re.listItemStart=S(/^( *)(bull) */).replace("bull",re.bullet).getRegex(),re.list=S(re.list).replace(/bull/g,re.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+re.def.source+")").getRegex(),re._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",re._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,re.html=S(re.html,"i").replace("comment",re._comment).replace("tag",re._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),re.paragraph=S(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.blockquote=S(re.blockquote).replace("paragraph",re.paragraph).getRegex(),re.normal=I({},re),re.gfm=I({},re.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),re.gfm.table=S(re.gfm.table).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.gfm.paragraph=S(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",re.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.pedantic=I({},re.normal,{html:S(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",re._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:S(re.normal._paragraph).replace("hr",re.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",re.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var te={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};te._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",te.punctuation=S(te.punctuation).replace(/punctuation/g,te._punctuation).getRegex(),te.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,te.escapedEmSt=/\\\*|\\_/g,te._comment=S(re._comment).replace("(?:-->|$)","-->").getRegex(),te.emStrong.lDelim=S(te.emStrong.lDelim).replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimAst=S(te.emStrong.rDelimAst,"g").replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimUnd=S(te.emStrong.rDelimUnd,"g").replace(/punct/g,te._punctuation).getRegex(),te._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,te._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,te._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,te.autolink=S(te.autolink).replace("scheme",te._scheme).replace("email",te._email).getRegex(),te._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,te.tag=S(te.tag).replace("comment",te._comment).replace("attribute",te._attribute).getRegex(),te._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,te._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,te._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,te.link=S(te.link).replace("label",te._label).replace("href",te._href).replace("title",te._title).getRegex(),te.reflink=S(te.reflink).replace("label",te._label).replace("ref",re._label).getRegex(),te.nolink=S(te.nolink).replace("ref",re._label).getRegex(),te.reflinkSearch=S(te.reflinkSearch,"g").replace("reflink",te.reflink).replace("nolink",te.nolink).getRegex(),te.normal=I({},te),te.pedantic=I({},te.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:S(/^!?\[(label)\]\((.*?)\)/).replace("label",te._label).getRegex(),reflink:S(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",te._label).getRegex()}),te.gfm=I({},te.normal,{escape:S(te.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),te.gfm.url=S(te.gfm.url,"i").replace("email",te.gfm._extended_email).getRegex(),te.breaks=I({},te.gfm,{br:S(te.br).replace("{2,}","*").getRegex(),text:S(te.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function Z(U){return U.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function fe(U){var q="",G,F,V=U.length;for(G=0;G<V;G++)F=U.charCodeAt(G),Math.random()>.5&&(F="x"+F.toString(16)),q+="&#"+F+";";return q}var K=function(){function U(G){this.tokens=[],this.tokens.links=Object.create(null),this.options=G||se.defaults,this.options.tokenizer=this.options.tokenizer||new X,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var F={block:re.normal,inline:te.normal};this.options.pedantic?(F.block=re.pedantic,F.inline=te.pedantic):this.options.gfm&&(F.block=re.gfm,this.options.breaks?F.inline=te.breaks:F.inline=te.gfm),this.tokenizer.rules=F}U.lex=function(F,V){var oe=new U(V);return oe.lex(F)},U.lexInline=function(F,V){var oe=new U(V);return oe.inlineTokens(F)};var q=U.prototype;return q.lex=function(F){F=F.replace(/\r\n|\r/g,`
`),this.blockTokens(F,this.tokens);for(var V;V=this.inlineQueue.shift();)this.inlineTokens(V.src,V.tokens);return this.tokens},q.blockTokens=function(F,V){var oe=this;V===void 0&&(V=[]),this.options.pedantic?F=F.replace(/\t/g,"    ").replace(/^ +$/gm,""):F=F.replace(/^( *)(\t+)/gm,function(Te,Le,he){return Le+"    ".repeat(he.length)});for(var de,Ce,Ne,ge;F;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Te){return(de=Te.call({lexer:oe},F,V))?(F=F.substring(de.raw.length),V.push(de),!0):!1}))){if(de=this.tokenizer.space(F)){F=F.substring(de.raw.length),de.raw.length===1&&V.length>0?V[V.length-1].raw+=`
`:V.push(de);continue}if(de=this.tokenizer.code(F)){F=F.substring(de.raw.length),Ce=V[V.length-1],Ce&&(Ce.type==="paragraph"||Ce.type==="text")?(Ce.raw+=`
`+de.raw,Ce.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=Ce.text):V.push(de);continue}if(de=this.tokenizer.fences(F)){F=F.substring(de.raw.length),V.push(de);continue}if(de=this.tokenizer.heading(F)){F=F.substring(de.raw.length),V.push(de);continue}if(de=this.tokenizer.hr(F)){F=F.substring(de.raw.length),V.push(de);continue}if(de=this.tokenizer.blockquote(F)){F=F.substring(de.raw.length),V.push(de);continue}if(de=this.tokenizer.list(F)){F=F.substring(de.raw.length),V.push(de);continue}if(de=this.tokenizer.html(F)){F=F.substring(de.raw.length),V.push(de);continue}if(de=this.tokenizer.def(F)){F=F.substring(de.raw.length),Ce=V[V.length-1],Ce&&(Ce.type==="paragraph"||Ce.type==="text")?(Ce.raw+=`
`+de.raw,Ce.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ce.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(F)){F=F.substring(de.raw.length),V.push(de);continue}if(de=this.tokenizer.lheading(F)){F=F.substring(de.raw.length),V.push(de);continue}if(Ne=F,this.options.extensions&&this.options.extensions.startBlock&&function(){var Te=1/0,Le=F.slice(1),he=void 0;oe.options.extensions.startBlock.forEach(function(De){he=De.call({lexer:this},Le),typeof he=="number"&&he>=0&&(Te=Math.min(Te,he))}),Te<1/0&&Te>=0&&(Ne=F.substring(0,Te+1))}(),this.state.top&&(de=this.tokenizer.paragraph(Ne))){Ce=V[V.length-1],ge&&Ce.type==="paragraph"?(Ce.raw+=`
`+de.raw,Ce.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ce.text):V.push(de),ge=Ne.length!==F.length,F=F.substring(de.raw.length);continue}if(de=this.tokenizer.text(F)){F=F.substring(de.raw.length),Ce=V[V.length-1],Ce&&Ce.type==="text"?(Ce.raw+=`
`+de.raw,Ce.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ce.text):V.push(de);continue}if(F){var pe="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return this.state.top=!0,V},q.inline=function(F,V){return V===void 0&&(V=[]),this.inlineQueue.push({src:F,tokens:V}),V},q.inlineTokens=function(F,V){var oe=this;V===void 0&&(V=[]);var de,Ce,Ne,ge=F,pe,Te,Le;if(this.tokens.links){var he=Object.keys(this.tokens.links);if(he.length>0)for(;(pe=this.tokenizer.rules.inline.reflinkSearch.exec(ge))!=null;)he.includes(pe[0].slice(pe[0].lastIndexOf("[")+1,-1))&&(ge=ge.slice(0,pe.index)+"["+P("a",pe[0].length-2)+"]"+ge.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(pe=this.tokenizer.rules.inline.blockSkip.exec(ge))!=null;)ge=ge.slice(0,pe.index)+"["+P("a",pe[0].length-2)+"]"+ge.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(pe=this.tokenizer.rules.inline.escapedEmSt.exec(ge))!=null;)ge=ge.slice(0,pe.index)+"++"+ge.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;F;)if(Te||(Le=""),Te=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Re){return(de=Re.call({lexer:oe},F,V))?(F=F.substring(de.raw.length),V.push(de),!0):!1}))){if(de=this.tokenizer.escape(F)){F=F.substring(de.raw.length),V.push(de);continue}if(de=this.tokenizer.tag(F)){F=F.substring(de.raw.length),Ce=V[V.length-1],Ce&&de.type==="text"&&Ce.type==="text"?(Ce.raw+=de.raw,Ce.text+=de.text):V.push(de);continue}if(de=this.tokenizer.link(F)){F=F.substring(de.raw.length),V.push(de);continue}if(de=this.tokenizer.reflink(F,this.tokens.links)){F=F.substring(de.raw.length),Ce=V[V.length-1],Ce&&de.type==="text"&&Ce.type==="text"?(Ce.raw+=de.raw,Ce.text+=de.text):V.push(de);continue}if(de=this.tokenizer.emStrong(F,ge,Le)){F=F.substring(de.raw.length),V.push(de);continue}if(de=this.tokenizer.codespan(F)){F=F.substring(de.raw.length),V.push(de);continue}if(de=this.tokenizer.br(F)){F=F.substring(de.raw.length),V.push(de);continue}if(de=this.tokenizer.del(F)){F=F.substring(de.raw.length),V.push(de);continue}if(de=this.tokenizer.autolink(F,fe)){F=F.substring(de.raw.length),V.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(F,fe))){F=F.substring(de.raw.length),V.push(de);continue}if(Ne=F,this.options.extensions&&this.options.extensions.startInline&&function(){var Re=1/0,xe=F.slice(1),Ve=void 0;oe.options.extensions.startInline.forEach(function(Xe){Ve=Xe.call({lexer:this},xe),typeof Ve=="number"&&Ve>=0&&(Re=Math.min(Re,Ve))}),Re<1/0&&Re>=0&&(Ne=F.substring(0,Re+1))}(),de=this.tokenizer.inlineText(Ne,Z)){F=F.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(Le=de.raw.slice(-1)),Te=!0,Ce=V[V.length-1],Ce&&Ce.type==="text"?(Ce.raw+=de.raw,Ce.text+=de.text):V.push(de);continue}if(F){var De="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return V},i(U,null,[{key:"rules",get:function(){return{block:re,inline:te}}}]),U}(),ae=function(){function U(G){this.options=G||se.defaults}var q=U.prototype;return q.code=function(F,V,oe){var de=(V||"").match(/\S*/)[0];if(this.options.highlight){var Ce=this.options.highlight(F,de);Ce!=null&&Ce!==F&&(oe=!0,F=Ce)}return F=F.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+a(de,!0)+'">'+(oe?F:a(F,!0))+`</code></pre>
`:"<pre><code>"+(oe?F:a(F,!0))+`</code></pre>
`},q.blockquote=function(F){return`<blockquote>
`+F+`</blockquote>
`},q.html=function(F){return F},q.heading=function(F,V,oe,de){if(this.options.headerIds){var Ce=this.options.headerPrefix+de.slug(oe);return"<h"+V+' id="'+Ce+'">'+F+"</h"+V+`>
`}return"<h"+V+">"+F+"</h"+V+`>
`},q.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},q.list=function(F,V,oe){var de=V?"ol":"ul",Ce=V&&oe!==1?' start="'+oe+'"':"";return"<"+de+Ce+`>
`+F+"</"+de+`>
`},q.listitem=function(F){return"<li>"+F+`</li>
`},q.checkbox=function(F){return"<input "+(F?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},q.paragraph=function(F){return"<p>"+F+`</p>
`},q.table=function(F,V){return V&&(V="<tbody>"+V+"</tbody>"),`<table>
<thead>
`+F+`</thead>
`+V+`</table>
`},q.tablerow=function(F){return`<tr>
`+F+`</tr>
`},q.tablecell=function(F,V){var oe=V.header?"th":"td",de=V.align?"<"+oe+' align="'+V.align+'">':"<"+oe+">";return de+F+("</"+oe+`>
`)},q.strong=function(F){return"<strong>"+F+"</strong>"},q.em=function(F){return"<em>"+F+"</em>"},q.codespan=function(F){return"<code>"+F+"</code>"},q.br=function(){return this.options.xhtml?"<br/>":"<br>"},q.del=function(F){return"<del>"+F+"</del>"},q.link=function(F,V,oe){if(F=t(this.options.sanitize,this.options.baseUrl,F),F===null)return oe;var de='<a href="'+a(F)+'"';return V&&(de+=' title="'+V+'"'),de+=">"+oe+"</a>",de},q.image=function(F,V,oe){if(F=t(this.options.sanitize,this.options.baseUrl,F),F===null)return oe;var de='<img src="'+F+'" alt="'+oe+'"';return V&&(de+=' title="'+V+'"'),de+=this.options.xhtml?"/>":">",de},q.text=function(F){return F},U}(),x=function(){function U(){}var q=U.prototype;return q.strong=function(F){return F},q.em=function(F){return F},q.codespan=function(F){return F},q.del=function(F){return F},q.html=function(F){return F},q.text=function(F){return F},q.link=function(F,V,oe){return""+oe},q.image=function(F,V,oe){return""+oe},q.br=function(){return""},U}(),z=function(){function U(){this.seen={}}var q=U.prototype;return q.serialize=function(F){return F.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},q.getNextSafeSlug=function(F,V){var oe=F,de=0;if(this.seen.hasOwnProperty(oe)){de=this.seen[F];do de++,oe=F+"-"+de;while(this.seen.hasOwnProperty(oe))}return V||(this.seen[F]=de,this.seen[oe]=0),oe},q.slug=function(F,V){V===void 0&&(V={});var oe=this.serialize(F);return this.getNextSafeSlug(oe,V.dryrun)},U}(),ne=function(){function U(G){this.options=G||se.defaults,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new z}U.parse=function(F,V){var oe=new U(V);return oe.parse(F)},U.parseInline=function(F,V){var oe=new U(V);return oe.parseInline(F)};var q=U.prototype;return q.parse=function(F,V){V===void 0&&(V=!0);var oe="",de,Ce,Ne,ge,pe,Te,Le,he,De,Re,xe,Ve,Xe,je,qe,Je,st,lt,rt,it=F.length;for(de=0;de<it;de++){if(Re=F[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Re.type]&&(rt=this.options.extensions.renderers[Re.type].call({parser:this},Re),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Re.type))){oe+=rt||"";continue}switch(Re.type){case"space":continue;case"hr":{oe+=this.renderer.hr();continue}case"heading":{oe+=this.renderer.heading(this.parseInline(Re.tokens),Re.depth,m(this.parseInline(Re.tokens,this.textRenderer)),this.slugger);continue}case"code":{oe+=this.renderer.code(Re.text,Re.lang,Re.escaped);continue}case"table":{for(he="",Le="",ge=Re.header.length,Ce=0;Ce<ge;Ce++)Le+=this.renderer.tablecell(this.parseInline(Re.header[Ce].tokens),{header:!0,align:Re.align[Ce]});for(he+=this.renderer.tablerow(Le),De="",ge=Re.rows.length,Ce=0;Ce<ge;Ce++){for(Te=Re.rows[Ce],Le="",pe=Te.length,Ne=0;Ne<pe;Ne++)Le+=this.renderer.tablecell(this.parseInline(Te[Ne].tokens),{header:!1,align:Re.align[Ne]});De+=this.renderer.tablerow(Le)}oe+=this.renderer.table(he,De);continue}case"blockquote":{De=this.parse(Re.tokens),oe+=this.renderer.blockquote(De);continue}case"list":{for(xe=Re.ordered,Ve=Re.start,Xe=Re.loose,ge=Re.items.length,De="",Ce=0;Ce<ge;Ce++)qe=Re.items[Ce],Je=qe.checked,st=qe.task,je="",qe.task&&(lt=this.renderer.checkbox(Je),Xe?qe.tokens.length>0&&qe.tokens[0].type==="paragraph"?(qe.tokens[0].text=lt+" "+qe.tokens[0].text,qe.tokens[0].tokens&&qe.tokens[0].tokens.length>0&&qe.tokens[0].tokens[0].type==="text"&&(qe.tokens[0].tokens[0].text=lt+" "+qe.tokens[0].tokens[0].text)):qe.tokens.unshift({type:"text",text:lt}):je+=lt),je+=this.parse(qe.tokens,Xe),De+=this.renderer.listitem(je,st,Je);oe+=this.renderer.list(De,xe,Ve);continue}case"html":{oe+=this.renderer.html(Re.text);continue}case"paragraph":{oe+=this.renderer.paragraph(this.parseInline(Re.tokens));continue}case"text":{for(De=Re.tokens?this.parseInline(Re.tokens):Re.text;de+1<it&&F[de+1].type==="text";)Re=F[++de],De+=`
`+(Re.tokens?this.parseInline(Re.tokens):Re.text);oe+=V?this.renderer.paragraph(De):De;continue}default:{var tt='Token with "'+Re.type+'" type was not found.';if(this.options.silent){console.error(tt);return}else throw new Error(tt)}}}return oe},q.parseInline=function(F,V){V=V||this.renderer;var oe="",de,Ce,Ne,ge=F.length;for(de=0;de<ge;de++){if(Ce=F[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ce.type]&&(Ne=this.options.extensions.renderers[Ce.type].call({parser:this},Ce),Ne!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ce.type))){oe+=Ne||"";continue}switch(Ce.type){case"escape":{oe+=V.text(Ce.text);break}case"html":{oe+=V.html(Ce.text);break}case"link":{oe+=V.link(Ce.href,Ce.title,this.parseInline(Ce.tokens,V));break}case"image":{oe+=V.image(Ce.href,Ce.title,Ce.text);break}case"strong":{oe+=V.strong(this.parseInline(Ce.tokens,V));break}case"em":{oe+=V.em(this.parseInline(Ce.tokens,V));break}case"codespan":{oe+=V.codespan(Ce.text);break}case"br":{oe+=V.br();break}case"del":{oe+=V.del(this.parseInline(Ce.tokens,V));break}case"text":{oe+=V.text(Ce.text);break}default:{var pe='Token with "'+Ce.type+'" type was not found.';if(this.options.silent){console.error(pe);return}else throw new Error(pe)}}}return oe},U}();function le(U,q,G){if(typeof U>"u"||U===null)throw new Error("marked(): input parameter is undefined or null");if(typeof U!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(U)+", string expected");if(typeof q=="function"&&(G=q,q=null),q=I({},le.defaults,q||{}),k(q),G){var F=q.highlight,V;try{V=K.lex(U,q)}catch(ge){return G(ge)}var oe=function(pe){var Te;if(!pe)try{q.walkTokens&&le.walkTokens(V,q.walkTokens),Te=ne.parse(V,q)}catch(Le){pe=Le}return q.highlight=F,pe?G(pe):G(null,Te)};if(!F||F.length<3||(delete q.highlight,!V.length))return oe();var de=0;le.walkTokens(V,function(ge){ge.type==="code"&&(de++,setTimeout(function(){F(ge.text,ge.lang,function(pe,Te){if(pe)return oe(pe);Te!=null&&Te!==ge.text&&(ge.text=Te,ge.escaped=!0),de--,de===0&&oe()})},0))}),de===0&&oe();return}function Ce(ge){if(ge.message+=`
Please report this to https://github.com/markedjs/marked.`,q.silent)return"<p>An error occurred:</p><pre>"+a(ge.message+"",!0)+"</pre>";throw ge}try{var Ne=K.lex(U,q);if(q.walkTokens){if(q.async)return Promise.all(le.walkTokens(Ne,q.walkTokens)).then(function(){return ne.parse(Ne,q)}).catch(Ce);le.walkTokens(Ne,q.walkTokens)}return ne.parse(Ne,q)}catch(ge){Ce(ge)}}le.options=le.setOptions=function(U){return I(le.defaults,U),_(le.defaults),le},le.getDefaults=R,le.defaults=se.defaults,le.use=function(){for(var U=arguments.length,q=new Array(U),G=0;G<U;G++)q[G]=arguments[G];var F=I.apply(void 0,[{}].concat(q)),V=le.defaults.extensions||{renderers:{},childTokens:{}},oe;q.forEach(function(de){if(de.extensions&&(oe=!0,de.extensions.forEach(function(Ne){if(!Ne.name)throw new Error("extension name required");if(Ne.renderer){var ge=V.renderers?V.renderers[Ne.name]:null;ge?V.renderers[Ne.name]=function(){for(var pe=arguments.length,Te=new Array(pe),Le=0;Le<pe;Le++)Te[Le]=arguments[Le];var he=Ne.renderer.apply(this,Te);return he===!1&&(he=ge.apply(this,Te)),he}:V.renderers[Ne.name]=Ne.renderer}if(Ne.tokenizer){if(!Ne.level||Ne.level!=="block"&&Ne.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");V[Ne.level]?V[Ne.level].unshift(Ne.tokenizer):V[Ne.level]=[Ne.tokenizer],Ne.start&&(Ne.level==="block"?V.startBlock?V.startBlock.push(Ne.start):V.startBlock=[Ne.start]:Ne.level==="inline"&&(V.startInline?V.startInline.push(Ne.start):V.startInline=[Ne.start]))}Ne.childTokens&&(V.childTokens[Ne.name]=Ne.childTokens)})),de.renderer&&function(){var Ne=le.defaults.renderer||new ae,ge=function(Le){var he=Ne[Le];Ne[Le]=function(){for(var De=arguments.length,Re=new Array(De),xe=0;xe<De;xe++)Re[xe]=arguments[xe];var Ve=de.renderer[Le].apply(Ne,Re);return Ve===!1&&(Ve=he.apply(Ne,Re)),Ve}};for(var pe in de.renderer)ge(pe);F.renderer=Ne}(),de.tokenizer&&function(){var Ne=le.defaults.tokenizer||new X,ge=function(Le){var he=Ne[Le];Ne[Le]=function(){for(var De=arguments.length,Re=new Array(De),xe=0;xe<De;xe++)Re[xe]=arguments[xe];var Ve=de.tokenizer[Le].apply(Ne,Re);return Ve===!1&&(Ve=he.apply(Ne,Re)),Ve}};for(var pe in de.tokenizer)ge(pe);F.tokenizer=Ne}(),de.walkTokens){var Ce=le.defaults.walkTokens;F.walkTokens=function(Ne){var ge=[];return ge.push(de.walkTokens.call(this,Ne)),Ce&&(ge=ge.concat(Ce.call(this,Ne))),ge}}oe&&(F.extensions=V),le.setOptions(F)})},le.walkTokens=function(U,q){for(var G=[],F=function(){var Ce=oe.value;switch(G=G.concat(q.call(le,Ce)),Ce.type){case"table":{for(var Ne=C(Ce.header),ge;!(ge=Ne()).done;){var pe=ge.value;G=G.concat(le.walkTokens(pe.tokens,q))}for(var Te=C(Ce.rows),Le;!(Le=Te()).done;)for(var he=Le.value,De=C(he),Re;!(Re=De()).done;){var xe=Re.value;G=G.concat(le.walkTokens(xe.tokens,q))}break}case"list":{G=G.concat(le.walkTokens(Ce.items,q));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[Ce.type]?le.defaults.extensions.childTokens[Ce.type].forEach(function(Ve){G=G.concat(le.walkTokens(Ce[Ve],q))}):Ce.tokens&&(G=G.concat(le.walkTokens(Ce.tokens,q)))}},V=C(U),oe;!(oe=V()).done;)F();return G},le.parseInline=function(U,q){if(typeof U>"u"||U===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof U!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(U)+", string expected");q=I({},le.defaults,q||{}),k(q);try{var G=K.lexInline(U,q);return q.walkTokens&&le.walkTokens(G,q.walkTokens),ne.parseInline(G,q)}catch(F){if(F.message+=`
Please report this to https://github.com/markedjs/marked.`,q.silent)return"<p>An error occurred:</p><pre>"+a(F.message+"",!0)+"</pre>";throw F}},le.Parser=ne,le.parser=ne.parse,le.Renderer=ae,le.TextRenderer=x,le.Lexer=K,le.lexer=K.lex,le.Tokenizer=X,le.Slugger=z,le.parse=le;var ve=le.options,H=le.setOptions,ce=le.use,J=le.walkTokens,W=le.parseInline,L=le,Q=ne.parse,$=K.lex;se.Lexer=K,se.Parser=ne,se.Renderer=ae,se.Slugger=z,se.TextRenderer=x,se.Tokenizer=X,se.getDefaults=R,se.lexer=$,se.marked=le,se.options=ve,se.parse=L,se.parseInline=W,se.parser=Q,se.setOptions=H,se.use=ce,se.walkTokens=J,Object.defineProperty(se,"__esModule",{value:!0})}),define(ye[81],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var i;(function(r){r[r.Uri=1]="Uri",r[r.Regexp=2]="Regexp",r[r.ScmResource=3]="ScmResource",r[r.ScmResourceGroup=4]="ScmResourceGroup",r[r.ScmProvider=5]="ScmProvider",r[r.CommentController=6]="CommentController",r[r.CommentThread=7]="CommentThread",r[r.CommentThreadInstance=8]="CommentThreadInstance",r[r.CommentThreadReply=9]="CommentThreadReply",r[r.CommentNode=10]="CommentNode",r[r.CommentThreadNode=11]="CommentThreadNode",r[r.TimelineActionContext=12]="TimelineActionContext",r[r.NotebookCellActionContext=13]="NotebookCellActionContext",r[r.NotebookActionContext=14]="NotebookActionContext",r[r.TerminalContext=15]="TerminalContext",r[r.TestItemContext=16]="TestItemContext",r[r.Date=17]="Date",r[r.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(i||(e.MarshalledId=i={}))}),define(ye[162],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getKoreanAltChars=i;function i(f){const m=C(f);if(m&&m.length>0)return new Uint32Array(m)}let r=0;const w=new Uint32Array(10);function C(f){if(r=0,R(f,y,b.InitialConsonant),r>0||(R(f,d,b.Vowel),r>0)||(R(f,E,b.FinalConsonant),r>0)||(R(f,a,b.CompatibilityJamo),r))return w.subarray(0,r);if(f>=44032&&f<=55203){const m=f-44032,p=m%588,S=Math.floor(m/588),g=Math.floor(p/28),v=p%28-1;if(S<y.length?R(S,y,0):b.InitialConsonant+S-b.CompatibilityJamo<a.length&&R(b.InitialConsonant+S,a,b.CompatibilityJamo),g<d.length?R(g,d,0):b.Vowel+g-b.CompatibilityJamo<a.length&&R(b.Vowel+g-b.CompatibilityJamo,a,b.CompatibilityJamo),v>=0&&(v<E.length?R(v,E,0):b.FinalConsonant+v-b.CompatibilityJamo<a.length&&R(b.FinalConsonant+v-b.CompatibilityJamo,a,b.CompatibilityJamo)),r>0)return w.subarray(0,r)}}function R(f,m,p){f>=p&&f<p+m.length&&_(m[f-p])}function _(f){f!==o.NUL&&(w[r++]=f&255,f>>8&&(w[r++]=f>>8&255),f>>16&&(w[r++]=f>>16&255))}var b;(function(f){f[f.InitialConsonant=4352]="InitialConsonant",f[f.Vowel=4449]="Vowel",f[f.FinalConsonant=4520]="FinalConsonant",f[f.CompatibilityJamo=12593]="CompatibilityJamo"})(b||(b={}));var o;(function(f){f[f.NUL=0]="NUL",f[f.A=65]="A",f[f.B=66]="B",f[f.C=67]="C",f[f.D=68]="D",f[f.E=69]="E",f[f.F=70]="F",f[f.G=71]="G",f[f.H=72]="H",f[f.I=73]="I",f[f.J=74]="J",f[f.K=75]="K",f[f.L=76]="L",f[f.M=77]="M",f[f.N=78]="N",f[f.O=79]="O",f[f.P=80]="P",f[f.Q=81]="Q",f[f.R=82]="R",f[f.S=83]="S",f[f.T=84]="T",f[f.U=85]="U",f[f.V=86]="V",f[f.W=87]="W",f[f.X=88]="X",f[f.Y=89]="Y",f[f.Z=90]="Z",f[f.a=97]="a",f[f.b=98]="b",f[f.c=99]="c",f[f.d=100]="d",f[f.e=101]="e",f[f.f=102]="f",f[f.g=103]="g",f[f.h=104]="h",f[f.i=105]="i",f[f.j=106]="j",f[f.k=107]="k",f[f.l=108]="l",f[f.m=109]="m",f[f.n=110]="n",f[f.o=111]="o",f[f.p=112]="p",f[f.q=113]="q",f[f.r=114]="r",f[f.s=115]="s",f[f.t=116]="t",f[f.u=117]="u",f[f.v=118]="v",f[f.w=119]="w",f[f.x=120]="x",f[f.y=121]="y",f[f.z=122]="z"})(o||(o={}));var D;(function(f){f[f.fa=24934]="fa",f[f.fg=26470]="fg",f[f.fq=29030]="fq",f[f.fr=29286]="fr",f[f.ft=29798]="ft",f[f.fv=30310]="fv",f[f.fx=30822]="fx",f[f.hk=27496]="hk",f[f.hl=27752]="hl",f[f.ho=28520]="ho",f[f.ml=27757]="ml",f[f.nj=27246]="nj",f[f.nl=27758]="nl",f[f.np=28782]="np",f[f.qt=29809]="qt",f[f.rt=29810]="rt",f[f.sg=26483]="sg",f[f.sw=30579]="sw"})(D||(D={}));const y=new Uint8Array([o.r,o.R,o.s,o.e,o.E,o.f,o.a,o.q,o.Q,o.t,o.T,o.d,o.w,o.W,o.c,o.z,o.x,o.v,o.g]),d=new Uint16Array([o.k,o.o,o.i,o.O,o.j,o.p,o.u,o.P,o.h,D.hk,D.ho,D.hl,o.y,o.n,D.nj,D.np,D.nl,o.b,o.m,D.ml,o.l]),E=new Uint16Array([o.r,o.R,D.rt,o.s,D.sw,D.sg,o.e,o.f,D.fr,D.fa,D.fq,D.ft,D.fx,D.fv,D.fg,o.a,o.q,D.qt,o.t,o.T,o.d,o.w,o.c,o.z,o.x,o.v,o.g]),a=new Uint16Array([o.r,o.R,D.rt,o.s,D.sw,D.sg,o.e,o.E,o.f,D.fr,D.fa,D.fq,D.ft,D.fx,D.fv,D.fg,o.a,o.q,o.Q,D.qt,o.t,o.T,o.d,o.w,o.W,o.c,o.z,o.x,o.v,o.g,o.k,o.o,o.i,o.O,o.j,o.p,o.u,o.P,o.h,D.hk,D.ho,D.hl,o.y,o.n,D.nj,D.np,D.nl,o.b,o.m,D.ml,o.l])}),define(ye[107],Ie([1,0,26]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=w,e.normalizeNFD=R;const r=new i.LRUCache(1e4);function w(o){return b(o,"NFC",r)}const C=new i.LRUCache(1e4);function R(o){return b(o,"NFD",C)}const _=/[^\u0000-\u0080]/;function b(o,D,y){if(!o)return o;const d=y.get(o);if(d)return d;let E;return _.test(o)?E=o.normalize(D):E=o,y.set(o,E),E}e.removeAccents=function(){const o=/[\u0300-\u036f]/g;return function(D){return R(D).replace(o,"")}}()}),define(ye[163],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=void 0,e.clamp=i,e.rot=r,e.isPointWithinTriangle=_;function i(b,o,D){return Math.min(Math.max(b,o),D)}function r(b,o){return(o+b%o)%o}class w{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=w;class C{constructor(){this._n=1,this._val=0}update(o){return this._val=this._val+(o-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=C;class R{constructor(o){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(o),this._values.fill(0,0,o)}update(o){const D=this._values[this._index];return this._values[this._index]=o,this._index=(this._index+1)%this._values.length,this._sum-=D,this._sum+=o,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=R;function _(b,o,D,y,d,E,a,f){const m=a-D,p=f-y,S=d-D,g=E-y,v=b-D,t=o-y,l=m*m+p*p,n=m*S+p*g,h=m*v+p*t,s=S*S+g*g,c=S*v+g*t,u=1/(l*s-n*n),I=(s*h-n*c)*u,T=(l*c-n*h)*u;return I>=0&&T>=0&&I+T<1}}),define(ye[164],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugNameData=void 0,e.getDebugName=C,e.getFunctionName=d;class i{constructor(a,f,m){this.owner=a,this.debugNameSource=f,this.referenceFn=m}getDebugName(a){return C(a,this)}}e.DebugNameData=i;const r=new Map,w=new WeakMap;function C(E,a){const f=w.get(E);if(f)return f;const m=R(E,a);if(m){let p=r.get(m)??0;p++,r.set(m,p);const S=p===1?m:`${m}#${p}`;return w.set(E,S),S}}function R(E,a){const f=w.get(E);if(f)return f;const m=a.owner?D(a.owner)+".":"";let p;const S=a.debugNameSource;if(S!==void 0)if(typeof S=="function"){if(p=S(),p!==void 0)return m+p}else return m+S;const g=a.referenceFn;if(g!==void 0&&(p=d(g),p!==void 0))return m+p;if(a.owner!==void 0){const v=_(a.owner,E);if(v!==void 0)return m+v}}function _(E,a){for(const f in E)if(E[f]===a)return f}const b=new Map,o=new WeakMap;function D(E){const a=o.get(E);if(a)return a;const f=y(E);let m=b.get(f)??0;m++,b.set(f,m);const p=m===1?f:`${f}#${m}`;return o.set(E,p),p}function y(E){const a=E.constructor;return a?a.name:"Object"}function d(E){const a=E.toString(),m=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(a);return(m?m[1]:void 0)?.trim()}}),define(ye[165],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=void 0,e.setLogger=r,e.getLogger=w;let i;function r(f){i=f}function w(){return i}class C{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(m){return R([_(E("|  ",this.indentation)),m])}formatInfo(m){return m.hadValue?m.didChange?[_(" "),o(D(m.oldValue,70),{color:"red",strikeThrough:!0}),_(" "),o(D(m.newValue,60),{color:"green"})]:[_(" (unchanged)")]:[_(" "),o(D(m.newValue,60),{color:"green"}),_(" (initial)")]}handleObservableChanged(m,p){console.log(...this.textToConsoleArgs([b("observable value changed"),o(m.debugName,{color:"BlueViolet"}),...this.formatInfo(p)]))}formatChanges(m){if(m.size!==0)return o(" (changed deps: "+[...m].map(p=>p.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(m){const p=m.handleChange;this.changedObservablesSets.set(m,new Set),m.handleChange=(S,g)=>(this.changedObservablesSets.get(m).add(S),p.apply(m,[S,g]))}handleDerivedRecomputed(m,p){const S=this.changedObservablesSets.get(m);console.log(...this.textToConsoleArgs([b("derived recomputed"),o(m.debugName,{color:"BlueViolet"}),...this.formatInfo(p),this.formatChanges(S),{data:[{fn:m._debugNameData.referenceFn??m._computeFn}]}])),S.clear()}handleFromEventObservableTriggered(m,p){console.log(...this.textToConsoleArgs([b("observable from event triggered"),o(m.debugName,{color:"BlueViolet"}),...this.formatInfo(p),{data:[{fn:m._getValue}]}]))}handleAutorunCreated(m){const p=m.handleChange;this.changedObservablesSets.set(m,new Set),m.handleChange=(S,g)=>(this.changedObservablesSets.get(m).add(S),p.apply(m,[S,g]))}handleAutorunTriggered(m){const p=this.changedObservablesSets.get(m);console.log(...this.textToConsoleArgs([b("autorun"),o(m.debugName,{color:"BlueViolet"}),this.formatChanges(p),{data:[{fn:m._debugNameData.referenceFn??m._runFn}]}])),p.clear(),this.indentation++}handleAutorunFinished(m){this.indentation--}handleBeginTransaction(m){let p=m.getDebugName();p===void 0&&(p=""),console.log(...this.textToConsoleArgs([b("transaction"),o(p,{color:"BlueViolet"}),{data:[{fn:m._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=C;function R(f){const m=new Array,p=[];let S="";function g(t){if("length"in t)for(const l of t)l&&g(l);else"text"in t?(S+=`%c${t.text}`,m.push(t.style),t.data&&p.push(...t.data)):"data"in t&&p.push(...t.data)}g(f);const v=[S,...m];return v.push(...p),v}function _(f){return o(f,{color:"black"})}function b(f){return o(a(`${f}: `,10),{color:"black",bold:!0})}function o(f,m={color:"black"}){function p(g){return Object.entries(g).reduce((v,[t,l])=>`${v}${t}:${l};`,"")}const S={color:m.color};return m.strikeThrough&&(S["text-decoration"]="line-through"),m.bold&&(S["font-weight"]="bold"),{text:f,style:p(S)}}function D(f,m){switch(typeof f){case"number":return""+f;case"string":return f.length+2<=m?`"${f}"`:`"${f.substr(0,m-7)}"+...`;case"boolean":return f?"true":"false";case"undefined":return"undefined";case"object":return f===null?"null":Array.isArray(f)?y(f,m):d(f,m);case"symbol":return f.toString();case"function":return`[[Function${f.name?" "+f.name:""}]]`;default:return""+f}}function y(f,m){let p="[ ",S=!0;for(const g of f){if(S||(p+=", "),p.length-5>m){p+="...";break}S=!1,p+=`${D(g,m-p.length)}`}return p+=" ]",p}function d(f,m){let p="{ ",S=!0;for(const[g,v]of Object.entries(f)){if(S||(p+=", "),p.length-5>m){p+="...";break}S=!1,p+=`${g}: ${D(v,m-p.length)}`}return p+=" }",p}function E(f,m){let p="";for(let S=1;S<=m;S++)p+=f;return p}function a(f,m){for(;f.length<m;)f+=" ";return f}}),define(ye[166],Ie([1,0,158,164,165]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.ObservableValue=e.TransactionImpl=e.BaseObservable=e.ConvenientObservable=void 0,e._setRecomputeInitiallyAndOnChange=R,e._setKeepObserved=b,e._setDerivedOpts=D,e.transaction=E,e.globalTransaction=f,e.asyncTransaction=m,e.subtransaction=p,e.observableValue=g,e.disposableObservableValue=t;let C;function R(n){C=n}let _;function b(n){_=n}let o;function D(n){o=n}class y{get TChange(){return null}reportChanges(){this.get()}read(h){return h?h.readObservable(this):this.get()}map(h,s){const c=s===void 0?void 0:h,u=s===void 0?h:s;return o({owner:c,debugName:()=>{const I=(0,r.getFunctionName)(u);if(I!==void 0)return I;const A=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(u.toString());if(A)return`${this.debugName}.${A[2]}`;if(!c)return`${this.debugName} (mapped)`},debugReferenceFn:u},I=>u(this.read(I),I))}recomputeInitiallyAndOnChange(h,s){return h.add(C(this,s)),this}keepObserved(h){return h.add(_(this)),this}get debugValue(){return this.get()}}e.ConvenientObservable=y;class d extends y{constructor(){super(...arguments),this.observers=new Set}addObserver(h){const s=this.observers.size;this.observers.add(h),s===0&&this.onFirstObserverAdded()}removeObserver(h){this.observers.delete(h)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=d;function E(n,h){const s=new S(n,h);try{n(s)}finally{s.finish()}}let a;function f(n){if(a)n(a);else{const h=new S(n,void 0);a=h;try{n(h)}finally{h.finish(),a=void 0}}}async function m(n,h){const s=new S(n,h);try{await n(s)}finally{s.finish()}}function p(n,h,s){n?h(n):E(h,s)}class S{constructor(h,s){this._fn=h,this._getDebugName=s,this.updatingObservers=[],(0,w.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():(0,r.getFunctionName)(this._fn)}updateObserver(h,s){this.updatingObservers.push({observer:h,observable:s}),h.beginUpdate(s)}finish(){const h=this.updatingObservers;for(let s=0;s<h.length;s++){const{observer:c,observable:u}=h[s];c.endUpdate(u)}this.updatingObservers=null,(0,w.getLogger)()?.handleEndTransaction()}}e.TransactionImpl=S;function g(n,h){let s;return typeof n=="string"?s=new r.DebugNameData(void 0,n,void 0):s=new r.DebugNameData(n,void 0,void 0),new v(s,h,i.strictEquals)}class v extends d{get debugName(){return this._debugNameData.getDebugName(this)??"ObservableValue"}constructor(h,s,c){super(),this._debugNameData=h,this._equalityComparator=c,this._value=s}get(){return this._value}set(h,s,c){if(c===void 0&&this._equalityComparator(this._value,h))return;let u;s||(s=u=new S(()=>{},()=>`Setting ${this.debugName}`));try{const I=this._value;this._setValue(h),(0,w.getLogger)()?.handleObservableChanged(this,{oldValue:I,newValue:h,change:c,didChange:!0,hadValue:!0});for(const T of this.observers)s.updateObserver(T,this),T.handleChange(this,c)}finally{u&&u.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(h){this._value=h}}e.ObservableValue=v;function t(n,h){let s;return typeof n=="string"?s=new r.DebugNameData(void 0,n,void 0):s=new r.DebugNameData(n,void 0,void 0),new l(s,h,i.strictEquals)}class l extends v{_setValue(h){this._value!==h&&(this._value&&this._value.dispose(),this._value=h)}dispose(){this._value?.dispose()}}e.DisposableObservableValue=l}),function(){function se(w){const C=[];typeof w=="number"&&C.push("code/timeOrigin",w);function R(b){C.push(b,Date.now())}function _(){const b=[];for(let o=0;o<C.length;o+=2)b.push({name:C[o],startTime:C[o+1]});return b}return{mark:R,getMarks:_}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?se():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const R of performance.getEntriesByType("mark"))C.push({name:R.name,startTime:Math.round(w+R.startTime)});return C}};if(typeof process=="object"){const w=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return se(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),se()}function i(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=e()),w.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=i(r))}(),define(ye[167],Ie([1,0,40]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WellDefinedPrefixTree=void 0;const r=Symbol("unset");class w{constructor(){this.root=new R,this._size=0}get size(){return this._size}get nodes(){return this.root.children?.values()||i.Iterable.empty()}insert(b,o,D){this.opNode(b,y=>y._value=o,D)}mutate(b,o){this.opNode(b,D=>D._value=o(D._value===r?void 0:D._value))}mutatePath(b,o){this.opNode(b,()=>{},D=>o(D))}delete(b){const o=this.getPathToKey(b);if(!o)return;let D=o.length-1;const y=o[D].node._value;if(y!==r){for(this._size--,o[D].node._value=r;D>0;D--){const{node:d,part:E}=o[D];if(d.children?.size||d._value!==r)break;o[D-1].node.children.delete(E)}return y}}*deleteRecursive(b){const o=this.getPathToKey(b);if(!o)return;const D=o[o.length-1].node;for(let y=o.length-1;y>0;y--){const d=o[y-1];if(d.node.children.delete(o[y].part),d.node.children.size>0||d.node._value!==r)break}for(const y of C(D))y._value!==r&&(this._size--,yield y._value)}find(b){let o=this.root;for(const D of b){const y=o.children?.get(D);if(!y)return;o=y}return o._value===r?void 0:o._value}hasKeyOrParent(b){let o=this.root;for(const D of b){const y=o.children?.get(D);if(!y)return!1;if(y._value!==r)return!0;o=y}return!1}hasKeyOrChildren(b){let o=this.root;for(const D of b){const y=o.children?.get(D);if(!y)return!1;o=y}return!0}hasKey(b){let o=this.root;for(const D of b){const y=o.children?.get(D);if(!y)return!1;o=y}return o._value!==r}getPathToKey(b){const o=[{part:"",node:this.root}];let D=0;for(const y of b){const d=o[D].node.children?.get(y);if(!d)return;o.push({part:y,node:d}),D++}return o}opNode(b,o,D){let y=this.root;for(const a of b){if(y.children)if(y.children.has(a))y=y.children.get(a);else{const f=new R;y.children.set(a,f),y=f}else{const f=new R;y.children=new Map([[a,f]]),y=f}D?.(y)}const d=y._value===r?0:1;o(y);const E=y._value===r?0:1;this._size+=E-d}*values(){for(const{_value:b}of C(this.root))b!==r&&(yield b)}}e.WellDefinedPrefixTree=w;function*C(_){const b=[_];for(;b.length>0;){const o=b.pop();if(yield o,o.children)for(const D of o.children.values())b.push(D)}}class R{constructor(){this._value=r}get value(){return this._value===r?void 0:this._value}set value(b){this._value=b===void 0?r:b}}}),function(se,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var r in i)(typeof exports=="object"?exports:se)[r]=i[r]}}(typeof self<"u"?self:this,function(){return function(se){var e={};function i(r){if(e[r])return e[r].exports;var w=e[r]={i:r,l:!1,exports:{}};return se[r].call(w.exports,w,w.exports,i),w.l=!0,w.exports}return i.m=se,i.c=e,i.d=function(r,w,C){i.o(r,w)||Object.defineProperty(r,w,{enumerable:!0,get:C})},i.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},i.t=function(r,w){if(1&w&&(r=i(r)),8&w||4&w&&typeof r=="object"&&r&&r.__esModule)return r;var C=Object.create(null);if(i.r(C),Object.defineProperty(C,"default",{enumerable:!0,value:r}),2&w&&typeof r!="string")for(var R in r)i.d(C,R,function(_){return r[_]}.bind(null,R));return C},i.n=function(r){var w=r&&r.__esModule?function(){return r.default}:function(){return r};return i.d(w,"a",w),w},i.o=function(r,w){return Object.prototype.hasOwnProperty.call(r,w)},i.p="",i(i.s=0)}([function(se,e,i){(function(r){var w;e=se.exports=ce,w=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var he=Array.prototype.slice.call(arguments,0);he.unshift("SEMVER"),console.log.apply(console,he)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var C=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,_=e.re=[],b=e.src=[],o=0,D=o++;b[D]="0|[1-9]\\d*";var y=o++;b[y]="[0-9]+";var d=o++;b[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=o++;b[E]="("+b[D]+")\\.("+b[D]+")\\.("+b[D]+")";var a=o++;b[a]="("+b[y]+")\\.("+b[y]+")\\.("+b[y]+")";var f=o++;b[f]="(?:"+b[D]+"|"+b[d]+")";var m=o++;b[m]="(?:"+b[y]+"|"+b[d]+")";var p=o++;b[p]="(?:-("+b[f]+"(?:\\."+b[f]+")*))";var S=o++;b[S]="(?:-?("+b[m]+"(?:\\."+b[m]+")*))";var g=o++;b[g]="[0-9A-Za-z-]+";var v=o++;b[v]="(?:\\+("+b[g]+"(?:\\."+b[g]+")*))";var t=o++,l="v?"+b[E]+b[p]+"?"+b[v]+"?";b[t]="^"+l+"$";var n="[v=\\s]*"+b[a]+b[S]+"?"+b[v]+"?",h=o++;b[h]="^"+n+"$";var s=o++;b[s]="((?:<|>)?=?)";var c=o++;b[c]=b[y]+"|x|X|\\*";var u=o++;b[u]=b[D]+"|x|X|\\*";var I=o++;b[I]="[v=\\s]*("+b[u]+")(?:\\.("+b[u]+")(?:\\.("+b[u]+")(?:"+b[p]+")?"+b[v]+"?)?)?";var T=o++;b[T]="[v=\\s]*("+b[c]+")(?:\\.("+b[c]+")(?:\\.("+b[c]+")(?:"+b[S]+")?"+b[v]+"?)?)?";var A=o++;b[A]="^"+b[s]+"\\s*"+b[I]+"$";var O=o++;b[O]="^"+b[s]+"\\s*"+b[T]+"$";var k=o++;b[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=o++;b[P]="(?:~>?)";var B=o++;b[B]="(\\s*)"+b[P]+"\\s+",_[B]=new RegExp(b[B],"g");var Y=o++;b[Y]="^"+b[P]+b[I]+"$";var X=o++;b[X]="^"+b[P]+b[T]+"$";var re=o++;b[re]="(?:\\^)";var te=o++;b[te]="(\\s*)"+b[re]+"\\s+",_[te]=new RegExp(b[te],"g");var Z=o++;b[Z]="^"+b[re]+b[I]+"$";var fe=o++;b[fe]="^"+b[re]+b[T]+"$";var K=o++;b[K]="^"+b[s]+"\\s*("+n+")$|^$";var ae=o++;b[ae]="^"+b[s]+"\\s*("+l+")$|^$";var x=o++;b[x]="(\\s*)"+b[s]+"\\s*("+n+"|"+b[I]+")",_[x]=new RegExp(b[x],"g");var z=o++;b[z]="^\\s*("+b[I]+")\\s+-\\s+("+b[I]+")\\s*$";var ne=o++;b[ne]="^\\s*("+b[T]+")\\s+-\\s+("+b[T]+")\\s*$";var le=o++;b[le]="(<|>)?=?\\s*\\*";for(var ve=0;ve<35;ve++)w(ve,b[ve]),_[ve]||(_[ve]=new RegExp(b[ve]));function H(he,De){if(he instanceof ce)return he;if(typeof he!="string"||he.length>C||!(De?_[h]:_[t]).test(he))return null;try{return new ce(he,De)}catch{return null}}function ce(he,De){if(he instanceof ce){if(he.loose===De)return he;he=he.version}else if(typeof he!="string")throw new TypeError("Invalid Version: "+he);if(he.length>C)throw new TypeError("version is longer than "+C+" characters");if(!(this instanceof ce))return new ce(he,De);w("SemVer",he,De),this.loose=De;var Re=he.trim().match(De?_[h]:_[t]);if(!Re)throw new TypeError("Invalid Version: "+he);if(this.raw=he,this.major=+Re[1],this.minor=+Re[2],this.patch=+Re[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");Re[4]?this.prerelease=Re[4].split(".").map(function(xe){if(/^[0-9]+$/.test(xe)){var Ve=+xe;if(Ve>=0&&Ve<R)return Ve}return xe}):this.prerelease=[],this.build=Re[5]?Re[5].split("."):[],this.format()}e.parse=H,e.valid=function(he,De){var Re=H(he,De);return Re?Re.version:null},e.clean=function(he,De){var Re=H(he.trim().replace(/^[=v]+/,""),De);return Re?Re.version:null},e.SemVer=ce,ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ce.prototype.toString=function(){return this.version},ce.prototype.compare=function(he){return w("SemVer.compare",this.version,this.loose,he),he instanceof ce||(he=new ce(he,this.loose)),this.compareMain(he)||this.comparePre(he)},ce.prototype.compareMain=function(he){return he instanceof ce||(he=new ce(he,this.loose)),W(this.major,he.major)||W(this.minor,he.minor)||W(this.patch,he.patch)},ce.prototype.comparePre=function(he){if(he instanceof ce||(he=new ce(he,this.loose)),this.prerelease.length&&!he.prerelease.length)return-1;if(!this.prerelease.length&&he.prerelease.length)return 1;if(!this.prerelease.length&&!he.prerelease.length)return 0;var De=0;do{var Re=this.prerelease[De],xe=he.prerelease[De];if(w("prerelease compare",De,Re,xe),Re===void 0&&xe===void 0)return 0;if(xe===void 0)return 1;if(Re===void 0)return-1;if(Re!==xe)return W(Re,xe)}while(++De)},ce.prototype.inc=function(he,De){switch(he){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",De);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",De);break;case"prepatch":this.prerelease.length=0,this.inc("patch",De),this.inc("pre",De);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",De),this.inc("pre",De);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Re=this.prerelease.length;--Re>=0;)typeof this.prerelease[Re]=="number"&&(this.prerelease[Re]++,Re=-2);Re===-1&&this.prerelease.push(0)}De&&(this.prerelease[0]===De?isNaN(this.prerelease[1])&&(this.prerelease=[De,0]):this.prerelease=[De,0]);break;default:throw new Error("invalid increment argument: "+he)}return this.format(),this.raw=this.version,this},e.inc=function(he,De,Re,xe){typeof Re=="string"&&(xe=Re,Re=void 0);try{return new ce(he,Re).inc(De,xe).version}catch{return null}},e.diff=function(he,De){if(U(he,De))return null;var Re=H(he),xe=H(De);if(Re.prerelease.length||xe.prerelease.length){for(var Ve in Re)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&Re[Ve]!==xe[Ve])return"pre"+Ve;return"prerelease"}for(var Ve in Re)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&Re[Ve]!==xe[Ve])return Ve},e.compareIdentifiers=W;var J=/^[0-9]+$/;function W(he,De){var Re=J.test(he),xe=J.test(De);return Re&&xe&&(he=+he,De=+De),Re&&!xe?-1:xe&&!Re?1:he<De?-1:he>De?1:0}function L(he,De,Re){return new ce(he,Re).compare(new ce(De,Re))}function Q(he,De,Re){return L(he,De,Re)>0}function $(he,De,Re){return L(he,De,Re)<0}function U(he,De,Re){return L(he,De,Re)===0}function q(he,De,Re){return L(he,De,Re)!==0}function G(he,De,Re){return L(he,De,Re)>=0}function F(he,De,Re){return L(he,De,Re)<=0}function V(he,De,Re,xe){var Ve;switch(De){case"===":typeof he=="object"&&(he=he.version),typeof Re=="object"&&(Re=Re.version),Ve=he===Re;break;case"!==":typeof he=="object"&&(he=he.version),typeof Re=="object"&&(Re=Re.version),Ve=he!==Re;break;case"":case"=":case"==":Ve=U(he,Re,xe);break;case"!=":Ve=q(he,Re,xe);break;case">":Ve=Q(he,Re,xe);break;case">=":Ve=G(he,Re,xe);break;case"<":Ve=$(he,Re,xe);break;case"<=":Ve=F(he,Re,xe);break;default:throw new TypeError("Invalid operator: "+De)}return Ve}function oe(he,De){if(he instanceof oe){if(he.loose===De)return he;he=he.value}if(!(this instanceof oe))return new oe(he,De);w("comparator",he,De),this.loose=De,this.parse(he),this.semver===de?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}e.rcompareIdentifiers=function(he,De){return W(De,he)},e.major=function(he,De){return new ce(he,De).major},e.minor=function(he,De){return new ce(he,De).minor},e.patch=function(he,De){return new ce(he,De).patch},e.compare=L,e.compareLoose=function(he,De){return L(he,De,!0)},e.rcompare=function(he,De,Re){return L(De,he,Re)},e.sort=function(he,De){return he.sort(function(Re,xe){return e.compare(Re,xe,De)})},e.rsort=function(he,De){return he.sort(function(Re,xe){return e.rcompare(Re,xe,De)})},e.gt=Q,e.lt=$,e.eq=U,e.neq=q,e.gte=G,e.lte=F,e.cmp=V,e.Comparator=oe;var de={};function Ce(he,De){if(he instanceof Ce)return he.loose===De?he:new Ce(he.raw,De);if(he instanceof oe)return new Ce(he.value,De);if(!(this instanceof Ce))return new Ce(he,De);if(this.loose=De,this.raw=he,this.set=he.split(/\s*\|\|\s*/).map(function(Re){return this.parseRange(Re.trim())},this).filter(function(Re){return Re.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+he);this.format()}function Ne(he){return!he||he.toLowerCase()==="x"||he==="*"}function ge(he,De,Re,xe,Ve,Xe,je,qe,Je,st,lt,rt,it){return((De=Ne(Re)?"":Ne(xe)?">="+Re+".0.0":Ne(Ve)?">="+Re+"."+xe+".0":">="+De)+" "+(qe=Ne(Je)?"":Ne(st)?"<"+(+Je+1)+".0.0":Ne(lt)?"<"+Je+"."+(+st+1)+".0":rt?"<="+Je+"."+st+"."+lt+"-"+rt:"<="+qe)).trim()}function pe(he,De){for(var Re=0;Re<he.length;Re++)if(!he[Re].test(De))return!1;if(De.prerelease.length){for(Re=0;Re<he.length;Re++)if(w(he[Re].semver),he[Re].semver!==de&&he[Re].semver.prerelease.length>0){var xe=he[Re].semver;if(xe.major===De.major&&xe.minor===De.minor&&xe.patch===De.patch)return!0}return!1}return!0}function Te(he,De,Re){try{De=new Ce(De,Re)}catch{return!1}return De.test(he)}function Le(he,De,Re,xe){var Ve,Xe,je,qe,Je;switch(he=new ce(he,xe),De=new Ce(De,xe),Re){case">":Ve=Q,Xe=F,je=$,qe=">",Je=">=";break;case"<":Ve=$,Xe=G,je=Q,qe="<",Je="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Te(he,De,xe))return!1;for(var st=0;st<De.set.length;++st){var lt=De.set[st],rt=null,it=null;if(lt.forEach(function(tt){tt.semver===de&&(tt=new oe(">=0.0.0")),rt=rt||tt,it=it||tt,Ve(tt.semver,rt.semver,xe)?rt=tt:je(tt.semver,it.semver,xe)&&(it=tt)}),rt.operator===qe||rt.operator===Je||(!it.operator||it.operator===qe)&&Xe(he,it.semver)||it.operator===Je&&je(he,it.semver))return!1}return!0}oe.prototype.parse=function(he){var De=this.loose?_[K]:_[ae],Re=he.match(De);if(!Re)throw new TypeError("Invalid comparator: "+he);this.operator=Re[1],this.operator==="="&&(this.operator=""),Re[2]?this.semver=new ce(Re[2],this.loose):this.semver=de},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(he){return w("Comparator.test",he,this.loose),this.semver===de||(typeof he=="string"&&(he=new ce(he,this.loose)),V(he,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(he,De){if(!(he instanceof oe))throw new TypeError("a Comparator is required");var Re;if(this.operator==="")return Re=new Ce(he.value,De),Te(this.value,Re,De);if(he.operator==="")return Re=new Ce(this.value,De),Te(he.semver,Re,De);var xe=!(this.operator!==">="&&this.operator!==">"||he.operator!==">="&&he.operator!==">"),Ve=!(this.operator!=="<="&&this.operator!=="<"||he.operator!=="<="&&he.operator!=="<"),Xe=this.semver.version===he.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||he.operator!==">="&&he.operator!=="<="),qe=V(this.semver,"<",he.semver,De)&&(this.operator===">="||this.operator===">")&&(he.operator==="<="||he.operator==="<"),Je=V(this.semver,">",he.semver,De)&&(this.operator==="<="||this.operator==="<")&&(he.operator===">="||he.operator===">");return xe||Ve||Xe&&je||qe||Je},e.Range=Ce,Ce.prototype.format=function(){return this.range=this.set.map(function(he){return he.join(" ").trim()}).join("||").trim(),this.range},Ce.prototype.toString=function(){return this.range},Ce.prototype.parseRange=function(he){var De=this.loose;he=he.trim(),w("range",he,De);var Re=De?_[ne]:_[z];he=he.replace(Re,ge),w("hyphen replace",he),he=he.replace(_[x],"$1$2$3"),w("comparator trim",he,_[x]),he=(he=(he=he.replace(_[B],"$1~")).replace(_[te],"$1^")).split(/\s+/).join(" ");var xe=De?_[K]:_[ae],Ve=he.split(" ").map(function(Xe){return function(je,qe){return w("comp",je),je=function(Je,st){return Je.trim().split(/\s+/).map(function(lt){return function(rt,it){w("caret",rt,it);var tt=it?_[fe]:_[Z];return rt.replace(tt,function(et,Qe,Ee,Oe,Fe){var be;return w("caret",rt,et,Qe,Ee,Oe,Fe),Ne(Qe)?be="":Ne(Ee)?be=">="+Qe+".0.0 <"+(+Qe+1)+".0.0":Ne(Oe)?be=Qe==="0"?">="+Qe+"."+Ee+".0 <"+Qe+"."+(+Ee+1)+".0":">="+Qe+"."+Ee+".0 <"+(+Qe+1)+".0.0":Fe?(w("replaceCaret pr",Fe),Fe.charAt(0)!=="-"&&(Fe="-"+Fe),be=Qe==="0"?Ee==="0"?">="+Qe+"."+Ee+"."+Oe+Fe+" <"+Qe+"."+Ee+"."+(+Oe+1):">="+Qe+"."+Ee+"."+Oe+Fe+" <"+Qe+"."+(+Ee+1)+".0":">="+Qe+"."+Ee+"."+Oe+Fe+" <"+(+Qe+1)+".0.0"):(w("no pr"),be=Qe==="0"?Ee==="0"?">="+Qe+"."+Ee+"."+Oe+" <"+Qe+"."+Ee+"."+(+Oe+1):">="+Qe+"."+Ee+"."+Oe+" <"+Qe+"."+(+Ee+1)+".0":">="+Qe+"."+Ee+"."+Oe+" <"+(+Qe+1)+".0.0"),w("caret return",be),be})}(lt,st)}).join(" ")}(je,qe),w("caret",je),je=function(Je,st){return Je.trim().split(/\s+/).map(function(lt){return function(rt,it){var tt=it?_[X]:_[Y];return rt.replace(tt,function(et,Qe,Ee,Oe,Fe){var be;return w("tilde",rt,et,Qe,Ee,Oe,Fe),Ne(Qe)?be="":Ne(Ee)?be=">="+Qe+".0.0 <"+(+Qe+1)+".0.0":Ne(Oe)?be=">="+Qe+"."+Ee+".0 <"+Qe+"."+(+Ee+1)+".0":Fe?(w("replaceTilde pr",Fe),Fe.charAt(0)!=="-"&&(Fe="-"+Fe),be=">="+Qe+"."+Ee+"."+Oe+Fe+" <"+Qe+"."+(+Ee+1)+".0"):be=">="+Qe+"."+Ee+"."+Oe+" <"+Qe+"."+(+Ee+1)+".0",w("tilde return",be),be})}(lt,st)}).join(" ")}(je,qe),w("tildes",je),je=function(Je,st){return w("replaceXRanges",Je,st),Je.split(/\s+/).map(function(lt){return function(rt,it){rt=rt.trim();var tt=it?_[O]:_[A];return rt.replace(tt,function(et,Qe,Ee,Oe,Fe,be){w("xRange",rt,et,Qe,Ee,Oe,Fe,be);var Ae=Ne(Ee),ie=Ae||Ne(Oe),ee=ie||Ne(Fe);return Qe==="="&&ee&&(Qe=""),Ae?et=Qe===">"||Qe==="<"?"<0.0.0":"*":Qe&&ee?(ie&&(Oe=0),ee&&(Fe=0),Qe===">"?(Qe=">=",ie?(Ee=+Ee+1,Oe=0,Fe=0):ee&&(Oe=+Oe+1,Fe=0)):Qe==="<="&&(Qe="<",ie?Ee=+Ee+1:Oe=+Oe+1),et=Qe+Ee+"."+Oe+"."+Fe):ie?et=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ee&&(et=">="+Ee+"."+Oe+".0 <"+Ee+"."+(+Oe+1)+".0"),w("xRange return",et),et})}(lt,st)}).join(" ")}(je,qe),w("xrange",je),je=function(Je,st){return w("replaceStars",Je,st),Je.trim().replace(_[le],"")}(je,qe),w("stars",je),je}(Xe,De)}).join(" ").split(/\s+/);return this.loose&&(Ve=Ve.filter(function(Xe){return!!Xe.match(xe)})),Ve=Ve.map(function(Xe){return new oe(Xe,De)})},Ce.prototype.intersects=function(he,De){if(!(he instanceof Ce))throw new TypeError("a Range is required");return this.set.some(function(Re){return Re.every(function(xe){return he.set.some(function(Ve){return Ve.every(function(Xe){return xe.intersects(Xe,De)})})})})},e.toComparators=function(he,De){return new Ce(he,De).set.map(function(Re){return Re.map(function(xe){return xe.value}).join(" ").trim().split(" ")})},Ce.prototype.test=function(he){if(!he)return!1;typeof he=="string"&&(he=new ce(he,this.loose));for(var De=0;De<this.set.length;De++)if(pe(this.set[De],he))return!0;return!1},e.satisfies=Te,e.maxSatisfying=function(he,De,Re){var xe=null,Ve=null;try{var Xe=new Ce(De,Re)}catch{return null}return he.forEach(function(je){Xe.test(je)&&(xe&&Ve.compare(je)!==-1||(Ve=new ce(xe=je,Re)))}),xe},e.minSatisfying=function(he,De,Re){var xe=null,Ve=null;try{var Xe=new Ce(De,Re)}catch{return null}return he.forEach(function(je){Xe.test(je)&&(xe&&Ve.compare(je)!==1||(Ve=new ce(xe=je,Re)))}),xe},e.validRange=function(he,De){try{return new Ce(he,De).range||"*"}catch{return null}},e.ltr=function(he,De,Re){return Le(he,De,"<",Re)},e.gtr=function(he,De,Re){return Le(he,De,">",Re)},e.outside=Le,e.prerelease=function(he,De){var Re=H(he,De);return Re&&Re.prerelease.length?Re.prerelease:null},e.intersects=function(he,De,Re){return he=new Ce(he,Re),De=new Ce(De,Re),he.intersects(De)},e.coerce=function(he){if(he instanceof ce)return he;if(typeof he!="string")return null;var De=he.match(_[k]);return De==null?null:H((De[1]||"0")+"."+(De[2]||"0")+"."+(De[3]||"0"))}}).call(this,i(1))},function(se,e){var i,r,w=se.exports={};function C(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function _(m){if(i===setTimeout)return setTimeout(m,0);if((i===C||!i)&&setTimeout)return i=setTimeout,setTimeout(m,0);try{return i(m,0)}catch{try{return i.call(null,m,0)}catch{return i.call(this,m,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:C}catch{i=C}try{r=typeof clearTimeout=="function"?clearTimeout:R}catch{r=R}})();var b,o=[],D=!1,y=-1;function d(){D&&b&&(D=!1,b.length?o=b.concat(o):y=-1,o.length&&E())}function E(){if(!D){var m=_(d);D=!0;for(var p=o.length;p;){for(b=o,o=[];++y<p;)b&&b[y].run();y=-1,p=o.length}b=null,D=!1,function(S){if(r===clearTimeout)return clearTimeout(S);if((r===R||!r)&&clearTimeout)return r=clearTimeout,clearTimeout(S);try{r(S)}catch{try{return r.call(null,S)}catch{return r.call(this,S)}}}(m)}}function a(m,p){this.fun=m,this.array=p}function f(){}w.nextTick=function(m){var p=new Array(arguments.length-1);if(arguments.length>1)for(var S=1;S<arguments.length;S++)p[S-1]=arguments[S];o.push(new a(m,p)),o.length!==1||D||_(E)},a.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=f,w.addListener=f,w.once=f,w.off=f,w.removeListener=f,w.removeAllListeners=f,w.emit=f,w.prependListener=f,w.prependOnceListener=f,w.listeners=function(m){return[]},w.binding=function(m){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(m){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(ye[168],Ie([1,0]),function(se,e){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class r{constructor(_,b,o){this.level=_,this.key=b,this.value=o,this.forward=[]}}const w=void 0;class C{constructor(_,b=2**16){this.comparator=_,this[i]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(b)|0),this._header=new r(this._maxLevel,w,w)}get size(){return this._size}clear(){this._header=new r(this._maxLevel,w,w),this._size=0}has(_){return!!C._search(this,_,this.comparator)}get(_){return C._search(this,_,this.comparator)?.value}set(_,b){return C._insert(this,_,b,this.comparator)&&(this._size+=1),this}delete(_){const b=C._delete(this,_,this.comparator);return b&&(this._size-=1),b}forEach(_,b){let o=this._header.forward[0];for(;o;)_.call(b,o.value,o.key,this),o=o.forward[0]}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let _=this._header.forward[0];for(;_;)yield[_.key,_.value],_=_.forward[0]}*keys(){let _=this._header.forward[0];for(;_;)yield _.key,_=_.forward[0]}*values(){let _=this._header.forward[0];for(;_;)yield _.value,_=_.forward[0]}toString(){let _="[SkipList]:",b=this._header.forward[0];for(;b;)_+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return _}static _search(_,b,o){let D=_._header;for(let y=_._level-1;y>=0;y--)for(;D.forward[y]&&o(D.forward[y].key,b)<0;)D=D.forward[y];if(D=D.forward[0],D&&o(D.key,b)===0)return D}static _insert(_,b,o,D){const y=[];let d=_._header;for(let E=_._level-1;E>=0;E--){for(;d.forward[E]&&D(d.forward[E].key,b)<0;)d=d.forward[E];y[E]=d}if(d=d.forward[0],d&&D(d.key,b)===0)return d.value=o,!1;{const E=C._randomLevel(_);if(E>_._level){for(let a=_._level;a<E;a++)y[a]=_._header;_._level=E}d=new r(E,b,o);for(let a=0;a<E;a++)d.forward[a]=y[a].forward[a],y[a].forward[a]=d;return!0}}static _randomLevel(_,b=.5){let o=1;for(;Math.random()<b&&o<_._maxLevel;)o+=1;return o}static _delete(_,b,o){const D=[];let y=_._header;for(let d=_._level-1;d>=0;d--){for(;y.forward[d]&&o(y.forward[d].key,b)<0;)y=y.forward[d];D[d]=y}if(y=y.forward[0],!y||o(y.key,b)!==0)return!1;for(let d=0;d<_._level&&D[d].forward[d]===y;d++)D[d].forward[d]=y.forward[d];for(;_._level>0&&_._header.forward[_._level-1]===w;)_._level-=1;return!0}}e.SkipList=C}),define(ye[48],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class r{static create(C){return new r(C)}constructor(C){this._now=i&&C===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=r}),define(ye[6],Ie([1,0,10,79,2,80,48]),function(se,e,i,r,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.ListenerRefusalError=e.ListenerLeakError=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=E;const _=!1,b=!1,o=!1;var D;(function(X){X.None=()=>w.Disposable.None;function re(ge){if(o){const{onDidAddListener:pe}=ge,Te=f.create();let Le=0;ge.onDidAddListener=()=>{++Le===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Te.print()),pe?.()}}}function te(ge,pe){return H(ge,()=>{},0,void 0,!0,void 0,pe)}X.defer=te;function Z(ge){return(pe,Te=null,Le)=>{let he=!1,De;return De=ge(Re=>{if(!he)return De?De.dispose():he=!0,pe.call(Te,Re)},null,Le),he&&De.dispose(),De}}X.once=Z;function fe(ge,pe,Te){return le((Le,he=null,De)=>ge(Re=>Le.call(he,pe(Re)),null,De),Te)}X.map=fe;function K(ge,pe,Te){return le((Le,he=null,De)=>ge(Re=>{pe(Re),Le.call(he,Re)},null,De),Te)}X.forEach=K;function ae(ge,pe,Te){return le((Le,he=null,De)=>ge(Re=>pe(Re)&&Le.call(he,Re),null,De),Te)}X.filter=ae;function x(ge){return ge}X.signal=x;function z(...ge){return(pe,Te=null,Le)=>{const he=(0,w.combinedDisposable)(...ge.map(De=>De(Re=>pe.call(Te,Re))));return ve(he,Le)}}X.any=z;function ne(ge,pe,Te,Le){let he=Te;return fe(ge,De=>(he=pe(he,De),he),Le)}X.reduce=ne;function le(ge,pe){let Te;const Le={onWillAddFirstListener(){Te=ge(he.fire,he)},onDidRemoveLastListener(){Te?.dispose()}};pe||re(Le);const he=new n(Le);return pe?.add(he),he.event}function ve(ge,pe){return pe instanceof Array?pe.push(ge):pe&&pe.add(ge),ge}function H(ge,pe,Te=100,Le=!1,he=!1,De,Re){let xe,Ve,Xe,je=0,qe;const Je={leakWarningThreshold:De,onWillAddFirstListener(){xe=ge(lt=>{je++,Ve=pe(Ve,lt),Le&&!Xe&&(st.fire(Ve),Ve=void 0),qe=()=>{const rt=Ve;Ve=void 0,Xe=void 0,(!Le||je>1)&&st.fire(rt),je=0},typeof Te=="number"?(clearTimeout(Xe),Xe=setTimeout(qe,Te)):Xe===void 0&&(Xe=0,queueMicrotask(qe))})},onWillRemoveListener(){he&&je>0&&qe?.()},onDidRemoveLastListener(){qe=void 0,xe.dispose()}};Re||re(Je);const st=new n(Je);return Re?.add(st),st.event}X.debounce=H;function ce(ge,pe=0,Te){return X.debounce(ge,(Le,he)=>Le?(Le.push(he),Le):[he],pe,void 0,!0,void 0,Te)}X.accumulate=ce;function J(ge,pe=(Le,he)=>Le===he,Te){let Le=!0,he;return ae(ge,De=>{const Re=Le||!pe(De,he);return Le=!1,he=De,Re},Te)}X.latch=J;function W(ge,pe,Te){return[X.filter(ge,pe,Te),X.filter(ge,Le=>!pe(Le),Te)]}X.split=W;function L(ge,pe=!1,Te=[],Le){let he=Te.slice(),De=ge(Ve=>{he?he.push(Ve):xe.fire(Ve)});Le&&Le.add(De);const Re=()=>{he?.forEach(Ve=>xe.fire(Ve)),he=null},xe=new n({onWillAddFirstListener(){De||(De=ge(Ve=>xe.fire(Ve)),Le&&Le.add(De))},onDidAddFirstListener(){he&&(pe?setTimeout(Re):Re())},onDidRemoveLastListener(){De&&De.dispose(),De=null}});return Le&&Le.add(xe),xe.event}X.buffer=L;function Q(ge,pe){return(Le,he,De)=>{const Re=pe(new U);return ge(function(xe){const Ve=Re.evaluate(xe);Ve!==$&&Le.call(he,Ve)},void 0,De)}}X.chain=Q;const $=Symbol("HaltChainable");class U{constructor(){this.steps=[]}map(pe){return this.steps.push(pe),this}forEach(pe){return this.steps.push(Te=>(pe(Te),Te)),this}filter(pe){return this.steps.push(Te=>pe(Te)?Te:$),this}reduce(pe,Te){let Le=Te;return this.steps.push(he=>(Le=pe(Le,he),Le)),this}latch(pe=(Te,Le)=>Te===Le){let Te=!0,Le;return this.steps.push(he=>{const De=Te||!pe(he,Le);return Te=!1,Le=he,De?he:$}),this}evaluate(pe){for(const Te of this.steps)if(pe=Te(pe),pe===$)break;return pe}}function q(ge,pe,Te=Le=>Le){const Le=(...xe)=>Re.fire(Te(...xe)),he=()=>ge.on(pe,Le),De=()=>ge.removeListener(pe,Le),Re=new n({onWillAddFirstListener:he,onDidRemoveLastListener:De});return Re.event}X.fromNodeEventEmitter=q;function G(ge,pe,Te=Le=>Le){const Le=(...xe)=>Re.fire(Te(...xe)),he=()=>ge.addEventListener(pe,Le),De=()=>ge.removeEventListener(pe,Le),Re=new n({onWillAddFirstListener:he,onDidRemoveLastListener:De});return Re.event}X.fromDOMEventEmitter=G;function F(ge){return new Promise(pe=>Z(ge)(pe))}X.toPromise=F;function V(ge){const pe=new n;return ge.then(Te=>{pe.fire(Te)},()=>{pe.fire(void 0)}).finally(()=>{pe.dispose()}),pe.event}X.fromPromise=V;function oe(ge,pe,Te){return pe(Te),ge(Le=>pe(Le))}X.runAndSubscribe=oe;class de{constructor(pe,Te){this._observable=pe,this._counter=0,this._hasChanged=!1;const Le={onWillAddFirstListener:()=>{pe.addObserver(this)},onDidRemoveLastListener:()=>{pe.removeObserver(this)}};Te||re(Le),this.emitter=new n(Le),Te&&Te.add(this.emitter)}beginUpdate(pe){this._counter++}handlePossibleChange(pe){}handleChange(pe,Te){this._hasChanged=!0}endUpdate(pe){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function Ce(ge,pe){return new de(ge,pe).emitter.event}X.fromObservable=Ce;function Ne(ge){return(pe,Te,Le)=>{let he=0,De=!1;const Re={beginUpdate(){he++},endUpdate(){he--,he===0&&(ge.reportChanges(),De&&(De=!1,pe.call(Te)))},handlePossibleChange(){},handleChange(){De=!0}};ge.addObserver(Re),ge.reportChanges();const xe={dispose(){ge.removeObserver(Re)}};return Le instanceof w.DisposableStore?Le.add(xe):Array.isArray(Le)&&Le.push(xe),xe}}X.fromObservableLight=Ne})(D||(e.Event=D={}));class y{static{this.all=new Set}static{this._idPool=0}constructor(re){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${re}_${y._idPool++}`,y.all.add(this)}start(re){this._stopWatch=new R.StopWatch,this.listenerCount=re}stop(){if(this._stopWatch){const re=this._stopWatch.elapsed();this.durations.push(re),this.elapsedOverall+=re,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=y;let d=-1;function E(X){const re=d;return d=X,{dispose(){d=re}}}class a{static{this._idPool=1}constructor(re,te,Z=(a._idPool++).toString(16).padStart(3,"0")){this._errorHandler=re,this.threshold=te,this.name=Z,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(re,te){const Z=this.threshold;if(Z<=0||te<Z)return;this._stacks||(this._stacks=new Map);const fe=this._stacks.get(re.value)||0;if(this._stacks.set(re.value,fe+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=Z*.5;const[K,ae]=this.getMostFrequentStack(),x=`[${this.name}] potential listener LEAK detected, having ${te} listeners already. MOST frequent listener (${ae}):`;console.warn(x),console.warn(K);const z=new m(x,K);this._errorHandler(z)}return()=>{const K=this._stacks.get(re.value)||0;this._stacks.set(re.value,K-1)}}getMostFrequentStack(){if(!this._stacks)return;let re,te=0;for(const[Z,fe]of this._stacks)(!re||te<fe)&&(re=[Z,fe],te=fe);return re}}class f{static create(){const re=new Error;return new f(re.stack??"")}constructor(re){this.value=re}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m extends Error{constructor(re,te){super(re),this.name="ListenerLeakError",this.stack=te}}e.ListenerLeakError=m;class p extends Error{constructor(re,te){super(re),this.name="ListenerRefusalError",this.stack=te}}e.ListenerRefusalError=p;let S=0;class g{constructor(re){this.value=re,this.id=S++}}const v=2,t=(X,re)=>{if(X instanceof g)re(X);else for(let te=0;te<X.length;te++){const Z=X[te];Z&&re(Z)}};let l;if(_){const X=[];setInterval(()=>{X.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(X.join(`
`)),X.length=0)},3e3),l=new FinalizationRegistry(re=>{typeof re=="string"&&X.push(re)})}class n{constructor(re){this._size=0,this._options=re,this._leakageMon=d>0||this._options?.leakWarningThreshold?new a(re?.onListenerError??i.onUnexpectedError,this._options?.leakWarningThreshold??d):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(b){const re=this._listeners;queueMicrotask(()=>{t(re,te=>te.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(re,te,Z)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold**2){const z=`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this._size} vs ${this._leakageMon.threshold})`;console.warn(z);const ne=this._leakageMon.getMostFrequentStack()??["UNKNOWN stack",-1],le=new p(`${z}. HINT: Stack shows most frequent listener (${ne[1]}-times)`,ne[0]);return(this._options?.onListenerError||i.onUnexpectedError)(le),w.Disposable.None}if(this._disposed)return w.Disposable.None;te&&(re=re.bind(te));const fe=new g(re);let K,ae;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(fe.stack=f.create(),K=this._leakageMon.check(fe.stack,this._size+1)),b&&(fe.stack=ae??f.create()),this._listeners?this._listeners instanceof g?(this._deliveryQueue??=new s,this._listeners=[this._listeners,fe]):this._listeners.push(fe):(this._options?.onWillAddFirstListener?.(this),this._listeners=fe,this._options?.onDidAddFirstListener?.(this)),this._size++;const x=(0,w.toDisposable)(()=>{l?.unregister(x),K?.(),this._removeListener(fe)});if(Z instanceof w.DisposableStore?Z.add(x):Array.isArray(Z)&&Z.push(x),l){const z=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),ne=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(z);l.register(x,ne?.[2]??z,x)}return x},this._event}_removeListener(re){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const te=this._listeners,Z=te.indexOf(re);if(Z===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,te[Z]=void 0;const fe=this._deliveryQueue.current===this;if(this._size*v<=te.length){let K=0;for(let ae=0;ae<te.length;ae++)te[ae]?te[K++]=te[ae]:fe&&(this._deliveryQueue.end--,K<this._deliveryQueue.i&&this._deliveryQueue.i--);te.length=K}}_deliver(re,te){if(!re)return;const Z=this._options?.onListenerError||i.onUnexpectedError;if(!Z){re.value(te);return}try{re.value(te)}catch(fe){Z(fe)}}_deliverQueue(re){const te=re.current._listeners;for(;re.i<re.end;)this._deliver(te[re.i++],re.value);re.reset()}fire(re){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof g)this._deliver(this._listeners,re);else{const te=this._deliveryQueue;te.enqueue(this,re,this._listeners.length),this._deliverQueue(te)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=n;const h=()=>new s;e.createEventDeliveryQueue=h;class s{constructor(){this.i=-1,this.end=0}enqueue(re,te,Z){this.i=0,this.end=Z,this.current=re,this.value=te}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class c extends n{async fireAsync(re,te,Z){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList),t(this._listeners,fe=>this._asyncDeliveryQueue.push([fe.value,re]));this._asyncDeliveryQueue.size>0&&!te.isCancellationRequested;){const[fe,K]=this._asyncDeliveryQueue.shift(),ae=[],x={...K,token:te,waitUntil:z=>{if(Object.isFrozen(ae))throw new Error("waitUntil can NOT be called asynchronous");Z&&(z=Z(z,fe)),ae.push(z)}};try{fe(x)}catch(z){(0,i.onUnexpectedError)(z);continue}Object.freeze(ae),await Promise.allSettled(ae).then(z=>{for(const ne of z)ne.status==="rejected"&&(0,i.onUnexpectedError)(ne.reason)})}}}e.AsyncEmitter=c;class u extends n{get isPaused(){return this._isPaused!==0}constructor(re){super(re),this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=re?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const re=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(re))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(re){this._size&&(this._isPaused!==0?this._eventQueue.push(re):super.fire(re))}}e.PauseableEmitter=u;class I extends u{constructor(re){super(re),this._delay=re.delay??100}fire(re){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(re)}}e.DebounceEmitter=I;class T extends n{constructor(re){super(re),this._queuedEvents=[],this._mergeFn=re?.merge}fire(re){this.hasListeners()&&(this._queuedEvents.push(re),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(te=>super.fire(te)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=T;class A{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new n({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(re){const te={event:re,listener:null};this.events.push(te),this.hasListeners&&this.hook(te);const Z=()=>{this.hasListeners&&this.unhook(te);const fe=this.events.indexOf(te);this.events.splice(fe,1)};return(0,w.toDisposable)((0,r.createSingleCallFunction)(Z))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(re=>this.hook(re))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(re=>this.unhook(re))}hook(re){re.listener=re.event(te=>this.emitter.fire(te))}unhook(re){re.listener?.dispose(),re.listener=null}dispose(){this.emitter.dispose();for(const re of this.events)re.listener?.dispose();this.events=[]}}e.EventMultiplexer=A;class O{constructor(re,te,Z,fe){this._store=new w.DisposableStore;const K=this._store.add(new A),ae=this._store.add(new w.DisposableMap);function x(z){ae.set(z,K.add(fe(z)))}for(const z of re)x(z);this._store.add(te(z=>{x(z)})),this._store.add(Z(z=>{ae.deleteAndDispose(z)})),this.event=K.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=O;class k{constructor(){this.data=[]}wrapEvent(re,te,Z){return(fe,K,ae)=>re(x=>{const z=this.data[this.data.length-1];if(!te){z?z.buffers.push(()=>fe.call(K,x)):fe.call(K,x);return}const ne=z;if(!ne){fe.call(K,te(Z,x));return}ne.items??=[],ne.items.push(x),ne.buffers.length===0&&z.buffers.push(()=>{ne.reducedResult??=Z?ne.items.reduce(te,Z):ne.items.reduce(te),fe.call(K,ne.reducedResult)})},void 0,ae)}bufferEvents(re){const te={buffers:new Array};this.data.push(te);const Z=re();return this.data.pop(),te.buffers.forEach(fe=>fe()),Z}}e.EventBufferer=k;class P{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=w.Disposable.None,this.emitter=new n({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(re){this.inputEvent=re,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=re(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=P;class B{static const(re){return new Y(re)}constructor(re){this._value=re,this._onDidChange=new n,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(re){re!==this._value&&(this._value=re,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=B;class Y{constructor(re){this.value=re,this.onDidChange=D.None}}}),define(ye[19],Ie([1,0,6]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=_;const r=Object.freeze(function(b,o){const D=setTimeout(b.bind(o),0);return{dispose(){clearTimeout(D)}}});var w;(function(b){function o(D){return D===b.None||D===b.Cancelled||D instanceof C?!0:!D||typeof D!="object"?!1:typeof D.isCancellationRequested=="boolean"&&typeof D.onCancellationRequested=="function"}b.isCancellationToken=o,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(w||(e.CancellationToken=w={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?r:(this._emitter||(this._emitter=new i.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class R{constructor(o){this._token=void 0,this._parentListener=void 0,this._parentListener=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=w.Cancelled}dispose(o=!1){o&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=w.None}}e.CancellationTokenSource=R;function _(b){const o=new R;return b.add({dispose(){o.cancel()}}),o.token}}),define(ye[169],Ie([1,0,19]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=w;class r{constructor(b){this.task=b,this.result=null}get(){if(this.result)return this.result;const b=new i.CancellationTokenSource,o=this.task(b.token);return this.result={promise:o,dispose:()=>{this.result=null,b.cancel(),b.dispose()}},this.result}}e.Cache=r;function w(_){return _}class C{constructor(b,o){this.lastCache=void 0,this.lastArgKey=void 0,typeof b=="function"?(this._fn=b,this._computeKey=w):(this._fn=o,this._computeKey=b.getCacheKey)}get(b){const o=this._computeKey(b);return this.lastArgKey!==o&&(this.lastArgKey=o,this.lastCache=this._fn(b)),this.lastCache}}e.LRUCachedFunction=C;class R{get cachedValues(){return this._map}constructor(b,o){this._map=new Map,this._map2=new Map,typeof b=="function"?(this._fn=b,this._computeKey=w):(this._fn=o,this._computeKey=b.getCacheKey)}get(b){const o=this._computeKey(b);if(this._map2.has(o))return this._map2.get(o);const D=this._fn(b);return this._map.set(b,D),this._map2.set(o,D),D}}e.CachedFunction=R}),define(ye[170],Ie([1,0,6,2]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SmoothScrollingOperation=e.SmoothScrollingUpdate=e.Scrollable=e.ScrollState=e.ScrollbarVisibility=void 0;var w;(function(E){E[E.Auto=1]="Auto",E[E.Hidden=2]="Hidden",E[E.Visible=3]="Visible"})(w||(e.ScrollbarVisibility=w={}));class C{constructor(a,f,m,p,S,g,v){this._forceIntegerValues=a,this._scrollStateBrand=void 0,this._forceIntegerValues&&(f=f|0,m=m|0,p=p|0,S=S|0,g=g|0,v=v|0),this.rawScrollLeft=p,this.rawScrollTop=v,f<0&&(f=0),p+f>m&&(p=m-f),p<0&&(p=0),S<0&&(S=0),v+S>g&&(v=g-S),v<0&&(v=0),this.width=f,this.scrollWidth=m,this.scrollLeft=p,this.height=S,this.scrollHeight=g,this.scrollTop=v}equals(a){return this.rawScrollLeft===a.rawScrollLeft&&this.rawScrollTop===a.rawScrollTop&&this.width===a.width&&this.scrollWidth===a.scrollWidth&&this.scrollLeft===a.scrollLeft&&this.height===a.height&&this.scrollHeight===a.scrollHeight&&this.scrollTop===a.scrollTop}withScrollDimensions(a,f){return new C(this._forceIntegerValues,typeof a.width<"u"?a.width:this.width,typeof a.scrollWidth<"u"?a.scrollWidth:this.scrollWidth,f?this.rawScrollLeft:this.scrollLeft,typeof a.height<"u"?a.height:this.height,typeof a.scrollHeight<"u"?a.scrollHeight:this.scrollHeight,f?this.rawScrollTop:this.scrollTop)}withScrollPosition(a){return new C(this._forceIntegerValues,this.width,this.scrollWidth,typeof a.scrollLeft<"u"?a.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof a.scrollTop<"u"?a.scrollTop:this.rawScrollTop)}createScrollEvent(a,f){const m=this.width!==a.width,p=this.scrollWidth!==a.scrollWidth,S=this.scrollLeft!==a.scrollLeft,g=this.height!==a.height,v=this.scrollHeight!==a.scrollHeight,t=this.scrollTop!==a.scrollTop;return{inSmoothScrolling:f,oldWidth:a.width,oldScrollWidth:a.scrollWidth,oldScrollLeft:a.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:a.height,oldScrollHeight:a.scrollHeight,oldScrollTop:a.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:m,scrollWidthChanged:p,scrollLeftChanged:S,heightChanged:g,scrollHeightChanged:v,scrollTopChanged:t}}}e.ScrollState=C;class R extends r.Disposable{constructor(a){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new i.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=a.smoothScrollDuration,this._scheduleAtNextAnimationFrame=a.scheduleAtNextAnimationFrame,this._state=new C(a.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(a){this._smoothScrollDuration=a}validateScrollPosition(a){return this._state.withScrollPosition(a)}getScrollDimensions(){return this._state}setScrollDimensions(a,f){const m=this._state.withScrollDimensions(a,f);this._setState(m,!!this._smoothScrolling),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(a){const f=this._state.withScrollPosition(a);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(f,!1)}setScrollPositionSmooth(a,f){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(a);if(this._smoothScrolling){a={scrollLeft:typeof a.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:a.scrollLeft,scrollTop:typeof a.scrollTop>"u"?this._smoothScrolling.to.scrollTop:a.scrollTop};const m=this._state.withScrollPosition(a);if(this._smoothScrolling.to.scrollLeft===m.scrollLeft&&this._smoothScrolling.to.scrollTop===m.scrollTop)return;let p;f?p=new D(this._smoothScrolling.from,m,this._smoothScrolling.startTime,this._smoothScrolling.duration):p=this._smoothScrolling.combine(this._state,m,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=p}else{const m=this._state.withScrollPosition(a);this._smoothScrolling=D.start(this._state,m,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}hasPendingScrollAnimation(){return!!this._smoothScrolling}_performSmoothScrolling(){if(!this._smoothScrolling)return;const a=this._smoothScrolling.tick(),f=this._state.withScrollPosition(a);if(this._setState(f,!0),!!this._smoothScrolling){if(a.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(a,f){const m=this._state;m.equals(a)||(this._state=a,this._onScroll.fire(this._state.createScrollEvent(m,f)))}}e.Scrollable=R;class _{constructor(a,f,m){this.scrollLeft=a,this.scrollTop=f,this.isDone=m}}e.SmoothScrollingUpdate=_;function b(E,a){const f=a-E;return function(m){return E+f*d(m)}}function o(E,a,f){return function(m){return m<f?E(m/f):a((m-f)/(1-f))}}class D{constructor(a,f,m,p){this.from=a,this.to=f,this.duration=p,this.startTime=m,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(a,f,m){if(Math.abs(a-f)>2.5*m){let S,g;return a<f?(S=a+.75*m,g=f-.75*m):(S=a-.75*m,g=f+.75*m),o(b(a,S),b(g,f),.33)}return b(a,f)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(a){this.to=a.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(a){const f=(a-this.startTime)/this.duration;if(f<1){const m=this.scrollLeft(f),p=this.scrollTop(f);return new _(m,p,!1)}return new _(this.to.scrollLeft,this.to.scrollTop,!0)}combine(a,f,m){return D.start(a,f,m)}static start(a,f,m){m=m+10;const p=Date.now()-10;return new D(a,f,p,m)}}e.SmoothScrollingOperation=D;function y(E){return Math.pow(E,3)}function d(E){return 1-y(1-E)}}),define(ye[56],Ie([1,0,10,2]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=w,e.isReadableStream=C,e.isReadableBufferedStream=R,e.newWriteableStream=_,e.consumeReadable=o,e.peekReadable=D,e.consumeStream=y,e.listenStream=d,e.peekStream=E,e.toStream=a,e.emptyStream=f,e.toReadable=m,e.transform=p,e.prefixedReadable=S,e.prefixedStream=g;function w(v){const t=v;return t?typeof t.read=="function":!1}function C(v){const t=v;return t?[t.on,t.pause,t.resume,t.destroy].every(l=>typeof l=="function"):!1}function R(v){const t=v;return t?C(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function _(v,t){return new b(v,t)}class b{constructor(t,l){this.reducer=t,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(t){if(!this.state.destroyed){if(this.state.flowing)this.emitData(t);else if(this.buffer.data.push(t),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(t){this.state.destroyed||(this.state.flowing?this.emitError(t):this.buffer.error.push(t))}end(t){this.state.destroyed||(typeof t<"u"&&this.write(t),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(t){this.listeners.data.slice(0).forEach(l=>l(t))}emitError(t){this.listeners.error.length===0?(0,i.onUnexpectedError)(t):this.listeners.error.slice(0).forEach(l=>l(t))}emitEnd(){this.listeners.end.slice(0).forEach(t=>t())}on(t,l){if(!this.state.destroyed)switch(t){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(t,l){if(this.state.destroyed)return;let n;switch(t){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const h=n.indexOf(l);h>=0&&n.splice(h,1)}}flowData(){if(this.buffer.data.length>0){const t=this.reducer(this.buffer.data);this.emitData(t),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const t of this.buffer.error)this.emitError(t);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function o(v,t){const l=[];let n;for(;(n=v.read())!==null;)l.push(n);return t(l)}function D(v,t,l){const n=[];let h;for(;(h=v.read())!==null&&n.length<l;)n.push(h);return h===null&&n.length>0?t(n):{read:()=>{if(n.length>0)return n.shift();if(typeof h<"u"){const s=h;return h=void 0,s}return v.read()}}}function y(v,t){return new Promise((l,n)=>{const h=[];d(v,{onData:s=>{t&&h.push(s)},onError:s=>{t?n(s):l(void 0)},onEnd:()=>{l(t?t(h):void 0)}})})}function d(v,t,l){v.on("error",n=>{l?.isCancellationRequested||t.onError(n)}),v.on("end",()=>{l?.isCancellationRequested||t.onEnd()}),v.on("data",n=>{l?.isCancellationRequested||t.onData(n)})}function E(v,t){return new Promise((l,n)=>{const h=new r.DisposableStore,s=[],c=T=>{if(s.push(T),s.length>t)return h.dispose(),v.pause(),l({stream:v,buffer:s,ended:!1})},u=T=>(h.dispose(),n(T)),I=()=>(h.dispose(),l({stream:v,buffer:s,ended:!0}));h.add((0,r.toDisposable)(()=>v.removeListener("error",u))),v.on("error",u),h.add((0,r.toDisposable)(()=>v.removeListener("end",I))),v.on("end",I),h.add((0,r.toDisposable)(()=>v.removeListener("data",c))),v.on("data",c)})}function a(v,t){const l=_(t);return l.end(v),l}function f(){const v=_(()=>{throw new Error("not supported")});return v.end(),v}function m(v){let t=!1;return{read:()=>t?null:(t=!0,v)}}function p(v,t,l){const n=_(l);return d(v,{onData:h=>n.write(t.data(h)),onError:h=>n.error(t.error?t.error(h):h),onEnd:()=>n.end()}),n}function S(v,t,l){let n=!1;return{read:()=>{const h=t.read();return n?h:(n=!0,h!==null?l([v,h]):v)}}}function g(v,t,l){let n=!1;const h=_(l);return d(t,{onData:s=>n?h.write(s):(n=!0,h.write(l([v,s]))),onError:s=>h.error(s),onEnd:()=>{n||(n=!0,h.write(v)),h.end()}}),h}}),define(ye[15],Ie([1,0,65,56]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=o,e.readUInt16LE=D,e.writeUInt16LE=y,e.readUInt32BE=d,e.writeUInt32BE=E,e.readUInt32LE=a,e.writeUInt32LE=f,e.readUInt8=m,e.writeUInt8=p,e.readableToBuffer=S,e.bufferToReadable=g,e.streamToBuffer=v,e.bufferedStreamToBuffer=t,e.bufferToStream=l,e.streamToBufferReadableStream=n,e.newWriteableBufferStream=h,e.prefixedBufferReadable=s,e.prefixedBufferStream=c,e.decodeBase64=u,e.encodeBase64=A,r=Be(r);const w=typeof Buffer<"u",C=new i.Lazy(()=>new Uint8Array(256));let R,_;class b{static alloc(k){return w?new b(Buffer.allocUnsafe(k)):new b(new Uint8Array(k))}static wrap(k){return w&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new b(k)}static fromString(k,P){return!(P?.dontUseNodeBuffer||!1)&&w?new b(Buffer.from(k)):(R||(R=new TextEncoder),new b(R.encode(k)))}static fromByteArray(k){const P=b.alloc(k.length);for(let B=0,Y=k.length;B<Y;B++)P.buffer[B]=k[B];return P}static concat(k,P){if(typeof P>"u"){P=0;for(let X=0,re=k.length;X<re;X++)P+=k[X].byteLength}const B=b.alloc(P);let Y=0;for(let X=0,re=k.length;X<re;X++){const te=k[X];B.set(te,Y),Y+=te.byteLength}return B}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=b.alloc(this.byteLength);return k.set(this),k}toString(){return w?this.buffer.toString():(_||(_=new TextDecoder),_.decode(this.buffer))}slice(k,P){return new b(this.buffer.subarray(k,P))}set(k,P){if(k instanceof b)this.buffer.set(k.buffer,P);else if(k instanceof Uint8Array)this.buffer.set(k,P);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),P);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return d(this.buffer,k)}writeUInt32BE(k,P){E(this.buffer,k,P)}readUInt32LE(k){return a(this.buffer,k)}writeUInt32LE(k,P){f(this.buffer,k,P)}readUInt8(k){return m(this.buffer,k)}writeUInt8(k,P){p(this.buffer,k,P)}indexOf(k,P=0){return o(this.buffer,k instanceof b?k.buffer:k,P)}}e.VSBuffer=b;function o(O,k,P=0){const B=k.byteLength,Y=O.byteLength;if(B===0)return 0;if(B===1)return O.indexOf(k[0]);if(B>Y-P)return-1;const X=C.value;X.fill(k.length);for(let fe=0;fe<k.length;fe++)X[k[fe]]=k.length-fe-1;let re=P+k.length-1,te=re,Z=-1;for(;re<Y;)if(O[re]===k[te]){if(te===0){Z=re;break}re--,te--}else re+=Math.max(k.length-te,X[O[re]]),te=k.length-1;return Z}function D(O,k){return O[k+0]<<0>>>0|O[k+1]<<8>>>0}function y(O,k,P){O[P+0]=k&255,k=k>>>8,O[P+1]=k&255}function d(O,k){return O[k]*2**24+O[k+1]*2**16+O[k+2]*2**8+O[k+3]}function E(O,k,P){O[P+3]=k,k=k>>>8,O[P+2]=k,k=k>>>8,O[P+1]=k,k=k>>>8,O[P]=k}function a(O,k){return O[k+0]<<0>>>0|O[k+1]<<8>>>0|O[k+2]<<16>>>0|O[k+3]<<24>>>0}function f(O,k,P){O[P+0]=k&255,k=k>>>8,O[P+1]=k&255,k=k>>>8,O[P+2]=k&255,k=k>>>8,O[P+3]=k&255}function m(O,k){return O[k]}function p(O,k,P){O[P]=k}function S(O){return r.consumeReadable(O,k=>b.concat(k))}function g(O){return r.toReadable(O)}function v(O){return r.consumeStream(O,k=>b.concat(k))}async function t(O){return O.ended?b.concat(O.buffer):b.concat([...O.buffer,await v(O.stream)])}function l(O){return r.toStream(O,k=>b.concat(k))}function n(O){return r.transform(O,{data:k=>typeof k=="string"?b.fromString(k):b.wrap(k)},k=>b.concat(k))}function h(O){return r.newWriteableStream(k=>b.concat(k),O)}function s(O,k){return r.prefixedReadable(O,k,P=>b.concat(P))}function c(O,k){return r.prefixedStream(O,k,P=>b.concat(P))}function u(O){let k=0,P=0,B=0;const Y=new Uint8Array(Math.floor(O.length/4*3)),X=te=>{switch(P){case 3:Y[B++]=k|te,P=0;break;case 2:Y[B++]=k|te>>>2,k=te<<6,P=3;break;case 1:Y[B++]=k|te>>>4,k=te<<4,P=2;break;default:k=te<<2,P=1}};for(let te=0;te<O.length;te++){const Z=O.charCodeAt(te);if(Z>=65&&Z<=90)X(Z-65);else if(Z>=97&&Z<=122)X(Z-97+26);else if(Z>=48&&Z<=57)X(Z-48+52);else if(Z===43||Z===45)X(62);else if(Z===47||Z===95)X(63);else{if(Z===61)break;throw new SyntaxError(`Unexpected base64 character ${O[te]}`)}}const re=B;for(;P>0;)X(0);return b.wrap(Y).slice(0,re)}const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",T="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function A({buffer:O},k=!0,P=!1){const B=P?T:I;let Y="";const X=O.byteLength%3;let re=0;for(;re<O.byteLength-X;re+=3){const te=O[re+0],Z=O[re+1],fe=O[re+2];Y+=B[te>>>2],Y+=B[(te<<4|Z>>>4)&63],Y+=B[(Z<<2|fe>>>6)&63],Y+=B[fe&63]}if(X===1){const te=O[re+0];Y+=B[te>>>2],Y+=B[te<<4&63],k&&(Y+="==")}else if(X===2){const te=O[re+0],Z=O[re+1];Y+=B[te>>>2],Y+=B[(te<<4|Z>>>4)&63],Y+=B[Z<<2&63],k&&(Y+="=")}return Y}}),define(ye[171],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ye[11],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=i,e.isStringArray=r,e.isObject=w,e.isTypedArray=C,e.isNumber=R,e.isIterable=_,e.isBoolean=b,e.isUndefined=o,e.isDefined=D,e.isUndefinedOrNull=y,e.assertType=d,e.assertIsDefined=E,e.assertAllDefined=a,e.isEmptyObject=m,e.isFunction=p,e.areFunctions=S,e.validateConstraints=g,e.validateConstraint=v;function i(t){return typeof t=="string"}function r(t){return Array.isArray(t)&&t.every(l=>i(l))}function w(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}function C(t){const l=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof l}function R(t){return typeof t=="number"&&!isNaN(t)}function _(t){return!!t&&typeof t[Symbol.iterator]=="function"}function b(t){return t===!0||t===!1}function o(t){return typeof t>"u"}function D(t){return!y(t)}function y(t){return o(t)||t===null}function d(t,l){if(!t)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}function E(t){if(y(t))throw new Error("Assertion Failed: argument is undefined or null");return t}function a(...t){const l=[];for(let n=0;n<t.length;n++){const h=t[n];if(y(h))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);l.push(h)}return l}const f=Object.prototype.hasOwnProperty;function m(t){if(!w(t))return!1;for(const l in t)if(f.call(t,l))return!1;return!0}function p(t){return typeof t=="function"}function S(...t){return t.length>0&&t.every(p)}function g(t,l){const n=Math.min(t.length,l.length);for(let h=0;h<n;h++)v(t[h],l[h])}function v(t,l){if(i(l)){if(typeof t!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(p(l)){try{if(t instanceof l)return}catch{}if(!y(t)&&t.constructor===l||l.length===1&&l.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ye[108],Ie([1,0,11]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.register=w,e.getCodiconFontCharacters=C;const r=Object.create(null);function w(R,_){if((0,i.isString)(_)){const b=r[_];if(b===void 0)throw new Error(`${R} references an unknown codicon: ${_}`);_=b}return r[R]=_,{id:R}}function C(){return r}}),define(ye[172],Ie([1,0,108]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.codiconsLibrary=void 0,e.codiconsLibrary={add:(0,i.register)("add",6e4),plus:(0,i.register)("plus",6e4),gistNew:(0,i.register)("gist-new",6e4),repoCreate:(0,i.register)("repo-create",6e4),lightbulb:(0,i.register)("lightbulb",60001),lightBulb:(0,i.register)("light-bulb",60001),repo:(0,i.register)("repo",60002),repoDelete:(0,i.register)("repo-delete",60002),gistFork:(0,i.register)("gist-fork",60003),repoForked:(0,i.register)("repo-forked",60003),gitPullRequest:(0,i.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.register)("git-pull-request-abandoned",60004),recordKeys:(0,i.register)("record-keys",60005),keyboard:(0,i.register)("keyboard",60005),tag:(0,i.register)("tag",60006),gitPullRequestLabel:(0,i.register)("git-pull-request-label",60006),tagAdd:(0,i.register)("tag-add",60006),tagRemove:(0,i.register)("tag-remove",60006),person:(0,i.register)("person",60007),personFollow:(0,i.register)("person-follow",60007),personOutline:(0,i.register)("person-outline",60007),personFilled:(0,i.register)("person-filled",60007),gitBranch:(0,i.register)("git-branch",60008),gitBranchCreate:(0,i.register)("git-branch-create",60008),gitBranchDelete:(0,i.register)("git-branch-delete",60008),sourceControl:(0,i.register)("source-control",60008),mirror:(0,i.register)("mirror",60009),mirrorPublic:(0,i.register)("mirror-public",60009),star:(0,i.register)("star",60010),starAdd:(0,i.register)("star-add",60010),starDelete:(0,i.register)("star-delete",60010),starEmpty:(0,i.register)("star-empty",60010),comment:(0,i.register)("comment",60011),commentAdd:(0,i.register)("comment-add",60011),alert:(0,i.register)("alert",60012),warning:(0,i.register)("warning",60012),search:(0,i.register)("search",60013),searchSave:(0,i.register)("search-save",60013),logOut:(0,i.register)("log-out",60014),signOut:(0,i.register)("sign-out",60014),logIn:(0,i.register)("log-in",60015),signIn:(0,i.register)("sign-in",60015),eye:(0,i.register)("eye",60016),eyeUnwatch:(0,i.register)("eye-unwatch",60016),eyeWatch:(0,i.register)("eye-watch",60016),circleFilled:(0,i.register)("circle-filled",60017),primitiveDot:(0,i.register)("primitive-dot",60017),closeDirty:(0,i.register)("close-dirty",60017),debugBreakpoint:(0,i.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.register)("debug-breakpoint-disabled",60017),debugHint:(0,i.register)("debug-hint",60017),terminalDecorationSuccess:(0,i.register)("terminal-decoration-success",60017),primitiveSquare:(0,i.register)("primitive-square",60018),edit:(0,i.register)("edit",60019),pencil:(0,i.register)("pencil",60019),info:(0,i.register)("info",60020),issueOpened:(0,i.register)("issue-opened",60020),gistPrivate:(0,i.register)("gist-private",60021),gitForkPrivate:(0,i.register)("git-fork-private",60021),lock:(0,i.register)("lock",60021),mirrorPrivate:(0,i.register)("mirror-private",60021),close:(0,i.register)("close",60022),removeClose:(0,i.register)("remove-close",60022),x:(0,i.register)("x",60022),repoSync:(0,i.register)("repo-sync",60023),sync:(0,i.register)("sync",60023),clone:(0,i.register)("clone",60024),desktopDownload:(0,i.register)("desktop-download",60024),beaker:(0,i.register)("beaker",60025),microscope:(0,i.register)("microscope",60025),vm:(0,i.register)("vm",60026),deviceDesktop:(0,i.register)("device-desktop",60026),file:(0,i.register)("file",60027),fileText:(0,i.register)("file-text",60027),more:(0,i.register)("more",60028),ellipsis:(0,i.register)("ellipsis",60028),kebabHorizontal:(0,i.register)("kebab-horizontal",60028),mailReply:(0,i.register)("mail-reply",60029),reply:(0,i.register)("reply",60029),organization:(0,i.register)("organization",60030),organizationFilled:(0,i.register)("organization-filled",60030),organizationOutline:(0,i.register)("organization-outline",60030),newFile:(0,i.register)("new-file",60031),fileAdd:(0,i.register)("file-add",60031),newFolder:(0,i.register)("new-folder",60032),fileDirectoryCreate:(0,i.register)("file-directory-create",60032),trash:(0,i.register)("trash",60033),trashcan:(0,i.register)("trashcan",60033),history:(0,i.register)("history",60034),clock:(0,i.register)("clock",60034),folder:(0,i.register)("folder",60035),fileDirectory:(0,i.register)("file-directory",60035),symbolFolder:(0,i.register)("symbol-folder",60035),logoGithub:(0,i.register)("logo-github",60036),markGithub:(0,i.register)("mark-github",60036),github:(0,i.register)("github",60036),terminal:(0,i.register)("terminal",60037),console:(0,i.register)("console",60037),repl:(0,i.register)("repl",60037),zap:(0,i.register)("zap",60038),symbolEvent:(0,i.register)("symbol-event",60038),error:(0,i.register)("error",60039),stop:(0,i.register)("stop",60039),variable:(0,i.register)("variable",60040),symbolVariable:(0,i.register)("symbol-variable",60040),array:(0,i.register)("array",60042),symbolArray:(0,i.register)("symbol-array",60042),symbolModule:(0,i.register)("symbol-module",60043),symbolPackage:(0,i.register)("symbol-package",60043),symbolNamespace:(0,i.register)("symbol-namespace",60043),symbolObject:(0,i.register)("symbol-object",60043),symbolMethod:(0,i.register)("symbol-method",60044),symbolFunction:(0,i.register)("symbol-function",60044),symbolConstructor:(0,i.register)("symbol-constructor",60044),symbolBoolean:(0,i.register)("symbol-boolean",60047),symbolNull:(0,i.register)("symbol-null",60047),symbolNumeric:(0,i.register)("symbol-numeric",60048),symbolNumber:(0,i.register)("symbol-number",60048),symbolStructure:(0,i.register)("symbol-structure",60049),symbolStruct:(0,i.register)("symbol-struct",60049),symbolParameter:(0,i.register)("symbol-parameter",60050),symbolTypeParameter:(0,i.register)("symbol-type-parameter",60050),symbolKey:(0,i.register)("symbol-key",60051),symbolText:(0,i.register)("symbol-text",60051),symbolReference:(0,i.register)("symbol-reference",60052),goToFile:(0,i.register)("go-to-file",60052),symbolEnum:(0,i.register)("symbol-enum",60053),symbolValue:(0,i.register)("symbol-value",60053),symbolRuler:(0,i.register)("symbol-ruler",60054),symbolUnit:(0,i.register)("symbol-unit",60054),activateBreakpoints:(0,i.register)("activate-breakpoints",60055),archive:(0,i.register)("archive",60056),arrowBoth:(0,i.register)("arrow-both",60057),arrowDown:(0,i.register)("arrow-down",60058),arrowLeft:(0,i.register)("arrow-left",60059),arrowRight:(0,i.register)("arrow-right",60060),arrowSmallDown:(0,i.register)("arrow-small-down",60061),arrowSmallLeft:(0,i.register)("arrow-small-left",60062),arrowSmallRight:(0,i.register)("arrow-small-right",60063),arrowSmallUp:(0,i.register)("arrow-small-up",60064),arrowUp:(0,i.register)("arrow-up",60065),bell:(0,i.register)("bell",60066),bold:(0,i.register)("bold",60067),book:(0,i.register)("book",60068),bookmark:(0,i.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.register)("briefcase",60076),broadcast:(0,i.register)("broadcast",60077),browser:(0,i.register)("browser",60078),bug:(0,i.register)("bug",60079),calendar:(0,i.register)("calendar",60080),caseSensitive:(0,i.register)("case-sensitive",60081),check:(0,i.register)("check",60082),checklist:(0,i.register)("checklist",60083),chevronDown:(0,i.register)("chevron-down",60084),chevronLeft:(0,i.register)("chevron-left",60085),chevronRight:(0,i.register)("chevron-right",60086),chevronUp:(0,i.register)("chevron-up",60087),chromeClose:(0,i.register)("chrome-close",60088),chromeMaximize:(0,i.register)("chrome-maximize",60089),chromeMinimize:(0,i.register)("chrome-minimize",60090),chromeRestore:(0,i.register)("chrome-restore",60091),circleOutline:(0,i.register)("circle-outline",60092),circle:(0,i.register)("circle",60092),debugBreakpointUnverified:(0,i.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.register)("terminal-decoration-incomplete",60092),circleSlash:(0,i.register)("circle-slash",60093),circuitBoard:(0,i.register)("circuit-board",60094),clearAll:(0,i.register)("clear-all",60095),clippy:(0,i.register)("clippy",60096),closeAll:(0,i.register)("close-all",60097),cloudDownload:(0,i.register)("cloud-download",60098),cloudUpload:(0,i.register)("cloud-upload",60099),code:(0,i.register)("code",60100),collapseAll:(0,i.register)("collapse-all",60101),colorMode:(0,i.register)("color-mode",60102),commentDiscussion:(0,i.register)("comment-discussion",60103),creditCard:(0,i.register)("credit-card",60105),dash:(0,i.register)("dash",60108),dashboard:(0,i.register)("dashboard",60109),database:(0,i.register)("database",60110),debugContinue:(0,i.register)("debug-continue",60111),debugDisconnect:(0,i.register)("debug-disconnect",60112),debugPause:(0,i.register)("debug-pause",60113),debugRestart:(0,i.register)("debug-restart",60114),debugStart:(0,i.register)("debug-start",60115),debugStepInto:(0,i.register)("debug-step-into",60116),debugStepOut:(0,i.register)("debug-step-out",60117),debugStepOver:(0,i.register)("debug-step-over",60118),debugStop:(0,i.register)("debug-stop",60119),debug:(0,i.register)("debug",60120),deviceCameraVideo:(0,i.register)("device-camera-video",60121),deviceCamera:(0,i.register)("device-camera",60122),deviceMobile:(0,i.register)("device-mobile",60123),diffAdded:(0,i.register)("diff-added",60124),diffIgnored:(0,i.register)("diff-ignored",60125),diffModified:(0,i.register)("diff-modified",60126),diffRemoved:(0,i.register)("diff-removed",60127),diffRenamed:(0,i.register)("diff-renamed",60128),diff:(0,i.register)("diff",60129),diffSidebyside:(0,i.register)("diff-sidebyside",60129),discard:(0,i.register)("discard",60130),editorLayout:(0,i.register)("editor-layout",60131),emptyWindow:(0,i.register)("empty-window",60132),exclude:(0,i.register)("exclude",60133),extensions:(0,i.register)("extensions",60134),eyeClosed:(0,i.register)("eye-closed",60135),fileBinary:(0,i.register)("file-binary",60136),fileCode:(0,i.register)("file-code",60137),fileMedia:(0,i.register)("file-media",60138),filePdf:(0,i.register)("file-pdf",60139),fileSubmodule:(0,i.register)("file-submodule",60140),fileSymlinkDirectory:(0,i.register)("file-symlink-directory",60141),fileSymlinkFile:(0,i.register)("file-symlink-file",60142),fileZip:(0,i.register)("file-zip",60143),files:(0,i.register)("files",60144),filter:(0,i.register)("filter",60145),flame:(0,i.register)("flame",60146),foldDown:(0,i.register)("fold-down",60147),foldUp:(0,i.register)("fold-up",60148),fold:(0,i.register)("fold",60149),folderActive:(0,i.register)("folder-active",60150),folderOpened:(0,i.register)("folder-opened",60151),gear:(0,i.register)("gear",60152),gift:(0,i.register)("gift",60153),gistSecret:(0,i.register)("gist-secret",60154),gist:(0,i.register)("gist",60155),gitCommit:(0,i.register)("git-commit",60156),gitCompare:(0,i.register)("git-compare",60157),compareChanges:(0,i.register)("compare-changes",60157),gitMerge:(0,i.register)("git-merge",60158),githubAction:(0,i.register)("github-action",60159),githubAlt:(0,i.register)("github-alt",60160),globe:(0,i.register)("globe",60161),grabber:(0,i.register)("grabber",60162),graph:(0,i.register)("graph",60163),gripper:(0,i.register)("gripper",60164),heart:(0,i.register)("heart",60165),home:(0,i.register)("home",60166),horizontalRule:(0,i.register)("horizontal-rule",60167),hubot:(0,i.register)("hubot",60168),inbox:(0,i.register)("inbox",60169),issueReopened:(0,i.register)("issue-reopened",60171),issues:(0,i.register)("issues",60172),italic:(0,i.register)("italic",60173),jersey:(0,i.register)("jersey",60174),json:(0,i.register)("json",60175),kebabVertical:(0,i.register)("kebab-vertical",60176),key:(0,i.register)("key",60177),law:(0,i.register)("law",60178),lightbulbAutofix:(0,i.register)("lightbulb-autofix",60179),linkExternal:(0,i.register)("link-external",60180),link:(0,i.register)("link",60181),listOrdered:(0,i.register)("list-ordered",60182),listUnordered:(0,i.register)("list-unordered",60183),liveShare:(0,i.register)("live-share",60184),loading:(0,i.register)("loading",60185),location:(0,i.register)("location",60186),mailRead:(0,i.register)("mail-read",60187),mail:(0,i.register)("mail",60188),markdown:(0,i.register)("markdown",60189),megaphone:(0,i.register)("megaphone",60190),mention:(0,i.register)("mention",60191),milestone:(0,i.register)("milestone",60192),gitPullRequestMilestone:(0,i.register)("git-pull-request-milestone",60192),mortarBoard:(0,i.register)("mortar-board",60193),move:(0,i.register)("move",60194),multipleWindows:(0,i.register)("multiple-windows",60195),mute:(0,i.register)("mute",60196),noNewline:(0,i.register)("no-newline",60197),note:(0,i.register)("note",60198),octoface:(0,i.register)("octoface",60199),openPreview:(0,i.register)("open-preview",60200),package:(0,i.register)("package",60201),paintcan:(0,i.register)("paintcan",60202),pin:(0,i.register)("pin",60203),play:(0,i.register)("play",60204),run:(0,i.register)("run",60204),plug:(0,i.register)("plug",60205),preserveCase:(0,i.register)("preserve-case",60206),preview:(0,i.register)("preview",60207),project:(0,i.register)("project",60208),pulse:(0,i.register)("pulse",60209),question:(0,i.register)("question",60210),quote:(0,i.register)("quote",60211),radioTower:(0,i.register)("radio-tower",60212),reactions:(0,i.register)("reactions",60213),references:(0,i.register)("references",60214),refresh:(0,i.register)("refresh",60215),regex:(0,i.register)("regex",60216),remoteExplorer:(0,i.register)("remote-explorer",60217),remote:(0,i.register)("remote",60218),remove:(0,i.register)("remove",60219),replaceAll:(0,i.register)("replace-all",60220),replace:(0,i.register)("replace",60221),repoClone:(0,i.register)("repo-clone",60222),repoForcePush:(0,i.register)("repo-force-push",60223),repoPull:(0,i.register)("repo-pull",60224),repoPush:(0,i.register)("repo-push",60225),report:(0,i.register)("report",60226),requestChanges:(0,i.register)("request-changes",60227),rocket:(0,i.register)("rocket",60228),rootFolderOpened:(0,i.register)("root-folder-opened",60229),rootFolder:(0,i.register)("root-folder",60230),rss:(0,i.register)("rss",60231),ruby:(0,i.register)("ruby",60232),saveAll:(0,i.register)("save-all",60233),saveAs:(0,i.register)("save-as",60234),save:(0,i.register)("save",60235),screenFull:(0,i.register)("screen-full",60236),screenNormal:(0,i.register)("screen-normal",60237),searchStop:(0,i.register)("search-stop",60238),server:(0,i.register)("server",60240),settingsGear:(0,i.register)("settings-gear",60241),settings:(0,i.register)("settings",60242),shield:(0,i.register)("shield",60243),smiley:(0,i.register)("smiley",60244),sortPrecedence:(0,i.register)("sort-precedence",60245),splitHorizontal:(0,i.register)("split-horizontal",60246),splitVertical:(0,i.register)("split-vertical",60247),squirrel:(0,i.register)("squirrel",60248),starFull:(0,i.register)("star-full",60249),starHalf:(0,i.register)("star-half",60250),symbolClass:(0,i.register)("symbol-class",60251),symbolColor:(0,i.register)("symbol-color",60252),symbolConstant:(0,i.register)("symbol-constant",60253),symbolEnumMember:(0,i.register)("symbol-enum-member",60254),symbolField:(0,i.register)("symbol-field",60255),symbolFile:(0,i.register)("symbol-file",60256),symbolInterface:(0,i.register)("symbol-interface",60257),symbolKeyword:(0,i.register)("symbol-keyword",60258),symbolMisc:(0,i.register)("symbol-misc",60259),symbolOperator:(0,i.register)("symbol-operator",60260),symbolProperty:(0,i.register)("symbol-property",60261),wrench:(0,i.register)("wrench",60261),wrenchSubaction:(0,i.register)("wrench-subaction",60261),symbolSnippet:(0,i.register)("symbol-snippet",60262),tasklist:(0,i.register)("tasklist",60263),telescope:(0,i.register)("telescope",60264),textSize:(0,i.register)("text-size",60265),threeBars:(0,i.register)("three-bars",60266),thumbsdown:(0,i.register)("thumbsdown",60267),thumbsup:(0,i.register)("thumbsup",60268),tools:(0,i.register)("tools",60269),triangleDown:(0,i.register)("triangle-down",60270),triangleLeft:(0,i.register)("triangle-left",60271),triangleRight:(0,i.register)("triangle-right",60272),triangleUp:(0,i.register)("triangle-up",60273),twitter:(0,i.register)("twitter",60274),unfold:(0,i.register)("unfold",60275),unlock:(0,i.register)("unlock",60276),unmute:(0,i.register)("unmute",60277),unverified:(0,i.register)("unverified",60278),verified:(0,i.register)("verified",60279),versions:(0,i.register)("versions",60280),vmActive:(0,i.register)("vm-active",60281),vmOutline:(0,i.register)("vm-outline",60282),vmRunning:(0,i.register)("vm-running",60283),watch:(0,i.register)("watch",60284),whitespace:(0,i.register)("whitespace",60285),wholeWord:(0,i.register)("whole-word",60286),window:(0,i.register)("window",60287),wordWrap:(0,i.register)("word-wrap",60288),zoomIn:(0,i.register)("zoom-in",60289),zoomOut:(0,i.register)("zoom-out",60290),listFilter:(0,i.register)("list-filter",60291),listFlat:(0,i.register)("list-flat",60292),listSelection:(0,i.register)("list-selection",60293),selection:(0,i.register)("selection",60293),listTree:(0,i.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.register)("debug-stackframe-active",60297),circleSmallFilled:(0,i.register)("circle-small-filled",60298),debugStackframeDot:(0,i.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.register)("terminal-decoration-mark",60298),debugStackframe:(0,i.register)("debug-stackframe",60299),debugStackframeFocused:(0,i.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.register)("debug-breakpoint-unsupported",60300),symbolString:(0,i.register)("symbol-string",60301),debugReverseContinue:(0,i.register)("debug-reverse-continue",60302),debugStepBack:(0,i.register)("debug-step-back",60303),debugRestartFrame:(0,i.register)("debug-restart-frame",60304),debugAlt:(0,i.register)("debug-alt",60305),callIncoming:(0,i.register)("call-incoming",60306),callOutgoing:(0,i.register)("call-outgoing",60307),menu:(0,i.register)("menu",60308),expandAll:(0,i.register)("expand-all",60309),feedback:(0,i.register)("feedback",60310),gitPullRequestReviewer:(0,i.register)("git-pull-request-reviewer",60310),groupByRefType:(0,i.register)("group-by-ref-type",60311),ungroupByRefType:(0,i.register)("ungroup-by-ref-type",60312),account:(0,i.register)("account",60313),gitPullRequestAssignee:(0,i.register)("git-pull-request-assignee",60313),bellDot:(0,i.register)("bell-dot",60314),debugConsole:(0,i.register)("debug-console",60315),library:(0,i.register)("library",60316),output:(0,i.register)("output",60317),runAll:(0,i.register)("run-all",60318),syncIgnored:(0,i.register)("sync-ignored",60319),pinned:(0,i.register)("pinned",60320),githubInverted:(0,i.register)("github-inverted",60321),serverProcess:(0,i.register)("server-process",60322),serverEnvironment:(0,i.register)("server-environment",60323),pass:(0,i.register)("pass",60324),issueClosed:(0,i.register)("issue-closed",60324),stopCircle:(0,i.register)("stop-circle",60325),playCircle:(0,i.register)("play-circle",60326),record:(0,i.register)("record",60327),debugAltSmall:(0,i.register)("debug-alt-small",60328),vmConnect:(0,i.register)("vm-connect",60329),cloud:(0,i.register)("cloud",60330),merge:(0,i.register)("merge",60331),export:(0,i.register)("export",60332),graphLeft:(0,i.register)("graph-left",60333),magnet:(0,i.register)("magnet",60334),notebook:(0,i.register)("notebook",60335),redo:(0,i.register)("redo",60336),checkAll:(0,i.register)("check-all",60337),pinnedDirty:(0,i.register)("pinned-dirty",60338),passFilled:(0,i.register)("pass-filled",60339),circleLargeFilled:(0,i.register)("circle-large-filled",60340),circleLarge:(0,i.register)("circle-large",60341),circleLargeOutline:(0,i.register)("circle-large-outline",60341),combine:(0,i.register)("combine",60342),gather:(0,i.register)("gather",60342),table:(0,i.register)("table",60343),variableGroup:(0,i.register)("variable-group",60344),typeHierarchy:(0,i.register)("type-hierarchy",60345),typeHierarchySub:(0,i.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.register)("git-pull-request-create",60348),runAbove:(0,i.register)("run-above",60349),runBelow:(0,i.register)("run-below",60350),notebookTemplate:(0,i.register)("notebook-template",60351),debugRerun:(0,i.register)("debug-rerun",60352),workspaceTrusted:(0,i.register)("workspace-trusted",60353),workspaceUntrusted:(0,i.register)("workspace-untrusted",60354),workspaceUnknown:(0,i.register)("workspace-unknown",60355),terminalCmd:(0,i.register)("terminal-cmd",60356),terminalDebian:(0,i.register)("terminal-debian",60357),terminalLinux:(0,i.register)("terminal-linux",60358),terminalPowershell:(0,i.register)("terminal-powershell",60359),terminalTmux:(0,i.register)("terminal-tmux",60360),terminalUbuntu:(0,i.register)("terminal-ubuntu",60361),terminalBash:(0,i.register)("terminal-bash",60362),arrowSwap:(0,i.register)("arrow-swap",60363),copy:(0,i.register)("copy",60364),personAdd:(0,i.register)("person-add",60365),filterFilled:(0,i.register)("filter-filled",60366),wand:(0,i.register)("wand",60367),debugLineByLine:(0,i.register)("debug-line-by-line",60368),inspect:(0,i.register)("inspect",60369),layers:(0,i.register)("layers",60370),layersDot:(0,i.register)("layers-dot",60371),layersActive:(0,i.register)("layers-active",60372),compass:(0,i.register)("compass",60373),compassDot:(0,i.register)("compass-dot",60374),compassActive:(0,i.register)("compass-active",60375),azure:(0,i.register)("azure",60376),issueDraft:(0,i.register)("issue-draft",60377),gitPullRequestClosed:(0,i.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.register)("git-pull-request-draft",60379),debugAll:(0,i.register)("debug-all",60380),debugCoverage:(0,i.register)("debug-coverage",60381),runErrors:(0,i.register)("run-errors",60382),folderLibrary:(0,i.register)("folder-library",60383),debugContinueSmall:(0,i.register)("debug-continue-small",60384),beakerStop:(0,i.register)("beaker-stop",60385),graphLine:(0,i.register)("graph-line",60386),graphScatter:(0,i.register)("graph-scatter",60387),pieChart:(0,i.register)("pie-chart",60388),bracket:(0,i.register)("bracket",60175),bracketDot:(0,i.register)("bracket-dot",60389),bracketError:(0,i.register)("bracket-error",60390),lockSmall:(0,i.register)("lock-small",60391),azureDevops:(0,i.register)("azure-devops",60392),verifiedFilled:(0,i.register)("verified-filled",60393),newline:(0,i.register)("newline",60394),layout:(0,i.register)("layout",60395),layoutActivitybarLeft:(0,i.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.register)("layout-panel-left",60398),layoutPanelCenter:(0,i.register)("layout-panel-center",60399),layoutPanelJustify:(0,i.register)("layout-panel-justify",60400),layoutPanelRight:(0,i.register)("layout-panel-right",60401),layoutPanel:(0,i.register)("layout-panel",60402),layoutSidebarLeft:(0,i.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.register)("layout-sidebar-right",60404),layoutStatusbar:(0,i.register)("layout-statusbar",60405),layoutMenubar:(0,i.register)("layout-menubar",60406),layoutCentered:(0,i.register)("layout-centered",60407),target:(0,i.register)("target",60408),indent:(0,i.register)("indent",60409),recordSmall:(0,i.register)("record-small",60410),errorSmall:(0,i.register)("error-small",60411),terminalDecorationError:(0,i.register)("terminal-decoration-error",60411),arrowCircleDown:(0,i.register)("arrow-circle-down",60412),arrowCircleLeft:(0,i.register)("arrow-circle-left",60413),arrowCircleRight:(0,i.register)("arrow-circle-right",60414),arrowCircleUp:(0,i.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.register)("layout-sidebar-left-off",60418),blank:(0,i.register)("blank",60419),heartFilled:(0,i.register)("heart-filled",60420),map:(0,i.register)("map",60421),mapHorizontal:(0,i.register)("map-horizontal",60421),foldHorizontal:(0,i.register)("fold-horizontal",60421),mapFilled:(0,i.register)("map-filled",60422),mapHorizontalFilled:(0,i.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.register)("fold-horizontal-filled",60422),circleSmall:(0,i.register)("circle-small",60423),bellSlash:(0,i.register)("bell-slash",60424),bellSlashDot:(0,i.register)("bell-slash-dot",60425),commentUnresolved:(0,i.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.register)("search-fuzzy",60429),commentDraft:(0,i.register)("comment-draft",60430),send:(0,i.register)("send",60431),sparkle:(0,i.register)("sparkle",60432),insert:(0,i.register)("insert",60433),mic:(0,i.register)("mic",60434),thumbsdownFilled:(0,i.register)("thumbsdown-filled",60435),thumbsupFilled:(0,i.register)("thumbsup-filled",60436),coffee:(0,i.register)("coffee",60437),snake:(0,i.register)("snake",60438),game:(0,i.register)("game",60439),vr:(0,i.register)("vr",60440),chip:(0,i.register)("chip",60441),piano:(0,i.register)("piano",60442),music:(0,i.register)("music",60443),micFilled:(0,i.register)("mic-filled",60444),repoFetch:(0,i.register)("repo-fetch",60445),copilot:(0,i.register)("copilot",60446),lightbulbSparkle:(0,i.register)("lightbulb-sparkle",60447),robot:(0,i.register)("robot",60448),sparkleFilled:(0,i.register)("sparkle-filled",60449),diffSingle:(0,i.register)("diff-single",60450),diffMultiple:(0,i.register)("diff-multiple",60451),surroundWith:(0,i.register)("surround-with",60452),share:(0,i.register)("share",60453),gitStash:(0,i.register)("git-stash",60454),gitStashApply:(0,i.register)("git-stash-apply",60455),gitStashPop:(0,i.register)("git-stash-pop",60456),vscode:(0,i.register)("vscode",60457),vscodeInsiders:(0,i.register)("vscode-insiders",60458),codeOss:(0,i.register)("code-oss",60459),runCoverage:(0,i.register)("run-coverage",60460),runAllCoverage:(0,i.register)("run-all-coverage",60461),coverage:(0,i.register)("coverage",60462),githubProject:(0,i.register)("github-project",60463),mapVertical:(0,i.register)("map-vertical",60464),foldVertical:(0,i.register)("fold-vertical",60464),mapVerticalFilled:(0,i.register)("map-vertical-filled",60465),foldVerticalFilled:(0,i.register)("fold-vertical-filled",60465),goToSearch:(0,i.register)("go-to-search",60466),percentage:(0,i.register)("percentage",60467),sortPercentage:(0,i.register)("sort-percentage",60467),attach:(0,i.register)("attach",60468)}}),define(ye[57],Ie([1,0,108,172]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.codiconsDerived=void 0,e.getAllCodicons=w;function w(){return Object.values(e.Codicon)}e.codiconsDerived={dialogError:(0,i.register)("dialog-error","error"),dialogWarning:(0,i.register)("dialog-warning","warning"),dialogInfo:(0,i.register)("dialog-info","info"),dialogClose:(0,i.register)("dialog-close","close"),treeItemExpanded:(0,i.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.register)("tree-filter-clear","close"),treeItemLoading:(0,i.register)("tree-item-loading","loading"),menuSelection:(0,i.register)("menu-selection","check"),menuSubmenu:(0,i.register)("menu-submenu","chevron-right"),menuBarMore:(0,i.register)("menubar-more","more"),scrollbarButtonLeft:(0,i.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.register)("toolbar-more","more"),quickInputBack:(0,i.register)("quick-input-back","arrow-left"),dropDownButton:(0,i.register)("drop-down-button",60084),symbolCustomColor:(0,i.register)("symbol-customcolor",60252),exportIcon:(0,i.register)("export",60332),workspaceUnspecified:(0,i.register)("workspace-unspecified",60355),newLine:(0,i.register)("newline",60394),thumbsDownFilled:(0,i.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.register)("thumbsup-filled",60436),gitFetch:(0,i.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.register)("debug-breakpoint-pending",60377)},e.Codicon={...r.codiconsLibrary,...e.codiconsDerived}}),define(ye[21],Ie([1,0,11]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=r,e.deepFreeze=w,e.cloneAndChange=R,e.mixin=b,e.equals=o,e.safeStringify=D,e.distinct=y,e.getCaseInsensitive=d,e.filter=E,e.getAllPropertyNames=a,e.getAllMethodNames=f,e.createProxyObject=m,e.mapValues=p;function r(S){if(!S||typeof S!="object"||S instanceof RegExp)return S;const g=Array.isArray(S)?[]:{};return Object.entries(S).forEach(([v,t])=>{g[v]=t&&typeof t=="object"?r(t):t}),g}function w(S){if(!S||typeof S!="object")return S;const g=[S];for(;g.length>0;){const v=g.shift();Object.freeze(v);for(const t in v)if(C.call(v,t)){const l=v[t];typeof l=="object"&&!Object.isFrozen(l)&&!(0,i.isTypedArray)(l)&&g.push(l)}}return S}const C=Object.prototype.hasOwnProperty;function R(S,g){return _(S,g,new Set)}function _(S,g,v){if((0,i.isUndefinedOrNull)(S))return S;const t=g(S);if(typeof t<"u")return t;if(Array.isArray(S)){const l=[];for(const n of S)l.push(_(n,g,v));return l}if((0,i.isObject)(S)){if(v.has(S))throw new Error("Cannot clone recursive data-structure");v.add(S);const l={};for(const n in S)C.call(S,n)&&(l[n]=_(S[n],g,v));return v.delete(S),l}return S}function b(S,g,v=!0){return(0,i.isObject)(S)?((0,i.isObject)(g)&&Object.keys(g).forEach(t=>{t in S?v&&((0,i.isObject)(S[t])&&(0,i.isObject)(g[t])?b(S[t],g[t],v):S[t]=g[t]):S[t]=g[t]}),S):g}function o(S,g){if(S===g)return!0;if(S==null||g===null||g===void 0||typeof S!=typeof g||typeof S!="object"||Array.isArray(S)!==Array.isArray(g))return!1;let v,t;if(Array.isArray(S)){if(S.length!==g.length)return!1;for(v=0;v<S.length;v++)if(!o(S[v],g[v]))return!1}else{const l=[];for(t in S)l.push(t);l.sort();const n=[];for(t in g)n.push(t);if(n.sort(),!o(l,n))return!1;for(v=0;v<l.length;v++)if(!o(S[l[v]],g[l[v]]))return!1}return!0}function D(S){const g=new Set;return JSON.stringify(S,(v,t)=>{if((0,i.isObject)(t)||Array.isArray(t)){if(g.has(t))return"[Circular]";g.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function y(S,g){const v=Object.create(null);return!S||!g||Object.keys(g).forEach(l=>{const n=S[l],h=g[l];o(n,h)||(v[l]=h)}),v}function d(S,g){const v=g.toLowerCase(),t=Object.keys(S).find(l=>l.toLowerCase()===v);return t?S[t]:S[g]}function E(S,g){const v=Object.create(null);for(const[t,l]of Object.entries(S))g(t,l)&&(v[t]=l);return v}function a(S){let g=[];for(;Object.prototype!==S;)g=g.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return g}function f(S){const g=[];for(const v of a(S))typeof S[v]=="function"&&g.push(v);return g}function m(S,g){const v=l=>function(){const n=Array.prototype.slice.call(arguments,0);return g(l,n)},t={};for(const l of S)t[l]=v(l);return t}function p(S,g){const v={};for(const[t,l]of Object.entries(S))v[t]=g(l,t);return v}}),define(ye[82],Ie([1,0,57]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.themeColorFromId=w;var r;(function(R){function _(b){return b&&typeof b=="object"&&typeof b.id=="string"}R.isThemeColor=_})(r||(e.ThemeColor=r={}));function w(R){return{id:R}}var C;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const _=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function b(S){const g=_.exec(S.id);if(!g)return b(i.Codicon.error);const[,v,t]=g,l=["codicon","codicon-"+v];return t&&l.push("codicon-modifier-"+t.substring(1)),l}R.asClassNameArray=b;function o(S){return b(S).join(" ")}R.asClassName=o;function D(S){return"."+b(S).join(".")}R.asCSSSelector=D;function y(S){return S&&typeof S=="object"&&typeof S.id=="string"&&(typeof S.color>"u"||r.isThemeColor(S.color))}R.isThemeIcon=y;const d=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function E(S){const g=d.exec(S);if(!g)return;const[,v]=g;return{id:v}}R.fromString=E;function a(S){return{id:S}}R.fromId=a;function f(S,g){let v=S.id;const t=v.lastIndexOf("~");return t!==-1&&(v=v.substring(0,t)),g&&(v=`${v}~${g}`),{id:v}}R.modify=f;function m(S){const g=S.id.lastIndexOf("~");if(g!==-1)return S.id.substring(g+1)}R.getModifier=m;function p(S,g){return S.id===g.id&&S.color?.id===g.color?.id}R.isEqual=p})(C||(e.ThemeIcon=C={}))}),define(ye[109],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.toUint8=r,e.toUint32=w;var i;(function(C){C[C.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",C[C.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",C[C.MAX_UINT_8=255]="MAX_UINT_8",C[C.MAX_UINT_16=65535]="MAX_UINT_16",C[C.MAX_UINT_32=4294967295]="MAX_UINT_32",C[C.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(e.Constants=i={}));function r(C){return C<0?0:C>i.MAX_UINT_8?i.MAX_UINT_8:C|0}function w(C){return C<0?0:C>i.MAX_UINT_32?i.MAX_UINT_32:C|0}}),define(ye[17],Ie([1,0,169,35,65,109]),function(se,e,i,r,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=R,e.format=b,e.format2=D,e.htmlAttributeEncodeValue=y,e.escape=d,e.escapeRegExpCharacters=E,e.count=a,e.truncate=f,e.truncateMiddle=m,e.trim=p,e.ltrim=S,e.rtrim=g,e.convertSimple2RegExpPattern=v,e.stripWildcards=t,e.createRegExp=l,e.regExpLeadsToEndlessLoop=n,e.splitLines=h,e.splitLinesIncludeSeparators=s,e.firstNonWhitespaceIndex=c,e.getLeadingWhitespace=u,e.lastNonWhitespaceIndex=I,e.replaceAsync=T,e.compare=A,e.compareSubstring=O,e.compareIgnoreCase=k,e.compareSubstringIgnoreCase=P,e.isAsciiDigit=B,e.isLowerAsciiLetter=Y,e.isUpperAsciiLetter=X,e.equalsIgnoreCase=re,e.startsWithIgnoreCase=te,e.commonPrefixLength=Z,e.commonSuffixLength=fe,e.isHighSurrogate=K,e.isLowSurrogate=ae,e.computeCodePoint=x,e.getNextCodePoint=z,e.nextCharLength=H,e.prevCharLength=ce,e.getCharContainingOffset=J,e.charCount=W,e.containsRTL=$,e.isBasicASCII=q,e.containsUnusualLineTerminators=G,e.isFullWidthCharacter=F,e.isEmojiImprecise=V,e.lcut=oe,e.forAnsiStringParts=Ce,e.removeAnsiEscapeCodes=Ne,e.removeAnsiEscapeCodesFromPrompt=pe,e.startsWithUTF8BOM=Te,e.stripUTF8BOM=Le,e.fuzzyContains=he,e.containsUppercaseCharacter=De,e.uppercaseFirstLetter=Re,e.getNLines=xe,e.singleLetterHash=Ve,e.getGraphemeBreakType=Xe,e.getLeftDeleteOffset=lt;function R(Ee){return!Ee||typeof Ee!="string"?!0:Ee.trim().length===0}const _=/{(\d+)}/g;function b(Ee,...Oe){return Oe.length===0?Ee:Ee.replace(_,function(Fe,be){const Ae=parseInt(be,10);return isNaN(Ae)||Ae<0||Ae>=Oe.length?Fe:Oe[Ae]})}const o=/{([^}]+)}/g;function D(Ee,Oe){return Object.keys(Oe).length===0?Ee:Ee.replace(o,(Fe,be)=>Oe[be]??Fe)}function y(Ee){return Ee.replace(/[<>"'&]/g,Oe=>{switch(Oe){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Oe})}function d(Ee){return Ee.replace(/[<>&]/g,function(Oe){switch(Oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Oe}})}function E(Ee){return Ee.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function a(Ee,Oe){let Fe=0,be=Ee.indexOf(Oe);for(;be!==-1;)Fe++,be=Ee.indexOf(Oe,be+Oe.length);return Fe}function f(Ee,Oe,Fe="\u2026"){return Ee.length<=Oe?Ee:`${Ee.substr(0,Oe)}${Fe}`}function m(Ee,Oe,Fe="\u2026"){if(Ee.length<=Oe)return Ee;const be=Math.ceil(Oe/2)-Fe.length/2,Ae=Math.floor(Oe/2)-Fe.length/2;return`${Ee.substr(0,be)}${Fe}${Ee.substr(Ee.length-Ae)}`}function p(Ee,Oe=" "){const Fe=S(Ee,Oe);return g(Fe,Oe)}function S(Ee,Oe){if(!Ee||!Oe)return Ee;const Fe=Oe.length;if(Fe===0||Ee.length===0)return Ee;let be=0;for(;Ee.indexOf(Oe,be)===be;)be=be+Fe;return Ee.substring(be)}function g(Ee,Oe){if(!Ee||!Oe)return Ee;const Fe=Oe.length,be=Ee.length;if(Fe===0||be===0)return Ee;let Ae=be,ie=-1;for(;ie=Ee.lastIndexOf(Oe,Ae-1),!(ie===-1||ie+Fe!==Ae);){if(ie===0)return"";Ae=ie}return Ee.substring(0,Ae)}function v(Ee){return Ee.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(Ee){return Ee.replace(/\*/g,"")}function l(Ee,Oe,Fe={}){if(!Ee)throw new Error("Cannot create regex from empty string");Oe||(Ee=E(Ee)),Fe.wholeWord&&(/\B/.test(Ee.charAt(0))||(Ee="\\b"+Ee),/\B/.test(Ee.charAt(Ee.length-1))||(Ee=Ee+"\\b"));let be="";return Fe.global&&(be+="g"),Fe.matchCase||(be+="i"),Fe.multiline&&(be+="m"),Fe.unicode&&(be+="u"),new RegExp(Ee,be)}function n(Ee){return Ee.source==="^"||Ee.source==="^$"||Ee.source==="$"||Ee.source==="^\\s*$"?!1:!!(Ee.exec("")&&Ee.lastIndex===0)}function h(Ee){return Ee.split(/\r\n|\r|\n/)}function s(Ee){const Oe=[],Fe=Ee.split(/(\r\n|\r|\n)/);for(let be=0;be<Math.ceil(Fe.length/2);be++)Oe.push(Fe[2*be]+(Fe[2*be+1]??""));return Oe}function c(Ee){for(let Oe=0,Fe=Ee.length;Oe<Fe;Oe++){const be=Ee.charCodeAt(Oe);if(be!==r.CharCode.Space&&be!==r.CharCode.Tab)return Oe}return-1}function u(Ee,Oe=0,Fe=Ee.length){for(let be=Oe;be<Fe;be++){const Ae=Ee.charCodeAt(be);if(Ae!==r.CharCode.Space&&Ae!==r.CharCode.Tab)return Ee.substring(Oe,be)}return Ee.substring(Oe,Fe)}function I(Ee,Oe=Ee.length-1){for(let Fe=Oe;Fe>=0;Fe--){const be=Ee.charCodeAt(Fe);if(be!==r.CharCode.Space&&be!==r.CharCode.Tab)return Fe}return-1}function T(Ee,Oe,Fe){const be=[];let Ae=0;for(const ie of Ee.matchAll(Oe)){if(be.push(Ee.slice(Ae,ie.index)),ie.index===void 0)throw new Error("match.index should be defined");Ae=ie.index+ie[0].length,be.push(Fe(ie[0],...ie.slice(1),ie.index,Ee,ie.groups))}return be.push(Ee.slice(Ae)),Promise.all(be).then(ie=>ie.join(""))}function A(Ee,Oe){return Ee<Oe?-1:Ee>Oe?1:0}function O(Ee,Oe,Fe=0,be=Ee.length,Ae=0,ie=Oe.length){for(;Fe<be&&Ae<ie;Fe++,Ae++){const He=Ee.charCodeAt(Fe),Ge=Oe.charCodeAt(Ae);if(He<Ge)return-1;if(He>Ge)return 1}const ee=be-Fe,Se=ie-Ae;return ee<Se?-1:ee>Se?1:0}function k(Ee,Oe){return P(Ee,Oe,0,Ee.length,0,Oe.length)}function P(Ee,Oe,Fe=0,be=Ee.length,Ae=0,ie=Oe.length){for(;Fe<be&&Ae<ie;Fe++,Ae++){let He=Ee.charCodeAt(Fe),Ge=Oe.charCodeAt(Ae);if(He===Ge)continue;if(He>=128||Ge>=128)return O(Ee.toLowerCase(),Oe.toLowerCase(),Fe,be,Ae,ie);Y(He)&&(He-=32),Y(Ge)&&(Ge-=32);const Ze=He-Ge;if(Ze!==0)return Ze}const ee=be-Fe,Se=ie-Ae;return ee<Se?-1:ee>Se?1:0}function B(Ee){return Ee>=r.CharCode.Digit0&&Ee<=r.CharCode.Digit9}function Y(Ee){return Ee>=r.CharCode.a&&Ee<=r.CharCode.z}function X(Ee){return Ee>=r.CharCode.A&&Ee<=r.CharCode.Z}function re(Ee,Oe){return Ee.length===Oe.length&&P(Ee,Oe)===0}function te(Ee,Oe){const Fe=Oe.length;return Oe.length>Ee.length?!1:P(Ee,Oe,0,Fe)===0}function Z(Ee,Oe){const Fe=Math.min(Ee.length,Oe.length);let be;for(be=0;be<Fe;be++)if(Ee.charCodeAt(be)!==Oe.charCodeAt(be))return be;return Fe}function fe(Ee,Oe){const Fe=Math.min(Ee.length,Oe.length);let be;const Ae=Ee.length-1,ie=Oe.length-1;for(be=0;be<Fe;be++)if(Ee.charCodeAt(Ae-be)!==Oe.charCodeAt(ie-be))return be;return Fe}function K(Ee){return 55296<=Ee&&Ee<=56319}function ae(Ee){return 56320<=Ee&&Ee<=57343}function x(Ee,Oe){return(Ee-55296<<10)+(Oe-56320)+65536}function z(Ee,Oe,Fe){const be=Ee.charCodeAt(Fe);if(K(be)&&Fe+1<Oe){const Ae=Ee.charCodeAt(Fe+1);if(ae(Ae))return x(be,Ae)}return be}function ne(Ee,Oe){const Fe=Ee.charCodeAt(Oe-1);if(ae(Fe)&&Oe>1){const be=Ee.charCodeAt(Oe-2);if(K(be))return x(be,Fe)}return Fe}class le{get offset(){return this._offset}constructor(Oe,Fe=0){this._str=Oe,this._len=Oe.length,this._offset=Fe}setOffset(Oe){this._offset=Oe}prevCodePoint(){const Oe=ne(this._str,this._offset);return this._offset-=Oe>=C.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Oe}nextCodePoint(){const Oe=z(this._str,this._len,this._offset);return this._offset+=Oe>=C.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Oe}eol(){return this._offset>=this._len}}e.CodePointIterator=le;class ve{get offset(){return this._iterator.offset}constructor(Oe,Fe=0){this._iterator=new le(Oe,Fe)}nextGraphemeLength(){const Oe=Je.getInstance(),Fe=this._iterator,be=Fe.offset;let Ae=Oe.getGraphemeBreakType(Fe.nextCodePoint());for(;!Fe.eol();){const ie=Fe.offset,ee=Oe.getGraphemeBreakType(Fe.nextCodePoint());if(je(Ae,ee)){Fe.setOffset(ie);break}Ae=ee}return Fe.offset-be}prevGraphemeLength(){const Oe=Je.getInstance(),Fe=this._iterator,be=Fe.offset;let Ae=Oe.getGraphemeBreakType(Fe.prevCodePoint());for(;Fe.offset>0;){const ie=Fe.offset,ee=Oe.getGraphemeBreakType(Fe.prevCodePoint());if(je(ee,Ae)){Fe.setOffset(ie);break}Ae=ee}return be-Fe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ve;function H(Ee,Oe){return new ve(Ee,Oe).nextGraphemeLength()}function ce(Ee,Oe){return new ve(Ee,Oe).prevGraphemeLength()}function J(Ee,Oe){Oe>0&&ae(Ee.charCodeAt(Oe))&&Oe--;const Fe=Oe+H(Ee,Oe);return[Fe-ce(Ee,Fe),Fe]}function W(Ee){const Oe=new ve(Ee);let Fe=0;for(;!Oe.eol();)Fe++,Oe.nextGraphemeLength();return Fe}let L;function Q(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function $(Ee){return L||(L=Q()),L.test(Ee)}const U=/^[\t\n\r\x20-\x7E]*$/;function q(Ee){return U.test(Ee)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function G(Ee){return e.UNUSUAL_LINE_TERMINATORS.test(Ee)}function F(Ee){return Ee>=11904&&Ee<=55215||Ee>=63744&&Ee<=64255||Ee>=65281&&Ee<=65374}function V(Ee){return Ee>=127462&&Ee<=127487||Ee===8986||Ee===8987||Ee===9200||Ee===9203||Ee>=9728&&Ee<=10175||Ee===11088||Ee===11093||Ee>=127744&&Ee<=128591||Ee>=128640&&Ee<=128764||Ee>=128992&&Ee<=129008||Ee>=129280&&Ee<=129535||Ee>=129648&&Ee<=129782}function oe(Ee,Oe,Fe=""){const be=Ee.trimStart();if(be.length<Oe)return be;const Ae=/\b/g;let ie=0;for(;Ae.test(be)&&!(be.length-Ae.lastIndex<Oe);)ie=Ae.lastIndex,Ae.lastIndex+=1;return ie===0?be:Fe+be.substring(ie).trimStart()}const de=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Ce(Ee){let Oe=0;for(const Fe of Ee.matchAll(de))Oe!==Fe.index&&(yield{isCode:!1,str:Ee.substring(Oe,Fe.index)}),yield{isCode:!0,str:Fe[0]},Oe=Fe.index+Fe[0].length;Oe!==Ee.length&&(yield{isCode:!1,str:Ee.substring(Oe)})}function Ne(Ee){return Ee&&(Ee=Ee.replace(de,"")),Ee}const ge=/\\\[.*?\\\]/g;function pe(Ee){return Ne(Ee).replace(ge,"")}e.UTF8_BOM_CHARACTER=String.fromCharCode(r.CharCode.UTF8_BOM);function Te(Ee){return!!(Ee&&Ee.length>0&&Ee.charCodeAt(0)===r.CharCode.UTF8_BOM)}function Le(Ee){return Te(Ee)?Ee.substr(1):Ee}function he(Ee,Oe){if(!Ee||!Oe||Ee.length<Oe.length)return!1;const Fe=Oe.length,be=Ee.toLowerCase();let Ae=0,ie=-1;for(;Ae<Fe;){const ee=be.indexOf(Oe[Ae],ie+1);if(ee<0)return!1;ie=ee,Ae++}return!0}function De(Ee,Oe=!1){return Ee?(Oe&&(Ee=Ee.replace(/\\./g,"")),Ee.toLowerCase()!==Ee):!1}function Re(Ee){return Ee.charAt(0).toUpperCase()+Ee.slice(1)}function xe(Ee,Oe=1){if(Oe===0)return"";let Fe=-1;do Fe=Ee.indexOf(`
`,Fe+1),Oe--;while(Oe>0&&Fe>=0);return Fe===-1?Ee:(Ee[Fe-1]==="\r"&&Fe--,Ee.substr(0,Fe))}function Ve(Ee){const Oe=r.CharCode.Z-r.CharCode.A+1;return Ee=Ee%(2*Oe),Ee<Oe?String.fromCharCode(r.CharCode.a+Ee):String.fromCharCode(r.CharCode.A+Ee-Oe)}function Xe(Ee){return Je.getInstance().getGraphemeBreakType(Ee)}function je(Ee,Oe){return Ee===qe.Other?Oe!==qe.Extend&&Oe!==qe.SpacingMark:Ee===qe.CR&&Oe===qe.LF?!1:Ee===qe.Control||Ee===qe.CR||Ee===qe.LF||Oe===qe.Control||Oe===qe.CR||Oe===qe.LF?!0:!(Ee===qe.L&&(Oe===qe.L||Oe===qe.V||Oe===qe.LV||Oe===qe.LVT)||(Ee===qe.LV||Ee===qe.V)&&(Oe===qe.V||Oe===qe.T)||(Ee===qe.LVT||Ee===qe.T)&&Oe===qe.T||Oe===qe.Extend||Oe===qe.ZWJ||Oe===qe.SpacingMark||Ee===qe.Prepend||Ee===qe.ZWJ&&Oe===qe.Extended_Pictographic||Ee===qe.Regional_Indicator&&Oe===qe.Regional_Indicator)}var qe;(function(Ee){Ee[Ee.Other=0]="Other",Ee[Ee.Prepend=1]="Prepend",Ee[Ee.CR=2]="CR",Ee[Ee.LF=3]="LF",Ee[Ee.Control=4]="Control",Ee[Ee.Extend=5]="Extend",Ee[Ee.Regional_Indicator=6]="Regional_Indicator",Ee[Ee.SpacingMark=7]="SpacingMark",Ee[Ee.L=8]="L",Ee[Ee.V=9]="V",Ee[Ee.T=10]="T",Ee[Ee.LV=11]="LV",Ee[Ee.LVT=12]="LVT",Ee[Ee.ZWJ=13]="ZWJ",Ee[Ee.Extended_Pictographic=14]="Extended_Pictographic"})(qe||(e.GraphemeBreakType=qe={}));class Je{static{this._INSTANCE=null}static getInstance(){return Je._INSTANCE||(Je._INSTANCE=new Je),Je._INSTANCE}constructor(){this._data=st()}getGraphemeBreakType(Oe){if(Oe<32)return Oe===r.CharCode.LineFeed?qe.LF:Oe===r.CharCode.CarriageReturn?qe.CR:qe.Control;if(Oe<127)return qe.Other;const Fe=this._data,be=Fe.length/3;let Ae=1;for(;Ae<=be;)if(Oe<Fe[3*Ae])Ae=2*Ae;else if(Oe>Fe[3*Ae+1])Ae=2*Ae+1;else return Fe[3*Ae+2];return qe.Other}}function st(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function lt(Ee,Oe){if(Ee===0)return 0;const Fe=rt(Ee,Oe);if(Fe!==void 0)return Fe;const be=new le(Oe,Ee);return be.prevCodePoint(),be.offset}function rt(Ee,Oe){const Fe=new le(Oe,Ee);let be=Fe.prevCodePoint();for(;it(be)||be===tt.emojiVariantSelector||be===tt.enclosingKeyCap;){if(Fe.offset===0)return;be=Fe.prevCodePoint()}if(!V(be))return;let Ae=Fe.offset;return Ae>0&&Fe.prevCodePoint()===tt.zwj&&(Ae=Fe.offset),Ae}function it(Ee){return 127995<=Ee&&Ee<=127999}var tt;(function(Ee){Ee[Ee.zwj=8205]="zwj",Ee[Ee.emojiVariantSelector=65039]="emojiVariantSelector",Ee[Ee.enclosingKeyCap=8419]="enclosingKeyCap"})(tt||(tt={})),e.noBreakWhitespace="\xA0";class et{static{this.ambiguousCharacterData=new w.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new i.LRUCachedFunction({getCacheKey:JSON.stringify},Oe=>{function Fe(Ze){const nt=new Map;for(let ut=0;ut<Ze.length;ut+=2)nt.set(Ze[ut],Ze[ut+1]);return nt}function be(Ze,nt){const ut=new Map(Ze);for(const[mt,Et]of nt)ut.set(mt,Et);return ut}function Ae(Ze,nt){if(!Ze)return nt;const ut=new Map;for(const[mt,Et]of Ze)nt.has(mt)&&ut.set(mt,Et);return ut}const ie=this.ambiguousCharacterData.value;let ee=Oe.filter(Ze=>!Ze.startsWith("_")&&Ze in ie);ee.length===0&&(ee=["_default"]);let Se;for(const Ze of ee){const nt=Fe(ie[Ze]);Se=Ae(Se,nt)}const He=Fe(ie._common),Ge=be(He,Se);return new et(Ge)})}static getInstance(Oe){return et.cache.get(Array.from(Oe))}static{this._locales=new w.Lazy(()=>Object.keys(et.ambiguousCharacterData.value).filter(Oe=>!Oe.startsWith("_")))}static getLocales(){return et._locales.value}constructor(Oe){this.confusableDictionary=Oe}isAmbiguous(Oe){return this.confusableDictionary.has(Oe)}containsAmbiguousCharacter(Oe){for(let Fe=0;Fe<Oe.length;Fe++){const be=Oe.codePointAt(Fe);if(typeof be=="number"&&this.isAmbiguous(be))return!0}return!1}getPrimaryConfusable(Oe){return this.confusableDictionary.get(Oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=et;class Qe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Qe.getRawData())),this._data}static isInvisibleCharacter(Oe){return Qe.getData().has(Oe)}static containsInvisibleCharacter(Oe){for(let Fe=0;Fe<Oe.length;Fe++){const be=Oe.codePointAt(Fe);if(typeof be=="number"&&Qe.isInvisibleCharacter(be))return!0}return!1}static get codePoints(){return Qe.getData()}}e.InvisibleCharacters=Qe}),define(ye[173],Ie([1,0,35,26,162,17]),function(se,e,i,r,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FuzzyScoreOptions=e.FuzzyScore=e.matchesPrefix=e.matchesStrictPrefix=void 0,e.or=R,e.matchesContiguousSubString=b,e.matchesSubString=o,e.isUpper=d,e.matchesCamelCase=I,e.matchesWords=T,e.matchesFuzzy=Y,e.matchesFuzzy2=X,e.anyScore=re,e.createMatches=te,e.isPatternInWord=Q,e.fuzzyScore=G,e.fuzzyScoreGracefulAggressive=oe,e.fuzzyScoreGraceful=de,C=Be(C);function R(...ge){return function(pe,Te){for(let Le=0,he=ge.length;Le<he;Le++){const De=ge[Le](pe,Te);if(De)return De}return null}}e.matchesStrictPrefix=_.bind(void 0,!1),e.matchesPrefix=_.bind(void 0,!0);function _(ge,pe,Te){if(!Te||Te.length<pe.length)return null;let Le;return ge?Le=C.startsWithIgnoreCase(Te,pe):Le=Te.indexOf(pe)===0,Le?pe.length>0?[{start:0,end:pe.length}]:[]:null}function b(ge,pe){const Te=pe.toLowerCase().indexOf(ge.toLowerCase());return Te===-1?null:[{start:Te,end:Te+ge.length}]}function o(ge,pe){return D(ge.toLowerCase(),pe.toLowerCase(),0,0)}function D(ge,pe,Te,Le){if(Te===ge.length)return[];if(Le===pe.length)return null;if(ge[Te]===pe[Le]){let he=null;return(he=D(ge,pe,Te+1,Le+1))?t({start:Le,end:Le+1},he):null}return D(ge,pe,Te,Le+1)}function y(ge){return i.CharCode.a<=ge&&ge<=i.CharCode.z}function d(ge){return i.CharCode.A<=ge&&ge<=i.CharCode.Z}function E(ge){return i.CharCode.Digit0<=ge&&ge<=i.CharCode.Digit9}function a(ge){return ge===i.CharCode.Space||ge===i.CharCode.Tab||ge===i.CharCode.LineFeed||ge===i.CharCode.CarriageReturn}const f=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ge=>f.add(ge.charCodeAt(0)));function m(ge){return a(ge)||f.has(ge)}function p(ge,pe){return ge===pe||m(ge)&&m(pe)}const S=new Map;function g(ge){if(S.has(ge))return S.get(ge);let pe;const Te=(0,w.getKoreanAltChars)(ge);return Te&&(pe=Te),S.set(ge,pe),pe}function v(ge){return y(ge)||d(ge)||E(ge)}function t(ge,pe){return pe.length===0?pe=[ge]:ge.end===pe[0].start?pe[0].start=ge.start:pe.unshift(ge),pe}function l(ge,pe){for(let Te=pe;Te<ge.length;Te++){const Le=ge.charCodeAt(Te);if(d(Le)||E(Le)||Te>0&&!v(ge.charCodeAt(Te-1)))return Te}return ge.length}function n(ge,pe,Te,Le){if(Te===ge.length)return[];if(Le===pe.length)return null;if(ge[Te]!==pe[Le].toLowerCase())return null;{let he=null,De=Le+1;for(he=n(ge,pe,Te+1,Le+1);!he&&(De=l(pe,De))<pe.length;)he=n(ge,pe,Te+1,De),De++;return he===null?null:t({start:Le,end:Le+1},he)}}function h(ge){let pe=0,Te=0,Le=0,he=0,De=0;for(let je=0;je<ge.length;je++)De=ge.charCodeAt(je),d(De)&&pe++,y(De)&&Te++,v(De)&&Le++,E(De)&&he++;const Re=pe/ge.length,xe=Te/ge.length,Ve=Le/ge.length,Xe=he/ge.length;return{upperPercent:Re,lowerPercent:xe,alphaPercent:Ve,numericPercent:Xe}}function s(ge){const{upperPercent:pe,lowerPercent:Te}=ge;return Te===0&&pe>.6}function c(ge){const{upperPercent:pe,lowerPercent:Te,alphaPercent:Le,numericPercent:he}=ge;return Te>.2&&pe<.8&&Le>.6&&he<.2}function u(ge){let pe=0,Te=0,Le=0,he=0;for(let De=0;De<ge.length;De++)Le=ge.charCodeAt(De),d(Le)&&pe++,y(Le)&&Te++,a(Le)&&he++;return(pe===0||Te===0)&&he===0?ge.length<=30:pe<=5}function I(ge,pe){if(!pe||(pe=pe.trim(),pe.length===0)||!u(ge))return null;pe.length>60&&(pe=pe.substring(0,60));const Te=h(pe);if(!c(Te)){if(!s(Te))return null;pe=pe.toLowerCase()}let Le=null,he=0;for(ge=ge.toLowerCase();he<pe.length&&(Le=n(ge,pe,0,he))===null;)he=l(pe,he+1);return Le}function T(ge,pe,Te=!1){if(!pe||pe.length===0)return null;let Le=null,he=0;for(ge=ge.toLowerCase(),pe=pe.toLowerCase();he<pe.length&&(Le=A(ge,pe,0,he,Te),Le===null);)he=O(pe,he+1);return Le}function A(ge,pe,Te,Le,he){let De=0;if(Te===ge.length)return[];if(Le===pe.length)return null;if(!p(ge.charCodeAt(Te),pe.charCodeAt(Le))){const Ve=g(ge.charCodeAt(Te));if(!Ve)return null;for(let Xe=0;Xe<Ve.length;Xe++)if(!p(Ve[Xe],pe.charCodeAt(Le+Xe)))return null;De+=Ve.length-1}let Re=null,xe=Le+De+1;if(Re=A(ge,pe,Te+1,xe,he),!he)for(;!Re&&(xe=O(pe,xe))<pe.length;)Re=A(ge,pe,Te+1,xe,he),xe++;if(!Re)return null;if(ge.charCodeAt(Te)!==pe.charCodeAt(Le)){const Ve=g(ge.charCodeAt(Te));if(!Ve)return Re;for(let Xe=0;Xe<Ve.length;Xe++)if(Ve[Xe]!==pe.charCodeAt(Le+Xe))return Re}return t({start:Le,end:Le+De+1},Re)}function O(ge,pe){for(let Te=pe;Te<ge.length;Te++)if(m(ge.charCodeAt(Te))||Te>0&&m(ge.charCodeAt(Te-1)))return Te;return ge.length}const k=R(e.matchesPrefix,I,b),P=R(e.matchesPrefix,I,o),B=new r.LRUCache(1e4);function Y(ge,pe,Te=!1){if(typeof ge!="string"||typeof pe!="string")return null;let Le=B.get(ge);Le||(Le=new RegExp(C.convertSimple2RegExpPattern(ge),"i"),B.set(ge,Le));const he=Le.exec(pe);return he?[{start:he.index,end:he.index+he[0].length}]:Te?P(ge,pe):k(ge,pe)}function X(ge,pe){const Te=G(ge,ge.toLowerCase(),0,pe,pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Te?te(Te):null}function re(ge,pe,Te,Le,he,De){const Re=Math.min(13,ge.length);for(;Te<Re;Te++){const xe=G(ge,pe,Te,Le,he,De,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(xe)return xe}return[0,De]}function te(ge){if(typeof ge>"u")return[];const pe=[],Te=ge[1];for(let Le=ge.length-1;Le>1;Le--){const he=ge[Le]+Te,De=pe[pe.length-1];De&&De.end===he?De.end=he+1:pe.push({start:he,end:he+1})}return pe}const Z=128;function fe(){const ge=[],pe=[];for(let Te=0;Te<=Z;Te++)pe[Te]=0;for(let Te=0;Te<=Z;Te++)ge.push(pe.slice(0));return ge}function K(ge){const pe=[];for(let Te=0;Te<=ge;Te++)pe[Te]=0;return pe}const ae=K(2*Z),x=K(2*Z),z=fe(),ne=fe(),le=fe(),ve=!1;function H(ge,pe,Te,Le,he){function De(xe,Ve,Xe=" "){for(;xe.length<Ve;)xe=Xe+xe;return xe}let Re=` |   |${Le.split("").map(xe=>De(xe,3)).join("|")}
`;for(let xe=0;xe<=Te;xe++)xe===0?Re+=" |":Re+=`${pe[xe-1]}|`,Re+=ge[xe].slice(0,he+1).map(Ve=>De(Ve.toString(),3)).join("|")+`
`;return Re}function ce(ge,pe,Te,Le){ge=ge.substr(pe),Te=Te.substr(Le),console.log(H(ne,ge,ge.length,Te,Te.length)),console.log(H(le,ge,ge.length,Te,Te.length)),console.log(H(z,ge,ge.length,Te,Te.length))}function J(ge,pe){if(pe<0||pe>=ge.length)return!1;const Te=ge.codePointAt(pe);switch(Te){case i.CharCode.Underline:case i.CharCode.Dash:case i.CharCode.Period:case i.CharCode.Space:case i.CharCode.Slash:case i.CharCode.Backslash:case i.CharCode.SingleQuote:case i.CharCode.DoubleQuote:case i.CharCode.Colon:case i.CharCode.DollarSign:case i.CharCode.LessThan:case i.CharCode.GreaterThan:case i.CharCode.OpenParen:case i.CharCode.CloseParen:case i.CharCode.OpenSquareBracket:case i.CharCode.CloseSquareBracket:case i.CharCode.OpenCurlyBrace:case i.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!C.isEmojiImprecise(Te)}}function W(ge,pe){if(pe<0||pe>=ge.length)return!1;switch(ge.charCodeAt(pe)){case i.CharCode.Space:case i.CharCode.Tab:return!0;default:return!1}}function L(ge,pe,Te){return pe[ge]!==Te[ge]}function Q(ge,pe,Te,Le,he,De,Re=!1){for(;pe<Te&&he<De;)ge[pe]===Le[he]&&(Re&&(ae[pe]=he),pe+=1),he+=1;return pe===Te}var $;(function(ge){ge[ge.Diag=1]="Diag",ge[ge.Left=2]="Left",ge[ge.LeftLeft=3]="LeftLeft"})($||($={}));var U;(function(ge){ge.Default=[-100,0];function pe(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}ge.isDefault=pe})(U||(e.FuzzyScore=U={}));class q{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(pe,Te){this.firstMatchCanBeWeak=pe,this.boostFullMatch=Te}}e.FuzzyScoreOptions=q;function G(ge,pe,Te,Le,he,De,Re=q.default){const xe=ge.length>Z?Z:ge.length,Ve=Le.length>Z?Z:Le.length;if(Te>=xe||De>=Ve||xe-Te>Ve-De||!Q(pe,Te,xe,he,De,Ve,!0))return;F(xe,Ve,Te,De,pe,he);let Xe=1,je=1,qe=Te,Je=De;const st=[!1];for(Xe=1,qe=Te;qe<xe;Xe++,qe++){const et=ae[qe],Qe=x[qe],Ee=qe+1<xe?x[qe+1]:Ve;for(je=et-De+1,Je=et;Je<Ee;je++,Je++){let Oe=Number.MIN_SAFE_INTEGER,Fe=!1;Je<=Qe&&(Oe=V(ge,pe,qe,Te,Le,he,Je,Ve,De,z[Xe-1][je-1]===0,st));let be=0;Oe!==Number.MAX_SAFE_INTEGER&&(Fe=!0,be=Oe+ne[Xe-1][je-1]);const Ae=Je>et,ie=Ae?ne[Xe][je-1]+(z[Xe][je-1]>0?-5:0):0,ee=Je>et+1&&z[Xe][je-1]>0,Se=ee?ne[Xe][je-2]+(z[Xe][je-2]>0?-5:0):0;if(ee&&(!Ae||Se>=ie)&&(!Fe||Se>=be))ne[Xe][je]=Se,le[Xe][je]=$.LeftLeft,z[Xe][je]=0;else if(Ae&&(!Fe||ie>=be))ne[Xe][je]=ie,le[Xe][je]=$.Left,z[Xe][je]=0;else if(Fe)ne[Xe][je]=be,le[Xe][je]=$.Diag,z[Xe][je]=z[Xe-1][je-1]+1;else throw new Error("not possible")}}if(ve&&ce(ge,Te,Le,De),!st[0]&&!Re.firstMatchCanBeWeak)return;Xe--,je--;const lt=[ne[Xe][je],De];let rt=0,it=0;for(;Xe>=1;){let et=je;do{const Qe=le[Xe][et];if(Qe===$.LeftLeft)et=et-2;else if(Qe===$.Left)et=et-1;else break}while(et>=1);rt>1&&pe[Te+Xe-1]===he[De+je-1]&&!L(et+De-1,Le,he)&&rt+1>z[Xe][et]&&(et=je),et===je?rt++:rt=1,it||(it=et),Xe--,je=et-1,lt.push(je)}Ve-De===xe&&Re.boostFullMatch&&(lt[0]+=2);const tt=it-xe;return lt[0]-=tt,lt}function F(ge,pe,Te,Le,he,De){let Re=ge-1,xe=pe-1;for(;Re>=Te&&xe>=Le;)he[Re]===De[xe]&&(x[Re]=xe,Re--),xe--}function V(ge,pe,Te,Le,he,De,Re,xe,Ve,Xe,je){if(pe[Te]!==De[Re])return Number.MIN_SAFE_INTEGER;let qe=1,Je=!1;return Re===Te-Le?qe=ge[Te]===he[Re]?7:5:L(Re,he,De)&&(Re===0||!L(Re-1,he,De))?(qe=ge[Te]===he[Re]?7:5,Je=!0):J(De,Re)&&(Re===0||!J(De,Re-1))?qe=5:(J(De,Re-1)||W(De,Re-1))&&(qe=5,Je=!0),qe>1&&Te===Le&&(je[0]=!0),Je||(Je=L(Re,he,De)||J(De,Re-1)||W(De,Re-1)),Te===Le?Re>Ve&&(qe-=Je?3:5):Xe?qe+=Je?2:0:qe+=Je?0:1,Re+1===xe&&(qe-=Je?3:5),qe}function oe(ge,pe,Te,Le,he,De,Re){return Ce(ge,pe,Te,Le,he,De,!0,Re)}function de(ge,pe,Te,Le,he,De,Re){return Ce(ge,pe,Te,Le,he,De,!1,Re)}function Ce(ge,pe,Te,Le,he,De,Re,xe){let Ve=G(ge,pe,Te,Le,he,De,xe);if(Ve&&!Re)return Ve;if(ge.length>=3){const Xe=Math.min(7,ge.length-1);for(let je=Te+1;je<Xe;je++){const qe=Ne(ge,je);if(qe){const Je=G(qe,qe.toLowerCase(),Te,Le,he,De,xe);Je&&(Je[0]-=3,(!Ve||Je[0]>Ve[0])&&(Ve=Je))}}}return Ve}function Ne(ge,pe){if(pe+1>=ge.length)return;const Te=ge[pe],Le=ge[pe+1];if(Te!==Le)return ge.slice(0,pe)+Le+Te+ge.slice(pe+2)}}),define(ye[66],Ie([1,0,17]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=r,e.doHash=w,e.numberHash=C,e.stringHash=_,e.toHexString=f,i=Be(i);function r(p){return w(p,0)}function w(p,S){switch(typeof p){case"object":return p===null?C(349,S):Array.isArray(p)?b(p,S):o(p,S);case"string":return _(p,S);case"boolean":return R(p,S);case"number":return C(p,S);case"undefined":return C(937,S);default:return C(617,S)}}function C(p,S){return(S<<5)-S+p|0}function R(p,S){return C(p?433:863,S)}function _(p,S){S=C(149417,S);for(let g=0,v=p.length;g<v;g++)S=C(p.charCodeAt(g),S);return S}function b(p,S){return S=C(104579,S),p.reduce((g,v)=>w(v,g),S)}function o(p,S){return S=C(181387,S),Object.keys(p).sort().reduce((g,v)=>(g=_(v,g),w(p[v],g)),S)}class D{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=w(S,this._value),this._value}}e.Hasher=D;var y;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function d(p,S,g=32){const v=g-S,t=~((1<<v)-1);return(p<<S|(t&p)>>>v)>>>0}function E(p,S=0,g=p.byteLength,v=0){for(let t=0;t<g;t++)p[S+t]=v}function a(p,S,g="0"){for(;p.length<S;)p=g+p;return p}function f(p,S=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(g=>g.toString(16).padStart(2,"0")).join(""):a((p>>>0).toString(16),S/4)}class m{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(y.BLOCK_SIZE+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const g=S.length;if(g===0)return;const v=this._buff;let t=this._buffLen,l=this._leftoverHighSurrogate,n,h;for(l!==0?(n=l,h=-1,l=0):(n=S.charCodeAt(0),h=0);;){let s=n;if(i.isHighSurrogate(n))if(h+1<g){const c=S.charCodeAt(h+1);i.isLowSurrogate(c)?(h++,s=i.computeCodePoint(n,c)):s=y.UNICODE_REPLACEMENT}else{l=n;break}else i.isLowSurrogate(n)&&(s=y.UNICODE_REPLACEMENT);if(t=this._push(v,t,s),h++,h<g)n=S.charCodeAt(h);else break}this._buffLen=t,this._leftoverHighSurrogate=l}_push(S,g,v){return v<128?S[g++]=v:v<2048?(S[g++]=192|(v&1984)>>>6,S[g++]=128|(v&63)>>>0):v<65536?(S[g++]=224|(v&61440)>>>12,S[g++]=128|(v&4032)>>>6,S[g++]=128|(v&63)>>>0):(S[g++]=240|(v&1835008)>>>18,S[g++]=128|(v&258048)>>>12,S[g++]=128|(v&4032)>>>6,S[g++]=128|(v&63)>>>0),g>=y.BLOCK_SIZE&&(this._step(),g-=y.BLOCK_SIZE,this._totalLen+=y.BLOCK_SIZE,S[0]=S[y.BLOCK_SIZE+0],S[1]=S[y.BLOCK_SIZE+1],S[2]=S[y.BLOCK_SIZE+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,y.UNICODE_REPLACEMENT)),this._totalLen+=this._buffLen,this._wrapUp()),f(this._h0)+f(this._h1)+f(this._h2)+f(this._h3)+f(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,E(this._buff,this._buffLen),this._buffLen>56&&(this._step(),E(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=m._bigBlock32,g=this._buffDV;for(let I=0;I<64;I+=4)S.setUint32(I,g.getUint32(I,!1),!1);for(let I=64;I<320;I+=4)S.setUint32(I,d(S.getUint32(I-12,!1)^S.getUint32(I-32,!1)^S.getUint32(I-56,!1)^S.getUint32(I-64,!1),1),!1);let v=this._h0,t=this._h1,l=this._h2,n=this._h3,h=this._h4,s,c,u;for(let I=0;I<80;I++)I<20?(s=t&l|~t&n,c=1518500249):I<40?(s=t^l^n,c=1859775393):I<60?(s=t&l|t&n|l&n,c=2400959708):(s=t^l^n,c=3395469782),u=d(v,5)+s+h+c+S.getUint32(I*4,!1)&4294967295,h=n,n=l,l=d(t,30),t=v,v=u;this._h0=this._h0+v&4294967295,this._h1=this._h1+t&4294967295,this._h2=this._h2+l&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+h&4294967295}}e.StringSHA1=m}),define(ye[174],Ie([1,0,173,17,82]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.escapeIcons=b,e.markdownEscapeEscapedIcons=D,e.stripIcons=d,e.getCodiconAriaLabel=E,e.parseLabelWithIcons=f,e.matchesFuzzyIconAware=m;const C="$(",R=new RegExp(`\\$\\(${w.ThemeIcon.iconNameExpression}(?:${w.ThemeIcon.iconModifierExpression})?\\)`,"g"),_=new RegExp(`(\\\\)?${R.source}`,"g");function b(p){return p.replace(_,(S,g)=>g?S:`\\${S}`)}const o=new RegExp(`\\\\${R.source}`,"g");function D(p){return p.replace(o,S=>`\\${S}`)}const y=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function d(p){return p.indexOf(C)===-1?p:p.replace(y,(S,g,v,t)=>v?S:g||t||"")}function E(p){return p?p.replace(/\$\((.*?)\)/g,(S,g)=>` ${g} `).trim():""}const a=new RegExp(`\\$\\(${w.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(p){a.lastIndex=0;let S="";const g=[];let v=0;for(;;){const t=a.lastIndex,l=a.exec(p),n=p.substring(t,l?.index);if(n.length>0){S+=n;for(let h=0;h<n.length;h++)g.push(v)}if(!l)break;v+=l[0].length}return{text:S,iconOffsets:g}}function m(p,S,g=!1){const{text:v,iconOffsets:t}=S;if(!t||t.length===0)return(0,i.matchesFuzzy)(p,v,g);const l=(0,r.ltrim)(v," "),n=v.length-l.length,h=(0,i.matchesFuzzy)(p,l,g);if(h)for(const s of h){const c=t[s.start+n]+n;s.start+=c,s.end+=c}return h}}),define(ye[58],Ie([1,0,17]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),i=Be(i);var r;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(r||(r={})),function(w){const C="error",R="warning",_="warn",b="info",o="ignore";function D(d){return d?i.equalsIgnoreCase(C,d)?w.Error:i.equalsIgnoreCase(R,d)||i.equalsIgnoreCase(_,d)?w.Warning:i.equalsIgnoreCase(b,d)?w.Info:w.Ignore:w.Ignore}w.fromValue=D;function y(d){switch(d){case w.Error:return C;case w.Warning:return R;case w.Info:return b;default:return o}}w.toString=y}(r||(r={})),e.default=r}),define(ye[67],Ie([1,0,18,35,17]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class C{constructor(){this._value="",this._pos=0}reset(a){return this._value=a,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(a){const f=a.charCodeAt(0),m=this._value.charCodeAt(this._pos);return f-m}value(){return this._value[this._pos]}}e.StringIterator=C;class R{constructor(a=!0){this._caseSensitive=a}reset(a){return this._value=a,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let a=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===r.CharCode.Period)if(a)this._from++;else break;else a=!1;return this}cmp(a){return this._caseSensitive?(0,w.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,w.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=R;class _{constructor(a=!0,f=!0){this._splitOnBackslash=a,this._caseSensitive=f}reset(a){this._from=0,this._to=0,this._value=a,this._valueLen=a.length;for(let f=a.length-1;f>=0;f--,this._valueLen--){const m=this._value.charCodeAt(f);if(!(m===r.CharCode.Slash||this._splitOnBackslash&&m===r.CharCode.Backslash))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let a=!0;for(;this._to<this._valueLen;this._to++){const f=this._value.charCodeAt(this._to);if(f===r.CharCode.Slash||this._splitOnBackslash&&f===r.CharCode.Backslash)if(a)this._from++;else break;else a=!1}return this}cmp(a){return this._caseSensitive?(0,w.compareSubstring)(a,this._value,0,a.length,this._from,this._to):(0,w.compareSubstringIgnoreCase)(a,this._value,0,a.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=_;var b;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(b||(b={}));class o{constructor(a,f){this._ignorePathCasing=a,this._ignoreQueryAndFragment=f,this._states=[],this._stateIdx=0}reset(a){return this._value=a,this._states=[],this._value.scheme&&this._states.push(b.Scheme),this._value.authority&&this._states.push(b.Authority),this._value.path&&(this._pathIterator=new _(!1,!this._ignorePathCasing(a)),this._pathIterator.reset(a.path),this._pathIterator.value()&&this._states.push(b.Path)),this._ignoreQueryAndFragment(a)||(this._value.query&&this._states.push(b.Query),this._value.fragment&&this._states.push(b.Fragment)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===b.Path&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===b.Path&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(a){if(this._states[this._stateIdx]===b.Scheme)return(0,w.compareIgnoreCase)(a,this._value.scheme);if(this._states[this._stateIdx]===b.Authority)return(0,w.compareIgnoreCase)(a,this._value.authority);if(this._states[this._stateIdx]===b.Path)return this._pathIterator.cmp(a);if(this._states[this._stateIdx]===b.Query)return(0,w.compare)(a,this._value.query);if(this._states[this._stateIdx]===b.Fragment)return(0,w.compare)(a,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===b.Scheme)return this._value.scheme;if(this._states[this._stateIdx]===b.Authority)return this._value.authority;if(this._states[this._stateIdx]===b.Path)return this._pathIterator.value();if(this._states[this._stateIdx]===b.Query)return this._value.query;if(this._states[this._stateIdx]===b.Fragment)return this._value.fragment;throw new Error}}e.UriIterator=o;class D{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(y||(y={}));class d{static forUris(a=()=>!1,f=()=>!1){return new d(new o(a,f))}static forPaths(a=!1){return new d(new _(void 0,!a))}static forStrings(){return new d(new C)}static forConfigKeys(){return new d(new R)}constructor(a){this._iter=a}clear(){this._root=void 0}fill(a,f){if(f){const m=f.slice(0);(0,i.shuffle)(m);for(const p of m)this.set(p,a)}else{const m=a.slice(0);(0,i.shuffle)(m);for(const p of m)this.set(p[0],p[1])}}set(a,f){const m=this._iter.reset(a);let p;this._root||(this._root=new D,this._root.segment=m.value());const S=[];for(p=this._root;;){const v=m.cmp(p.segment);if(v>0)p.left||(p.left=new D,p.left.segment=m.value()),S.push([y.Left,p]),p=p.left;else if(v<0)p.right||(p.right=new D,p.right.segment=m.value()),S.push([y.Right,p]),p=p.right;else if(m.hasNext())m.next(),p.mid||(p.mid=new D,p.mid.segment=m.value()),S.push([y.Mid,p]),p=p.mid;else break}const g=p.value;p.value=f,p.key=a;for(let v=S.length-1;v>=0;v--){const t=S[v][1];t.updateHeight();const l=t.balanceFactor();if(l<-1||l>1){const n=S[v][0],h=S[v+1][0];if(n===y.Right&&h===y.Right)S[v][1]=t.rotateLeft();else if(n===y.Left&&h===y.Left)S[v][1]=t.rotateRight();else if(n===y.Right&&h===y.Left)t.right=S[v+1][1]=S[v+1][1].rotateRight(),S[v][1]=t.rotateLeft();else if(n===y.Left&&h===y.Right)t.left=S[v+1][1]=S[v+1][1].rotateLeft(),S[v][1]=t.rotateRight();else throw new Error;if(v>0)switch(S[v-1][0]){case y.Left:S[v-1][1].left=S[v][1];break;case y.Right:S[v-1][1].right=S[v][1];break;case y.Mid:S[v-1][1].mid=S[v][1];break}else this._root=S[0][1]}}return g}get(a){return this._getNode(a)?.value}_getNode(a){const f=this._iter.reset(a);let m=this._root;for(;m;){const p=f.cmp(m.segment);if(p>0)m=m.left;else if(p<0)m=m.right;else if(f.hasNext())f.next(),m=m.mid;else break}return m}has(a){const f=this._getNode(a);return!(f?.value===void 0&&f?.mid===void 0)}delete(a){return this._delete(a,!1)}deleteSuperstr(a){return this._delete(a,!0)}_delete(a,f){const m=this._iter.reset(a),p=[];let S=this._root;for(;S;){const g=m.cmp(S.segment);if(g>0)p.push([y.Left,S]),S=S.left;else if(g<0)p.push([y.Right,S]),S=S.right;else if(m.hasNext())m.next(),p.push([y.Mid,S]),S=S.mid;else break}if(S){if(f?(S.left=void 0,S.mid=void 0,S.right=void 0,S.height=1):(S.key=void 0,S.value=void 0),!S.mid&&!S.value)if(S.left&&S.right){const g=this._min(S.right);if(g.key){const{key:v,value:t,segment:l}=g;this._delete(g.key,!1),S.key=v,S.value=t,S.segment=l}}else{const g=S.left??S.right;if(p.length>0){const[v,t]=p[p.length-1];switch(v){case y.Left:t.left=g;break;case y.Mid:t.mid=g;break;case y.Right:t.right=g;break}}else this._root=g}for(let g=p.length-1;g>=0;g--){const v=p[g][1];v.updateHeight();const t=v.balanceFactor();if(t>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),p[g][1]=v.rotateLeft()):t<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),p[g][1]=v.rotateRight()),g>0)switch(p[g-1][0]){case y.Left:p[g-1][1].left=p[g][1];break;case y.Right:p[g-1][1].right=p[g][1];break;case y.Mid:p[g-1][1].mid=p[g][1];break}else this._root=p[0][1]}}}_min(a){for(;a.left;)a=a.left;return a}findSubstr(a){const f=this._iter.reset(a);let m=this._root,p;for(;m;){const S=f.cmp(m.segment);if(S>0)m=m.left;else if(S<0)m=m.right;else if(f.hasNext())f.next(),p=m.value||p,m=m.mid;else break}return m&&m.value||p}findSuperstr(a){return this._findSuperstrOrElement(a,!1)}_findSuperstrOrElement(a,f){const m=this._iter.reset(a);let p=this._root;for(;p;){const S=m.cmp(p.segment);if(S>0)p=p.left;else if(S<0)p=p.right;else if(m.hasNext())m.next(),p=p.mid;else return p.mid?this._entries(p.mid):f?p.value:void 0}}hasElementOrSubtree(a){return this._findSuperstrOrElement(a,!0)!==void 0}forEach(a){for(const[f,m]of this)a(m,f)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(a){const f=[];return this._dfsEntries(a,f),f[Symbol.iterator]()}_dfsEntries(a,f){a&&(a.left&&this._dfsEntries(a.left,f),a.value&&f.push([a.key,a.value]),a.mid&&this._dfsEntries(a.mid,f),a.right&&this._dfsEntries(a.right,f))}_isBalanced(){const a=f=>{if(!f)return!0;const m=f.balanceFactor();return m<-1||m>1?!1:a(f.left)&&a(f.right)};return a(this._root)}}e.TernarySearchTree=d}),define(ye[23],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=r;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(w){return i.test(w)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let w;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?w=crypto.getRandomValues.bind(crypto):w=function(_){for(let b=0;b<_.length;b++)_[b]=Math.floor(Math.random()*256);return _};const C=new Uint8Array(16),R=[];for(let _=0;_<256;_++)R.push(_.toString(16).padStart(2,"0"));return function(){w(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let b=0,o="";return o+=R[C[b++]],o+=R[C[b++]],o+=R[C[b++]],o+=R[C[b++]],o+="-",o+=R[C[b++]],o+=R[C[b++]],o+="-",o+=R[C[b++]],o+=R[C[b++]],o+="-",o+=R[C[b++]],o+=R[C[b++]],o+="-",o+=R[C[b++]],o+=R[C[b++]],o+=R[C[b++]],o+=R[C[b++]],o+=R[C[b++]],o+=R[C[b++]],o}}()}),define(ye[175],Ie([1,0,18,40,23]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=void 0,e.createStringDataTransferItem=C,e.createFileDataTransferItem=R,e.matchesMimeType=o;function C(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function R(y,d,E){const a={id:(0,w.generateUuid)(),name:y,uri:d,data:E};return{asString:async()=>"",asFile:()=>a,value:void 0}}class _{constructor(){this._entries=new Map}get size(){let d=0;for(const E of this._entries)d++;return d}has(d){return this._entries.has(this.toKey(d))}matches(d){const E=[...this._entries.keys()];return r.Iterable.some(this,([a,f])=>f.asFile())&&E.push("files"),D(b(d),E)}get(d){return this._entries.get(this.toKey(d))?.[0]}append(d,E){const a=this._entries.get(d);a?a.push(E):this._entries.set(this.toKey(d),[E])}replace(d,E){this._entries.set(this.toKey(d),[E])}delete(d){this._entries.delete(this.toKey(d))}*[Symbol.iterator](){for(const[d,E]of this._entries)for(const a of E)yield[d,a]}toKey(d){return b(d)}}e.VSDataTransfer=_;function b(y){return y.toLowerCase()}function o(y,d){return D(b(y),d.map(b))}function D(y,d){if(y==="*/*")return d.length>0;if(d.includes(y))return!0;const E=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[a,f,m]=E;return m==="*"?d.some(p=>p.startsWith(f+"/")):!1}e.UriList=Object.freeze({create:y=>(0,i.distinct)(y.map(d=>d.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.UriList.split(y).filter(d=>!d.startsWith("#"))})}),function(){"use strict";function se(e,i,r){function w(E){return new Promise(a=>i.exists(E,a))}function C(E){return new Promise((a,f)=>{const m=new Date;i.utimes(E,m,m,p=>p?f(p):a())})}function R(E){return new Promise((a,f)=>i.mkdir(E,{recursive:!0},m=>m&&m.code!=="EEXIST"?f(m):a(E)))}function _(E){return new Promise((a,f)=>i.rm(E,{recursive:!0,force:!0,maxRetries:3},m=>m?f(m):a()))}function b(E){return new Promise((a,f)=>i.readFile(E,"utf8",(m,p)=>m?f(m):a(p)))}function o(E,a){return new Promise((f,m)=>i.writeFile(E,a,"utf8",p=>p?m(p):f()))}async function D(E){const a=e.join(E,"languagepacks.json");try{return JSON.parse(await b(a))}catch{}}function y(E,a){try{for(;a;){if(E[a])return a;{const f=a.lastIndexOf("-");if(f>0)a=a.substring(0,f);else return}}}catch(f){console.error("Resolving language pack configuration failed.",f)}}function d(E,a,f,m,p){const S=function(v){return r.mark("code/didGenerateNls"),Promise.resolve({locale:v,osLocale:p,availableLanguages:{}})};if(r.mark("code/willGenerateNls"),m==="pseudo")return Promise.resolve({locale:m,osLocale:p,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:m,osLocale:p,availableLanguages:{}});if(m&&(m==="en"||m==="en-us"))return Promise.resolve({locale:m,osLocale:p,availableLanguages:{}});const g=m;try{return E?D(a).then(v=>{if(!v)return S(g);const t=y(v,m);if(!t)return S(g);m=t;const l=v[m];let n;return!l||typeof l.hash!="string"||!l.translations||typeof(n=l.translations.vscode)!="string"?S(g):w(n).then(h=>{if(!h)return S(g);const s=l.hash+"."+m,c=e.join(a,"clp",s),u=e.join(c,E),I=e.join(c,"tcf.json"),T=e.join(c,"corrupted.info"),A={locale:g,osLocale:p,availableLanguages:{"*":m},_languagePackId:s,_translationsConfigFile:I,_cacheRoot:c,_resolvedLanguagePackCoreLocation:u,_corruptedFile:T};return w(T).then(O=>{let k;return O?k=_(c):k=Promise.resolve(void 0),k.then(()=>w(u).then(P=>P?(C(u).catch(()=>{}),r.mark("code/didGenerateNls"),A):R(u).then(()=>Promise.all([b(f),b(n)])).then(B=>{const Y=JSON.parse(B[0]),X=JSON.parse(B[1]).contents,re=Object.keys(Y.bundles),te=[];for(const Z of re){const fe=Y.bundles[Z],K=Object.create(null);for(const ae of fe){const x=Y.keys[ae],z=Y.messages[ae],ne=X[ae];let le;if(ne){le=[];for(let ve=0;ve<x.length;ve++){const H=x[ve],ce=typeof H=="string"?H:H.key;let J=ne[ce];J===void 0&&(J=z[ve]),le.push(J)}}else le=z;K[ae]=le}te.push(o(e.join(u,Z.replace(/\//g,"!")+".nls.json"),JSON.stringify(K)))}return te.push(o(I,JSON.stringify(l.translations))),Promise.all(te)}).then(()=>(r.mark("code/didGenerateNls"),A)).catch(B=>(console.error("Generating translation files failed.",B),S(m)))))})})}):S(g)}catch(v){return console.error("Generating translation files failed.",v),S(m)}}return{getNLSConfiguration:d}}if(typeof define=="function")define(ye[176],Ie([83,31,44]),function(e,i,r){return se(e,i,r)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),i=require("fs"),r=require("../common/performance");module.exports=se(e,i,r)}else throw new Error("Unknown context")}(),define(ye[177],Ie([1,0,32]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=C;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function w(R){const _=R.replace(/\-/g,":").toLowerCase();return!r.has(_)}function C(){const R=(0,i.networkInterfaces)();for(const _ in R){const b=R[_];if(b){for(const{mac:o}of b)if(w(o))return o}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ye[178],Ie([1,0,84]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BROWSER_RESTRICTED_PORTS=void 0,e.findFreePort=r,e.findFreePortFaster=C,i=Be(i);function r(_,b,o,D=1){let y=!1;return new Promise(d=>{const E=setTimeout(()=>{if(!y)return y=!0,d(0)},o);w(_,b,D,a=>{if(!y)return y=!0,clearTimeout(E),d(a)})})}function w(_,b,o,D){if(b===0)return D(0);const y=new i.Socket;y.once("connect",()=>(R(y),w(_+o,b-1,o,D))),y.once("data",()=>{}),y.once("error",d=>(R(y),d.code!=="ECONNREFUSED"?w(_+o,b-1,o,D):D(_))),y.connect(_,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(_,b,o,D="127.0.0.1"){let y=!1,d,E=1;const a=i.createServer({pauseOnConnect:!0});function f(m,p){y||(y=!0,a.removeAllListeners(),a.close(),d&&clearTimeout(d),p(m))}return new Promise(m=>{d=setTimeout(()=>{f(0,m)},o),a.on("listening",()=>{f(_,m)}),a.on("error",p=>{p&&(p.code==="EADDRINUSE"||p.code==="EACCES")&&E<b?(_++,E++,a.listen(_,D)):f(0,m)}),a.on("close",()=>{f(0,m)}),a.listen(_,D)})}function R(_){try{_.removeAllListeners("connect"),_.removeAllListeners("error"),_.end(),_.destroy(),_.unref()}catch(b){console.error(b)}}}),function(){function se(){function e(){return process.uncHostAllowlist}function i(b){const o=new Set;if(Array.isArray(b))for(const D of b)typeof D=="string"&&o.add(D);return Array.from(o)}function r(){const b=e();return b?Array.from(b):[]}function w(b){if(process.platform!=="win32")return;const o=e();if(o)if(typeof b=="string")o.add(b.toLowerCase());else for(const D of i(b))w(D)}function C(b){if(typeof b!="string")return;const o=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let D;for(const y of o){if(b.indexOf(y)!==0)continue;const E=b.indexOf("\\",y.length);if(E===-1)continue;const a=b.substring(y.length,E);if(a){D=a;break}}return D}function R(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function _(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:r,addUNCHostToAllowlist:w,getUNCHost:C,disableUNCAccessRestrictions:R,isUNCAccessRestrictionsDisabled:_}}typeof define=="function"?define("vs/base/node/unc",[],function(){return se()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=se():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ye[85],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class i{constructor(w,C){this.lineNumber=w,this.column=C}with(w=this.lineNumber,C=this.column){return w===this.lineNumber&&C===this.column?this:new i(w,C)}delta(w=0,C=0){return this.with(this.lineNumber+w,this.column+C)}equals(w){return i.equals(this,w)}static equals(w,C){return!w&&!C?!0:!!w&&!!C&&w.lineNumber===C.lineNumber&&w.column===C.column}isBefore(w){return i.isBefore(this,w)}static isBefore(w,C){return w.lineNumber<C.lineNumber?!0:C.lineNumber<w.lineNumber?!1:w.column<C.column}isBeforeOrEqual(w){return i.isBeforeOrEqual(this,w)}static isBeforeOrEqual(w,C){return w.lineNumber<C.lineNumber?!0:C.lineNumber<w.lineNumber?!1:w.column<=C.column}static compare(w,C){const R=w.lineNumber|0,_=C.lineNumber|0;if(R===_){const b=w.column|0,o=C.column|0;return b-o}return R-_}clone(){return new i(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(w){return new i(w.lineNumber,w.column)}static isIPosition(w){return w&&typeof w.lineNumber=="number"&&typeof w.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.Position=i}),define(ye[49],Ie([1,0,85]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class r{constructor(C,R,_,b){C>_||C===_&&R>b?(this.startLineNumber=_,this.startColumn=b,this.endLineNumber=C,this.endColumn=R):(this.startLineNumber=C,this.startColumn=R,this.endLineNumber=_,this.endColumn=b)}isEmpty(){return r.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return r.containsPosition(this,C)}static containsPosition(C,R){return!(R.lineNumber<C.startLineNumber||R.lineNumber>C.endLineNumber||R.lineNumber===C.startLineNumber&&R.column<C.startColumn||R.lineNumber===C.endLineNumber&&R.column>C.endColumn)}static strictContainsPosition(C,R){return!(R.lineNumber<C.startLineNumber||R.lineNumber>C.endLineNumber||R.lineNumber===C.startLineNumber&&R.column<=C.startColumn||R.lineNumber===C.endLineNumber&&R.column>=C.endColumn)}containsRange(C){return r.containsRange(this,C)}static containsRange(C,R){return!(R.startLineNumber<C.startLineNumber||R.endLineNumber<C.startLineNumber||R.startLineNumber>C.endLineNumber||R.endLineNumber>C.endLineNumber||R.startLineNumber===C.startLineNumber&&R.startColumn<C.startColumn||R.endLineNumber===C.endLineNumber&&R.endColumn>C.endColumn)}strictContainsRange(C){return r.strictContainsRange(this,C)}static strictContainsRange(C,R){return!(R.startLineNumber<C.startLineNumber||R.endLineNumber<C.startLineNumber||R.startLineNumber>C.endLineNumber||R.endLineNumber>C.endLineNumber||R.startLineNumber===C.startLineNumber&&R.startColumn<=C.startColumn||R.endLineNumber===C.endLineNumber&&R.endColumn>=C.endColumn)}plusRange(C){return r.plusRange(this,C)}static plusRange(C,R){let _,b,o,D;return R.startLineNumber<C.startLineNumber?(_=R.startLineNumber,b=R.startColumn):R.startLineNumber===C.startLineNumber?(_=R.startLineNumber,b=Math.min(R.startColumn,C.startColumn)):(_=C.startLineNumber,b=C.startColumn),R.endLineNumber>C.endLineNumber?(o=R.endLineNumber,D=R.endColumn):R.endLineNumber===C.endLineNumber?(o=R.endLineNumber,D=Math.max(R.endColumn,C.endColumn)):(o=C.endLineNumber,D=C.endColumn),new r(_,b,o,D)}intersectRanges(C){return r.intersectRanges(this,C)}static intersectRanges(C,R){let _=C.startLineNumber,b=C.startColumn,o=C.endLineNumber,D=C.endColumn;const y=R.startLineNumber,d=R.startColumn,E=R.endLineNumber,a=R.endColumn;return _<y?(_=y,b=d):_===y&&(b=Math.max(b,d)),o>E?(o=E,D=a):o===E&&(D=Math.min(D,a)),_>o||_===o&&b>D?null:new r(_,b,o,D)}equalsRange(C){return r.equalsRange(this,C)}static equalsRange(C,R){return!C&&!R?!0:!!C&&!!R&&C.startLineNumber===R.startLineNumber&&C.startColumn===R.startColumn&&C.endLineNumber===R.endLineNumber&&C.endColumn===R.endColumn}getEndPosition(){return r.getEndPosition(this)}static getEndPosition(C){return new i.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return r.getStartPosition(this)}static getStartPosition(C){return new i.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,R){return new r(this.startLineNumber,this.startColumn,C,R)}setStartPosition(C,R){return new r(C,R,this.endLineNumber,this.endColumn)}collapseToStart(){return r.collapseToStart(this)}static collapseToStart(C){return new r(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}collapseToEnd(){return r.collapseToEnd(this)}static collapseToEnd(C){return new r(C.endLineNumber,C.endColumn,C.endLineNumber,C.endColumn)}delta(C){return new r(this.startLineNumber+C,this.startColumn,this.endLineNumber+C,this.endColumn)}static fromPositions(C,R=C){return new r(C.lineNumber,C.column,R.lineNumber,R.column)}static lift(C){return C?new r(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,R){return!(C.endLineNumber<R.startLineNumber||C.endLineNumber===R.startLineNumber&&C.endColumn<R.startColumn||R.endLineNumber<C.startLineNumber||R.endLineNumber===C.startLineNumber&&R.endColumn<C.startColumn)}static areIntersecting(C,R){return!(C.endLineNumber<R.startLineNumber||C.endLineNumber===R.startLineNumber&&C.endColumn<=R.startColumn||R.endLineNumber<C.startLineNumber||R.endLineNumber===C.startLineNumber&&R.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,R){if(C&&R){const o=C.startLineNumber|0,D=R.startLineNumber|0;if(o===D){const y=C.startColumn|0,d=R.startColumn|0;if(y===d){const E=C.endLineNumber|0,a=R.endLineNumber|0;if(E===a){const f=C.endColumn|0,m=R.endColumn|0;return f-m}return E-a}return y-d}return o-D}return(C?1:0)-(R?1:0)}static compareRangesUsingEnds(C,R){return C.endLineNumber===R.endLineNumber?C.endColumn===R.endColumn?C.startLineNumber===R.startLineNumber?C.startColumn-R.startColumn:C.startLineNumber-R.startLineNumber:C.endColumn-R.endColumn:C.endLineNumber-R.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}toJSON(){return this}}e.Range=r}),define(ye[179],Ie([1,0,49]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditOperation=void 0;class r{static insert(C,R){return{range:new i.Range(C.lineNumber,C.column,C.lineNumber,C.column),text:R,forceMoveMarkers:!0}}static delete(C){return{range:C,text:null}}static replace(C,R){return{range:C,text:R}}static replaceMove(C,R){return{range:C,text:R,forceMoveMarkers:!0}}}e.EditOperation=r}),define(ye[180],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[181],Ie([1,0,40,2,80]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.ensureValidWordDefinition=R,e.setDefaultGetWordAtTextConfig=b,e.getWordAtText=o,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function C(y=""){let d="(-?\\d*\\.\\d\\w*)|([^";for(const E of e.USUAL_WORD_SEPARATORS)y.indexOf(E)>=0||(d+="\\"+E);return d+="\\s]+)",new RegExp(d,"g")}e.DEFAULT_WORD_REGEXP=C();function R(y){let d=e.DEFAULT_WORD_REGEXP;if(y&&y instanceof RegExp)if(y.global)d=y;else{let E="g";y.ignoreCase&&(E+="i"),y.multiline&&(E+="m"),y.unicode&&(E+="u"),d=new RegExp(y.source,E)}return d.lastIndex=0,d}const _=new w.LinkedList;_.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function b(y){const d=_.unshift(y);return(0,r.toDisposable)(d)}function o(y,d,E,a,f){if(d=R(d),f||(f=i.Iterable.first(_)),E.length>f.maxLen){let v=y-f.maxLen/2;return v<0?v=0:a+=v,E=E.substring(v,y+f.maxLen/2),o(y,d,E,a,f)}const m=Date.now(),p=y-1-a;let S=-1,g=null;for(let v=1;!(Date.now()-m>=f.timeBudget);v++){const t=p-f.windowSize*v;d.lastIndex=Math.max(0,t);const l=D(d,E,p,S);if(!l&&g||(g=l,t<=0))break;S=t}if(g){const v={word:g[0],startColumn:a+1+g.index,endColumn:a+1+g.index+g[0].length};return d.lastIndex=0,v}return null}function D(y,d,E,a){let f;for(;f=y.exec(d);){const m=f.index||0;if(m<=E&&y.lastIndex>=E)return f;if(a>0&&m>a)return null}return null}}),define(ye[110],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var i;(function(b){b[b.Null=0]="Null",b[b.PlainText=1]="PlainText"})(i||(e.LanguageId=i={}));var r;(function(b){b[b.NotSet=-1]="NotSet",b[b.None=0]="None",b[b.Italic=1]="Italic",b[b.Bold=2]="Bold",b[b.Underline=4]="Underline",b[b.Strikethrough=8]="Strikethrough"})(r||(e.FontStyle=r={}));var w;(function(b){b[b.None=0]="None",b[b.DefaultForeground=1]="DefaultForeground",b[b.DefaultBackground=2]="DefaultBackground"})(w||(e.ColorId=w={}));var C;(function(b){b[b.Other=0]="Other",b[b.Comment=1]="Comment",b[b.String=2]="String",b[b.RegEx=3]="RegEx"})(C||(e.StandardTokenType=C={}));var R;(function(b){b[b.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",b[b.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",b[b.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",b[b.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",b[b.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",b[b.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",b[b.ITALIC_MASK=2048]="ITALIC_MASK",b[b.BOLD_MASK=4096]="BOLD_MASK",b[b.UNDERLINE_MASK=8192]="UNDERLINE_MASK",b[b.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",b[b.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",b[b.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",b[b.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",b[b.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",b[b.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",b[b.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",b[b.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",b[b.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",b[b.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",b[b.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",b[b.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",b[b.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(R||(e.MetadataConsts=R={}));class _{static getLanguageId(o){return(o&R.LANGUAGEID_MASK)>>>R.LANGUAGEID_OFFSET}static getTokenType(o){return(o&R.TOKEN_TYPE_MASK)>>>R.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(o){return(o&R.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(o){return(o&R.FONT_STYLE_MASK)>>>R.FONT_STYLE_OFFSET}static getForeground(o){return(o&R.FOREGROUND_MASK)>>>R.FOREGROUND_OFFSET}static getBackground(o){return(o&R.BACKGROUND_MASK)>>>R.BACKGROUND_OFFSET}static getClassNameFromMetadata(o){let y="mtk"+this.getForeground(o);const d=this.getFontStyle(o);return d&r.Italic&&(y+=" mtki"),d&r.Bold&&(y+=" mtkb"),d&r.Underline&&(y+=" mtku"),d&r.Strikethrough&&(y+=" mtks"),y}static getInlineStyleFromMetadata(o,D){const y=this.getForeground(o),d=this.getFontStyle(o);let E=`color: ${D[y]};`;d&r.Italic&&(E+="font-style: italic;"),d&r.Bold&&(E+="font-weight: bold;");let a="";return d&r.Underline&&(a+=" underline"),d&r.Strikethrough&&(a+=" line-through"),a&&(E+=`text-decoration:${a};`),E}static getPresentationFromMetadata(o){const D=this.getForeground(o),y=this.getFontStyle(o);return{foreground:D,italic:!!(y&r.Italic),bold:!!(y&r.Bold),underline:!!(y&r.Underline),strikethrough:!!(y&r.Strikethrough)}}}e.TokenMetadata=_}),define(ye[182],Ie([1,0,21]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.isITextSnapshot=a,e.shouldSynchronizeModel=v;var r;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(r||(e.OverviewRulerLane=r={}));var w;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=3]="Right"})(w||(e.GlyphMarginLane=w={}));var C;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(C||(e.MinimapPosition=C={}));var R;(function(t){t[t.Normal=1]="Normal",t[t.Underlined=2]="Underlined"})(R||(e.MinimapSectionHeaderStyle=R={}));var _;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(_||(e.InjectedTextCursorStops=_={}));var b;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var o;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(o||(e.DefaultEndOfLine=o={}));var D;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(D||(e.EndOfLineSequence=D={}));class y{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(l){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,l.tabSize|0),l.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,l.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!l.insertSpaces,this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=!!l.trimAutoWhitespace,this.bracketPairColorizationOptions=l.bracketPairColorizationOptions}equals(l){return this.tabSize===l.tabSize&&this._indentSizeIsTabSize===l._indentSizeIsTabSize&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace&&(0,i.equals)(this.bracketPairColorizationOptions,l.bracketPairColorizationOptions)}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class d{constructor(l,n){this._findMatchBrand=void 0,this.range=l,this.matches=n}}e.FindMatch=d;var E;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(E||(e.TrackedRangeStickiness=E={}));function a(t){return t&&typeof t.read=="function"}var f;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(f||(e.PositionAffinity=f={}));var m;(function(t){t[t.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class p{constructor(l,n,h,s,c,u){this.identifier=l,this.range=n,this.text=h,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=c,this._isTracked=u}}e.ValidAnnotatedEditOperation=p;class S{constructor(l,n,h){this.regex=l,this.wordSeparators=n,this.simpleSearch=h}}e.SearchData=S;class g{constructor(l,n,h){this.reverseEdits=l,this.changes=n,this.trimAutoWhitespaceLineNumbers=h}}e.ApplyEditsResult=g;function v(t){return!t.isTooLargeForSyncing()&&!t.isForSimpleWidget}}),define(ye[183],Ie([1,0,6,2,110]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class C{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(b){this._onDidChange.fire({changedLanguages:b,changedColorMap:!1})}register(b,o){return this._tokenizationSupports.set(b,o),this.handleChange([b]),(0,r.toDisposable)(()=>{this._tokenizationSupports.get(b)===o&&(this._tokenizationSupports.delete(b),this.handleChange([b]))})}get(b){return this._tokenizationSupports.get(b)||null}registerFactory(b,o){this._factories.get(b)?.dispose();const D=new R(this,b,o);return this._factories.set(b,D),(0,r.toDisposable)(()=>{const y=this._factories.get(b);!y||y!==D||(this._factories.delete(b),y.dispose())})}async getOrCreate(b){const o=this.get(b);if(o)return o;const D=this._factories.get(b);return!D||D.isResolved?null:(await D.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const D=this._factories.get(b);return!!(!D||D.isResolved)}setColorMap(b){this._colorMap=b,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>w.ColorId.DefaultBackground?this._colorMap[w.ColorId.DefaultBackground]:null}}e.TokenizationRegistry=C;class R extends r.Disposable{get isResolved(){return this._isResolved}constructor(b,o,D){super(),this._registry=b,this._languageId=o,this._factory=D,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const b=await this._factory.tokenizationSupport;this._isResolved=!0,b&&!this._isDisposed&&this._register(this._registry.register(this._languageId,b))}}}),define(ye[184],Ie([7,8]),function(se,e){return se.create("vs/base/common/actions",e)}),define(ye[185],Ie([1,0,6,2,184]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0,e.toAction=D,w=Be(w);class C extends r.Disposable{constructor(d,E="",a="",f=!0,m){super(),this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=d,this._label=E,this._cssClass=a,this._enabled=f,this._actionCallback=m}get id(){return this._id}get label(){return this._label}set label(d){this._setLabel(d)}_setLabel(d){this._label!==d&&(this._label=d,this._onDidChange.fire({label:d}))}get tooltip(){return this._tooltip||""}set tooltip(d){this._setTooltip(d)}_setTooltip(d){this._tooltip!==d&&(this._tooltip=d,this._onDidChange.fire({tooltip:d}))}get class(){return this._cssClass}set class(d){this._setClass(d)}_setClass(d){this._cssClass!==d&&(this._cssClass=d,this._onDidChange.fire({class:d}))}get enabled(){return this._enabled}set enabled(d){this._setEnabled(d)}_setEnabled(d){this._enabled!==d&&(this._enabled=d,this._onDidChange.fire({enabled:d}))}get checked(){return this._checked}set checked(d){this._setChecked(d)}_setChecked(d){this._checked!==d&&(this._checked=d,this._onDidChange.fire({checked:d}))}async run(d,E){this._actionCallback&&await this._actionCallback(d)}}e.Action=C;class R extends r.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new i.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new i.Emitter),this.onDidRun=this._onDidRun.event}async run(d,E){if(!d.enabled)return;this._onWillRun.fire({action:d});let a;try{await this.runAction(d,E)}catch(f){a=f}this._onDidRun.fire({action:d,error:a})}async runAction(d,E){await d.run(E)}}e.ActionRunner=R;class _{constructor(){this.id=_.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...d){let E=[];for(const a of d)a.length&&(E.length?E=[...E,new _,...a]:E=a);return E}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=_;class b{get actions(){return this._actions}constructor(d,E,a,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=d,this.label=E,this.class=f,this._actions=a}async run(){}}e.SubmenuAction=b;class o extends C{static{this.ID="vs.actions.empty"}constructor(){super(o.ID,w.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=o;function D(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...d)=>y.run(...d)}}}),define(ye[186],Ie([7,8]),function(se,e){return se.create("vs/base/common/date",e)}),define(ye[187],Ie([1,0,186]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=o,e.getDurationString=D,e.toLocalISOString=y;const r=60,w=r*60,C=w*24,R=C*7,_=C*30,b=C*365;function o(d,E,a,f){typeof d!="number"&&(d=d.getTime());const m=Math.round((new Date().getTime()-d)/1e3);if(m<-30)return(0,i.localize)(0,null,o(new Date().getTime()+m*1e3,!1));if(!f&&m<30)return(0,i.localize)(1,null);let p;return m<r?(p=m,E?p===1?a?(0,i.localize)(2,null,p):(0,i.localize)(3,null,p):a?(0,i.localize)(4,null,p):(0,i.localize)(5,null,p):p===1?a?(0,i.localize)(6,null,p):(0,i.localize)(7,null,p):a?(0,i.localize)(8,null,p):(0,i.localize)(9,null,p)):m<w?(p=Math.floor(m/r),E?p===1?a?(0,i.localize)(10,null,p):(0,i.localize)(11,null,p):a?(0,i.localize)(12,null,p):(0,i.localize)(13,null,p):p===1?a?(0,i.localize)(14,null,p):(0,i.localize)(15,null,p):a?(0,i.localize)(16,null,p):(0,i.localize)(17,null,p)):m<C?(p=Math.floor(m/w),E?p===1?a?(0,i.localize)(18,null,p):(0,i.localize)(19,null,p):a?(0,i.localize)(20,null,p):(0,i.localize)(21,null,p):p===1?a?(0,i.localize)(22,null,p):(0,i.localize)(23,null,p):a?(0,i.localize)(24,null,p):(0,i.localize)(25,null,p)):m<R?(p=Math.floor(m/C),E?p===1?(0,i.localize)(26,null,p):(0,i.localize)(27,null,p):p===1?(0,i.localize)(28,null,p):(0,i.localize)(29,null,p)):m<_?(p=Math.floor(m/R),E?p===1?a?(0,i.localize)(30,null,p):(0,i.localize)(31,null,p):a?(0,i.localize)(32,null,p):(0,i.localize)(33,null,p):p===1?a?(0,i.localize)(34,null,p):(0,i.localize)(35,null,p):a?(0,i.localize)(36,null,p):(0,i.localize)(37,null,p)):m<b?(p=Math.floor(m/_),E?p===1?a?(0,i.localize)(38,null,p):(0,i.localize)(39,null,p):a?(0,i.localize)(40,null,p):(0,i.localize)(41,null,p):p===1?a?(0,i.localize)(42,null,p):(0,i.localize)(43,null,p):a?(0,i.localize)(44,null,p):(0,i.localize)(45,null,p)):(p=Math.floor(m/b),E?p===1?a?(0,i.localize)(46,null,p):(0,i.localize)(47,null,p):a?(0,i.localize)(48,null,p):(0,i.localize)(49,null,p):p===1?a?(0,i.localize)(50,null,p):(0,i.localize)(51,null,p):a?(0,i.localize)(52,null,p):(0,i.localize)(53,null,p))}function D(d,E){const a=Math.abs(d/1e3);return a<1?E?(0,i.localize)(54,null,d):(0,i.localize)(55,null,d):a<r?E?(0,i.localize)(56,null,Math.round(d)/1e3):(0,i.localize)(57,null,Math.round(d)/1e3):a<w?E?(0,i.localize)(58,null,Math.round(d/(1e3*r))):(0,i.localize)(59,null,Math.round(d/(1e3*r))):a<C?E?(0,i.localize)(60,null,Math.round(d/(1e3*w))):(0,i.localize)(61,null,Math.round(d/(1e3*w))):(0,i.localize)(62,null,Math.round(d/(1e3*C)))}function y(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ye[188],Ie([7,8]),function(se,e){return se.create("vs/base/common/errorMessage",e)}),define(ye[45],Ie([1,0,18,11,188]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=b,e.isErrorWithActions=o,e.createErrorWithActions=D,i=Be(i),r=Be(r),w=Be(w);function C(y,d){return d&&(y.stack||y.stacktrace)?w.localize(0,null,_(y),R(y.stack)||R(y.stacktrace)):_(y)}function R(y){return Array.isArray(y)?y.join(`
`):y}function _(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?w.localize(1,null,y.message):y.message||w.localize(2,null)}function b(y=null,d=!1){if(!y)return w.localize(3,null);if(Array.isArray(y)){const E=i.coalesce(y),a=b(E[0],d);return E.length>1?w.localize(4,null,a,E.length):a}if(r.isString(y))return y;if(y.detail){const E=y.detail;if(E.error)return C(E.error,d);if(E.exception)return C(E.exception,d)}return y.stack?C(y,d):y.message?y.message:w.localize(5,null)}function o(y){const d=y;return d instanceof Error&&Array.isArray(d.actions)}function D(y,d){let E;return typeof y=="string"?E=new Error(y):E=y,E.actions=d,E}}),define(ye[189],Ie([7,8]),function(se,e){return se.create("vs/base/common/jsonErrorMessages",e)}),define(ye[190],Ie([1,0,189,43]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=w;function w(C){switch(C){case r.ParseErrorCode.InvalidSymbol:return(0,i.localize)(0,null);case r.ParseErrorCode.InvalidNumberFormat:return(0,i.localize)(1,null);case r.ParseErrorCode.PropertyNameExpected:return(0,i.localize)(2,null);case r.ParseErrorCode.ValueExpected:return(0,i.localize)(3,null);case r.ParseErrorCode.ColonExpected:return(0,i.localize)(4,null);case r.ParseErrorCode.CommaExpected:return(0,i.localize)(5,null);case r.ParseErrorCode.CloseBraceExpected:return(0,i.localize)(6,null);case r.ParseErrorCode.CloseBracketExpected:return(0,i.localize)(7,null);case r.ParseErrorCode.EndOfFileExpected:return(0,i.localize)(8,null);default:return""}}}),define(ye[191],Ie([7,8]),function(se,e){return se.create("vs/base/common/platform",e)}),define(ye[3],Ie([1,0,191]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=n,e.isLittleEndian=T,e.isBigSurOrNewer=A,i=Be(i),e.LANGUAGE_DEFAULT="en";let r=!1,w=!1,C=!1,R=!1,_=!1,b=!1,o=!1,D=!1,y=!1,d=!1,E,a=e.LANGUAGE_DEFAULT,f=e.LANGUAGE_DEFAULT,m,p;const S=globalThis;let g;typeof S.vscode<"u"&&typeof S.vscode.process<"u"?g=S.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(g=process);const v=typeof g?.versions?.electron=="string",t=v&&g?.type==="renderer";if(typeof g=="object"){r=g.platform==="win32",w=g.platform==="darwin",C=g.platform==="linux",R=C&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,o=v,y=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,E=e.LANGUAGE_DEFAULT,a=e.LANGUAGE_DEFAULT;const O=g.env.VSCODE_NLS_CONFIG;if(O)try{const k=JSON.parse(O),P=k.availableLanguages["*"];E=k.locale,f=k.osLocale,a=P||e.LANGUAGE_DEFAULT,m=k._translationsConfigFile}catch{}_=!0}else typeof navigator=="object"&&!t?(p=navigator.userAgent,r=p.indexOf("Windows")>=0,w=p.indexOf("Macintosh")>=0,D=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=p.indexOf("Linux")>=0,d=p?.indexOf("Mobi")>=0,b=!0,E=i.getConfiguredDefaultLocale(i.localize(0,null))||e.LANGUAGE_DEFAULT,a=E,f=navigator.language):console.error("Unable to resolve platform.");var l;(function(O){O[O.Web=0]="Web",O[O.Mac=1]="Mac",O[O.Linux=2]="Linux",O[O.Windows=3]="Windows"})(l||(e.Platform=l={}));function n(O){switch(O){case l.Web:return"Web";case l.Mac:return"Mac";case l.Linux:return"Linux";case l.Windows:return"Windows"}}let h=l.Web;w?h=l.Mac:r?h=l.Windows:C&&(h=l.Linux),e.isWindows=r,e.isMacintosh=w,e.isLinux=C,e.isLinuxSnap=R,e.isNative=_,e.isElectron=o,e.isWeb=b,e.isWebWorker=b&&typeof S.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?S.origin:void 0,e.isIOS=D,e.isMobile=d,e.isCI=y,e.platform=h,e.userAgent=p,e.language=a;var s;(function(O){function k(){return e.language}O.value=k;function P(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}O.isDefaultVariant=P;function B(){return e.language==="en"}O.isDefault=B})(s||(e.Language=s={})),e.locale=E,e.platformLocale=f,e.translationsConfigFile=m,e.setTimeout0IsFaster=typeof S.postMessage=="function"&&!S.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const O=[];S.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let B=0,Y=O.length;B<Y;B++){const X=O[B];if(X.id===P.data.vscodeScheduleAsyncWork){O.splice(B,1),X.callback();return}}});let k=0;return P=>{const B=++k;O.push({id:B,callback:P}),S.postMessage({vscodeScheduleAsyncWork:B},"*")}}return O=>setTimeout(O)})();var c;(function(O){O[O.Windows=1]="Windows",O[O.Macintosh=2]="Macintosh",O[O.Linux=3]="Linux"})(c||(e.OperatingSystem=c={})),e.OS=w||D?c.Macintosh:r?c.Windows:c.Linux;let u=!0,I=!1;function T(){if(!I){I=!0;const O=new Uint8Array(2);O[0]=1,O[1]=2,u=new Uint16Array(O.buffer)[0]===513}return u}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function A(O){return parseFloat(O)>=20}}),define(ye[33],Ie([1,0,3]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let r;const w=globalThis.vscode;if(typeof w<"u"&&typeof w.process<"u"){const C=w.process;r={get platform(){return C.platform},get arch(){return C.arch},get env(){return C.env},cwd(){return C.cwd()}}}else typeof process<"u"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return i.isWindows?"win32":i.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.platform=r.platform,e.arch=r.arch}),define(ye[9],Ie([1,0,33]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0,i=Be(i);const r=65,w=97,C=90,R=122,_=46,b=47,o=92,D=58,y=63;class d extends Error{constructor(n,h,s){let c;typeof h=="string"&&h.indexOf("not ")===0?(c="must not be",h=h.replace(/^not /,"")):c="must be";const u=n.indexOf(".")!==-1?"property":"argument";let I=`The "${n}" ${u} ${c} of type ${h}`;I+=`. Received type ${typeof s}`,super(I),this.code="ERR_INVALID_ARG_TYPE"}}function E(l,n){if(l===null||typeof l!="object")throw new d(n,"Object",l)}function a(l,n){if(typeof l!="string")throw new d(n,"string",l)}const f=i.platform==="win32";function m(l){return l===b||l===o}function p(l){return l===b}function S(l){return l>=r&&l<=C||l>=w&&l<=R}function g(l,n,h,s){let c="",u=0,I=-1,T=0,A=0;for(let O=0;O<=l.length;++O){if(O<l.length)A=l.charCodeAt(O);else{if(s(A))break;A=b}if(s(A)){if(!(I===O-1||T===1))if(T===2){if(c.length<2||u!==2||c.charCodeAt(c.length-1)!==_||c.charCodeAt(c.length-2)!==_){if(c.length>2){const k=c.lastIndexOf(h);k===-1?(c="",u=0):(c=c.slice(0,k),u=c.length-1-c.lastIndexOf(h)),I=O,T=0;continue}else if(c.length!==0){c="",u=0,I=O,T=0;continue}}n&&(c+=c.length>0?`${h}..`:"..",u=2)}else c.length>0?c+=`${h}${l.slice(I+1,O)}`:c=l.slice(I+1,O),u=O-I-1;I=O,T=0}else A===_&&T!==-1?++T:T=-1}return c}function v(l,n){E(n,"pathObject");const h=n.dir||n.root,s=n.base||`${n.name||""}${n.ext||""}`;return h?h===n.root?`${h}${s}`:`${h}${l}${s}`:s}e.win32={resolve(...l){let n="",h="",s=!1;for(let c=l.length-1;c>=-1;c--){let u;if(c>=0){if(u=l[c],a(u,"path"),u.length===0)continue}else n.length===0?u=i.cwd():(u=i.env[`=${n}`]||i.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==n.toLowerCase()&&u.charCodeAt(2)===o)&&(u=`${n}\\`));const I=u.length;let T=0,A="",O=!1;const k=u.charCodeAt(0);if(I===1)m(k)&&(T=1,O=!0);else if(m(k))if(O=!0,m(u.charCodeAt(1))){let P=2,B=P;for(;P<I&&!m(u.charCodeAt(P));)P++;if(P<I&&P!==B){const Y=u.slice(B,P);for(B=P;P<I&&m(u.charCodeAt(P));)P++;if(P<I&&P!==B){for(B=P;P<I&&!m(u.charCodeAt(P));)P++;(P===I||P!==B)&&(A=`\\\\${Y}\\${u.slice(B,P)}`,T=P)}}}else T=1;else S(k)&&u.charCodeAt(1)===D&&(A=u.slice(0,2),T=2,I>2&&m(u.charCodeAt(2))&&(O=!0,T=3));if(A.length>0)if(n.length>0){if(A.toLowerCase()!==n.toLowerCase())continue}else n=A;if(s){if(n.length>0)break}else if(h=`${u.slice(T)}\\${h}`,s=O,O&&n.length>0)break}return h=g(h,!s,"\\",m),s?`${n}\\${h}`:`${n}${h}`||"."},normalize(l){a(l,"path");const n=l.length;if(n===0)return".";let h=0,s,c=!1;const u=l.charCodeAt(0);if(n===1)return p(u)?"\\":l;if(m(u))if(c=!0,m(l.charCodeAt(1))){let T=2,A=T;for(;T<n&&!m(l.charCodeAt(T));)T++;if(T<n&&T!==A){const O=l.slice(A,T);for(A=T;T<n&&m(l.charCodeAt(T));)T++;if(T<n&&T!==A){for(A=T;T<n&&!m(l.charCodeAt(T));)T++;if(T===n)return`\\\\${O}\\${l.slice(A)}\\`;T!==A&&(s=`\\\\${O}\\${l.slice(A,T)}`,h=T)}}}else h=1;else S(u)&&l.charCodeAt(1)===D&&(s=l.slice(0,2),h=2,n>2&&m(l.charCodeAt(2))&&(c=!0,h=3));let I=h<n?g(l.slice(h),!c,"\\",m):"";return I.length===0&&!c&&(I="."),I.length>0&&m(l.charCodeAt(n-1))&&(I+="\\"),s===void 0?c?`\\${I}`:I:c?`${s}\\${I}`:`${s}${I}`},isAbsolute(l){a(l,"path");const n=l.length;if(n===0)return!1;const h=l.charCodeAt(0);return m(h)||n>2&&S(h)&&l.charCodeAt(1)===D&&m(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let n,h;for(let u=0;u<l.length;++u){const I=l[u];a(I,"path"),I.length>0&&(n===void 0?n=h=I:n+=`\\${I}`)}if(n===void 0)return".";let s=!0,c=0;if(typeof h=="string"&&m(h.charCodeAt(0))){++c;const u=h.length;u>1&&m(h.charCodeAt(1))&&(++c,u>2&&(m(h.charCodeAt(2))?++c:s=!1))}if(s){for(;c<n.length&&m(n.charCodeAt(c));)c++;c>=2&&(n=`\\${n.slice(c)}`)}return e.win32.normalize(n)},relative(l,n){if(a(l,"from"),a(n,"to"),l===n)return"";const h=e.win32.resolve(l),s=e.win32.resolve(n);if(h===s||(l=h.toLowerCase(),n=s.toLowerCase(),l===n))return"";let c=0;for(;c<l.length&&l.charCodeAt(c)===o;)c++;let u=l.length;for(;u-1>c&&l.charCodeAt(u-1)===o;)u--;const I=u-c;let T=0;for(;T<n.length&&n.charCodeAt(T)===o;)T++;let A=n.length;for(;A-1>T&&n.charCodeAt(A-1)===o;)A--;const O=A-T,k=I<O?I:O;let P=-1,B=0;for(;B<k;B++){const X=l.charCodeAt(c+B);if(X!==n.charCodeAt(T+B))break;X===o&&(P=B)}if(B!==k){if(P===-1)return s}else{if(O>k){if(n.charCodeAt(T+B)===o)return s.slice(T+B+1);if(B===2)return s.slice(T+B)}I>k&&(l.charCodeAt(c+B)===o?P=B:B===2&&(P=3)),P===-1&&(P=0)}let Y="";for(B=c+P+1;B<=u;++B)(B===u||l.charCodeAt(B)===o)&&(Y+=Y.length===0?"..":"\\..");return T+=P,Y.length>0?`${Y}${s.slice(T,A)}`:(s.charCodeAt(T)===o&&++T,s.slice(T,A))},toNamespacedPath(l){if(typeof l!="string"||l.length===0)return l;const n=e.win32.resolve(l);if(n.length<=2)return l;if(n.charCodeAt(0)===o){if(n.charCodeAt(1)===o){const h=n.charCodeAt(2);if(h!==y&&h!==_)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(S(n.charCodeAt(0))&&n.charCodeAt(1)===D&&n.charCodeAt(2)===o)return`\\\\?\\${n}`;return l},dirname(l){a(l,"path");const n=l.length;if(n===0)return".";let h=-1,s=0;const c=l.charCodeAt(0);if(n===1)return m(c)?l:".";if(m(c)){if(h=s=1,m(l.charCodeAt(1))){let T=2,A=T;for(;T<n&&!m(l.charCodeAt(T));)T++;if(T<n&&T!==A){for(A=T;T<n&&m(l.charCodeAt(T));)T++;if(T<n&&T!==A){for(A=T;T<n&&!m(l.charCodeAt(T));)T++;if(T===n)return l;T!==A&&(h=s=T+1)}}}}else S(c)&&l.charCodeAt(1)===D&&(h=n>2&&m(l.charCodeAt(2))?3:2,s=h);let u=-1,I=!0;for(let T=n-1;T>=s;--T)if(m(l.charCodeAt(T))){if(!I){u=T;break}}else I=!1;if(u===-1){if(h===-1)return".";u=h}return l.slice(0,u)},basename(l,n){n!==void 0&&a(n,"ext"),a(l,"path");let h=0,s=-1,c=!0,u;if(l.length>=2&&S(l.charCodeAt(0))&&l.charCodeAt(1)===D&&(h=2),n!==void 0&&n.length>0&&n.length<=l.length){if(n===l)return"";let I=n.length-1,T=-1;for(u=l.length-1;u>=h;--u){const A=l.charCodeAt(u);if(m(A)){if(!c){h=u+1;break}}else T===-1&&(c=!1,T=u+1),I>=0&&(A===n.charCodeAt(I)?--I===-1&&(s=u):(I=-1,s=T))}return h===s?s=T:s===-1&&(s=l.length),l.slice(h,s)}for(u=l.length-1;u>=h;--u)if(m(l.charCodeAt(u))){if(!c){h=u+1;break}}else s===-1&&(c=!1,s=u+1);return s===-1?"":l.slice(h,s)},extname(l){a(l,"path");let n=0,h=-1,s=0,c=-1,u=!0,I=0;l.length>=2&&l.charCodeAt(1)===D&&S(l.charCodeAt(0))&&(n=s=2);for(let T=l.length-1;T>=n;--T){const A=l.charCodeAt(T);if(m(A)){if(!u){s=T+1;break}continue}c===-1&&(u=!1,c=T+1),A===_?h===-1?h=T:I!==1&&(I=1):h!==-1&&(I=-1)}return h===-1||c===-1||I===0||I===1&&h===c-1&&h===s+1?"":l.slice(h,c)},format:v.bind(null,"\\"),parse(l){a(l,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return n;const h=l.length;let s=0,c=l.charCodeAt(0);if(h===1)return m(c)?(n.root=n.dir=l,n):(n.base=n.name=l,n);if(m(c)){if(s=1,m(l.charCodeAt(1))){let P=2,B=P;for(;P<h&&!m(l.charCodeAt(P));)P++;if(P<h&&P!==B){for(B=P;P<h&&m(l.charCodeAt(P));)P++;if(P<h&&P!==B){for(B=P;P<h&&!m(l.charCodeAt(P));)P++;P===h?s=P:P!==B&&(s=P+1)}}}}else if(S(c)&&l.charCodeAt(1)===D){if(h<=2)return n.root=n.dir=l,n;if(s=2,m(l.charCodeAt(2))){if(h===3)return n.root=n.dir=l,n;s=3}}s>0&&(n.root=l.slice(0,s));let u=-1,I=s,T=-1,A=!0,O=l.length-1,k=0;for(;O>=s;--O){if(c=l.charCodeAt(O),m(c)){if(!A){I=O+1;break}continue}T===-1&&(A=!1,T=O+1),c===_?u===-1?u=O:k!==1&&(k=1):u!==-1&&(k=-1)}return T!==-1&&(u===-1||k===0||k===1&&u===T-1&&u===I+1?n.base=n.name=l.slice(I,T):(n.name=l.slice(I,u),n.base=l.slice(I,T),n.ext=l.slice(u,T))),I>0&&I!==s?n.dir=l.slice(0,I-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const t=(()=>{if(f){const l=/\\/g;return()=>{const n=i.cwd().replace(l,"/");return n.slice(n.indexOf("/"))}}return()=>i.cwd()})();e.posix={resolve(...l){let n="",h=!1;for(let s=l.length-1;s>=-1&&!h;s--){const c=s>=0?l[s]:t();a(c,"path"),c.length!==0&&(n=`${c}/${n}`,h=c.charCodeAt(0)===b)}return n=g(n,!h,"/",p),h?`/${n}`:n.length>0?n:"."},normalize(l){if(a(l,"path"),l.length===0)return".";const n=l.charCodeAt(0)===b,h=l.charCodeAt(l.length-1)===b;return l=g(l,!n,"/",p),l.length===0?n?"/":h?"./":".":(h&&(l+="/"),n?`/${l}`:l)},isAbsolute(l){return a(l,"path"),l.length>0&&l.charCodeAt(0)===b},join(...l){if(l.length===0)return".";let n;for(let h=0;h<l.length;++h){const s=l[h];a(s,"path"),s.length>0&&(n===void 0?n=s:n+=`/${s}`)}return n===void 0?".":e.posix.normalize(n)},relative(l,n){if(a(l,"from"),a(n,"to"),l===n||(l=e.posix.resolve(l),n=e.posix.resolve(n),l===n))return"";const h=1,s=l.length,c=s-h,u=1,I=n.length-u,T=c<I?c:I;let A=-1,O=0;for(;O<T;O++){const P=l.charCodeAt(h+O);if(P!==n.charCodeAt(u+O))break;P===b&&(A=O)}if(O===T)if(I>T){if(n.charCodeAt(u+O)===b)return n.slice(u+O+1);if(O===0)return n.slice(u+O)}else c>T&&(l.charCodeAt(h+O)===b?A=O:O===0&&(A=0));let k="";for(O=h+A+1;O<=s;++O)(O===s||l.charCodeAt(O)===b)&&(k+=k.length===0?"..":"/..");return`${k}${n.slice(u+A)}`},toNamespacedPath(l){return l},dirname(l){if(a(l,"path"),l.length===0)return".";const n=l.charCodeAt(0)===b;let h=-1,s=!0;for(let c=l.length-1;c>=1;--c)if(l.charCodeAt(c)===b){if(!s){h=c;break}}else s=!1;return h===-1?n?"/":".":n&&h===1?"//":l.slice(0,h)},basename(l,n){n!==void 0&&a(n,"ext"),a(l,"path");let h=0,s=-1,c=!0,u;if(n!==void 0&&n.length>0&&n.length<=l.length){if(n===l)return"";let I=n.length-1,T=-1;for(u=l.length-1;u>=0;--u){const A=l.charCodeAt(u);if(A===b){if(!c){h=u+1;break}}else T===-1&&(c=!1,T=u+1),I>=0&&(A===n.charCodeAt(I)?--I===-1&&(s=u):(I=-1,s=T))}return h===s?s=T:s===-1&&(s=l.length),l.slice(h,s)}for(u=l.length-1;u>=0;--u)if(l.charCodeAt(u)===b){if(!c){h=u+1;break}}else s===-1&&(c=!1,s=u+1);return s===-1?"":l.slice(h,s)},extname(l){a(l,"path");let n=-1,h=0,s=-1,c=!0,u=0;for(let I=l.length-1;I>=0;--I){const T=l.charCodeAt(I);if(T===b){if(!c){h=I+1;break}continue}s===-1&&(c=!1,s=I+1),T===_?n===-1?n=I:u!==1&&(u=1):n!==-1&&(u=-1)}return n===-1||s===-1||u===0||u===1&&n===s-1&&n===h+1?"":l.slice(n,s)},format:v.bind(null,"/"),parse(l){a(l,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return n;const h=l.charCodeAt(0)===b;let s;h?(n.root="/",s=1):s=0;let c=-1,u=0,I=-1,T=!0,A=l.length-1,O=0;for(;A>=s;--A){const k=l.charCodeAt(A);if(k===b){if(!T){u=A+1;break}continue}I===-1&&(T=!1,I=A+1),k===_?c===-1?c=A:O!==1&&(O=1):c!==-1&&(O=-1)}if(I!==-1){const k=u===0&&h?1:u;c===-1||O===0||O===1&&c===I-1&&c===u+1?n.base=n.name=l.slice(k,I):(n.name=l.slice(k,c),n.base=l.slice(k,I),n.ext=l.slice(c,I))}return u>0?n.dir=l.slice(0,u-1):h&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=f?e.win32.normalize:e.posix.normalize,e.isAbsolute=f?e.win32.isAbsolute:e.posix.isAbsolute,e.join=f?e.win32.join:e.posix.join,e.resolve=f?e.win32.resolve:e.posix.resolve,e.relative=f?e.win32.relative:e.posix.relative,e.dirname=f?e.win32.dirname:e.posix.dirname,e.basename=f?e.win32.basename:e.posix.basename,e.extname=f?e.win32.extname:e.posix.extname,e.format=f?e.win32.format:e.posix.format,e.parse=f?e.win32.parse:e.posix.parse,e.toNamespacedPath=f?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=f?e.win32.sep:e.posix.sep,e.delimiter=f?e.win32.delimiter:e.posix.delimiter}),define(ye[37],Ie([1,0,35,9,3,17,11]),function(se,e,i,r,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=_,e.toSlashes=b,e.toPosixPath=o,e.getRoot=D,e.isUNC=y,e.isValidBasename=f,e.isEqual=m,e.isEqualOrParent=p,e.isWindowsDriveLetter=S,e.sanitizeFilePath=g,e.removeTrailingPathSeparator=v,e.isRootOrDriveLetter=t,e.hasDriveLetter=l,e.getDriveLetter=n,e.indexOfPath=h,e.parseLineAndColumnAware=s,e.randomPath=I;function _(T){return T===i.CharCode.Slash||T===i.CharCode.Backslash}function b(T){return T.replace(/[\\/]/g,r.posix.sep)}function o(T){return T.indexOf("/")===-1&&(T=b(T)),/^[a-zA-Z]:(\/|$)/.test(T)&&(T="/"+T),T}function D(T,A=r.posix.sep){if(!T)return"";const O=T.length,k=T.charCodeAt(0);if(_(k)){if(_(T.charCodeAt(1))&&!_(T.charCodeAt(2))){let B=3;const Y=B;for(;B<O&&!_(T.charCodeAt(B));B++);if(Y!==B&&!_(T.charCodeAt(B+1))){for(B+=1;B<O;B++)if(_(T.charCodeAt(B)))return T.slice(0,B+1).replace(/[\\/]/g,A)}}return A}else if(S(k)&&T.charCodeAt(1)===i.CharCode.Colon)return _(T.charCodeAt(2))?T.slice(0,2)+A:T.slice(0,2);let P=T.indexOf("://");if(P!==-1){for(P+=3;P<O;P++)if(_(T.charCodeAt(P)))return T.slice(0,P+1)}return""}function y(T){if(!w.isWindows||!T||T.length<5)return!1;let A=T.charCodeAt(0);if(A!==i.CharCode.Backslash||(A=T.charCodeAt(1),A!==i.CharCode.Backslash))return!1;let O=2;const k=O;for(;O<T.length&&(A=T.charCodeAt(O),A!==i.CharCode.Backslash);O++);return!(k===O||(A=T.charCodeAt(O+1),isNaN(A)||A===i.CharCode.Backslash))}const d=/[\\/:\*\?"<>\|]/g,E=/[/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(T,A=w.isWindows){const O=A?d:E;return!(!T||T.length===0||/^\s+$/.test(T)||(O.lastIndex=0,O.test(T))||A&&a.test(T)||T==="."||T===".."||A&&T[T.length-1]==="."||A&&T.length!==T.trim().length||T.length>255)}function m(T,A,O){const k=T===A;return!O||k?k:!T||!A?!1:(0,C.equalsIgnoreCase)(T,A)}function p(T,A,O,k=r.sep){if(T===A)return!0;if(!T||!A||A.length>T.length)return!1;if(O){if(!(0,C.startsWithIgnoreCase)(T,A))return!1;if(A.length===T.length)return!0;let B=A.length;return A.charAt(A.length-1)===k&&B--,T.charAt(B)===k}return A.charAt(A.length-1)!==k&&(A+=k),T.indexOf(A)===0}function S(T){return T>=i.CharCode.A&&T<=i.CharCode.Z||T>=i.CharCode.a&&T<=i.CharCode.z}function g(T,A){return w.isWindows&&T.endsWith(":")&&(T+=r.sep),(0,r.isAbsolute)(T)||(T=(0,r.join)(A,T)),T=(0,r.normalize)(T),v(T)}function v(T){return w.isWindows?(T=(0,C.rtrim)(T,r.sep),T.endsWith(":")&&(T+=r.sep)):(T=(0,C.rtrim)(T,r.sep),T||(T=r.sep)),T}function t(T){const A=(0,r.normalize)(T);return w.isWindows?T.length>3?!1:l(A)&&(T.length===2||A.charCodeAt(2)===i.CharCode.Backslash):A===r.posix.sep}function l(T,A=w.isWindows){return A?S(T.charCodeAt(0))&&T.charCodeAt(1)===i.CharCode.Colon:!1}function n(T,A=w.isWindows){return l(T,A)?T[0]:void 0}function h(T,A,O){return A.length>T.length?-1:T===A?0:(O&&(T=T.toLowerCase(),A=A.toLowerCase()),T.indexOf(A))}function s(T){const A=T.split(":");let O,k,P;for(const B of A){const Y=Number(B);(0,R.isNumber)(Y)?k===void 0?k=Y:P===void 0&&(P=Y):O=O?[O,B].join(":"):B}if(!O)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:O,line:k!==void 0?k:void 0,column:P!==void 0?P:k!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function I(T,A,O=8){let k="";for(let B=0;B<O;B++){let Y;B===0&&w.isWindows&&!A&&(O===3||O===4)?Y=u:Y=c,k+=Y.charAt(Math.floor(Math.random()*Y.length))}let P;return A?P=`${A}-${k}`:P=k,T?(0,r.join)(T,P):P}}),define(ye[68],Ie([1,0,9]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Mimes=void 0,e.getMediaOrTextMime=C,e.getMediaMime=R,e.getExtensionForMimeType=_,e.normalizeMimeType=o,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const r={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},w={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function C(D){const y=(0,i.extname)(D),d=r[y.toLowerCase()];return d!==void 0?d:R(D)}function R(D){const y=(0,i.extname)(D);return w[y.toLowerCase()]}function _(D){for(const y in w)if(w[y]===D)return y}const b=/^(.+)\/(.+?)(;.+)?$/;function o(D,y){const d=b.exec(D);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:y?void 0:D}}),define(ye[69],Ie([1,0,3]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=C,e.removeDangerousEnvVariables=R;var r;(function(_){_[_.stdout=0]="stdout",_[_.stderr=1]="stderr"})(r||(e.Source=r={}));var w;(function(_){_[_.Success=0]="Success",_[_.Unknown=1]="Unknown",_[_.AccessDenied=2]="AccessDenied",_[_.ProcessNotFound=3]="ProcessNotFound"})(w||(e.TerminateResponseCode=w={}));function C(_,...b){const o=b.reduce((d,E)=>(d[E]=!0,d),{}),D=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(_).filter(d=>!o[d]).forEach(d=>{for(let E=0;E<D.length;E++)if(d.search(D[E])!==-1){delete _[d];break}})}function R(_){_&&(delete _.DEBUG,i.isMacintosh&&delete _.DYLD_LIBRARY_PATH,i.isLinux&&delete _.LD_PRELOAD)}}),define(ye[4],Ie([1,0,35,81,9,3]),function(se,e,i,r,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=m,e.uriToFsPath=l,w=Be(w);const R=/^\w[\w\d+.-]*$/,_=/^\//,b=/^\/\//;function o(u,I){if(!u.scheme&&I)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!R.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!_.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(b.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(u,I){return!u&&!I?"file":u}function y(u,I){switch(u){case"https":case"http":case"file":I?I[0]!==E&&(I=E+I):I=E;break}return I}const d="",E="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(I){return I instanceof f?!0:I?typeof I.authority=="string"&&typeof I.fragment=="string"&&typeof I.path=="string"&&typeof I.query=="string"&&typeof I.scheme=="string"&&typeof I.fsPath=="string"&&typeof I.with=="function"&&typeof I.toString=="function":!1}constructor(I,T,A,O,k,P=!1){typeof I=="object"?(this.scheme=I.scheme||d,this.authority=I.authority||d,this.path=I.path||d,this.query=I.query||d,this.fragment=I.fragment||d):(this.scheme=D(I,P),this.authority=T||d,this.path=y(this.scheme,A||d),this.query=O||d,this.fragment=k||d,o(this,P))}get fsPath(){return l(this,!1)}with(I){if(!I)return this;let{scheme:T,authority:A,path:O,query:k,fragment:P}=I;return T===void 0?T=this.scheme:T===null&&(T=d),A===void 0?A=this.authority:A===null&&(A=d),O===void 0?O=this.path:O===null&&(O=d),k===void 0?k=this.query:k===null&&(k=d),P===void 0?P=this.fragment:P===null&&(P=d),T===this.scheme&&A===this.authority&&O===this.path&&k===this.query&&P===this.fragment?this:new S(T,A,O,k,P)}static parse(I,T=!1){const A=a.exec(I);return A?new S(A[2]||d,c(A[4]||d),c(A[5]||d),c(A[7]||d),c(A[9]||d),T):new S(d,d,d,d,d)}static file(I){let T=d;if(C.isWindows&&(I=I.replace(/\\/g,E)),I[0]===E&&I[1]===E){const A=I.indexOf(E,2);A===-1?(T=I.substring(2),I=E):(T=I.substring(2,A),I=I.substring(A)||E)}return new S("file",T,I,d,d)}static from(I,T){return new S(I.scheme,I.authority,I.path,I.query,I.fragment,T)}static joinPath(I,...T){if(!I.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let A;return C.isWindows&&I.scheme==="file"?A=f.file(w.win32.join(l(I,!0),...T)).path:A=w.posix.join(I.path,...T),I.with({path:A})}toString(I=!1){return n(this,I)}toJSON(){return this}static revive(I){if(I){if(I instanceof f)return I;{const T=new S(I);return T._formatted=I.external??null,T._fsPath=I._sep===p?I.fsPath??null:null,T}}else return I}}e.URI=f;function m(u){return!u||typeof u!="object"?!1:typeof u.scheme=="string"&&(typeof u.authority=="string"||typeof u.authority>"u")&&(typeof u.path=="string"||typeof u.path>"u")&&(typeof u.query=="string"||typeof u.query>"u")&&(typeof u.fragment=="string"||typeof u.fragment>"u")}const p=C.isWindows?1:void 0;class S extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(I=!1){return I?n(this,!0):(this._formatted||(this._formatted=n(this,!1)),this._formatted)}toJSON(){const I={$mid:r.MarshalledId.Uri};return this._fsPath&&(I.fsPath=this._fsPath,I._sep=p),this._formatted&&(I.external=this._formatted),this.path&&(I.path=this.path),this.scheme&&(I.scheme=this.scheme),this.authority&&(I.authority=this.authority),this.query&&(I.query=this.query),this.fragment&&(I.fragment=this.fragment),I}}const g={[i.CharCode.Colon]:"%3A",[i.CharCode.Slash]:"%2F",[i.CharCode.QuestionMark]:"%3F",[i.CharCode.Hash]:"%23",[i.CharCode.OpenSquareBracket]:"%5B",[i.CharCode.CloseSquareBracket]:"%5D",[i.CharCode.AtSign]:"%40",[i.CharCode.ExclamationMark]:"%21",[i.CharCode.DollarSign]:"%24",[i.CharCode.Ampersand]:"%26",[i.CharCode.SingleQuote]:"%27",[i.CharCode.OpenParen]:"%28",[i.CharCode.CloseParen]:"%29",[i.CharCode.Asterisk]:"%2A",[i.CharCode.Plus]:"%2B",[i.CharCode.Comma]:"%2C",[i.CharCode.Semicolon]:"%3B",[i.CharCode.Equals]:"%3D",[i.CharCode.Space]:"%20"};function v(u,I,T){let A,O=-1;for(let k=0;k<u.length;k++){const P=u.charCodeAt(k);if(P>=i.CharCode.a&&P<=i.CharCode.z||P>=i.CharCode.A&&P<=i.CharCode.Z||P>=i.CharCode.Digit0&&P<=i.CharCode.Digit9||P===i.CharCode.Dash||P===i.CharCode.Period||P===i.CharCode.Underline||P===i.CharCode.Tilde||I&&P===i.CharCode.Slash||T&&P===i.CharCode.OpenSquareBracket||T&&P===i.CharCode.CloseSquareBracket||T&&P===i.CharCode.Colon)O!==-1&&(A+=encodeURIComponent(u.substring(O,k)),O=-1),A!==void 0&&(A+=u.charAt(k));else{A===void 0&&(A=u.substr(0,k));const B=g[P];B!==void 0?(O!==-1&&(A+=encodeURIComponent(u.substring(O,k)),O=-1),A+=B):O===-1&&(O=k)}}return O!==-1&&(A+=encodeURIComponent(u.substring(O))),A!==void 0?A:u}function t(u){let I;for(let T=0;T<u.length;T++){const A=u.charCodeAt(T);A===i.CharCode.Hash||A===i.CharCode.QuestionMark?(I===void 0&&(I=u.substr(0,T)),I+=g[A]):I!==void 0&&(I+=u[T])}return I!==void 0?I:u}function l(u,I){let T;return u.authority&&u.path.length>1&&u.scheme==="file"?T=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===i.CharCode.Slash&&(u.path.charCodeAt(1)>=i.CharCode.A&&u.path.charCodeAt(1)<=i.CharCode.Z||u.path.charCodeAt(1)>=i.CharCode.a&&u.path.charCodeAt(1)<=i.CharCode.z)&&u.path.charCodeAt(2)===i.CharCode.Colon?I?T=u.path.substr(1):T=u.path[1].toLowerCase()+u.path.substr(2):T=u.path,C.isWindows&&(T=T.replace(/\//g,"\\")),T}function n(u,I){const T=I?t:v;let A="",{scheme:O,authority:k,path:P,query:B,fragment:Y}=u;if(O&&(A+=O,A+=":"),(k||O==="file")&&(A+=E,A+=E),k){let X=k.indexOf("@");if(X!==-1){const re=k.substr(0,X);k=k.substr(X+1),X=re.lastIndexOf(":"),X===-1?A+=T(re,!1,!1):(A+=T(re.substr(0,X),!1,!1),A+=":",A+=T(re.substr(X+1),!1,!0)),A+="@"}k=k.toLowerCase(),X=k.lastIndexOf(":"),X===-1?A+=T(k,!1,!0):(A+=T(k.substr(0,X),!1,!0),A+=k.substr(X))}if(P){if(P.length>=3&&P.charCodeAt(0)===i.CharCode.Slash&&P.charCodeAt(2)===i.CharCode.Colon){const X=P.charCodeAt(1);X>=i.CharCode.A&&X<=i.CharCode.Z&&(P=`/${String.fromCharCode(X+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===i.CharCode.Colon){const X=P.charCodeAt(0);X>=i.CharCode.A&&X<=i.CharCode.Z&&(P=`${String.fromCharCode(X+32)}:${P.substr(2)}`)}A+=T(P,!0,!1)}return B&&(A+="?",A+=T(B,!1,!1)),Y&&(A+="#",A+=I?Y:v(Y,!1,!1)),A}function h(u){try{return decodeURIComponent(u)}catch{return u.length>3?u.substr(0,3)+h(u.substr(3)):u}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(u){return u.match(s)?u.replace(s,I=>h(I)):u}}),define(ye[192],Ie([1,0,4]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=r,e.parse=w,e.getFirstFrame=C,e.log=_;function r(o){const D=o;return D&&typeof D.type=="string"&&typeof D.severity=="string"}function w(o){const D=[];let y;try{const d=JSON.parse(o.arguments),E=d[d.length-1];E&&E.__$stack&&(d.pop(),y=E.__$stack),D.push(...d)}catch{D.push("Unable to log remote console arguments",o.arguments)}return{args:D,stack:y}}function C(o){if(typeof o!="string")return C(w(o).stack);const D=o;if(D){const y=R(D),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(d&&d.length===4)return{uri:i.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}function R(o){if(!o)return o;const D=o.indexOf(`
`);return D===-1?o:o.substring(0,D)}function _(o,D){const{args:y,stack:d}=w(o),E=typeof y[0]=="string"&&y.length===1;let a=R(d);a&&(a=`(${a.trim()})`);let f=[];if(typeof y[0]=="string"?a&&E?f=[`%c[${D}] %c${y[0]} %c${a}`,b("blue"),b(""),b("grey")]:f=[`%c[${D}] %c${y[0]}`,b("blue"),b(""),...y.slice(1)]:f=[`%c[${D}]%`,b("blue"),...y],a&&!E&&f.push(a),typeof console[o.severity]!="function")throw new Error("Unknown console method");console[o.severity].apply(console,f)}function b(o){return`color: ${o}`}}),define(ye[50],Ie([1,0,15,4,81]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=C,e.parse=R,e.revive=b;function C(o){return JSON.stringify(o,_)}function R(o){let D=JSON.parse(o);return D=b(D),D}function _(o,D){return D instanceof RegExp?{$mid:w.MarshalledId.Regexp,source:D.source,flags:D.flags}:D}function b(o,D=0){if(!o||D>200)return o;if(typeof o=="object"){switch(o.$mid){case w.MarshalledId.Uri:return r.URI.revive(o);case w.MarshalledId.Regexp:return new RegExp(o.source,o.flags);case w.MarshalledId.Date:return new Date(o.source)}if(o instanceof i.VSBuffer||o instanceof Uint8Array)return o;if(Array.isArray(o))for(let y=0;y<o.length;++y)o[y]=b(o[y],D+1);else for(const y in o)Object.hasOwnProperty.call(o,y)&&(o[y]=b(o[y],D+1))}return o}}),define(ye[13],Ie([1,0,10,3,17,4,9]),function(se,e,i,r,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=b,e.matchesSomeScheme=o,e.getServerRootPath=y,i=Be(i),r=Be(r),R=Be(R);var _;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatCodeBlock="vscode-chat-code-block",a.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",a.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm",a.commentsInput="comment",a.codeSetting="code-setting"})(_||(e.Schemas=_={}));function b(a,f){return C.URI.isUri(a)?(0,w.equalsIgnoreCase)(a.scheme,f):(0,w.startsWithIgnoreCase)(a,f+":")}function o(a,...f){return f.some(m=>b(a,m))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class D{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}setServerRootPath(f,m){this._serverRootPath=y(f,m)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return R.posix.join(this._serverRootPath,_.vscodeRemoteResource)}set(f,m,p){this._hosts[f]=m,this._ports[f]=p}setConnectionToken(f,m){this._connectionTokens[f]=m}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(f){if(this._delegate)try{return this._delegate(f)}catch(t){return i.onUnexpectedError(t),f}const m=f.authority;let p=this._hosts[m];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const S=this._ports[m],g=this._connectionTokens[m];let v=`path=${encodeURIComponent(f.path)}`;return typeof g=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),C.URI.from({scheme:r.isWeb?this._preferredWebSchema:_.vscodeRemoteResource,authority:`${p}:${S}`,path:this._remoteResourcesPath,query:v})}}e.RemoteAuthorities=new D;function y(a,f){return R.posix.join(f??"/",`${a.quality??"oss"}-${a.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class d{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(f){const m=this.toUri(f,se);return this.uriToBrowserUri(m)}uriToBrowserUri(f){return f.scheme===_.vscodeRemote?e.RemoteAuthorities.rewrite(f):f.scheme===_.file&&(r.isNative||r.webWorkerOrigin===`${_.vscodeFileResource}://${d.FALLBACK_AUTHORITY}`)?f.with({scheme:_.vscodeFileResource,authority:f.authority||d.FALLBACK_AUTHORITY,query:null,fragment:null}):f}asFileUri(f){const m=this.toUri(f,se);return this.uriToFileUri(m)}uriToFileUri(f){return f.scheme===_.vscodeFileResource?f.with({scheme:_.file,authority:f.authority!==d.FALLBACK_AUTHORITY?f.authority:null,query:null,fragment:null}):f}toUri(f,m){return C.URI.isUri(f)?f:C.URI.parse(m.toUrl(f))}}e.FileAccess=new d;var E;(function(a){const f=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(f.get("3"));const m="vscode-coi";function p(g){let v;typeof g=="string"?v=new URL(g).searchParams:g instanceof URL?v=g.searchParams:C.URI.isUri(g)&&(v=new URL(g.toString(!0)).searchParams);const t=v?.get(m);if(t)return f.get(t)}a.getHeadersFromQuery=p;function S(g,v,t){if(!globalThis.crossOriginIsolated)return;const l=v&&t?"3":t?"2":"1";g instanceof URLSearchParams?g.set(m,l):g[m]=l}a.addSearchParam=S})(E||(e.COI=E={}))}),define(ye[193],Ie([1,0,104,13,3,4]),function(se,e,i,r,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=D,w=Be(w);class R{constructor(d,E,a){this.id=d,this.dependencies=E,this.callback=a}}class _{static{this.INSTANCE=new _}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(d,E,a)=>{typeof d!="string"&&(a=E,E=d,d=null),(typeof E!="object"||!Array.isArray(E))&&(a=E,E=null),this._defineCalls.push(new R(d,E,a))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this._initialize();const E=await(this._isWebWorker?this._workerLoadScript(d):this._isRenderer?this._rendererLoadScript(d):this._nodeJSLoadScript(d));if(!E)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(E.dependencies)&&E.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${E.dependencies.join(", ")}`);return typeof E.callback=="function"?E.callback([]):E.callback}_rendererLoadScript(d){return new Promise((E,a)=>{const f=document.createElement("script");f.setAttribute("async","async"),f.setAttribute("type","text/javascript");const m=()=>{f.removeEventListener("load",p),f.removeEventListener("error",S)},p=g=>{m(),E(this._defineCalls.pop())},S=g=>{m(),a(g)};f.addEventListener("load",p),f.addEventListener("error",S),this._amdPolicy&&(d=this._amdPolicy.createScriptURL(d)),f.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(f)})}_workerLoadScript(d){return new Promise((E,a)=>{try{this._amdPolicy&&(d=this._amdPolicy.createScriptURL(d)),importScripts(d),E(this._defineCalls.pop())}catch(f){a(f)}})}async _nodeJSLoadScript(d){try{const E=globalThis._VSCODE_NODE_MODULES.fs,a=globalThis._VSCODE_NODE_MODULES.vm,f=globalThis._VSCODE_NODE_MODULES.module,m=C.URI.parse(d).fsPath,p=E.readFileSync(m).toString(),S=f.wrap(p.replace(/^#!.*/,""));return new a.Script(S).runInThisContext().apply(),this._defineCalls.pop()}catch(E){throw E}}}const b=new Map;let o={};typeof globalThis.require=="object"&&(o=globalThis.require.paths??{});async function D(y,d,E){if(i.isESM){E===void 0&&(E=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),o[y]&&(y=o[y]);const a=`${y}/${d}`;if(b.has(a))return b.get(a);let f;if(/^\w[\w\d+.-]*:\/\//.test(a))f=a;else{const g=`${E&&!w.isWeb?r.nodeModulesAsarPath:r.nodeModulesPath}/${a}`;f=r.FileAccess.asBrowserUri(g).toString(!0)}const m=_.INSTANCE.load(f);return b.set(a,m),m}else return await new Promise((a,f)=>{se([y],a,f)}).then(Be)}}),define(ye[20],Ie([1,0,35,37,13,9,3,17,4]),function(se,e,i,r,w,C,R,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=o,e.distinctParents=y,e.toLocalResource=E,r=Be(r),C=Be(C);function o(a){return(0,b.uriToFsPath)(a,!0)}class D{constructor(f){this._ignorePathCasing=f}compare(f,m,p=!1){return f===m?0:(0,_.compare)(this.getComparisonKey(f,p),this.getComparisonKey(m,p))}isEqual(f,m,p=!1){return f===m?!0:!f||!m?!1:this.getComparisonKey(f,p)===this.getComparisonKey(m,p)}getComparisonKey(f,m=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,m,p=!1){if(f.scheme===m.scheme){if(f.scheme===w.Schemas.file)return r.isEqualOrParent(o(f),o(m),this._ignorePathCasing(f))&&f.query===m.query&&(p||f.fragment===m.fragment);if((0,e.isEqualAuthority)(f.authority,m.authority))return r.isEqualOrParent(f.path,m.path,this._ignorePathCasing(f),"/")&&f.query===m.query&&(p||f.fragment===m.fragment)}return!1}joinPath(f,...m){return b.URI.joinPath(f,...m)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return C.posix.basename(f.path)}extname(f){return C.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let m;return f.scheme===w.Schemas.file?m=b.URI.file(C.dirname(o(f))).path:(m=C.posix.dirname(f.path),f.authority&&m.length&&m.charCodeAt(0)!==i.CharCode.Slash&&(console.error(`dirname("${f.toString})) resulted in a relative path`),m="/")),f.with({path:m})}normalizePath(f){if(!f.path.length)return f;let m;return f.scheme===w.Schemas.file?m=b.URI.file(C.normalize(o(f))).path:m=C.posix.normalize(f.path),f.with({path:m})}relativePath(f,m){if(f.scheme!==m.scheme||!(0,e.isEqualAuthority)(f.authority,m.authority))return;if(f.scheme===w.Schemas.file){const g=C.relative(o(f),o(m));return R.isWindows?r.toSlashes(g):g}let p=f.path||"/";const S=m.path||"/";if(this._ignorePathCasing(f)){let g=0;for(const v=Math.min(p.length,S.length);g<v&&!(p.charCodeAt(g)!==S.charCodeAt(g)&&p.charAt(g).toLowerCase()!==S.charAt(g).toLowerCase());g++);p=S.substr(0,g)+p.substr(g)}return C.posix.relative(p,S)}resolvePath(f,m){if(f.scheme===w.Schemas.file){const p=b.URI.file(C.resolve(o(f),m));return f.with({authority:p.authority,path:p.path})}return m=r.toPosixPath(m),f.with({path:C.posix.resolve(f.path,m)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,m){return f===m||f!==void 0&&m!==void 0&&(0,_.equalsIgnoreCase)(f,m)}hasTrailingPathSeparator(f,m=C.sep){if(f.scheme===w.Schemas.file){const p=o(f);return p.length>r.getRoot(p).length&&p[p.length-1]===m}else{const p=f.path;return p.length>1&&p.charCodeAt(p.length-1)===i.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,m=C.sep){return(0,e.hasTrailingPathSeparator)(f,m)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,m=C.sep){let p=!1;if(f.scheme===w.Schemas.file){const S=o(f);p=S!==void 0&&S.length===r.getRoot(S).length&&S[S.length-1]===m}else{m="/";const S=f.path;p=S.length===1&&S.charCodeAt(S.length-1)===i.CharCode.Slash}return!p&&!(0,e.hasTrailingPathSeparator)(f,m)?f.with({path:f.path+"/"}):f}}e.ExtUri=D,e.extUri=new D(()=>!1),e.extUriBiasedIgnorePathCase=new D(a=>a.scheme===w.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new D(a=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function y(a,f){const m=[];for(let p=0;p<a.length;p++){const S=f(a[p]);a.some((g,v)=>v===p?!1:(0,e.isEqualOrParent)(S,f(g)))||m.push(a[p])}return m}var d;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function f(m){const p=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(v=>{const[t,l]=v.split(":");t&&l&&p.set(t,l)});const g=m.path.substring(0,m.path.indexOf(";"));return g&&p.set(a.META_DATA_MIME,g),p}a.parseMetaData=f})(d||(e.DataUri=d={}));function E(a,f,m){if(f){let p=a.path;return p&&p[0]!==C.posix.sep&&(p=C.posix.sep+p),a.with({scheme:m,authority:f,path:p})}return a.with({scheme:m})}}),define(ye[14],Ie([1,0,19,10,6,2,20,3,171,65]),function(se,e,i,r,w,C,R,_,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=D,e.createCancelablePromise=y,e.raceCancellation=d,e.raceCancellationError=E,e.raceCancellablePromises=a,e.raceTimeout=f,e.asPromise=m,e.promiseWithResolvers=p,e.timeout=u,e.disposableTimeout=I,e.sequence=T,e.first=A,e.firstParallel=O,e.retry=z,e.createCancelableAsyncIterable=U;function D(G){return!!G&&typeof G.then=="function"}function y(G){const F=new i.CancellationTokenSource,V=G(F.token),oe=new Promise((de,Ce)=>{const Ne=F.token.onCancellationRequested(()=>{Ne.dispose(),Ce(new r.CancellationError)});Promise.resolve(V).then(ge=>{Ne.dispose(),F.dispose(),de(ge)},ge=>{Ne.dispose(),F.dispose(),Ce(ge)})});return new class{cancel(){F.cancel(),F.dispose()}then(de,Ce){return oe.then(de,Ce)}catch(de){return this.then(void 0,de)}finally(de){return oe.finally(de)}}}function d(G,F,V){return new Promise((oe,de)=>{const Ce=F.onCancellationRequested(()=>{Ce.dispose(),oe(V)});G.then(oe,de).finally(()=>Ce.dispose())})}function E(G,F){return new Promise((V,oe)=>{const de=F.onCancellationRequested(()=>{de.dispose(),oe(new r.CancellationError)});G.then(V,oe).finally(()=>de.dispose())})}async function a(G){let F=-1;const V=G.map((oe,de)=>oe.then(Ce=>(F=de,Ce)));try{return await Promise.race(V)}finally{G.forEach((oe,de)=>{de!==F&&oe.cancel()})}}function f(G,F,V){let oe;const de=setTimeout(()=>{oe?.(void 0),V?.()},F);return Promise.race([G.finally(()=>clearTimeout(de)),new Promise(Ce=>oe=Ce)])}function m(G){return new Promise((F,V)=>{const oe=G();D(oe)?oe.then(F,V):F(oe)})}function p(){let G,F;return{promise:new Promise((oe,de)=>{G=oe,F=de}),resolve:G,reject:F}}class S{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const V=()=>{if(this.queuedPromise=null,this.isDisposed)return;const oe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,oe};this.queuedPromise=new Promise(oe=>{this.activePromise.then(V,V).then(oe)})}return new Promise((V,oe)=>{this.queuedPromise.then(V,oe)})}return this.activePromise=F(),new Promise((V,oe)=>{this.activePromise.then(de=>{this.activePromise=null,V(de)},de=>{this.activePromise=null,oe(de)})})}dispose(){this.isDisposed=!0}}e.Throttler=S;class g{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=g;class v{constructor(){this.promiseMap=new Map}queue(F,V){const de=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(V).finally(()=>{this.promiseMap.get(F)===de&&this.promiseMap.delete(F)});return this.promiseMap.set(F,de),de}}e.SequencerByKey=v;const t=(G,F)=>{let V=!0;const oe=setTimeout(()=>{V=!1,F()},G);return{isTriggered:()=>V,dispose:()=>{clearTimeout(oe),V=!1}}},l=G=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,G())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};class n{constructor(F){this.defaultDelay=F,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,V=this.defaultDelay){this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((de,Ce)=>{this.doResolve=de,this.doReject=Ce}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const de=this.task;return this.task=null,de()}}));const oe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=V===b.MicrotaskDelay?l(oe):t(V,oe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new r.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=n;class h{constructor(F){this.delayer=new n(F),this.throttler=new S}trigger(F,V){return this.delayer.trigger(()=>this.throttler.queue(F),V)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=h;class s{constructor(){this._isOpen=!1,this._promise=new Promise((F,V)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class c extends s{constructor(F){super(),this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function u(G,F){return F?new Promise((V,oe)=>{const de=setTimeout(()=>{Ce.dispose(),V()},G),Ce=F.onCancellationRequested(()=>{clearTimeout(de),Ce.dispose(),oe(new r.CancellationError)})}):y(V=>u(G,V))}function I(G,F=0,V){const oe=setTimeout(()=>{G(),V&&de.dispose()},F),de=(0,C.toDisposable)(()=>{clearTimeout(oe),V?.deleteAndLeak(de)});return V?.add(de),de}function T(G){const F=[];let V=0;const oe=G.length;function de(){return V<oe?G[V++]():null}function Ce(Ne){Ne!=null&&F.push(Ne);const ge=de();return ge?ge.then(Ce):Promise.resolve(F)}return Promise.resolve(null).then(Ce)}function A(G,F=oe=>!!oe,V=null){let oe=0;const de=G.length,Ce=()=>{if(oe>=de)return Promise.resolve(V);const Ne=G[oe++];return Promise.resolve(Ne()).then(pe=>F(pe)?Promise.resolve(pe):Ce())};return Ce()}function O(G,F=oe=>!!oe,V=null){if(G.length===0)return Promise.resolve(V);let oe=G.length;const de=()=>{oe=-1;for(const Ce of G)Ce.cancel?.()};return new Promise((Ce,Ne)=>{for(const ge of G)ge.then(pe=>{--oe>=0&&F(pe)?(de(),Ce(pe)):oe===0&&Ce(V)}).catch(pe=>{--oe>=0&&(de(),Ne(pe))})})}class k{constructor(F){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new w.Emitter}whenIdle(){return this.size>0?w.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(F){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((V,oe)=>{this.outstandingPromises.push({factory:F,c:V,e:oe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const V=F.factory();V.then(F.c,F.e),V.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=k;class P extends k{constructor(){super(1)}}e.Queue=P;class B{constructor(){this.sequentializer=new ne,this.tasks=0}queue(F){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,F())):this.sequentializer.run(this.tasks++,F())}}e.LimitedQueue=B;class Y{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const F=new H;return this.drainers.add(F),F.p}isDrained(){for(const[,F]of this.queues)if(F.size>0)return!1;return!0}queueSize(F,V=R.extUri){const oe=V.getComparisonKey(F);return this.queues.get(oe)?.size??0}queueFor(F,V,oe=R.extUri){const de=oe.getComparisonKey(F);let Ce=this.queues.get(de);if(!Ce){Ce=new P;const Ne=this.drainListenerCount++,ge=w.Event.once(Ce.onDrained)(()=>{Ce?.dispose(),this.queues.delete(de),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(Ne),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new C.DisposableMap),this.drainListeners.set(Ne,ge),this.queues.set(de,Ce)}return Ce.queue(V)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const F of this.drainers)F.complete();this.drainers.clear()}dispose(){for(const[,F]of this.queues)F.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=Y;class X{constructor(F,V){this._isDisposed=!1,this._token=-1,typeof F=="function"&&typeof V=="number"&&this.setIfNotSet(F,V)}dispose(){this.cancel(),this._isDisposed=!0}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,V){if(this._isDisposed)throw new r.BugIndicatingError("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},V)}setIfNotSet(F,V){if(this._isDisposed)throw new r.BugIndicatingError("Calling 'setIfNotSet' on a disposed TimeoutTimer");this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},V))}}e.TimeoutTimer=X;class re{constructor(){this.disposable=void 0,this.isDisposed=!1}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(F,V,oe=globalThis){if(this.isDisposed)throw new r.BugIndicatingError("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const de=oe.setInterval(()=>{F()},V);this.disposable=(0,C.toDisposable)(()=>{oe.clearInterval(de),this.disposable=void 0})}dispose(){this.cancel(),this.isDisposed=!0}}e.IntervalTimer=re;class te{constructor(F,V){this.timeoutToken=-1,this.runner=F,this.timeout=V,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=te;class Z{constructor(F,V){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.runner=F,this.timeout=V,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(F=this.timeout){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(F/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=Z;class fe extends te{constructor(F,V){super(F,V),this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner?.(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=fe;class K extends C.Disposable{constructor(F,V){super(),this.options=F,this.handler=V,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.options.maxBufferedWork)return!1}else if(this.pending+F.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const V of F)this.pendingWork.push(V);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new te(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(G,F)=>{(0,_.setTimeout0)(()=>{if(V)return;const oe=Date.now()+15;F(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,oe-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0)}}}:e._runWhenIdle=(G,F,V)=>{const oe=G.requestIdleCallback(F,typeof V=="number"?{timeout:V}:void 0);let de=!1;return{dispose(){de||(de=!0,G.cancelIdleCallback(oe))}}},e.runWhenGlobalIdle=G=>(0,e._runWhenIdle)(globalThis,G)}();class ae{constructor(F,V){this._didRun=!1,this._executor=()=>{try{this._value=V()}catch(oe){this._error=oe}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(F,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=ae;class x extends ae{constructor(F){super(globalThis,F)}}e.GlobalIdleValue=x;async function z(G,F,V){let oe;for(let de=0;de<V;de++)try{return await G()}catch(Ce){oe=Ce,await u(F)}throw oe}class ne{isRunning(F){return typeof F=="number"?this._running?.taskId===F:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(F,V,oe){return this._running={taskId:F,cancel:()=>oe?.(),promise:V},V.then(()=>this.doneRunning(F),()=>this.doneRunning(F)),V}doneRunning(F){this._running&&F===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const F=this._queued;this._queued=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}queue(F){if(this._queued)this._queued.run=F;else{const{promise:V,resolve:oe,reject:de}=p();this._queued={run:F,promise:V,promiseResolve:oe,promiseReject:de}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=ne;class le{constructor(F,V=()=>Date.now()){this.interval=F,this.nowFn=V,this.lastIncrementTime=0,this.value=0}increment(){const F=this.nowFn();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=le;var ve;(function(G){G[G.Resolved=0]="Resolved",G[G.Rejected=1]="Rejected"})(ve||(ve={}));class H{get isRejected(){return this.outcome?.outcome===ve.Rejected}get isResolved(){return this.outcome?.outcome===ve.Resolved}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===ve.Resolved?this.outcome?.value:void 0}constructor(){this.p=new Promise((F,V)=>{this.completeCallback=F,this.errorCallback=V})}complete(F){return new Promise(V=>{this.completeCallback(F),this.outcome={outcome:ve.Resolved,value:F},V()})}error(F){return new Promise(V=>{this.errorCallback(F),this.outcome={outcome:ve.Rejected,value:F},V()})}cancel(){return this.error(new r.CancellationError)}}e.DeferredPromise=H;var ce;(function(G){async function F(oe){let de;const Ce=await Promise.all(oe.map(Ne=>Ne.then(ge=>ge,ge=>{de||(de=ge)})));if(typeof de<"u")throw de;return Ce}G.settled=F;function V(oe){return new Promise(async(de,Ce)=>{try{await oe(de,Ce)}catch(Ne){Ce(Ne)}})}G.withAsyncBody=V})(ce||(e.Promises=ce={}));class J{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(F){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=F.then(V=>(this._value=V,this._isResolved=!0,V),V=>{throw this._error=V,this._isResolved=!0,V})}requireValue(){if(!this._isResolved)throw new r.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=J;class W{constructor(F){this._compute=F,this._promise=new o.Lazy(()=>new J(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=W;var L;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(L||(L={}));class Q{static fromArray(F){return new Q(V=>{V.emitMany(F)})}static fromPromise(F){return new Q(async V=>{V.emitMany(await F)})}static fromPromises(F){return new Q(async V=>{await Promise.all(F.map(async oe=>V.emitOne(await oe)))})}static merge(F){return new Q(async V=>{await Promise.all(F.map(async oe=>{for await(const de of oe)V.emitOne(de)}))})}static{this.EMPTY=Q.fromArray([])}constructor(F,V){this._state=L.Initial,this._results=[],this._error=null,this._onReturn=V,this._onStateChanged=new w.Emitter,queueMicrotask(async()=>{const oe={emitOne:de=>this.emitOne(de),emitMany:de=>this.emitMany(de),reject:de=>this.reject(de)};try{await Promise.resolve(F(oe)),this.resolve()}catch(de){this.reject(de)}finally{oe.emitOne=void 0,oe.emitMany=void 0,oe.reject=void 0}})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this._state===L.DoneError)throw this._error;if(F<this._results.length)return{done:!1,value:this._results[F++]};if(this._state===L.DoneOK)return{done:!0,value:void 0};await w.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(F,V){return new Q(async oe=>{for await(const de of F)oe.emitOne(V(de))})}map(F){return Q.map(this,F)}static filter(F,V){return new Q(async oe=>{for await(const de of F)V(de)&&oe.emitOne(de)})}filter(F){return Q.filter(this,F)}static coalesce(F){return Q.filter(F,V=>!!V)}coalesce(){return Q.coalesce(this)}static async toPromise(F){const V=[];for await(const oe of F)V.push(oe);return V}toPromise(){return Q.toPromise(this)}emitOne(F){this._state===L.Initial&&(this._results.push(F),this._onStateChanged.fire())}emitMany(F){this._state===L.Initial&&(this._results=this._results.concat(F),this._onStateChanged.fire())}resolve(){this._state===L.Initial&&(this._state=L.DoneOK,this._onStateChanged.fire())}reject(F){this._state===L.Initial&&(this._state=L.DoneError,this._error=F,this._onStateChanged.fire())}}e.AsyncIterableObject=Q;class $ extends Q{constructor(F,V){super(V),this._source=F}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=$;function U(G){const F=new i.CancellationTokenSource,V=G(F.token);return new $(F,async oe=>{const de=F.token.onCancellationRequested(()=>{de.dispose(),F.dispose(),oe.reject(new r.CancellationError)});try{for await(const Ce of V){if(F.token.isCancellationRequested)return;oe.emitOne(Ce)}de.dispose(),F.dispose()}catch(Ce){de.dispose(),F.dispose(),oe.reject(Ce)}})}class q{constructor(F){this._deferred=new H,this._asyncIterable=new Q(de=>{if(V){de.reject(V);return}return oe&&de.emitMany(oe),this._errorFn=Ce=>de.reject(Ce),this._emitFn=Ce=>de.emitOne(Ce),this._deferred.p},F);let V,oe;this._emitFn=de=>{oe||(oe=[]),oe.push(de)},this._errorFn=de=>{V||(V=de)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(F){this._errorFn(F),this._deferred.complete()}emitOne(F){this._emitFn(F)}}e.AsyncIterableSource=q}),define(ye[86],Ie([1,0,18,14,35,37,26,9,3,17]),function(se,e,i,r,w,C,R,_,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=D,e.splitGlobAware=f,e.match=B,e.parse=Y,e.isRelativePattern=X,e.getBasenameTerms=re,e.getPathTerms=te,e.patternsEquals=ae;function D(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const y="[/\\\\]",d="[^/\\\\]",E=/\//g;function a(x,z){switch(x){case 0:return"";case 1:return`${d}*?`;default:return`(?:${y}|${d}+${y}${z?`|${y}${d}+`:""})*?`}}function f(x,z){if(!x)return[];const ne=[];let le=!1,ve=!1,H="";for(const ce of x){switch(ce){case z:if(!le&&!ve){ne.push(H),H="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":ve=!0;break;case"]":ve=!1;break}H+=ce}return H&&ne.push(H),ne}function m(x){if(!x)return"";let z="";const ne=f(x,e.GLOB_SPLIT);if(ne.every(le=>le===e.GLOBSTAR))z=".*";else{let le=!1;ne.forEach((ve,H)=>{if(ve===e.GLOBSTAR){if(le)return;z+=a(2,H===ne.length-1)}else{let ce=!1,J="",W=!1,L="";for(const Q of ve){if(Q!=="}"&&ce){J+=Q;continue}if(W&&(Q!=="]"||!L)){let $;Q==="-"?$=Q:(Q==="^"||Q==="!")&&!L?$="^":Q===e.GLOB_SPLIT?$="":$=(0,o.escapeRegExpCharacters)(Q),L+=$;continue}switch(Q){case"{":ce=!0;continue;case"[":W=!0;continue;case"}":{const U=`(?:${f(J,",").map(q=>m(q)).join("|")})`;z+=U,ce=!1,J="";break}case"]":{z+="["+L+"]",W=!1,L="";break}case"?":z+=d;continue;case"*":z+=a(1);continue;default:z+=(0,o.escapeRegExpCharacters)(Q)}}H<ne.length-1&&(ne[H+1]!==e.GLOBSTAR||H+2<ne.length)&&(z+=y)}le=ve===e.GLOBSTAR})}return z}const p=/^\*\*\/\*\.[\w\.-]+$/,S=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,v=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new R.LRUCache(1e4),h=function(){return!1},s=function(){return null};function c(x,z){if(!x)return s;let ne;typeof x!="string"?ne=x.pattern:ne=x,ne=ne.trim();const le=`${ne}_${!!z.trimForExclusions}`;let ve=n.get(le);if(ve)return u(ve,x);let H;return p.test(ne)?ve=T(ne.substr(4),ne):(H=S.exec(I(ne,z)))?ve=A(H[1],ne):(z.trimForExclusions?v:g).test(ne)?ve=O(ne,z):(H=t.exec(I(ne,z)))?ve=k(H[1].substr(1),ne,!0):(H=l.exec(I(ne,z)))?ve=k(H[1],ne,!1):ve=P(ne),n.set(le,ve),u(ve,x)}function u(x,z){if(typeof z=="string")return x;const ne=function(le,ve){return(0,C.isEqualOrParent)(le,z.base,!b.isLinux)?x((0,o.ltrim)(le.substr(z.base.length),_.sep),ve):null};return ne.allBasenames=x.allBasenames,ne.allPaths=x.allPaths,ne.basenames=x.basenames,ne.patterns=x.patterns,ne}function I(x,z){return z.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function T(x,z){return function(ne,le){return typeof ne=="string"&&ne.endsWith(x)?z:null}}function A(x,z){const ne=`/${x}`,le=`\\${x}`,ve=function(ce,J){return typeof ce!="string"?null:J?J===x?z:null:ce===x||ce.endsWith(ne)||ce.endsWith(le)?z:null},H=[x];return ve.basenames=H,ve.patterns=[z],ve.allBasenames=H,ve}function O(x,z){const ne=K(x.slice(1,-1).split(",").map(J=>c(J,z)).filter(J=>J!==s),x),le=ne.length;if(!le)return s;if(le===1)return ne[0];const ve=function(J,W){for(let L=0,Q=ne.length;L<Q;L++)if(ne[L](J,W))return x;return null},H=ne.find(J=>!!J.allBasenames);H&&(ve.allBasenames=H.allBasenames);const ce=ne.reduce((J,W)=>W.allPaths?J.concat(W.allPaths):J,[]);return ce.length&&(ve.allPaths=ce),ve}function k(x,z,ne){const le=_.sep===_.posix.sep,ve=le?x:x.replace(E,_.sep),H=_.sep+ve,ce=_.posix.sep+x;let J;return ne?J=function(W,L){return typeof W=="string"&&(W===ve||W.endsWith(H)||!le&&(W===x||W.endsWith(ce)))?z:null}:J=function(W,L){return typeof W=="string"&&(W===ve||!le&&W===x)?z:null},J.allPaths=[(ne?"*/":"./")+x],J}function P(x){try{const z=new RegExp(`^${m(x)}$`);return function(ne){return z.lastIndex=0,typeof ne=="string"&&z.test(ne)?x:null}}catch{return s}}function B(x,z,ne){return!x||typeof z!="string"?!1:Y(x)(z,void 0,ne)}function Y(x,z={}){if(!x)return h;if(typeof x=="string"||X(x)){const ne=c(x,z);if(ne===s)return h;const le=function(ve,H){return!!ne(ve,H)};return ne.allBasenames&&(le.allBasenames=ne.allBasenames),ne.allPaths&&(le.allPaths=ne.allPaths),le}return Z(x,z)}function X(x){const z=x;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}function re(x){return x.allBasenames||[]}function te(x){return x.allPaths||[]}function Z(x,z){const ne=K(Object.getOwnPropertyNames(x).map(J=>fe(J,x[J],z)).filter(J=>J!==s)),le=ne.length;if(!le)return s;if(!ne.some(J=>!!J.requiresSiblings)){if(le===1)return ne[0];const J=function(Q,$){let U;for(let q=0,G=ne.length;q<G;q++){const F=ne[q](Q,$);if(typeof F=="string")return F;(0,r.isThenable)(F)&&(U||(U=[]),U.push(F))}return U?(async()=>{for(const q of U){const G=await q;if(typeof G=="string")return G}return null})():null},W=ne.find(Q=>!!Q.allBasenames);W&&(J.allBasenames=W.allBasenames);const L=ne.reduce((Q,$)=>$.allPaths?Q.concat($.allPaths):Q,[]);return L.length&&(J.allPaths=L),J}const ve=function(J,W,L){let Q,$;for(let U=0,q=ne.length;U<q;U++){const G=ne[U];G.requiresSiblings&&L&&(W||(W=(0,_.basename)(J)),Q||(Q=W.substr(0,W.length-(0,_.extname)(J).length)));const F=G(J,W,Q,L);if(typeof F=="string")return F;(0,r.isThenable)(F)&&($||($=[]),$.push(F))}return $?(async()=>{for(const U of $){const q=await U;if(typeof q=="string")return q}return null})():null},H=ne.find(J=>!!J.allBasenames);H&&(ve.allBasenames=H.allBasenames);const ce=ne.reduce((J,W)=>W.allPaths?J.concat(W.allPaths):J,[]);return ce.length&&(ve.allPaths=ce),ve}function fe(x,z,ne){if(z===!1)return s;const le=c(x,ne);if(le===s)return s;if(typeof z=="boolean")return le;if(z){const ve=z.when;if(typeof ve=="string"){const H=(ce,J,W,L)=>{if(!L||!le(ce,J))return null;const Q=ve.replace("$(basename)",()=>W),$=L(Q);return(0,r.isThenable)($)?$.then(U=>U?x:null):$?x:null};return H.requiresSiblings=!0,H}}return le}function K(x,z){const ne=x.filter(J=>!!J.basenames);if(ne.length<2)return x;const le=ne.reduce((J,W)=>{const L=W.basenames;return L?J.concat(L):J},[]);let ve;if(z){ve=[];for(let J=0,W=le.length;J<W;J++)ve.push(z)}else ve=ne.reduce((J,W)=>{const L=W.patterns;return L?J.concat(L):J},[]);const H=function(J,W){if(typeof J!="string")return null;if(!W){let Q;for(Q=J.length;Q>0;Q--){const $=J.charCodeAt(Q-1);if($===w.CharCode.Slash||$===w.CharCode.Backslash)break}W=J.substr(Q)}const L=le.indexOf(W);return L!==-1?ve[L]:null};H.basenames=le,H.patterns=ve,H.allBasenames=le;const ce=x.filter(J=>!J.basenames);return ce.push(H),ce}function ae(x,z){return(0,i.equals)(x,z,(ne,le)=>typeof ne=="string"&&typeof le=="string"?ne===le:typeof ne!="string"&&typeof le!="string"?ne.base===le.base&&ne.pattern===le.pattern:!1)}}),define(ye[111],Ie([1,0,10,174,20,17,4]),function(se,e,i,r,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0,e.isEmptyMarkdownString=o,e.isMarkdownString=D,e.markdownStringEqual=y,e.escapeMarkdownSyntaxTokens=d,e.appendEscapedMarkdownCodeBlockFence=E,e.escapeDoubleQuotes=a,e.removeMarkdownEscapes=f,e.parseHrefAndDimensions=m;var _;(function(p){p[p.Paragraph=0]="Paragraph",p[p.Break=1]="Break"})(_||(e.MarkdownStringTextNewlineStyle=_={}));class b{constructor(S="",g=!1){if(this.value=S,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(S,g=_.Paragraph){return this.value+=d(this.supportThemeIcons?(0,r.escapeIcons)(S):S).replace(/([ \t]+)/g,(v,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===_.Break?`\\
`:`

`),this}appendMarkdown(S){return this.value+=S,this}appendCodeblock(S,g){return this.value+=`
${E(g,S)}
`,this}appendLink(S,g,v){return this.value+="[",this.value+=this._escape(g,"]"),this.value+="](",this.value+=this._escape(String(S),")"),v&&(this.value+=` "${this._escape(this._escape(v,'"'),")")}"`),this.value+=")",this}_escape(S,g){const v=new RegExp((0,C.escapeRegExpCharacters)(g),"g");return S.replace(v,(t,l)=>S.charAt(l-1)!=="\\"?`\\${t}`:t)}}e.MarkdownString=b;function o(p){return D(p)?!p.value:Array.isArray(p)?p.every(o):!0}function D(p){return p instanceof b?!0:p&&typeof p=="object"?typeof p.value=="string"&&(typeof p.isTrusted=="boolean"||typeof p.isTrusted=="object"||p.isTrusted===void 0)&&(typeof p.supportThemeIcons=="boolean"||p.supportThemeIcons===void 0):!1}function y(p,S){return p===S?!0:!p||!S?!1:p.value===S.value&&p.isTrusted===S.isTrusted&&p.supportThemeIcons===S.supportThemeIcons&&p.supportHtml===S.supportHtml&&(p.baseUri===S.baseUri||!!p.baseUri&&!!S.baseUri&&(0,w.isEqual)(R.URI.from(p.baseUri),R.URI.from(S.baseUri)))}function d(p){return p.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function E(p,S){const g=p.match(/^`+/gm)?.reduce((t,l)=>t.length>l.length?t:l).length??0,v=g>=3?g+1:3;return[`${"`".repeat(v)}${S}`,p,`${"`".repeat(v)}`].join(`
`)}function a(p){return p.replace(/"/g,"&quot;")}function f(p){return p&&p.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m(p){const S=[],g=p.split("|").map(t=>t.trim());p=g[0];const v=g[1];if(v){const t=/height=(\d+)/.exec(v),l=/width=(\d+)/.exec(v),n=t?t[1]:"",h=l?l[1]:"",s=isFinite(parseInt(h)),c=isFinite(parseInt(n));s&&S.push(`width="${h}"`),c&&S.push(`height="${n}"`)}return{href:p,dimensions:S}}}),define(ye[194],Ie([1,0,18,37,9,3,20,17]),function(se,e,i,r,w,C,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathLabel=b,e.normalizeDriveLetter=D,e.tildify=d,e.untildify=E,e.shorten=p,e.template=g,e.mnemonicMenuLabel=v,e.mnemonicButtonLabel=t,e.unmnemonicLabel=l,e.splitRecentLabel=n;function b(s,c){const{os:u,tildify:I,relative:T}=c;if(T){const k=o(s,T,u);if(typeof k=="string")return k}let A=s.fsPath;if(u===C.OperatingSystem.Windows&&!C.isWindows?A=A.replace(/\//g,"\\"):u!==C.OperatingSystem.Windows&&C.isWindows&&(A=A.replace(/\\/g,"/")),u!==C.OperatingSystem.Windows&&I?.userHome){const k=I.userHome.fsPath;let P;s.scheme!==I.userHome.scheme&&s.path[0]===w.posix.sep&&s.path[1]!==w.posix.sep?P=I.userHome.with({path:s.path}).fsPath:P=A,A=d(P,k,u)}return(u===C.OperatingSystem.Windows?w.win32:w.posix).normalize(D(A,u===C.OperatingSystem.Windows))}function o(s,c,u){const I=u===C.OperatingSystem.Windows?w.win32:w.posix,T=u===C.OperatingSystem.Linux?R.extUri:R.extUriIgnorePathCase,A=c.getWorkspace(),O=(0,i.firstOrDefault)(A.folders);if(!O)return;s.scheme!==O.uri.scheme&&s.path[0]===w.posix.sep&&s.path[1]!==w.posix.sep&&(s=O.uri.with({path:s.path}));const k=c.getWorkspaceFolder(s);if(!k)return;let P;if(T.isEqual(k.uri,s)?P="":P=T.relativePath(k.uri,s)??"",P&&(P=I.normalize(P)),A.folders.length>1&&!c.noPrefix){const B=k.name?k.name:T.basenameOrAuthority(k.uri);P=P?`${B} \u2022 ${P}`:B}return P}function D(s,c=C.isWindows){return(0,r.hasDriveLetter)(s,c)?s.charAt(0).toUpperCase()+s.slice(1):s}let y=Object.create(null);function d(s,c,u=C.OS){if(u===C.OperatingSystem.Windows||!s||!c)return s;let I=y.original===c?y.normalized:void 0;I||(I=c,C.isWindows&&(I=(0,r.toSlashes)(I)),I=`${(0,_.rtrim)(I,w.posix.sep)}${w.posix.sep}`,y={original:c,normalized:I});let T=s;return C.isWindows&&(T=(0,r.toSlashes)(T)),(u===C.OperatingSystem.Linux?T.startsWith(I):(0,_.startsWithIgnoreCase)(T,I))?`~/${T.substr(I.length)}`:s}function E(s,c){return s.replace(/^~($|\/|\\)/,`${c}$1`)}const a="\u2026",f="\\\\",m="~";function p(s,c=w.sep){const u=new Array(s.length);let I=!1;for(let T=0;T<s.length;T++){const A=s[T];if(A===""){u[T]=`.${c}`;continue}if(!A){u[T]=A;continue}I=!0;let O="",k=A;k.indexOf(f)===0?(O=k.substr(0,k.indexOf(f)+f.length),k=k.substr(k.indexOf(f)+f.length)):k.indexOf(c)===0?(O=k.substr(0,k.indexOf(c)+c.length),k=k.substr(k.indexOf(c)+c.length)):k.indexOf(m)===0&&(O=k.substr(0,k.indexOf(m)+m.length),k=k.substr(k.indexOf(m)+m.length));const P=k.split(c);for(let B=1;I&&B<=P.length;B++)for(let Y=P.length-B;I&&Y>=0;Y--){I=!1;let X=P.slice(Y,Y+B).join(c);for(let re=0;!I&&re<s.length;re++)if(re!==T&&s[re]&&s[re].indexOf(X)>-1){const te=Y+B===P.length,Z=Y>0&&s[re].indexOf(c)>-1?c+X:X,fe=s[re].endsWith(Z);I=!te||fe}if(!I){let re="";(P[0].endsWith(":")||O!=="")&&(Y===1&&(Y=0,B++,X=P[0]+c+X),Y>0&&(re=P[0]+c),re=O+re),Y>0&&(re=re+a+c),re=re+X,Y+B<P.length&&(re=re+c+a),u[T]=re}}I&&(u[T]=A)}return u}var S;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(S||(S={}));function g(s,c=Object.create(null)){const u=[];let I=!1,T="";for(const A of s)if(A==="$"||I&&A==="{")T&&u.push({value:T,type:S.TEXT}),T="",I=!0;else if(A==="}"&&I){const O=c[T];if(typeof O=="string")O.length&&u.push({value:O,type:S.VARIABLE});else if(O){const k=u[u.length-1];(!k||k.type!==S.SEPARATOR)&&u.push({value:O.label,type:S.SEPARATOR})}T="",I=!1}else T+=A;return T&&!I&&u.push({value:T,type:S.TEXT}),u.filter((A,O)=>{if(A.type===S.SEPARATOR){const k=u[O-1],P=u[O+1];return[k,P].every(B=>B&&(B.type===S.VARIABLE||B.type===S.TEXT)&&B.value.length>0)}return!0}).map(A=>A.value).join("")}function v(s,c){return C.isMacintosh||c?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):s.replace(/&&|&/g,u=>u==="&"?"&&":"&")}function t(s,c){return C.isMacintosh||c?s.replace(/\(&&\w\)|&&/g,""):C.isWindows?s.replace(/&&|&/g,u=>u==="&"?"&&":"&"):s.replace(/&&/g,"_")}function l(s){return s.replace(/&/g,"&&")}function n(s){if(s.endsWith("]")){const c=s.lastIndexOf(" [",s.length-2);if(c!==-1){const u=h(s.substring(0,c)),I=s.substring(c);return{name:u.name+I,parentPath:u.parentPath}}}return h(s)}function h(s){const c=s.indexOf("/")!==-1?w.posix:w.win32,u=c.basename(s),I=c.dirname(s);return u.length?{name:u,parentPath:I}:{name:I,parentPath:""}}}),define(ye[59],Ie([1,0,15,81,4]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=b,e.transformIncomingURIs=D,e.transformAndReviveIncomingURIs=y;function C(d){return d.toJSON()}class R{constructor(E){this._uriTransformer=E}transformIncoming(E){const a=this._uriTransformer.transformIncoming(E);return a===E?E:C(w.URI.from(a))}transformOutgoing(E){const a=this._uriTransformer.transformOutgoing(E);return a===E?E:C(w.URI.from(a))}transformOutgoingURI(E){const a=this._uriTransformer.transformOutgoing(E);return a===E?E:w.URI.from(a)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(d){return d}transformOutgoing(d){return d}transformOutgoingURI(d){return d}transformOutgoingScheme(d){return d}};function _(d,E,a){if(!d||a>200)return null;if(typeof d=="object"){if(d instanceof w.URI)return E.transformOutgoing(d);for(const f in d)if(Object.hasOwnProperty.call(d,f)){const m=_(d[f],E,a+1);m!==null&&(d[f]=m)}}return null}function b(d,E){const a=_(d,E,0);return a===null?d:a}function o(d,E,a,f){if(!d||f>200)return null;if(typeof d=="object"){if(d.$mid===r.MarshalledId.Uri)return a?w.URI.revive(E.transformIncoming(d)):E.transformIncoming(d);if(d instanceof i.VSBuffer)return null;for(const m in d)if(Object.hasOwnProperty.call(d,m)){const p=o(d[m],E,a,f+1);p!==null&&(d[m]=p)}}return null}function D(d,E){const a=o(d,E,!1,0);return a===null?d:a}function y(d,E){const a=o(d,E,!0,0);return a===null?d:a}}),define(ye[112],Ie([1,0,32,67,23,177,3]),function(se,e,i,r,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.virtualMachineHint=void 0,e.getMachineId=b,e.getSqmMachineId=y,e.getdevDeviceId=d,w=Be(w),e.virtualMachineHint=new class{_isVirtualMachineMacAddress(E){return this._virtualMachineOUIs||(this._virtualMachineOUIs=r.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(E)}value(){if(this._value===void 0){let E=0,a=0;const f=(0,i.networkInterfaces)();for(const m in f){const p=f[m];if(p)for(const{mac:S,internal:g}of p)g||(a+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(E+=1))}this._value=a>0?E/a:0}return this._value}};let _;async function b(E){return _||(_=(async()=>await o(E)||w.generateUuid())()),_}async function o(E){try{const a=await new Promise((m,p)=>{se(["crypto"],m,p)}).then(Be),f=(0,C.getMac)();return a.createHash("sha256").update(f,"utf8").digest("hex")}catch(a){E(a);return}}const D="Software\\Microsoft\\SQMClient";async function y(E){if(R.isWindows){const a=await new Promise((f,m)=>{se(["@vscode/windows-registry"],f,m)}).then(Be);try{return a.GetStringRegKey("HKEY_LOCAL_MACHINE",D,"MachineId")||""}catch(f){return E(f),""}}return""}async function d(E){try{return await(await new Promise((m,p)=>{se(["@vscode/deviceid"],m,p)}).then(Be)).getDeviceId()}catch(a){return E(a),""}}}),define(ye[195],Ie([1,0,31,331,332,3]),function(se,e,i,r,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getOSReleaseInfo=R,C=Be(C);async function R(_){if(C.isMacintosh||C.isWindows)return;let b;for(const o of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{b=await(0,r.open)(o,i.constants.R_OK);break}catch{}if(!b){_("Unable to retrieve release information from known identifier paths.");return}try{const o=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),D={id:"unknown"};for await(const y of(0,w.createInterface)({input:b.createReadStream(),crlfDelay:1/0})){if(!y.includes("="))continue;const d=y.split("=")[0].toUpperCase().trim();if(o.has(d)){const E=y.split("=")[1].replace(/"/g,"").toLowerCase().trim();d==="ID"||d==="DISTRIB_ID"?D.id=E:d==="ID_LIKE"?D.id_like=E:(d==="VERSION_ID"||d==="DISTRIB_RELEASE")&&(D.version_id=E)}}return D}catch(o){_(o)}}}),define(ye[25],Ie([1,0,31,32,333,14,37,107,9,3,20,4]),function(se,e,i,r,w,C,R,_,b,o,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=g,e.whenDeleted=l,e.configureFlushOnWrite=u,e.writeFileSync=T,i=Be(i);var d;(function(Z){Z[Z.UNLINK=0]="UNLINK",Z[Z.MOVE=1]="MOVE"})(d||(e.RimRafMode=d={}));async function E(Z,fe=d.UNLINK,K){if((0,R.isRootOrDriveLetter)(Z))throw new Error("rimraf - will refuse to recursively delete root");return fe===d.UNLINK?f(Z):a(Z,K)}async function a(Z,fe=(0,R.randomPath)((0,r.tmpdir)())){try{try{await i.promises.rename(Z,fe)}catch(K){return K.code==="ENOENT"?void 0:f(Z)}f(fe).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function f(Z){return i.promises.rm(Z,{recursive:!0,force:!0,maxRetries:3})}function m(Z){if((0,R.isRootOrDriveLetter)(Z))throw new Error("rimraf - will refuse to recursively delete root");i.rmSync(Z,{recursive:!0,force:!0,maxRetries:3})}async function p(Z,fe){return v(await(fe?S(Z):i.promises.readdir(Z)))}async function S(Z){try{return await i.promises.readdir(Z,{withFileTypes:!0})}catch(ae){console.warn("[node.js fs] readdir with filetypes failed with error: ",ae)}const fe=[],K=await p(Z);for(const ae of K){let x=!1,z=!1,ne=!1;try{const le=await e.Promises.lstat((0,b.join)(Z,ae));x=le.isFile(),z=le.isDirectory(),ne=le.isSymbolicLink()}catch(le){console.warn("[node.js fs] unexpected error from lstat after readdir: ",le)}fe.push({name:ae,isFile:()=>x,isDirectory:()=>z,isSymbolicLink:()=>ne})}return fe}function g(Z){return v(i.readdirSync(Z))}function v(Z){return Z.map(fe=>typeof fe=="string"?o.isMacintosh?(0,_.normalizeNFC)(fe):fe:(fe.name=o.isMacintosh?(0,_.normalizeNFC)(fe.name):fe.name,fe))}async function t(Z){const fe=await p(Z),K=[];for(const ae of fe)await n.existsDirectory((0,b.join)(Z,ae))&&K.push(ae);return K}function l(Z,fe=1e3){return new Promise(K=>{let ae=!1;const x=setInterval(()=>{ae||(ae=!0,i.access(Z,z=>{ae=!1,z&&(clearInterval(x),K(void 0))}))},fe)})}var n;(function(Z){async function fe(x){let z;try{if(z=await e.Promises.lstat(x),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ne){if(ne.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(o.isWindows&&ne.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(le){if(le.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw le}throw ne}}Z.stat=fe;async function K(x){try{const{stat:z,symbolicLink:ne}=await Z.stat(x);return z.isFile()&&ne?.dangling!==!0}catch{}return!1}Z.existsFile=K;async function ae(x){try{const{stat:z,symbolicLink:ne}=await Z.stat(x);return z.isDirectory()&&ne?.dangling!==!0}catch{}return!1}Z.existsDirectory=ae})(n||(e.SymlinkSupport=n={}));const h=new C.ResourceQueue;function s(Z,fe,K){return h.queueFor(y.URI.file(Z),()=>{const ae=A(K);return new Promise((x,z)=>I(Z,fe,ae,ne=>ne?z(ne):x()))},D.extUriBiasedIgnorePathCase)}let c=!0;function u(Z){c=Z}function I(Z,fe,K,ae){if(!c)return i.writeFile(Z,fe,{mode:K.mode,flag:K.flag},ae);i.open(Z,K.flag,K.mode,(x,z)=>{if(x)return ae(x);i.writeFile(z,fe,ne=>{if(ne)return i.close(z,()=>ae(ne));i.fdatasync(z,le=>(le&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",le),u(!1)),i.close(z,ve=>ae(ve))))})})}function T(Z,fe,K){const ae=A(K);if(!c)return i.writeFileSync(Z,fe,{mode:ae.mode,flag:ae.flag});const x=i.openSync(Z,ae.flag,ae.mode);try{i.writeFileSync(x,fe);try{i.fdatasyncSync(x)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),u(!1)}}finally{i.closeSync(x)}}function A(Z){return Z?{mode:typeof Z.mode=="number"?Z.mode:438,flag:typeof Z.flag=="string"?Z.flag:"w"}:{mode:438,flag:"w"}}async function O(Z,fe,K=6e4){if(Z!==fe)try{o.isWindows&&typeof K=="number"?await k(Z,fe,Date.now(),K):await i.promises.rename(Z,fe)}catch(ae){if(Z.toLowerCase()!==fe.toLowerCase()&&ae.code==="EXDEV"||Z.endsWith("."))await P(Z,fe,{preserveSymlinks:!1}),await E(Z,d.MOVE);else throw ae}}async function k(Z,fe,K,ae,x=0){try{return await i.promises.rename(Z,fe)}catch(z){if(z.code!=="EACCES"&&z.code!=="EPERM"&&z.code!=="EBUSY")throw z;if(Date.now()-K>=ae)throw console.error(`[node.js fs] rename failed after ${x} retries with error: ${z}`),z;if(x===0){let ne=!1;try{const{stat:le}=await n.stat(fe);le.isFile()||(ne=!0)}catch{}if(ne)throw z}return await(0,C.timeout)(Math.min(100,x*10)),k(Z,fe,K,ae,x+1)}}async function P(Z,fe,K){return Y(Z,fe,{root:{source:Z,target:fe},options:K,handledSourcePaths:new Set})}const B=511;async function Y(Z,fe,K){if(K.handledSourcePaths.has(Z))return;K.handledSourcePaths.add(Z);const{stat:ae,symbolicLink:x}=await n.stat(Z);if(x){if(K.options.preserveSymlinks)try{return await te(Z,fe,K)}catch{}if(x.dangling)return}return ae.isDirectory()?X(Z,fe,ae.mode&B,K):re(Z,fe,ae.mode&B)}async function X(Z,fe,K,ae){await e.Promises.mkdir(fe,{recursive:!0,mode:K});const x=await p(Z);for(const z of x)await Y((0,b.join)(Z,z),(0,b.join)(fe,z),ae)}async function re(Z,fe,K){await e.Promises.copyFile(Z,fe),await e.Promises.chmod(fe,K)}async function te(Z,fe,K){let ae=await e.Promises.readlink(Z);(0,R.isEqualOrParent)(ae,K.root.source,!o.isLinux)&&(ae=(0,b.join)(K.root.target,ae.substr(K.root.source.length+1))),await e.Promises.symlink(ae,fe)}e.Promises=new class{get access(){return i.promises.access}get stat(){return i.promises.stat}get lstat(){return i.promises.lstat}get utimes(){return i.promises.utimes}get read(){return(Z,fe,K,ae,x)=>new Promise((z,ne)=>{i.read(Z,fe,K,ae,x,(le,ve,H)=>le?ne(le):z({bytesRead:ve,buffer:H}))})}get readFile(){return i.promises.readFile}get write(){return(Z,fe,K,ae,x)=>new Promise((z,ne)=>{i.write(Z,fe,K,ae,x,(le,ve,H)=>le?ne(le):z({bytesWritten:ve,buffer:H}))})}get appendFile(){return i.promises.appendFile}get fdatasync(){return(0,w.promisify)(i.fdatasync)}get truncate(){return i.promises.truncate}get copyFile(){return i.promises.copyFile}get open(){return(0,w.promisify)(i.open)}get close(){return(0,w.promisify)(i.close)}get symlink(){return i.promises.symlink}get readlink(){return i.promises.readlink}get chmod(){return i.promises.chmod}get mkdir(){return i.promises.mkdir}get unlink(){return i.promises.unlink}get rmdir(){return i.promises.rmdir}get realpath(){return(0,w.promisify)(i.realpath)}async exists(Z){try{return await e.Promises.access(Z),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return t}get writeFile(){return s}get rm(){return E}get rename(){return O}get copy(){return P}}}),define(ye[196],Ie([1,0,31,9,3,17,25]),function(se,e,i,r,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realcaseSync=_,e.realcase=b,e.realpath=o,e.realpathSync=D,i=Be(i);function _(d){if(w.isLinux)return d;const E=(0,r.dirname)(d);if(d===E)return d;const a=((0,r.basename)(d)||d).toLowerCase();try{const m=(0,R.readdirSync)(E).filter(p=>p.toLowerCase()===a);if(m.length===1){const p=_(E);if(p)return(0,r.join)(p,m[0])}else if(m.length>1){const p=m.indexOf(a);if(p>=0){const S=_(E);if(S)return(0,r.join)(S,m[p])}}}catch{}return null}async function b(d,E){if(w.isLinux)return d;const a=(0,r.dirname)(d);if(d===a)return d;const f=((0,r.basename)(d)||d).toLowerCase();try{if(E?.isCancellationRequested)return null;const p=(await R.Promises.readdir(a)).filter(S=>S.toLowerCase()===f);if(p.length===1){const S=await b(a,E);if(S)return(0,r.join)(S,p[0])}else if(p.length>1){const S=p.indexOf(f);if(S>=0){const g=await b(a,E);if(g)return(0,r.join)(g,p[S])}}}catch{}return null}async function o(d){try{return await R.Promises.realpath(d)}catch{const a=y(d);return await R.Promises.access(a,i.constants.R_OK),a}}function D(d){try{return i.realpathSync(d)}catch{const a=y(d);return i.accessSync(a,i.constants.R_OK),a}}function y(d){return(0,C.rtrim)((0,r.normalize)(d),r.sep)}}),define(ye[113],Ie([1,0,32,9,25]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.enumeratePowerShellInstallations=S,e.getFirstAvailablePowerShellInstallation=g,i=Be(i),r=Be(r),w=Be(w);const C=/^\d+$/,R=/^Microsoft.PowerShell_.*/,_=/^Microsoft.PowerShellPreview_.*/;var b;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(b||(b={}));let o;switch(process.arch){case"ia32":o=b.x86;break;case"arm":case"arm64":o=b.ARM;break;default:o=b.x64;break}let D;process.env.PROCESSOR_ARCHITEW6432?D=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?b.ARM:b.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?D=b.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?D=b.x86:D=b.x64;class y{constructor(t,l,n){this.exePath=t,this.displayName=l,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await w.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:v=!1}={}){return v?o===b.x64?process.env["ProgramFiles(x86)"]||null:D===b.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function E({useAlternateBitness:v=!1,findPreview:t=!1}={}){const l=d({useAlternateBitness:v});if(!l)return null;const n=r.join(l,"PowerShell");if(!await w.SymlinkSupport.existsDirectory(n))return null;let h=-1,s=null;for(const I of await w.Promises.readdir(n)){let T=-1;if(t){const O=I.indexOf("-");if(O<0)continue;const k=I.substring(0,O);if(!C.test(k)||I.substring(O+1)!=="preview")continue;T=parseInt(k,10)}else{if(!C.test(I))continue;T=parseInt(I,10)}if(T<=h)continue;const A=r.join(n,I,"pwsh.exe");await w.SymlinkSupport.existsFile(A)&&(s=A,h=T)}if(!s)return null;const c=l.includes("x86")?" (x86)":"",u=t?" Preview":"";return new y(s,`PowerShell${u}${c}`,!0)}async function a({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const t=r.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await w.SymlinkSupport.existsDirectory(t))return null;const{pwshMsixDirRegex:l,pwshMsixName:n}=v?{pwshMsixDirRegex:_,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const h of await w.Promises.readdir(t))if(l.test(h)){const s=r.join(t,h,"pwsh.exe");return new y(s,n)}return null}function f(){const v=r.join(i.homedir(),".dotnet","tools","pwsh.exe");return new y(v,".NET Core PowerShell Global Tool")}function m(){const v=r.join(process.env.windir,o===b.x86&&D!==b.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(v,"Windows PowerShell",!0)}async function*p(){let v=await E();v&&(yield v),v=await E({useAlternateBitness:!0}),v&&(yield v),v=await a(),v&&(yield v),v=f(),v&&(yield v),v=await E({findPreview:!0}),v&&(yield v),v=await a({findPreview:!0}),v&&(yield v),v=await E({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=m(),v&&(yield v)}async function*S(){for await(const v of p())await v.exists()&&(yield v)}async function g(){for await(const v of S())return v;return null}}),define(ye[114],Ie([1,0,9,3,33,69,11,25]),function(se,e,i,r,w,C,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=b,e.createQueuedSender=o,i=Be(i),r=Be(r),w=Be(w),R=Be(R),_=Be(_),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function b(y=w.env){return y.comspec||"cmd.exe"}function o(y){let d=[],E=!1;const a=function(f){if(E){d.push(f);return}(!y.send(f,p=>{if(p&&console.error(p),E=!1,d.length>0){const S=d.slice(0);d=[],S.forEach(g=>a(g))}})||r.isWindows)&&(E=!0)};return{send:a}}var D;(function(y){async function d(E,a,f){if(i.isAbsolute(E))return E;if(a===void 0&&(a=w.cwd()),i.dirname(E)!=="."||(f===void 0&&R.isString(w.env.PATH)&&(f=w.env.PATH.split(i.delimiter)),f===void 0||f.length===0))return i.join(a,E);async function p(S){if(await _.Promises.exists(S)){let g;try{g=await _.Promises.stat(S)}catch(v){v.message.startsWith("EACCES")&&(g=await _.Promises.lstat(S))}return g?!g.isDirectory():!1}return!1}for(const S of f){let g;if(i.isAbsolute(S)?g=i.join(S,E):g=i.join(a,S,E),await p(g))return g;let v=g+".com";if(await p(v)||(v=g+".exe",await p(v)))return v}return i.join(a,E)}y.findExecutable=d})(D||(e.win32=D={}))}),define(ye[115],Ie([1,0,60,13]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=w;function w(R){return new Promise((_,b)=>{let o;const D=new Map;function y(E,a,f,m,p){const S=D.get(a);if(E===R||S){const g={name:d(f),cmd:f,pid:E,ppid:a,load:m,mem:p};D.set(E,g),E===R&&(o=g),S&&(S.children||(S.children=[]),S.children.push(g),S.children.length>1&&(S.children=S.children.sort((v,t)=>v.pid-t.pid)))}}function d(E){const a=/--utility-sub-type=network/i,f=/--crashes-directory/i,m=/\\pipe\\winpty-control/i,p=/conhost\.exe.+--headless/i,S=/--type=([a-zA-Z-]+)/;if(f.exec(E))return"electron-crash-reporter";if(m.exec(E))return"winpty-agent";if(p.exec(E))return"conpty-agent";let g=S.exec(E);if(g&&g.length===2)return g[1]==="renderer"?"window":g[1]==="utility"?a.exec(E)?"utility-network-service":"utility-process":g[1]==="extensionHost"?"extension-host":g[1];const v=/[a-zA-Z-]+\.js/g;let t="";do g=v.exec(E),g&&(t+=g+" ");while(g);return t&&E.indexOf("node ")<0&&E.indexOf("node.exe")<0?`electron-nodejs (${t})`:E}if(process.platform==="win32"){const E=a=>a.indexOf("\\\\?\\")===0||a.indexOf("\\??\\")===0?a.substring(4):a.indexOf('"\\\\?\\')===0||a.indexOf('"\\??\\')===0?'"'+a.substring(5):a;new Promise((a,f)=>{se(["@vscode/windows-process-tree"],a,f)}).then(Be).then(a=>{a.getProcessList(R,f=>{if(!f){b(new Error(`Root process ${R} not found`));return}a.getProcessCpuUsage(f,m=>{const p=new Map;m.forEach(S=>{const g=E(S.commandLine||"");p.set(S.pid,{name:d(g),cmd:g,pid:S.pid,ppid:S.ppid,load:S.cpu||0,mem:S.memory||0})}),o=p.get(R),o?(p.forEach(S=>{const g=p.get(S.ppid);g&&(g.children||(g.children=[]),g.children.push(S))}),p.forEach(S=>{S.children&&(S.children=S.children.sort((g,v)=>g.pid-v.pid))}),_(o)):b(new Error(`Root process ${R} not found`))})},a.ProcessDataFlag.CommandLine|a.ProcessDataFlag.Memory)})}else{let E=function(){let a=[o];const f=[];for(;a.length;){const p=a.shift();p&&(f.push(p.pid),p.children&&(a=a.concat(p.children)))}let m=JSON.stringify(r.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);m+=" "+f.join(" "),(0,i.exec)(m,{},(p,S,g)=>{if(p||g)b(p||new Error(g.toString()));else{const v=S.toString().split(`
`);for(let t=0;t<f.length;t++){const l=D.get(f[t]);l.load=parseFloat(v[t])}if(!o){b(new Error(`Root process ${R} not found`));return}_(o)}})};(0,i.exec)("which ps",{},(a,f,m)=>{if(a||m)if(process.platform!=="linux")b(a||new Error(m.toString()));else{const p=JSON.stringify(r.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,i.exec)(p,{},(S,g,v)=>{S||v?b(S||new Error(v.toString())):(C(g,y),E())})}else{const p=f.toString().trim();(0,i.exec)(`${p} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,v,t)=>{g||t&&!t.includes("screen size is bogus")?b(g||new Error(t.toString())):(C(v,y),process.platform==="linux"?E():o?_(o):b(new Error(`Root process ${R} not found`)))})}})}})}function C(R,_){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,o=R.toString().split(`
`);for(const D of o){const y=b.exec(D.trim());y&&y.length===6&&_(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(ye[116],Ie([1,0,32,3,113,114]),function(se,e,i,r,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=R,r=Be(r),C=Be(C);async function R(y,d){return y===r.OperatingSystem.Windows?r.isWindows?D():C.getWindowsShell(d):b(y,d)}let _=null;function b(y,d){if(r.isLinux&&y===r.OperatingSystem.Macintosh||r.isMacintosh&&y===r.OperatingSystem.Linux)return"/bin/bash";if(!_){let E;if(r.isWindows)E="/bin/bash";else{if(E=d.SHELL,!E)try{E=(0,i.userInfo)().shell}catch{}E||(E="sh"),E==="/bin/false"&&(E="/bin/bash")}_=E}return _}let o=null;async function D(){return o||(o=(await(0,w.getFirstAvailablePowerShellInstallation)()).exePath),o}});var ze=this&&this.__decorate||function(se,e,i,r){var w=arguments.length,C=w<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,i):r,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(se,e,i,r);else for(var _=se.length-1;_>=0;_--)(R=se[_])&&(C=(w<3?R(C):w>3?R(e,i,C):R(e,i))||C);return w>3&&C&&Object.defineProperty(e,i,C),C};define(ye[51],Ie([1,0,18,14,15,19,78,10,6,2,50,17,11]),function(se,e,i,r,w,C,R,_,b,o,D,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=u,e.deserialize=I,e.getDelayedChannel=B,e.getNextTickChannel=Y,y=Be(y);var E;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(E||(E={}));function a(x){switch(x){case E.Promise:return"req";case E.PromiseCancel:return"cancel";case E.EventListen:return"subscribe";case E.EventDispose:return"unsubscribe"}}var f;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(f||(f={}));function m(x){switch(x){case f.Initialize:return"init";case f.PromiseSuccess:return"reply:";case f.PromiseError:case f.PromiseErrorObj:return"replyErr:";case f.EventFire:return"event:"}}var p;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(p||(p={}));function S(x){let z=0;for(let ne=0;;ne+=7){const le=x.read(1);if(z|=(le.buffer[0]&127)<<ne,!(le.buffer[0]&128))return z}}const g=h(0);function v(x,z){if(z===0){x.write(g);return}let ne=0;for(let ve=z;ve!==0;ve=ve>>>7)ne++;const le=w.VSBuffer.alloc(ne);for(let ve=0;z!==0;ve++)le.buffer[ve]=z&127,z=z>>>7,z>0&&(le.buffer[ve]|=128);x.write(le)}class t{constructor(z){this.buffer=z,this.pos=0}read(z){const ne=this.buffer.slice(this.pos,this.pos+z);return this.pos+=ne.byteLength,ne}}e.BufferReader=t;class l{constructor(){this.buffers=[]}get buffer(){return w.VSBuffer.concat(this.buffers)}write(z){this.buffers.push(z)}}e.BufferWriter=l;var n;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(n||(n={}));function h(x){const z=w.VSBuffer.alloc(1);return z.writeUInt8(x,0),z}const s={Undefined:h(n.Undefined),String:h(n.String),Buffer:h(n.Buffer),VSBuffer:h(n.VSBuffer),Array:h(n.Array),Object:h(n.Object),Uint:h(n.Int)},c=typeof Buffer<"u";function u(x,z){if(typeof z>"u")x.write(s.Undefined);else if(typeof z=="string"){const ne=w.VSBuffer.fromString(z);x.write(s.String),v(x,ne.byteLength),x.write(ne)}else if(c&&Buffer.isBuffer(z)){const ne=w.VSBuffer.wrap(z);x.write(s.Buffer),v(x,ne.byteLength),x.write(ne)}else if(z instanceof w.VSBuffer)x.write(s.VSBuffer),v(x,z.byteLength),x.write(z);else if(Array.isArray(z)){x.write(s.Array),v(x,z.length);for(const ne of z)u(x,ne)}else if(typeof z=="number"&&(z|0)===z)x.write(s.Uint),v(x,z);else{const ne=w.VSBuffer.fromString(JSON.stringify(z));x.write(s.Object),v(x,ne.byteLength),x.write(ne)}}function I(x){switch(x.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return x.read(S(x)).toString();case n.Buffer:return x.read(S(x)).buffer;case n.VSBuffer:return x.read(S(x));case n.Array:{const ne=S(x),le=[];for(let ve=0;ve<ne;ve++)le.push(I(x));return le}case n.Object:return JSON.parse(x.read(S(x)).toString());case n.Int:return S(x)}}class T{constructor(z,ne,le=null,ve=1e3){this.protocol=z,this.ctx=ne,this.logger=le,this.timeoutDelay=ve,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(H=>this.onRawMessage(H)),this.sendResponse({type:f.Initialize})}registerChannel(z,ne){this.channels.set(z,ne),setTimeout(()=>this.flushPendingRequests(z),0)}sendResponse(z){switch(z.type){case f.Initialize:{const ne=this.send([z.type]);this.logger?.logOutgoing(ne,0,A.OtherSide,m(z.type));return}case f.PromiseSuccess:case f.PromiseError:case f.EventFire:case f.PromiseErrorObj:{const ne=this.send([z.type,z.id],z.data);this.logger?.logOutgoing(ne,z.id,A.OtherSide,m(z.type),z.data);return}}}send(z,ne=void 0){const le=new l;return u(le,z),u(le,ne),this.sendBuffer(le.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onRawMessage(z){const ne=new t(z),le=I(ne),ve=I(ne),H=le[0];switch(H){case E.Promise:return this.logger?.logIncoming(z.byteLength,le[1],A.OtherSide,`${a(H)}: ${le[2]}.${le[3]}`,ve),this.onPromise({type:H,id:le[1],channelName:le[2],name:le[3],arg:ve});case E.EventListen:return this.logger?.logIncoming(z.byteLength,le[1],A.OtherSide,`${a(H)}: ${le[2]}.${le[3]}`,ve),this.onEventListen({type:H,id:le[1],channelName:le[2],name:le[3],arg:ve});case E.PromiseCancel:return this.logger?.logIncoming(z.byteLength,le[1],A.OtherSide,`${a(H)}`),this.disposeActiveRequest({type:H,id:le[1]});case E.EventDispose:return this.logger?.logIncoming(z.byteLength,le[1],A.OtherSide,`${a(H)}`),this.disposeActiveRequest({type:H,id:le[1]})}}onPromise(z){const ne=this.channels.get(z.channelName);if(!ne){this.collectPendingRequest(z);return}const le=new C.CancellationTokenSource;let ve;try{ve=ne.call(this.ctx,z.name,z.arg,le.token)}catch(J){ve=Promise.reject(J)}const H=z.id;ve.then(J=>{this.sendResponse({id:H,data:J,type:f.PromiseSuccess})},J=>{J instanceof Error?this.sendResponse({id:H,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split(`
`):void 0},type:f.PromiseError}):this.sendResponse({id:H,data:J,type:f.PromiseErrorObj})}).finally(()=>{ce.dispose(),this.activeRequests.delete(z.id)});const ce=(0,o.toDisposable)(()=>le.cancel());this.activeRequests.set(z.id,ce)}onEventListen(z){const ne=this.channels.get(z.channelName);if(!ne){this.collectPendingRequest(z);return}const le=z.id,H=ne.listen(this.ctx,z.name,z.arg)(ce=>this.sendResponse({id:le,data:ce,type:f.EventFire}));this.activeRequests.set(z.id,H)}disposeActiveRequest(z){const ne=this.activeRequests.get(z.id);ne&&(ne.dispose(),this.activeRequests.delete(z.id))}collectPendingRequest(z){let ne=this.pendingRequests.get(z.channelName);ne||(ne=[],this.pendingRequests.set(z.channelName,ne));const le=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===E.Promise&&this.sendResponse({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:f.PromiseError})},this.timeoutDelay);ne.push({request:z,timeoutTimer:le})}flushPendingRequests(z){const ne=this.pendingRequests.get(z);if(ne){for(const le of ne)switch(clearTimeout(le.timeoutTimer),le.request.type){case E.Promise:this.onPromise(le.request);break;case E.EventListen:this.onEventListen(le.request);break}this.pendingRequests.delete(z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,o.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=T;var A;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(A||(e.RequestInitiator=A={}));class O{constructor(z,ne=null){this.protocol=z,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(le=>this.onBuffer(le)),this.logger=ne}getChannel(z){const ne=this;return{call(le,ve,H){return ne.isDisposed?Promise.reject(new _.CancellationError):ne.requestPromise(z,le,ve,H)},listen(le,ve){return ne.isDisposed?b.Event.None:ne.requestEvent(z,le,ve)}}}requestPromise(z,ne,le,ve=C.CancellationToken.None){const H=this.lastRequestId++,ce=E.Promise,J={id:H,type:ce,channelName:z,name:ne,arg:le};if(ve.isCancellationRequested)return Promise.reject(new _.CancellationError);let W;return new Promise((Q,$)=>{if(ve.isCancellationRequested)return $(new _.CancellationError);const U=()=>{const V=oe=>{switch(oe.type){case f.PromiseSuccess:this.handlers.delete(H),Q(oe.data);break;case f.PromiseError:{this.handlers.delete(H);const de=new Error(oe.data.message);de.stack=Array.isArray(oe.data.stack)?oe.data.stack.join(`
`):oe.data.stack,de.name=oe.data.name,$(de);break}case f.PromiseErrorObj:this.handlers.delete(H),$(oe.data);break}};this.handlers.set(H,V),this.sendRequest(J)};let q=null;this.state===p.Idle?U():(q=(0,r.createCancelablePromise)(V=>this.whenInitialized()),q.then(()=>{q=null,U()}));const G=()=>{q?(q.cancel(),q=null):this.sendRequest({id:H,type:E.PromiseCancel}),$(new _.CancellationError)},F=ve.onCancellationRequested(G);W=(0,o.combinedDisposable)((0,o.toDisposable)(G),F),this.activeRequests.add(W)}).finally(()=>{W.dispose(),this.activeRequests.delete(W)})}requestEvent(z,ne,le){const ve=this.lastRequestId++,H=E.EventListen,ce={id:ve,type:H,channelName:z,name:ne,arg:le};let J=null;const W=new b.Emitter({onWillAddFirstListener:()=>{J=(0,r.createCancelablePromise)(Q=>this.whenInitialized()),J.then(()=>{J=null,this.activeRequests.add(W),this.sendRequest(ce)})},onDidRemoveLastListener:()=>{J?(J.cancel(),J=null):(this.activeRequests.delete(W),this.sendRequest({id:ve,type:E.EventDispose}))}}),L=Q=>W.fire(Q.data);return this.handlers.set(ve,L),W.event}sendRequest(z){switch(z.type){case E.Promise:case E.EventListen:{const ne=this.send([z.type,z.id,z.channelName,z.name],z.arg);this.logger?.logOutgoing(ne,z.id,A.LocalSide,`${a(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case E.PromiseCancel:case E.EventDispose:{const ne=this.send([z.type,z.id]);this.logger?.logOutgoing(ne,z.id,A.LocalSide,a(z.type));return}}}send(z,ne=void 0){const le=new l;return u(le,z),u(le,ne),this.sendBuffer(le.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onBuffer(z){const ne=new t(z),le=I(ne),ve=I(ne),H=le[0];switch(H){case f.Initialize:return this.logger?.logIncoming(z.byteLength,0,A.LocalSide,m(H)),this.onResponse({type:le[0]});case f.PromiseSuccess:case f.PromiseError:case f.EventFire:case f.PromiseErrorObj:return this.logger?.logIncoming(z.byteLength,le[1],A.LocalSide,m(H),ve),this.onResponse({type:le[0],id:le[1],data:ve})}}onResponse(z){if(z.type===f.Initialize){this.state=p.Idle,this._onDidInitialize.fire();return}this.handlers.get(z.id)?.(z)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,o.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=O,ze([R.memoize],O.prototype,"onDidInitializePromise",null);class k{get connections(){const z=[];return this._connections.forEach(ne=>z.push(ne)),z}constructor(z,ne,le){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new o.DisposableStore,this.disposables.add(z(({protocol:ve,onDidClientDisconnect:H})=>{const ce=b.Event.once(ve.onMessage);this.disposables.add(ce(J=>{const W=new t(J),L=I(W),Q=new T(ve,L,ne,le),$=new O(ve,ne);this.channels.forEach((q,G)=>Q.registerChannel(G,q));const U={channelServer:Q,channelClient:$,ctx:L};this._connections.add(U),this._onDidAddConnection.fire(U),this.disposables.add(H(()=>{Q.dispose(),$.dispose(),this._connections.delete(U),this._onDidRemoveConnection.fire(U)}))}))}))}getChannel(z,ne){const le=this;return{call(ve,H,ce){let J;if((0,d.isFunction)(ne)){const L=(0,i.getRandomElement)(le.connections.filter(ne));J=L?Promise.resolve(L):b.Event.toPromise(b.Event.filter(le.onDidAddConnection,ne))}else J=ne.routeCall(le,ve,H);const W=J.then(L=>L.channelClient.getChannel(z));return B(W).call(ve,H,ce)},listen(ve,H){if((0,d.isFunction)(ne))return le.getMulticastEvent(z,ne,ve,H);const ce=ne.routeEvent(le,ve,H).then(J=>J.channelClient.getChannel(z));return B(ce).listen(ve,H)}}}getMulticastEvent(z,ne,le,ve){const H=this;let ce;const J=new b.Emitter({onWillAddFirstListener:()=>{ce=new o.DisposableStore;const W=new b.EventMultiplexer,L=new Map,Q=U=>{const G=U.channelClient.getChannel(z).listen(le,ve),F=W.add(G);L.set(U,F)},$=U=>{const q=L.get(U);q&&(q.dispose(),L.delete(U))};H.connections.filter(ne).forEach(Q),b.Event.filter(H.onDidAddConnection,ne)(Q,void 0,ce),H.onDidRemoveConnection($,void 0,ce),W.event(J.fire,J,ce),ce.add(W)},onDidRemoveLastListener:()=>{ce?.dispose(),ce=void 0}});return J.event}registerChannel(z,ne){this.channels.set(z,ne);for(const le of this._connections)le.channelServer.registerChannel(z,ne)}dispose(){this.disposables.dispose();for(const z of this._connections)z.channelClient.dispose(),z.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=k;class P{constructor(z,ne,le=null){const ve=new l;u(ve,ne),z.send(ve.buffer),this.channelClient=new O(z,le),this.channelServer=new T(z,ne,le)}getChannel(z){return this.channelClient.getChannel(z)}registerChannel(z,ne){this.channelServer.registerChannel(z,ne)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=P;function B(x){return{call(z,ne,le){return x.then(ve=>ve.call(z,ne,le))},listen(z,ne){const le=new b.Relay;return x.then(ve=>le.input=ve.listen(z,ne)),le.event}}}function Y(x){let z=!1;return{call(ne,le,ve){return z?x.call(ne,le,ve):(0,r.timeout)(0).then(()=>z=!0).then(()=>x.call(ne,le,ve))},listen(ne,le){if(z)return x.listen(ne,le);const ve=new b.Relay;return(0,r.timeout)(0).then(()=>z=!0).then(()=>ve.input=x.listen(ne,le)),ve.event}}}class X{constructor(z){this.fn=z}routeCall(z){return this.route(z)}routeEvent(z){return this.route(z)}async route(z){for(const ne of z.connections)if(await Promise.resolve(this.fn(ne.ctx)))return Promise.resolve(ne);return await b.Event.toPromise(z.onDidAddConnection),await this.route(z)}}e.StaticRouter=X;var re;(function(x){function z(H,ce,J){const W=H,L=J&&J.disableMarshalling,Q=new Map;for(const $ in W)le($)&&Q.set($,b.Event.buffer(W[$],!0,void 0,ce));return new class{listen($,U,q){const G=Q.get(U);if(G)return G;const F=W[U];if(typeof F=="function"){if(ve(U))return F.call(W,q);if(le(U))return Q.set(U,b.Event.buffer(W[U],!0,void 0,ce)),Q.get(U)}throw new _.ErrorNoTelemetry(`Event not found: ${U}`)}call($,U,q){const G=W[U];if(typeof G=="function"){if(!L&&Array.isArray(q))for(let V=0;V<q.length;V++)q[V]=(0,D.revive)(q[V]);let F=G.apply(W,q);return F instanceof Promise||(F=Promise.resolve(F)),F}throw new _.ErrorNoTelemetry(`Method not found: ${U}`)}}}x.fromService=z;function ne(H,ce){const J=ce&&ce.disableMarshalling;return new Proxy({},{get(W,L){if(typeof L=="string")return ce?.properties?.has(L)?ce.properties.get(L):ve(L)?function(Q){return H.listen(L,Q)}:le(L)?H.listen(L):async function(...Q){let $;ce&&!(0,d.isUndefinedOrNull)(ce.context)?$=[ce.context,...Q]:$=Q;const U=await H.call(L,$);return J?U:(0,D.revive)(U)};throw new _.ErrorNoTelemetry(`Property not found: ${String(L)}`)}})}x.toService=ne;function le(H){return H[0]==="o"&&H[1]==="n"&&y.isUpperAsciiLetter(H.charCodeAt(2))}function ve(H){return/^onDynamic/.test(H)&&y.isUpperAsciiLetter(H.charCodeAt(9))}})(re||(e.ProxyChannel=re={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Z(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const z=x.toString();if(z!=="[object Object]")return z}return x}function fe(x){return Array.isArray(x)?x.map(Z):Z(x)}function K(x,z,ne,le,ve,H,ce){ce=fe(ce);const J=te[ve],W=J[le%J.length];let L=[`%c[${x}]%c[${String(z).padStart(7," ")}]%c[len: ${String(ne).padStart(5," ")}]%c${String(le).padStart(5," ")} - ${H}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(H)?(L=L.concat(ce),L.push(")")):L.push(ce),console.log.apply(console,L)}class ae{constructor(z,ne){this._outgoingPrefix=z,this._incomingPrefix=ne,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(z,ne,le,ve,H){this._totalOutgoing+=z,K(this._outgoingPrefix,this._totalOutgoing,z,ne,le,ve,H)}logIncoming(z,ne,le,ve,H){this._totalIncoming+=z,K(this._incomingPrefix,this._totalIncoming,z,ne,le,ve,H)}}e.IPCLogger=ae}),define(ye[61],Ie([1,0,15,6,2,51]),function(se,e,i,r,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var _;(function(s){s.enableDiagnostics=!1,s.records=[];const c=new WeakMap;let u=0;function I(A,O){if(!c.has(A)){const k=String(++u);c.set(A,k)}return c.get(A)}function T(A,O,k,P){if(!s.enableDiagnostics)return;const B=I(A,O);if(P instanceof i.VSBuffer||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const Y=i.VSBuffer.alloc(P.byteLength);Y.set(P),s.records.push({timestamp:Date.now(),id:B,label:O,type:k,buff:Y})}else s.records.push({timestamp:Date.now(),id:B,label:O,type:k,data:P})}s.traceSocketEvent=T})(_||(e.SocketDiagnostics=_={}));var b;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let o=null;function D(){return o||(o=i.VSBuffer.alloc(0)),o}class y{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(c){this._chunks.push(c),this._totalLength+=c.byteLength}read(c){return this._read(c,!0)}peek(c){return this._read(c,!1)}_read(c,u){if(c===0)return D();if(c>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===c){const O=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=c),O}if(this._chunks[0].byteLength>c){const O=this._chunks[0].slice(0,c);return u&&(this._chunks[0]=this._chunks[0].slice(c),this._totalLength-=c),O}const I=i.VSBuffer.alloc(c);let T=0,A=0;for(;c>0;){const O=this._chunks[A];if(O.byteLength>c){const k=O.slice(0,c);I.set(k,T),T+=c,u&&(this._chunks[A]=O.slice(c),this._totalLength-=c),c-=c}else I.set(O,T),T+=O.byteLength,u?(this._chunks.shift(),this._totalLength-=O.byteLength):A++,c-=O.byteLength}return I}}e.ChunkStream=y;var d;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(d||(d={}));function E(s){switch(s){case d.None:return"None";case d.Regular:return"Regular";case d.Control:return"Control";case d.Ack:return"Ack";case d.Disconnect:return"Disconnect";case d.ReplayRequest:return"ReplayRequest";case d.Pause:return"PauseWriting";case d.Resume:return"ResumeWriting";case d.KeepAlive:return"KeepAlive"}}var a;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(a||(e.ProtocolConstants=a={}));class f{constructor(c,u,I,T){this.type=c,this.id=u,this.ack=I,this.data=T,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends w.Disposable{constructor(c){super(),this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:a.HeaderLength,messageType:d.None,id:0,ack:0},this._socket=c,this._isDisposed=!1,this._incomingData=new y,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5),this._socket.traceSocketEvent(R.ProtocolHeaderRead,{messageType:E(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const I=this._state.messageType,T=this._state.id,A=this._state.ack;if(this._state.readHead=!0,this._state.readLen=a.HeaderLength,this._state.messageType=d.None,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent(R.ProtocolMessageRead,u),this._onMessage.fire(new f(I,T,A,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(c){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=c,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(c){if(this._isDisposed)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=i.VSBuffer.alloc(a.HeaderLength);u.writeUInt8(c.type,0),u.writeUInt32BE(c.id,1),u.writeUInt32BE(c.ack,5),u.writeUInt32BE(c.data.byteLength,9),this._socket.traceSocketEvent(R.ProtocolHeaderWrite,{messageType:E(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this._socket.traceSocketEvent(R.ProtocolMessageWrite,c.data),this._writeSoon(u,c.data)}_bufferAdd(c,u){const I=this._totalLength===0;return this._data.push(c,u),this._totalLength+=c.byteLength+u.byteLength,I}_bufferTake(){const c=i.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,c}_writeSoon(c,u){this._bufferAdd(c,u)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const c=this._bufferTake();this._socket.traceSocketEvent(R.ProtocolWrite,{byteLength:c.byteLength}),this._socket.write(c)}}class S extends w.Disposable{constructor(c){super(),this._onMessage=new r.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new r.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=c,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===d.Regular&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(c){this._socketWriter.write(new f(d.Regular,0,0,c))}}e.Protocol=S;class g extends C.IPCClient{static fromSocket(c,u){return new g(new S(c),u)}get onDidDispose(){return this.protocol.onDidDispose}constructor(c,u,I=null){super(c,u,I),this.protocol=c}dispose(){super.dispose();const c=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),c.end()}}e.Client=g;class v{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new r.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(c){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(c):this._emitter.fire(c):this._bufferedMessages.push(c)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=v;class t{constructor(c){this.data=c,this.next=null}}class l{constructor(){this._first=null,this._last=null}length(){let c=0,u=this._first;for(;u;)u=u.next,c++;return c}peek(){return this._first?this._first.data:null}toArray(){const c=[];let u=0,I=this._first;for(;I;)c[u++]=I.data,I=I.next;return c}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(c){const u=new t(c);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class n{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return n._INSTANCE||(n._INSTANCE=new n),n._INSTANCE}constructor(){this.lastRuns=[];const c=Date.now();for(let u=0;u<n._HISTORY_LENGTH;u++)this.lastRuns[u]=c-1e3*u;setInterval(()=>{for(let u=n._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}load(){const c=Date.now(),u=(1+n._HISTORY_LENGTH)*1e3;let I=0;for(let T=0;T<n._HISTORY_LENGTH;T++)c-this.lastRuns[T]<=u&&I++;return 1-I/n._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class h{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(c){this._onControlMessage=new v,this.onControlMessage=this._onControlMessage.event,this._onMessage=new v,this.onMessage=this._onMessage.event,this._onDidDispose=new v,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new v,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new v,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c.loadEstimator??n.getInstance(),this._shouldSendKeepAlive=c.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new w.DisposableStore,this._socket=c.socket,this._socketWriter=this._socketDisposables.add(new p(this._socket)),this._socketReader=this._socketDisposables.add(new m(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.add(this._socket.onClose(u=>this._onSocketClose.fire(u))),c.initialChunk&&this._socketReader.acceptChunk(c.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},a.KeepAliveSendTime):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const c=new f(d.Disconnect,0,0,D());this._socketWriter.write(c),this._socketWriter.flush()}sendPause(){const c=new f(d.Pause,0,0,D());this._socketWriter.write(c)}sendResume(){const c=new f(d.Resume,0,0,D());this._socketWriter.write(c)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(c,u){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new w.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=c,this._socketWriter=this._socketDisposables.add(new p(this._socket)),this._socketReader=this._socketDisposables.add(new m(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(I=>this._receiveMessage(I))),this._socketDisposables.add(this._socket.onClose(I=>this._onSocketClose.fire(I))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const c=new f(d.Ack,0,this._incomingAckId,D());this._socketWriter.write(c);const u=this._outgoingUnackMsg.toArray();for(let I=0,T=u.length;I<T;I++)this._socketWriter.write(u[I]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(c){if(c.ack>this._outgoingAckId){this._outgoingAckId=c.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=c.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(c.type){case d.None:break;case d.Regular:{if(c.id>this._incomingMsgId)if(c.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new f(d.ReplayRequest,0,0,D())))}else this._incomingMsgId=c.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(c.data);break}case d.Control:{this._onControlMessage.fire(c.data);break}case d.Ack:break;case d.Disconnect:{this._onDidDispose.fire();break}case d.ReplayRequest:{const u=this._outgoingUnackMsg.toArray();for(let I=0,T=u.length;I<T;I++)this._socketWriter.write(u[I]);this._recvAckCheck();break}case d.Pause:{this._socketWriter.pause();break}case d.Resume:{this._socketWriter.resume();break}case d.KeepAlive:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(c){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const I=new f(d.Regular,u,this._incomingAckId,c);this._outgoingUnackMsg.push(I),this._isReconnecting||(this._socketWriter.write(I),this._recvAckCheck())}sendControl(c){const u=new f(d.Control,0,0,c);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const c=Date.now()-this._incomingMsgLastTime;if(c>=a.AcknowledgeTime){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},a.AcknowledgeTime-c+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const c=this._outgoingUnackMsg.peek(),u=Date.now()-c.writtenTime,I=Date.now()-this._socketReader.lastReadTime,T=Date.now()-this._lastSocketTimeoutTime;if(u>=a.TimeoutTime&&I>=a.TimeoutTime&&T>=a.TimeoutTime&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:I});return}const A=Math.max(a.TimeoutTime-u,a.TimeoutTime-I,a.TimeoutTime-T,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},A)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const c=new f(d.Ack,0,this._incomingAckId,D());this._socketWriter.write(c)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const c=new f(d.KeepAlive,0,this._incomingAckId,D());this._socketWriter.write(c)}}e.PersistentProtocol=h}),define(ye[117],Ie([1,0,60,14,15,19,192,10,6,2,21,114,69,51]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0,_=Be(_);class a extends E.ChannelServer{constructor(p){super({send:S=>{try{process.send?.(S.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",S=>w.VSBuffer.wrap(Buffer.from(S,"base64")))},p),process.once("disconnect",()=>this.dispose())}}e.Server=a;class f{constructor(p,S){this.modulePath=p,this.options=S,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new b.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const g=S&&S.timeout?S.timeout:6e4;this.disposeDelayer=new r.Delayer(g),this.child=null,this._client=null}getChannel(p){const S=this;return{call(g,v,t){return S.requestPromise(p,g,v,t)},listen(g,v){return S.requestEvent(p,g,v)}}}requestPromise(p,S,g,v=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(_.canceled());this.disposeDelayer.cancel();const t=this.getCachedChannel(p),l=(0,r.createCancelablePromise)(s=>t.call(S,g,s)),n=v.onCancellationRequested(()=>l.cancel()),h=(0,o.toDisposable)(()=>l.cancel());return this.activeRequests.add(h),l.finally(()=>{n.dispose(),this.activeRequests.delete(h),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(p,S,g){if(!this.disposeDelayer)return b.Event.None;this.disposeDelayer.cancel();let v;const t=new b.Emitter({onWillAddFirstListener:()=>{v=this.getCachedChannel(p).listen(S,g)(t.fire,t),this.activeRequests.add(v)},onDidRemoveLastListener:()=>{this.activeRequests.delete(v),v.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return t.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],S=Object.create(null);S.env={...(0,D.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(S.env={...S.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(S.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(S.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(S.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),S.execArgv===void 0&&(S.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u)).filter(u=>!u.startsWith("--vscode-"))),(0,d.removeDangerousEnvVariables)(S.env),this.child=(0,i.fork)(this.modulePath,p,S);const g=new b.Emitter,t=b.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if((0,R.isRemoteConsoleLog)(u)){(0,R.log)(u,`IPC Library: ${this.options.serverName}`);return}g.fire(w.VSBuffer.wrap(Buffer.from(u,"base64")))}),l=this.options.useQueue?(0,y.createQueuedSender)(this.child):this.child,n=u=>this.child&&this.child.connected&&l.send(u.buffer.toString("base64")),h=g.event,s={send:n,onMessage:h};this._client=new E.ChannelClient(s);const c=()=>this.disposeClient();process.once("exit",c),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,I)=>{process.removeListener("exit",c),t.dispose(),this.activeRequests.forEach(T=>(0,o.dispose)(T)),this.activeRequests.clear(),u!==0&&I!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+I),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:I})})}return this._client}getCachedChannel(p){let S=this.channels.get(p);return S||(S=this.client.getChannel(p),this.channels.set(p,S)),S}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=f}),define(ye[197],Ie([1,0,14,6,2,50,11]),function(se,e,i,r,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=b;var _;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(_||(e.StorageHint=_={}));function b(d){const E=d;return E?.changed instanceof Map||E?.deleted instanceof Set}var o;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(o||(e.StorageState=o={}));class D extends w.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(E,a=Object.create(null)){super(),this.database=E,this.options=a,this._onDidChangeStorage=this._register(new r.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=o.None,this.cache=new Map,this.flushDelayer=this._register(new i.ThrottledDelayer(D.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(E=>this.onDidChangeItemsExternal(E)))}onDidChangeItemsExternal(E){this._onDidChangeStorage.pause();try{E.changed?.forEach((a,f)=>this.acceptExternal(f,a)),E.deleted?.forEach(a=>this.acceptExternal(a,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(E,a){if(this.state===o.Closed)return;let f=!1;(0,R.isUndefinedOrNull)(a)?f=this.cache.delete(E):this.cache.get(E)!==a&&(this.cache.set(E,a),f=!0),f&&this._onDidChangeStorage.fire({key:E,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===o.None&&(this.state=o.Initialized,this.options.hint!==_.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(E,a){const f=this.cache.get(E);return(0,R.isUndefinedOrNull)(f)?a:f}getBoolean(E,a){const f=this.get(E);return(0,R.isUndefinedOrNull)(f)?a:f==="true"}getNumber(E,a){const f=this.get(E);return(0,R.isUndefinedOrNull)(f)?a:parseInt(f,10)}getObject(E,a){const f=this.get(E);return(0,R.isUndefinedOrNull)(f)?a:(0,C.parse)(f)}async set(E,a,f=!1){if(this.state===o.Closed)return;if((0,R.isUndefinedOrNull)(a))return this.delete(E,f);const m=(0,R.isObject)(a)||Array.isArray(a)?(0,C.stringify)(a):String(a);if(this.cache.get(E)!==m)return this.cache.set(E,m),this.pendingInserts.set(E,m),this.pendingDeletes.delete(E),this._onDidChangeStorage.fire({key:E,external:f}),this.doFlush()}async delete(E,a=!1){if(!(this.state===o.Closed||!this.cache.delete(E)))return this.pendingDeletes.has(E)||this.pendingDeletes.add(E),this.pendingInserts.delete(E),this._onDidChangeStorage.fire({key:E,external:a}),this.doFlush()}async optimize(){if(this.state!==o.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=o.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const E={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(E).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(E){if(!(this.state===o.Closed||this.pendingClose))return this.doFlush(E)}async doFlush(E){return this.options.hint===_.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),E)}async whenFlushed(){if(this.hasPending)return new Promise(E=>this.whenFlushedCallbacks.push(E))}isInMemory(){return this.options.hint===_.STORAGE_IN_MEMORY}}e.Storage=D;class y{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(E){E.insert?.forEach((a,f)=>this.items.set(f,a)),E.delete?.forEach(a=>this.items.delete(a))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=y}),define(ye[198],Ie([7,8]),function(se,e){return se.create("vs/base/node/zip",e)}),define(ye[87],Ie([1,0,31,14,9,11,25,198]),function(se,e,i,r,w,C,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtractError=e.CorruptZipMessage=void 0,e.zip=m,e.extract=p,e.buffer=g,w=Be(w),_=Be(_),e.CorruptZipMessage="end of central directory record signature not found";const b=new RegExp(e.CorruptZipMessage);class o extends Error{constructor(t,l){let n=l.message;switch(t){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=t,this.cause=l}}e.ExtractError=o;function D(v){const t=v.externalFileAttributes>>16||33188;return[448,56,7].map(l=>t&l).reduce((l,n)=>l+n,t&61440)}function y(v){if(v instanceof o)return v;let t;return b.test(v.message)&&(t="CorruptZip"),new o(t,v)}function d(v,t,l,n,h,s){const c=w.dirname(t),u=w.join(n,c);if(!u.startsWith(n))return Promise.reject(new Error(_.localize(0,null,t)));const I=w.join(n,t);let T;return s.onCancellationRequested(()=>{T?.destroy()}),Promise.resolve(R.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((A,O)=>{if(!s.isCancellationRequested)try{T=(0,i.createWriteStream)(I,{mode:l}),T.once("close",()=>A()),T.once("error",O),v.once("error",O),v.pipe(T)}catch(k){O(k)}}))}function E(v,t,l,n){let h=(0,r.createCancelablePromise)(()=>Promise.resolve()),s=0;const c=n.onCancellationRequested(()=>{h.cancel(),v.close()});return new Promise((u,I)=>{const T=new r.Sequencer,A=O=>{O.isCancellationRequested||(s++,v.readEntry())};v.once("error",I),v.once("close",()=>h.then(()=>{n.isCancellationRequested||v.entryCount===s?u():I(new o("Incomplete",new Error(_.localize(1,null,s,v.entryCount))))},I)),v.readEntry(),v.on("entry",O=>{if(n.isCancellationRequested)return;if(!l.sourcePathRegex.test(O.fileName)){A(n);return}const k=O.fileName.replace(l.sourcePathRegex,"");if(/\/$/.test(k)){const Y=w.join(t,k);h=(0,r.createCancelablePromise)(X=>R.Promises.mkdir(Y,{recursive:!0}).then(()=>A(X)).then(void 0,I));return}const P=f(v,O),B=D(O);h=(0,r.createCancelablePromise)(Y=>T.queue(()=>P.then(X=>d(X,k,B,t,l,Y).then(()=>A(Y)))).then(null,I))})}).finally(()=>c.dispose())}async function a(v,t=!1){const{open:l}=await new Promise((n,h)=>{se(["yauzl"],n,h)}).then(Be);return new Promise((n,h)=>{l(v,t?{lazyEntries:!0}:void 0,(s,c)=>{s?h(y(s)):n((0,C.assertIsDefined)(c))})})}function f(v,t){return new Promise((l,n)=>{v.openReadStream(t,(h,s)=>{h?n(y(h)):l((0,C.assertIsDefined)(s))})})}async function m(v,t){const{ZipFile:l}=await new Promise((n,h)=>{se(["yazl"],n,h)}).then(Be);return new Promise((n,h)=>{const s=new l;t.forEach(u=>{u.contents?s.addBuffer(typeof u.contents=="string"?Buffer.from(u.contents,"utf8"):u.contents,u.path):u.localPath&&s.addFile(u.localPath,u.path)}),s.end();const c=(0,i.createWriteStream)(v);s.outputStream.pipe(c),s.outputStream.once("error",h),c.once("error",h),c.once("finish",()=>n(v))})}function p(v,t,l={},n){const h=new RegExp(l.sourcePath?`^${l.sourcePath}`:"");let s=a(v,!0);return l.overwrite&&(s=s.then(c=>R.Promises.rm(t).then(()=>c))),s.then(c=>E(c,t,{sourcePathRegex:h},n))}function S(v,t){return a(v).then(l=>new Promise((n,h)=>{l.on("entry",s=>{s.fileName===t&&f(l,s).then(c=>n(c),c=>h(c))}),l.once("close",()=>h(new Error(_.localize(2,null,t))))}))}function g(v,t){return S(v,t).then(l=>new Promise((n,h)=>{const s=[];l.once("error",h),l.on("data",c=>s.push(c)),l.on("end",()=>n(Buffer.concat(s)))}))}}),define(ye[199],Ie([7,8]),function(se,e){return se.create("vs/editor/common/config/editorOptions",e)}),define(ye[200],Ie([7,8]),function(se,e){return se.create("vs/editor/common/languages",e)}),define(ye[201],Ie([1,0,57,4,179,49,183,200]),function(se,e,i,r,w,C,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.FoldingRangeKind=e.TextEdit=e.SymbolKinds=e.SymbolTag=e.symbolKindNames=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0,e.isLocationLink=h,e.getAriaLabelForSymbol=c;class b{constructor(z,ne,le){this.offset=z,this.type=ne,this.language=le,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=b;class o{constructor(z,ne){this.tokens=z,this.endState=ne,this._tokenizationResultBrand=void 0}}e.TokenizationResult=o;class D{constructor(z,ne){this.tokens=z,this.endState=ne,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=D;var y;(function(x){x[x.Increase=0]="Increase",x[x.Decrease=1]="Decrease"})(y||(e.HoverVerbosityAction=y={}));var d;(function(x){x[x.Method=0]="Method",x[x.Function=1]="Function",x[x.Constructor=2]="Constructor",x[x.Field=3]="Field",x[x.Variable=4]="Variable",x[x.Class=5]="Class",x[x.Struct=6]="Struct",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Event=10]="Event",x[x.Operator=11]="Operator",x[x.Unit=12]="Unit",x[x.Value=13]="Value",x[x.Constant=14]="Constant",x[x.Enum=15]="Enum",x[x.EnumMember=16]="EnumMember",x[x.Keyword=17]="Keyword",x[x.Text=18]="Text",x[x.Color=19]="Color",x[x.File=20]="File",x[x.Reference=21]="Reference",x[x.Customcolor=22]="Customcolor",x[x.Folder=23]="Folder",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue",x[x.Snippet=27]="Snippet"})(d||(e.CompletionItemKind=d={}));var E;(function(x){const z=new Map;z.set(d.Method,i.Codicon.symbolMethod),z.set(d.Function,i.Codicon.symbolFunction),z.set(d.Constructor,i.Codicon.symbolConstructor),z.set(d.Field,i.Codicon.symbolField),z.set(d.Variable,i.Codicon.symbolVariable),z.set(d.Class,i.Codicon.symbolClass),z.set(d.Struct,i.Codicon.symbolStruct),z.set(d.Interface,i.Codicon.symbolInterface),z.set(d.Module,i.Codicon.symbolModule),z.set(d.Property,i.Codicon.symbolProperty),z.set(d.Event,i.Codicon.symbolEvent),z.set(d.Operator,i.Codicon.symbolOperator),z.set(d.Unit,i.Codicon.symbolUnit),z.set(d.Value,i.Codicon.symbolValue),z.set(d.Enum,i.Codicon.symbolEnum),z.set(d.Constant,i.Codicon.symbolConstant),z.set(d.Enum,i.Codicon.symbolEnum),z.set(d.EnumMember,i.Codicon.symbolEnumMember),z.set(d.Keyword,i.Codicon.symbolKeyword),z.set(d.Snippet,i.Codicon.symbolSnippet),z.set(d.Text,i.Codicon.symbolText),z.set(d.Color,i.Codicon.symbolColor),z.set(d.File,i.Codicon.symbolFile),z.set(d.Reference,i.Codicon.symbolReference),z.set(d.Customcolor,i.Codicon.symbolCustomColor),z.set(d.Folder,i.Codicon.symbolFolder),z.set(d.TypeParameter,i.Codicon.symbolTypeParameter),z.set(d.User,i.Codicon.account),z.set(d.Issue,i.Codicon.issues);function ne(H){let ce=z.get(H);return ce||(console.info("No codicon found for CompletionItemKind "+H),ce=i.Codicon.symbolProperty),ce}x.toIcon=ne;const le=new Map;le.set("method",d.Method),le.set("function",d.Function),le.set("constructor",d.Constructor),le.set("field",d.Field),le.set("variable",d.Variable),le.set("class",d.Class),le.set("struct",d.Struct),le.set("interface",d.Interface),le.set("module",d.Module),le.set("property",d.Property),le.set("event",d.Event),le.set("operator",d.Operator),le.set("unit",d.Unit),le.set("value",d.Value),le.set("constant",d.Constant),le.set("enum",d.Enum),le.set("enum-member",d.EnumMember),le.set("enumMember",d.EnumMember),le.set("keyword",d.Keyword),le.set("snippet",d.Snippet),le.set("text",d.Text),le.set("color",d.Color),le.set("file",d.File),le.set("reference",d.Reference),le.set("customcolor",d.Customcolor),le.set("folder",d.Folder),le.set("type-parameter",d.TypeParameter),le.set("typeParameter",d.TypeParameter),le.set("account",d.User),le.set("issue",d.Issue);function ve(H,ce){let J=le.get(H);return typeof J>"u"&&!ce&&(J=d.Property),J}x.fromString=ve})(E||(e.CompletionItemKinds=E={}));var a;(function(x){x[x.Deprecated=1]="Deprecated"})(a||(e.CompletionItemTag=a={}));var f;(function(x){x[x.None=0]="None",x[x.KeepWhitespace=1]="KeepWhitespace",x[x.InsertAsSnippet=4]="InsertAsSnippet"})(f||(e.CompletionItemInsertTextRule=f={}));var m;(function(x){x[x.Word=0]="Word",x[x.Line=1]="Line",x[x.Suggest=2]="Suggest"})(m||(e.PartialAcceptTriggerKind=m={}));var p;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p||(e.CompletionTriggerKind=p={}));var S;(function(x){x[x.Automatic=0]="Automatic",x[x.Explicit=1]="Explicit"})(S||(e.InlineCompletionTriggerKind=S={}));class g{constructor(z,ne,le,ve){this.range=z,this.text=ne,this.completionKind=le,this.isSnippetText=ve}equals(z){return C.Range.lift(this.range).equalsRange(z.range)&&this.text===z.text&&this.completionKind===z.completionKind&&this.isSnippetText===z.isSnippetText}}e.SelectedSuggestionInfo=g;var v;(function(x){x[x.Invoke=1]="Invoke",x[x.Auto=2]="Auto"})(v||(e.CodeActionTriggerType=v={}));var t;(function(x){x[x.Automatic=0]="Automatic",x[x.PasteAs=1]="PasteAs"})(t||(e.DocumentPasteTriggerKind=t={}));var l;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(l||(e.SignatureHelpTriggerKind=l={}));var n;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(n||(e.DocumentHighlightKind=n={}));function h(x){return x&&r.URI.isUri(x.uri)&&C.Range.isIRange(x.range)&&(C.Range.isIRange(x.originSelectionRange)||C.Range.isIRange(x.targetSelectionRange))}var s;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(s||(e.SymbolKind=s={})),e.symbolKindNames={[s.Array]:(0,_.localize)(0,null),[s.Boolean]:(0,_.localize)(1,null),[s.Class]:(0,_.localize)(2,null),[s.Constant]:(0,_.localize)(3,null),[s.Constructor]:(0,_.localize)(4,null),[s.Enum]:(0,_.localize)(5,null),[s.EnumMember]:(0,_.localize)(6,null),[s.Event]:(0,_.localize)(7,null),[s.Field]:(0,_.localize)(8,null),[s.File]:(0,_.localize)(9,null),[s.Function]:(0,_.localize)(10,null),[s.Interface]:(0,_.localize)(11,null),[s.Key]:(0,_.localize)(12,null),[s.Method]:(0,_.localize)(13,null),[s.Module]:(0,_.localize)(14,null),[s.Namespace]:(0,_.localize)(15,null),[s.Null]:(0,_.localize)(16,null),[s.Number]:(0,_.localize)(17,null),[s.Object]:(0,_.localize)(18,null),[s.Operator]:(0,_.localize)(19,null),[s.Package]:(0,_.localize)(20,null),[s.Property]:(0,_.localize)(21,null),[s.String]:(0,_.localize)(22,null),[s.Struct]:(0,_.localize)(23,null),[s.TypeParameter]:(0,_.localize)(24,null),[s.Variable]:(0,_.localize)(25,null)};function c(x,z){return(0,_.localize)(26,null,x,e.symbolKindNames[z])}var u;(function(x){x[x.Deprecated=1]="Deprecated"})(u||(e.SymbolTag=u={}));var I;(function(x){const z=new Map;z.set(s.File,i.Codicon.symbolFile),z.set(s.Module,i.Codicon.symbolModule),z.set(s.Namespace,i.Codicon.symbolNamespace),z.set(s.Package,i.Codicon.symbolPackage),z.set(s.Class,i.Codicon.symbolClass),z.set(s.Method,i.Codicon.symbolMethod),z.set(s.Property,i.Codicon.symbolProperty),z.set(s.Field,i.Codicon.symbolField),z.set(s.Constructor,i.Codicon.symbolConstructor),z.set(s.Enum,i.Codicon.symbolEnum),z.set(s.Interface,i.Codicon.symbolInterface),z.set(s.Function,i.Codicon.symbolFunction),z.set(s.Variable,i.Codicon.symbolVariable),z.set(s.Constant,i.Codicon.symbolConstant),z.set(s.String,i.Codicon.symbolString),z.set(s.Number,i.Codicon.symbolNumber),z.set(s.Boolean,i.Codicon.symbolBoolean),z.set(s.Array,i.Codicon.symbolArray),z.set(s.Object,i.Codicon.symbolObject),z.set(s.Key,i.Codicon.symbolKey),z.set(s.Null,i.Codicon.symbolNull),z.set(s.EnumMember,i.Codicon.symbolEnumMember),z.set(s.Struct,i.Codicon.symbolStruct),z.set(s.Event,i.Codicon.symbolEvent),z.set(s.Operator,i.Codicon.symbolOperator),z.set(s.TypeParameter,i.Codicon.symbolTypeParameter);function ne(le){let ve=z.get(le);return ve||(console.info("No codicon found for SymbolKind "+le),ve=i.Codicon.symbolProperty),ve}x.toIcon=ne})(I||(e.SymbolKinds=I={}));class T{static asEditOperation(z){return w.EditOperation.replace(C.Range.lift(z.range),z.text)}}e.TextEdit=T;class A{static{this.Comment=new A("comment")}static{this.Imports=new A("imports")}static{this.Region=new A("region")}static fromValue(z){switch(z){case"comment":return A.Comment;case"imports":return A.Imports;case"region":return A.Region}return new A(z)}constructor(z){this.value=z}}e.FoldingRangeKind=A;var O;(function(x){x[x.AIGenerated=1]="AIGenerated"})(O||(e.NewSymbolNameTag=O={}));var k;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(k||(e.NewSymbolNameTriggerKind=k={}));var P;(function(x){function z(ne){return!ne||typeof ne!="object"?!1:typeof ne.id=="string"&&typeof ne.title=="string"}x.is=z})(P||(e.Command=P={}));var B;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(B||(e.CommentThreadCollapsibleState=B={}));var Y;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(Y||(e.CommentThreadState=Y={}));var X;(function(x){x[x.Current=0]="Current",x[x.Outdated=1]="Outdated"})(X||(e.CommentThreadApplicability=X={}));var re;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(re||(e.CommentMode=re={}));var te;(function(x){x[x.Published=0]="Published",x[x.Draft=1]="Draft"})(te||(e.CommentState=te={}));var Z;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(Z||(e.InlayHintKind=Z={}));class fe{constructor(z){this.createSupport=z,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(z=>{z&&z.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}e.LazyTokenizationSupport=fe,e.TokenizationRegistry=new R.TokenizationRegistry;var K;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(K||(e.ExternalUriOpenerPriority=K={}));var ae;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(ae||(e.InlineEditTriggerKind=ae={}))}),define(ye[202],Ie([7,8]),function(se,e){return se.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[203],Ie([7,8]),function(se,e){return se.create("vs/platform/contextkey/common/contextkey",e)}),define(ye[204],Ie([7,8]),function(se,e){return se.create("vs/platform/contextkey/common/scanner",e)}),define(ye[205],Ie([7,8]),function(se,e){return se.create("vs/platform/environment/node/argv",e)}),define(ye[206],Ie([7,8]),function(se,e){return se.create("vs/platform/environment/node/argvHelper",e)}),define(ye[207],Ie([7,8]),function(se,e){return se.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ye[208],Ie([7,8]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[209],Ie([7,8]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ye[210],Ie([7,8]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ye[211],Ie([7,8]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ye[212],Ie([7,8]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ye[213],Ie([7,8]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ye[214],Ie([7,8]),function(se,e){return se.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[215],Ie([7,8]),function(se,e){return se.create("vs/platform/files/common/fileService",e)}),define(ye[216],Ie([7,8]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(ye[217],Ie([7,8]),function(se,e){return se.create("vs/platform/files/common/io",e)}),define(ye[218],Ie([7,8]),function(se,e){return se.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ye[219],Ie([7,8]),function(se,e){return se.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ye[220],Ie([7,8]),function(se,e){return se.create("vs/platform/log/common/log",e)}),define(ye[221],Ie([7,8]),function(se,e){return se.create("vs/platform/markers/common/markers",e)}),define(ye[222],Ie([7,8]),function(se,e){return se.create("vs/platform/request/common/request",e)}),define(ye[223],Ie([7,8]),function(se,e){return se.create("vs/platform/shell/node/shellEnv",e)}),define(ye[224],Ie([7,8]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryService",e)}),define(ye[225],Ie([7,8]),function(se,e){return se.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ye[226],Ie([7,8]),function(se,e){return se.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ye[227],Ie([7,8]),function(se,e){return se.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ye[228],Ie([7,8]),function(se,e){return se.create("vs/platform/workspace/common/workspace",e)}),define(ye[229],Ie([7,8]),function(se,e){return se.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(ye[230],Ie([7,8]),function(se,e){return se.create("vs/server/node/serverEnvironmentService",e)}),define(ye[231],Ie([7,8]),function(se,e){return se.create("vs/server/node/serverServices",e)}),define(ye[232],Ie([7,8]),function(se,e){return se.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ye[233],Ie([7,8]),function(se,e){return se.create("vs/workbench/common/editor",e)}),define(ye[234],Ie([7,8]),function(se,e){return se.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ye[235],Ie([7,8]),function(se,e){return se.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(ye[236],Ie([7,8]),function(se,e){return se.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[237],Ie([7,8]),function(se,e){return se.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[238],Ie([7,8]),function(se,e){return se.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[239],Ie([7,8]),function(se,e){return se.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(ye[240],Ie([1,0,35,10,204]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var C;(function(D){D[D.LParen=0]="LParen",D[D.RParen=1]="RParen",D[D.Neg=2]="Neg",D[D.Eq=3]="Eq",D[D.NotEq=4]="NotEq",D[D.Lt=5]="Lt",D[D.LtEq=6]="LtEq",D[D.Gt=7]="Gt",D[D.GtEq=8]="GtEq",D[D.RegexOp=9]="RegexOp",D[D.RegexStr=10]="RegexStr",D[D.True=11]="True",D[D.False=12]="False",D[D.In=13]="In",D[D.Not=14]="Not",D[D.And=15]="And",D[D.Or=16]="Or",D[D.Str=17]="Str",D[D.QuotedStr=18]="QuotedStr",D[D.Error=19]="Error",D[D.EOF=20]="EOF"})(C||(e.TokenType=C={}));function R(...D){switch(D.length){case 1:return(0,w.localize)(0,null,D[0]);case 2:return(0,w.localize)(1,null,D[0],D[1]);case 3:return(0,w.localize)(2,null,D[0],D[1],D[2]);default:return}}const _=(0,w.localize)(3,null),b=(0,w.localize)(4,null);class o{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case C.LParen:return"(";case C.RParen:return")";case C.Neg:return"!";case C.Eq:return y.isTripleEq?"===":"==";case C.NotEq:return y.isTripleEq?"!==":"!=";case C.Lt:return"<";case C.LtEq:return"<=";case C.Gt:return">=";case C.GtEq:return">=";case C.RegexOp:return"=~";case C.RegexStr:return y.lexeme;case C.True:return"true";case C.False:return"false";case C.In:return"in";case C.Not:return"not";case C.And:return"&&";case C.Or:return"||";case C.Str:return y.lexeme;case C.QuotedStr:return y.lexeme;case C.Error:return y.lexeme;case C.EOF:return"EOF";default:throw(0,r.illegalState)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this._keywords=new Map([["not",C.Not],["in",C.In],["false",C.False],["true",C.True]])}get errors(){return this._errors}reset(y){return this._input=y,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case i.CharCode.OpenParen:this._addToken(C.LParen);break;case i.CharCode.CloseParen:this._addToken(C.RParen);break;case i.CharCode.ExclamationMark:if(this._match(i.CharCode.Equals)){const d=this._match(i.CharCode.Equals);this._tokens.push({type:C.NotEq,offset:this._start,isTripleEq:d})}else this._addToken(C.Neg);break;case i.CharCode.SingleQuote:this._quotedString();break;case i.CharCode.Slash:this._regex();break;case i.CharCode.Equals:if(this._match(i.CharCode.Equals)){const d=this._match(i.CharCode.Equals);this._tokens.push({type:C.Eq,offset:this._start,isTripleEq:d})}else this._match(i.CharCode.Tilde)?this._addToken(C.RegexOp):this._error(R("==","=~"));break;case i.CharCode.LessThan:this._addToken(this._match(i.CharCode.Equals)?C.LtEq:C.Lt);break;case i.CharCode.GreaterThan:this._addToken(this._match(i.CharCode.Equals)?C.GtEq:C.Gt);break;case i.CharCode.Ampersand:this._match(i.CharCode.Ampersand)?this._addToken(C.And):this._error(R("&&"));break;case i.CharCode.Pipe:this._match(i.CharCode.Pipe)?this._addToken(C.Or):this._error(R("||"));break;case i.CharCode.Space:case i.CharCode.CarriageReturn:case i.CharCode.Tab:case i.CharCode.LineFeed:case i.CharCode.NoBreakSpace:break;default:this._string()}return this._start=this._current,this._addToken(C.EOF),Array.from(this._tokens)}_match(y){return this._isAtEnd()||this._input.charCodeAt(this._current)!==y?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?i.CharCode.Null:this._input.charCodeAt(this._current)}_addToken(y){this._tokens.push({type:y,offset:this._start})}_error(y){const d=this._start,E=this._input.substring(this._start,this._current),a={type:C.Error,offset:this._start,lexeme:E};this._errors.push({offset:d,lexeme:E,additionalInfo:y}),this._tokens.push(a)}_string(){this.stringRe.lastIndex=this._start;const y=this.stringRe.exec(this._input);if(y){this._current=this._start+y[0].length;const d=this._input.substring(this._start,this._current),E=o._keywords.get(d);E?this._addToken(E):this._tokens.push({type:C.Str,lexeme:d,offset:this._start})}}_quotedString(){for(;this._peek()!==i.CharCode.SingleQuote&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(_);return}this._advance(),this._tokens.push({type:C.QuotedStr,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let y=this._current,d=!1,E=!1;for(;;){if(y>=this._input.length){this._current=y,this._error(b);return}const f=this._input.charCodeAt(y);if(d)d=!1;else if(f===i.CharCode.Slash&&!E){y++;break}else f===i.CharCode.OpenSquareBracket?E=!0:f===i.CharCode.Backslash?d=!0:f===i.CharCode.CloseSquareBracket&&(E=!1);y++}for(;y<this._input.length&&o._regexFlags.has(this._input.charCodeAt(y));)y++;this._current=y;const a=this._input.substring(this._start,this._current);this._tokens.push({type:C.RegexStr,lexeme:a,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=o}),define(ye[241],Ie([1,0,6,2]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class w{constructor(){this._onCloseEmitter=new i.Emitter,this._onReloadEmitter=new i.Emitter,this._onTerminateEmitter=new i.Emitter,this._onAttachEmitter=new i.Emitter}static{this.ChannelName="extensionhostdebugservice"}call(_,b,o){switch(b){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:o[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:o[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:o[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:o[0],port:o[1],subId:o[2]}))}throw new Error("Method not implemented.")}listen(_,b,o){switch(b){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=w;class C extends r.Disposable{constructor(_){super(),this.channel=_}reload(_){this.channel.call("reload",[_])}get onReload(){return this.channel.listen("reload")}close(_){this.channel.call("close",[_])}get onClose(){return this.channel.listen("close")}attachSession(_,b,o){this.channel.call("attach",[_,b,o])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(_,b){this.channel.call("terminate",[_,b])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(_,b){return this.channel.call("openExtensionDevelopmentHostWindow",[_,b])}}e.ExtensionHostDebugChannelClient=C}),define(ye[242],Ie([1,0,4]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class r{constructor(R){this.service=R}listen(R,_,b){throw new Error("Invalid listen")}call(R,_,b){switch(_){case"download":return this.service.download(i.URI.revive(b[0]),i.URI.revive(b[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=r;class w{constructor(R,_){this.channel=R,this.getUriTransformer=_}async download(R,_){const b=this.getUriTransformer();b&&(R=b.transformOutgoingURI(R),_=b.transformOutgoingURI(_)),await this.channel.call("download",[R,_])}}e.DownloadServiceChannelClient=w}),define(ye[243],Ie([1,0,187,78,13,9,33,20,4]),function(se,e,i,r,w,C,R,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.parseExtensionHostDebugPort=D,e.parseDebugParams=y,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class o{get appRoot(){return(0,C.dirname)(w.FileAccess.asFileUri("").fsPath)}get userHome(){return b.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return b.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.paths.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get stateResource(){return(0,_.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:w.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,_.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const E=(0,i.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",E)}return b.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,_.joinPath)(b.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,_.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,_.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,_.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const E=R.env.VSCODE_PORTABLE;return E?b.URI.file((0,C.join)(E,"argv.json")):(0,_.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const E=this.args["builtin-extensions-dir"];return E?(0,C.resolve)(E):(0,C.normalize)((0,C.join)(w.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const E=this.args["extensions-download-dir"];return E?b.URI.file((0,C.resolve)(E)):b.URI.file((0,C.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const E=this.args["extensions-dir"];if(E)return(0,C.resolve)(E);const a=R.env.VSCODE_EXTENSIONS;if(a)return a;const f=R.env.VSCODE_PORTABLE;return f?(0,C.join)(f,"extensions"):(0,_.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const E=this.args.extensionDevelopmentPath;if(Array.isArray(E))return E.map(a=>/^[^:/?#]+?:\/\//.test(a)?b.URI.parse(a):b.URI.file((0,C.normalize)(a)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(E=>E==="ui"||E==="workspace"||E==="web"?E:"workspace")}get extensionTestsLocationURI(){const E=this.args.extensionTestsPath;if(E)return/^[^:/?#]+?:\/\//.test(E)?b.URI.parse(E):b.URI.file((0,C.normalize)(E))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const E=this.args["disable-extension"];if(E){if(typeof E=="string")return[E];if(Array.isArray(E)&&E.length>0)return E}return!1}get debugExtensionHost(){return D(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(E=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(E))}get extensionLogLevel(){const E=[];for(const a of this.args.log||[]){const f=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(a);f&&f[1]&&f[2]&&E.push([f[1],f[2]])}return E.length?E:void 0}get serviceMachineIdResource(){return(0,_.joinPath)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const E=R.env.VSCODE_PORTABLE;return E?b.URI.file((0,C.join)(E,"policy.json")):(0,_.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(E){this.args.continueOn=E}get args(){return this._args}constructor(E,a,f){this._args=E,this.paths=a,this.productService=f,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=o,ze([r.memoize],o.prototype,"appRoot",null),ze([r.memoize],o.prototype,"userHome",null),ze([r.memoize],o.prototype,"userDataPath",null),ze([r.memoize],o.prototype,"appSettingsHome",null),ze([r.memoize],o.prototype,"tmpDir",null),ze([r.memoize],o.prototype,"cacheHome",null),ze([r.memoize],o.prototype,"stateResource",null),ze([r.memoize],o.prototype,"userRoamingDataHome",null),ze([r.memoize],o.prototype,"userDataSyncHome",null),ze([r.memoize],o.prototype,"sync",null),ze([r.memoize],o.prototype,"machineSettingsResource",null),ze([r.memoize],o.prototype,"workspaceStorageHome",null),ze([r.memoize],o.prototype,"localHistoryHome",null),ze([r.memoize],o.prototype,"keyboardLayoutResource",null),ze([r.memoize],o.prototype,"argvResource",null),ze([r.memoize],o.prototype,"isExtensionDevelopment",null),ze([r.memoize],o.prototype,"untitledWorkspacesHome",null),ze([r.memoize],o.prototype,"builtinExtensionsPath",null),ze([r.memoize],o.prototype,"extensionsPath",null),ze([r.memoize],o.prototype,"extensionDevelopmentLocationURI",null),ze([r.memoize],o.prototype,"extensionDevelopmentKind",null),ze([r.memoize],o.prototype,"extensionTestsLocationURI",null),ze([r.memoize],o.prototype,"debugExtensionHost",null),ze([r.memoize],o.prototype,"logLevel",null),ze([r.memoize],o.prototype,"extensionLogLevel",null),ze([r.memoize],o.prototype,"serviceMachineIdResource",null),ze([r.memoize],o.prototype,"disableTelemetry",null),ze([r.memoize],o.prototype,"disableWorkspaceTrust",null),ze([r.memoize],o.prototype,"useInMemorySecretStorage",null),ze([r.memoize],o.prototype,"policyFile",null);function D(d,E){return y(d["inspect-extensions"],d["inspect-brk-extensions"],5870,E,d.debugId,d.extensionEnvironment)}function y(d,E,a,f,m,p){const g=Number(E||d)||(f?null:a),v=g?!!E:!1;let t;if(p)try{t=JSON.parse(p)}catch{}return{port:g,break:v,debugId:m,env:t}}});var gt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ye[70],Ie([1,0,334,3,205]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0,e.parseArgs=_,e.formatOptions=o,e.buildHelpMessage=E,e.buildVersionMessage=a,i=gt(i);const C={o:(0,w.localize)(0,null),e:(0,w.localize)(1,null),t:(0,w.localize)(2,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,w.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,w.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,w.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,w.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,w.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,w.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,w.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,w.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,w.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,w.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,w.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,w.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,w.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,w.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,w.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,w.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,w.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,w.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,w.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,w.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,w.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,w.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,w.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,w.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,w.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,w.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,w.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,w.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,w.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,w.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,w.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,w.localize)(34,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,w.localize)(35,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,w.localize)(36,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,w.localize)(37,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,w.localize)(38,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const R={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function _(f,m,p=R){const S=f.find(u=>u.length>0&&u[0]!=="-"),g={},v=["_"],t=[],l={};let n;for(const u in m){const I=m[u];I.type==="subcommand"?u===S&&(n=I):(I.alias&&(g[u]=I.alias),I.type==="string"||I.type==="string[]"?(v.push(u),I.deprecates&&v.push(...I.deprecates)):I.type==="boolean"&&(t.push(u),I.deprecates&&t.push(...I.deprecates)),I.global&&(l[u]=I))}if(n&&S){const u=l;for(const O in n.options)u[O]=n.options[O];const I=f.filter(O=>O!==S),T=p.getSubcommandReporter?p.getSubcommandReporter(S):void 0,A=_(I,u,T);return{[S]:A,_:[]}}const h=(0,i.default)(f,{string:v,boolean:t,alias:g}),s={},c=h;s._=h._.map(u=>String(u)).filter(u=>u.length>0),delete c._;for(const u in m){const I=m[u];if(I.type==="subcommand")continue;I.alias&&delete c[I.alias];let T=c[u];if(I.deprecates)for(const A of I.deprecates)c.hasOwnProperty(A)&&(T||(T=c[A],T&&p.onDeprecatedOption(A,I.deprecationMessage||(0,w.localize)(39,null,u))),delete c[A]);if(typeof T<"u"){if(I.type==="string[]"){if(Array.isArray(T)||(T=[T]),!I.allowEmptyValue){const A=T.filter(O=>O.length>0);A.length!==T.length&&(p.onEmptyValue(u),T=A.length>0?A:void 0)}}else I.type==="string"&&(Array.isArray(T)?(T=T.pop(),p.onMultipleValues(u,T)):!T&&!I.allowEmptyValue&&(p.onEmptyValue(u),T=void 0));s[u]=T,I.deprecationMessage&&p.onDeprecatedOption(u,I.deprecationMessage)}delete c[u]}for(const u in c)p.onUnknownOption(u);return s}function b(f,m){let p="";return m.args&&(Array.isArray(m.args)?p=` <${m.args.join("> <")}>`:p=` <${m.args}>`),m.alias?`-${m.alias} --${f}${p}`:`--${f}${p}`}function o(f,m){const p=[];for(const S in f){const g=f[S],v=b(S,g);p.push([v,g.description])}return D(p,m)}function D(f,m){const S=f.reduce((t,l)=>Math.max(t,l[0].length),12)+2+1;if(m-S<25)return f.reduce((t,l)=>t.concat([`  ${l[0]}`,`      ${l[1]}`]),[]);const g=m-S-1,v=[];for(const t of f){const l=t[0],n=d(t[1],g),h=y(S-l.length-2);v.push("  "+l+h+n[0]);for(let s=1;s<n.length;s++)v.push(y(S)+n[s])}return v}function y(f){return" ".repeat(f)}function d(f,m){const p=[];for(;f.length;){const S=f.length<m?f.length:f.lastIndexOf(" ",m),g=f.slice(0,S).trim();f=f.slice(S),p.push(g)}return p}function E(f,m,p,S,g){const v=process.stdout.isTTY&&process.stdout.columns||80,t=g?.noInputFiles!==!0?`[${(0,w.localize)(40,null)}...]`:"",l=[`${f} ${p}`];l.push(""),l.push(`${(0,w.localize)(41,null)}: ${m} [${(0,w.localize)(42,null)}]${t}`),l.push(""),g?.noPipe!==!0&&(r.isWindows?l.push((0,w.localize)(43,null,m)):l.push((0,w.localize)(44,null,m)),l.push(""));const n={},h=[];for(const s in S){const c=S[s];if(c.type==="subcommand")c.description&&h.push({command:s,description:c.description});else if(c.description&&c.cat){let u=n[c.cat];u||(n[c.cat]=u={}),u[s]=c}}for(const s in n){const c=s,u=n[c];u&&(l.push(C[c]),l.push(...o(u,v)),l.push(""))}return h.length&&(l.push((0,w.localize)(45,null)),l.push(...D(h.map(s=>[s.command,s.description]),v)),l.push("")),l.join(`
`)}function a(f,m){return`${f||(0,w.localize)(46,null)}
${m||(0,w.localize)(47,null)}
${process.arch}`}});var gt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ye[244],Ie([1,0,335,206,70]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseMainProcessArgv=_,e.parseCLIProcessArgv=b,e.addArg=o,e.isLaunchedFromCli=D,i=gt(i);function C(y,d){const E=(g,v)=>{console.warn((0,r.localize)(0,null,g,v))},a=g=>{console.warn((0,r.localize)(1,null,g))},f=(g,v)=>{console.warn((0,r.localize)(2,null,g,v))},m=g=>({onUnknownOption:v=>{w.NATIVE_CLI_COMMANDS.includes(g)||console.warn((0,r.localize)(3,null,v,g))},onMultipleValues:E,onEmptyValue:a,onDeprecatedOption:f,getSubcommandReporter:w.NATIVE_CLI_COMMANDS.includes(g)?m:void 0}),p={onUnknownOption:g=>{console.warn((0,r.localize)(4,null,g))},onMultipleValues:E,onEmptyValue:a,onDeprecatedOption:f,getSubcommandReporter:m},S=(0,w.parseArgs)(y,w.OPTIONS,d?p:void 0);return S.goto&&S._.forEach(g=>(0,i.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(g),(0,r.localize)(5,null))),S}function R(y){const d=y.findIndex(E=>!/^-/.test(E));if(d>-1)return[...y.slice(0,d),...y.slice(d+1)]}function _(y){let[,...d]=y;process.env.VSCODE_DEV&&(d=R(d)||[]);const E=!D(process.env);return C(d,E)}function b(y){let[,,...d]=y;return process.env.VSCODE_DEV&&(d=R(d)||[]),C(d,!0)}function o(y,...d){const E=y.indexOf("--");return E===-1?y.push(...d):y.splice(E,0,...d),y}function D(y){return y.VSCODE_CLI==="1"}}),function(){"use strict";function se(e,i,r){function w(R,_){const b=C(R,_),o=[b];return e.isAbsolute(b)||o.unshift(r),e.resolve(...o)}function C(R,_){process.env.VSCODE_DEV&&(_="code-oss-dev");const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let o=process.env.VSCODE_APPDATA;if(o)return e.join(o,_);const D=R["user-data-dir"];if(D)return D;switch(process.platform){case"win32":if(o=process.env.APPDATA,!o){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");o=e.join(y,"AppData","Roaming")}break;case"darwin":o=e.join(i.homedir(),"Library","Application Support");break;case"linux":o=process.env.XDG_CONFIG_HOME||e.join(i.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(o,_)}return{getUserDataPath:w}}if(typeof define=="function")define(ye[245],Ie([83,32,33]),function(e,i,r){return se(e,i,r.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),i=require("os");module.exports=se(e,i,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ye[118],Ie([1,0,32,243,245]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0,e.parsePtyHostDebugPort=R,e.parseSharedProcessDebugPort=_;class C extends r.AbstractNativeEnvironmentService{constructor(o,D){super(o,{homeDir:(0,i.homedir)(),tmpDir:(0,i.tmpdir)(),userDataDir:(0,w.getUserDataPath)(o,D.nameShort)},D)}}e.NativeEnvironmentService=C;function R(b,o){return(0,r.parseDebugParams)(b["inspect-ptyhost"],b["inspect-brk-ptyhost"],5877,o,b.extensionEnvironment)}function _(b,o){return(0,r.parseDebugParams)(b["inspect-sharedprocess"],b["inspect-brk-sharedprocess"],5879,o,b.extensionEnvironment)}}),define(ye[246],Ie([1,0,11,210]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=w;function w(R,_,b,o){try{C(R,_,b,o)}catch(D){R.error(D?.message??D)}return _}function C(R,_,b,o){const D=(y,d,E)=>{const a=y[d];if((0,i.isString)(a)){const f=a,m=f.length;if(m>1&&f[0]==="%"&&f[m-1]==="%"){const p=f.substr(1,m-2);let S=b[p];S===void 0&&o&&(S=o[p]);const g=typeof S=="string"?S:S?.message,v=o?.[p],t=typeof v=="string"?v:v?.message;if(!g){t||R.warn(`[${_.name}]: ${(0,r.localize)(0,null,p)}`);return}if(E&&(d==="title"||d==="category")&&t&&t!==g){const l={value:g,original:t};y[d]=l}else y[d]=g}}else if((0,i.isObject)(a))for(const f in a)a.hasOwnProperty(f)&&(f==="commands"?D(a,f,!0):D(a,f,E));else if(Array.isArray(a))for(let f=0;f<a.length;f++)D(a,f,E)};for(const y in _)_.hasOwnProperty(y)&&D(_,y)}}),define(ye[119],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const i={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts"},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(i)}),define(ye[71],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class i{constructor(w,C=[],R=!1){this.ctor=w,this.staticArguments=C,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=i}),define(ye[120],Ie([1,0,71]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=C,e.getSingletonServiceDescriptors=R;const r=[];var w;(function(_){_[_.Eager=0]="Eager",_[_.Delayed=1]="Delayed"})(w||(e.InstantiationType=w={}));function C(_,b,o){b instanceof i.SyncDescriptor||(b=new i.SyncDescriptor(b,[],!!o)),r.push([_,b])}function R(){return r}}),define(ye[247],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class i{constructor(C,R){this.key=C,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.Node=i;class r{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(const R of this._nodes.values())R.outgoing.size===0&&C.push(R);return C}insertEdge(C,R){const _=this.lookupOrInsertNode(C),b=this.lookupOrInsertNode(R);_.outgoing.set(b.key,b),b.incoming.set(_.key,_)}removeNode(C){const R=this._hashFn(C);this._nodes.delete(R);for(const _ of this._nodes.values())_.outgoing.delete(R),_.incoming.delete(R)}lookupOrInsertNode(C){const R=this._hashFn(C);let _=this._nodes.get(R);return _||(_=new i(R,C),this._nodes.set(R,_)),_}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){const C=[];for(const[R,_]of this._nodes)C.push(`${R}
	(-> incoming)[${[..._.incoming.keys()].join(", ")}]
	(outgoing ->)[${[..._.outgoing.keys()].join(",")}]
`);return C.join(`
`)}findCycleSlow(){for(const[C,R]of this._nodes){const _=new Set([C]),b=this._findCycle(R,_);if(b)return b}}_findCycle(C,R){for(const[_,b]of C.outgoing){if(R.has(_))return[...R,_].join(" -> ");R.add(_);const o=this._findCycle(b,R);if(o)return o;R.delete(_)}}}e.Graph=r}),define(ye[5],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=w,e.refineServiceDecorator=C;var i;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function _(b){return b[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=_})(i||(e._util=i={})),e.IInstantiationService=w("instantiationService");function r(R,_,b){_[i.DI_TARGET]===_?_[i.DI_DEPENDENCIES].push({id:R,index:b}):(_[i.DI_DEPENDENCIES]=[{id:R,index:b}],_[i.DI_TARGET]=_)}function w(R){if(i.serviceIds.has(R))return i.serviceIds.get(R);const _=function(b,o,D){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(_,b,D)};return _.toString=()=>R,i.serviceIds.set(R,_),_}function C(R){return R}}),define(ye[27],Ie([1,0,11,4,5]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=C,e.isConfigurationUpdateOverrides=R,e.ConfigurationTargetToString=b,e.isConfigured=o,e.toValuesTree=D,e.addToValueTree=y,e.removeFromValueTree=d,e.getConfigurationValue=a,e.merge=f,e.getLanguageTagSettingPlainKey=m,i=Be(i),e.IConfigurationService=(0,w.createDecorator)("configurationService");function C(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof r.URI)}function R(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||Array.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof r.URI)}var _;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.USER=2]="USER",p[p.USER_LOCAL=3]="USER_LOCAL",p[p.USER_REMOTE=4]="USER_REMOTE",p[p.WORKSPACE=5]="WORKSPACE",p[p.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",p[p.DEFAULT=7]="DEFAULT",p[p.MEMORY=8]="MEMORY"})(_||(e.ConfigurationTarget=_={}));function b(p){switch(p){case _.APPLICATION:return"APPLICATION";case _.USER:return"USER";case _.USER_LOCAL:return"USER_LOCAL";case _.USER_REMOTE:return"USER_REMOTE";case _.WORKSPACE:return"WORKSPACE";case _.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case _.DEFAULT:return"DEFAULT";case _.MEMORY:return"MEMORY"}}function o(p){return p.applicationValue!==void 0||p.userValue!==void 0||p.userLocalValue!==void 0||p.userRemoteValue!==void 0||p.workspaceValue!==void 0||p.workspaceFolderValue!==void 0}function D(p,S){const g=Object.create(null);for(const v in p)y(g,v,p[v],S);return g}function y(p,S,g,v){const t=S.split("."),l=t.pop();let n=p;for(let h=0;h<t.length;h++){const s=t[h];let c=n[s];switch(typeof c){case"undefined":c=n[s]=Object.create(null);break;case"object":if(c===null){v(`Ignoring ${S} as ${t.slice(0,h+1).join(".")} is null`);return}break;default:v(`Ignoring ${S} as ${t.slice(0,h+1).join(".")} is ${JSON.stringify(c)}`);return}n=c}if(typeof n=="object"&&n!==null)try{n[l]=g}catch{v(`Ignoring ${S} as ${t.join(".")} is ${JSON.stringify(n)}`)}else v(`Ignoring ${S} as ${t.join(".")} is ${JSON.stringify(n)}`)}function d(p,S){const g=S.split(".");E(p,g)}function E(p,S){const g=S.shift();if(S.length===0){delete p[g];return}if(Object.keys(p).indexOf(g)!==-1){const v=p[g];typeof v=="object"&&!Array.isArray(v)&&(E(v,S),Object.keys(v).length===0&&delete p[g])}}function a(p,S,g){function v(n,h){let s=n;for(const c of h){if(typeof s!="object"||s===null)return;s=s[c]}return s}const t=S.split("."),l=v(p,t);return typeof l>"u"?g:l}function f(p,S,g){Object.keys(S).forEach(v=>{v!=="__proto__"&&(v in p?i.isObject(p[v])&&i.isObject(S[v])?f(p[v],S[v],g):g&&(p[v]=S[v]):p[v]=S[v])})}function m(p){return p.replace(/[\[\]]/g,"")}}),define(ye[42],Ie([1,0,35,3,17,240,5,203,10]),function(se,e,i,r,w,C,R,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=D,e.validateWhenClauses=h,e.expressionsAreEqualWithConstantSubstitution=s,e.implies=H;const o=new Map;o.set("false",!1),o.set("true",!0),o.set("isMac",r.isMacintosh),o.set("isLinux",r.isLinux),o.set("isWindows",r.isWindows),o.set("isWeb",r.isWeb),o.set("isMacNative",r.isMacintosh&&!r.isWeb),o.set("isEdge",r.isEdge),o.set("isFirefox",r.isFirefox),o.set("isChrome",r.isChrome),o.set("isSafari",r.isSafari);function D(W,L){if(o.get(W)!==void 0)throw(0,b.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");o.set(W,L)}const y=Object.prototype.hasOwnProperty;var d;(function(W){W[W.False=0]="False",W[W.True=1]="True",W[W.Defined=2]="Defined",W[W.Not=3]="Not",W[W.Equals=4]="Equals",W[W.NotEquals=5]="NotEquals",W[W.And=6]="And",W[W.Regex=7]="Regex",W[W.NotRegex=8]="NotRegex",W[W.Or=9]="Or",W[W.In=10]="In",W[W.NotIn=11]="NotIn",W[W.Greater=12]="Greater",W[W.GreaterEquals=13]="GreaterEquals",W[W.Smaller=14]="Smaller",W[W.SmallerEquals=15]="SmallerEquals"})(d||(e.ContextKeyExprType=d={}));const E={regexParsingWithErrorRecovery:!0},a=(0,_.localize)(0,null),f=(0,_.localize)(1,null),m=(0,_.localize)(2,null),p=(0,_.localize)(3,null),S=(0,_.localize)(4,null),g=(0,_.localize)(5,null),v=(0,_.localize)(6,null),t=(0,_.localize)(7,null);class l{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(L=E){this._config=L,this._scanner=new C.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(L){if(L===""){this._parsingErrors.push({message:a,offset:0,lexeme:"",additionalInfo:f});return}this._tokens=this._scanner.reset(L).scan(),this._current=0,this._parsingErrors=[];try{const Q=this._expr();if(!this._isAtEnd()){const $=this._peek(),U=$.type===C.TokenType.Str?g:void 0;throw this._parsingErrors.push({message:S,offset:$.offset,lexeme:C.Scanner.getLexeme($),additionalInfo:U}),l._parseError}return Q}catch(Q){if(Q!==l._parseError)throw Q;return}}_expr(){return this._or()}_or(){const L=[this._and()];for(;this._matchOne(C.TokenType.Or);){const Q=this._and();L.push(Q)}return L.length===1?L[0]:n.or(...L)}_and(){const L=[this._term()];for(;this._matchOne(C.TokenType.And);){const Q=this._term();L.push(Q)}return L.length===1?L[0]:n.and(...L)}_term(){if(this._matchOne(C.TokenType.Neg)){const L=this._peek();switch(L.type){case C.TokenType.True:return this._advance(),u.INSTANCE;case C.TokenType.False:return this._advance(),I.INSTANCE;case C.TokenType.LParen:{this._advance();const Q=this._expr();return this._consume(C.TokenType.RParen,p),Q?.negate()}case C.TokenType.Str:return this._advance(),B.create(L.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",L)}}return this._primary()}_primary(){const L=this._peek();switch(L.type){case C.TokenType.True:return this._advance(),n.true();case C.TokenType.False:return this._advance(),n.false();case C.TokenType.LParen:{this._advance();const Q=this._expr();return this._consume(C.TokenType.RParen,p),Q}case C.TokenType.Str:{const Q=L.lexeme;if(this._advance(),this._matchOne(C.TokenType.RegexOp)){const U=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),U.type!==C.TokenType.RegexStr)throw this._errExpectedButGot("REGEX",U);const q=U.lexeme,G=q.lastIndexOf("/"),F=G===q.length-1?void 0:this._removeFlagsGY(q.substring(G+1));let V;try{V=new RegExp(q.substring(1,G),F)}catch{throw this._errExpectedButGot("REGEX",U)}return fe.create(Q,V)}switch(U.type){case C.TokenType.RegexStr:case C.TokenType.Error:{const q=[U.lexeme];this._advance();let G=this._peek(),F=0;for(let Ne=0;Ne<U.lexeme.length;Ne++)U.lexeme.charCodeAt(Ne)===i.CharCode.OpenParen?F++:U.lexeme.charCodeAt(Ne)===i.CharCode.CloseParen&&F--;for(;!this._isAtEnd()&&G.type!==C.TokenType.And&&G.type!==C.TokenType.Or;){switch(G.type){case C.TokenType.LParen:F++;break;case C.TokenType.RParen:F--;break;case C.TokenType.RegexStr:case C.TokenType.QuotedStr:for(let Ne=0;Ne<G.lexeme.length;Ne++)G.lexeme.charCodeAt(Ne)===i.CharCode.OpenParen?F++:U.lexeme.charCodeAt(Ne)===i.CharCode.CloseParen&&F--}if(F<0)break;q.push(C.Scanner.getLexeme(G)),this._advance(),G=this._peek()}const V=q.join(""),oe=V.lastIndexOf("/"),de=oe===V.length-1?void 0:this._removeFlagsGY(V.substring(oe+1));let Ce;try{Ce=new RegExp(V.substring(1,oe),de)}catch{throw this._errExpectedButGot("REGEX",U)}return n.regex(Q,Ce)}case C.TokenType.QuotedStr:{const q=U.lexeme;this._advance();let G=null;if(!(0,w.isFalsyOrWhitespace)(q)){const F=q.indexOf("/"),V=q.lastIndexOf("/");if(F!==V&&F>=0){const oe=q.slice(F+1,V),de=q[V+1]==="i"?"i":"";try{G=new RegExp(oe,de)}catch{throw this._errExpectedButGot("REGEX",U)}}}if(G===null)throw this._errExpectedButGot("REGEX",U);return fe.create(Q,G)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(C.TokenType.Not)){this._consume(C.TokenType.In,m);const U=this._value();return n.notIn(Q,U)}switch(this._peek().type){case C.TokenType.Eq:{this._advance();const U=this._value();if(this._previous().type===C.TokenType.QuotedStr)return n.equals(Q,U);switch(U){case"true":return n.has(Q);case"false":return n.not(Q);default:return n.equals(Q,U)}}case C.TokenType.NotEq:{this._advance();const U=this._value();if(this._previous().type===C.TokenType.QuotedStr)return n.notEquals(Q,U);switch(U){case"true":return n.not(Q);case"false":return n.has(Q);default:return n.notEquals(Q,U)}}case C.TokenType.Lt:return this._advance(),te.create(Q,this._value());case C.TokenType.LtEq:return this._advance(),Z.create(Q,this._value());case C.TokenType.Gt:return this._advance(),X.create(Q,this._value());case C.TokenType.GtEq:return this._advance(),re.create(Q,this._value());case C.TokenType.In:return this._advance(),n.in(Q,this._value());default:return n.has(Q)}}case C.TokenType.EOF:throw this._parsingErrors.push({message:v,offset:L.offset,lexeme:"",additionalInfo:t}),l._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const L=this._peek();switch(L.type){case C.TokenType.Str:case C.TokenType.QuotedStr:return this._advance(),L.lexeme;case C.TokenType.True:return this._advance(),"true";case C.TokenType.False:return this._advance(),"false";case C.TokenType.In:return this._advance(),"in";default:return""}}_removeFlagsGY(L){return L.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(L){return this._check(L)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(L,Q){if(this._check(L))return this._advance();throw this._errExpectedButGot(Q,this._peek())}_errExpectedButGot(L,Q,$){const U=(0,_.localize)(8,null,L,C.Scanner.getLexeme(Q)),q=Q.offset,G=C.Scanner.getLexeme(Q);return this._parsingErrors.push({message:U,offset:q,lexeme:G,additionalInfo:$}),l._parseError}_check(L){return this._peek().type===L}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===C.TokenType.EOF}}e.Parser=l;class n{static false(){return u.INSTANCE}static true(){return I.INSTANCE}static has(L){return T.create(L)}static equals(L,Q){return A.create(L,Q)}static notEquals(L,Q){return P.create(L,Q)}static regex(L,Q){return fe.create(L,Q)}static in(L,Q){return O.create(L,Q)}static notIn(L,Q){return k.create(L,Q)}static not(L){return B.create(L)}static and(...L){return x.create(L,null,!0)}static or(...L){return z.create(L,null,!0)}static greater(L,Q){return X.create(L,Q)}static greaterEquals(L,Q){return re.create(L,Q)}static smaller(L,Q){return te.create(L,Q)}static smallerEquals(L,Q){return Z.create(L,Q)}static{this._parser=new l({regexParsingWithErrorRecovery:!1})}static deserialize(L){return L==null?void 0:this._parser.parse(L)}}e.ContextKeyExpr=n;function h(W){const L=new l({regexParsingWithErrorRecovery:!1});return W.map(Q=>(L.parse(Q),L.lexingErrors.length>0?L.lexingErrors.map($=>({errorMessage:$.additionalInfo?(0,_.localize)(9,null,$.additionalInfo):(0,_.localize)(10,null),offset:$.offset,length:$.lexeme.length})):L.parsingErrors.length>0?L.parsingErrors.map($=>({errorMessage:$.additionalInfo?`${$.message}. ${$.additionalInfo}`:$.message,offset:$.offset,length:$.lexeme.length})):[]))}function s(W,L){const Q=W?W.substituteConstants():void 0,$=L?L.substituteConstants():void 0;return!Q&&!$?!0:!Q||!$?!1:Q.equals($)}function c(W,L){return W.cmp(L)}class u{static{this.INSTANCE=new u}constructor(){this.type=d.False}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return I.INSTANCE}}e.ContextKeyFalseExpr=u;class I{static{this.INSTANCE=new I}constructor(){this.type=d.True}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return u.INSTANCE}}e.ContextKeyTrueExpr=I;class T{static create(L,Q=null){const $=o.get(L);return typeof $=="boolean"?$?I.INSTANCE:u.INSTANCE:new T(L,Q)}constructor(L,Q){this.key=L,this.negated=Q,this.type=d.Defined}cmp(L){return L.type!==this.type?this.type-L.type:le(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=o.get(this.key);return typeof L=="boolean"?L?I.INSTANCE:u.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.negated||(this.negated=B.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=T;class A{static create(L,Q,$=null){if(typeof Q=="boolean")return Q?T.create(L,$):B.create(L,$);const U=o.get(L);return typeof U=="boolean"?Q===(U?"true":"false")?I.INSTANCE:u.INSTANCE:new A(L,Q,$)}constructor(L,Q,$){this.key=L,this.value=Q,this.negated=$,this.type=d.Equals}cmp(L){return L.type!==this.type?this.type-L.type:ve(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=o.get(this.key);if(typeof L=="boolean"){const Q=L?"true":"false";return this.value===Q?I.INSTANCE:u.INSTANCE}return this}evaluate(L){return L.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(L){return L.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=P.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=A;class O{static create(L,Q){return new O(L,Q)}constructor(L,Q){this.key=L,this.valueKey=Q,this.type=d.In,this.negated=null}cmp(L){return L.type!==this.type?this.type-L.type:ve(this.key,this.valueKey,L.key,L.valueKey)}equals(L){return L.type===this.type?this.key===L.key&&this.valueKey===L.valueKey:!1}substituteConstants(){return this}evaluate(L){const Q=L.getValue(this.valueKey),$=L.getValue(this.key);return Array.isArray(Q)?Q.includes($):typeof $=="string"&&typeof Q=="object"&&Q!==null?y.call(Q,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(L){return L.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=k.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=O;class k{static create(L,Q){return new k(L,Q)}constructor(L,Q){this.key=L,this.valueKey=Q,this.type=d.NotIn,this._negated=O.create(L,Q)}cmp(L){return L.type!==this.type?this.type-L.type:this._negated.cmp(L._negated)}equals(L){return L.type===this.type?this._negated.equals(L._negated):!1}substituteConstants(){return this}evaluate(L){return!this._negated.evaluate(L)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(L){return L.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=k;class P{static create(L,Q,$=null){if(typeof Q=="boolean")return Q?B.create(L,$):T.create(L,$);const U=o.get(L);return typeof U=="boolean"?Q===(U?"true":"false")?u.INSTANCE:I.INSTANCE:new P(L,Q,$)}constructor(L,Q,$){this.key=L,this.value=Q,this.negated=$,this.type=d.NotEquals}cmp(L){return L.type!==this.type?this.type-L.type:ve(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=o.get(this.key);if(typeof L=="boolean"){const Q=L?"true":"false";return this.value===Q?u.INSTANCE:I.INSTANCE}return this}evaluate(L){return L.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(L){return L.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=A.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=P;class B{static create(L,Q=null){const $=o.get(L);return typeof $=="boolean"?$?u.INSTANCE:I.INSTANCE:new B(L,Q)}constructor(L,Q){this.key=L,this.negated=Q,this.type=d.Not}cmp(L){return L.type!==this.type?this.type-L.type:le(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=o.get(this.key);return typeof L=="boolean"?L?u.INSTANCE:I.INSTANCE:this}evaluate(L){return!L.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(L){return L.mapNot(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=B;function Y(W,L){if(typeof W=="string"){const Q=parseFloat(W);isNaN(Q)||(W=Q)}return typeof W=="string"||typeof W=="number"?L(W):u.INSTANCE}class X{static create(L,Q,$=null){return Y(Q,U=>new X(L,U,$))}constructor(L,Q,$){this.key=L,this.value=Q,this.negated=$,this.type=d.Greater}cmp(L){return L.type!==this.type?this.type-L.type:ve(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=Z.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=X;class re{static create(L,Q,$=null){return Y(Q,U=>new re(L,U,$))}constructor(L,Q,$){this.key=L,this.value=Q,this.negated=$,this.type=d.GreaterEquals}cmp(L){return L.type!==this.type?this.type-L.type:ve(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=te.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=re;class te{static create(L,Q,$=null){return Y(Q,U=>new te(L,U,$))}constructor(L,Q,$){this.key=L,this.value=Q,this.negated=$,this.type=d.Smaller}cmp(L){return L.type!==this.type?this.type-L.type:ve(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=re.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=te;class Z{static create(L,Q,$=null){return Y(Q,U=>new Z(L,U,$))}constructor(L,Q,$){this.key=L,this.value=Q,this.negated=$,this.type=d.SmallerEquals}cmp(L){return L.type!==this.type?this.type-L.type:ve(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=X.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=Z;class fe{static create(L,Q){return new fe(L,Q)}constructor(L,Q){this.key=L,this.regexp=Q,this.type=d.Regex,this.negated=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.key<L.key)return-1;if(this.key>L.key)return 1;const Q=this.regexp?this.regexp.source:"",$=L.regexp?L.regexp.source:"";return Q<$?-1:Q>$?1:0}equals(L){if(L.type===this.type){const Q=this.regexp?this.regexp.source:"",$=L.regexp?L.regexp.source:"";return this.key===L.key&&Q===$}return!1}substituteConstants(){return this}evaluate(L){const Q=L.getValue(this.key);return this.regexp?this.regexp.test(Q):!1}serialize(){const L=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${L}`}keys(){return[this.key]}map(L){return L.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=K.create(this)),this.negated}}e.ContextKeyRegexExpr=fe;class K{static create(L){return new K(L)}constructor(L){this._actual=L,this.type=d.NotRegex}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(L){return new K(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=K;function ae(W){let L=null;for(let Q=0,$=W.length;Q<$;Q++){const U=W[Q].substituteConstants();if(W[Q]!==U&&L===null){L=[];for(let q=0;q<Q;q++)L[q]=W[q]}L!==null&&(L[Q]=U)}return L===null?W:L}class x{static create(L,Q,$){return x._normalizeArr(L,Q,$)}constructor(L,Q){this.expr=L,this.negated=Q,this.type=d.And}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let Q=0,$=this.expr.length;Q<$;Q++){const U=c(this.expr[Q],L.expr[Q]);if(U!==0)return U}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let Q=0,$=this.expr.length;Q<$;Q++)if(!this.expr[Q].equals(L.expr[Q]))return!1;return!0}return!1}substituteConstants(){const L=ae(this.expr);return L===this.expr?this:x.create(L,this.negated,!1)}evaluate(L){for(let Q=0,$=this.expr.length;Q<$;Q++)if(!this.expr[Q].evaluate(L))return!1;return!0}static _normalizeArr(L,Q,$){const U=[];let q=!1;for(const G of L)if(G){if(G.type===d.True){q=!0;continue}if(G.type===d.False)return u.INSTANCE;if(G.type===d.And){U.push(...G.expr);continue}U.push(G)}if(U.length===0&&q)return I.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(c);for(let G=1;G<U.length;G++)U[G-1].equals(U[G])&&(U.splice(G,1),G--);if(U.length===1)return U[0];for(;U.length>1;){const G=U[U.length-1];if(G.type!==d.Or)break;U.pop();const F=U.pop(),V=U.length===0,oe=z.create(G.expr.map(de=>x.create([de,F],null,$)),null,V);oe&&(U.push(oe),U.sort(c))}if(U.length===1)return U[0];if($){for(let G=0;G<U.length;G++)for(let F=G+1;F<U.length;F++)if(U[G].negate().equals(U[F]))return u.INSTANCE;if(U.length===1)return U[0]}return new x(U,Q)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const Q of this.expr)L.push(...Q.keys());return L}map(L){return new x(this.expr.map(Q=>Q.map(L)),null)}negate(){if(!this.negated){const L=[];for(const Q of this.expr)L.push(Q.negate());this.negated=z.create(L,this,!0)}return this.negated}}e.ContextKeyAndExpr=x;class z{static create(L,Q,$){return z._normalizeArr(L,Q,$)}constructor(L,Q){this.expr=L,this.negated=Q,this.type=d.Or}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let Q=0,$=this.expr.length;Q<$;Q++){const U=c(this.expr[Q],L.expr[Q]);if(U!==0)return U}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let Q=0,$=this.expr.length;Q<$;Q++)if(!this.expr[Q].equals(L.expr[Q]))return!1;return!0}return!1}substituteConstants(){const L=ae(this.expr);return L===this.expr?this:z.create(L,this.negated,!1)}evaluate(L){for(let Q=0,$=this.expr.length;Q<$;Q++)if(this.expr[Q].evaluate(L))return!0;return!1}static _normalizeArr(L,Q,$){let U=[],q=!1;if(L){for(let G=0,F=L.length;G<F;G++){const V=L[G];if(V){if(V.type===d.False){q=!0;continue}if(V.type===d.True)return I.INSTANCE;if(V.type===d.Or){U=U.concat(V.expr);continue}U.push(V)}}if(U.length===0&&q)return u.INSTANCE;U.sort(c)}if(U.length!==0){if(U.length===1)return U[0];for(let G=1;G<U.length;G++)U[G-1].equals(U[G])&&(U.splice(G,1),G--);if(U.length===1)return U[0];if($){for(let G=0;G<U.length;G++)for(let F=G+1;F<U.length;F++)if(U[G].negate().equals(U[F]))return I.INSTANCE;if(U.length===1)return U[0]}return new z(U,Q)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const Q of this.expr)L.push(...Q.keys());return L}map(L){return new z(this.expr.map(Q=>Q.map(L)),null)}negate(){if(!this.negated){const L=[];for(const Q of this.expr)L.push(Q.negate());for(;L.length>1;){const Q=L.shift(),$=L.shift(),U=[];for(const q of J(Q))for(const G of J($))U.push(x.create([q,G],null,!1));L.unshift(z.create(U,null,!1))}this.negated=z.create(L,this,!0)}return this.negated}}e.ContextKeyOrExpr=z;class ne extends T{static{this._info=[]}static all(){return ne._info.values()}constructor(L,Q,$){super(L,null),this._defaultValue=Q,typeof $=="object"?ne._info.push({...$,key:L}):$!==!0&&ne._info.push({key:L,description:$,type:Q!=null?typeof Q:void 0})}bindTo(L){return L.createKey(this.key,this._defaultValue)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return A.create(this.key,L)}notEqualsTo(L){return P.create(this.key,L)}}e.RawContextKey=ne,e.IContextKeyService=(0,R.createDecorator)("contextKeyService");function le(W,L){return W<L?-1:W>L?1:0}function ve(W,L,Q,$){return W<Q?-1:W>Q?1:L<$?-1:L>$?1:0}function H(W,L){if(W.type===d.False||L.type===d.True)return!0;if(W.type===d.Or)return L.type===d.Or?ce(W.expr,L.expr):!1;if(L.type===d.Or){for(const Q of L.expr)if(H(W,Q))return!0;return!1}if(W.type===d.And){if(L.type===d.And)return ce(L.expr,W.expr);for(const Q of W.expr)if(H(Q,L))return!0;return!1}return W.equals(L)}function ce(W,L){let Q=0,$=0;for(;Q<W.length&&$<L.length;){const U=W[Q].cmp(L[$]);if(U<0)return!1;U===0&&Q++,$++}return Q===W.length}function J(W){return W.type===d.Or?W.expr:[W]}}),define(ye[248],Ie([1,0,42,5]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACCESSIBLE_VIEW_SHOWN_STORAGE_PREFIX=e.CONTEXT_ACCESSIBILITY_MODE_ENABLED=e.AccessibilitySupport=e.IAccessibilityService=void 0,e.isAccessibilityInformation=C,e.IAccessibilityService=(0,r.createDecorator)("accessibilityService");var w;(function(R){R[R.Unknown=0]="Unknown",R[R.Disabled=1]="Disabled",R[R.Enabled=2]="Enabled"})(w||(e.AccessibilitySupport=w={})),e.CONTEXT_ACCESSIBILITY_MODE_ENABLED=new i.RawContextKey("accessibilityModeEnabled",!1);function C(R){return R&&typeof R=="object"&&typeof R.label=="string"&&(typeof R.role>"u"||typeof R.role=="string")}e.ACCESSIBLE_VIEW_SHOWN_STORAGE_PREFIX="ACCESSIBLE_VIEW_SHOWN_"}),define(ye[249],Ie([1,0,18,21,3,170,109,180,181,199,248]),function(se,e,i,r,w,C,R,_,b,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=g,e.clampedInt=t,e.clampedFloat=n,e.stringSet=c,e.cursorStyleToString=Y,e.filterValidationDecorations=pe,i=Be(i),r=Be(r),w=Be(w),o=Be(o);var y;(function(ie){ie[ie.None=0]="None",ie[ie.Keep=1]="Keep",ie[ie.Brackets=2]="Brackets",ie[ie.Advanced=3]="Advanced",ie[ie.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class d{constructor(ee){this._values=ee}hasChanged(ee){return this._values[ee]}}e.ConfigurationChangedEvent=d;class E{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=E;class a{constructor(ee,Se,He,Ge){this.id=ee,this.name=Se,this.defaultValue=He,this.schema=Ge}applyUpdate(ee,Se){return m(ee,Se)}compute(ee,Se,He){return He}}class f{constructor(ee,Se){this.newValue=ee,this.didChange=Se}}e.ApplyUpdateResult=f;function m(ie,ee){if(typeof ie!="object"||typeof ee!="object"||!ie||!ee)return new f(ee,ie!==ee);if(Array.isArray(ie)||Array.isArray(ee)){const He=Array.isArray(ie)&&Array.isArray(ee)&&i.equals(ie,ee);return new f(ee,!He)}let Se=!1;for(const He in ee)if(ee.hasOwnProperty(He)){const Ge=m(ie[He],ee[He]);Ge.didChange&&(ie[He]=Ge.newValue,Se=!0)}return new f(ie,Se)}class p{constructor(ee){this.schema=void 0,this.id=ee,this.name="_never_",this.defaultValue=void 0}applyUpdate(ee,Se){return m(ee,Se)}validate(ee){return this.defaultValue}}class S{constructor(ee,Se,He,Ge){this.id=ee,this.name=Se,this.defaultValue=He,this.schema=Ge}applyUpdate(ee,Se){return m(ee,Se)}validate(ee){return typeof ee>"u"?this.defaultValue:ee}compute(ee,Se,He){return He}}function g(ie,ee){return typeof ie>"u"?ee:ie==="false"?!1:!!ie}class v extends S{constructor(ee,Se,He,Ge=void 0){typeof Ge<"u"&&(Ge.type="boolean",Ge.default=He),super(ee,Se,He,Ge)}validate(ee){return g(ee,this.defaultValue)}}function t(ie,ee,Se,He){if(typeof ie>"u")return ee;let Ge=parseInt(ie,10);return isNaN(Ge)?ee:(Ge=Math.max(Se,Ge),Ge=Math.min(He,Ge),Ge|0)}class l extends S{static clampedInt(ee,Se,He,Ge){return t(ee,Se,He,Ge)}constructor(ee,Se,He,Ge,Ze,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=He,nt.minimum=Ge,nt.maximum=Ze),super(ee,Se,He,nt),this.minimum=Ge,this.maximum=Ze}validate(ee){return l.clampedInt(ee,this.defaultValue,this.minimum,this.maximum)}}function n(ie,ee,Se,He){if(typeof ie>"u")return ee;const Ge=h.float(ie,ee);return h.clamp(Ge,Se,He)}class h extends S{static clamp(ee,Se,He){return ee<Se?Se:ee>He?He:ee}static float(ee,Se){if(typeof ee=="number")return ee;if(typeof ee>"u")return Se;const He=parseFloat(ee);return isNaN(He)?Se:He}constructor(ee,Se,He,Ge,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=He),super(ee,Se,He,Ze),this.validationFn=Ge}validate(ee){return this.validationFn(h.float(ee,this.defaultValue))}}class s extends S{static string(ee,Se){return typeof ee!="string"?Se:ee}constructor(ee,Se,He,Ge=void 0){typeof Ge<"u"&&(Ge.type="string",Ge.default=He),super(ee,Se,He,Ge)}validate(ee){return s.string(ee,this.defaultValue)}}function c(ie,ee,Se,He){return typeof ie!="string"?ee:He&&ie in He?He[ie]:Se.indexOf(ie)===-1?ee:ie}class u extends S{constructor(ee,Se,He,Ge,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Ge,Ze.default=He),super(ee,Se,He,Ze),this._allowedValues=Ge}validate(ee){return c(ee,this.defaultValue,this._allowedValues)}}class I extends a{constructor(ee,Se,He,Ge,Ze,nt,ut=void 0){typeof ut<"u"&&(ut.type="string",ut.enum=Ze,ut.default=Ge),super(ee,Se,He,ut),this._allowedValues=Ze,this._convert=nt}validate(ee){return typeof ee!="string"?this.defaultValue:this._allowedValues.indexOf(ee)===-1?this.defaultValue:this._convert(ee)}}function T(ie){switch(ie){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class A extends a{constructor(){super(Ae.accessibilitySupport,"accessibilitySupport",D.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[o.localize(0,null),o.localize(1,null),o.localize(2,null)],default:"auto",tags:["accessibility"],description:o.localize(3,null)})}validate(ee){switch(ee){case"auto":return D.AccessibilitySupport.Unknown;case"off":return D.AccessibilitySupport.Disabled;case"on":return D.AccessibilitySupport.Enabled}return this.defaultValue}compute(ee,Se,He){return He===D.AccessibilitySupport.Unknown?ee.accessibilitySupport:He}}class O extends a{constructor(){const ee={insertSpace:!0,ignoreEmptyLines:!0};super(Ae.comments,"comments",ee,{"editor.comments.insertSpace":{type:"boolean",default:ee.insertSpace,description:o.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ee.ignoreEmptyLines,description:o.localize(5,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{insertSpace:g(Se.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(Se.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var k;(function(ie){ie[ie.Hidden=0]="Hidden",ie[ie.Blink=1]="Blink",ie[ie.Smooth=2]="Smooth",ie[ie.Phase=3]="Phase",ie[ie.Expand=4]="Expand",ie[ie.Solid=5]="Solid"})(k||(e.TextEditorCursorBlinkingStyle=k={}));function P(ie){switch(ie){case"blink":return k.Blink;case"smooth":return k.Smooth;case"phase":return k.Phase;case"expand":return k.Expand;case"solid":return k.Solid}}var B;(function(ie){ie[ie.Line=1]="Line",ie[ie.Block=2]="Block",ie[ie.Underline=3]="Underline",ie[ie.LineThin=4]="LineThin",ie[ie.BlockOutline=5]="BlockOutline",ie[ie.UnderlineThin=6]="UnderlineThin"})(B||(e.TextEditorCursorStyle=B={}));function Y(ie){switch(ie){case B.Line:return"line";case B.Block:return"block";case B.Underline:return"underline";case B.LineThin:return"line-thin";case B.BlockOutline:return"block-outline";case B.UnderlineThin:return"underline-thin"}}function X(ie){switch(ie){case"line":return B.Line;case"block":return B.Block;case"underline":return B.Underline;case"line-thin":return B.LineThin;case"block-outline":return B.BlockOutline;case"underline-thin":return B.UnderlineThin}}class re extends p{constructor(){super(Ae.editorClassName)}compute(ee,Se,He){const Ge=["monaco-editor"];return Se.get(Ae.extraEditorClassName)&&Ge.push(Se.get(Ae.extraEditorClassName)),ee.extraEditorClassName&&Ge.push(ee.extraEditorClassName),Se.get(Ae.mouseStyle)==="default"?Ge.push("mouse-default"):Se.get(Ae.mouseStyle)==="copy"&&Ge.push("mouse-copy"),Se.get(Ae.showUnused)&&Ge.push("showUnused"),Se.get(Ae.showDeprecated)&&Ge.push("showDeprecated"),Ge.join(" ")}}class te extends v{constructor(){super(Ae.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:o.localize(6,null)})}compute(ee,Se,He){return He&&ee.emptySelectionClipboard}}class Z extends a{constructor(){const ee={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(Ae.find,"find",ee,{"editor.find.cursorMoveOnType":{type:"boolean",default:ee.cursorMoveOnType,description:o.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ee.seedSearchStringFromSelection,enumDescriptions:[o.localize(8,null),o.localize(9,null),o.localize(10,null)],description:o.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ee.autoFindInSelection,enumDescriptions:[o.localize(12,null),o.localize(13,null),o.localize(14,null)],description:o.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ee.globalFindClipboard,description:o.localize(16,null),included:w.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ee.addExtraSpaceOnTop,description:o.localize(17,null)},"editor.find.loop":{type:"boolean",default:ee.loop,description:o.localize(18,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{cursorMoveOnType:g(Se.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ee.seedSearchStringFromSelection=="boolean"?ee.seedSearchStringFromSelection?"always":"never":c(Se.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ee.autoFindInSelection=="boolean"?ee.autoFindInSelection?"always":"never":c(Se.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(Se.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(Se.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(Se.loop,this.defaultValue.loop)}}}class fe extends a{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(Ae.fontLigatures,"fontLigatures",fe.OFF,{anyOf:[{type:"boolean",description:o.localize(19,null)},{type:"string",description:o.localize(20,null)}],description:o.localize(21,null),default:!1})}validate(ee){return typeof ee>"u"?this.defaultValue:typeof ee=="string"?ee==="false"||ee.length===0?fe.OFF:ee==="true"?fe.ON:ee:ee?fe.ON:fe.OFF}}e.EditorFontLigatures=fe;class K extends a{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(Ae.fontVariations,"fontVariations",K.OFF,{anyOf:[{type:"boolean",description:o.localize(22,null)},{type:"string",description:o.localize(23,null)}],description:o.localize(24,null),default:!1})}validate(ee){return typeof ee>"u"?this.defaultValue:typeof ee=="string"?ee==="false"?K.OFF:ee==="true"?K.TRANSLATE:ee:ee?K.TRANSLATE:K.OFF}compute(ee,Se,He){return ee.fontInfo.fontVariationSettings}}e.EditorFontVariations=K;class ae extends p{constructor(){super(Ae.fontInfo)}compute(ee,Se,He){return ee.fontInfo}}class x extends S{constructor(){super(Ae.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:o.localize(25,null)})}validate(ee){const Se=h.float(ee,this.defaultValue);return Se===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(Se,6,100)}compute(ee,Se,He){return ee.fontInfo.fontSize}}class z extends a{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(Ae.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:o.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:o.localize(27,null)})}validate(ee){return ee==="normal"||ee==="bold"?ee:String(l.clampedInt(ee,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}class ne extends a{constructor(){const ee={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Se={type:"string",enum:["peek","gotoAndPeek","goto"],default:ee.multiple,enumDescriptions:[o.localize(28,null),o.localize(29,null),o.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(Ae.gotoLocation,"gotoLocation",ee,{"editor.gotoLocation.multiple":{deprecationMessage:o.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:o.localize(32,null),...Se},"editor.gotoLocation.multipleTypeDefinitions":{description:o.localize(33,null),...Se},"editor.gotoLocation.multipleDeclarations":{description:o.localize(34,null),...Se},"editor.gotoLocation.multipleImplementations":{description:o.localize(35,null),...Se},"editor.gotoLocation.multipleReferences":{description:o.localize(36,null),...Se},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ee.alternativeDefinitionCommand,enum:He,description:o.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ee.alternativeTypeDefinitionCommand,enum:He,description:o.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ee.alternativeDeclarationCommand,enum:He,description:o.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ee.alternativeImplementationCommand,enum:He,description:o.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ee.alternativeReferenceCommand,enum:He,description:o.localize(41,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{multiple:c(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Se.multipleDefinitions??c(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Se.multipleTypeDefinitions??c(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Se.multipleDeclarations??c(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Se.multipleImplementations??c(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Se.multipleReferences??c(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:s.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:s.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:s.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:s.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:s.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class le extends a{constructor(){const ee={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(Ae.hover,"hover",ee,{"editor.hover.enabled":{type:"boolean",default:ee.enabled,description:o.localize(42,null)},"editor.hover.delay":{type:"number",default:ee.delay,minimum:0,maximum:1e4,description:o.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ee.sticky,description:o.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ee.hidingDelay,description:o.localize(45,null)},"editor.hover.above":{type:"boolean",default:ee.above,description:o.localize(46,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{enabled:g(Se.enabled,this.defaultValue.enabled),delay:l.clampedInt(Se.delay,this.defaultValue.delay,0,1e4),sticky:g(Se.sticky,this.defaultValue.sticky),hidingDelay:l.clampedInt(Se.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:g(Se.above,this.defaultValue.above)}}}var ve;(function(ie){ie[ie.None=0]="None",ie[ie.Text=1]="Text",ie[ie.Blocks=2]="Blocks"})(ve||(e.RenderMinimap=ve={}));class H extends p{constructor(){super(Ae.layoutInfo)}compute(ee,Se,He){return H.computeLayout(Se,{memory:ee.memory,outerWidth:ee.outerWidth,outerHeight:ee.outerHeight,isDominatedByLongLines:ee.isDominatedByLongLines,lineHeight:ee.fontInfo.lineHeight,viewLineCount:ee.viewLineCount,lineNumbersDigitCount:ee.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ee.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ee.fontInfo.maxDigitWidth,pixelRatio:ee.pixelRatio,glyphMarginDecorationLaneCount:ee.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ee){const Se=ee.height/ee.lineHeight,He=Math.floor(ee.paddingTop/ee.lineHeight);let Ge=Math.floor(ee.paddingBottom/ee.lineHeight);ee.scrollBeyondLastLine&&(Ge=Math.max(Ge,Se-1));const Ze=(He+ee.viewLineCount+Ge)/(ee.pixelRatio*ee.height),nt=Math.floor(ee.viewLineCount/Ze);return{typicalViewportLineCount:Se,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:Ge,desiredRatio:Ze,minimapLineCount:nt}}static _computeMinimapLayout(ee,Se){const He=ee.outerWidth,Ge=ee.outerHeight,Ze=ee.pixelRatio;if(!ee.minimap.enabled)return{renderMinimap:ve.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*Ge),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ge};const nt=Se.stableMinimapLayoutInput,ut=nt&&ee.outerHeight===nt.outerHeight&&ee.lineHeight===nt.lineHeight&&ee.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&ee.pixelRatio===nt.pixelRatio&&ee.scrollBeyondLastLine===nt.scrollBeyondLastLine&&ee.paddingTop===nt.paddingTop&&ee.paddingBottom===nt.paddingBottom&&ee.minimap.enabled===nt.minimap.enabled&&ee.minimap.side===nt.minimap.side&&ee.minimap.size===nt.minimap.size&&ee.minimap.showSlider===nt.minimap.showSlider&&ee.minimap.renderCharacters===nt.minimap.renderCharacters&&ee.minimap.maxColumn===nt.minimap.maxColumn&&ee.minimap.scale===nt.minimap.scale&&ee.verticalScrollbarWidth===nt.verticalScrollbarWidth&&ee.isViewportWrapping===nt.isViewportWrapping,mt=ee.lineHeight,Et=ee.typicalHalfwidthCharacterWidth,Ut=ee.scrollBeyondLastLine,_t=ee.minimap.renderCharacters;let ht=Ze>=2?Math.round(ee.minimap.scale*2):ee.minimap.scale;const St=ee.minimap.maxColumn,wt=ee.minimap.size,Ct=ee.minimap.side,Kt=ee.verticalScrollbarWidth,Lt=ee.viewLineCount,dt=ee.remainingWidth,vt=ee.isViewportWrapping,yt=_t?2:3;let Pt=Math.floor(Ze*Ge);const xt=Pt/Ze;let At=!1,Zt=!1,Tt=yt*ht,Ot=ht/Ze,zt=1;if(wt==="fill"||wt==="fit"){const{typicalViewportLineCount:Vt,extraLinesBeforeFirstLine:Xt,extraLinesBeyondLastLine:ei,desiredRatio:$t,minimapLineCount:Dt}=H.computeContainedMinimapLineCount({viewLineCount:Lt,scrollBeyondLastLine:Ut,paddingTop:ee.paddingTop,paddingBottom:ee.paddingBottom,height:Ge,lineHeight:mt,pixelRatio:Ze});if(Lt/Dt>1)At=!0,Zt=!0,ht=1,Tt=1,Ot=ht/Ze;else{let pt=!1,Yt=ht+1;if(wt==="fit"){const Qt=Math.ceil((Xt+Lt+ei)*Tt);vt&&ut&&dt<=Se.stableFitRemainingWidth?(pt=!0,Yt=Se.stableFitMaxMinimapScale):pt=Qt>Pt}if(wt==="fill"||pt){At=!0;const Qt=ht;Tt=Math.min(mt*Ze,Math.max(1,Math.floor(1/$t))),vt&&ut&&dt<=Se.stableFitRemainingWidth&&(Yt=Se.stableFitMaxMinimapScale),ht=Math.min(Yt,Math.max(1,Math.floor(Tt/yt))),ht>Qt&&(zt=Math.min(2,ht/Qt)),Ot=ht/Ze/zt,Pt=Math.ceil(Math.max(Vt,Xt+Lt+ei)*Tt),vt?(Se.stableMinimapLayoutInput=ee,Se.stableFitRemainingWidth=dt,Se.stableFitMaxMinimapScale=ht):(Se.stableMinimapLayoutInput=null,Se.stableFitRemainingWidth=0)}}}const Nt=Math.floor(St*Ot),kt=Math.min(Nt,Math.max(0,Math.floor((dt-Kt-2)*Ot/(Et+Ot)))+e.MINIMAP_GUTTER_WIDTH);let It=Math.floor(Ze*kt);const Wt=It/Ze;It=Math.floor(It*zt);const Bt=_t?ve.Text:ve.Blocks,Ht=Ct==="left"?0:He-kt-Kt;return{renderMinimap:Bt,minimapLeft:Ht,minimapWidth:kt,minimapHeightIsEditorHeight:At,minimapIsSampling:Zt,minimapScale:ht,minimapLineHeight:Tt,minimapCanvasInnerWidth:It,minimapCanvasInnerHeight:Pt,minimapCanvasOuterWidth:Wt,minimapCanvasOuterHeight:xt}}static computeLayout(ee,Se){const He=Se.outerWidth|0,Ge=Se.outerHeight|0,Ze=Se.lineHeight|0,nt=Se.lineNumbersDigitCount|0,ut=Se.typicalHalfwidthCharacterWidth,mt=Se.maxDigitWidth,Et=Se.pixelRatio,Ut=Se.viewLineCount,_t=ee.get(Ae.wordWrapOverride2),ht=_t==="inherit"?ee.get(Ae.wordWrapOverride1):_t,St=ht==="inherit"?ee.get(Ae.wordWrap):ht,wt=ee.get(Ae.wordWrapColumn),Ct=Se.isDominatedByLongLines,Kt=ee.get(Ae.glyphMargin),Lt=ee.get(Ae.lineNumbers).renderType!==Ne.Off,dt=ee.get(Ae.lineNumbersMinChars),vt=ee.get(Ae.scrollBeyondLastLine),yt=ee.get(Ae.padding),Pt=ee.get(Ae.minimap),xt=ee.get(Ae.scrollbar),At=xt.verticalScrollbarSize,Zt=xt.verticalHasArrows,Tt=xt.arrowSize,Ot=xt.horizontalScrollbarSize,zt=ee.get(Ae.folding),Nt=ee.get(Ae.showFoldingControls)!=="never";let kt=ee.get(Ae.lineDecorationsWidth);zt&&Nt&&(kt+=16);let It=0;if(Lt){const ai=Math.max(nt,dt);It=Math.round(ai*mt)}let Wt=0;Kt&&(Wt=Ze*Se.glyphMarginDecorationLaneCount);let Bt=0,Ht=Bt+Wt,Vt=Ht+It,Xt=Vt+kt;const ei=He-Wt-It-kt;let $t=!1,Dt=!1,Ft=-1;ht==="inherit"&&Ct?($t=!0,Dt=!0):St==="on"||St==="bounded"?Dt=!0:St==="wordWrapColumn"&&(Ft=wt);const pt=H._computeMinimapLayout({outerWidth:He,outerHeight:Ge,lineHeight:Ze,typicalHalfwidthCharacterWidth:ut,pixelRatio:Et,scrollBeyondLastLine:vt,paddingTop:yt.top,paddingBottom:yt.bottom,minimap:Pt,verticalScrollbarWidth:At,viewLineCount:Ut,remainingWidth:ei,isViewportWrapping:Dt},Se.memory||new E);pt.renderMinimap!==ve.None&&pt.minimapLeft===0&&(Bt+=pt.minimapWidth,Ht+=pt.minimapWidth,Vt+=pt.minimapWidth,Xt+=pt.minimapWidth);const Yt=ei-pt.minimapWidth,Qt=Math.max(1,Math.floor((Yt-At-2)/ut)),oi=Zt?Tt:0;return Dt&&(Ft=Math.max(1,Qt),St==="bounded"&&(Ft=Math.min(Ft,wt))),{width:He,height:Ge,glyphMarginLeft:Bt,glyphMarginWidth:Wt,glyphMarginDecorationLaneCount:Se.glyphMarginDecorationLaneCount,lineNumbersLeft:Ht,lineNumbersWidth:It,decorationsLeft:Vt,decorationsWidth:kt,contentLeft:Xt,contentWidth:Yt,minimap:pt,viewportColumn:Qt,isWordWrapMinified:$t,isViewportWrapping:Dt,wrappingColumn:Ft,verticalScrollbarWidth:At,horizontalScrollbarHeight:Ot,overviewRuler:{top:oi,width:At,height:Ge-2*oi,right:0}}}}e.EditorLayoutInfoComputer=H;class ce extends a{constructor(){super(Ae.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[o.localize(47,null),o.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:o.localize(49,null)}})}validate(ee){return c(ee,"simple",["simple","advanced"])}compute(ee,Se,He){return Se.get(Ae.accessibilitySupport)===D.AccessibilitySupport.Enabled?"advanced":He}}var J;(function(ie){ie.Off="off",ie.OnCode="onCode",ie.On="on"})(J||(e.ShowLightbulbIconMode=J={}));class W extends a{constructor(){const ee={enabled:J.On};super(Ae.lightbulb,"lightbulb",ee,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[J.Off,J.OnCode,J.On],default:ee.enabled,enumDescriptions:[o.localize(50,null),o.localize(51,null),o.localize(52,null)],description:o.localize(53,null)}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{enabled:c(ee.enabled,this.defaultValue.enabled,[J.Off,J.OnCode,J.On])}}}class L extends a{constructor(){const ee={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(Ae.stickyScroll,"stickyScroll",ee,{"editor.stickyScroll.enabled":{type:"boolean",default:ee.enabled,description:o.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ee.maxLineCount,minimum:1,maximum:20,description:o.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ee.defaultModel,description:o.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ee.scrollWithEditor,description:o.localize(57,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{enabled:g(Se.enabled,this.defaultValue.enabled),maxLineCount:l.clampedInt(Se.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:c(Se.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:g(Se.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class Q extends a{constructor(){const ee={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(Ae.inlayHints,"inlayHints",ee,{"editor.inlayHints.enabled":{type:"string",default:ee.enabled,description:o.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[o.localize(59,null),o.localize(60,null,w.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),o.localize(61,null,w.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),o.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ee.fontSize,markdownDescription:o.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ee.fontFamily,markdownDescription:o.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ee.padding,description:o.localize(65,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return typeof Se.enabled=="boolean"&&(Se.enabled=Se.enabled?"on":"off"),{enabled:c(Se.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:l.clampedInt(Se.fontSize,this.defaultValue.fontSize,0,100),fontFamily:s.string(Se.fontFamily,this.defaultValue.fontFamily),padding:g(Se.padding,this.defaultValue.padding)}}}class $ extends a{constructor(){super(Ae.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(ee){return typeof ee=="string"&&/^\d+(\.\d+)?ch$/.test(ee)?-parseFloat(ee.substring(0,ee.length-2)):l.clampedInt(ee,this.defaultValue,0,1e3)}compute(ee,Se,He){return He<0?l.clampedInt(-He*ee.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class U extends h{constructor(){super(Ae.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ee=>h.clamp(ee,0,150),{markdownDescription:o.localize(66,null)})}compute(ee,Se,He){return ee.fontInfo.lineHeight}}class q extends a{constructor(){const ee={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(Ae.minimap,"minimap",ee,{"editor.minimap.enabled":{type:"boolean",default:ee.enabled,description:o.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ee.autohide,description:o.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[o.localize(69,null),o.localize(70,null),o.localize(71,null)],default:ee.size,description:o.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ee.side,description:o.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ee.showSlider,description:o.localize(74,null)},"editor.minimap.scale":{type:"number",default:ee.scale,minimum:1,maximum:3,enum:[1,2,3],description:o.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ee.renderCharacters,description:o.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ee.maxColumn,description:o.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ee.showRegionSectionHeaders,description:o.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ee.showMarkSectionHeaders,description:o.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ee.sectionHeaderFontSize,description:o.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:ee.sectionHeaderLetterSpacing,description:o.localize(81,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{enabled:g(Se.enabled,this.defaultValue.enabled),autohide:g(Se.autohide,this.defaultValue.autohide),size:c(Se.size,this.defaultValue.size,["proportional","fill","fit"]),side:c(Se.side,this.defaultValue.side,["right","left"]),showSlider:c(Se.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(Se.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(Se.scale,1,1,3),maxColumn:l.clampedInt(Se.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:g(Se.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:g(Se.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:h.clamp(Se.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:h.clamp(Se.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function G(ie){return ie==="ctrlCmd"?w.isMacintosh?"metaKey":"ctrlKey":"altKey"}class F extends a{constructor(){super(Ae.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(83,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{top:l.clampedInt(Se.top,0,0,1e3),bottom:l.clampedInt(Se.bottom,0,0,1e3)}}}class V extends a{constructor(){const ee={enabled:!0,cycle:!0};super(Ae.parameterHints,"parameterHints",ee,{"editor.parameterHints.enabled":{type:"boolean",default:ee.enabled,description:o.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:ee.cycle,description:o.localize(85,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{enabled:g(Se.enabled,this.defaultValue.enabled),cycle:g(Se.cycle,this.defaultValue.cycle)}}}class oe extends p{constructor(){super(Ae.pixelRatio)}compute(ee,Se,He){return ee.pixelRatio}}class de extends a{constructor(){super(Ae.placeholder,"placeholder",void 0)}validate(ee){return typeof ee>"u"?this.defaultValue:typeof ee=="string"?ee:this.defaultValue}}class Ce extends a{constructor(){const ee={other:"on",comments:"off",strings:"off"},Se=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[o.localize(86,null),o.localize(87,null),o.localize(88,null)]}];super(Ae.quickSuggestions,"quickSuggestions",ee,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Se,default:ee.strings,description:o.localize(89,null)},comments:{anyOf:Se,default:ee.comments,description:o.localize(90,null)},other:{anyOf:Se,default:ee.other,description:o.localize(91,null)}},default:ee,markdownDescription:o.localize(92,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=ee}validate(ee){if(typeof ee=="boolean"){const Et=ee?"on":"off";return{comments:Et,strings:Et,other:Et}}if(!ee||typeof ee!="object")return this.defaultValue;const{other:Se,comments:He,strings:Ge}=ee,Ze=["on","inline","off"];let nt,ut,mt;return typeof Se=="boolean"?nt=Se?"on":"off":nt=c(Se,this.defaultValue.other,Ze),typeof He=="boolean"?ut=He?"on":"off":ut=c(He,this.defaultValue.comments,Ze),typeof Ge=="boolean"?mt=Ge?"on":"off":mt=c(Ge,this.defaultValue.strings,Ze),{other:nt,comments:ut,strings:mt}}}var Ne;(function(ie){ie[ie.Off=0]="Off",ie[ie.On=1]="On",ie[ie.Relative=2]="Relative",ie[ie.Interval=3]="Interval",ie[ie.Custom=4]="Custom"})(Ne||(e.RenderLineNumbersType=Ne={}));class ge extends a{constructor(){super(Ae.lineNumbers,"lineNumbers",{renderType:Ne.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[o.localize(93,null),o.localize(94,null),o.localize(95,null),o.localize(96,null)],default:"on",description:o.localize(97,null)})}validate(ee){let Se=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof ee<"u"&&(typeof ee=="function"?(Se=Ne.Custom,He=ee):ee==="interval"?Se=Ne.Interval:ee==="relative"?Se=Ne.Relative:ee==="on"?Se=Ne.On:Se=Ne.Off),{renderType:Se,renderFn:He}}}function pe(ie){const ee=ie.get(Ae.renderValidationDecorations);return ee==="editable"?ie.get(Ae.readOnly):ee!=="on"}class Te extends a{constructor(){const ee=[],Se={type:"number",description:o.localize(98,null)};super(Ae.rulers,"rulers",ee,{type:"array",items:{anyOf:[Se,{type:["object"],properties:{column:Se,color:{type:"string",description:o.localize(99,null),format:"color-hex"}}}]},default:ee,description:o.localize(100,null)})}validate(ee){if(Array.isArray(ee)){const Se=[];for(const He of ee)if(typeof He=="number")Se.push({column:l.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const Ge=He;Se.push({column:l.clampedInt(Ge.column,0,0,1e4),color:Ge.color})}return Se.sort((He,Ge)=>He.column-Ge.column),Se}return this.defaultValue}}class Le extends a{constructor(){super(Ae.readOnlyMessage,"readOnlyMessage",void 0)}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:ee}}function he(ie,ee){if(typeof ie!="string")return ee;switch(ie){case"hidden":return C.ScrollbarVisibility.Hidden;case"visible":return C.ScrollbarVisibility.Visible;default:return C.ScrollbarVisibility.Auto}}class De extends a{constructor(){const ee={vertical:C.ScrollbarVisibility.Auto,horizontal:C.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(Ae.scrollbar,"scrollbar",ee,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(101,null),o.localize(102,null),o.localize(103,null)],default:"auto",description:o.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(105,null),o.localize(106,null),o.localize(107,null)],default:"auto",description:o.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ee.verticalScrollbarSize,description:o.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ee.horizontalScrollbarSize,description:o.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ee.scrollByPage,description:o.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ee.ignoreHorizontalScrollbarInContentHeight,description:o.localize(112,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee,He=l.clampedInt(Se.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ge=l.clampedInt(Se.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(Se.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:he(Se.vertical,this.defaultValue.vertical),horizontal:he(Se.horizontal,this.defaultValue.horizontal),useShadows:g(Se.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(Se.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(Se.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(Se.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(Se.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:l.clampedInt(Se.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:Ge,verticalSliderSize:l.clampedInt(Se.verticalSliderSize,Ge,0,1e3),scrollByPage:g(Se.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:g(Se.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Re extends a{constructor(){const ee={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(Ae.unicodeHighlighting,"unicodeHighlight",ee,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ee.nonBasicASCII,description:o.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ee.invisibleCharacters,description:o.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ee.ambiguousCharacters,description:o.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ee.includeComments,description:o.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ee.includeStrings,description:o.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ee.allowedCharacters,description:o.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ee.allowedLocales,description:o.localize(119,null)}})}applyUpdate(ee,Se){let He=!1;Se.allowedCharacters&&ee&&(r.equals(ee.allowedCharacters,Se.allowedCharacters)||(ee={...ee,allowedCharacters:Se.allowedCharacters},He=!0)),Se.allowedLocales&&ee&&(r.equals(ee.allowedLocales,Se.allowedLocales)||(ee={...ee,allowedLocales:Se.allowedLocales},He=!0));const Ge=super.applyUpdate(ee,Se);return He?new f(Ge.newValue,!0):Ge}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{nonBasicASCII:qe(Se.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(Se.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(Se.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:qe(Se.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:qe(Se.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(ee.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(ee.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(ee,Se){if(typeof ee!="object"||!ee)return Se;const He={};for(const[Ge,Ze]of Object.entries(ee))Ze===!0&&(He[Ge]=!0);return He}}class xe extends a{constructor(){const ee={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(Ae.inlineSuggest,"inlineSuggest",ee,{"editor.inlineSuggest.enabled":{type:"boolean",default:ee.enabled,description:o.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ee.showToolbar,enum:["always","onHover","never"],enumDescriptions:[o.localize(121,null),o.localize(122,null),o.localize(123,null)],description:o.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ee.suppressSuggestions,description:o.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ee.fontFamily,description:o.localize(126,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{enabled:g(Se.enabled,this.defaultValue.enabled),mode:c(Se.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:c(Se.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:g(Se.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:g(Se.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:s.string(Se.fontFamily,this.defaultValue.fontFamily)}}}class Ve extends a{constructor(){const ee={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(Ae.inlineEdit,"experimentalInlineEdit",ee,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ee.enabled,description:o.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ee.showToolbar,enum:["always","onHover","never"],enumDescriptions:[o.localize(128,null),o.localize(129,null),o.localize(130,null)],description:o.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ee.fontFamily,description:o.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:ee.backgroundColoring,description:o.localize(133,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{enabled:g(Se.enabled,this.defaultValue.enabled),showToolbar:c(Se.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:s.string(Se.fontFamily,this.defaultValue.fontFamily),keepOnBlur:g(Se.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:g(Se.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Xe extends a{constructor(){const ee={enabled:_.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:_.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(Ae.bracketPairColorization,"bracketPairColorization",ee,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ee.enabled,markdownDescription:o.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ee.independentColorPoolPerBracketType,description:o.localize(135,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{enabled:g(Se.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:g(Se.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class je extends a{constructor(){const ee={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(Ae.guides,"guides",ee,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(136,null),o.localize(137,null),o.localize(138,null)],default:ee.bracketPairs,description:o.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(140,null),o.localize(141,null),o.localize(142,null)],default:ee.bracketPairsHorizontal,description:o.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ee.highlightActiveBracketPair,description:o.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:ee.indentation,description:o.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[o.localize(146,null),o.localize(147,null),o.localize(148,null)],default:ee.highlightActiveIndentation,description:o.localize(149,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{bracketPairs:qe(Se.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:qe(Se.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(Se.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(Se.indentation,this.defaultValue.indentation),highlightActiveIndentation:qe(Se.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function qe(ie,ee,Se){const He=Se.indexOf(ie);return He===-1?ee:Se[He]}class Je extends a{constructor(){const ee={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(Ae.suggest,"suggest",ee,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[o.localize(150,null),o.localize(151,null)],default:ee.insertMode,description:o.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ee.filterGraceful,description:o.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:ee.localityBonus,description:o.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ee.shareSuggestSelections,markdownDescription:o.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[o.localize(156,null),o.localize(157,null),o.localize(158,null),o.localize(159,null)],default:ee.selectionMode,markdownDescription:o.localize(160,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ee.snippetsPreventQuickSuggestions,description:o.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:ee.showIcons,description:o.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ee.showStatusBar,description:o.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:ee.preview,description:o.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ee.showInlineDetails,description:o.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:o.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:o.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:o.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:o.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:o.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:o.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:o.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:o.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:o.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:o.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:o.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:o.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:o.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:o.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:o.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:o.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:o.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:o.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:o.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:o.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:o.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:o.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:o.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:o.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:o.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:o.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:o.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:o.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:o.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:o.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:o.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:o.localize(197,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{insertMode:c(Se.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(Se.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(Se.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(Se.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(Se.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:c(Se.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:g(Se.showIcons,this.defaultValue.showIcons),showStatusBar:g(Se.showStatusBar,this.defaultValue.showStatusBar),preview:g(Se.preview,this.defaultValue.preview),previewMode:c(Se.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(Se.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(Se.showMethods,this.defaultValue.showMethods),showFunctions:g(Se.showFunctions,this.defaultValue.showFunctions),showConstructors:g(Se.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(Se.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:g(Se.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:g(Se.showFields,this.defaultValue.showFields),showVariables:g(Se.showVariables,this.defaultValue.showVariables),showClasses:g(Se.showClasses,this.defaultValue.showClasses),showStructs:g(Se.showStructs,this.defaultValue.showStructs),showInterfaces:g(Se.showInterfaces,this.defaultValue.showInterfaces),showModules:g(Se.showModules,this.defaultValue.showModules),showProperties:g(Se.showProperties,this.defaultValue.showProperties),showEvents:g(Se.showEvents,this.defaultValue.showEvents),showOperators:g(Se.showOperators,this.defaultValue.showOperators),showUnits:g(Se.showUnits,this.defaultValue.showUnits),showValues:g(Se.showValues,this.defaultValue.showValues),showConstants:g(Se.showConstants,this.defaultValue.showConstants),showEnums:g(Se.showEnums,this.defaultValue.showEnums),showEnumMembers:g(Se.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(Se.showKeywords,this.defaultValue.showKeywords),showWords:g(Se.showWords,this.defaultValue.showWords),showColors:g(Se.showColors,this.defaultValue.showColors),showFiles:g(Se.showFiles,this.defaultValue.showFiles),showReferences:g(Se.showReferences,this.defaultValue.showReferences),showFolders:g(Se.showFolders,this.defaultValue.showFolders),showTypeParameters:g(Se.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(Se.showSnippets,this.defaultValue.showSnippets),showUsers:g(Se.showUsers,this.defaultValue.showUsers),showIssues:g(Se.showIssues,this.defaultValue.showIssues)}}}class st extends a{constructor(){super(Ae.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:o.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:o.localize(199,null),default:!0,type:"boolean"}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(ee.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:g(ee.selectSubwords,this.defaultValue.selectSubwords)}}}class lt extends a{constructor(){const ee=[];super(Ae.wordSegmenterLocales,"wordSegmenterLocales",ee,{anyOf:[{description:o.localize(200,null),type:"string"},{description:o.localize(201,null),type:"array",items:{type:"string"}}]})}validate(ee){if(typeof ee=="string"&&(ee=[ee]),Array.isArray(ee)){const Se=[];for(const He of ee)if(typeof He=="string")try{Intl.Segmenter.supportedLocalesOf(He).length>0&&Se.push(He)}catch{}return Se}return this.defaultValue}}var rt;(function(ie){ie[ie.None=0]="None",ie[ie.Same=1]="Same",ie[ie.Indent=2]="Indent",ie[ie.DeepIndent=3]="DeepIndent"})(rt||(e.WrappingIndent=rt={}));class it extends a{constructor(){super(Ae.wrappingIndent,"wrappingIndent",rt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[o.localize(202,null),o.localize(203,null),o.localize(204,null),o.localize(205,null)],description:o.localize(206,null),default:"same"}})}validate(ee){switch(ee){case"none":return rt.None;case"same":return rt.Same;case"indent":return rt.Indent;case"deepIndent":return rt.DeepIndent}return rt.Same}compute(ee,Se,He){return Se.get(Ae.accessibilitySupport)===D.AccessibilitySupport.Enabled?rt.None:He}}class tt extends p{constructor(){super(Ae.wrappingInfo)}compute(ee,Se,He){const Ge=Se.get(Ae.layoutInfo);return{isDominatedByLongLines:ee.isDominatedByLongLines,isWordWrapMinified:Ge.isWordWrapMinified,isViewportWrapping:Ge.isViewportWrapping,wrappingColumn:Ge.wrappingColumn}}}class et extends a{constructor(){const ee={enabled:!0,showDropSelector:"afterDrop"};super(Ae.dropIntoEditor,"dropIntoEditor",ee,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ee.enabled,markdownDescription:o.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:o.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[o.localize(209,null),o.localize(210,null)],default:"afterDrop"}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{enabled:g(Se.enabled,this.defaultValue.enabled),showDropSelector:c(Se.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Qe extends a{constructor(){const ee={enabled:!0,showPasteSelector:"afterPaste"};super(Ae.pasteAs,"pasteAs",ee,{"editor.pasteAs.enabled":{type:"boolean",default:ee.enabled,markdownDescription:o.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:o.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[o.localize(213,null),o.localize(214,null)],default:"afterPaste"}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Se=ee;return{enabled:g(Se.enabled,this.defaultValue.enabled),showPasteSelector:c(Se.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ee="Consolas, 'Courier New', monospace",Oe="Menlo, Monaco, 'Courier New', monospace",Fe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:w.isMacintosh?Oe:w.isLinux?Fe:Ee,fontWeight:"normal",fontSize:w.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function be(ie){return e.editorOptionsRegistry[ie.id]=ie,ie}var Ae;(function(ie){ie[ie.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ie[ie.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ie[ie.accessibilitySupport=2]="accessibilitySupport",ie[ie.accessibilityPageSize=3]="accessibilityPageSize",ie[ie.ariaLabel=4]="ariaLabel",ie[ie.ariaRequired=5]="ariaRequired",ie[ie.autoClosingBrackets=6]="autoClosingBrackets",ie[ie.autoClosingComments=7]="autoClosingComments",ie[ie.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ie[ie.autoClosingDelete=9]="autoClosingDelete",ie[ie.autoClosingOvertype=10]="autoClosingOvertype",ie[ie.autoClosingQuotes=11]="autoClosingQuotes",ie[ie.autoIndent=12]="autoIndent",ie[ie.automaticLayout=13]="automaticLayout",ie[ie.autoSurround=14]="autoSurround",ie[ie.bracketPairColorization=15]="bracketPairColorization",ie[ie.guides=16]="guides",ie[ie.codeLens=17]="codeLens",ie[ie.codeLensFontFamily=18]="codeLensFontFamily",ie[ie.codeLensFontSize=19]="codeLensFontSize",ie[ie.colorDecorators=20]="colorDecorators",ie[ie.colorDecoratorsLimit=21]="colorDecoratorsLimit",ie[ie.columnSelection=22]="columnSelection",ie[ie.comments=23]="comments",ie[ie.contextmenu=24]="contextmenu",ie[ie.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ie[ie.cursorBlinking=26]="cursorBlinking",ie[ie.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ie[ie.cursorStyle=28]="cursorStyle",ie[ie.cursorSurroundingLines=29]="cursorSurroundingLines",ie[ie.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ie[ie.cursorWidth=31]="cursorWidth",ie[ie.disableLayerHinting=32]="disableLayerHinting",ie[ie.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ie[ie.domReadOnly=34]="domReadOnly",ie[ie.dragAndDrop=35]="dragAndDrop",ie[ie.dropIntoEditor=36]="dropIntoEditor",ie[ie.emptySelectionClipboard=37]="emptySelectionClipboard",ie[ie.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ie[ie.extraEditorClassName=39]="extraEditorClassName",ie[ie.fastScrollSensitivity=40]="fastScrollSensitivity",ie[ie.find=41]="find",ie[ie.fixedOverflowWidgets=42]="fixedOverflowWidgets",ie[ie.folding=43]="folding",ie[ie.foldingStrategy=44]="foldingStrategy",ie[ie.foldingHighlight=45]="foldingHighlight",ie[ie.foldingImportsByDefault=46]="foldingImportsByDefault",ie[ie.foldingMaximumRegions=47]="foldingMaximumRegions",ie[ie.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ie[ie.fontFamily=49]="fontFamily",ie[ie.fontInfo=50]="fontInfo",ie[ie.fontLigatures=51]="fontLigatures",ie[ie.fontSize=52]="fontSize",ie[ie.fontWeight=53]="fontWeight",ie[ie.fontVariations=54]="fontVariations",ie[ie.formatOnPaste=55]="formatOnPaste",ie[ie.formatOnType=56]="formatOnType",ie[ie.glyphMargin=57]="glyphMargin",ie[ie.gotoLocation=58]="gotoLocation",ie[ie.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ie[ie.hover=60]="hover",ie[ie.inDiffEditor=61]="inDiffEditor",ie[ie.inlineSuggest=62]="inlineSuggest",ie[ie.inlineEdit=63]="inlineEdit",ie[ie.letterSpacing=64]="letterSpacing",ie[ie.lightbulb=65]="lightbulb",ie[ie.lineDecorationsWidth=66]="lineDecorationsWidth",ie[ie.lineHeight=67]="lineHeight",ie[ie.lineNumbers=68]="lineNumbers",ie[ie.lineNumbersMinChars=69]="lineNumbersMinChars",ie[ie.linkedEditing=70]="linkedEditing",ie[ie.links=71]="links",ie[ie.matchBrackets=72]="matchBrackets",ie[ie.minimap=73]="minimap",ie[ie.mouseStyle=74]="mouseStyle",ie[ie.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ie[ie.mouseWheelZoom=76]="mouseWheelZoom",ie[ie.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ie[ie.multiCursorModifier=78]="multiCursorModifier",ie[ie.multiCursorPaste=79]="multiCursorPaste",ie[ie.multiCursorLimit=80]="multiCursorLimit",ie[ie.occurrencesHighlight=81]="occurrencesHighlight",ie[ie.overviewRulerBorder=82]="overviewRulerBorder",ie[ie.overviewRulerLanes=83]="overviewRulerLanes",ie[ie.padding=84]="padding",ie[ie.pasteAs=85]="pasteAs",ie[ie.parameterHints=86]="parameterHints",ie[ie.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ie[ie.placeholder=88]="placeholder",ie[ie.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",ie[ie.quickSuggestions=90]="quickSuggestions",ie[ie.quickSuggestionsDelay=91]="quickSuggestionsDelay",ie[ie.readOnly=92]="readOnly",ie[ie.readOnlyMessage=93]="readOnlyMessage",ie[ie.renameOnType=94]="renameOnType",ie[ie.renderControlCharacters=95]="renderControlCharacters",ie[ie.renderFinalNewline=96]="renderFinalNewline",ie[ie.renderLineHighlight=97]="renderLineHighlight",ie[ie.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",ie[ie.renderValidationDecorations=99]="renderValidationDecorations",ie[ie.renderWhitespace=100]="renderWhitespace",ie[ie.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",ie[ie.roundedSelection=102]="roundedSelection",ie[ie.rulers=103]="rulers",ie[ie.scrollbar=104]="scrollbar",ie[ie.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",ie[ie.scrollBeyondLastLine=106]="scrollBeyondLastLine",ie[ie.scrollPredominantAxis=107]="scrollPredominantAxis",ie[ie.selectionClipboard=108]="selectionClipboard",ie[ie.selectionHighlight=109]="selectionHighlight",ie[ie.selectOnLineNumbers=110]="selectOnLineNumbers",ie[ie.showFoldingControls=111]="showFoldingControls",ie[ie.showUnused=112]="showUnused",ie[ie.snippetSuggestions=113]="snippetSuggestions",ie[ie.smartSelect=114]="smartSelect",ie[ie.smoothScrolling=115]="smoothScrolling",ie[ie.stickyScroll=116]="stickyScroll",ie[ie.stickyTabStops=117]="stickyTabStops",ie[ie.stopRenderingLineAfter=118]="stopRenderingLineAfter",ie[ie.suggest=119]="suggest",ie[ie.suggestFontSize=120]="suggestFontSize",ie[ie.suggestLineHeight=121]="suggestLineHeight",ie[ie.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",ie[ie.suggestSelection=123]="suggestSelection",ie[ie.tabCompletion=124]="tabCompletion",ie[ie.tabIndex=125]="tabIndex",ie[ie.unicodeHighlighting=126]="unicodeHighlighting",ie[ie.unusualLineTerminators=127]="unusualLineTerminators",ie[ie.useShadowDOM=128]="useShadowDOM",ie[ie.useTabStops=129]="useTabStops",ie[ie.wordBreak=130]="wordBreak",ie[ie.wordSegmenterLocales=131]="wordSegmenterLocales",ie[ie.wordSeparators=132]="wordSeparators",ie[ie.wordWrap=133]="wordWrap",ie[ie.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",ie[ie.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",ie[ie.wordWrapColumn=136]="wordWrapColumn",ie[ie.wordWrapOverride1=137]="wordWrapOverride1",ie[ie.wordWrapOverride2=138]="wordWrapOverride2",ie[ie.wrappingIndent=139]="wrappingIndent",ie[ie.wrappingStrategy=140]="wrappingStrategy",ie[ie.showDeprecated=141]="showDeprecated",ie[ie.inlayHints=142]="inlayHints",ie[ie.editorClassName=143]="editorClassName",ie[ie.pixelRatio=144]="pixelRatio",ie[ie.tabFocusMode=145]="tabFocusMode",ie[ie.layoutInfo=146]="layoutInfo",ie[ie.wrappingInfo=147]="wrappingInfo",ie[ie.defaultColorDecorators=148]="defaultColorDecorators",ie[ie.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",ie[ie.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(Ae||(e.EditorOption=Ae={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:be(new v(Ae.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:o.localize(215,null)})),acceptSuggestionOnEnter:be(new u(Ae.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",o.localize(216,null),""],markdownDescription:o.localize(217,null)})),accessibilitySupport:be(new A),accessibilityPageSize:be(new l(Ae.accessibilityPageSize,"accessibilityPageSize",10,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(218,null),tags:["accessibility"]})),ariaLabel:be(new s(Ae.ariaLabel,"ariaLabel",o.localize(219,null))),ariaRequired:be(new v(Ae.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:be(new v(Ae.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:o.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:be(new u(Ae.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(221,null),o.localize(222,null),""],description:o.localize(223,null)})),autoClosingComments:be(new u(Ae.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(224,null),o.localize(225,null),""],description:o.localize(226,null)})),autoClosingDelete:be(new u(Ae.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",o.localize(227,null),""],description:o.localize(228,null)})),autoClosingOvertype:be(new u(Ae.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",o.localize(229,null),""],description:o.localize(230,null)})),autoClosingQuotes:be(new u(Ae.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(231,null),o.localize(232,null),""],description:o.localize(233,null)})),autoIndent:be(new I(Ae.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],T,{enumDescriptions:[o.localize(234,null),o.localize(235,null),o.localize(236,null),o.localize(237,null),o.localize(238,null)],description:o.localize(239,null)})),automaticLayout:be(new v(Ae.automaticLayout,"automaticLayout",!1)),autoSurround:be(new u(Ae.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[o.localize(240,null),o.localize(241,null),o.localize(242,null),""],description:o.localize(243,null)})),bracketPairColorization:be(new Xe),bracketPairGuides:be(new je),stickyTabStops:be(new v(Ae.stickyTabStops,"stickyTabStops",!1,{description:o.localize(244,null)})),codeLens:be(new v(Ae.codeLens,"codeLens",!0,{description:o.localize(245,null)})),codeLensFontFamily:be(new s(Ae.codeLensFontFamily,"codeLensFontFamily","",{description:o.localize(246,null)})),codeLensFontSize:be(new l(Ae.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:o.localize(247,null)})),colorDecorators:be(new v(Ae.colorDecorators,"colorDecorators",!0,{description:o.localize(248,null)})),colorDecoratorActivatedOn:be(new u(Ae.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[o.localize(249,null),o.localize(250,null),o.localize(251,null)],description:o.localize(252,null)})),colorDecoratorsLimit:be(new l(Ae.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:o.localize(253,null)})),columnSelection:be(new v(Ae.columnSelection,"columnSelection",!1,{description:o.localize(254,null)})),comments:be(new O),contextmenu:be(new v(Ae.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:be(new v(Ae.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:o.localize(255,null)})),cursorBlinking:be(new I(Ae.cursorBlinking,"cursorBlinking",k.Blink,"blink",["blink","smooth","phase","expand","solid"],P,{description:o.localize(256,null)})),cursorSmoothCaretAnimation:be(new u(Ae.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[o.localize(257,null),o.localize(258,null),o.localize(259,null)],description:o.localize(260,null)})),cursorStyle:be(new I(Ae.cursorStyle,"cursorStyle",B.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],X,{description:o.localize(261,null)})),cursorSurroundingLines:be(new l(Ae.cursorSurroundingLines,"cursorSurroundingLines",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(262,null)})),cursorSurroundingLinesStyle:be(new u(Ae.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[o.localize(263,null),o.localize(264,null)],markdownDescription:o.localize(265,null)})),cursorWidth:be(new l(Ae.cursorWidth,"cursorWidth",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:o.localize(266,null)})),disableLayerHinting:be(new v(Ae.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:be(new v(Ae.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:be(new v(Ae.domReadOnly,"domReadOnly",!1)),dragAndDrop:be(new v(Ae.dragAndDrop,"dragAndDrop",!0,{description:o.localize(267,null)})),emptySelectionClipboard:be(new te),dropIntoEditor:be(new et),stickyScroll:be(new L),experimentalWhitespaceRendering:be(new u(Ae.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[o.localize(268,null),o.localize(269,null),o.localize(270,null)],description:o.localize(271,null)})),extraEditorClassName:be(new s(Ae.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:be(new h(Ae.fastScrollSensitivity,"fastScrollSensitivity",5,ie=>ie<=0?5:ie,{markdownDescription:o.localize(272,null)})),find:be(new Z),fixedOverflowWidgets:be(new v(Ae.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:be(new v(Ae.folding,"folding",!0,{description:o.localize(273,null)})),foldingStrategy:be(new u(Ae.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[o.localize(274,null),o.localize(275,null)],description:o.localize(276,null)})),foldingHighlight:be(new v(Ae.foldingHighlight,"foldingHighlight",!0,{description:o.localize(277,null)})),foldingImportsByDefault:be(new v(Ae.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:o.localize(278,null)})),foldingMaximumRegions:be(new l(Ae.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:o.localize(279,null)})),unfoldOnClickAfterEndOfLine:be(new v(Ae.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:o.localize(280,null)})),fontFamily:be(new s(Ae.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:o.localize(281,null)})),fontInfo:be(new ae),fontLigatures2:be(new fe),fontSize:be(new x),fontWeight:be(new z),fontVariations:be(new K),formatOnPaste:be(new v(Ae.formatOnPaste,"formatOnPaste",!1,{description:o.localize(282,null)})),formatOnType:be(new v(Ae.formatOnType,"formatOnType",!1,{description:o.localize(283,null)})),glyphMargin:be(new v(Ae.glyphMargin,"glyphMargin",!0,{description:o.localize(284,null)})),gotoLocation:be(new ne),hideCursorInOverviewRuler:be(new v(Ae.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:o.localize(285,null)})),hover:be(new le),inDiffEditor:be(new v(Ae.inDiffEditor,"inDiffEditor",!1)),letterSpacing:be(new h(Ae.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ie=>h.clamp(ie,-5,20),{description:o.localize(286,null)})),lightbulb:be(new W),lineDecorationsWidth:be(new $),lineHeight:be(new U),lineNumbers:be(new ge),lineNumbersMinChars:be(new l(Ae.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:be(new v(Ae.linkedEditing,"linkedEditing",!1,{description:o.localize(287,null)})),links:be(new v(Ae.links,"links",!0,{description:o.localize(288,null)})),matchBrackets:be(new u(Ae.matchBrackets,"matchBrackets","always",["always","near","never"],{description:o.localize(289,null)})),minimap:be(new q),mouseStyle:be(new u(Ae.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:be(new h(Ae.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ie=>ie===0?1:ie,{markdownDescription:o.localize(290,null)})),mouseWheelZoom:be(new v(Ae.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:w.isMacintosh?o.localize(291,null):o.localize(292,null)})),multiCursorMergeOverlapping:be(new v(Ae.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:o.localize(293,null)})),multiCursorModifier:be(new I(Ae.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],G,{markdownEnumDescriptions:[o.localize(294,null),o.localize(295,null)],markdownDescription:o.localize(296,null)})),multiCursorPaste:be(new u(Ae.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[o.localize(297,null),o.localize(298,null)],markdownDescription:o.localize(299,null)})),multiCursorLimit:be(new l(Ae.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:o.localize(300,null)})),occurrencesHighlight:be(new u(Ae.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[o.localize(301,null),o.localize(302,null),o.localize(303,null)],markdownDescription:o.localize(304,null)})),overviewRulerBorder:be(new v(Ae.overviewRulerBorder,"overviewRulerBorder",!0,{description:o.localize(305,null)})),overviewRulerLanes:be(new l(Ae.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:be(new F),pasteAs:be(new Qe),parameterHints:be(new V),peekWidgetDefaultFocus:be(new u(Ae.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[o.localize(306,null),o.localize(307,null)],description:o.localize(308,null)})),placeholder:be(new de),definitionLinkOpensInPeek:be(new v(Ae.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:o.localize(309,null)})),quickSuggestions:be(new Ce),quickSuggestionsDelay:be(new l(Ae.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(310,null)})),readOnly:be(new v(Ae.readOnly,"readOnly",!1)),readOnlyMessage:be(new Le),renameOnType:be(new v(Ae.renameOnType,"renameOnType",!1,{description:o.localize(311,null),markdownDeprecationMessage:o.localize(312,null)})),renderControlCharacters:be(new v(Ae.renderControlCharacters,"renderControlCharacters",!0,{description:o.localize(313,null),restricted:!0})),renderFinalNewline:be(new u(Ae.renderFinalNewline,"renderFinalNewline",w.isLinux?"dimmed":"on",["off","on","dimmed"],{description:o.localize(314,null)})),renderLineHighlight:be(new u(Ae.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",o.localize(315,null)],description:o.localize(316,null)})),renderLineHighlightOnlyWhenFocus:be(new v(Ae.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:o.localize(317,null)})),renderValidationDecorations:be(new u(Ae.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:be(new u(Ae.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",o.localize(318,null),o.localize(319,null),o.localize(320,null),""],description:o.localize(321,null)})),revealHorizontalRightPadding:be(new l(Ae.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:be(new v(Ae.roundedSelection,"roundedSelection",!0,{description:o.localize(322,null)})),rulers:be(new Te),scrollbar:be(new De),scrollBeyondLastColumn:be(new l(Ae.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(323,null)})),scrollBeyondLastLine:be(new v(Ae.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:o.localize(324,null)})),scrollPredominantAxis:be(new v(Ae.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:o.localize(325,null)})),selectionClipboard:be(new v(Ae.selectionClipboard,"selectionClipboard",!0,{description:o.localize(326,null),included:w.isLinux})),selectionHighlight:be(new v(Ae.selectionHighlight,"selectionHighlight",!0,{description:o.localize(327,null)})),selectOnLineNumbers:be(new v(Ae.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:be(new u(Ae.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[o.localize(328,null),o.localize(329,null),o.localize(330,null)],description:o.localize(331,null)})),showUnused:be(new v(Ae.showUnused,"showUnused",!0,{description:o.localize(332,null)})),showDeprecated:be(new v(Ae.showDeprecated,"showDeprecated",!0,{description:o.localize(333,null)})),inlayHints:be(new Q),snippetSuggestions:be(new u(Ae.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[o.localize(334,null),o.localize(335,null),o.localize(336,null),o.localize(337,null)],description:o.localize(338,null)})),smartSelect:be(new st),smoothScrolling:be(new v(Ae.smoothScrolling,"smoothScrolling",!1,{description:o.localize(339,null)})),stopRenderingLineAfter:be(new l(Ae.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:be(new Je),inlineSuggest:be(new xe),inlineEdit:be(new Ve),inlineCompletionsAccessibilityVerbose:be(new v(Ae.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:o.localize(340,null)})),suggestFontSize:be(new l(Ae.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:o.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:be(new l(Ae.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:o.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:be(new v(Ae.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:o.localize(343,null)})),suggestSelection:be(new u(Ae.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[o.localize(344,null),o.localize(345,null),o.localize(346,null)],description:o.localize(347,null)})),tabCompletion:be(new u(Ae.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[o.localize(348,null),o.localize(349,null),o.localize(350,null)],description:o.localize(351,null)})),tabIndex:be(new l(Ae.tabIndex,"tabIndex",0,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:be(new Re),unusualLineTerminators:be(new u(Ae.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[o.localize(352,null),o.localize(353,null),o.localize(354,null)],description:o.localize(355,null)})),useShadowDOM:be(new v(Ae.useShadowDOM,"useShadowDOM",!0)),useTabStops:be(new v(Ae.useTabStops,"useTabStops",!0,{description:o.localize(356,null)})),wordBreak:be(new u(Ae.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[o.localize(357,null),o.localize(358,null)],description:o.localize(359,null)})),wordSegmenterLocales:be(new lt),wordSeparators:be(new s(Ae.wordSeparators,"wordSeparators",b.USUAL_WORD_SEPARATORS,{description:o.localize(360,null)})),wordWrap:be(new u(Ae.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[o.localize(361,null),o.localize(362,null),o.localize(363,null),o.localize(364,null)],description:o.localize(365,null)})),wordWrapBreakAfterCharacters:be(new s(Ae.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:be(new s(Ae.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:be(new l(Ae.wordWrapColumn,"wordWrapColumn",80,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:o.localize(366,null)})),wordWrapOverride1:be(new u(Ae.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:be(new u(Ae.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:be(new re),defaultColorDecorators:be(new v(Ae.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:o.localize(367,null)})),pixelRatio:be(new oe),tabFocusMode:be(new v(Ae.tabFocusMode,"tabFocusMode",!1,{markdownDescription:o.localize(368,null)})),layoutInfo:be(new H),wrappingInfo:be(new tt),wrappingIndent:be(new it),wrappingStrategy:be(new ce)}}),define(ye[250],Ie([1,0,5]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.IDiagnosticsService=e.ID=void 0,e.isRemoteDiagnosticError=r,e.ID="diagnosticsService",e.IDiagnosticsService=(0,i.createDecorator)(e.ID);function r(C){return!!C.hostName&&!!C.errorMessage}class w{async getPerformanceInfo(R,_){return{}}async getSystemInfo(R,_){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(R,_){return""}async getWorkspaceFileExtensions(R){return{extensions:[]}}async reportWorkspaceStats(R){}}e.NullDiagnosticsService=w}),define(ye[88],Ie([1,0,5]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,i.createDecorator)("downloadService")}),define(ye[28],Ie([1,0,5]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,i.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,i.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[16],Ie([1,0,67,9,17,11,4,216,5,3,13,65]),function(se,e,i,r,w,C,R,_,b,o,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=d,e.isFileSystemWatcher=m,e.hasReadWriteCapability=S,e.hasFileFolderCopyCapability=g,e.hasFileCloneCapability=v,e.hasOpenReadWriteCloseCapability=t,e.hasFileReadStreamCapability=l,e.hasFileAtomicReadCapability=n,e.hasFileAtomicWriteCapability=h,e.hasFileAtomicDeleteCapability=s,e.hasReadonlyCapability=c,e.createFileSystemProviderError=T,e.ensureFileSystemProviderError=A,e.markAsFileSystemProviderError=O,e.toFileSystemProviderErrorCode=k,e.toFileOperationResult=P,e.isParent=te,e.etag=z,e.whenProviderRegistered=ne,e.getLargeFileConfirmationLimit=ve,e.IFileService=(0,b.createDecorator)("fileService");function d(H){return H.create===!0}var E;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var a;(function(H){H[H.Readonly=1]="Readonly",H[H.Locked=2]="Locked"})(a||(e.FilePermission=a={}));var f;(function(H){H[H.UPDATED=2]="UPDATED",H[H.ADDED=4]="ADDED",H[H.DELETED=8]="DELETED"})(f||(e.FileChangeFilter=f={}));function m(H){const ce=H;return!!ce&&typeof ce.onDidChange=="function"}var p;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileAtomicWrite=32768]="FileAtomicWrite",H[H.FileAtomicDelete=65536]="FileAtomicDelete",H[H.FileClone=131072]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function S(H){return!!(H.capabilities&p.FileReadWrite)}function g(H){return!!(H.capabilities&p.FileFolderCopy)}function v(H){return!!(H.capabilities&p.FileClone)}function t(H){return!!(H.capabilities&p.FileOpenReadWriteClose)}function l(H){return!!(H.capabilities&p.FileReadStream)}function n(H){return S(H)?!!(H.capabilities&p.FileAtomicRead):!1}function h(H){return S(H)?!!(H.capabilities&p.FileAtomicWrite):!1}function s(H){return!!(H.capabilities&p.FileAtomicDelete)}function c(H){return!!(H.capabilities&p.Readonly)}var u;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(u||(e.FileSystemProviderErrorCode=u={}));class I extends Error{static create(ce,J){const W=new I(ce.toString(),J);return O(W,J),W}constructor(ce,J){super(ce),this.code=J}}e.FileSystemProviderError=I;function T(H,ce){return I.create(H,ce)}function A(H){return H||T((0,_.localize)(0,null),u.Unknown)}function O(H,ce){return H.name=ce?`${ce} (FileSystemError)`:"FileSystemError",H}function k(H){if(!H)return u.Unknown;if(H instanceof I)return H.code;const ce=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!ce)return u.Unknown;switch(ce[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}function P(H){if(H instanceof Z)return H.fileOperationResult;switch(k(H)){case u.FileNotFound:return ae.FILE_NOT_FOUND;case u.FileIsADirectory:return ae.FILE_IS_DIRECTORY;case u.FileNotADirectory:return ae.FILE_NOT_DIRECTORY;case u.FileWriteLocked:return ae.FILE_WRITE_LOCKED;case u.NoPermissions:return ae.FILE_PERMISSION_DENIED;case u.FileExists:return ae.FILE_MOVE_CONFLICT;case u.FileTooLarge:return ae.FILE_TOO_LARGE;default:return ae.FILE_OTHER_ERROR}}var B;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(B||(e.FileOperation=B={}));class Y{constructor(ce,J,W){this.resource=ce,this.operation=J,this.target=W}isOperation(ce){return this.operation===ce}}e.FileOperationEvent=Y;var X;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(X||(e.FileChangeType=X={}));class re{static{this.MIXED_CORRELATION=null}constructor(ce,J){this.ignorePathCasing=J,this.correlationId=void 0,this.added=new y.Lazy(()=>{const W=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return W.fill(this.rawAdded.map(L=>[L,!0])),W}),this.updated=new y.Lazy(()=>{const W=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return W.fill(this.rawUpdated.map(L=>[L,!0])),W}),this.deleted=new y.Lazy(()=>{const W=i.TernarySearchTree.forUris(()=>this.ignorePathCasing);return W.fill(this.rawDeleted.map(L=>[L,!0])),W}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const W of ce){switch(W.type){case X.ADDED:this.rawAdded.push(W.resource);break;case X.UPDATED:this.rawUpdated.push(W.resource);break;case X.DELETED:this.rawDeleted.push(W.resource);break}this.correlationId!==re.MIXED_CORRELATION&&(typeof W.cId=="number"?this.correlationId===void 0?this.correlationId=W.cId:this.correlationId!==W.cId&&(this.correlationId=re.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=re.MIXED_CORRELATION))}}contains(ce,...J){return this.doContains(ce,{includeChildren:!1},...J)}affects(ce,...J){return this.doContains(ce,{includeChildren:!0},...J)}doContains(ce,J,...W){if(!ce)return!1;const L=W.length>0;return!!((!L||W.includes(X.ADDED))&&(this.added.value.get(ce)||J.includeChildren&&this.added.value.findSuperstr(ce))||(!L||W.includes(X.UPDATED))&&(this.updated.value.get(ce)||J.includeChildren&&this.updated.value.findSuperstr(ce))||(!L||W.includes(X.DELETED))&&(this.deleted.value.findSubstr(ce)||J.includeChildren&&this.deleted.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.correlationId===ce}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=re;function te(H,ce,J){return!H||!ce||H===ce||ce.length>H.length?!1:(ce.charAt(ce.length-1)!==r.sep&&(ce+=r.sep),J?(0,w.startsWithIgnoreCase)(H,ce):H.indexOf(ce)===0)}class Z extends Error{constructor(ce,J,W){super(ce),this.fileOperationResult=J,this.options=W}}e.FileOperationError=Z;class fe extends Z{constructor(ce,J,W,L){super(ce,J,L),this.fileOperationResult=J,this.size=W}}e.TooLargeFileOperationError=fe;class K extends Z{constructor(ce,J,W){super(ce,ae.FILE_NOT_MODIFIED_SINCE,W),this.stat=J}}e.NotModifiedSinceFileOperationError=K;var ae;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var x;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(x||(e.FileKind=x={})),e.ETAG_DISABLED="";function z(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}async function ne(H,ce){if(!ce.hasProvider(R.URI.from({scheme:H.scheme})))return new Promise(J=>{const W=ce.onDidChangeFileSystemProviderRegistrations(L=>{L.scheme===H.scheme&&L.added&&(W.dispose(),J())})})}class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize(ce){return(0,C.isNumber)(ce)||(ce=0),ce<le.KB?(0,_.localize)(1,null,ce.toFixed(0)):ce<le.MB?(0,_.localize)(2,null,(ce/le.KB).toFixed(2)):ce<le.GB?(0,_.localize)(3,null,(ce/le.MB).toFixed(2)):ce<le.TB?(0,_.localize)(4,null,(ce/le.GB).toFixed(2)):(0,_.localize)(5,null,(ce/le.TB).toFixed(2))}}e.ByteSize=le;function ve(H){const ce=typeof H=="string"||H?.scheme===D.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===D.Schemas.file?1024*le.MB:ce?10*le.MB:o.isWeb?50*le.MB:1024*le.MB}}),define(ye[121],Ie([1,0,15,10,217,16]),function(se,e,i,r,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=R;async function R(D,y,d,E,a,f){let m;try{await _(D,y,d,E,a,f)}catch(p){m=p}finally{m&&a.errorTransformer&&(m=a.errorTransformer(m)),typeof m<"u"&&d.error(m),d.end()}}async function _(D,y,d,E,a,f){b(f);const m=await D.open(y,{create:!1});try{b(f);let p=0,S=0,g=a&&typeof a.length=="number"?a.length:void 0,v=i.VSBuffer.alloc(Math.min(a.bufferSize,typeof g=="number"?g:a.bufferSize)),t=a&&typeof a.position=="number"?a.position:0,l=0;do S=await D.read(m,t,v.buffer,l,v.byteLength-l),t+=S,l+=S,p+=S,typeof g=="number"&&(g-=S),l===v.byteLength&&(await d.write(E(v)),v=i.VSBuffer.alloc(Math.min(a.bufferSize,typeof g=="number"?g:a.bufferSize)),l=0);while(S>0&&(typeof g!="number"||g>0)&&b(f)&&o(p,a));if(l>0){let n=l;typeof g=="number"&&(n=Math.min(l,g)),d.write(E(v.slice(0,n)))}}catch(p){throw(0,C.ensureFileSystemProviderError)(p)}finally{await D.close(m)}}function b(D){if(D.isCancellationRequested)throw(0,r.canceled)();return!0}function o(D,y){if(typeof y?.limits?.size=="number"&&D>y.limits.size)throw(0,C.createFileSystemProviderError)((0,w.localize)(0,null),C.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ye[52],Ie([1,0,86,2,9,3,4,16]),function(se,e,i,r,w,C,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=void 0,e.isWatchRequestWithCorrelation=b,e.isRecursiveWatchRequest=o,e.reviveFileChanges=E,e.coalesceEvents=a,e.normalizeWatcherPattern=f,e.parseWatcherPatterns=m,e.isFiltered=S,e.requestFilterToString=g;function b(v){return typeof v.correlationId=="number"}function o(v){return v.recursive===!0}class D extends r.Disposable{static{this.MAX_RESTARTS=5}constructor(t,l,n,h){super(),this.onFileChanges=t,this.onLogMessage=l,this.verboseLogging=n,this.options=h,this.watcherDisposables=this._register(new r.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const t=new r.DisposableStore;this.watcherDisposables.value=t,this.watcher=this.createWatcher(t),this.watcher.setVerboseLogging(this.verboseLogging),t.add(this.watcher.onDidChangeFile(l=>this.onFileChanges(l))),t.add(this.watcher.onDidLogMessage(l=>this.onLogMessage(l))),t.add(this.watcher.onDidError(l=>this.onError(l.error,l.request)))}onError(t,l){this.canRestart(t,l)?this.restartCounter<D.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after unexpected error: ${t}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after unexpected error: ${t}`):this.error(t)}canRestart(t,l){return!(!this.options.restartOnError||l||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}restart(t){this.restartCounter++,this.init(),this.watch(t)}async watch(t){this.requests=t,await this.watcher?.watch(t)}async setVerboseLogging(t){this.verboseLogging=t,await this.watcher?.setVerboseLogging(t)}error(t){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${t}`})}trace(t){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${t}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=D;class y extends D{constructor(t,l,n){super(t,l,n,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=y;class d extends D{constructor(t,l,n){super(t,l,n,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=d;function E(v){return v.map(t=>({type:t.type,resource:R.URI.revive(t.resource),cId:t.cId}))}function a(v){const t=new p;for(const l of v)t.processEvent(l);return t.coalesce()}function f(v,t){return typeof t=="string"&&!t.startsWith(i.GLOBSTAR)&&!(0,w.isAbsolute)(t)?{base:v,pattern:t}:t}function m(v,t){const l=[];for(const n of t)l.push((0,i.parse)(f(v,n)));return l}class p{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(t){return C.isLinux?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const l=this.mapPathToChange.get(this.toKey(t));let n=!1;if(l){const h=l.type,s=t.type;l.resource.fsPath!==t.resource.fsPath&&(t.type===_.FileChangeType.DELETED||t.type===_.FileChangeType.ADDED)?n=!0:h===_.FileChangeType.ADDED&&s===_.FileChangeType.DELETED?(this.mapPathToChange.delete(this.toKey(t)),this.coalesced.delete(l)):h===_.FileChangeType.DELETED&&s===_.FileChangeType.ADDED?l.type=_.FileChangeType.UPDATED:h===_.FileChangeType.ADDED&&s===_.FileChangeType.UPDATED||(l.type=s)}else n=!0;n&&(this.coalesced.add(t),this.mapPathToChange.set(this.toKey(t),t))}coalesce(){const t=[],l=[];return Array.from(this.coalesced).filter(n=>n.type!==_.FileChangeType.DELETED?(t.push(n),!1):!0).sort((n,h)=>n.resource.fsPath.length-h.resource.fsPath.length).filter(n=>l.some(h=>(0,_.isParent)(n.resource.fsPath,h,!C.isLinux))?!1:(l.push(n.resource.fsPath),!0)).concat(t)}}function S(v,t){if(typeof t=="number")switch(v.type){case _.FileChangeType.ADDED:return(t&_.FileChangeFilter.ADDED)===0;case _.FileChangeType.DELETED:return(t&_.FileChangeFilter.DELETED)===0;case _.FileChangeType.UPDATED:return(t&_.FileChangeFilter.UPDATED)===0}return!1}function g(v){if(typeof v=="number"){const t=[];return v&_.FileChangeFilter.ADDED&&t.push("Added"),v&_.FileChangeFilter.DELETED&&t.push("Deleted"),v&_.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(ye[251],Ie([1,0,15,45,10,6,2,56,23,16,52]),function(se,e,i,r,w,C,R,_,b,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class y extends R.Disposable{constructor(E,a){super(),this.channel=E,this.extraCapabilities=a,this.onDidChangeCapabilities=C.Event.None,this._onDidChange=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,b.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=o.FileSystemProviderCapabilities.FileReadWrite|o.FileSystemProviderCapabilities.FileOpenReadWriteClose|o.FileSystemProviderCapabilities.FileReadStream|o.FileSystemProviderCapabilities.FileFolderCopy|o.FileSystemProviderCapabilities.FileWriteUnlock|o.FileSystemProviderCapabilities.FileAtomicRead|o.FileSystemProviderCapabilities.FileAtomicWrite|o.FileSystemProviderCapabilities.FileAtomicDelete|o.FileSystemProviderCapabilities.FileClone,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=o.FileSystemProviderCapabilities.PathCaseSensitive),this.extraCapabilities.trash&&(this._capabilities|=o.FileSystemProviderCapabilities.Trash)),this._capabilities}stat(E){return this.channel.call("stat",[E])}readdir(E){return this.channel.call("readdir",[E])}async readFile(E,a){const{buffer:f}=await this.channel.call("readFile",[E,a]);return f}readFileStream(E,a,f){const m=(0,_.newWriteableStream)(S=>i.VSBuffer.concat(S.map(g=>i.VSBuffer.wrap(g))).buffer),p=new R.DisposableStore;return p.add(this.channel.listen("readFileStream",[E,a])(S=>{if(S instanceof i.VSBuffer)m.write(S.buffer);else{if(S==="end")m.end();else{let g;if(S instanceof Error)g=S;else{const v=S;g=(0,o.createFileSystemProviderError)(v.message??(0,r.toErrorMessage)(v),v.code??o.FileSystemProviderErrorCode.Unknown)}m.error(g),m.end()}p.dispose()}})),p.add(f.onCancellationRequested(()=>{m.error((0,w.canceled)()),m.end(),p.dispose()})),m}writeFile(E,a,f){return this.channel.call("writeFile",[E,i.VSBuffer.wrap(a),f])}open(E,a){return this.channel.call("open",[E,a])}close(E){return this.channel.call("close",[E])}async read(E,a,f,m,p){const[S,g]=await this.channel.call("read",[E,a,p]);return f.set(S.buffer.slice(0,g),m),g}write(E,a,f,m,p){return this.channel.call("write",[E,a,i.VSBuffer.wrap(f),m,p])}mkdir(E){return this.channel.call("mkdir",[E])}delete(E,a){return this.channel.call("delete",[E,a])}rename(E,a,f){return this.channel.call("rename",[E,a,f])}copy(E,a,f){return this.channel.call("copy",[E,a,f])}cloneFile(E,a){return this.channel.call("cloneFile",[E,a])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(E=>{if(Array.isArray(E)){const a=E;this._onDidChange.fire((0,D.reviveFileChanges)(a))}else{const a=E;this._onDidWatchError.fire(a)}}))}watch(E,a){const f=(0,b.generateUuid)();return this.channel.call("watch",[this.sessionId,f,E,a]),(0,R.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,f]))}}e.DiskFileSystemProviderClient=y}),define(ye[252],Ie([1,0,31,2,52,6,16,4,14]),function(se,e,i,r,w,C,R,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class o extends r.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new C.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new C.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new r.DisposableMap),this.suspendedWatchRequestsWithPolling=new Set,this.updateWatchersDelayer=this._register(new b.ThrottledDelayer(this.getUpdateWatchersDelay())),this.suspendedWatchRequestPollingInterval=5007,this.joinWatch=new b.DeferredPromise,this.verboseLogging=!1,this._register(this.onDidWatchFail(y=>this.handleDidWatchFail(y)))}handleDidWatchFail(y){this.isCorrelated(y)&&this.suspendWatchRequest(y)}isCorrelated(y){return(0,w.isWatchRequestWithCorrelation)(y)}async watch(y){this.joinWatch.isSettled||this.joinWatch.complete(),this.joinWatch=new b.DeferredPromise;try{this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const d of y)this.isCorrelated(d)?this.allCorrelatedWatchRequests.set(d.correlationId,d):this.allNonCorrelatedWatchRequests.add(d);for(const[d]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(d)||(this.suspendedWatchRequests.deleteAndDispose(d),this.suspendedWatchRequestsWithPolling.delete(d));return await this.updateWatchers(!1)}finally{this.joinWatch.complete()}}updateWatchers(y){return this.updateWatchersDelayer.trigger(()=>this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(d=>!this.suspendedWatchRequests.has(d.correlationId))]),y?this.getUpdateWatchersDelay():0)}getUpdateWatchersDelay(){return 800}isSuspended(y){return typeof y.correlationId!="number"?!1:this.suspendedWatchRequestsWithPolling.has(y.correlationId)?"polling":this.suspendedWatchRequests.has(y.correlationId)}async suspendWatchRequest(y){if(this.suspendedWatchRequests.has(y.correlationId))return;const d=new r.DisposableStore;this.suspendedWatchRequests.set(y.correlationId,d),await this.joinWatch.p,!d.isDisposed&&(this.monitorSuspendedWatchRequest(y,d),this.updateWatchers(!0))}resumeWatchRequest(y){this.suspendedWatchRequests.deleteAndDispose(y.correlationId),this.suspendedWatchRequestsWithPolling.delete(y.correlationId),this.updateWatchers(!1)}monitorSuspendedWatchRequest(y,d){this.doMonitorWithExistingWatcher(y,d)?(this.trace(`reusing an existing recursive watcher to monitor ${y.path}`),this.suspendedWatchRequestsWithPolling.delete(y.correlationId)):(this.doMonitorWithNodeJS(y,d),this.suspendedWatchRequestsWithPolling.add(y.correlationId))}doMonitorWithExistingWatcher(y,d){const E=this.recursiveWatcher?.subscribe(y.path,(a,f)=>{d.isDisposed||(a?this.monitorSuspendedWatchRequest(y,d):f?.type===R.FileChangeType.ADDED&&this.onMonitoredPathAdded(y))});return E?(d.add(E),!0):!1}doMonitorWithNodeJS(y,d){let E=!1;const a=(f,m)=>{if(d.isDisposed)return;const p=this.isPathNotFound(f),S=this.isPathNotFound(m),g=E;E=p,!p&&(S||g)&&this.onMonitoredPathAdded(y)};this.trace(`starting fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,i.watchFile)(y.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},a)}catch(f){this.warn(`fs.watchFile() failed with error ${f} on path ${y.path} (correlationId: ${y.correlationId})`)}d.add((0,r.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,i.unwatchFile)(y.path,a)}catch(f){this.warn(`fs.unwatchFile() failed with error ${f} on path ${y.path} (correlationId: ${y.correlationId})`)}}))}onMonitoredPathAdded(y){this.trace(`detected ${y.path} exists again, resuming watcher (correlationId: ${y.correlationId})`);const d={resource:_.URI.file(y.path),type:R.FileChangeType.ADDED,cId:y.correlationId};this._onDidChangeFile.fire([d]),this.traceEvent(d,y),this.resumeWatchRequest(y)}isPathNotFound(y){return y.ctimeMs===0&&y.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll(),this.suspendedWatchRequestsWithPolling.clear()}traceEvent(y,d){if(this.verboseLogging){const E=` >> normalized ${y.type===R.FileChangeType.ADDED?"[ADDED]":y.type===R.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${y.resource.fsPath}`;this.traceWithCorrelation(E,d)}}traceWithCorrelation(y,d){this.verboseLogging&&this.trace(`${y}${typeof d.correlationId=="number"?` <${d.correlationId}> `:""}`)}requestToString(y){return`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, filter: ${(0,w.requestFilterToString)(y.filter)}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`}async setVerboseLogging(y){this.verboseLogging=y}}e.BaseWatcher=o}),define(ye[253],Ie([1,0,31,14,19,37,2,107,9,3,20,4,196,25,16,52]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcherLibrary=void 0,e.watchFileContents=p;class m extends R.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}get isReusingRecursiveWatcher(){return this._isReusingRecursiveWatcher}get failed(){return this.didFail}constructor(g,v,t,l,n,h){super(),this.request=g,this.recursiveWatcher=v,this.onDidFilesChange=t,this.onDidWatchFail=l,this.onLogMessage=n,this.verboseLogging=h,this.throttledFileChangesEmitter=this._register(new r.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.onDidFilesChange(s))),this.fileChangesAggregator=this._register(new r.RunOnceWorker(s=>this.handleFileChanges(s),m.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,f.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,f.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.filter=(0,f.isWatchRequestWithCorrelation)(this.request)?this.request.filter:void 0,this.cts=new w.CancellationTokenSource,this.ready=this.watch(),this._isReusingRecursiveWatcher=!1,this.didFail=!1}async watch(){try{const g=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const v=await E.Promises.stat(g);if(this.cts.token.isCancellationRequested)return;this._register(await this.doWatch(g,v.isDirectory()))}catch(g){g.code!=="ENOENT"?this.error(g):this.trace(`ignoring a path for watching who's stat info failed to resolve: ${this.request.path} (error: ${g})`),this.notifyWatchFailed()}}notifyWatchFailed(){this.didFail=!0,this.onDidWatchFail?.()}async normalizePath(g){let v=g.path;try{v=await E.Promises.realpath(g.path),g.path===v&&(v=await(0,d.realcase)(g.path,this.cts.token)??g.path),g.path!==v&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${g.path}, real: ${v})`)}catch{}return v}async doWatch(g,v){const t=new R.DisposableStore;return this.doWatchWithExistingWatcher(g,v,t)?(this.trace(`reusing an existing recursive watcher for ${this.request.path}`),this._isReusingRecursiveWatcher=!0):(this._isReusingRecursiveWatcher=!1,await this.doWatchWithNodeJS(g,v,t)),t}doWatchWithExistingWatcher(g,v,t){if(v)return!1;const l=y.URI.file(this.request.path),n=this.recursiveWatcher?.subscribe(this.request.path,async(h,s)=>{if(!t.isDisposed)if(h){const c=await this.doWatch(g,v);t.isDisposed?c.dispose():t.add(c)}else s&&(typeof s.cId=="number"||typeof this.request.correlationId=="number")&&this.onFileChange({resource:l,type:s.type,cId:this.request.correlationId},!0)});return n?(t.add(n),!0):!1}async doWatchWithNodeJS(g,v,t){if(o.isMacintosh&&(0,C.isEqualOrParent)(g,"/Volumes/",!0)){this.error(`Refusing to watch ${g} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const l=new w.CancellationTokenSource(this.cts.token);t.add((0,R.toDisposable)(()=>l.dispose(!0)));const n=new R.DisposableStore;t.add(n);try{const h=y.URI.file(this.request.path),s=(0,b.basename)(g),c=(0,i.watch)(g);n.add((0,R.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.trace(`Started watching: '${g}'`);const u=new Set;if(v)try{for(const T of await E.Promises.readdir(g))u.add(T)}catch(T){this.error(T)}if(l.token.isCancellationRequested)return;const I=new Map;n.add((0,R.toDisposable)(()=>{for(const[,T]of I)T.dispose();I.clear()})),c.on("error",(T,A)=>{l.token.isCancellationRequested||(this.error(`Failed to watch ${g} for changes using fs.watch() (${T}, ${A})`),this.notifyWatchFailed())}),c.on("change",(T,A)=>{if(l.token.isCancellationRequested)return;this.verboseLogging&&this.traceWithCorrelation(`[raw] ["${T}"] ${A}`);let O="";if(A&&(O=A.toString(),o.isMacintosh&&(O=(0,_.normalizeNFC)(O))),!(!O||T!=="change"&&T!=="rename"))if(v)if(T==="rename"){I.get(O)?.dispose();const k=setTimeout(async()=>{if(I.delete(O),O===s&&!await E.Promises.exists(g)){this.onWatchedPathDeleted(h);return}if(l.token.isCancellationRequested)return;const P=await this.existsChildStrictCase((0,b.join)(g,O));if(l.token.isCancellationRequested)return;let B;P?u.has(O)?B=a.FileChangeType.UPDATED:(B=a.FileChangeType.ADDED,u.add(O)):(u.delete(O),B=a.FileChangeType.DELETED),this.onFileChange({resource:(0,D.joinPath)(h,O),type:B,cId:this.request.correlationId})},m.FILE_DELETE_HANDLER_DELAY);I.set(O,(0,R.toDisposable)(()=>clearTimeout(k)))}else{let k;u.has(O)?k=a.FileChangeType.UPDATED:(k=a.FileChangeType.ADDED,u.add(O)),this.onFileChange({resource:(0,D.joinPath)(h,O),type:k,cId:this.request.correlationId})}else if(T==="rename"||O!==s){const k=setTimeout(async()=>{const P=await E.Promises.exists(g);l.token.isCancellationRequested||(P?(this.onFileChange({resource:h,type:a.FileChangeType.UPDATED,cId:this.request.correlationId},!0),n.add(await this.doWatch(g,!1))):this.onWatchedPathDeleted(h))},m.FILE_DELETE_HANDLER_DELAY);n.clear(),n.add((0,R.toDisposable)(()=>clearTimeout(k)))}else this.onFileChange({resource:h,type:a.FileChangeType.UPDATED,cId:this.request.correlationId},!0)})}catch(h){l.token.isCancellationRequested||this.error(`Failed to watch ${g} for changes using fs.watch() (${h.toString()})`),this.notifyWatchFailed()}}onWatchedPathDeleted(g){this.warn("Watcher shutdown because watched path got deleted"),this.onFileChange({resource:g,type:a.FileChangeType.DELETED,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.notifyWatchFailed()}onFileChange(g,v=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.traceWithCorrelation(`${g.type===a.FileChangeType.ADDED?"[ADDED]":g.type===a.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${g.resource.fsPath}`),!v&&this.excludes.some(t=>t(g.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (excluded) ${g.resource.fsPath}`):!v&&this.includes&&this.includes.length>0&&!this.includes.some(t=>t(g.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (not included) ${g.resource.fsPath}`):this.fileChangesAggregator.work(g))}handleFileChanges(g){const v=(0,f.coalesceEvents)(g),t=[];for(const n of v){if((0,f.isFiltered)(n,this.filter)){this.verboseLogging&&this.traceWithCorrelation(` >> ignored (filtered) ${n.resource.fsPath}`);continue}t.push(n)}if(t.length===0)return;if(this.verboseLogging)for(const n of t)this.traceWithCorrelation(` >> normalized ${n.type===a.FileChangeType.ADDED?"[ADDED]":n.type===a.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`);this.throttledFileChangesEmitter.work(t)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async existsChildStrictCase(g){if(o.isLinux)return E.Promises.exists(g);try{const v=(0,b.basename)(g);return(await E.Promises.readdir((0,b.dirname)(g))).some(l=>l===v)}catch(v){return this.trace(v),!1}}setVerboseLogging(g){this.verboseLogging=g}error(g){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${g}`})}warn(g){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${g}`})}trace(g){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${g}`})}traceWithCorrelation(g){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.trace(`${g}${typeof this.request.correlationId=="number"?` <${this.request.correlationId}> `:""}`)}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=m;async function p(S,g,v,t,l=512){const n=await E.Promises.open(S,"r"),h=Buffer.allocUnsafe(l),s=new w.CancellationTokenSource(t);let c,u=!1;const I={path:S,excludes:[],recursive:!1},T=new m(I,void 0,A=>{(async()=>{for(const{type:O}of A)if(O===a.FileChangeType.UPDATED){if(u)return;u=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:k}=await E.Promises.read(n,h,0,l,null);if(!k||s.token.isCancellationRequested)break;g(h.slice(0,k))}}catch(k){c=new Error(k),s.dispose(!0)}finally{u=!1}}})()});return await T.ready,v(),new Promise((A,O)=>{s.token.onCancellationRequested(async()=>{T.dispose();try{await E.Promises.close(n)}catch(k){c=new Error(k)}c?O(c):A()})})}}),define(ye[254],Ie([1,0,6,86,252,3,253,37]),function(se,e,i,r,w,C,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class b extends w.BaseWatcher{constructor(D){super(),this.recursiveWatcher=D,this.onDidError=i.Event.None,this.watchers=new Set}async doWatch(D){D=this.removeDuplicateRequests(D);const y=[],d=new Set(Array.from(this.watchers));for(const E of D){const a=this.findWatcher(E);a&&(0,r.patternsEquals)(a.request.excludes,E.excludes)&&(0,r.patternsEquals)(a.request.includes,E.includes)?d.delete(a):y.push(E)}y.length&&this.trace(`Request to start watching: ${y.map(E=>this.requestToString(E)).join(",")}`),d.size&&this.trace(`Request to stop watching: ${Array.from(d).map(E=>this.requestToString(E.request)).join(",")}`);for(const E of d)this.stopWatching(E);for(const E of y)this.startWatching(E)}findWatcher(D){for(const y of this.watchers)if(typeof D.correlationId=="number"||typeof y.request.correlationId=="number"){if(y.request.correlationId===D.correlationId)return y}else if((0,_.isEqual)(y.request.path,D.path,!C.isLinux))return y}startWatching(D){const y=new R.NodeJSFileWatcherLibrary(D,this.recursiveWatcher,E=>this._onDidChangeFile.fire(E),()=>this._onDidWatchFail.fire(D),E=>this._onDidLogMessage.fire(E),this.verboseLogging),d={request:D,instance:y};this.watchers.add(d)}async stop(){await super.stop();for(const D of this.watchers)this.stopWatching(D)}stopWatching(D){this.trace("stopping file watcher",D),this.watchers.delete(D),D.instance.dispose()}removeDuplicateRequests(D){const y=new Map;for(const d of D){const E=C.isLinux?d.path:d.path.toLowerCase();let a=y.get(d.correlationId);a||(a=new Map,y.set(d.correlationId,a)),a.has(E)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(d)}`),a.set(E,d)}return Array.from(y.values()).map(d=>Array.from(d.values())).flat()}async setVerboseLogging(D){super.setVerboseLogging(D);for(const y of this.watchers)y.instance.setVerboseLogging(D)}trace(D,y){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(D,y)})}warn(D){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(D)})}toMessage(D,y){return y?`[File Watcher (node.js)] ${D} (${this.requestToString(y.request)})`:`[File Watcher (node.js)] ${D}`}}e.NodeJSWatcher=b}),define(ye[255],Ie([1,0,52,254]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class w extends i.AbstractNonRecursiveWatcherClient{constructor(R,_,b){super(R,_,b),this.init()}createWatcher(R){return R.add(new r.NodeJSWatcher(void 0))}}e.NodeJSWatcherClient=w}),define(ye[256],Ie([1,0,13,51,117,52]),function(se,e,i,r,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class R extends C.AbstractUniversalWatcherClient{constructor(b,o,D){super(b,o,D),this.init()}createWatcher(b){const o=b.add(new w.Client(i.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(o.onDidProcessExit(({code:D,signal:y})=>this.onError(`terminated by itself with code ${D}, signal: ${y} (ETERM)`))),r.ProxyChannel.toService((0,r.getNextTickChannel)(o.getChannel("watcher")))}}e.UniversalWatcherClient=R}),define(ye[89],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class i{constructor(...w){this._entries=new Map;for(const[C,R]of w)this.set(C,R)}set(w,C){const R=this._entries.get(w);return this._entries.set(w,C),R}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}e.ServiceCollection=i}),define(ye[122],Ie([1,0,14,10,2,71,247,5,89,80]),function(se,e,i,r,w,C,R,_,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const D=!1;class y extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class d{constructor(m=new b.ServiceCollection,p=!1,S,g=D){this._services=m,this._strict=p,this._parent=S,this._enableTracing=g,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(_.IInstantiationService,this),this._globalGraph=g?S?._globalGraph??new R.Graph(v=>v):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,w.dispose)(this._children),this._children.clear();for(const m of this._servicesToMaybeDispose)(0,w.isDisposable)(m)&&m.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(m,p){this._throwIfDisposed();const S=this,g=new class extends d{dispose(){S._children.delete(g),super.dispose()}}(m,this._strict,this,this._enableTracing);return this._children.add(g),p?.add(g),g}invokeFunction(m,...p){this._throwIfDisposed();const S=a.traceInvocation(this._enableTracing,m);let g=!1;try{return m({get:t=>{if(g)throw(0,r.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(t,S);if(!l)throw new Error(`[invokeFunction] unknown service '${t}'`);return l}},...p)}finally{g=!0,S.stop()}}createInstance(m,...p){this._throwIfDisposed();let S,g;return m instanceof C.SyncDescriptor?(S=a.traceCreation(this._enableTracing,m.ctor),g=this._createInstance(m.ctor,m.staticArguments.concat(p),S)):(S=a.traceCreation(this._enableTracing,m),g=this._createInstance(m,p,S)),S.stop(),g}_createInstance(m,p=[],S){const g=_._util.getServiceDependencies(m).sort((l,n)=>l.index-n.index),v=[];for(const l of g){const n=this._getOrCreateServiceInstance(l.id,S);n||this._throwIfStrict(`[createInstance] ${m.name} depends on UNKNOWN service ${l.id}.`,!1),v.push(n)}const t=g.length>0?g[0].index:p.length;if(p.length!==t){console.trace(`[createInstance] First service dependency of ${m.name} at position ${t+1} conflicts with ${p.length} static arguments`);const l=t-p.length;l>0?p=p.concat(new Array(l)):p=p.slice(0,t)}return Reflect.construct(m,p.concat(v))}_setCreatedServiceInstance(m,p){if(this._services.get(m)instanceof C.SyncDescriptor)this._services.set(m,p);else if(this._parent)this._parent._setCreatedServiceInstance(m,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(m){const p=this._services.get(m);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(m):p}_getOrCreateServiceInstance(m,p){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(m));const S=this._getServiceInstanceOrDescriptor(m);return S instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(m,S,p.branch(m,!0)):(p.branch(m,!1),S)}_safeCreateAndCacheServiceInstance(m,p,S){if(this._activeInstantiations.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this._activeInstantiations.add(m);try{return this._createAndCacheServiceInstance(m,p,S)}finally{this._activeInstantiations.delete(m)}}_createAndCacheServiceInstance(m,p,S){const g=new R.Graph(l=>l.id.toString());let v=0;const t=[{id:m,desc:p,_trace:S}];for(;t.length;){const l=t.pop();if(g.lookupOrInsertNode(l),v++>1e3)throw new y(g);for(const n of _._util.getServiceDependencies(l.desc.ctor)){const h=this._getServiceInstanceOrDescriptor(n.id);if(h||this._throwIfStrict(`[createInstance] ${m} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(l.id),String(n.id)),h instanceof C.SyncDescriptor){const s={id:n.id,desc:h,_trace:l._trace.branch(n.id,!0)};g.insertEdge(l,s),t.push(s)}}}for(;;){const l=g.roots();if(l.length===0){if(!g.isEmpty())throw new y(g);break}for(const{data:n}of l){if(this._getServiceInstanceOrDescriptor(n.id)instanceof C.SyncDescriptor){const s=this._createServiceInstanceWithOwner(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this._setCreatedServiceInstance(n.id,s)}g.removeNode(n)}}return this._getServiceInstanceOrDescriptor(m)}_createServiceInstanceWithOwner(m,p,S=[],g,v){if(this._services.get(m)instanceof C.SyncDescriptor)return this._createServiceInstance(m,p,S,g,v,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(m,p,S,g,v);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(m,p,S=[],g,v,t){if(g){const l=new d(void 0,this._strict,this,this._enableTracing);l._globalGraphImplicitDependency=String(m);const n=new Map,h=new i.GlobalIdleValue(()=>{const s=l._createInstance(p,S,v);for(const[c,u]of n){const I=s[c];if(typeof I=="function")for(const T of u)T.disposable=I.apply(s,T.listener)}return n.clear(),t.add(s),s});return new Proxy(Object.create(null),{get(s,c){if(!h.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let T=n.get(c);return T||(T=new o.LinkedList,n.set(c,T)),(O,k,P)=>{if(h.isInitialized)return h.value[c](O,k,P);{const B={listener:[O,k,P],disposable:void 0},Y=T.push(B);return(0,w.toDisposable)(()=>{Y(),B.disposable?.dispose()})}}}if(c in s)return s[c];const u=h.value;let I=u[c];return typeof I!="function"||(I=I.bind(u),s[c]=I),I},set(s,c,u){return h.value[c]=u,!0},getPrototypeOf(s){return p.prototype}})}else{const l=this._createInstance(p,S,v);return t.add(l),l}}_throwIfStrict(m,p){if(p&&console.warn(m),this._strict)throw new Error(m)}}e.InstantiationService=d;var E;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(E||(E={}));class a{static{this.all=new Set}static{this._None=new class extends a{constructor(){super(E.None,null)}stop(){}branch(){return this}}}static traceInvocation(m,p){return m?new a(E.Invocation,p.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):a._None}static traceCreation(m,p){return m?new a(E.Creation,p.name):a._None}static{this._totals=0}constructor(m,p){this.type=m,this.name=p,this._start=Date.now(),this._dep=[]}branch(m,p){const S=new a(E.Branch,m.toString());return this._dep.push([m,p,S]),S}stop(){const m=Date.now()-this._start;a._totals+=m;let p=!1;function S(v,t){const l=[],n=new Array(v+1).join("	");for(const[h,s,c]of t._dep)if(s&&c){p=!0,l.push(`${n}CREATES -> ${h}`);const u=S(v+1,c);u&&l.push(u)}else l.push(`${n}uses -> ${h}`);return l.join(`
`)}const g=[`${this.type===E.Creation?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${a._totals.toFixed(2)}ms)`];(m>2||p)&&a.all.add(g.join(`
`))}}e.Trace=a}),define(ye[257],Ie([1,0,5]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.ILabelService=void 0,e.ILabelService=(0,i.createDecorator)("labelService");var r;(function(w){w[w.SHORT=0]="SHORT",w[w.MEDIUM=1]="MEDIUM",w[w.LONG=2]="LONG"})(r||(e.Verbosity=r={}))}),define(ye[12],Ie([1,0,220,45,6,66,2,26,3,20,11,4,42,5]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=f,e.log=p,e.getLogLevel=I,e.LogLevelToString=T,e.LogLevelToLocalizedString=A,e.parseLogLevel=O,i=Be(i),e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function a(){return new Date().toISOString()}function f(k){return(0,D.isNumber)(k)}var m;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(m||(e.LogLevel=m={})),e.DEFAULT_LOG_LEVEL=m.Info;function p(k,P,B){switch(P){case m.Trace:k.trace(B);break;case m.Debug:k.debug(B);break;case m.Info:k.info(B);break;case m.Warning:k.warn(B);break;case m.Error:k.error(B);break;case m.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function S(k,P=!1){let B="";for(let Y=0;Y<k.length;Y++){let X=k[Y];if(X instanceof Error&&(X=(0,r.toErrorMessage)(X,P)),typeof X=="object")try{X=JSON.stringify(X)}catch{}B+=(Y>0?" ":"")+X}return B}class g extends R.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new w.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(P){this.level!==P&&(this.level=P,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(P){return this.level!==m.Off&&this.level<=P}}e.AbstractLogger=g;class v extends g{constructor(P){super(),this.logAlways=P}checkLogLevel(P){return this.logAlways||super.checkLogLevel(P)}trace(P,...B){this.checkLogLevel(m.Trace)&&this.log(m.Trace,S([P,...B],!0))}debug(P,...B){this.checkLogLevel(m.Debug)&&this.log(m.Debug,S([P,...B]))}info(P,...B){this.checkLogLevel(m.Info)&&this.log(m.Info,S([P,...B]))}warn(P,...B){this.checkLogLevel(m.Warning)&&this.log(m.Warning,S([P,...B]))}error(P,...B){if(this.checkLogLevel(m.Error))if(P instanceof Error){const Y=Array.prototype.slice.call(arguments);Y[0]=P.stack,this.log(m.Error,S(Y))}else this.log(m.Error,S([P,...B]))}flush(){}}e.AbstractMessageLogger=v;class t extends g{constructor(P=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(P),this.useColors=!b.isWindows}trace(P,...B){this.checkLogLevel(m.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,P,...B):console.log(`[main ${a()}]`,P,...B))}debug(P,...B){this.checkLogLevel(m.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,P,...B):console.log(`[main ${a()}]`,P,...B))}info(P,...B){this.checkLogLevel(m.Info)&&(this.useColors?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,P,...B):console.log(`[main ${a()}]`,P,...B))}warn(P,...B){this.checkLogLevel(m.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${a()}]\x1B[0m`,P,...B):console.warn(`[main ${a()}]`,P,...B))}error(P,...B){this.checkLogLevel(m.Error)&&(this.useColors?console.error(`\x1B[91m[main ${a()}]\x1B[0m`,P,...B):console.error(`[main ${a()}]`,P,...B))}flush(){}}e.ConsoleMainLogger=t;class l extends g{constructor(P=e.DEFAULT_LOG_LEVEL,B=!0){super(),this.useColors=B,this.setLevel(P)}trace(P,...B){this.checkLogLevel(m.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",P,...B):console.log(P,...B))}debug(P,...B){this.checkLogLevel(m.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",P,...B):console.log(P,...B))}info(P,...B){this.checkLogLevel(m.Info)&&(this.useColors?console.log("%c INFO","color: #33f",P,...B):console.log(P,...B))}warn(P,...B){this.checkLogLevel(m.Warning)&&(this.useColors?console.log("%c WARN","color: #993",P,...B):console.log(P,...B))}error(P,...B){this.checkLogLevel(m.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",P,...B):console.error(P,...B))}flush(){}}e.ConsoleLogger=l;class n extends g{constructor(P,B=e.DEFAULT_LOG_LEVEL){super(),this.adapter=P,this.setLevel(B)}trace(P,...B){this.checkLogLevel(m.Trace)&&this.adapter.log(m.Trace,[this.extractMessage(P),...B])}debug(P,...B){this.checkLogLevel(m.Debug)&&this.adapter.log(m.Debug,[this.extractMessage(P),...B])}info(P,...B){this.checkLogLevel(m.Info)&&this.adapter.log(m.Info,[this.extractMessage(P),...B])}warn(P,...B){this.checkLogLevel(m.Warning)&&this.adapter.log(m.Warning,[this.extractMessage(P),...B])}error(P,...B){this.checkLogLevel(m.Error)&&this.adapter.log(m.Error,[this.extractMessage(P),...B])}extractMessage(P){return typeof P=="string"?P:(0,r.toErrorMessage)(P,this.checkLogLevel(m.Trace))}flush(){}}e.AdapterLogger=n;class h extends g{constructor(P){super(),this.loggers=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const B of this.loggers)B.setLevel(P);super.setLevel(P)}trace(P,...B){for(const Y of this.loggers)Y.trace(P,...B)}debug(P,...B){for(const Y of this.loggers)Y.debug(P,...B)}info(P,...B){for(const Y of this.loggers)Y.info(P,...B)}warn(P,...B){for(const Y of this.loggers)Y.warn(P,...B)}error(P,...B){for(const Y of this.loggers)Y.error(P,...B)}flush(){for(const P of this.loggers)P.flush()}dispose(){for(const P of this.loggers)P.dispose();super.dispose()}}e.MultiplexLogger=h;class s extends R.Disposable{constructor(P,B,Y){if(super(),this.logLevel=P,this.logsHome=B,this._loggers=new _.ResourceMap,this._onDidChangeLoggers=this._register(new w.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new w.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new w.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,Y)for(const X of Y)this._loggers.set(X.resource,{logger:void 0,info:X})}getLoggerEntry(P){return(0,D.isString)(P)?[...this._loggers.values()].find(B=>B.info.id===P):this._loggers.get(P)}getLogger(P){return this.getLoggerEntry(P)?.logger}createLogger(P,B){const Y=this.toResource(P),X=(0,D.isString)(P)?P:B?.id??(0,C.hash)(Y.toString()).toString(16);let re=this._loggers.get(Y)?.logger;const te=B?.logLevel==="always"?m.Trace:B?.logLevel;re||(re=this.doCreateLogger(Y,te??this.getLogLevel(Y)??this.logLevel,{...B,id:X}));const Z={logger:re,info:{resource:Y,id:X,logLevel:te,name:B?.name,hidden:B?.hidden,extensionId:B?.extensionId,when:B?.when}};return this.registerLogger(Z.info),this._loggers.set(Y,Z),re}toResource(P){return(0,D.isString)(P)?(0,o.joinPath)(this.logsHome,`${P}.log`):P}setLogLevel(P,B){if(y.URI.isUri(P)){const Y=P,X=B,re=this._loggers.get(Y);re&&X!==re.info.logLevel&&(re.info.logLevel=X===this.logLevel?void 0:X,re.logger?.setLevel(X),this._loggers.set(re.info.resource,re),this._onDidChangeLogLevel.fire([Y,X]))}else{this.logLevel=P;for(const[Y,X]of this._loggers.entries())this._loggers.get(Y)?.info.logLevel===void 0&&X.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(P,B){const Y=this.getLoggerEntry(P);Y&&B!==!Y.info.hidden&&(Y.info.hidden=!B,this._loggers.set(Y.info.resource,Y),this._onDidChangeVisibility.fire([Y.info.resource,B]))}getLogLevel(P){let B;return P&&(B=this._loggers.get(P)?.info.logLevel),B??this.logLevel}registerLogger(P){const B=this._loggers.get(P.resource);B?B.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this._loggers.set(P.resource,{info:P,logger:void 0}),this._onDidChangeLoggers.fire({added:[P],removed:[]}))}deregisterLogger(P){const B=this._loggers.get(P);B&&(B.logger&&B.logger.dispose(),this._loggers.delete(P),this._onDidChangeLoggers.fire({added:[],removed:[B.info]}))}*getRegisteredLoggers(){for(const P of this._loggers.values())yield P.info}getRegisteredLogger(P){return this._loggers.get(P)?.info}dispose(){this._loggers.forEach(P=>P.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=s;class c{constructor(){this.onDidChangeLogLevel=new w.Emitter().event}setLevel(P){}getLevel(){return m.Info}trace(P,...B){}debug(P,...B){}info(P,...B){}warn(P,...B){}error(P,...B){}critical(P,...B){}dispose(){}flush(){}}e.NullLogger=c;class u extends c{}e.NullLogService=u;function I(k){if(k.verbose)return m.Trace;if(typeof k.logLevel=="string"){const P=O(k.logLevel.toLowerCase());if(P!==void 0)return P}return e.DEFAULT_LOG_LEVEL}function T(k){switch(k){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function A(k){switch(k){case m.Trace:return{original:"Trace",value:i.localize(0,null)};case m.Debug:return{original:"Debug",value:i.localize(1,null)};case m.Info:return{original:"Info",value:i.localize(2,null)};case m.Warning:return{original:"Warning",value:i.localize(3,null)};case m.Error:return{original:"Error",value:i.localize(4,null)};case m.Off:return{original:"Off",value:i.localize(5,null)}}}function O(k){switch(k){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.CONTEXT_LOG_LEVEL=new d.RawContextKey("logLevel",T(m.Info))}),define(ye[258],Ie([1,0,18,14,10,6,37,2,9,52,12]),function(se,e,i,r,w,C,R,_,b,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class y extends _.Disposable{constructor(E,a){super(),this.logService=E,this.options=a,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalWatchRequests=[],this.universalWatchRequestDelayer=this._register(new r.ThrottledDelayer(0)),this.nonRecursiveWatchRequests=[],this.nonRecursiveWatchRequestDelayer=this._register(new r.ThrottledDelayer(0))}watch(E,a){return a.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(E,a):this.watchNonRecursive(E,a)}watchUniversal(E,a){const f={path:this.toWatchPath(E),excludes:a.excludes,includes:a.includes,recursive:a.recursive,filter:a.filter,correlationId:a.correlationId},m=(0,i.insert)(this.universalWatchRequests,f);return this.refreshUniversalWatchers(),(0,_.toDisposable)(()=>{m(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(E=>(0,w.onUnexpectedError)(E))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(a=>this._onDidChangeFile.fire((0,o.reviveFileChanges)(a)),a=>this.onWatcherLogMessage(a),this.logService.getLevel()===D.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===D.LogLevel.Trace)})));const E=this.options?.watcher?.recursive?.usePolling;if(E===!0)for(const a of this.universalWatchRequests)(0,o.isRecursiveWatchRequest)(a)&&(a.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(E))for(const a of this.universalWatchRequests)(0,o.isRecursiveWatchRequest)(a)&&E.includes(a.path)&&(a.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalWatchRequests)}watchNonRecursive(E,a){const f={path:this.toWatchPath(E),excludes:a.excludes,includes:a.includes,recursive:!1,filter:a.filter,correlationId:a.correlationId},m=(0,i.insert)(this.nonRecursiveWatchRequests,f);return this.refreshNonRecursiveWatchers(),(0,_.toDisposable)(()=>{m(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(E=>(0,w.onUnexpectedError)(E))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(E=>this._onDidChangeFile.fire((0,o.reviveFileChanges)(E)),E=>this.onWatcherLogMessage(E),this.logService.getLevel()===D.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===D.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursiveWatchRequests)}onWatcherLogMessage(E){E.type==="error"&&this._onDidWatchError.fire(E.message),this.logWatcherMessage(E)}logWatcherMessage(E){this.logService[E.type](E.message)}toFilePath(E){return(0,b.normalize)(E.fsPath)}toWatchPath(E){const a=this.toFilePath(E);return(0,R.removeTrailingPathSeparator)(a)}}e.AbstractDiskFileSystemProvider=y});var Me=this&&this.__param||function(se,e){return function(i,r){e(i,r,se)}};define(ye[123],Ie([1,0,18,14,15,19,6,66,40,2,67,13,44,20,56,215,16,121,12,10]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a,f,m,p,S,g){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let t=class extends o.Disposable{static{v=this}constructor(n){super(),this.logService=n,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new R.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new R.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new R.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new R.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new R.Emitter),this._onDidUncorrelatedFilesChange=this._register(new R.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new r.ResourceQueue)}registerProvider(n,h){if(this.provider.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${n}`);const s=new o.DisposableStore;return this.provider.set(n,h),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:n,provider:h}),s.add(h.onDidChangeFile(c=>{const u=new m.FileChangesEvent(c,!this.isPathCaseSensitive(h));this.internalOnDidFilesChange.fire(u),u.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(u)})),typeof h.onDidWatchError=="function"&&s.add(h.onDidWatchError(c=>this._onDidWatchError.fire(new Error(c)))),s.add(h.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:h,scheme:n}))),(0,o.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:n,provider:h}),this.provider.delete(n),(0,o.dispose)(s)})}getProvider(n){return this.provider.get(n)}async activateProvider(n){const h=[];this._onWillActivateFileSystemProvider.fire({scheme:n,join(s){h.push(s)}}),!this.provider.has(n)&&await r.Promises.settled(h)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.provider.has(n.scheme)}hasCapability(n,h){const s=this.provider.get(n.scheme);return!!(s&&s.capabilities&h)}listCapabilities(){return b.Iterable.map(this.provider,([n,h])=>({scheme:n,capabilities:h.capabilities}))}async withProvider(n){if(!(0,E.isAbsolutePath)(n))throw new m.FileOperationError((0,f.localize)(0,null,this.resourceForError(n)),m.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(n.scheme);const h=this.provider.get(n.scheme);if(!h){const s=new g.ErrorNoTelemetry;throw s.message=(0,f.localize)(1,null,n.toString()),s}return h}async withReadProvider(n){const h=await this.withProvider(n);if((0,m.hasOpenReadWriteCloseCapability)(h)||(0,m.hasReadWriteCapability)(h)||(0,m.hasFileReadStreamCapability)(h))return h;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(n){const h=await this.withProvider(n);if((0,m.hasOpenReadWriteCloseCapability)(h)||(0,m.hasReadWriteCapability)(h))return h;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,h){try{return await this.doResolveFile(n,h)}catch(s){throw(0,m.toFileSystemProviderErrorCode)(s)===m.FileSystemProviderErrorCode.FileNotFound?new m.FileOperationError((0,f.localize)(2,null,this.resourceForError(n)),m.FileOperationResult.FILE_NOT_FOUND):(0,m.ensureFileSystemProviderError)(s)}}async doResolveFile(n,h){const s=await this.withProvider(n),c=this.isPathCaseSensitive(s),u=h?.resolveTo,I=h?.resolveSingleChildDescendants,T=h?.resolveMetadata,A=await s.stat(n);let O;return this.toFileStat(s,n,A,void 0,!!T,(k,P)=>(O||(O=D.TernarySearchTree.forUris(()=>!c),O.set(n,!0),u&&O.fill(!0,u)),O.get(k.resource)||O.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&I?P===1:!1))}async toFileStat(n,h,s,c,u,I){const{providerExtUri:T}=this.getExtUri(n),A={resource:h,name:T.basename(h),isFile:(s.type&m.FileType.File)!==0,isDirectory:(s.type&m.FileType.Directory)!==0,isSymbolicLink:(s.type&m.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&m.FilePermission.Readonly)||!!(n.capabilities&m.FileSystemProviderCapabilities.Readonly),locked:!!((s.permissions??0)&m.FilePermission.Locked),etag:(0,m.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(A.isDirectory&&I(A,c)){try{const O=await n.readdir(h),k=await r.Promises.settled(O.map(async([P,B])=>{try{const Y=T.joinPath(h,P),X=u?await n.stat(Y):{type:B};return await this.toFileStat(n,Y,X,O.length,u,I)}catch(Y){return this.logService.trace(Y),null}}));A.children=(0,i.coalesce)(k)}catch(O){this.logService.trace(O),A.children=[]}return A}return A}async resolveAll(n){return r.Promises.settled(n.map(async h=>{try{return{stat:await this.doResolveFile(h.resource,h.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async stat(n){const h=await this.withProvider(n),s=await h.stat(n);return this.toFileStat(h,n,s,void 0,!0,()=>!1)}async exists(n){const h=await this.withProvider(n);try{return!!await h.stat(n)}catch{return!1}}async canCreateFile(n,h){try{await this.doValidateCreateFile(n,h)}catch(s){return s}return!0}async doValidateCreateFile(n,h){if(!h?.overwrite&&await this.exists(n))throw new m.FileOperationError((0,f.localize)(3,null,this.resourceForError(n)),m.FileOperationResult.FILE_MODIFIED_SINCE,h)}async createFile(n,h=w.VSBuffer.fromString(""),s){await this.doValidateCreateFile(n,s);const c=await this.writeFile(n,h);return this._onDidRunOperation.fire(new m.FileOperationEvent(n,m.FileOperation.CREATE,c)),c}async writeFile(n,h,s){const c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),{providerExtUri:u}=this.getExtUri(c);let I=s;if((0,m.hasFileAtomicWriteCapability)(c)&&!I?.atomic){const T=c.enforceAtomicWriteFile?.(n);T&&(I={...s,atomic:T})}try{await this.validateWriteFile(c,n,I)||await this.mkdirp(c,u.dirname(n));let A;if((0,m.hasReadWriteCapability)(c)&&!(h instanceof w.VSBuffer))if((0,a.isReadableStream)(h)){const O=await(0,a.peekStream)(h,3);O.ended?A=w.VSBuffer.concat(O.buffer):A=O}else A=(0,a.peekReadable)(h,O=>w.VSBuffer.concat(O),3);else A=h;!(0,m.hasOpenReadWriteCloseCapability)(c)||(0,m.hasReadWriteCapability)(c)&&A instanceof w.VSBuffer||(0,m.hasReadWriteCapability)(c)&&(0,m.hasFileAtomicWriteCapability)(c)&&I?.atomic?await this.doWriteUnbuffered(c,n,I,A):await this.doWriteBuffered(c,n,I,A instanceof w.VSBuffer?(0,w.bufferToReadable)(A):A),this._onDidRunOperation.fire(new m.FileOperationEvent(n,m.FileOperation.WRITE))}catch(T){throw new m.FileOperationError((0,f.localize)(4,null,this.resourceForError(n),(0,m.ensureFileSystemProviderError)(T).toString()),(0,m.toFileOperationResult)(T),I)}return this.resolve(n,{resolveMetadata:!0})}async validateWriteFile(n,h,s){const c=!!s?.unlock;if(c&&!(n.capabilities&m.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,f.localize)(5,null,this.resourceForError(h)));if(!!s?.atomic){if(!(n.capabilities&m.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,f.localize)(6,null,this.resourceForError(h)));if(!(n.capabilities&m.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,f.localize)(7,null,this.resourceForError(h)));if(c)throw new Error((0,f.localize)(8,null,this.resourceForError(h)))}let I;try{I=await n.stat(h)}catch{return}if(I.type&m.FileType.Directory)throw new m.FileOperationError((0,f.localize)(9,null,this.resourceForError(h)),m.FileOperationResult.FILE_IS_DIRECTORY,s);if(this.throwIfFileIsReadonly(h,I),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==m.ETAG_DISABLED&&typeof I.mtime=="number"&&typeof I.size=="number"&&s.mtime<I.mtime&&s.etag!==(0,m.etag)({mtime:s.mtime,size:I.size}))throw new m.FileOperationError((0,f.localize)(10,null),m.FileOperationResult.FILE_MODIFIED_SINCE,s);return I}async readFile(n,h,s){const c=await this.withReadProvider(n);return h?.atomic?this.doReadFileAtomic(c,n,h,s):this.doReadFile(c,n,h,s)}async doReadFileAtomic(n,h,s,c){return new Promise((u,I)=>{this.writeQueue.queueFor(h,async()=>{try{const T=await this.doReadFile(n,h,s,c);u(T)}catch(T){I(T)}},this.getExtUri(n).providerExtUri)})}async doReadFile(n,h,s,c){const u=await this.doReadFileStream(n,h,{...s,preferUnbuffered:!0},c);return{...u,value:await(0,w.streamToBuffer)(u.value)}}async readFileStream(n,h,s){const c=await this.withReadProvider(n);return this.doReadFileStream(c,n,h,s)}async doReadFileStream(n,h,s,c){const u=new C.CancellationTokenSource(c);let I=s;(0,m.hasFileAtomicReadCapability)(n)&&n.enforceAtomicReadFile?.(h)&&(I={...s,atomic:!0});const T=this.validateReadFile(h,I).then(O=>O,O=>{throw u.dispose(!0),O});let A;try{return typeof I?.etag=="string"&&I.etag!==m.ETAG_DISABLED&&await T,I?.atomic&&(0,m.hasFileAtomicReadCapability)(n)||!((0,m.hasOpenReadWriteCloseCapability)(n)||(0,m.hasFileReadStreamCapability)(n))||(0,m.hasReadWriteCapability)(n)&&I?.preferUnbuffered?A=this.readFileUnbuffered(n,h,I):(0,m.hasFileReadStreamCapability)(n)?A=this.readFileStreamed(n,h,u.token,I):A=this.readFileBuffered(n,h,u.token,I),A.on("end",()=>u.dispose()),A.on("error",()=>u.dispose()),{...await T,value:A}}catch(O){throw A&&await(0,a.consumeStream)(A),this.restoreReadError(O,h,I)}}restoreReadError(n,h,s){const c=(0,f.localize)(11,null,this.resourceForError(h),(0,m.ensureFileSystemProviderError)(n).toString());return n instanceof m.NotModifiedSinceFileOperationError?new m.NotModifiedSinceFileOperationError(c,n.stat,s):n instanceof m.TooLargeFileOperationError?new m.TooLargeFileOperationError(c,n.fileOperationResult,n.size,n.options):new m.FileOperationError(c,(0,m.toFileOperationResult)(n),s)}readFileStreamed(n,h,s,c=Object.create(null)){const u=n.readFileStream(h,c,s);return(0,a.transform)(u,{data:I=>I instanceof w.VSBuffer?I:w.VSBuffer.wrap(I),error:I=>this.restoreReadError(I,h,c)},I=>w.VSBuffer.concat(I))}readFileBuffered(n,h,s,c=Object.create(null)){const u=(0,w.newWriteableBufferStream)();return(0,p.readFileIntoStream)(n,h,u,I=>I,{...c,bufferSize:this.BUFFER_SIZE,errorTransformer:I=>this.restoreReadError(I,h,c)},s),u}readFileUnbuffered(n,h,s){const c=(0,a.newWriteableStream)(u=>w.VSBuffer.concat(u));return(async()=>{try{let u;s?.atomic&&(0,m.hasFileAtomicReadCapability)(n)?u=await n.readFile(h,{atomic:!0}):u=await n.readFile(h),typeof s?.position=="number"&&(u=u.slice(s.position)),typeof s?.length=="number"&&(u=u.slice(0,s.length)),this.validateReadFileLimits(h,u.byteLength,s),c.end(w.VSBuffer.wrap(u))}catch(u){c.error(u),c.end()}})(),c}async validateReadFile(n,h){const s=await this.resolve(n,{resolveMetadata:!0});if(s.isDirectory)throw new m.FileOperationError((0,f.localize)(12,null,this.resourceForError(n)),m.FileOperationResult.FILE_IS_DIRECTORY,h);if(typeof h?.etag=="string"&&h.etag!==m.ETAG_DISABLED&&h.etag===s.etag)throw new m.NotModifiedSinceFileOperationError((0,f.localize)(13,null),s,h);return this.validateReadFileLimits(n,s.size,h),s}validateReadFileLimits(n,h,s){if(typeof s?.limits?.size=="number"&&h>s.limits.size)throw new m.TooLargeFileOperationError((0,f.localize)(14,null,this.resourceForError(n)),m.FileOperationResult.FILE_TOO_LARGE,h,s)}async canMove(n,h,s){return this.doCanMoveCopy(n,h,"move",s)}async canCopy(n,h,s){return this.doCanMoveCopy(n,h,"copy",s)}async doCanMoveCopy(n,h,s,c){if(n.toString()!==h.toString())try{const u=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n):await this.withReadProvider(n),I=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(h),h);await this.doValidateMoveCopy(u,n,I,h,s,c)}catch(u){return u}return!0}async move(n,h,s){const c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(h),h),I=await this.doMoveCopy(c,n,u,h,"move",!!s),T=await this.resolve(h,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(n,I==="move"?m.FileOperation.MOVE:m.FileOperation.COPY,T)),T}async copy(n,h,s){const c=await this.withReadProvider(n),u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(h),h),I=await this.doMoveCopy(c,n,u,h,"copy",!!s),T=await this.resolve(h,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(n,I==="copy"?m.FileOperation.COPY:m.FileOperation.MOVE,T)),T}async doMoveCopy(n,h,s,c,u,I){if(h.toString()===c.toString())return u;const{exists:T,isSameResourceWithDifferentPathCase:A}=await this.doValidateMoveCopy(n,h,s,c,u,I);if(T&&!A&&I&&await this.del(c,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(c)),u==="copy"){if(n===s&&(0,m.hasFileFolderCopyCapability)(n))await n.copy(h,c,{overwrite:I});else{const O=await this.resolve(h);O.isDirectory?await this.doCopyFolder(n,O,s,c):await this.doCopyFile(n,h,s,c)}return u}else return n===s?(await n.rename(h,c,{overwrite:I}),u):(await this.doMoveCopy(n,h,s,c,"copy",I),await this.del(h,{recursive:!0}),"copy")}async doCopyFile(n,h,s,c){if((0,m.hasOpenReadWriteCloseCapability)(n)&&(0,m.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(n,h,s,c);if((0,m.hasOpenReadWriteCloseCapability)(n)&&(0,m.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(n,h,s,c);if((0,m.hasReadWriteCapability)(n)&&(0,m.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(n,h,s,c);if((0,m.hasReadWriteCapability)(n)&&(0,m.hasReadWriteCapability)(s))return this.doPipeUnbuffered(n,h,s,c)}async doCopyFolder(n,h,s,c){await s.mkdir(c),Array.isArray(h.children)&&await r.Promises.settled(h.children.map(async u=>{const I=this.getExtUri(s).providerExtUri.joinPath(c,u.name);return u.isDirectory?this.doCopyFolder(n,await this.resolve(u.resource),s,I):this.doCopyFile(n,u.resource,s,I)}))}async doValidateMoveCopy(n,h,s,c,u,I){let T=!1;if(n===s){const{providerExtUri:O,isPathCaseSensitive:k}=this.getExtUri(n);if(k||(T=O.isEqual(h,c)),T&&u==="copy")throw new Error((0,f.localize)(15,null,this.resourceForError(h),this.resourceForError(c)));if(!T&&O.isEqualOrParent(c,h))throw new Error((0,f.localize)(16,null,this.resourceForError(h),this.resourceForError(c)))}const A=await this.exists(c);if(A&&!T){if(!I)throw new m.FileOperationError((0,f.localize)(17,null,this.resourceForError(h),this.resourceForError(c)),m.FileOperationResult.FILE_MOVE_CONFLICT);if(n===s){const{providerExtUri:O}=this.getExtUri(n);if(O.isEqualOrParent(h,c))throw new Error((0,f.localize)(18,null,this.resourceForError(h),this.resourceForError(c)))}}return{exists:A,isSameResourceWithDifferentPathCase:T}}getExtUri(n){const h=this.isPathCaseSensitive(n);return{providerExtUri:h?E.extUri:E.extUriIgnorePathCase,isPathCaseSensitive:h}}isPathCaseSensitive(n){return!!(n.capabilities&m.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(n){const h=this.throwIfFileSystemIsReadonly(await this.withProvider(n),n);await this.mkdirp(h,n);const s=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(n,m.FileOperation.CREATE,s)),s}async mkdirp(n,h){const s=[],{providerExtUri:c}=this.getExtUri(n);for(;!c.isEqual(h,c.dirname(h));)try{if(!((await n.stat(h)).type&m.FileType.Directory))throw new Error((0,f.localize)(19,null,this.resourceForError(h)));break}catch(u){if((0,m.toFileSystemProviderErrorCode)(u)!==m.FileSystemProviderErrorCode.FileNotFound)throw u;s.push(c.basename(h)),h=c.dirname(h)}for(let u=s.length-1;u>=0;u--){h=c.joinPath(h,s[u]);try{await n.mkdir(h)}catch(I){if((0,m.toFileSystemProviderErrorCode)(I)!==m.FileSystemProviderErrorCode.FileExists)throw I}}}async canDelete(n,h){try{await this.doValidateDelete(n,h)}catch(s){return s}return!0}async doValidateDelete(n,h){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(n),n),c=!!h?.useTrash;if(c&&!(s.capabilities&m.FileSystemProviderCapabilities.Trash))throw new Error((0,f.localize)(20,null,this.resourceForError(n)));const u=h?.atomic;if(u&&!(s.capabilities&m.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,f.localize)(21,null,this.resourceForError(n)));if(c&&u)throw new Error((0,f.localize)(22,null,this.resourceForError(n)));let I;try{I=await s.stat(n)}catch{}if(I)this.throwIfFileIsReadonly(n,I);else throw new m.FileOperationError((0,f.localize)(23,null,this.resourceForError(n)),m.FileOperationResult.FILE_NOT_FOUND);if(!!!h?.recursive){const A=await this.resolve(n);if(A.isDirectory&&Array.isArray(A.children)&&A.children.length>0)throw new Error((0,f.localize)(24,null,this.resourceForError(n)))}return s}async del(n,h){const s=await this.doValidateDelete(n,h);let c=h;if((0,m.hasFileAtomicDeleteCapability)(s)&&!c?.atomic){const A=s.enforceAtomicDelete?.(n);A&&(c={...h,atomic:A})}const u=!!c?.useTrash,I=!!c?.recursive,T=c?.atomic??!1;await s.delete(n,{recursive:I,useTrash:u,atomic:T}),this._onDidRunOperation.fire(new m.FileOperationEvent(n,m.FileOperation.DELETE))}async cloneFile(n,h){const s=await this.withProvider(n),c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(h),h);if(!(s===c&&this.getExtUri(s).providerExtUri.isEqual(n,h)))return s===c&&(0,m.hasFileCloneCapability)(s)?s.cloneFile(n,h):(await this.mkdirp(c,this.getExtUri(c).providerExtUri.dirname(h)),s===c&&(0,m.hasFileFolderCopyCapability)(s)?this.writeQueue.queueFor(n,()=>s.copy(n,h,{overwrite:!0}),this.getExtUri(s).providerExtUri):this.writeQueue.queueFor(n,()=>this.doCopyFile(s,n,c,h),this.getExtUri(s).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(n,h){return this.watch(n,{...h,correlationId:v.WATCHER_CORRELATION_IDS++})}watch(n,h={recursive:!1,excludes:[]}){const s=new o.DisposableStore;let c=!1,u=()=>{c=!0};s.add((0,o.toDisposable)(()=>u())),(async()=>{try{const T=await this.doWatch(n,h);c?(0,o.dispose)(T):u=()=>(0,o.dispose)(T)}catch(T){this.logService.error(T)}})();const I=h.correlationId;if(typeof I=="number"){const T=s.add(new R.Emitter);return s.add(this.internalOnDidFilesChange.event(O=>{O.correlates(I)&&T.fire(O)})),{onDidChange:T.event,dispose:()=>s.dispose()}}return s}async doWatch(n,h){const s=await this.withProvider(n),c=(0,_.hash)([this.getExtUri(s).providerExtUri.getComparisonKey(n),h]);let u=this.activeWatchers.get(c);return u||(u={count:0,disposable:s.watch(n,h)},this.activeWatchers.set(c,u)),u.count+=1,(0,o.toDisposable)(()=>{u&&(u.count--,u.count===0&&((0,o.dispose)(u.disposable),this.activeWatchers.delete(c)))})}dispose(){super.dispose();for(const[,n]of this.activeWatchers)(0,o.dispose)(n.disposable);this.activeWatchers.clear()}async doWriteBuffered(n,h,s,c){return this.writeQueue.queueFor(h,async()=>{const u=await n.open(h,{create:!0,unlock:s?.unlock??!1});try{(0,a.isReadableStream)(c)||(0,a.isReadableBufferedStream)(c)?await this.doWriteStreamBufferedQueued(n,u,c):await this.doWriteReadableBufferedQueued(n,u,c)}catch(I){throw(0,m.ensureFileSystemProviderError)(I)}finally{await n.close(u)}},this.getExtUri(n).providerExtUri)}async doWriteStreamBufferedQueued(n,h,s){let c=0,u;if((0,a.isReadableBufferedStream)(s)){if(s.buffer.length>0){const I=w.VSBuffer.concat(s.buffer);await this.doWriteBuffer(n,h,I,I.byteLength,c,0),c+=I.byteLength}if(s.ended)return;u=s.stream}else u=s;return new Promise((I,T)=>{(0,a.listenStream)(u,{onData:async A=>{u.pause();try{await this.doWriteBuffer(n,h,A,A.byteLength,c,0)}catch(O){return T(O)}c+=A.byteLength,setTimeout(()=>u.resume())},onError:A=>T(A),onEnd:()=>I()})})}async doWriteReadableBufferedQueued(n,h,s){let c=0,u;for(;(u=s.read())!==null;)await this.doWriteBuffer(n,h,u,u.byteLength,c,0),c+=u.byteLength}async doWriteBuffer(n,h,s,c,u,I){let T=0;for(;T<c;){const A=await n.write(h,u+T,s.buffer,I+T,c-T);T+=A}}async doWriteUnbuffered(n,h,s,c){return this.writeQueue.queueFor(h,()=>this.doWriteUnbufferedQueued(n,h,s,c),this.getExtUri(n).providerExtUri)}async doWriteUnbufferedQueued(n,h,s,c){let u;c instanceof w.VSBuffer?u=c:(0,a.isReadableStream)(c)?u=await(0,w.streamToBuffer)(c):(0,a.isReadableBufferedStream)(c)?u=await(0,w.bufferedStreamToBuffer)(c):u=(0,w.readableToBuffer)(c),await n.writeFile(h,u.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async doPipeBuffered(n,h,s,c){return this.writeQueue.queueFor(c,()=>this.doPipeBufferedQueued(n,h,s,c),this.getExtUri(s).providerExtUri)}async doPipeBufferedQueued(n,h,s,c){let u,I;try{u=await n.open(h,{create:!1}),I=await s.open(c,{create:!0,unlock:!1});const T=w.VSBuffer.alloc(this.BUFFER_SIZE);let A=0,O=0,k=0;do k=await n.read(u,A,T.buffer,O,T.byteLength-O),await this.doWriteBuffer(s,I,T,k,A,O),A+=k,O+=k,O===T.byteLength&&(O=0);while(k>0)}catch(T){throw(0,m.ensureFileSystemProviderError)(T)}finally{await r.Promises.settled([typeof u=="number"?n.close(u):Promise.resolve(),typeof I=="number"?s.close(I):Promise.resolve()])}}async doPipeUnbuffered(n,h,s,c){return this.writeQueue.queueFor(c,()=>this.doPipeUnbufferedQueued(n,h,s,c),this.getExtUri(s).providerExtUri)}async doPipeUnbufferedQueued(n,h,s,c){return s.writeFile(c,await n.readFile(h),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(n,h,s,c){return this.writeQueue.queueFor(c,()=>this.doPipeUnbufferedToBufferedQueued(n,h,s,c),this.getExtUri(s).providerExtUri)}async doPipeUnbufferedToBufferedQueued(n,h,s,c){const u=await s.open(c,{create:!0,unlock:!1});try{const I=await n.readFile(h);await this.doWriteBuffer(s,u,w.VSBuffer.wrap(I),I.byteLength,0,0)}catch(I){throw(0,m.ensureFileSystemProviderError)(I)}finally{await s.close(u)}}async doPipeBufferedToUnbuffered(n,h,s,c){const u=await(0,w.streamToBuffer)(this.readFileBuffered(n,h,C.CancellationToken.None));await this.doWriteUnbuffered(s,c,void 0,u)}throwIfFileSystemIsReadonly(n,h){if(n.capabilities&m.FileSystemProviderCapabilities.Readonly)throw new m.FileOperationError((0,f.localize)(25,null,this.resourceForError(h)),m.FileOperationResult.FILE_PERMISSION_DENIED);return n}throwIfFileIsReadonly(n,h){if((h.permissions??0)&m.FilePermission.Readonly)throw new m.FileOperationError((0,f.localize)(26,null,this.resourceForError(n)),m.FileOperationResult.FILE_PERMISSION_DENIED)}resourceForError(n){return n.scheme===y.Schemas.file?n.fsPath:n.toString(!0)}};e.FileService=t,e.FileService=t=v=ze([Me(0,S.ILogService)],t)}),define(ye[72],Ie([1,0,14,26,15,6,37,2,9,3,20,56,25,218,16,121,258,256,255]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a,f,m,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class g extends m.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(t,l){super(t,l),this.onDidChangeCapabilities=C.Event.None,this.resourceLocks=new r.ResourceMap(n=>D.extUriBiasedIgnorePathCase.getComparisonKey(n)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=a.FileSystemProviderCapabilities.FileReadWrite|a.FileSystemProviderCapabilities.FileOpenReadWriteClose|a.FileSystemProviderCapabilities.FileReadStream|a.FileSystemProviderCapabilities.FileFolderCopy|a.FileSystemProviderCapabilities.FileWriteUnlock|a.FileSystemProviderCapabilities.FileAtomicRead|a.FileSystemProviderCapabilities.FileAtomicWrite|a.FileSystemProviderCapabilities.FileAtomicDelete|a.FileSystemProviderCapabilities.FileClone,o.isLinux&&(this._capabilities|=a.FileSystemProviderCapabilities.PathCaseSensitive)),this._capabilities}async stat(t){try{const{stat:l,symbolicLink:n}=await d.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(l,n),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size,permissions:l.mode&128?void 0:a.FilePermission.Locked}}catch(l){throw this.toFileSystemProviderError(l)}}async statIgnoreError(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const l=await d.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),n=[];return await Promise.all(l.map(async h=>{try{let s;h.isSymbolicLink()?s=(await this.stat((0,D.joinPath)(t,h.name))).type:s=this.toType(h),n.push([h.name,s])}catch(s){this.logService.trace(s)}})),n}catch(l){throw this.toFileSystemProviderError(l)}}toType(t,l){let n;return l?.dangling?n=a.FileType.Unknown:t.isFile()?n=a.FileType.File:t.isDirectory()?n=a.FileType.Directory:n=a.FileType.Unknown,l&&(n|=a.FileType.SymbolicLink),n}async createResourceLock(t){const l=this.toFilePath(t);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${l})`);let n;for(;n=this.resourceLocks.get(t);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${l})`),await n.wait();const h=new i.Barrier;return this.resourceLocks.set(t,h),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${l})`),(0,_.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${l})`),this.resourceLocks.get(t)===h&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${l})`),this.resourceLocks.delete(t)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${l})`),h.open()})}async readFile(t,l){let n;try{l?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),n=await this.createResourceLock(t));const h=this.toFilePath(t);return await d.Promises.readFile(h)}catch(h){throw this.toFileSystemProviderError(h)}finally{n?.dispose()}}traceLock(t){g.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(t)}readFileStream(t,l,n){const h=(0,y.newWriteableStream)(s=>w.VSBuffer.concat(s.map(c=>w.VSBuffer.wrap(c))).buffer);return(0,f.readFileIntoStream)(this,t,h,s=>s.buffer,{...l,bufferSize:256*1024},n),h}async writeFile(t,l,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.canWriteFileAtomic(t)?this.doWriteFileAtomic(t,(0,D.joinPath)((0,D.dirname)(t),`${(0,D.basename)(t)}${n.atomic.postfix}`),l,n):this.doWriteFile(t,l,n)}async canWriteFileAtomic(t){try{const l=this.toFilePath(t),{symbolicLink:n}=await d.SymlinkSupport.stat(l);if(n)return!1}catch{}return!0}async doWriteFileAtomic(t,l,n,h){const s=new _.DisposableStore;try{s.add(await this.createResourceLock(t)),s.add(await this.createResourceLock(l)),await this.doWriteFile(l,n,h,!0);try{await this.rename(l,t,{overwrite:!0})}catch(c){try{await this.delete(l,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw c}}finally{s.dispose()}}async doWriteFile(t,l,n,h){let s;try{const c=this.toFilePath(t);if(!n.create||!n.overwrite){if(await d.Promises.exists(c)){if(!n.overwrite)throw(0,a.createFileSystemProviderError)((0,E.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,a.createFileSystemProviderError)((0,E.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(t,{create:!0,unlock:n.unlock},h),await this.write(s,0,l,0,l.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(t,c)}finally{typeof s=="number"&&await this.close(s)}}static{this.canFlush=!0}static configureFlushOnWrite(t){g.canFlush=t}async open(t,l,n){const h=this.toFilePath(t);let s;(0,a.isFileOpenForWriteOptions)(l)&&!n&&(s=await this.createResourceLock(t));let c;try{if((0,a.isFileOpenForWriteOptions)(l)&&l.unlock)try{const{stat:I}=await d.SymlinkSupport.stat(h);I.mode&128||await d.Promises.chmod(h,I.mode|128)}catch(I){I.code!=="ENOENT"&&this.logService.trace(I)}let u;if((0,a.isFileOpenForWriteOptions)(l)){if(o.isWindows)try{await d.Promises.truncate(h,0),u="r+"}catch(I){I.code!=="ENOENT"&&this.logService.trace(I)}u||(u="w")}else u="r";c=await d.Promises.open(h,u)}catch(u){throw s?.dispose(),(0,a.isFileOpenForWriteOptions)(l)?await this.toFileSystemProviderWriteError(t,u):this.toFileSystemProviderError(u)}if(this.mapHandleToPos.set(c,0),(0,a.isFileOpenForWriteOptions)(l)&&this.writeHandles.set(c,t),s){const u=this.mapHandleToLock.get(c);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${h})`),this.mapHandleToLock.set(c,s),u&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${h})`),u.dispose())}return c}async close(t){const l=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&g.canFlush)try{await d.Promises.fdatasync(t)}catch(n){g.configureFlushOnWrite(!1),this.logService.error(n)}return await d.Promises.close(t)}catch(n){throw this.toFileSystemProviderError(n)}finally{l&&(this.mapHandleToLock.get(t)===l&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),l.dispose())}}async read(t,l,n,h,s){const c=this.normalizePos(t,l);let u=null;try{u=(await d.Promises.read(t,n,h,s,c)).bytesRead}catch(I){throw this.toFileSystemProviderError(I)}finally{this.updatePos(t,c,u)}return u}normalizePos(t,l){return l===this.mapHandleToPos.get(t)?null:l}updatePos(t,l,n){const h=this.mapHandleToPos.get(t);typeof h=="number"&&(typeof l=="number"||(typeof n=="number"?this.mapHandleToPos.set(t,h+n):this.mapHandleToPos.delete(t)))}async write(t,l,n,h,s){return(0,i.retry)(()=>this.doWrite(t,l,n,h,s),100,3)}async doWrite(t,l,n,h,s){const c=this.normalizePos(t,l);let u=null;try{u=(await d.Promises.write(t,n,h,s,c)).bytesWritten}catch(I){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),I)}finally{this.updatePos(t,c,u)}return u}async mkdir(t){try{await d.Promises.mkdir(this.toFilePath(t))}catch(l){throw this.toFileSystemProviderError(l)}}async delete(t,l){try{const n=this.toFilePath(t);if(l.recursive){let h;l?.atomic!==!1&&l.atomic.postfix&&(h=(0,b.join)((0,b.dirname)(n),`${(0,b.basename)(n)}${l.atomic.postfix}`)),await d.Promises.rm(n,d.RimRafMode.MOVE,h)}else try{await d.Promises.unlink(n)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let s=!1;try{const{stat:c,symbolicLink:u}=await d.SymlinkSupport.stat(n);s=c.isDirectory()&&!u}catch{}if(s)await d.Promises.rmdir(n);else throw h}else throw h}}catch(n){throw this.toFileSystemProviderError(n)}}async rename(t,l,n){const h=this.toFilePath(t),s=this.toFilePath(l);if(h!==s)try{await this.validateMoveCopy(t,l,"move",n.overwrite),await d.Promises.rename(h,s)}catch(c){throw(c.code==="EINVAL"||c.code==="EBUSY"||c.code==="ENAMETOOLONG")&&(c=new Error((0,E.localize)(2,null,(0,b.basename)(h),(0,b.basename)((0,b.dirname)(s)),c.toString()))),this.toFileSystemProviderError(c)}}async copy(t,l,n){const h=this.toFilePath(t),s=this.toFilePath(l);if(h!==s)try{await this.validateMoveCopy(t,l,"copy",n.overwrite),await d.Promises.copy(h,s,{preserveSymlinks:!0})}catch(c){throw(c.code==="EINVAL"||c.code==="EBUSY"||c.code==="ENAMETOOLONG")&&(c=new Error((0,E.localize)(3,null,(0,b.basename)(h),(0,b.basename)((0,b.dirname)(s)),c.toString()))),this.toFileSystemProviderError(c)}}async validateMoveCopy(t,l,n,h){const s=this.toFilePath(t),c=this.toFilePath(l);let u=!1;if(!!(this.capabilities&a.FileSystemProviderCapabilities.PathCaseSensitive)||(u=(0,R.isEqual)(s,c,!0)),u){if(n==="copy")throw(0,a.createFileSystemProviderError)((0,E.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const T=await this.statIgnoreError(t);if(!T)throw(0,a.createFileSystemProviderError)((0,E.localize)(5,null),a.FileSystemProviderErrorCode.FileNotFound);const A=await this.statIgnoreError(l);if(A){if(!h)throw(0,a.createFileSystemProviderError)((0,E.localize)(6,null),a.FileSystemProviderErrorCode.FileExists);T.type&a.FileType.File&&A.type&a.FileType.File||await this.delete(l,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,l){return this.doCloneFile(t,l,!1)}async doCloneFile(t,l,n){const h=this.toFilePath(t),s=this.toFilePath(l),c=!!(this.capabilities&a.FileSystemProviderCapabilities.PathCaseSensitive);if((0,R.isEqual)(h,s,!c))return;const u=new _.DisposableStore;try{u.add(await this.createResourceLock(t)),u.add(await this.createResourceLock(l)),n&&await d.Promises.mkdir((0,b.dirname)(s),{recursive:!0}),await d.Promises.copyFile(h,s)}catch(I){if(I.code==="ENOENT"&&!n)return this.doCloneFile(t,l,!0);throw this.toFileSystemProviderError(I)}finally{u.dispose()}}createUniversalWatcher(t,l,n){return new p.UniversalWatcherClient(h=>t(h),h=>l(h),n)}createNonRecursiveWatcher(t,l,n){return new S.NodeJSWatcherClient(h=>t(h),h=>l(h),n)}toFileSystemProviderError(t){if(t instanceof a.FileSystemProviderError)return t;let l=t,n;switch(t.code){case"ENOENT":n=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=a.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":l=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=a.FileSystemProviderErrorCode.Unknown;break;default:n=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(l,n)}async toFileSystemProviderWriteError(t,l){let n=this.toFileSystemProviderError(l);if(t&&n.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await d.SymlinkSupport.stat(this.toFilePath(t));h.mode&128||(n=(0,a.createFileSystemProviderError)(l,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.logService.trace(h)}return n}}e.DiskFileSystemProvider=g}),define(ye[259],Ie([1,0,6,72,2,15,56,19]),function(se,e,i,r,w,C,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class b extends w.Disposable{constructor(y,d){super(),this.provider=y,this.logService=d,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(y,d,E){const a=this.getUriTransformer(y);switch(d){case"stat":return this.stat(a,E[0]);case"readdir":return this.readdir(a,E[0]);case"open":return this.open(a,E[0],E[1]);case"close":return this.close(E[0]);case"read":return this.read(E[0],E[1],E[2]);case"readFile":return this.readFile(a,E[0],E[1]);case"write":return this.write(E[0],E[1],E[2],E[3],E[4]);case"writeFile":return this.writeFile(a,E[0],E[1],E[2]);case"rename":return this.rename(a,E[0],E[1],E[2]);case"copy":return this.copy(a,E[0],E[1],E[2]);case"cloneFile":return this.cloneFile(a,E[0],E[1]);case"mkdir":return this.mkdir(a,E[0]);case"delete":return this.delete(a,E[0],E[1]);case"watch":return this.watch(a,E[0],E[1],E[2],E[3]);case"unwatch":return this.unwatch(E[0],E[1])}throw new Error(`IPC Command ${d} not found`)}listen(y,d,E){const a=this.getUriTransformer(y);switch(d){case"fileChange":return this.onFileChange(a,E[0]);case"readFileStream":return this.onReadFileStream(a,E[0],E[1])}throw new Error(`Unknown event ${d}`)}stat(y,d){const E=this.transformIncoming(y,d,!0);return this.provider.stat(E)}readdir(y,d){const E=this.transformIncoming(y,d);return this.provider.readdir(E)}async readFile(y,d,E){const a=this.transformIncoming(y,d,!0),f=await this.provider.readFile(a,E);return C.VSBuffer.wrap(f)}onReadFileStream(y,d,E){const a=this.transformIncoming(y,d,!0),f=new _.CancellationTokenSource,m=new i.Emitter({onDidRemoveLastListener:()=>{f.cancel()}}),p=this.provider.readFileStream(a,E,f.token);return(0,R.listenStream)(p,{onData:S=>m.fire(C.VSBuffer.wrap(S)),onError:S=>m.fire(S),onEnd:()=>{m.fire("end"),m.dispose(),f.dispose()}}),m.event}writeFile(y,d,E,a){const f=this.transformIncoming(y,d);return this.provider.writeFile(f,E.buffer,a)}open(y,d,E){const a=this.transformIncoming(y,d,!0);return this.provider.open(a,E)}close(y){return this.provider.close(y)}async read(y,d,E){const a=C.VSBuffer.alloc(E),m=await this.provider.read(y,d,a.buffer,0,E);return[a,m]}write(y,d,E,a,f){return this.provider.write(y,d,E.buffer,a,f)}mkdir(y,d){const E=this.transformIncoming(y,d);return this.provider.mkdir(E)}delete(y,d,E){const a=this.transformIncoming(y,d);return this.provider.delete(a,E)}rename(y,d,E,a){const f=this.transformIncoming(y,d),m=this.transformIncoming(y,E);return this.provider.rename(f,m,a)}copy(y,d,E,a){const f=this.transformIncoming(y,d),m=this.transformIncoming(y,E);return this.provider.copy(f,m,a)}cloneFile(y,d,E){const a=this.transformIncoming(y,d),f=this.transformIncoming(y,E);return this.provider.cloneFile(a,f)}onFileChange(y,d){const E=new i.Emitter({onWillAddFirstListener:()=>{this.sessionToWatcher.set(d,this.createSessionFileWatcher(y,E))},onDidRemoveLastListener:()=>{(0,w.dispose)(this.sessionToWatcher.get(d)),this.sessionToWatcher.delete(d)}});return E.event}async watch(y,d,E,a,f){const m=this.sessionToWatcher.get(d);if(m){const p=this.transformIncoming(y,a),S=m.watch(E,p,f);this.watchRequests.set(d+E,S)}}async unwatch(y,d){const E=y+d,a=this.watchRequests.get(E);a&&((0,w.dispose)(a),this.watchRequests.delete(E))}dispose(){super.dispose();for(const[,y]of this.watchRequests)y.dispose();this.watchRequests.clear();for(const[,y]of this.sessionToWatcher)y.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=b;class o extends w.Disposable{constructor(y,d,E,a){super(),this.uriTransformer=y,this.logService=E,this.environmentService=a,this.watcherRequests=new Map,this.fileWatcher=this._register(new r.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(d)}registerListeners(y){const d=this._register(new i.Emitter);this._register(d.event(E=>{y.fire(E.map(a=>({resource:this.uriTransformer.transformOutgoingURI(a.resource),type:a.type,cId:a.cId})))})),this._register(this.fileWatcher.onDidChangeFile(E=>d.fire(E))),this._register(this.fileWatcher.onDidWatchError(E=>y.fire(E)))}getRecursiveWatcherOptions(y){}getExtraExcludes(y){}watch(y,d,E){const a=this.getExtraExcludes(this.environmentService);return Array.isArray(a)&&(E.excludes=[...E.excludes,...a]),this.watcherRequests.set(y,this.fileWatcher.watch(d,E)),(0,w.toDisposable)(()=>{(0,w.dispose)(this.watcherRequests.get(y)),this.watcherRequests.delete(y)})}dispose(){for(const[,y]of this.watcherRequests)y.dispose();this.watcherRequests.clear(),super.dispose()}}e.AbstractSessionFileWatcher=o}),define(ye[124],Ie([1,0,4,6,12,2]),function(se,e,i,r,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class R extends w.AbstractLoggerService{constructor(y,d,E,a,f){super(d,E,a),this.windowId=y,this.channel=f,this._register(f.listen("onDidChangeLogLevel",y)(m=>{(0,w.isLogLevel)(m)?super.setLogLevel(m):super.setLogLevel(i.URI.revive(m[0]),m[1])})),this._register(f.listen("onDidChangeVisibility",y)(([m,p])=>super.setVisibility(i.URI.revive(m),p))),this._register(f.listen("onDidChangeLoggers",y)(({added:m,removed:p})=>{for(const S of m)super.registerLogger({...S,resource:i.URI.revive(S.resource)});for(const S of p)super.deregisterLogger(S.resource)}))}createConsoleMainLogger(){return new w.AdapterLogger({log:(y,d)=>{this.channel.call("consoleLog",[y,d])}})}registerLogger(y){super.registerLogger(y),this.channel.call("registerLogger",[y,this.windowId])}deregisterLogger(y){super.deregisterLogger(y),this.channel.call("deregisterLogger",[y,this.windowId])}setLogLevel(y,d){super.setLogLevel(y,d),this.channel.call("setLogLevel",[y,d])}setVisibility(y,d){super.setVisibility(y,d),this.channel.call("setVisibility",[this.toResource(y),d])}doCreateLogger(y,d,E){return new _(this.channel,y,d,E,this.windowId)}static setLogLevel(y,d,E){return y.call("setLogLevel",[d,E])}}e.LoggerChannelClient=R;class _ extends w.AbstractMessageLogger{constructor(y,d,E,a,f){super(a?.logLevel==="always"),this.channel=y,this.file=d,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(E),this.channel.call("createLogger",[d,a,f]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(y,d){const E=[[y,d]];this.isLoggerCreated?this.doLog(E):this.buffer.push(...E)}doLog(y){this.channel.call("log",[this.file,y])}}class b{constructor(y,d){this.loggerService=y,this.getUriTransformer=d}listen(y,d){const E=this.getUriTransformer(y);switch(d){case"onDidChangeLoggers":return r.Event.map(this.loggerService.onDidChangeLoggers,a=>({added:[...a.added].map(f=>this.transformLogger(f,E)),removed:[...a.removed].map(f=>this.transformLogger(f,E))}));case"onDidChangeVisibility":return r.Event.map(this.loggerService.onDidChangeVisibility,a=>[E.transformOutgoingURI(a[0]),a[1]]);case"onDidChangeLogLevel":return r.Event.map(this.loggerService.onDidChangeLogLevel,a=>(0,w.isLogLevel)(a)?a:[E.transformOutgoingURI(a[0]),a[1]])}throw new Error(`Event not found: ${d}`)}async call(y,d,E){const a=this.getUriTransformer(y);switch(d){case"setLogLevel":return(0,w.isLogLevel)(E[0])?this.loggerService.setLogLevel(E[0]):this.loggerService.setLogLevel(i.URI.revive(a.transformIncoming(E[0][0])),E[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(f=>this.transformLogger(f,a)))}throw new Error(`Call not found: ${d}`)}transformLogger(y,d){return{...y,resource:d.transformOutgoingURI(y.resource)}}}e.LoggerChannel=b;class o extends C.Disposable{constructor(y,d){super(),d.call("setLogLevel",[y.getLogLevel()]),this._register(y.onDidChangeLogLevel(E=>d.call("setLogLevel",[E]))),d.call("getRegisteredLoggers").then(E=>{for(const a of E)y.registerLogger({...a,resource:i.URI.revive(a.resource)})}),this._register(d.listen("onDidChangeVisibility")(([E,a])=>y.setVisibility(i.URI.revive(E),a))),this._register(d.listen("onDidChangeLoggers")(({added:E,removed:a})=>{for(const f of E)y.registerLogger({...f,resource:i.URI.revive(f.resource)});for(const f of a)y.deregisterLogger(f.resource)}))}}e.RemoteLoggerChannelClient=o}),define(ye[125],Ie([1,0,2,12]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class w extends i.Disposable{constructor(R,_=[]){super(),this.logger=new r.MultiplexLogger([R,..._]),this._register(R.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(R){this.logger.setLevel(R)}getLevel(){return this.logger.getLevel()}trace(R,..._){this.logger.trace(R,..._)}debug(R,..._){this.logger.debug(R,..._)}info(R,..._){this.logger.info(R,..._)}warn(R,..._){this.logger.warn(R,..._)}error(R,..._){this.logger.error(R,..._)}flush(){this.logger.flush()}}e.LogService=w}),define(ye[260],Ie([1,0,16,12]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var w;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(w||(w={}));async function C(o,D,y,d,E){try{const a=await new Promise((m,p)=>{se(["@vscode/spdlog"],m,p)}).then(Be);a.setFlushOn(w.Trace);const f=await a.createAsyncRotatingLogger(o,D,y,d);return E?f.clearFormatters():f.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),f}catch(a){console.error(a)}return null}function R(o,D,y){switch(D){case r.LogLevel.Trace:o.trace(y);break;case r.LogLevel.Debug:o.debug(y);break;case r.LogLevel.Info:o.info(y);break;case r.LogLevel.Warning:o.warn(y);break;case r.LogLevel.Error:o.error(y);break;case r.LogLevel.Off:break;default:throw new Error(`Invalid log level ${D}`)}}function _(o,D){switch(D){case r.LogLevel.Trace:o.setLevel(w.Trace);break;case r.LogLevel.Debug:o.setLevel(w.Debug);break;case r.LogLevel.Info:o.setLevel(w.Info);break;case r.LogLevel.Warning:o.setLevel(w.Warning);break;case r.LogLevel.Error:o.setLevel(w.Error);break;case r.LogLevel.Off:o.setLevel(w.Off);break;default:throw new Error(`Invalid log level ${D}`)}}class b extends r.AbstractMessageLogger{constructor(D,y,d,E,a){super(),this.buffer=[],this.setLevel(a),this._loggerCreationPromise=this._createSpdLogLogger(D,y,d,E),this._register(this.onDidChangeLogLevel(f=>{this._logger&&_(this._logger,f)}))}async _createSpdLogLogger(D,y,d,E){const a=d?6:1,f=30/a*i.ByteSize.MB,m=await C(D,y,f,a,E);if(m){this._logger=m,_(this._logger,this.getLevel());for(const{level:p,message:S}of this.buffer)R(this._logger,p,S);this.buffer=[]}}log(D,y){this._logger?R(this._logger,D,y):this.getLevel()<=D&&this.buffer.push({level:D,message:y})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=b}),define(ye[126],Ie([1,0,23,12,260]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class C extends r.AbstractLoggerService{doCreateLogger(_,b,o){return new w.SpdLogLogger((0,i.generateUuid)(),_.fsPath,!o?.donotRotate,!!o?.donotUseFormatters,b)}}e.LoggerService=C});var gt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ye[261],Ie([1,0,58,221,5]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,i=gt(i);var C;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(C||(e.MarkerTag=C={}));var R;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(b){function o(a,f){return f-a}b.compare=o;const D=Object.create(null);D[b.Error]=(0,r.localize)(0,null),D[b.Warning]=(0,r.localize)(1,null),D[b.Info]=(0,r.localize)(2,null);function y(a){return D[a]||""}b.toString=y;function d(a){switch(a){case i.default.Error:return b.Error;case i.default.Warning:return b.Warning;case i.default.Info:return b.Info;case i.default.Ignore:return b.Hint}}b.fromSeverity=d;function E(a){switch(a){case b.Error:return i.default.Error;case b.Warning:return i.default.Warning;case b.Info:return i.default.Info;case b.Hint:return i.default.Ignore}}b.toSeverity=E}(R||(e.MarkerSeverity=R={}));var _;(function(b){const o="";function D(d){return y(d,!0)}b.makeKey=D;function y(d,E){const a=[o];return d.source?a.push(d.source.replace("\xA6","\\\xA6")):a.push(o),d.code?typeof d.code=="string"?a.push(d.code.replace("\xA6","\\\xA6")):a.push(d.code.value.replace("\xA6","\\\xA6")):a.push(o),d.severity!==void 0&&d.severity!==null?a.push(R.toString(d.severity)):a.push(o),d.message&&E?a.push(d.message.replace("\xA6","\\\xA6")):a.push(o),d.startLineNumber!==void 0&&d.startLineNumber!==null?a.push(d.startLineNumber.toString()):a.push(o),d.startColumn!==void 0&&d.startColumn!==null?a.push(d.startColumn.toString()):a.push(o),d.endLineNumber!==void 0&&d.endLineNumber!==null?a.push(d.endLineNumber.toString()):a.push(o),d.endColumn!==void 0&&d.endColumn!==null?a.push(d.endColumn.toString()):a.push(o),a.push(o),a.join("\xA6")}b.makeKeyOptionalMessage=y})(_||(e.IMarkerData=_={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(ye[73],Ie([1,0,6,40,2,5]),function(se,e,i,r,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,C.createDecorator)("policy");class R extends w.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(o){const D=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...o,...this.policyDefinitions},D!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(o),r.Iterable.reduce(this.policies.entries(),(y,[d,E])=>({...y,[d]:E}),{})}getPolicyValue(o){return this.policies.get(o)}serialize(){return r.Iterable.reduce(Object.entries(this.policyDefinitions),(o,[D,y])=>({...o,[D]:{definition:y,value:this.policies.get(D)}}),{})}}e.AbstractPolicyService=R;class _{constructor(){this.onDidChange=i.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=_}),define(ye[62],Ie([1,0,33]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;const w=globalThis.vscode;if(typeof w<"u"&&typeof w.context<"u"){const C=w.context.configuration();if(C)r=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){r=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:C,searchUrl:R,itemUrl:_,controlUrl:b}=r.extensionsGallery||{};Object.assign(r,{extensionsGallery:{serviceUrl:i.env.VSCODE_GALLERY_SERVICE_URL||C,searchUrl:i.env.VSCODE_GALLERY_SEARCH_URL||R,itemUrl:i.env.VSCODE_GALLERY_ITEM_URL||_,controlUrl:i.env.VSCODE_GALLERY_CONTROL_URL||b}});try{const o=(...y)=>y.reduce((d,E)=>(Object.keys(E).forEach(a=>{Array.isArray(d[a])&&Array.isArray(E[a])?d[a]=E[a]:typeof d[a]=="object"&&typeof E[a]=="object"?d[a]=o(d[a],E[a]):d[a]=E[a]}),d),{}),D=globalThis._VSCODE_USER_PRODUCT_JSON||{};r=o(r,D)}catch{}if(i.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const o=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:o.version,release:o.release})}}else r={nameShort:"VSCodium",nameLong:"VSCodium",applicationName:"codium",dataFolderName:".vscode-oss",win32MutexName:"vscodium",licenseName:"MIT",licenseUrl:"https://github.com/VSCodium/vscodium/blob/master/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"codium-server",serverDataFolderName:".vscodium-server",tunnelApplicationName:"code-tunnel-oss",win32DirName:"VSCodium",win32NameVersion:"VSCodium",win32RegValueName:"VSCodium",win32x64AppId:"{{88DA3577-054F-4CA1-8122-7D820494CFFB}",win32arm64AppId:"{{67DEE444-3D04-4258-B92A-BC1F0FF2CAE4}",win32x64UserAppId:"{{2E1F05D1-C245-4562-81EE-28188DB6FD17}",win32arm64UserAppId:"{{57FD70A5-1B8D-4875-9F40-C5553F094828}",win32AppUserModelId:"VSCodium.VSCodium",win32ShellNameShort:"VSCodium",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.vscodium",linuxIconName:"vscodium",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/VSCodium/vscodium/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"vscodium",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.91.0",sha256:"53b99146c7fa280f00c74414e09721530c622bf3e5eac2c967ddfb9906b51c80",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.9",sha256:"3b62ee4276a2bbea3fe230f94b1d5edd915b05966090ea56f882e1e0ab53e1a6",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",extensionsGallery:{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item"},introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",linkProtectionTrustedDomains:["https://open-vsx.org"],releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",quality:"stable",win32AppId:"{{763CBF88-25C6-4B10-952F-326AE657F16B}",win32UserAppId:"{{0FD05EB4-651E-4E78-A062-515204B47A3A}",extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver","attributableCoverage"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","contribShareMenu","contribStatusBarItems","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-toolsai.vscode-ai-remote":["resolvers"],"ms-python.python":["contribEditorContentMenu","quickPickSortByLabel","portsAttributes","testObserver","quickPickItemTooltip","terminalDataWriteEvent","terminalExecuteCommandEvent","contribIssueReporter","terminalShellIntegration"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["canonicalUriProvider","contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","shareProvider","scmActionButton","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers","tunnels","contribViewsWelcome"],"ms-vscode.remote-explorer":["contribRemoteHelp","contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","portsAttributes","tunnels","workspaceTrust","terminalDimensions","contribRemoteHelp","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"ms-vscode.vscode-speech":["speech"],"GitHub.vscode-pull-request-github":["activeComment","codiconDecoration","codeActionRanges","commentingRangeHint","commentReactor","commentThreadApplicability","contribAccessibilityHelpContent","contribCommentEditorActionsMenu","contribCommentPeekContext","contribCommentThreadAdditionalMenu","contribCommentsViewThreadMenus","contribEditorContentMenu","contribMultiDiffEditorMenus","contribShareMenu","diffCommand","fileComments","quickDiffProvider","shareProvider","tabInputTextMerge","tokenInformation","treeViewMarkdownMessage"],"GitHub.copilot":["inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsAdditions"],"GitHub.copilot-chat":["interactive","terminalDataWriteEvent","terminalExecuteCommandEvent","terminalSelection","terminalQuickFixProvider","chatParticipantAdditions","defaultChatParticipant","embeddings","chatVariableResolver","chatProvider","mappedEditsProvider","aiRelatedInformation","codeActionAI","findTextInFiles","textSearchProvider","contribSourceControlInputBoxMenu","contribCommentEditorActionsMenu","contribCommentThreadAdditionalMenu","contribCommentsViewThreadMenus","newSymbolNamesProvider","findFiles2","extensionsAny","authLearnMore","testObserver","aiTextSearchProvider","documentFiltersExclusive","chatParticipantPrivate"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-python.debugpy":["portsAttributes","contribIssueReporter","debugVisualization"],"ms-toolsai.jupyter-renderers":["contribNotebookStaticPreloads"],"ms-toolsai.jupyter":["notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow","notebookControllerAffinityHidden","contribNotebookStaticPreloads","quickPickItemTooltip","notebookExecution","notebookCellExecution","notebookVariableProvider"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-azuretools.vscode-azureresourcegroups":["authGetSessions"],"ms-azuretools.vscode-azure-github-copilot":["chatParticipantAdditions","embeddings","languageModelSystem"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"redhat.java":["documentPaste"],"ms-dotnettools.csdevkit":["inlineCompletionsAdditions"],"ms-dotnettools.vscodeintellicode-csharp":["inlineCompletionsAdditions"],"microsoft-IsvExpTools.powerplatform-vscode":["fileSearchProvider","textSearchProvider"],"microsoft-IsvExpTools.powerplatform-vscode-preview":["fileSearchProvider","textSearchProvider"],"TeamsDevApp.ms-teams-vscode-extension":["chatParticipantAdditions","languageModelSystem"],"jeanp413.open-remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribRemoteHelp","contribViewsRemote"],"jeanp413.open-remote-wsl":["resolvers","contribRemoteHelp","contribViewsRemote"]},extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},version:"1.91.1",commit:"8512cb3341b26a5dba985a9a17eed8d7c3362886",date:"2024-07-11T18:44:22.848Z"},Object.keys(r).length===0&&Object.assign(r,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(ye[29],Ie([1,0,5]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,i.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ye[262],Ie([1,0,14,19,2,5]),function(se,e,i,r,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.AsyncProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var R;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class _{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(d){this.callback=d}report(d){this._value=d,this.callback(this._value)}}e.Progress=_;class b{get value(){return this._value}constructor(d){this.callback=d}report(d){this._asyncQueue?this._asyncQueue.push(d):this._asyncQueue=[d],this._processAsyncQueue()}async _processAsyncQueue(){if(!this._processingAsyncQueue)try{for(this._processingAsyncQueue=!0;this._asyncQueue&&this._asyncQueue.length;){const d=this._asyncQueue.shift();this._value=d,await this.callback(this._value)}}finally{this._processingAsyncQueue=!1;const d=this._drainListener;this._drainListener=void 0,d?.()}}drain(){return this._processingAsyncQueue?new Promise(d=>{const E=this._drainListener;this._drainListener=()=>{E?.(),d()}}):Promise.resolve()}}e.AsyncProgress=b;let o=class extends w.Disposable{constructor(d,E){super(),this.deferred=new i.DeferredPromise,E.withProgress(d,a=>(this.reporter=a,this.lastStep&&a.report(this.lastStep),this.deferred.p)),this._register((0,w.toDisposable)(()=>this.deferred.complete()))}report(d){this.reporter?this.reporter.report(d):this.lastStep=d}};e.UnmanagedProgress=o,e.UnmanagedProgress=o=ze([Me(1,e.IProgressService)],o);class D extends w.Disposable{constructor(d){super(),this.progressIndicator=d,this.currentOperationId=0,this.currentOperationDisposables=this._register(new w.DisposableStore)}start(d){this.stop();const E=++this.currentOperationId,a=new r.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{E===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},d),this.currentOperationDisposables.add((0,w.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,w.toDisposable)(()=>a.cancel())),this.currentOperationDisposables.add((0,w.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:E,token:a.token,stop:()=>this.doStop(E),isCurrent:()=>this.currentOperationId===E}}stop(){this.doStop(this.currentOperationId)}doStop(d){this.currentOperationId===d&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=D,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(ye[38],Ie([1,0,106,11]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0,i=Be(i),r=Be(r);class w{constructor(){this.data=new Map}add(R,_){i.ok(r.isString(R)),i.ok(r.isObject(_)),i.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,_)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new w}),define(ye[127],Ie([1,0,6,38]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,r=Be(r),e.Extensions={JSONContribution:"base.contributions.json"};function w(_){return _.length>0&&_.charAt(_.length-1)==="#"?_.substring(0,_.length-1):_}class C{constructor(){this._onDidChangeSchema=new i.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,o){this.schemasById[w(b)]=o,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new C;r.Registry.add(e.Extensions.JSONContribution,R)}),define(ye[46],Ie([1,0,18,6,11,202,27,127,38]),function(se,e,i,r,w,C,R,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=f,e.keyFromOverrideIdentifiers=m,e.getDefaultValue=p,e.validateProperty=g,e.getScopes=v,w=Be(w),C=Be(C);var o;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(o||(e.EditPresentationTypes=o={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D||(e.ConfigurationScope=D={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=b.Registry.as(_.Extensions.JSONContribution);class d{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new r.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new r.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,n=!0){this.registerConfigurations([l],n)}registerConfigurations(l,n=!0){const h=new Set;this.doRegisterConfigurations(l,n,h),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h})}deregisterConfigurations(l){const n=new Set;this.doDeregisterConfigurations(l,n),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:l,remove:n}){const h=new Set;this.doDeregisterConfigurations(n,h),this.doRegisterConfigurations(l,!1,h),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h})}registerDefaultConfigurations(l){const n=new Set;this.doRegisterDefaultConfigurations(l,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}doRegisterDefaultConfigurations(l,n){const h=[];for(const{overrides:s,source:c}of l)for(const u in s)if(n.add(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const I=this.configurationDefaultsOverrides.get(u),T=I?.valuesSources??new Map,A=I?.value||{};for(const P of Object.keys(s[u])){const B=s[u][P];if(w.isObject(B)&&(w.isUndefined(A[P])||w.isObject(A[P]))){if(A[P]={...A[P]??{},...B},c){let X=T.get(P);if(X||(X=new Map,T.set(P,X)),!(X instanceof Map)){console.error("objectConfigurationSources is not a Map");continue}for(const re in B)X.set(re,c)}}else A[P]=B,c&&T.set(P,c)}this.configurationDefaultsOverrides.set(u,{source:c,value:A,valuesSources:T});const O=(0,R.getLanguageTagSettingPlainKey)(u),k={type:"object",default:A,description:C.localize(1,null,O),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:A,source:w.isString(c)?void 0:c,defaultValueSource:c};h.push(...f(u)),this.configurationProperties[u]=k,this.defaultLanguageConfigurationOverridesNode.properties[u]=k}else{const I=this.configurationProperties[u],T=this.configurationDefaultsOverrides.get(u);let A=T?.value??I?.defaultDefaultValue,O=s[u],k=c;if(w.isObject(O)&&(I!==void 0&&I.type==="object"||I===void 0&&(w.isUndefined(A)||w.isObject(A)))){if(w.isObject(A)||(A={}),O={...A,...O},k=T?.source??new Map,!(k instanceof Map)){console.error("defaultValueSource is not a Map");continue}for(const B in s[u])c?k.set(B,c):k.delete(B)}this.configurationDefaultsOverrides.set(u,{value:O,source:k}),I&&(this.updatePropertyDefaultValue(u,I),this.updateSchema(u,I))}this.doRegisterOverrideIdentifiers(h)}deregisterDefaultConfigurations(l){const n=new Set;this.doDeregisterDefaultConfigurations(l,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(l,n){for(const{overrides:h,source:s}of l)for(const c in h){const u=w.isString(s)?s:s?.id,I=this.configurationDefaultsOverrides.get(c);if(I){if(e.OVERRIDE_PROPERTY_REGEX.test(c)){for(const A of Object.keys(h[c])){const O=h[c][A];if(w.isObject(O)){const k=I.valuesSources?.get(A);for(const P of Object.keys(O)){const B=k?.get(P);(w.isString(B)?B:B?.id)===u&&(k?.delete(P),delete I.value[A][P])}Object.keys(I.value[A]).length===0&&(delete I.value[A],I.valuesSources?.delete(A))}else{const k=I.valuesSources?.get(A);(w.isString(k)?k:k?.id)===u&&(I.valuesSources?.delete(A),delete I.value[A])}}const T=this.configurationDefaultsOverrides.get(c);T&&Object.keys(T.value).length===0&&(this.configurationDefaultsOverrides.delete(c),delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c])}else{if(I.source instanceof Map){const A=I.source;for(const O in h[c]){const k=A.get(O);(w.isString(k)?k:k?.id)===u&&(A.delete(O),delete I.value[O])}A.size===0&&this.configurationDefaultsOverrides.delete(c)}else{const A=w.isString(I.source)?I.source:I.source?.id;if(u!==A)continue;this.configurationDefaultsOverrides.delete(c)}const T=this.configurationProperties[c];T&&(this.updatePropertyDefaultValue(c,T),this.updateSchema(c,T))}n.add(c)}}this.updateOverridePropertyPatternKey()}deltaConfiguration(l){let n=!1;const h=new Set;l.removedDefaults&&(this.doDeregisterDefaultConfigurations(l.removedDefaults,h),n=!0),l.addedDefaults&&(this.doRegisterDefaultConfigurations(l.addedDefaults,h),n=!0),l.removedConfigurations&&this.doDeregisterConfigurations(l.removedConfigurations,h),l.addedConfigurations&&this.doRegisterConfigurations(l.addedConfigurations,!1,h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){this.doRegisterOverrideIdentifiers(l),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(l){for(const n of l)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,n,h){l.forEach(s=>{this.validateAndRegisterProperties(s,n,s.extensionInfo,s.restrictedProperties,void 0,h),this.configurationContributors.push(s),this.registerJSONConfiguration(s)})}doDeregisterConfigurations(l,n){const h=s=>{if(s.properties)for(const c in s.properties){n.add(c);const u=this.configurationProperties[c];u?.policy?.name&&this.policyConfigurations.delete(u.policy.name),delete this.configurationProperties[c],this.removeFromSchema(c,s.properties[c])}s.allOf?.forEach(c=>h(c))};for(const s of l){h(s);const c=this.configurationContributors.indexOf(s);c!==-1&&this.configurationContributors.splice(c,1)}}validateAndRegisterProperties(l,n=!0,h,s,c=D.WINDOW,u){c=w.isUndefinedOrNull(l.scope)?c:l.scope;const I=l.properties;if(I)for(const A in I){const O=I[A];if(n&&g(A,O)){delete I[A];continue}if(O.source=h,O.defaultDefaultValue=I[A].default,this.updatePropertyDefaultValue(A,O),e.OVERRIDE_PROPERTY_REGEX.test(A)?O.scope=void 0:(O.scope=w.isUndefinedOrNull(O.scope)?c:O.scope,O.restricted=w.isUndefinedOrNull(O.restricted)?!!s?.includes(A):O.restricted),I[A].hasOwnProperty("included")&&!I[A].included){this.excludedConfigurationProperties[A]=I[A],delete I[A];continue}else this.configurationProperties[A]=I[A],I[A].policy?.name&&this.policyConfigurations.set(I[A].policy.name,A);!I[A].deprecationMessage&&I[A].markdownDeprecationMessage&&(I[A].deprecationMessage=I[A].markdownDeprecationMessage),u.add(A)}const T=l.allOf;if(T)for(const A of T)this.validateAndRegisterProperties(A,n,h,s,c,u)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(l){const n=h=>{const s=h.properties;if(s)for(const u in s)this.updateSchema(u,s[u]);h.allOf?.forEach(n)};n(l)}updateSchema(l,n){switch(e.allSettings.properties[l]=n,n.scope){case D.APPLICATION:e.applicationSettings.properties[l]=n;break;case D.MACHINE:e.machineSettings.properties[l]=n;break;case D.MACHINE_OVERRIDABLE:e.machineOverridableSettings.properties[l]=n;break;case D.WINDOW:e.windowSettings.properties[l]=n;break;case D.RESOURCE:e.resourceSettings.properties[l]=n;break;case D.LANGUAGE_OVERRIDABLE:e.resourceSettings.properties[l]=n,this.resourceLanguageSettingsSchema.properties[l]=n;break}}removeFromSchema(l,n){switch(delete e.allSettings.properties[l],n.scope){case D.APPLICATION:delete e.applicationSettings.properties[l];break;case D.MACHINE:delete e.machineSettings.properties[l];break;case D.MACHINE_OVERRIDABLE:delete e.machineOverridableSettings.properties[l];break;case D.WINDOW:delete e.windowSettings.properties[l];break;case D.RESOURCE:case D.LANGUAGE_OVERRIDABLE:delete e.resourceSettings.properties[l],delete this.resourceLanguageSettingsSchema.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const n=`[${l}]`,h={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,h),e.allSettings.properties[n]=h,e.applicationSettings.properties[n]=h,e.machineSettings.properties[n]=h,e.machineOverridableSettings.properties[n]=h,e.windowSettings.properties[n]=h,e.resourceSettings.properties[n]=h}}registerOverridePropertyPatternKey(){const l={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,n){const h=this.configurationDefaultsOverrides.get(l);let s=h?.value,c=h?.source;w.isUndefined(s)&&(s=n.defaultDefaultValue,c=void 0),w.isUndefined(s)&&(s=p(n.type)),n.default=s,n.defaultValueSource=c}}const E="\\[([^\\]]+)\\]",a=new RegExp(E,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${E})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function f(t){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(t)){let n=a.exec(t);for(;n?.length;){const h=n[1].trim();h&&l.push(h),n=a.exec(t)}}return(0,i.distinct)(l)}function m(t){return t.reduce((l,n)=>`${l}[${n}]`,"")}function p(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const S=new d;b.Registry.add(e.Extensions.Configuration,S);function g(t,l){return t.trim()?e.OVERRIDE_PROPERTY_REGEX.test(t)?C.localize(7,null,t):S.getConfigurationProperties()[t]!==void 0?C.localize(8,null,t):l.policy?.name&&S.getPolicyConfigurations().get(l.policy?.name)!==void 0?C.localize(9,null,t,l.policy?.name,S.getPolicyConfigurations().get(l.policy?.name)):null:C.localize(6,null)}function v(){const t=[],l=S.getConfigurationProperties();for(const n of Object.keys(l))t.push([n,l[n].scope]);return t.push(["launch",D.RESOURCE]),t.push(["task",D.RESOURCE]),t}}),define(ye[128],Ie([1,0,18,6,43,2,26,21,11,4,27,46,16,38]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=v,i=Be(i),w=Be(w),_=Be(_),b=Be(b);function a(h){return Object.isFrozen(h)?h:_.deepFreeze(h)}class f{static createEmptyModel(s){return new f({},[],[],void 0,s)}constructor(s,c,u,I,T){this._contents=s,this._keys=c,this._overrides=u,this.raw=I,this.logService=T,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const s=this.raw.map(c=>{if(c instanceof f)return c;const u=new m("",this.logService);return u.parseRaw(c),u.configurationModel});this._rawConfiguration=s.reduce((c,u)=>u===c?u:c.merge(u),s[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,D.getConfigurationValue)(this.contents,s):this.contents}inspect(s,c){const u=this;return{get value(){return a(u.rawConfiguration.getValue(s))},get override(){return c?a(u.rawConfiguration.getOverrideValue(s,c)):void 0},get merged(){return a(c?u.rawConfiguration.override(c).getValue(s):u.rawConfiguration.getValue(s))},get overrides(){const I=[];for(const{contents:T,identifiers:A,keys:O}of u.rawConfiguration.overrides){const k=new f(T,O,[],void 0,u.logService).getValue(s);k!==void 0&&I.push({identifiers:A,value:k})}return I.length?a(I):void 0}}}getOverrideValue(s,c){const u=this.getContentsForOverrideIdentifer(c);return u?s?(0,D.getConfigurationValue)(u,s):u:void 0}getKeysForOverrideIdentifier(s){const c=[];for(const u of this.overrides)u.identifiers.includes(s)&&c.push(...u.keys);return i.distinct(c)}getAllOverrideIdentifiers(){const s=[];for(const c of this.overrides)s.push(...c.identifiers);return i.distinct(s)}override(s){let c=this.overrideConfigurations.get(s);return c||(c=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,c)),c}merge(...s){const c=_.deepClone(this.contents),u=_.deepClone(this.overrides),I=[...this.keys],T=this.raw?.length?[...this.raw]:[this];for(const A of s)if(T.push(...A.raw?.length?A.raw:[A]),!A.isEmpty()){this.mergeContents(c,A.contents);for(const O of A.overrides){const[k]=u.filter(P=>i.equals(P.identifiers,O.identifiers));k?(this.mergeContents(k.contents,O.contents),k.keys.push(...O.keys),k.keys=i.distinct(k.keys)):u.push(_.deepClone(O))}for(const O of A.keys)I.indexOf(O)===-1&&I.push(O)}return new f(c,I,u,T.every(A=>A instanceof f)?void 0:T,this.logService)}createOverrideConfigurationModel(s){const c=this.getContentsForOverrideIdentifer(s);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const u={};for(const I of i.distinct([...Object.keys(this.contents),...Object.keys(c)])){let T=this.contents[I];const A=c[I];A&&(typeof T=="object"&&typeof A=="object"?(T=_.deepClone(T),this.mergeContents(T,A)):T=A),u[I]=T}return new f(u,this.keys,this.overrides,void 0,this.logService)}mergeContents(s,c){for(const u of Object.keys(c)){if(u in s&&b.isObject(s[u])&&b.isObject(c[u])){this.mergeContents(s[u],c[u]);continue}s[u]=_.deepClone(c[u])}}getContentsForOverrideIdentifer(s){let c=null,u=null;const I=T=>{T&&(u?this.mergeContents(u,T):u=_.deepClone(T))};for(const T of this.overrides)T.identifiers.length===1&&T.identifiers[0]===s?c=T.contents:T.identifiers.includes(s)&&I(T.contents);return I(c),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,c){this.updateValue(s,c,!0)}setValue(s,c){this.updateValue(s,c,!1)}removeValue(s){const c=this.keys.indexOf(s);c!==-1&&(this.keys.splice(c,1),(0,D.removeFromValueTree)(this.contents,s),y.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(u=>i.equals(u.identifiers,(0,y.overrideIdentifiersFromKey)(s))),1))}updateValue(s,c,u){(0,D.addToValueTree)(this.contents,s,c,I=>this.logService.error(I)),u=u||this.keys.indexOf(s)===-1,u&&this.keys.push(s),y.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,y.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,D.toValuesTree)(this.contents[s],I=>this.logService.error(I))})}}e.ConfigurationModel=f;class m{constructor(s,c){this._name=s,this.logService=c,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||f.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,c){if(!b.isUndefinedOrNull(s)){const u=this.doParseContent(s);this.parseRaw(u,c)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,c){this._raw=s;const{contents:u,keys:I,overrides:T,restricted:A,hasExcludedProperties:O}=this.doParseRaw(s,c);this._configurationModel=new f(u,I,T,O?[s]:void 0,this.logService),this._restrictedConfigurations=A||[]}doParseContent(s){let c={},u=null,I=[];const T=[],A=[];function O(P){Array.isArray(I)?I.push(P):u!==null&&(I[u]=P)}const k={onObjectBegin:()=>{const P={};O(P),T.push(I),I=P,u=null},onObjectProperty:P=>{u=P},onObjectEnd:()=>{I=T.pop()},onArrayBegin:()=>{const P=[];O(P),T.push(I),I=P,u=null},onArrayEnd:()=>{I=T.pop()},onLiteralValue:O,onError:(P,B,Y)=>{A.push({error:P,offset:B,length:Y})}};if(s)try{w.visit(s,k),c=I[0]||{}}catch(P){this.logService.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return c}doParseRaw(s,c){const u=E.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),I=this.filter(s,u,!0,c);s=I.raw;const T=(0,D.toValuesTree)(s,k=>this.logService.error(`Conflict in settings file ${this._name}: ${k}`)),A=Object.keys(s),O=this.toOverrides(s,k=>this.logService.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:T,keys:A,overrides:O,restricted:I.restricted,hasExcludedProperties:I.hasExcludedProperties}}filter(s,c,u,I){let T=!1;if(!I?.scopes&&!I?.skipRestricted&&!I?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:T};const A={},O=[];for(const k in s)if(y.OVERRIDE_PROPERTY_REGEX.test(k)&&u){const P=this.filter(s[k],c,!1,I);A[k]=P.raw,T=T||P.hasExcludedProperties,O.push(...P.restricted)}else{const P=c[k],B=P?typeof P.scope<"u"?P.scope:y.ConfigurationScope.WINDOW:void 0;P?.restricted&&O.push(k),!I.exclude?.includes(k)&&(I.include?.includes(k)||(B===void 0||I.scopes===void 0||I.scopes.includes(B))&&!(I.skipRestricted&&P?.restricted))?A[k]=s[k]:T=!0}return{raw:A,restricted:O,hasExcludedProperties:T}}toOverrides(s,c){const u=[];for(const I of Object.keys(s))if(y.OVERRIDE_PROPERTY_REGEX.test(I)){const T={};for(const A in s[I])T[A]=s[I][A];u.push({identifiers:(0,y.overrideIdentifiersFromKey)(I),keys:Object.keys(T),contents:(0,D.toValuesTree)(T,c)})}return u}}e.ConfigurationModelParser=m;class p extends C.Disposable{constructor(s,c,u,I,T){super(),this.userSettingsResource=s,this.parseOptions=c,this.fileService=I,this.logService=T,this._onDidChange=this._register(new r.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString(),T),this._register(this.fileService.watch(u.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(r.Event.any(r.Event.filter(this.fileService.onDidFilesChange,A=>A.contains(this.userSettingsResource)),r.Event.filter(this.fileService.onDidRunOperation,A=>(A.isOperation(d.FileOperation.CREATE)||A.isOperation(d.FileOperation.COPY)||A.isOperation(d.FileOperation.DELETE)||A.isOperation(d.FileOperation.WRITE))&&u.isEqual(A.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return f.createEmptyModel(this.logService)}}reparse(s){return s&&(this.parseOptions=s),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class S{constructor(s,c,u,I,T,A,O,k,P,B,Y,X,re){this.key=s,this.overrides=c,this._value=u,this.overrideIdentifiers=I,this.defaultConfiguration=T,this.policyConfiguration=A,this.applicationConfiguration=O,this.userConfiguration=k,this.localUserConfiguration=P,this.remoteUserConfiguration=B,this.workspaceConfiguration=Y,this.folderConfigurationModel=X,this.memoryConfigurationModel=re}get value(){return a(this._value)}toInspectValue(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class g{constructor(s,c,u,I,T,A,O,k,P,B){this._defaultConfiguration=s,this._policyConfiguration=c,this._applicationConfiguration=u,this._localUserConfiguration=I,this._remoteUserConfiguration=T,this._workspaceConfiguration=A,this._folderConfigurations=O,this._memoryConfiguration=k,this._memoryConfigurationByResource=P,this.logService=B,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(s,c,u){return this.getConsolidatedConfigurationModel(s,c,u).getValue(s)}updateValue(s,c,u={}){let I;u.resource?(I=this._memoryConfigurationByResource.get(u.resource),I||(I=f.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(u.resource,I))):I=this._memoryConfiguration,c===void 0?I.removeValue(s):I.setValue(s,c),u.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,c,u){const I=this.getConsolidatedConfigurationModel(s,c,u),T=this.getFolderConfigurationModelForResource(c.resource,u),A=c.resource?this._memoryConfigurationByResource.get(c.resource)||this._memoryConfiguration:this._memoryConfiguration,O=new Set;for(const k of I.overrides)for(const P of k.identifiers)I.getOverrideValue(s,P)!==void 0&&O.add(P);return new S(s,c,I.getValue(s),O.size?[...O]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this._workspaceConfiguration:void 0,T||void 0,A)}keys(s){const c=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,c){this._folderConfigurations.set(s,c),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,c){const u=[];if(!c){const{added:I,updated:T,removed:A}=l(this._defaultConfiguration,s);c=[...I,...T,...A]}for(const I of c)for(const T of(0,y.overrideIdentifiersFromKey)(I)){const A=this._defaultConfiguration.getKeysForOverrideIdentifier(T),O=s.getKeysForOverrideIdentifier(T),k=[...O.filter(P=>A.indexOf(P)===-1),...A.filter(P=>O.indexOf(P)===-1),...A.filter(P=>!_.equals(this._defaultConfiguration.override(T).getValue(P),s.override(T).getValue(P)))];u.push([T,k])}return this.updateDefaultConfiguration(s),{keys:c,overrides:u}}compareAndUpdatePolicyConfiguration(s){const{added:c,updated:u,removed:I}=l(this._policyConfiguration,s),T=[...c,...u,...I];return T.length&&this.updatePolicyConfiguration(s),{keys:T,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:c,updated:u,removed:I,overrides:T}=l(this.applicationConfiguration,s),A=[...c,...u,...I];return A.length&&this.updateApplicationConfiguration(s),{keys:A,overrides:T}}compareAndUpdateLocalUserConfiguration(s){const{added:c,updated:u,removed:I,overrides:T}=l(this.localUserConfiguration,s),A=[...c,...u,...I];return A.length&&this.updateLocalUserConfiguration(s),{keys:A,overrides:T}}compareAndUpdateRemoteUserConfiguration(s){const{added:c,updated:u,removed:I,overrides:T}=l(this.remoteUserConfiguration,s),A=[...c,...u,...I];return A.length&&this.updateRemoteUserConfiguration(s),{keys:A,overrides:T}}compareAndUpdateWorkspaceConfiguration(s){const{added:c,updated:u,removed:I,overrides:T}=l(this.workspaceConfiguration,s),A=[...c,...u,...I];return A.length&&this.updateWorkspaceConfiguration(s),{keys:A,overrides:T}}compareAndUpdateFolderConfiguration(s,c){const u=this.folderConfigurations.get(s),{added:I,updated:T,removed:A,overrides:O}=l(u,c),k=[...I,...T,...A];return(k.length||!u)&&this.updateFolderConfiguration(s,c),{keys:k,overrides:O}}compareAndDeleteFolderConfiguration(s){const c=this.folderConfigurations.get(s);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:u,updated:I,removed:T,overrides:A}=l(c,void 0);return{keys:[...u,...I,...T],overrides:A}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,c,u){let I=this.getConsolidatedConfigurationModelForResource(c,u);return c.overrideIdentifier&&(I=I.override(c.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(I=I.merge(this._policyConfiguration)),I}getConsolidatedConfigurationModelForResource({resource:s},c){let u=this.getWorkspaceConsolidatedConfiguration();if(c&&s){const I=c.getFolder(s);I&&(u=this.getFolderConsolidatedConfiguration(I.uri)||u);const T=this._memoryConfigurationByResource.get(s);T&&(u=u.merge(T))}return u}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let c=this._foldersConsolidatedConfigurations.get(s);if(!c){const u=this.getWorkspaceConsolidatedConfiguration(),I=this._folderConfigurations.get(s);I?(c=u.merge(I),this._foldersConsolidatedConfigurations.set(s,c)):c=u}return c}getFolderConfigurationModelForResource(s,c){if(c&&s){const u=c.getFolder(s);if(u)return this._folderConfigurations.get(u.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,c)=>{const{contents:u,overrides:I,keys:T}=this._folderConfigurations.get(c);return s.push([c,{contents:u,overrides:I,keys:T}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.keys.forEach(c=>s.add(c)),this.userConfiguration.keys.forEach(c=>s.add(c)),this._workspaceConfiguration.keys.forEach(c=>s.add(c)),this._folderConfigurations.forEach(c=>c.keys.forEach(u=>s.add(u))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this._folderConfigurations.forEach(c=>c.getAllOverrideIdentifiers().forEach(u=>s.add(u))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const c=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(u=>c.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(u=>c.add(u)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(u=>c.add(u)),this._folderConfigurations.forEach(u=>u.getKeysForOverrideIdentifier(s).forEach(I=>c.add(I))),[...c.values()]}static parse(s,c){const u=this.parseConfigurationModel(s.defaults,c),I=this.parseConfigurationModel(s.policy,c),T=this.parseConfigurationModel(s.application,c),A=this.parseConfigurationModel(s.user,c),O=this.parseConfigurationModel(s.workspace,c),k=s.folders.reduce((P,B)=>(P.set(o.URI.revive(B[0]),this.parseConfigurationModel(B[1],c)),P),new R.ResourceMap);return new g(u,I,T,A,f.createEmptyModel(c),O,k,f.createEmptyModel(c),new R.ResourceMap,c)}static parseConfigurationModel(s,c){return new f(s.contents,s.keys,s.overrides,void 0,c)}}e.Configuration=g;function v(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const s=new Set,c=new Map;for(const I of h)I.keys.forEach(T=>s.add(T)),I.overrides.forEach(([T,A])=>{const O=(0,R.getOrSet)(c,T,new Set);A.forEach(k=>O.add(k))});const u=[];return c.forEach((I,T)=>u.push([T,[...I.values()]])),{keys:[...s.values()],overrides:u}}class t{constructor(s,c,u,I,T){this.change=s,this.previous=c,this.currentConfiguraiton=u,this.currentWorkspace=I,this.logService=T,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const A of s.keys)this.affectedKeys.add(A);for(const[,A]of s.overrides)for(const O of A)this.affectedKeys.add(O);this._affectsConfigStr=this._marker;for(const A of this.affectedKeys)this._affectsConfigStr+=A+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(s,c){const u=this._marker+s,I=this._affectsConfigStr.indexOf(u);if(I<0)return!1;const T=I+u.length;if(T>=this._affectsConfigStr.length)return!1;const A=this._affectsConfigStr.charCodeAt(T);if(A!==this._markerCode1&&A!==this._markerCode2)return!1;if(c){const O=this.previousConfiguration?this.previousConfiguration.getValue(s,c,this.previous?.workspace):void 0,k=this.currentConfiguraiton.getValue(s,c,this.currentWorkspace);return!_.equals(O,k)}return!0}}e.ConfigurationChangeEvent=t;function l(h,s){const{added:c,removed:u,updated:I}=n(s?.rawConfiguration,h?.rawConfiguration),T=[],A=h?.getAllOverrideIdentifiers()||[],O=s?.getAllOverrideIdentifiers()||[];if(s){const k=O.filter(P=>!A.includes(P));for(const P of k)T.push([P,s.getKeysForOverrideIdentifier(P)])}if(h){const k=A.filter(P=>!O.includes(P));for(const P of k)T.push([P,h.getKeysForOverrideIdentifier(P)])}if(s&&h){for(const k of A)if(O.includes(k)){const P=n({contents:h.getOverrideValue(void 0,k)||{},keys:h.getKeysForOverrideIdentifier(k)},{contents:s.getOverrideValue(void 0,k)||{},keys:s.getKeysForOverrideIdentifier(k)});T.push([k,[...P.added,...P.removed,...P.updated]])}}return{added:c,removed:u,updated:I,overrides:T}}function n(h,s){const c=h?s?h.keys.filter(T=>s.keys.indexOf(T)===-1):[...h.keys]:[],u=s?h?s.keys.filter(T=>h.keys.indexOf(T)===-1):[...s.keys]:[],I=[];if(h&&s){for(const T of s.keys)if(h.keys.indexOf(T)!==-1){const A=(0,D.getConfigurationValue)(s.contents,T),O=(0,D.getConfigurationValue)(h.contents,T);_.equals(A,O)||I.push(T)}}return{added:c,removed:u,updated:I}}}),define(ye[263],Ie([1,0,18,6,2,21,11,128,46,12,73,38]),function(se,e,i,r,w,C,R,_,b,o,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class d extends w.Disposable{get configurationModel(){return this._configurationModel}constructor(m){super(),this.logService=m,this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=_.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.resetConfigurationModel(),this._register(y.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:p})=>this.onDidUpdateConfiguration(Array.from(m),p))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(m,p){this.updateConfigurationModel(m,y.Registry.as(b.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:m})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=_.ConfigurationModel.createEmptyModel(this.logService);const m=y.Registry.as(b.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(m),m)}updateConfigurationModel(m,p){const S=this.getConfigurationDefaultOverrides();for(const g of m){const v=S[g],t=p[g];v!==void 0?this._configurationModel.addValue(g,v):t?this._configurationModel.addValue(g,t.default):this._configurationModel.removeValue(g)}}}e.DefaultConfiguration=d;class E{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=_.ConfigurationModel.createEmptyModel(new o.NullLogService)}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=E;let a=class extends w.Disposable{get configurationModel(){return this._configurationModel}constructor(m,p,S){super(),this.defaultConfiguration=m,this.policyService=p,this.logService=S,this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=_.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(m=>this.onDidChangePolicies(m))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:m})=>this.update(await this.updatePolicyDefinitions(m),!0))),this._configurationModel}async updatePolicyDefinitions(m){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",m);const p={},S=[],g=y.Registry.as(b.Extensions.Configuration).getConfigurationProperties();for(const v of m){const t=g[v];if(!t){S.push(v);continue}if(t.policy){if(t.type!=="string"&&t.type!=="number"){this.logService.warn(`Policy ${t.policy.name} has unsupported type ${t.type}`);continue}S.push(v),p[t.policy.name]={type:t.type}}}return(0,R.isEmptyObject)(p)||await this.policyService.updatePolicyDefinitions(p),S}onDidChangePolicies(m){this.logService.trace("PolicyConfiguration#onDidChangePolicies",m);const p=y.Registry.as(b.Extensions.Configuration).getPolicyConfigurations(),S=(0,i.coalesce)(m.map(g=>p.get(g)));this.update(S,!0)}update(m,p){this.logService.trace("PolicyConfiguration#update",m);const S=y.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),g=[],v=this._configurationModel.isEmpty();for(const t of m){const l=S[t]?.policy?.name;if(l){const n=this.policyService.getPolicyValue(l);(v?n!==void 0:!(0,C.equals)(this._configurationModel.getValue(t),n))&&g.push([t,n])}else this._configurationModel.getValue(t)!==void 0&&g.push([t,void 0])}if(g.length){this.logService.trace("PolicyConfiguration#changed",g);const t=this._configurationModel;this._configurationModel=_.ConfigurationModel.createEmptyModel(this.logService);for(const l of t.keys)this._configurationModel.setValue(l,t.getValue(l));for(const[l,n]of g)n===void 0?this._configurationModel.removeValue(l):this._configurationModel.setValue(l,n);p&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=a,e.PolicyConfiguration=a=ze([Me(1,D.IPolicyService),Me(2,o.ILogService)],a)}),define(ye[129],Ie([1,0,18,14,15,6,43,160,2,26,21,3,20,27,128,46,263,16,73]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a,f,m,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class g extends b.Disposable{constructor(l,n,h,s){super(),this.settingsResource=l,this.logService=s,this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new m.DefaultConfiguration(s)),this.policyConfiguration=h instanceof S.NullPolicyService?new m.NullPolicyConfiguration:this._register(new m.PolicyConfiguration(this.defaultConfiguration,h,s)),this.userConfiguration=this._register(new a.UserSettings(this.settingsResource,{},d.extUriBiasedIgnorePathCase,n,s)),this.configuration=new a.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,a.ConfigurationModel.createEmptyModel(s),a.ConfigurationModel.createEmptyModel(s),a.ConfigurationModel.createEmptyModel(s),a.ConfigurationModel.createEmptyModel(s),new o.ResourceMap,a.ConfigurationModel.createEmptyModel(s),new o.ResourceMap,s),this.configurationEditing=new v(l,n,this),this.reloadConfigurationScheduler=this._register(new r.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:c,properties:u})=>this.onDidDefaultConfigurationChange(c,u))),this._register(this.policyConfiguration.onDidChangeConfiguration(c=>this.onDidPolicyConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[l,n,h]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new a.Configuration(l,n,a.ConfigurationModel.createEmptyModel(this.logService),h,a.ConfigurationModel.createEmptyModel(this.logService),a.ConfigurationModel.createEmptyModel(this.logService),new o.ResourceMap,a.ConfigurationModel.createEmptyModel(this.logService),new o.ResourceMap,this.logService)}getConfigurationData(){return this.configuration.toData()}getValue(l,n){const h=typeof l=="string"?l:void 0,s=(0,E.isConfigurationOverrides)(l)?l:(0,E.isConfigurationOverrides)(n)?n:{};return this.configuration.getValue(h,s,void 0)}async updateValue(l,n,h,s,c){const u=(0,E.isConfigurationUpdateOverrides)(h)?h:(0,E.isConfigurationOverrides)(h)?{resource:h.resource,overrideIdentifiers:h.overrideIdentifier?[h.overrideIdentifier]:void 0}:void 0,I=u?s:h;if(I!==void 0&&I!==E.ConfigurationTarget.USER_LOCAL&&I!==E.ConfigurationTarget.USER)throw new Error(`Unable to write ${l} to target ${I}.`);u?.overrideIdentifiers&&(u.overrideIdentifiers=(0,i.distinct)(u.overrideIdentifiers),u.overrideIdentifiers=u.overrideIdentifiers.length?u.overrideIdentifiers:void 0);const T=this.inspect(l,{resource:u?.resource,overrideIdentifier:u?.overrideIdentifiers?u.overrideIdentifiers[0]:void 0});if(T.policyValue!==void 0)throw new Error(`Unable to write ${l} because it is configured in system policy.`);if((0,D.equals)(n,T.defaultValue)&&(n=void 0),u?.overrideIdentifiers?.length&&u.overrideIdentifiers.length>1){const O=u.overrideIdentifiers.sort(),k=this.configuration.localUserConfiguration.overrides.find(P=>(0,i.equals)([...P.identifiers].sort(),O));k&&(u.overrideIdentifiers=k.identifiers)}const A=u?.overrideIdentifiers?.length?[(0,f.keyFromOverrideIdentifiers)(u.overrideIdentifiers),l]:[l];await this.configurationEditing.write(A,n),await this.reloadConfiguration()}inspect(l,n={}){return this.configuration.inspect(l,n,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const l=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(l)}onDidChangeUserConfiguration(l){const n=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(l);this.trigger(h,n,E.ConfigurationTarget.USER)}onDidDefaultConfigurationChange(l,n){const h=this.configuration.toData(),s=this.configuration.compareAndUpdateDefaultConfiguration(l,n);this.trigger(s,h,E.ConfigurationTarget.DEFAULT)}onDidPolicyConfigurationChange(l){const n=this.configuration.toData(),h=this.configuration.compareAndUpdatePolicyConfiguration(l);this.trigger(h,n,E.ConfigurationTarget.DEFAULT)}trigger(l,n,h){const s=new a.ConfigurationChangeEvent(l,{data:n},this.configuration,void 0,this.logService);s.source=h,this._onDidChangeConfiguration.fire(s)}}e.ConfigurationService=g;class v{constructor(l,n,h){this.settingsResource=l,this.fileService=n,this.configurationService=h,this.queue=new r.Queue}write(l,n){return this.queue.queue(()=>this.doWriteConfiguration(l,n))}async doWriteConfiguration(l,n){let h;try{h=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(u){if(u.fileOperationResult===p.FileOperationResult.FILE_NOT_FOUND)h="{}";else throw u}const s=[];if((0,R.parse)(h,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const c=this.getEdits(h,l,n);h=(0,_.applyEdits)(h,c),await this.fileService.writeFile(this.settingsResource,w.VSBuffer.fromString(h))}getEdits(l,n,h){const{tabSize:s,insertSpaces:c,eol:u}=this.formattingOptions;if(!n.length){const I=JSON.stringify(h,null,c?" ".repeat(s):"	");return[{content:I,length:I.length,offset:0}]}return(0,_.setProperty)(l,n,h,{tabSize:s,insertSpaces:c,eol:u})}get formattingOptions(){if(!this._formattingOptions){let l=y.OS===y.OperatingSystem.Linux||y.OS===y.OperatingSystem.Macintosh?`
`:`\r
`;const n=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(l=n),this._formattingOptions={eol:l,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(ye[90],Ie([1,0,10,5]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=o,e.IRemoteAuthorityResolverService=(0,r.createDecorator)("remoteAuthorityResolverService");var w;(function(D){D[D.WebSocket=0]="WebSocket",D[D.Managed=1]="Managed"})(w||(e.RemoteConnectionType=w={}));class C{constructor(y){this.id=y,this.type=w.Managed}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=C;class R{constructor(y,d){this.host=y,this.port=d,this.type=w.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=R;var _;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound",D.InvalidAuthority="InvalidAuthority"})(_||(e.RemoteAuthorityResolverErrorCode=_={}));class b extends i.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof b&&y._code===_.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof b&&y._code===_.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof b&&y._code===_.NoResolverFound}static isInvalidAuthority(y){return y instanceof b&&y._code===_.InvalidAuthority}static isHandled(y){return y instanceof b&&y.isHandled}constructor(y,d=_.Unknown,E){super(y),this._message=y,this._code=d,this._detail=E,this.isHandled=d===_.NotAvailable&&E===!0,Object.setPrototypeOf(this,b.prototype)}}e.RemoteAuthorityResolverError=b;function o(D){const y=D.indexOf("+");return y===-1?D:D.substring(0,y)}}),define(ye[264],Ie([1,0,14,15,19,10,6,2,13,44,48,23,61,90]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.connectRemoteAgentManagement=T,e.connectRemoteAgentExtensionHost=A,e.connectRemoteAgentTunnel=k,o=Be(o);const a=30*1e3;var f;(function(J){J[J.Management=1]="Management",J[J.ExtensionHost=2]="ExtensionHost",J[J.Tunnel=3]="Tunnel"})(f||(e.ConnectionType=f={}));function m(J){switch(J){case f.Management:return"Management";case f.ExtensionHost:return"ExtensionHost";case f.Tunnel:return"Tunnel"}}function p(J){const W=new w.CancellationTokenSource;return setTimeout(()=>W.cancel(),J),W.token}function S(J,W){if(J.isCancellationRequested||W.isCancellationRequested)return w.CancellationToken.Cancelled;const L=new w.CancellationTokenSource;return J.onCancellationRequested(()=>L.cancel()),W.onCancellationRequested(()=>L.cancel()),L.token}class g{get didTimeout(){return this._state==="timedout"}constructor(W){this._state="pending",this._disposables=new _.DisposableStore,{promise:this.promise,resolve:this._resolvePromise,reject:this._rejectPromise}=(0,i.promiseWithResolvers)(),W.isCancellationRequested?this._timeout():this._disposables.add(W.onCancellationRequested(()=>this._timeout()))}registerDisposable(W){this._state==="pending"?this._disposables.add(W):W.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(W))}reject(W){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(W))}}function v(J,W){const L=new g(W);return L.registerDisposable(J.onControlMessage(Q=>{const $=JSON.parse(Q.toString()),U=z($);U?L.reject(U):L.resolve($)})),L.promise}function t(J,W,L,Q,$,U,q,G){const F=new g(G),V=D.StopWatch.create(!1);return J.info(`Creating a socket (${q})...`),o.mark(`code/willCreateSocket/${U}`),W.connect(L,Q,$,q).then(oe=>{F.didTimeout?(o.mark(`code/didCreateSocketError/${U}`),J.info(`Creating a socket (${q}) finished after ${V.elapsed()} ms, but this is too late and has timed out already.`),oe?.dispose()):(o.mark(`code/didCreateSocketOK/${U}`),J.info(`Creating a socket (${q}) was successful after ${V.elapsed()} ms.`),F.resolve(oe))},oe=>{o.mark(`code/didCreateSocketError/${U}`),J.info(`Creating a socket (${q}) returned an error after ${V.elapsed()} ms.`),J.error(oe),F.reject(oe)}),F.promise}function l(J,W){const L=new g(W);return J.then(Q=>{L.didTimeout||L.resolve(Q)},Q=>{L.didTimeout||L.reject(Q)}),L.promise}async function n(J,W,L,Q){const $=H(J,W);J.logService.trace(`${$} 1/6. invoking socketFactory.connect().`);let U;try{U=await t(J.logService,J.remoteSocketFactoryService,J.connectTo,b.RemoteAuthorities.getServerRootPath(),`reconnectionToken=${J.reconnectionToken}&reconnection=${J.reconnectionProtocol?"true":"false"}`,m(W),`renderer-${m(W)}-${J.reconnectionToken}`,Q)}catch(oe){throw J.logService.error(`${$} socketFactory.connect() failed or timed out. Error:`),J.logService.error(oe),oe}J.logService.trace(`${$} 2/6. socketFactory.connect() was successful.`);let q,G;J.reconnectionProtocol?(J.reconnectionProtocol.beginAcceptReconnection(U,null),q=J.reconnectionProtocol,G=!1):(q=new d.PersistentProtocol({socket:U}),G=!0),J.logService.trace(`${$} 3/6. sending AuthRequest control message.`);const F=await l(J.signService.createNewMessage((0,y.generateUuid)()),Q),V={type:"auth",auth:J.connectionToken||"00000000000000000000",data:F.data};q.sendControl(r.VSBuffer.fromString(JSON.stringify(V)));try{const oe=await v(q,S(Q,p(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const ge=new Error("Unexpected handshake message");throw ge.code="VSCODE_CONNECTION_ERROR",ge}if(J.logService.trace(`${$} 4/6. received SignRequest control message.`),!await l(J.signService.validate(F,oe.signedData),Q)){const ge=new Error("Refused to connect to unsupported server");throw ge.code="VSCODE_CONNECTION_ERROR",ge}const Ce=await l(J.signService.sign(oe.data),Q),Ne={type:"connectionType",commit:J.commit,signedData:Ce,desiredConnectionType:W};return L&&(Ne.args=L),J.logService.trace(`${$} 5/6. sending ConnectionTypeRequest control message.`),q.sendControl(r.VSBuffer.fromString(JSON.stringify(Ne))),{protocol:q,ownsProtocol:G}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&(J.logService.error(`${$} the handshake timed out. Error:`),J.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&(J.logService.error(`${$} received error control message when negotiating connection. Error:`),J.logService.error(oe)),G&&x(q),oe}}async function h(J,W,L,Q){const $=Date.now(),U=H(J,W),{protocol:q,ownsProtocol:G}=await n(J,W,L,Q),F=new g(Q);return F.registerDisposable(q.onControlMessage(V=>{const oe=JSON.parse(V.toString()),de=z(oe);de?(J.logService.error(`${U} received error control message when negotiating connection. Error:`),J.logService.error(de),G&&x(q),F.reject(de)):(J.reconnectionProtocol?.endAcceptReconnection(),J.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${ce($)}!`),F.resolve({protocol:q,firstMessage:oe}))})),F.promise}async function s(J,W){const{protocol:L}=await h(J,f.Management,void 0,W);return{protocol:L}}async function c(J,W,L){const{protocol:Q,firstMessage:$}=await h(J,f.ExtensionHost,W,L),U=$&&$.debugPort;return{protocol:Q,debugPort:U}}async function u(J,W,L){const Q=Date.now(),$=H(J,f.Tunnel),{protocol:U}=await n(J,f.Tunnel,W,L);return J.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${ce(Q)}!`),U}async function I(J,W,L){const{connectTo:Q,connectionToken:$}=await J.addressProvider.getAddress();return{commit:J.commit,quality:J.quality,connectTo:Q,connectionToken:$,reconnectionToken:W,reconnectionProtocol:L,remoteSocketFactoryService:J.remoteSocketFactoryService,signService:J.signService,logService:J.logService}}async function T(J,W,L){return O(J,async Q=>{const{protocol:$}=await s(Q,w.CancellationToken.None);return new K(J,W,L,Q.reconnectionToken,$)})}async function A(J,W){return O(J,async L=>{const{protocol:Q,debugPort:$}=await c(L,W,w.CancellationToken.None);return new ae(J,W,L.reconnectionToken,Q,$)})}async function O(J,W){for(let Q=1;;Q++)try{const $=(0,y.generateUuid)(),U=await I(J,$,null);return await W(U)}catch($){if(Q<5)J.logService.error(`[remote-connection][attempt ${Q}] An error occurred in initial connection! Will retry... Error:`),J.logService.error($);else throw J.logService.error(`[remote-connection][attempt ${Q}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),J.logService.error($),fe.triggerPermanentFailure(0,0,E.RemoteAuthorityResolverError.isHandled($)),$}}async function k(J,W,L){const Q=await I(J,(0,y.generateUuid)(),null);return await u(Q,{host:W,port:L},w.CancellationToken.None)}function P(J){return(0,i.createCancelablePromise)(W=>new Promise((L,Q)=>{const $=setTimeout(L,J*1e3);W.onCancellationRequested(()=>{clearTimeout($),L()})}))}var B;(function(J){J[J.ConnectionLost=0]="ConnectionLost",J[J.ReconnectionWait=1]="ReconnectionWait",J[J.ReconnectionRunning=2]="ReconnectionRunning",J[J.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",J[J.ConnectionGain=4]="ConnectionGain"})(B||(e.PersistentConnectionEventType=B={}));class Y{constructor(W,L){this.reconnectionToken=W,this.millisSinceLastIncomingData=L,this.type=B.ConnectionLost}}e.ConnectionLostEvent=Y;class X{constructor(W,L,Q,$){this.reconnectionToken=W,this.millisSinceLastIncomingData=L,this.durationSeconds=Q,this.cancellableTimer=$,this.type=B.ReconnectionWait}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=X;class re{constructor(W,L,Q){this.reconnectionToken=W,this.millisSinceLastIncomingData=L,this.attempt=Q,this.type=B.ReconnectionRunning}}e.ReconnectionRunningEvent=re;class te{constructor(W,L,Q){this.reconnectionToken=W,this.millisSinceLastIncomingData=L,this.attempt=Q,this.type=B.ConnectionGain}}e.ConnectionGainEvent=te;class Z{constructor(W,L,Q,$){this.reconnectionToken=W,this.millisSinceLastIncomingData=L,this.attempt=Q,this.handled=$,this.type=B.ReconnectionPermanentFailure}}e.ReconnectionPermanentFailureEvent=Z;class fe extends _.Disposable{static triggerPermanentFailure(W,L,Q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=W,this._permanentFailureAttempt=L,this._permanentFailureHandled=Q,this._instances.forEach($=>$._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(W=>W._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(W=>W._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||fe._permanentFailure}constructor(W,L,Q,$,U){super(),this._connectionType=W,this._options=L,this.reconnectionToken=Q,this.protocol=$,this._reconnectionFailureIsFatal=U,this._onDidStateChange=this._register(new R.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new te(this.reconnectionToken,0,0)),this._register($.onSocketClose(q=>{const G=ve(this._connectionType,this.reconnectionToken,!0);q?q.type===d.SocketCloseEventType.NodeSocketCloseEvent?(this._options.logService.info(`${G} received socket close event (hadError: ${q.hadError}).`),q.error&&this._options.logService.error(q.error)):(this._options.logService.info(`${G} received socket close event (wasClean: ${q.wasClean}, code: ${q.code}, reason: ${q.reason}).`),q.event&&this._options.logService.error(q.event)):this._options.logService.info(`${G} received socket close event.`),this._beginReconnecting()})),this._register($.onSocketTimeout(q=>{const G=ve(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${G} received socket timeout event (unacknowledgedMsgCount: ${q.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${q.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${q.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),fe._instances.push(this),this._register((0,_.toDisposable)(()=>{const q=fe._instances.indexOf(this);q>=0&&fe._instances.splice(q,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(fe._permanentFailureMillisSinceLastIncomingData,fe._permanentFailureAttempt,fe._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const W=ve(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let Q=-1;do{Q++;const $=Q<L.length?L[Q]:L[L.length-1];try{if($>0){const q=P($);this._onDidStateChange.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$,q)),this._options.logService.info(`${W} waiting for ${$} seconds before reconnecting...`);try{await q}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1)),this._options.logService.info(`${W} resolving connection...`);const U=await I(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${W} connecting to ${U.connectTo}...`),await this._reconnect(U,p(a)),this._options.logService.info(`${W} reconnected!`),this._onDidStateChange.fire(new te(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1));break}catch(U){if(U.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(U),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(Q>360){this._options.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(U),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(E.RemoteAuthorityResolverError.isTemporarilyNotAvailable(U)){this._options.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if((U.code==="ETIMEDOUT"||U.code==="ENETUNREACH"||U.code==="ECONNREFUSED"||U.code==="ECONNRESET")&&U.syscall==="connect"){this._options.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if((0,C.isCancellationError)(U)){this._options.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if(U instanceof E.RemoteAuthorityResolverError){this._options.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(U),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,E.RemoteAuthorityResolverError.isHandled(U));break}this._options.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(U),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(W,L,Q){this._reconnectionFailureIsFatal?fe.triggerPermanentFailure(W,L,Q):this._gotoPermanentFailure(W,L,Q)}_gotoPermanentFailure(W,L,Q){this._onDidStateChange.fire(new Z(this.reconnectionToken,W,L,Q)),x(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=fe;class K extends fe{constructor(W,L,Q,$,U){super(f.Management,W,$,U,!0),this.client=this._register(new d.Client(U,{remoteAuthority:L,clientId:Q},W.ipcLogger))}async _reconnect(W,L){await s(W,L)}}e.ManagementPersistentConnection=K;class ae extends fe{constructor(W,L,Q,$,U){super(f.ExtensionHost,W,Q,$,!1),this._startArguments=L,this.debugPort=U}async _reconnect(W,L){await c(W,this._startArguments,L)}}e.ExtensionHostPersistentConnection=ae;function x(J){try{J.acceptDisconnect();const W=J.getSocket();J.dispose(),W.dispose()}catch(W){(0,C.onUnexpectedError)(W)}}function z(J){if(J&&J.type==="error"){const W=new Error(`Connection error: ${J.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function ne(J,W){for(;J.length<W;)J+=" ";return J}function le(J,W){return`[remote-connection][${ne(m(J),13)}][${W.substr(0,5)}\u2026]`}function ve(J,W,L){return`${le(J,W)}[${L?"reconnect":"initial"}]`}function H(J,W){return`${ve(W,J.reconnectionToken,!!J.reconnectionProtocol)}[${J.connectTo}]`}function ce(J){return`${Date.now()-J} ms`}}),define(ye[265],Ie([1,0,5]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteExtensionsScannerChannelName=e.IRemoteExtensionsScannerService=void 0,e.IRemoteExtensionsScannerService=(0,i.createDecorator)("IRemoteExtensionsScannerService"),e.RemoteExtensionsScannerChannelName="remoteExtensionsScanner"}),define(ye[91],Ie([1,0,13]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=r,e.getRemoteName=w,e.parseAuthorityWithPort=C,e.parseAuthorityWithOptionalPort=R;function r(b){return b.scheme===i.Schemas.vscodeRemote?b.authority:void 0}function w(b){if(!b)return;const o=b.indexOf("+");return o<0?b:b.substr(0,o)}function C(b){const{host:o,port:D}=_(b);if(typeof D>"u")throw new Error(`Invalid remote authority: ${b}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:o,port:D}}function R(b,o){let{host:D,port:y}=_(b);return typeof y>"u"&&(y=o),{host:D,port:y}}function _(b){const o=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(o)return{host:o[1],port:parseInt(o[2],10)};const D=b.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const y=b.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:b,port:void 0}}}),define(ye[22],Ie([1,0,17,5,91]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=C,e.isApplicationScopedExtension=y,e.isLanguagePackExtension=d,e.isAuthenticationProviderExtension=E,e.isResolverExtension=a,e.parseApiProposals=f,e.parseEnabledApiProposalNames=m,i=Be(i),e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.EXTENSION_CATEGORIES=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(R||(e.ExtensionType=R={}));var _;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.LINUX_PPC64LE="linux-ppc64le",p.LINUX_RISCV64="linux-riscv64",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(_||(e.TargetPlatform=_={}));class b{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,g){if(typeof S>"u"||S===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof S=="string"||typeof g=="string"){const v=typeof S=="string"?S:S.value,t=typeof g=="string"?g:g.value;return i.equalsIgnoreCase(v,t)}return S._lower===g._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=b;class o{get size(){return this._set.size}constructor(S){if(this._set=new Set,S)for(const g of S)this.add(g)}add(S){this._set.add(b.toKey(S))}delete(S){return this._set.delete(b.toKey(S))}has(S){return this._set.has(b.toKey(S))}}e.ExtensionIdentifierSet=o;class D{constructor(){this._map=new Map}clear(){this._map.clear()}delete(S){this._map.delete(b.toKey(S))}get(S){return this._map.get(b.toKey(S))}has(S){return this._map.has(b.toKey(S))}set(S,g){this._map.set(b.toKey(S),g)}values(){return this._map.values()}forEach(S){this._map.forEach(S)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=D;function y(p){return d(p)}function d(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}function E(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}function a(p,S){if(S){const g=`onResolveRemoteAuthority:${(0,w.getRemoteName)(S)}`;return!!p.activationEvents?.includes(g)}return!1}function f(p){return p.map(S=>{const[g,v]=S.split("@");return{proposalName:g,version:v?parseInt(v):void 0}})}function m(p){return p.map(S=>S.split("@")[0])}e.IBuiltinExtensionsScannerService=(0,r.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[30],Ie([1,0,3,208,22,5]),function(se,e,i,r,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SOURCE_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=_,e.toTargetPlatform=b,e.getTargetPlatform=o,e.isNotWebExtensionInWebTargetPlatform=D,e.isTargetPlatformCompatible=y,e.isIExtensionIdentifier=d,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SOURCE_CONTEXT="extensionInstallSource",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall",e.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT="clientTargetPlatform";var R;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(R||(e.ExtensionInstallSource=R={}));function _(t){switch(t){case w.TargetPlatform.WIN32_X64:return"Windows 64 bit";case w.TargetPlatform.WIN32_ARM64:return"Windows ARM";case w.TargetPlatform.LINUX_X64:return"Linux 64 bit";case w.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case w.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case w.TargetPlatform.LINUX_PPC64LE:return"Linux PowerPC64";case w.TargetPlatform.LINUX_RISCV64:return"Linux RISC-V 64";case w.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case w.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case w.TargetPlatform.DARWIN_X64:return"Mac";case w.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case w.TargetPlatform.WEB:return"Web";case w.TargetPlatform.UNIVERSAL:return w.TargetPlatform.UNIVERSAL;case w.TargetPlatform.UNKNOWN:return w.TargetPlatform.UNKNOWN;case w.TargetPlatform.UNDEFINED:return w.TargetPlatform.UNDEFINED}}function b(t){switch(t){case w.TargetPlatform.WIN32_X64:return w.TargetPlatform.WIN32_X64;case w.TargetPlatform.WIN32_ARM64:return w.TargetPlatform.WIN32_ARM64;case w.TargetPlatform.LINUX_X64:return w.TargetPlatform.LINUX_X64;case w.TargetPlatform.LINUX_ARM64:return w.TargetPlatform.LINUX_ARM64;case w.TargetPlatform.LINUX_ARMHF:return w.TargetPlatform.LINUX_ARMHF;case w.TargetPlatform.LINUX_PPC64LE:return w.TargetPlatform.LINUX_PPC64LE;case w.TargetPlatform.LINUX_RISCV64:return w.TargetPlatform.LINUX_RISCV64;case w.TargetPlatform.ALPINE_X64:return w.TargetPlatform.ALPINE_X64;case w.TargetPlatform.ALPINE_ARM64:return w.TargetPlatform.ALPINE_ARM64;case w.TargetPlatform.DARWIN_X64:return w.TargetPlatform.DARWIN_X64;case w.TargetPlatform.DARWIN_ARM64:return w.TargetPlatform.DARWIN_ARM64;case w.TargetPlatform.WEB:return w.TargetPlatform.WEB;case w.TargetPlatform.UNIVERSAL:return w.TargetPlatform.UNIVERSAL;default:return w.TargetPlatform.UNKNOWN}}function o(t,l){switch(t){case i.Platform.Windows:return l==="x64"?w.TargetPlatform.WIN32_X64:l==="arm64"?w.TargetPlatform.WIN32_ARM64:w.TargetPlatform.UNKNOWN;case i.Platform.Linux:return l==="x64"?w.TargetPlatform.LINUX_X64:l==="arm64"?w.TargetPlatform.LINUX_ARM64:l==="arm"?w.TargetPlatform.LINUX_ARMHF:l==="ppc64le"?w.TargetPlatform.LINUX_PPC64LE:l==="riscv64"?w.TargetPlatform.LINUX_RISCV64:w.TargetPlatform.UNKNOWN;case"alpine":return l==="x64"?w.TargetPlatform.ALPINE_X64:l==="arm64"?w.TargetPlatform.ALPINE_ARM64:w.TargetPlatform.UNKNOWN;case i.Platform.Mac:return l==="x64"?w.TargetPlatform.DARWIN_X64:l==="arm64"?w.TargetPlatform.DARWIN_ARM64:w.TargetPlatform.UNKNOWN;case i.Platform.Web:return w.TargetPlatform.WEB}}function D(t,l){return l===w.TargetPlatform.WEB&&!t.includes(w.TargetPlatform.WEB)}function y(t,l,n){return D(l,n)?!1:t===w.TargetPlatform.UNDEFINED||t===w.TargetPlatform.UNIVERSAL?!0:t===w.TargetPlatform.UNKNOWN?!1:t===n}function d(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var E;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var a;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(a||(e.SortOrder=a={}));var f;(function(t){t.Install="install",t.Uninstall="uninstall"})(f||(e.StatisticType=f={}));var m;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var p;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(p||(e.ExtensionGalleryErrorCode=p={}));class S extends Error{constructor(l,n){super(l),this.code=n,this.name=n}}e.ExtensionGalleryError=S;var g;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(g||(e.ExtensionManagementErrorCode=g={}));class v extends Error{constructor(l,n){super(l),this.code=n,this.name=n}}e.ExtensionManagementError=v,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,r.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,r.localize2)(1,"Preferences")}),define(ye[266],Ie([1,0,6,2,21,4,59,30]),function(se,e,i,r,w,C,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(m,p){return m?C.URI.revive(p?p.transformIncoming(m):m):void 0}function o(m,p){return p?p.transformOutgoingURI(m):m}function D(m,p){p=p||R.DefaultURITransformer;const S=m.manifest;return{...(0,R.transformAndReviveIncomingURIs)({...m,manifest:void 0},p),manifest:S}}function y(m,p){return m?.profileLocation?(0,R.transformAndReviveIncomingURIs)(m,p??R.DefaultURITransformer):m}function d(m,p){return p?(0,w.cloneAndChange)(m,S=>S instanceof C.URI?p.transformOutgoingURI(S):void 0):m}class E{constructor(p,S){this.service=p,this.getUriTransformer=S,this.onInstallExtension=i.Event.buffer(p.onInstallExtension,!0),this.onDidInstallExtensions=i.Event.buffer(p.onDidInstallExtensions,!0),this.onUninstallExtension=i.Event.buffer(p.onUninstallExtension,!0),this.onDidUninstallExtension=i.Event.buffer(p.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=i.Event.buffer(p.onDidUpdateExtensionMetadata,!0)}listen(p,S){const g=this.getUriTransformer(p);switch(S){case"onInstallExtension":return i.Event.map(this.onInstallExtension,v=>({...v,profileLocation:v.profileLocation?o(v.profileLocation,g):v.profileLocation}));case"onDidInstallExtensions":return i.Event.map(this.onDidInstallExtensions,v=>v.map(t=>({...t,local:t.local?d(t.local,g):t.local,profileLocation:t.profileLocation?o(t.profileLocation,g):t.profileLocation})));case"onUninstallExtension":return i.Event.map(this.onUninstallExtension,v=>({...v,profileLocation:v.profileLocation?o(v.profileLocation,g):v.profileLocation}));case"onDidUninstallExtension":return i.Event.map(this.onDidUninstallExtension,v=>({...v,profileLocation:v.profileLocation?o(v.profileLocation,g):v.profileLocation}));case"onDidUpdateExtensionMetadata":return i.Event.map(this.onDidUpdateExtensionMetadata,v=>({local:d(v.local,g),profileLocation:o(v.profileLocation,g)}))}throw new Error("Invalid listen")}async call(p,S,g){const v=this.getUriTransformer(p);switch(S){case"zip":{const t=D(g[0],v),l=await this.service.zip(t);return o(l,v)}case"unzip":return this.service.unzip(b(g[0],v));case"install":return this.service.install(b(g[0],v),y(g[1],v));case"installFromLocation":return this.service.installFromLocation(b(g[0],v),b(g[1],v));case"installExtensionsFromProfile":return this.service.installExtensionsFromProfile(g[0],b(g[1],v),b(g[2],v));case"getManifest":return this.service.getManifest(b(g[0],v));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(g[0]);case"installFromGallery":return this.service.installFromGallery(g[0],y(g[1],v));case"installGalleryExtensions":{const t=g[0];return this.service.installGalleryExtensions(t.map(({extension:l,options:n})=>({extension:l,options:y(n,v)??{}})))}case"uninstall":return this.service.uninstall(D(g[0],v),y(g[1],v));case"reinstallFromGallery":return this.service.reinstallFromGallery(D(g[0],v));case"getInstalled":return(await this.service.getInstalled(g[0],b(g[1],v),g[2])).map(l=>d(l,v));case"toggleAppliationScope":{const t=await this.service.toggleAppliationScope(D(g[0],v),b(g[1],v));return d(t,v)}case"copyExtensions":return this.service.copyExtensions(b(g[0],v),b(g[1],v));case"updateMetadata":{const t=await this.service.updateMetadata(D(g[0],v),g[1],b(g[2],v));return d(t,v)}case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(g[0],g[1],g[2]);case"cleanUp":return this.service.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=E;class a extends r.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(p){super(),this.channel=p,this._onInstallExtension=this._register(new i.Emitter),this._onDidInstallExtensions=this._register(new i.Emitter),this._onUninstallExtension=this._register(new i.Emitter),this._onDidUninstallExtension=this._register(new i.Emitter),this._onDidUpdateExtensionMetadata=this._register(new i.Emitter),this._register(this.channel.listen("onInstallExtension")(S=>this.fireEvent(this._onInstallExtension,{...S,source:this.isUriComponents(S.source)?C.URI.revive(S.source):S.source,profileLocation:C.URI.revive(S.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(S=>this.fireEvent(this._onDidInstallExtensions,S.map(g=>({...g,local:g.local?D(g.local,null):g.local,source:this.isUriComponents(g.source)?C.URI.revive(g.source):g.source,profileLocation:C.URI.revive(g.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(S=>this.fireEvent(this._onUninstallExtension,{...S,profileLocation:C.URI.revive(S.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(S=>this.fireEvent(this._onDidUninstallExtension,{...S,profileLocation:C.URI.revive(S.profileLocation)}))),this._register(this.channel.listen("onDidUpdateExtensionMetadata")(S=>this.fireEvent(this._onDidUpdateExtensionMetadata,{profileLocation:C.URI.revive(S.profileLocation),local:D(S.local,null)})))}fireEvent(p,S){p.fire(S)}isUriComponents(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(p){const S=await this.getTargetPlatform();return p.allTargetPlatforms.some(g=>(0,_.isTargetPlatformCompatible)(g,p.allTargetPlatforms,S))}zip(p){return Promise.resolve(this.channel.call("zip",[p]).then(S=>C.URI.revive(S)))}unzip(p){return Promise.resolve(this.channel.call("unzip",[p]))}install(p,S){return Promise.resolve(this.channel.call("install",[p,S])).then(g=>D(g,null))}installFromLocation(p,S){return Promise.resolve(this.channel.call("installFromLocation",[p,S])).then(g=>D(g,null))}async installExtensionsFromProfile(p,S,g){return(await this.channel.call("installExtensionsFromProfile",[p,S,g])).map(t=>D(t,null))}getManifest(p){return Promise.resolve(this.channel.call("getManifest",[p]))}installFromGallery(p,S){return Promise.resolve(this.channel.call("installFromGallery",[p,S])).then(g=>D(g,null))}async installGalleryExtensions(p){return(await this.channel.call("installGalleryExtensions",[p])).map(g=>({...g,local:g.local?D(g.local,null):g.local,source:this.isUriComponents(g.source)?C.URI.revive(g.source):g.source,profileLocation:C.URI.revive(g.profileLocation)}))}uninstall(p,S){if(p.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.channel.call("uninstall",[p,S]))}reinstallFromGallery(p){return Promise.resolve(this.channel.call("reinstallFromGallery",[p])).then(S=>D(S,null))}getInstalled(p=null,S,g){return Promise.resolve(this.channel.call("getInstalled",[p,S,g])).then(v=>v.map(t=>D(t,null)))}updateMetadata(p,S,g){return Promise.resolve(this.channel.call("updateMetadata",[p,S,g])).then(v=>D(v,null))}toggleAppliationScope(p,S){return this.channel.call("toggleAppliationScope",[p,S]).then(g=>D(g,null))}copyExtensions(p,S){return this.channel.call("copyExtensions",[p,S])}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(p,S,g){const v=await this.channel.call("download",[p,S,g]);return C.URI.revive(v)}async cleanUp(){return this.channel.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=a;class f{constructor(p){this.service=p}listen(p,S){throw new Error("Invalid listen")}call(p,S,g){switch(S){case"getConfigBasedTips":return this.service.getConfigBasedTips(C.URI.revive(g[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=f}),define(ye[130],Ie([1,0,10,22]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class w{constructor(){this._generators=new Map,this._cache=new WeakMap}register(R,_){this._generators.set(R,_)}readActivationEvents(R){return this._cache.has(R)||this._cache.set(R,this._readActivationEvents(R)),this._cache.get(R)}createActivationEventsMap(R){const _=Object.create(null);for(const b of R){const o=this.readActivationEvents(b);o.length>0&&(_[r.ExtensionIdentifier.toKey(b.identifier)]=o)}return _}_readActivationEvents(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const _=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let b=0;b<_.length;b++)_[b]==="onUri"&&(_[b]=`onUri:${r.ExtensionIdentifier.toKey(R.identifier)}`);if(!R.contributes)return _;for(const b in R.contributes){const o=this._generators.get(b);if(!o)continue;const D=R.contributes[b],y=Array.isArray(D)?D:[D];try{o(y,_)}catch(d){(0,i.onUnexpectedError)(d)}}return _}}e.ImplicitActivationEventsImpl=w,e.ImplicitActivationEvents=new w}),define(ye[267],Ie([1,0,2,22,16]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class C extends i.Disposable{constructor(_,b,o,D,y){super(),this.userDataProfilesService=_,this.fileService=b,this.uriIdentityService=o,this.logService=y,this._register(D.onDidInstallExtensions(d=>this.onDidInstallExtensions(d))),this._register(D.onDidUninstallExtension(d=>this.onDidUnInstallExtension(d)))}onDidInstallExtensions(_){for(const b of _)b.local&&this.invalidate(b.profileLocation)}onDidUnInstallExtension(_){_.error||this.invalidate(_.profileLocation)}async invalidate(_){if(_)for(const b of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(b.extensionsResource,_)&&await this.deleteUserCacheFile(b);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(_){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(_.cacheHome,r.USER_MANIFEST_CACHE_FILE))}catch(b){(0,w.toFileOperationResult)(b)!==w.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(b)}}}e.ExtensionsManifestCache=C});var gt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ye[74],Ie([1,0,20,58,214,63,22,119]),function(se,e,i,r,w,C,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=D,e.parseVersion=y,e.normalizeVersion=d,e.isValidVersion=E,e.validateExtensionManifest=a,e.isValidExtensionVersion=f,e.isEngineValid=m,e.areApiProposalsCompatible=p,r=gt(r),w=Be(w),C=Be(C);const b=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,o=/^-(\d{4})(\d{2})(\d{2})$/;function D(v){return v=v.trim(),v==="*"||b.test(v)}function y(v){if(!D(v))return null;if(v=v.trim(),v==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=v.match(b);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function d(v){if(!v)return null;const t=v.majorBase,l=v.majorMustEqual,n=v.minorBase;let h=v.minorMustEqual;const s=v.patchBase;let c=v.patchMustEqual;v.hasCaret&&(t===0||(h=!1),c=!1);let u=0;if(v.preRelease){const I=o.exec(v.preRelease);if(I){const[,T,A,O]=I;u=Date.UTC(Number(T),Number(A)-1,Number(O))}}return{majorBase:t,majorMustEqual:l,minorBase:n,minorMustEqual:h,patchBase:s,patchMustEqual:c,isMinimum:v.hasGreaterEquals,notBefore:u}}function E(v,t,l){let n;typeof v=="string"?n=d(y(v)):n=v;let h;t instanceof Date?h=t.getTime():typeof t=="string"&&(h=new Date(t).getTime());let s;if(typeof l=="string"?s=d(y(l)):s=l,!n||!s)return!1;const c=n.majorBase,u=n.minorBase,I=n.patchBase;let T=s.majorBase,A=s.minorBase,O=s.patchBase;const k=s.notBefore;let P=s.majorMustEqual,B=s.minorMustEqual,Y=s.patchMustEqual;return s.isMinimum?c>T?!0:c<T?!1:u>A?!0:u<A||h&&h<k?!1:I>=O:(c===1&&T===0&&(!P||!B||!Y)&&(T=1,A=0,O=0,P=!0,B=!1,Y=!1),c<T?!1:c>T?!P:u<A?!1:u>A?!B:I<O?!1:I>O?!Y:!(h&&h<k))}function a(v,t,l,n,h,s){const c=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return c.push([r.default.Error,w.localize(0,null)]),c;if(typeof n.name!="string")return c.push([r.default.Error,w.localize(1,null,"name")]),c;if(typeof n.version!="string")return c.push([r.default.Error,w.localize(2,null,"version")]),c;if(!n.engines)return c.push([r.default.Error,w.localize(3,null,"engines")]),c;if(typeof n.engines.vscode!="string")return c.push([r.default.Error,w.localize(4,null,"engines.vscode")]),c;if(typeof n.extensionDependencies<"u"&&!g(n.extensionDependencies))return c.push([r.default.Error,w.localize(5,null,"extensionDependencies")]),c;if(typeof n.activationEvents<"u"){if(!g(n.activationEvents))return c.push([r.default.Error,w.localize(6,null,"activationEvents")]),c;if(typeof n.main>"u"&&typeof n.browser>"u")return c.push([r.default.Error,w.localize(7,null,"activationEvents","main","browser")]),c}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&c.push([r.default.Warning,w.localize(8,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return c.push([r.default.Error,w.localize(9,null,"main")]),c;{const T=(0,i.joinPath)(l,n.main);(0,i.isEqualOrParent)(T,l)||c.push([r.default.Warning,w.localize(10,null,T.path,l.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return c.push([r.default.Error,w.localize(11,null,"browser")]),c;{const T=(0,i.joinPath)(l,n.browser);(0,i.isEqualOrParent)(T,l)||c.push([r.default.Warning,w.localize(12,null,T.path,l.path)])}}if(!C.valid(n.version))return c.push([r.default.Error,w.localize(13,null)]),c;const u=[];if(!f(v,t,n,h,u))for(const T of u)c.push([r.default.Error,T]);if(s&&n.enabledApiProposals?.length){const T=[];if(!p([...n.enabledApiProposals],T))for(const A of T)c.push([r.default.Error,A])}return c}function f(v,t,l,n,h){return n||typeof l.main>"u"&&typeof l.browser>"u"?!0:S(v,t,l.engines.vscode,h)}function m(v,t,l){return v==="*"||S(t,l,v)}function p(v,t){if(v.length===0)return!0;const l=Array.isArray(t)?t:void 0,n=(l?void 0:t)??_.allApiProposals,h=[],s=(0,R.parseApiProposals)(v);for(const{proposalName:c,version:u}of s){const I=n[c];I&&u&&I.version!==u&&h.push(w.localize(14,null,c))}return l?.push(...h),h.length===0}function S(v,t,l,n=[]){const h=d(y(l));if(!h)return n.push(w.localize(15,null,l)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return n.push(w.localize(16,null,l)),!1}else if(!h.majorMustEqual)return n.push(w.localize(17,null,l)),!1;return E(v,t,h)?!0:(n.push(w.localize(18,null,v,l)),!1)}function g(v){if(!Array.isArray(v))return!1;for(let t=0,l=v.length;t<l;t++)if(typeof v[t]!="string")return!1;return!0}}),define(ye[92],Ie([1,0,19,2,3,219,30,5]),function(se,e,i,r,w,C,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.getLocale=b;function b(D){return D.tags.find(y=>y.startsWith("lp-"))?.split("lp-")[1]}e.ILanguagePackService=(0,_.createDecorator)("languagePackService");let o=class extends r.Disposable{constructor(y){super(),this.extensionGalleryService=y}async getAvailableLanguages(){const y=new i.CancellationTokenSource;setTimeout(()=>y.cancel(),1e3);let d;try{d=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},y.token)}catch{return[]}const a=d.firstPage.filter(f=>f.properties.localizedLanguages?.length&&f.tags.some(m=>m.startsWith("lp-"))).map(f=>{const m=f.properties.localizedLanguages?.[0],p=b(f);return{...this.createQuickPickItem(p,m,f),extensionId:f.identifier.id,galleryExtension:f}});return a.push(this.createQuickPickItem("en","English")),a}createQuickPickItem(y,d,E){const a=d??y;let f;if(a!==y&&(f=`(${y})`),y.toLowerCase()===w.language.toLowerCase()&&(f??="",f+=(0,C.localize)(0,null)),E?.installCount){f??="";const m=E.installCount;let p;m>1e6?p=`${Math.floor(m/1e5)/10}M`:m>1e3?p=`${Math.floor(m/1e3)}K`:p=String(m),f+=` $(cloud-download) ${p}`}return{id:y,label:a,description:f}}};e.LanguagePackBaseService=o,e.LanguagePackBaseService=o=ze([Me(0,R.IExtensionGalleryService)],o)}),define(ye[47],Ie([1,0,15,10,2,222,46,5,12,38]),function(se,e,i,r,w,C,R,_,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=d,e.hasNoContent=E,e.asText=a,e.asTextOrError=f,e.asJson=m,e.updateProxyConfigurationsScope=p,e.IRequestService=(0,_.createDecorator)("requestService");class D{constructor(t){this.original=t}toJSON(){if(!this.headers){const t=Object.create(null);for(const l in this.original)l.toLowerCase()==="authorization"||l.toLowerCase()==="proxy-authorization"?t[l]="*****":t[l]=this.original[l];this.headers=t}return this.headers}}class y extends w.Disposable{constructor(t){super(),this.counter=0,this.logger=t.createLogger("network",{name:(0,C.localize)(0,null),when:b.CONTEXT_LOG_LEVEL.isEqualTo((0,b.LogLevelToString)(b.LogLevel.Trace)).serialize()})}async logAndRequest(t,l,n){const h=`${t} #${++this.counter}: ${l.url}`;this.logger.trace(`${h} - begin`,l.type,new D(l.headers??{}));try{const s=await n();return this.logger.trace(`${h} - end`,l.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.logger.error(`${h} - error`,l.type,(0,r.getErrorMessage)(s)),s}}}e.AbstractRequestService=y;function d(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}function E(v){return v.res.statusCode===204}async function a(v){return E(v)?null:(await(0,i.streamToBuffer)(v.stream)).toString()}async function f(v){if(!d(v))throw new Error("Server returned "+v.res.statusCode);return a(v)}async function m(v){if(!d(v))throw new Error("Server returned "+v.res.statusCode);if(E(v))return null;const l=(await(0,i.streamToBuffer)(v.stream)).toString();try{return JSON.parse(l)}catch(n){throw n.message+=`:
`+l,n}}function p(v){g(v)}let S;function g(v){const t=o.Registry.as(R.Extensions.Configuration),l=S;S={id:"http",order:15,title:(0,C.localize)(1,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,C.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,C.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,C.localize)(4,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,C.localize)(5,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,C.localize)(6,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,C.localize)(7,null),(0,C.localize)(8,null),(0,C.localize)(9,null),(0,C.localize)(10,null)],default:"override",description:(0,C.localize)(11,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,C.localize)(12,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,C.localize)(13,null),restricted:!0}}},t.updateConfigurations({add:[S],remove:l?[l]:[]})}g(R.ConfigurationScope.APPLICATION)}),define(ye[268],Ie([1,0,19,13,16,47]),function(se,e,i,r,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let R=class{constructor(b,o){this.requestService=b,this.fileService=o}async download(b,o,D=i.CancellationToken.None){if(b.scheme===r.Schemas.file||b.scheme===r.Schemas.vscodeRemote){await this.fileService.copy(b,o);return}const y={type:"GET",url:b.toString(!0)},d=await this.requestService.request(y,D);if(d.res.statusCode===200)await this.fileService.writeFile(o,d.stream);else{const E=await(0,C.asTextOrError)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${E}`)}}};e.DownloadService=R,e.DownloadService=R=ze([Me(0,C.IRequestService),Me(1,w.IFileService)],R)}),define(ye[269],Ie([1,0,15,19]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class w{constructor(_){this.service=_}listen(_,b){throw new Error("Invalid listen")}call(_,b,o,D=r.CancellationToken.None){switch(b){case"request":return this.service.request(o[0],D).then(async({res:y,stream:d})=>{const E=await(0,i.streamToBuffer)(d);return[{statusCode:y.statusCode,headers:y.headers},E]});case"resolveProxy":return this.service.resolveProxy(o[0]);case"loadCertificates":return this.service.loadCertificates()}throw new Error("Invalid call")}}e.RequestChannel=w;class C{constructor(_){this.channel=_}async request(_,b){const[o,D]=await this.channel.call("request",[_],b);return{res:o,stream:(0,i.bufferToStream)(D)}}async resolveProxy(_){return this.channel.call("resolveProxy",[_])}async loadCertificates(){return this.channel.call("loadCertificates")}}e.RequestChannelClient=C}),define(ye[270],Ie([1,0,93,11]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=C;function w(R,_){return R.protocol==="http:"?_.HTTP_PROXY||_.http_proxy||null:R.protocol==="https:"&&(_.HTTPS_PROXY||_.https_proxy||_.HTTP_PROXY||_.http_proxy)||null}async function C(R,_,b={}){const o=(0,i.parse)(R),D=b.proxyUrl||w(o,_);if(!D)return null;const y=(0,i.parse)(D);if(!/^https?:$/.test(y.protocol||""))return null;const d={host:y.hostname||"",port:(y.port?+y.port:0)||(y.protocol==="https"?443:80),auth:y.auth,rejectUnauthorized:(0,r.isBoolean)(b.strictSSL)?b.strictSSL:!0};return o.protocol==="http:"?new(await new Promise((E,a)=>{se(["http-proxy-agent"],E,a)}).then(Be)).HttpProxyAgent(D,d):new(await new Promise((E,a)=>{se(["https-proxy-agent"],E,a)}).then(Be)).HttpsProxyAgent(D,d)}}),define(ye[94],Ie([1,0,60,9,223,19,45,10,3,23,116,244,14,163]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=f;let a;async function f(p,S,g,v){return g["force-disable-user-env"]?(S.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(S.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.isLaunchedFromCli)(v)&&!g["force-user-env"]?(S.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.isLaunchedFromCli)(v)?S.trace("resolveShellEnv(): running (--force-user-env)"):S.trace("resolveShellEnv(): running (macOS/Linux)"),a||(a=d.Promises.withAsyncBody(async(t,l)=>{const n=new C.CancellationTokenSource;let h=1e4;const s=p.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(h=(0,E.clamp)(s,1,120)*1e3);const c=setTimeout(()=>{n.dispose(!0),l(new Error((0,w.localize)(0,null)))},h);try{t(await m(S,n.token))}catch(u){!(0,_.isCancellationError)(u)&&!n.token.isCancellationRequested?l(new Error((0,w.localize)(1,null,(0,R.toErrorMessage)(u)))):t({})}finally{clearTimeout(c),n.dispose()}})),a)}async function m(p,S){const g=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",g);const v=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",v);const t=(0,o.generateUuid)().replace(/-/g,"").substr(0,12),l=new RegExp(t+"({.*})"+t),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};p.trace("getUnixShellEnvironment#env",n);const h=await(0,D.getSystemShell)(b.OS,n);return p.trace("getUnixShellEnvironment#shell",h),new Promise((s,c)=>{if(S.isCancellationRequested)return c(new _.CancellationError);const u=(0,r.basename)(h);let I,T;const A="";/^pwsh(-preview)?$/.test(u)?(I=`& '${process.execPath}' ${A} -p '''${t}'' + JSON.stringify(process.env) + ''${t}'''`,T=["-Login","-Command"]):u==="nu"?(I=`^'${process.execPath}' ${A} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,T=["-i","-l","-c"]):u==="xonsh"?(I=`import os, json; print("${t}", json.dumps(dict(os.environ)), "${t}")`,T=["-i","-l","-c"]):(I=`'${process.execPath}' ${A} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,u==="tcsh"||u==="csh"?T=["-ic"]:T=["-i","-l","-c"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(T),I);const O=(0,i.spawn)(h,[...T,I],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});S.onCancellationRequested(()=>(O.kill(),c(new _.CancellationError))),O.on("error",B=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,R.toErrorMessage)(B)),c(B)});const k=[];O.stdout.on("data",B=>k.push(B));const P=[];O.stderr.on("data",B=>P.push(B)),O.on("close",(B,Y)=>{const X=Buffer.concat(k).toString("utf8");p.trace("getUnixShellEnvironment#raw",X);const re=Buffer.concat(P).toString("utf8");if(re.trim()&&p.trace("getUnixShellEnvironment#stderr",re),B||Y)return c(new Error((0,w.localize)(2,null,B,Y)));const te=l.exec(X),Z=te?te[1]:"{}";try{const fe=JSON.parse(Z);g?fe.ELECTRON_RUN_AS_NODE=g:delete fe.ELECTRON_RUN_AS_NODE,v?fe.ELECTRON_NO_ATTACH_CONSOLE=v:delete fe.ELECTRON_NO_ATTACH_CONSOLE,delete fe.VSCODE_RESOLVING_ENVIRONMENT,delete fe.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",fe),s(fe)}catch(fe){p.error("getUnixShellEnvironment#errorCaught",(0,R.toErrorMessage)(fe)),c(fe)}})})}}),define(ye[271],Ie([1,0,5]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,i.createDecorator)("stateReadService"),e.IStateService=(0,i.createDecorator)("stateService")}),define(ye[272],Ie([1,0,14,15,2,11,28,16,12]),function(se,e,i,r,w,C,R,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var o;(function(E){E[E.IMMEDIATE=0]="IMMEDIATE",E[E.DELAYED=1]="DELAYED"})(o||(e.SaveStrategy=o={}));class D extends w.Disposable{constructor(a,f,m,p){super(),this.storagePath=a,this.saveStrategy=f,this.logService=m,this.fileService=p,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=this._register(new i.ThrottledDelayer(this.saveStrategy===o.IMMEDIATE?0:100)),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(a){a.fileOperationResult!==_.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(a)}}getItem(a,f){const m=this.storage[a];return(0,C.isUndefinedOrNull)(m)?f:m}setItem(a,f){this.setItems([{key:a,data:f}])}setItems(a){let f=!1;for(const{key:m,data:p}of a)this.storage[m]!==p&&((0,C.isUndefinedOrNull)(p)?(0,C.isUndefined)(this.storage[m])||(this.storage[m]=void 0,f=!0):(this.storage[m]=p,f=!0));f&&this.save()}removeItem(a){(0,C.isUndefined)(this.storage[a])||(this.storage[a]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const a=JSON.stringify(this.storage,null,4);if(a!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,r.VSBuffer.fromString(a),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=a}catch(f){this.logService.error(f)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=D;let y=class extends w.Disposable{constructor(a,f,m,p){super(),this.fileStorage=this._register(new D(f.stateResource,a,m,p))}async init(){await this.fileStorage.init()}getItem(a,f){return this.fileStorage.getItem(a,f)}};e.StateReadonlyService=y,e.StateReadonlyService=y=ze([Me(1,R.IEnvironmentService),Me(2,b.ILogService),Me(3,_.IFileService)],y);class d extends y{setItem(a,f){this.fileStorage.setItem(a,f)}setItems(a){this.fileStorage.setItems(a)}removeItem(a){this.fileStorage.removeItem(a)}close(){return this.fileStorage.close()}}e.StateService=d}),define(ye[131],Ie([1,0,3,33,23]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=R,e.verifyMicrosoftInternalDomain=_;function C(b){if(i.platform===i.Platform.Linux&&/^penguin(\.|$)/i.test(b))return"chromebook"}function R(b,o,D,y,d,E,a,f,m,p){const S=Object.create(null);S["common.machineId"]=E,S["common.sqmId"]=a,S["common.devDeviceId"]=f,S.sessionID=(0,w.generateUuid)()+Date.now(),S.commitHash=y,S.version=d,S["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),S["common.platform"]=(0,i.PlatformToString)(i.platform),S["common.nodePlatform"]=r.platform,S["common.nodeArch"]=D,S["common.product"]=p||"desktop",m&&(S["common.msftInternal"]=m);let g=0;const v=Date.now();Object.defineProperties(S,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),i.isLinuxSnap&&(S["common.snap"]="true");const t=C(o);return t&&(S["common.platformDetail"]=t),S}function _(b){const o=r.env.USERDNSDOMAIN;if(!o)return!1;const D=o.toLowerCase();return b.some(y=>D===y)}}),define(ye[273],Ie([1,0,18,10,2,21,16]),function(se,e,i,r,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var _;(function(o){function D(y,d){return y.callstack<d.callstack?-1:y.callstack>d.callstack?1:0}o.compare=D})(_||(e.ErrorEvent=_={}));class b{static{this.ERROR_FLUSH_TIMEOUT=5*1e3}constructor(D,y=b.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new w.DisposableStore,this._telemetryService=D,this._flushDelay=y;const d=r.errorHandler.addListener(E=>this._onErrorEvent(E));this._disposables.add((0,w.toDisposable)(d)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(D){if(!D||D.code||(D.detail&&D.detail.stack&&(D=D.detail),r.ErrorNoTelemetry.isErrorNoTelemetry(D)||D instanceof R.FileOperationError||typeof D?.message=="string"&&D.message.includes("Unable to read file")))return;const y=Array.isArray(D.stack)?D.stack.join(`
`):D.stack,d=D.message?D.message:(0,C.safeStringify)(D);y&&this._enqueue({msg:d,callstack:y})}_enqueue(D){const y=(0,i.binarySearch)(this._buffer,D,_.compare);y<0?(D.count=1,this._buffer.splice(~y,0,D)):(this._buffer[y].count||(this._buffer[y].count=0),this._buffer[y].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(const D of this._buffer)this._telemetryService.publicLogError2("UnhandledError",D);this._buffer.length=0}}e.default=b}),define(ye[24],Ie([1,0,5]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.devDeviceIdKey=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,i.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,i.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.devDeviceIdKey="telemetry.devDeviceId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var r;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(r||(e.TelemetryLevel=r={}));var w;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(w||(e.TelemetryConfiguration=w={}))}),define(ye[274],Ie([1,0,32,14,43,13,9,3,48,4,112,25,115,250,16,29,24]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=void 0,e.collectWorkspaceStats=S,e.getMachineInfo=v,e.collectLaunchConfigs=t,i=Be(i);const p=new Map;async function S(n,h){const s=`${n}::${h.join(":")}`,c=p.get(s);if(c)return c;const u=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],I=new Map,T=new Map,A=2e4;function O(P,B,Y,X){const re=B.substring(P.length+1);return r.Promises.withAsyncBody(async te=>{let Z;X.readdirCount++;try{Z=await y.Promises.readdir(B,{withFileTypes:!0})}catch{te();return}if(X.count>=A){X.count+=Z.length,X.maxReached=!0,te();return}let fe=Z.length;if(fe===0){te();return}let K=Z;X.count+Z.length>A&&(X.maxReached=!0,fe=A-X.count,K=Z.slice(0,fe)),X.count+=Z.length;for(const ae of K)if(ae.isDirectory()){if(Y.includes(ae.name)||await O(P,(0,R.join)(B,ae.name),Y,X),--fe===0){te();return}}else{const x=ae.name.lastIndexOf(".");if(x>=0){const z=ae.name.substring(x+1);z&&I.set(z,(I.get(z)??0)+1)}for(const z of u)z.relativePathPattern?.test(re)!==!1&&z.filePattern.test(ae.name)&&T.set(z.tag,(T.get(z.tag)??0)+1);if(--fe===0){te();return}}})}const k=r.Promises.withAsyncBody(async P=>{const B={count:0,maxReached:!1,readdirCount:0},Y=new b.StopWatch(!0);await O(n,n,h,B);const X=await t(n);P({configFiles:g(T),fileTypes:g(I),fileCount:B.count,maxFilesReached:B.maxReached,launchConfigFiles:X,totalScanTime:Y.elapsed(),totalReaddirCount:B.readdirCount})});return p.set(s,k),k}function g(n){return Array.from(n.entries(),([h,s])=>({name:h,count:s})).sort((h,s)=>s.count-h.count)}function v(){const n={os:`${i.type()} ${i.arch()} ${i.release()}`,memory:`${(i.totalmem()/a.ByteSize.GB).toFixed(2)}GB (${(i.freemem()/a.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(D.virtualMachineHint.value()*100)}%`},h=i.cpus();return h&&h.length>0&&(n.cpus=`${h[0].model} (${h.length} x ${h[0].speed})`),n}async function t(n){try{const h=new Map,s=(0,R.join)(n,".vscode","launch.json"),c=await y.Promises.readFile(s),u=[],I=(0,w.parse)(c.toString(),u);if(u.length)return console.log(`Unable to parse ${s}`),[];if((0,w.getNodeType)(I)==="object"&&I.configurations)for(const T of I.configurations){const A=T.type;A&&(h.has(A)?h.set(A,h.get(A)+1):h.set(A,1))}return g(h)}catch{return[]}}let l=class{constructor(h,s){this.telemetryService=h,this.productService=s}formatMachineInfo(h){const s=[];return s.push(`OS Version:       ${h.os}`),s.push(`CPUs:             ${h.cpus}`),s.push(`Memory (System):  ${h.memory}`),s.push(`VM:               ${h.vmHint}`),s.join(`
`)}formatEnvironment(h){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${i.type()} ${i.arch()} ${i.release()}`);const c=i.cpus();return c&&c.length>0&&s.push(`CPUs:             ${c[0].model} (${c.length} x ${c[0].speed})`),s.push(`Memory (System):  ${(i.totalmem()/a.ByteSize.GB).toFixed(2)}GB (${(i.freemem()/a.ByteSize.GB).toFixed(2)}GB free)`),_.isWindows||s.push(`Load (avg):       ${i.loadavg().map(u=>Math.round(u)).join(", ")}`),s.push(`VM:               ${Math.round(D.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${h.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${h.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(h.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(h,s){return Promise.all([(0,d.listProcesses)(h.mainPID),this.formatWorkspaceMetadata(h)]).then(async c=>{let[u,I]=c,T=this.formatProcessList(h,u);return s.forEach(A=>{if((0,E.isRemoteDiagnosticError)(A))T+=`
${A.errorMessage}`,I+=`
${A.errorMessage}`;else if(T+=`

Remote: ${A.hostName}`,A.processes&&(T+=`
${this.formatProcessList(h,A.processes)}`),A.workspaceMetadata){I+=`
|  Remote: ${A.hostName}`;for(const O of Object.keys(A.workspaceMetadata)){const k=A.workspaceMetadata[O];let P=`${k.fileCount} files`;k.maxFilesReached&&(P=`more than ${P}`),I+=`|    Folder (${O}): ${P}`,I+=this.formatWorkspaceStats(k)}}}),{processInfo:T,workspaceInfo:I}})}async getSystemInfo(h,s){const{memory:c,vmHint:u,os:I,cpus:T}=v(),A={os:I,memory:c,cpus:T,vmHint:u,processArgs:`${h.mainArguments.join(" ")}`,gpuStatus:h.gpuFeatureStatus,screenReader:`${h.screenReader?"yes":"no"}`,remoteData:s};return _.isWindows||(A.load=`${i.loadavg().map(O=>Math.round(O)).join(", ")}`),_.isLinux&&(A.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(A)}async getDiagnostics(h,s){const c=[];return(0,d.listProcesses)(h.mainPID).then(async u=>(c.push(""),c.push(this.formatEnvironment(h)),c.push(""),c.push(this.formatProcessList(h,u)),h.windows.some(I=>I.folderURIs&&I.folderURIs.length>0&&!I.remoteAuthority)&&(c.push(""),c.push("Workspace Stats: "),c.push(await this.formatWorkspaceMetadata(h))),s.forEach(I=>{if((0,E.isRemoteDiagnosticError)(I))c.push(`
${I.errorMessage}`);else if(c.push(`

`),c.push(`Remote:           ${I.hostName}`),c.push(this.formatMachineInfo(I.machineInfo)),I.processes&&c.push(this.formatProcessList(h,I.processes)),I.workspaceMetadata)for(const T of Object.keys(I.workspaceMetadata)){const A=I.workspaceMetadata[T];let O=`${A.fileCount} files`;A.maxFilesReached&&(O=`more than ${O}`),c.push(`Folder (${T}): ${O}`),c.push(this.formatWorkspaceStats(A))}}),c.push(""),c.push(""),c.join(`
`)))}formatWorkspaceStats(h){const s=[];let u=0;const I=(k,P)=>{const B=` ${k}(${P})`;u+B.length>60?(s.push(T),T="|                 ",u=T.length):u+=B.length,T+=B};let T="|      File types:";const A=10,O=h.fileTypes.length>A?A:h.fileTypes.length;for(let k=0;k<O;k++){const P=h.fileTypes[k];I(P.name,P.count)}if(s.push(T),h.configFiles.length>=0&&(T="|      Conf files:",u=0,h.configFiles.forEach(k=>{I(k.name,k.count)}),s.push(T)),h.launchConfigFiles.length>0){let k="|      Launch Configs:";h.launchConfigFiles.forEach(P=>{const B=P.count>1?` ${P.name}(${P.count})`:` ${P.name}`;k+=B}),s.push(k)}return s.join(`
`)}expandGPUFeatures(h){const s=Math.max(...Object.keys(h).map(c=>c.length));return Object.keys(h).map(c=>`${c}:  ${" ".repeat(s-c.length)}  ${h[c]}`).join(`
                  `)}formatWorkspaceMetadata(h){const s=[],c=[];return h.windows.forEach(u=>{u.folderURIs.length===0||u.remoteAuthority||(s.push(`|  Window (${u.title})`),u.folderURIs.forEach(I=>{const T=o.URI.revive(I);if(T.scheme===C.Schemas.file){const A=T.fsPath;c.push(S(A,["node_modules",".git"]).then(O=>{let k=`${O.fileCount} files`;O.maxFilesReached&&(k=`more than ${k}`),s.push(`|    Folder (${(0,R.basename)(A)}): ${k}`),s.push(this.formatWorkspaceStats(O))}).catch(O=>{s.push(`|      Error: Unable to collect workspace stats for folder ${A} (${O.toString()})`)}))}else s.push(`|    Folder (${T.toString()}): Workspace stats not available.`)}))}),Promise.all(c).then(u=>s.join(`
`)).catch(u=>`Unable to collect workspace stats: ${u}`)}formatProcessList(h,s){const c=new Map;h.windows.forEach(I=>c.set(I.pid,`window [${I.id}] (${I.title})`)),h.pidToNames.forEach(({pid:I,name:T})=>c.set(I,T));const u=[];return u.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(h.mainPID,c,u,s,0),u.join(`
`)}formatProcessItem(h,s,c,u,I){const T=I===0;let A;T?A=u.pid===h?`${this.productService.applicationName} main`:"remote agent":s.has(u.pid)?A=s.get(u.pid):A=`${"  ".repeat(I)} ${u.name}`;const O=process.platform==="win32"?u.mem:i.totalmem()*(u.mem/100);c.push(`${u.load.toFixed(0).padStart(5," ")}	${(O/a.ByteSize.MB).toFixed(0).padStart(6," ")}	${u.pid.toFixed(0).padStart(6," ")}	${A}`),Array.isArray(u.children)&&u.children.forEach(k=>this.formatProcessItem(h,s,c,k,I+1))}async getWorkspaceFileExtensions(h){const s=new Set;for(const{uri:c}of h.folders){const u=o.URI.revive(c);if(u.scheme!==C.Schemas.file)continue;const I=u.fsPath;try{(await S(I,["node_modules",".git"])).fileTypes.forEach(A=>s.add(A.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(h){for(const{uri:s}of h.folders){const c=o.URI.revive(s);if(c.scheme!==C.Schemas.file)continue;const u=c.fsPath;try{const I=await S(u,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":h.telemetryId,rendererSessionId:h.rendererSessionId}),I.fileTypes.forEach(T=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:h.rendererSessionId,type:T.name,count:T.count})}),I.launchConfigFiles.forEach(T=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:h.rendererSessionId,type:T.name,count:T.count})}),I.configFiles.forEach(T=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:h.rendererSessionId,type:T.name,count:T.count})}),this.telemetryService.publicLog2("workspace.stats.metadata",{duration:I.totalScanTime,reachedLimit:I.maxFilesReached,fileCount:I.fileCount,readdirCount:I.totalReaddirCount})}catch{}}}};e.DiagnosticsService=l,e.DiagnosticsService=l=ze([Me(0,m.ITelemetryService),Me(1,f.IProductService)],l)}),define(ye[95],Ie([1,0,10,5,12,24]),function(se,e,i,r,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.ExtensionSignatureVerificationError=e.ExtensionSignatureVerificationCode=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,r.createDecorator)("IExtensionSignatureVerificationService");var R;(function(o){o.Success="Success",o.RequiredArgumentMissing="RequiredArgumentMissing",o.InvalidArgument="InvalidArgument",o.PackageIsUnreadable="PackageIsUnreadable",o.UnhandledException="UnhandledException",o.SignatureManifestIsMissing="SignatureManifestIsMissing",o.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",o.SignatureIsMissing="SignatureIsMissing",o.SignatureIsUnreadable="SignatureIsUnreadable",o.CertificateIsUnreadable="CertificateIsUnreadable",o.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",o.FileAlreadyExists="FileAlreadyExists",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",o.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",o.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",o.SignatureIsInvalid="SignatureIsInvalid",o.SignatureManifestIsInvalid="SignatureManifestIsInvalid",o.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",o.EntryIsMissing="EntryIsMissing",o.EntryIsTampered="EntryIsTampered",o.Untrusted="Untrusted",o.CertificateRevoked="CertificateRevoked",o.SignatureIsNotValid="SignatureIsNotValid",o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(R||(e.ExtensionSignatureVerificationCode=R={}));class _ extends Error{constructor(D){super(D),this.code=D}}e.ExtensionSignatureVerificationError=_;let b=class{constructor(D,y){this.logService=D,this.telemetryService=y}vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((D,y)=>se(["@vscode/vsce-sign"],async d=>D(d),y))),this.moduleLoadingPromise}async verify(D,y,d,E){let a;const f=D.identifier.id;try{a=await this.vsceSign()}catch(g){return this.logService.error("Could not load vsce-sign module",(0,i.getErrorMessage)(g)),this.logService.info(`Extension signature verification is not done: ${f}`),!1}const m=new Date().getTime();let p;try{this.logService.trace(`Verifying extension signature for ${f}...`),p=await a.verify(y,d,this.logService.getLevel()===w.LogLevel.Trace)}catch(g){p={code:R.UnknownError,didExecute:!1,output:(0,i.getErrorMessage)(g)}}const S=new Date().getTime()-m;if(this.logService.info(`Extension signature verification result for ${f}: ${p.code}. Executed: ${p.didExecute}. Duration: ${S}ms.`),this.logService.trace(`Extension signature verification output for ${f}:
${p.output}`),this.telemetryService.publicLog2("extensionsignature:verification",{extensionId:f,extensionVersion:D.version,code:p.code,internalCode:p.internalCode,duration:S,didExecute:p.didExecute,clientTargetPlatform:E}),p.code===R.Success)return!0;throw new _(p.code)}};e.ExtensionSignatureVerificationService=b,e.ExtensionSignatureVerificationService=b=ze([Me(0,w.ILogService),Me(1,C.ITelemetryService)],b)}),define(ye[275],Ie([1,0,2,24]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class w extends i.Disposable{constructor(R,_){super(),this.telemetryService=R,this.telemetryAppender=_}async call(R,_,b){switch(_){case"updateTelemetryLevel":{const{telemetryLevel:o}=b;return this.telemetryService.updateInjectedTelemetryLevel(o)}case"logTelemetry":{const{eventName:o,data:D}=b;return this.telemetryAppender?this.telemetryAppender.log(o,D):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${_} not found`)}listen(R,_,b){throw new Error("Not supported")}dispose(){this.telemetryService.updateInjectedTelemetryLevel(r.TelemetryLevel.NONE),super.dispose()}}e.ServerTelemetryChannel=w}),define(ye[41],Ie([1,0,21,11,91,131,24]),function(se,e,i,r,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=D,e.isLoggingOnly=y,e.getTelemetryLevel=d,e.validateTelemetryData=E,e.cleanRemoteAuthority=f,e.isInternalTelemetry=p,e.getPiiPathsFromEnvironment=S,e.cleanData=t;class _{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=_;class b{constructor(){this.telemetryLevel=R.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=b,e.NullTelemetryService=new b;class o{async publicLog(n,h,s){}async publicLogError(n,h,s){}}e.NullEndpointTelemetryService=o,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function D(l,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!l.enableTelemetry)}function y(l,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}function d(l){const n=l.getValue(R.TELEMETRY_SETTING_ID),h=l.getValue(R.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(l.getValue(R.TELEMETRY_OLD_SETTING_ID)===!1||h===!1)return R.TelemetryLevel.NONE;switch(n??R.TelemetryConfiguration.ON){case R.TelemetryConfiguration.ON:return R.TelemetryLevel.USAGE;case R.TelemetryConfiguration.ERROR:return R.TelemetryLevel.ERROR;case R.TelemetryConfiguration.CRASH:return R.TelemetryLevel.CRASH;case R.TelemetryConfiguration.OFF:return R.TelemetryLevel.NONE}}function E(l){const n={},h={},s={};m(l,s);for(let c in s){c=c.length>150?c.substr(c.length-149):c;const u=s[c];typeof u=="number"?h[c]=u:typeof u=="boolean"?h[c]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${u.length}`),n[c]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(n[c]=u)}return{properties:n,measurements:h}}const a=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(l){if(!l)return"none";const n=(0,w.getRemoteName)(l);return a.has(n)?n:"other"}function m(l,n,h=0,s){if(l)for(const c of Object.getOwnPropertyNames(l)){const u=l[c],I=s?s+c:c;Array.isArray(u)?n[I]=(0,i.safeStringify)(u):u instanceof Date?n[I]=u.toISOString():(0,r.isObject)(u)?h<2?m(u,n,h+1,I+"."):n[I]=(0,i.safeStringify)(u):n[I]=u}}function p(l,n){const h=l.msftInternalDomains||[],s=n.getValue("telemetry.internalTesting");return(0,C.verifyMicrosoftInternalDomain)(h)||s}function S(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}function g(l,n){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let h=l;const s=[];for(const T of n)for(;;){const A=T.exec(l);if(!A)break;s.push([A.index,T.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let I=0;for(h="";;){const T=u.exec(l);if(!T)break;const A=s.some(([O,k])=>T.index<k&&O<u.lastIndex);!c.test(T[0])&&!A&&(h+=l.substring(I,T.index)+"<REDACTED: user-file-path>",I=u.lastIndex)}return I<l.length&&(h+=l.substr(I)),h}function v(l){if(!l)return l;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of n)if(h.regex.test(l))return`<REDACTED: ${h.label}>`;return l}function t(l,n){return(0,i.cloneAndChange)(l,h=>{if(h instanceof _||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let s=h.replaceAll("%20"," ");s=g(s,n);for(const c of n)s=s.replace(c,"");return s=v(s),s}})}}),define(ye[39],Ie([1,0,17,30,22,3,4,10,33,41]),function(se,e,i,r,w,C,R,_,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=D,e.getIdAndVersion=a,e.getExtensionId=f,e.adoptToGalleryExtensionId=m,e.getGalleryExtensionId=p,e.groupByExtension=S,e.getLocalExtensionTelemetryData=g,e.getGalleryExtensionTelemetryData=v,e.getExtensionDependencies=t,e.computeTargetPlatform=n;function D(h,s){return h.uuid&&s.uuid?h.uuid===s.uuid:h.id===s.id?!0:(0,i.compareIgnoreCase)(h.id,s.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(s){const c=s.manifest?s.manifest.version:s.version,u=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new d(s.identifier,c,u)}static parse(s){const c=y.exec(s);return c&&c[1]&&c[2]?new d({id:c[1]},c[2],c[4]||void 0):null}constructor(s,c,u=w.TargetPlatform.UNDEFINED){this.identifier=s,this.version=c,this.targetPlatform=u,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==w.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof d?D(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=d;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function a(h){const s=E.exec(h);return s&&s[1]?[m(s[1]),s[2]]:[m(h),void 0]}function f(h,s){return`${h}.${s}`}function m(h){return h.toLowerCase()}function p(h,s){return m(f(h??w.UNDEFINED_PUBLISHER,s))}function S(h,s){const c=[],u=I=>{for(const T of c)if(T.some(A=>D(s(A),s(I))))return T;return null};for(const I of h){const T=u(I);T?T.push(I):c.push([I])}return c}function g(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}function v(h){return{id:new o.TelemetryTrustedValue(h.identifier.id),name:new o.TelemetryTrustedValue(h.name),version:h.version,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),isSigned:h.isSigned,...h.telemetryData}}e.BetterMergeId=new w.ExtensionIdentifier("pprice.better-merge");function t(h,s){const c=[],u=s.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const I=u.shift();if(I&&c.every(T=>!D(T.identifier,{id:I}))){const T=h.filter(A=>D(A.identifier,{id:I}));T.length===1&&(c.push(T[0]),u.push(...T[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}async function l(h,s){if(!C.isLinux)return!1;let c;try{c=(await h.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await h.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(I){s.debug("Error while getting the os-release file.",(0,_.getErrorMessage)(I))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(h,s){const c=await l(h,s),u=(0,r.getTargetPlatform)(c?"alpine":C.platform,b.arch);return s.debug("ComputeTargetPlatform:",u),u}}),define(ye[132],Ie([1,0,19,10,13,20,63,4,209,30,39,22]),function(se,e,i,r,w,C,R,_,b,o,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const d=f=>(0,b.localize)(0,null,f),E=(0,b.localize)(1,null,"ms-dotnettools.csharp");let a=class{constructor(m,p,S){this.logger=m,this.extensionManagementService=p,this.extensionGalleryService=S}get location(){}async listExtensions(m,p,S){let g=await this.extensionManagementService.getInstalled(y.ExtensionType.User,S);const v=y.EXTENSION_CATEGORIES.map(l=>l.toLowerCase());if(p&&p!==""){if(v.indexOf(p.toLowerCase())<0){this.logger.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}g=g.filter(l=>l.manifest.categories?l.manifest.categories.map(h=>h.toLowerCase()).indexOf(p.toLowerCase())>-1:!1)}else if(p===""){this.logger.info("Possible Categories: "),v.forEach(l=>{this.logger.info(l)});return}this.location&&this.logger.info((0,b.localize)(2,null,this.location)),g=g.sort((l,n)=>l.identifier.id.localeCompare(n.identifier.id));let t;for(const l of g)t!==l.identifier.id&&(t=l.identifier.id,this.logger.info(m?`${t}@${l.manifest.version}`:t))}async installExtensions(m,p,S,g){const v=[];try{m.length&&this.logger.info(this.location?(0,b.localize)(3,null,this.location):(0,b.localize)(4,null));const t=[],l=[],n=(s,c,u)=>{l.push({id:s,version:c!=="prerelease"?c:void 0,installOptions:{...S,isBuiltin:u,installPreReleaseVersion:c==="prerelease"||S.installPreReleaseVersion}})};for(const s of m)if(s instanceof _.URI)t.push({vsix:s,installOptions:S});else{const[c,u]=(0,D.getIdAndVersion)(s);n(c,u,!1)}for(const s of p)if(s instanceof _.URI)t.push({vsix:s,installOptions:{...S,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[c,u]=(0,D.getIdAndVersion)(s);n(c,u,!0)}const h=await this.extensionManagementService.getInstalled(void 0,S.profileLocation);if(t.length&&await Promise.all(t.map(async({vsix:s,installOptions:c})=>{try{await this.installVSIX(s,c,g,h)}catch(u){this.logger.error(u),v.push(s.toString())}})),l.length){const s=await this.installGalleryExtensions(l,h,g);v.push(...s)}}catch(t){throw this.logger.error((0,b.localize)(5,null,(0,r.getErrorMessage)(t))),t}if(v.length)throw new Error((0,b.localize)(6,null,v.join(", ")))}async updateExtensions(m){const p=await this.extensionManagementService.getInstalled(y.ExtensionType.User,m),S=[];for(const l of p)l.identifier.uuid&&S.push({...l.identifier,preRelease:l.preRelease});this.logger.trace((0,b.localize)(7,null,S.length));const g=await this.extensionGalleryService.getExtensions(S,{compatible:!0},i.CancellationToken.None),v=[];for(const l of g)for(const n of p)(0,D.areSameExtensions)(n.identifier,l.identifier)&&(0,R.gt)(l.version,n.manifest.version)&&v.push({extension:l,options:{operation:o.InstallOperation.Update,installPreReleaseVersion:n.preRelease,profileLocation:m,isApplicationScoped:n.isApplicationScoped}});if(!v.length){this.logger.info((0,b.localize)(8,null));return}this.logger.info((0,b.localize)(9,null,v.map(l=>l.extension.identifier.id).join(", ")));const t=await this.extensionManagementService.installGalleryExtensions(v);for(const l of t)l.error?this.logger.error((0,b.localize)(10,null,l.identifier.id,(0,r.getErrorMessage)(l.error))):this.logger.info((0,b.localize)(11,null,l.identifier.id,l.local?.manifest.version))}async installGalleryExtensions(m,p,S){if(m=m.filter(({id:l,version:n})=>{const h=p.find(s=>(0,D.areSameExtensions)(s.identifier,{id:l}));if(h){if(!S&&(!n||n==="prerelease"&&h.preRelease))return this.logger.info((0,b.localize)(12,null,l,h.manifest.version,l)),!1;if(n&&h.manifest.version===n)return this.logger.info((0,b.localize)(13,null,`${l}@${n}`)),!1}return!0}),!m.length)return[];const g=[],v=[],t=await this.getGalleryExtensions(m);if(await Promise.all(m.map(async({id:l,version:n,installOptions:h})=>{const s=t.get(l.toLowerCase());if(!s){this.logger.error(`${d(n?`${l}@${n}`:l)}
${E}`),g.push(l);return}try{const u=await this.extensionGalleryService.getManifest(s,i.CancellationToken.None);if(u&&!this.validateExtensionKind(u))return}catch(u){this.logger.error(u.message||u.stack||u),g.push(l);return}const c=p.find(u=>(0,D.areSameExtensions)(u.identifier,s.identifier));if(c){if(s.version===c.manifest.version){this.logger.info((0,b.localize)(14,null,n?`${l}@${n}`:l));return}this.logger.info((0,b.localize)(15,null,l,s.version))}h.isBuiltin?this.logger.info(n?(0,b.localize)(16,null,l,n):(0,b.localize)(17,null,l)):this.logger.info(n?(0,b.localize)(18,null,l,n):(0,b.localize)(19,null,l)),v.push({extension:s,options:{...h,installGivenVersion:!!n,isApplicationScoped:h.isApplicationScoped||c?.isApplicationScoped}})})),v.length){const l=await this.extensionManagementService.installGalleryExtensions(v);for(const n of l)n.error?(this.logger.error((0,b.localize)(20,null,n.identifier.id,(0,r.getErrorMessage)(n.error))),g.push(n.identifier.id)):this.logger.info((0,b.localize)(21,null,n.identifier.id,n.local?.manifest.version))}return g}async installVSIX(m,p,S,g){const v=await this.extensionManagementService.getManifest(m);if(!v)throw new Error("Invalid vsix");if(await this.validateVSIX(v,S,p.profileLocation,g))try{await this.extensionManagementService.install(m,p),this.logger.info((0,b.localize)(22,null,(0,C.basename)(m)))}catch(l){if((0,r.isCancellationError)(l))this.logger.info((0,b.localize)(23,null,(0,C.basename)(m)));else throw l}}async getGalleryExtensions(m){const p=new Map,S=m.some(t=>t.installOptions.installPreReleaseVersion),g=await this.extensionManagementService.getTargetPlatform(),v=[];for(const t of m)o.EXTENSION_IDENTIFIER_REGEX.test(t.id)&&v.push({...t,preRelease:S});if(v.length){const t=await this.extensionGalleryService.getExtensions(v,{targetPlatform:g},i.CancellationToken.None);for(const l of t)p.set(l.identifier.id.toLowerCase(),l)}return p}validateExtensionKind(m){return!0}async validateVSIX(m,p,S,g){if(!p){const v={id:(0,D.getGalleryExtensionId)(m.publisher,m.name)},t=g.find(l=>(0,D.areSameExtensions)(v,l.identifier)&&(0,R.gt)(l.manifest.version,m.version));if(t)return this.logger.info((0,b.localize)(24,null,t.identifier.id,t.manifest.version,m.version)),!1}return this.validateExtensionKind(m)}async uninstallExtensions(m,p,S){const g=async t=>{if(t instanceof _.URI){const l=await this.extensionManagementService.getManifest(t);return(0,D.getExtensionId)(l.publisher,l.name)}return t},v=[];for(const t of m){const l=await g(t),h=(await this.extensionManagementService.getInstalled(void 0,S)).filter(s=>(0,D.areSameExtensions)(s.identifier,{id:l}));if(!h.length)throw new Error(`${this.notInstalled(l)}
${E}`);if(h.some(s=>s.type===y.ExtensionType.System)){this.logger.info((0,b.localize)(25,null,l));return}if(!p&&h.some(s=>s.isBuiltin)){this.logger.info((0,b.localize)(26,null,l));return}this.logger.info((0,b.localize)(27,null,l));for(const s of h)await this.extensionManagementService.uninstall(s,{profileLocation:S}),v.push(s);this.location?this.logger.info((0,b.localize)(28,null,l,this.location)):this.logger.info((0,b.localize)(29,null,l))}}async locateExtension(m){const p=await this.extensionManagementService.getInstalled();m.forEach(S=>{p.forEach(g=>{if(g.identifier.id===S&&g.location.scheme===w.Schemas.file){this.logger.info(g.location.fsPath);return}})})}notInstalled(m){return this.location?(0,b.localize)(30,null,m,this.location):(0,b.localize)(31,null,m)}};e.ExtensionManagementCLI=a,e.ExtensionManagementCLI=a=ze([Me(1,o.IExtensionManagementService),Me(2,o.IExtensionGalleryService)],a)}),define(ye[276],Ie([1,0,6,2,26,39,22,16]),function(se,e,i,r,w,C,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class b extends r.Disposable{constructor(D,y,d,E,a,f,m){super(),this.extensionManagementService=D,this.extensionsScannerService=y,this.userDataProfilesService=d,this.extensionsProfileScannerService=E,this.uriIdentityService=a,this.fileService=f,this.logService=m,this._onDidChangeExtensionsByAnotherSource=this._register(new i.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new r.DisposableMap),this.initialize().then(null,p=>m.error(p))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(D=>this.onDidChangeProfiles(D.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(D=>this.onAddExtensions(D))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(D=>this.onDidAddExtensions(D))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(D=>this.onRemoveExtensions(D))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(D=>this.onDidRemoveExtensions(D))),this._register(this.fileService.onDidFilesChange(D=>this.onDidFilesChange(D)))}async onDidChangeProfiles(D){try{D.length&&await Promise.all(D.map(y=>(this.extensionsProfileWatchDisposables.set(y.id,(0,r.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(y.extensionsResource)),this.fileService.watch(y.extensionsResource))),this.populateExtensionsFromProfile(y.extensionsResource))))}catch(y){throw this.logService.error(y),y}}async onAddExtensions(D){for(const y of D.extensions)this.addExtensionWithKey(this.getKey(y.identifier,y.version),D.profileLocation)}async onDidAddExtensions(D){for(const y of D.extensions){const d=this.getKey(y.identifier,y.version);D.error?this.removeExtensionWithKey(d,D.profileLocation):this.addExtensionWithKey(d,D.profileLocation)}}async onRemoveExtensions(D){for(const y of D.extensions)this.removeExtensionWithKey(this.getKey(y.identifier,y.version),D.profileLocation)}async onDidRemoveExtensions(D){const y=[],d=[];for(const E of D.extensions){const a=this.getKey(E.identifier,E.version);D.error?this.addExtensionWithKey(a,D.profileLocation):(this.removeExtensionWithKey(a,D.profileLocation),this.allExtensions.has(a)||(this.logService.debug("Extension is removed from all profiles",E.identifier.id,E.version),d.push(this.extensionManagementService.scanInstalledExtensionAtLocation(E.location).then(f=>{f?y.push(f):this.logService.info("Extension not found at the location",E.location.toString())},f=>this.logService.error(f)))))}try{await Promise.all(d),y.length&&await this.uninstallExtensionsNotInProfiles(y)}catch(E){this.logService.error(E)}}onDidFilesChange(D){for(const y of this.userDataProfilesService.profiles)D.contains(y.extensionsResource,_.FileChangeType.UPDATED,_.FileChangeType.ADDED)&&this.onDidExtensionsProfileChange(y.extensionsResource)}async onDidExtensionsProfileChange(D){const y=[],d=[],E=await this.extensionsProfileScannerService.scanProfileExtensions(D),a=new Set,f=new Set;for(const[m,p]of this.allExtensions)p.has(D)&&f.add(m);for(const m of E){const p=this.getKey(m.identifier,m.version);a.add(p),f.has(p)||(y.push(m.identifier),this.addExtensionWithKey(p,D))}for(const m of f)if(!a.has(m)){const p=this.fromKey(m);p&&(d.push(p.identifier),this.removeExtensionWithKey(m,D))}(y.length||d.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y.length?{extensions:y,profileLocation:D}:void 0,removed:d.length?{extensions:d,profileLocation:D}:void 0})}async populateExtensionsFromProfile(D){const y=await this.extensionsProfileScannerService.scanProfileExtensions(D);for(const d of y)this.addExtensionWithKey(this.getKey(d.identifier,d.version),D)}async uninstallExtensionsNotInProfiles(D){D||(D=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(d=>!this.allExtensions.has(this.getKey(d.identifier,d.manifest.version)))),D.length&&await this.extensionManagementService.markAsUninstalled(...D)}addExtensionWithKey(D,y){let d=this.allExtensions.get(D);d||this.allExtensions.set(D,d=new w.ResourceSet(E=>this.uriIdentityService.extUri.getComparisonKey(E))),d.add(y)}removeExtensionWithKey(D,y){const d=this.allExtensions.get(D);d&&d.delete(y),d?.size||this.allExtensions.delete(D)}getKey(D,y){return`${R.ExtensionIdentifier.toKey(D.id)}@${y}`}fromKey(D){const[y,d]=(0,C.getIdAndVersion)(D);return d?{identifier:{id:y},version:d}:void 0}}e.ExtensionsWatcher=b}),define(ye[133],Ie([1,0,96,18,14,2,13,9,25,28,30,39,12,92,4]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let f=class extends E.LanguagePackBaseService{constructor(g,v,t,l){super(t),this.extensionManagementService=g,this.logService=l,this.cache=this._register(new m(v,l)),this.extensionManagementService.registerParticipant({postInstall:async n=>this.postInstallExtension(n),postUninstall:async n=>this.postUninstallExtension(n)})}async getBuiltInExtensionTranslationsUri(g,v){const l=(await this.cache.getLanguagePacks())[v];if(!l){this.logService.warn(`No language pack found for ${v}`);return}const n=l.translations[g];return n?a.URI.file(n):void 0}async getInstalledLanguages(){const g=await this.cache.getLanguagePacks(),v=Object.keys(g).map(t=>{const l=g[t];return{...this.createQuickPickItem(t,l.label),extensionId:l.extensions[0].extensionIdentifier.id}});return v.push(this.createQuickPickItem("en","English")),v.sort((t,l)=>t.label.localeCompare(l.label)),v}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const v=await this.cache.getLanguagePacks();Object.keys(v).some(t=>v[t]&&v[t].extensions.some(l=>(0,y.areSameExtensions)(l.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,v]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),t=await this.cache.update(v);return!(0,r.equals)(Object.keys(g),Object.keys(t))}};e.NativeLanguagePackService=f,e.NativeLanguagePackService=f=ze([Me(0,D.IExtensionManagementService),Me(1,o.INativeEnvironmentService),Me(2,D.IExtensionGalleryService),Me(3,d.ILogService)],f);let m=class extends C.Disposable{constructor(g,v){super(),this.logService=v,this.languagePacks={},this.languagePacksFilePath=(0,_.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new w.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(v=>{Object.keys(v).forEach(t=>delete v[t]),this.createLanguagePacksFromExtensions(v,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...v){for(const t of v)t&&t.manifest&&t.manifest.contributes&&t.manifest.contributes.localizations&&t.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,t);Object.keys(g).forEach(t=>this.updateHash(g[t]))}createLanguagePacksFromExtension(g,v){const t=v.identifier,l=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const n of l)if(v.location.scheme===R.Schemas.file&&p(n)){let h=g[n.languageId];h||(h={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},g[n.languageId]=h);const s=h.extensions.filter(c=>(0,y.areSameExtensions)(c.extensionIdentifier,t))[0];s?s.version=v.manifest.version:h.extensions.push({extensionIdentifier:t,version:v.manifest.version});for(const c of n.translations)h.translations[c.id]=(0,_.join)(v.location.fsPath,c.path)}}updateHash(g){if(g){const v=(0,i.createHash)("md5");for(const t of g.extensions)v.update(t.extensionIdentifier.uuid||t.extensionIdentifier.id).update(t.version);g.hash=v.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let v=null;return b.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,t=>t.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(t)).then(t=>{try{return JSON.parse(t)}catch{return{}}}).then(t=>(v=g(t),t)).then(t=>{for(const n of Object.keys(t))t[n]||delete t[n];this.languagePacks=t,this.initializedCache=!0;const l=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",l),b.Promises.writeFile(this.languagePacksFilePath,l)}).then(()=>v,t=>this.logService.error(t))})}};m=ze([Me(0,o.INativeEnvironmentService),Me(1,d.ILogService)],m);function p(S){if(typeof S.languageId!="string"||!Array.isArray(S.translations)||S.translations.length===0)return!1;for(const g of S.translations)if(typeof g.id!="string"||typeof g.path!="string")return!1;return!(S.languageName&&typeof S.languageName!="string"||S.localizedLanguageName&&typeof S.localizedLanguageName!="string")}}),define(ye[277],Ie([1,0,193,10,21,41]),function(se,e,i,r,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const R="https://0.0.0.0/OneCollector/1.0",_="https://0.0.0.0/ping";async function b(D,y,d){const E=await(0,i.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),a=await(0,i.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),f=new E.AppInsightsCore,m=new a.PostChannel,p={instrumentationKey:D,endpointUrl:R,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[m]]};if(d){p.extensionConfig={};const S={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:d};p.extensionConfig[m.identifier]=S}return f.initialize(p,[]),f.addTelemetryInitializer(S=>{S.ext=S.ext??{},S.ext.web=S.ext.web??{},S.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',y&&(S.ext.utc=S.ext.utc??{},S.ext.utc.flags=8462029)}),f}class o{constructor(y,d,E,a,f){this._isInternalTelemetry=y,this._eventPrefix=d,this._defaultData=E,this._xhrOverride=f,this.endPointUrl=R,this.endPointHealthUrl=_,this._defaultData||(this._defaultData={}),typeof a=="function"?this._aiCoreOrKey=a():this._aiCoreOrKey=a,this._asyncAiCore=null}_withAIClient(y){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){y(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=b(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(d=>{y(d)},d=>{(0,r.onUnexpectedError)(d),console.error(d)})}}log(y,d){if(!this._aiCoreOrKey)return;d=(0,w.mixin)(d,this._defaultData),d=(0,C.validateTelemetryData)(d);const E=this._eventPrefix+"/"+y;try{this._withAIClient(a=>{a.pluginVersionString=d?.properties.version??"Unknown",a.track({name:E,baseData:{name:E,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(y=>{this._withAIClient(d=>{d.unload(!0,()=>{this._aiCoreOrKey=void 0,y(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=o});var gt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ye[278],Ie([1,0,2,21,3,17,224,27,46,62,29,38,24,41]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0,o=gt(o);let a=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(p,S,g){this._configurationService=S,this._productService=g,this._experimentProperties={},this._disposables=new i.DisposableStore,this._cleanupPatterns=[],this._appenders=p.appenders,this._commonProperties=p.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.devDeviceId=this._commonProperties["common.devDeviceId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=p.piiPaths||[],this._telemetryLevel=d.TelemetryLevel.USAGE,this._sendErrorTelemetry=!!p.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const v of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(v),"gi")),v.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(v.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(v=>{(v.affectsConfiguration(d.TELEMETRY_SETTING_ID)||v.affectsConfiguration(d.TELEMETRY_OLD_SETTING_ID)||v.affectsConfiguration(d.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(p,S){this._experimentProperties[p]=S}_updateTelemetryLevel(){let p=(0,E.getTelemetryLevel)(this._configurationService);const S=this._productService.enabledTelemetryLevels;if(S){this._sendErrorTelemetry=this.sendErrorTelemetry?S.error:!1;const g=S.usage?d.TelemetryLevel.USAGE:S.error?d.TelemetryLevel.ERROR:d.TelemetryLevel.NONE;p=Math.min(p,g)}this._telemetryLevel=p}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(p,S,g){this._telemetryLevel<S||(g=(0,r.mixin)(g,this._experimentProperties),g=(0,E.cleanData)(g,this._cleanupPatterns),g=(0,r.mixin)(g,this._commonProperties),this._appenders.forEach(v=>v.log(p,g)))}publicLog(p,S){this._log(p,d.TelemetryLevel.USAGE,S)}publicLog2(p,S){this.publicLog(p,S)}publicLogError(p,S){this._sendErrorTelemetry&&this._log(p,d.TelemetryLevel.ERROR,S)}publicLogError2(p,S){this.publicLogError(p,S)}};e.TelemetryService=a,e.TelemetryService=a=ze([Me(1,_.IConfigurationService),Me(2,D.IProductService)],a);function f(){const m=(0,R.localize)(0,null,o.default.nameLong),p=o.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",o.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),S=w.isWeb?"":(0,R.localize)(3,null),g=(0,R.localize)(4,null),v=(0,R.localize)(5,null),t=(0,R.localize)(6,null),l=(0,R.localize)(7,null),n=`
|       | ${g} | ${v} | ${t} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,h=(0,R.localize)(8,null);return`
${m} ${p} ${S}

&nbsp;

${l}
${n}

&nbsp;

${h}
`}y.Registry.as(b.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,R.localize)(9,null),properties:{[d.TELEMETRY_SETTING_ID]:{type:"string",enum:[d.TelemetryConfiguration.ON,d.TelemetryConfiguration.ERROR,d.TelemetryConfiguration.CRASH,d.TelemetryConfiguration.OFF],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:f(),default:d.TelemetryConfiguration.OFF,restricted:!0,scope:b.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(b.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[d.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:o.default.privacyStatementUrl?(0,R.localize)(16,null,o.default.nameLong,o.default.privacyStatementUrl):(0,R.localize)(15,null,o.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${d.TELEMETRY_SETTING_ID}#\``),scope:b.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(ye[279],Ie([1,0,27,5,29,24,278,41]),function(se,e,i,r,w,C,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let b=class extends R.TelemetryService{constructor(D,y,d,E){super(D,d,E),this._injectedTelemetryLevel=y}publicLog(D,y){if(!(this._injectedTelemetryLevel<C.TelemetryLevel.USAGE))return super.publicLog(D,y)}publicLog2(D,y){return this.publicLog(D,y)}publicLogError(D,y){return this._injectedTelemetryLevel<C.TelemetryLevel.ERROR?Promise.resolve(void 0):super.publicLogError(D,y)}publicLogError2(D,y){return this.publicLogError(D,y)}async updateInjectedTelemetryLevel(D){if(D===void 0)throw this._injectedTelemetryLevel=C.TelemetryLevel.NONE,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this._injectedTelemetryLevel=this._injectedTelemetryLevel?Math.min(this._injectedTelemetryLevel,D):D,this._injectedTelemetryLevel===C.TelemetryLevel.NONE&&this.dispose()}};e.ServerTelemetryService=b,e.ServerTelemetryService=b=ze([Me(2,i.IConfigurationService),Me(3,w.IProductService)],b),e.ServerNullTelemetryService=new class extends _.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,r.refineServiceDecorator)(C.ITelemetryService)}),define(ye[280],Ie([1,0,15,19,336,277]),function(se,e,i,r,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0,w=Be(w);async function R(D,y){const d=await y.request(D,r.CancellationToken.None),E=(await(0,i.streamToBuffer)(d.stream)).toString(),a=d.res.statusCode??200;return{headers:d.res.headers,statusCode:a,responseData:E}}async function _(D){const y={method:D.type,headers:D.headers};return new Promise((E,a)=>{const f=w.request(D.url??"",y,m=>{m.on("data",function(p){E({headers:m.headers,statusCode:m.statusCode??200,responseData:p.toString()})}),m.on("error",function(p){a(p)})});f.write(D.data,m=>{m&&a(m)}),f.end()})}async function b(D,y,d){const E=typeof y.data=="string"?y.data:new TextDecoder().decode(y.data),a={type:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data).toString()},url:y.urlString,data:E};try{const f=D?await R(a,D):await _(a);d(f.statusCode,f.headers,f.responseData)}catch{d(0,{})}}class o extends C.AbstractOneDataSystemAppender{constructor(y,d,E,a,f){const m={sendPOST:(p,S)=>{b(y,p,S)}};super(d,E,a,f,m)}}e.OneDataSystemAppender=o});var gt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ye[281],Ie([1,0,10,273]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=gt(r);class w extends r.default{installErrorListeners(){(0,i.setUnexpectedErrorHandler)(_=>console.error(_));const R=[];process.on("unhandledRejection",(_,b)=>{R.push(b),setTimeout(()=>{const o=R.indexOf(b);o>=0&&b.catch(D=>{R.splice(o,1),(0,i.isCancellationError)(D)||(console.warn(`rejected promise not handled within 1 second: ${D}`),D.stack&&console.warn(`stack trace: ${D.stack}`),_&&(0,i.onUnexpectedError)(_))})},1e3)}),process.on("rejectionHandled",_=>{const b=R.indexOf(_);b>=0&&R.splice(b,1)}),process.on("uncaughtException",_=>{(0,i.isSigPipeError)(_)||(0,i.onUnexpectedError)(_)})}}e.default=w}),define(ye[134],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var i;(function(r){r[r.Replace=1]="Replace",r[r.Append=2]="Append",r[r.Prepend=3]="Prepend"})(i||(e.EnvironmentVariableMutatorType=i={}))}),define(ye[135],Ie([1,0,3,134]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const w=new Map([[r.EnvironmentVariableMutatorType.Append,"APPEND"],[r.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[r.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class C{constructor(D){this.collections=D,this.map=new Map,this.descriptionMap=new Map,D.forEach((y,d)=>{this.populateDescriptionMap(y,d);const E=y.map.entries();let a=E.next();for(;!a.done;){const f=a.value[1],m=a.value[0];let p=this.map.get(m);if(p||(p=[],this.map.set(m,p)),p.length>0&&p[0].type===r.EnvironmentVariableMutatorType.Replace){a=E.next();continue}const S={extensionIdentifier:d,value:f.value,type:f.type,scope:f.scope,variable:f.variable,options:f.options};S.scope||delete S.scope,p.unshift(S),a=E.next()}})}async applyToProcessEnvironment(D,y,d){let E;i.isWindows&&(E={},Object.keys(D).forEach(a=>E[a.toLowerCase()]=a));for(const[a,f]of this.getVariableMap(y)){const m=i.isWindows&&E[a.toLowerCase()]||a;for(const p of f){const S=d?await d(p.value):p.value;if(p.options?.applyAtProcessCreation??!0)switch(p.type){case r.EnvironmentVariableMutatorType.Append:D[m]=(D[m]||"")+S;break;case r.EnvironmentVariableMutatorType.Prepend:D[m]=S+(D[m]||"");break;case r.EnvironmentVariableMutatorType.Replace:D[m]=S;break}if(p.options?.applyAtShellIntegration??!1){const g=`VSCODE_ENV_${w.get(p.type)}`;D[g]=(D[g]?D[g]+":":"")+a+"="+this._encodeColons(S)}}}}_encodeColons(D){return D.replaceAll(":","\\x3a")}diff(D,y){const d=new Map,E=new Map,a=new Map;if(D.getVariableMap(y).forEach((f,m)=>{const p=this.getVariableMap(y).get(m),S=_(f,p);S&&d.set(m,S)}),this.getVariableMap(y).forEach((f,m)=>{const p=D.getVariableMap(y).get(m),S=_(f,p);S&&a.set(m,S)}),this.getVariableMap(y).forEach((f,m)=>{const p=D.getVariableMap(y).get(m),S=b(f,p);S&&E.set(m,S)}),!(d.size===0&&E.size===0&&a.size===0))return{added:d,changed:E,removed:a}}getVariableMap(D){const y=new Map;for(const d of this.map.values()){const E=d.filter(a=>R(a,D));E.length>0&&y.set(E[0].variable,E)}return y}getDescriptionMap(D){const y=new Map;for(const d of this.descriptionMap.values()){const E=d.filter(a=>R(a,D,!0));for(const a of E)y.set(a.extensionIdentifier,a.description)}return y}populateDescriptionMap(D,y){if(!D.descriptionMap)return;const d=D.descriptionMap.entries();let E=d.next();for(;!E.done;){const a=E.value[1],f=E.value[0];let m=this.descriptionMap.get(f);m||(m=[],this.descriptionMap.set(f,m));const p={extensionIdentifier:y,scope:a.scope,description:a.description};p.scope||delete p.scope,m.push(p),E=d.next()}}}e.MergedEnvironmentVariableCollection=C;function R(o,D,y=!1){return o.scope?!!(o.scope.workspaceFolder&&D?.workspaceFolder&&o.scope.workspaceFolder.index===D.workspaceFolder.index):y?D===o.scope:!0}function _(o,D){if(!D)return o;const y=new Set;D.forEach(E=>y.add(E.extensionIdentifier));const d=[];return o.forEach(E=>{y.has(E.extensionIdentifier)||d.push(E)}),d.length===0?void 0:d}function b(o,D){if(!D)return;const y=new Map;D.forEach(E=>y.set(E.extensionIdentifier,E));const d=[];return o.forEach(E=>{const a=y.get(E.extensionIdentifier);a&&(E.type!==a.type||E.value!==a.value||E.scope?.workspaceFolder?.index!==a.scope?.workspaceFolder?.index)&&d.push(a)}),d.length===0?void 0:d}}),define(ye[97],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=i,e.serializeEnvironmentDescriptionMap=r,e.deserializeEnvironmentVariableCollection=w,e.deserializeEnvironmentDescriptionMap=C,e.serializeEnvironmentVariableCollections=R,e.deserializeEnvironmentVariableCollections=_;function i(b){return[...b.entries()]}function r(b){return b?[...b.entries()]:[]}function w(b){return new Map(b)}function C(b){return new Map(b??[])}function R(b){return Array.from(b.entries()).map(o=>[o[0],i(o[1].map),r(o[1].descriptionMap)])}function _(b){return new Map(b.map(o=>[o[0],{map:w(o[1]),descriptionMap:C(o[2])}]))}}),define(ye[282],Ie([1,0,14,19,6,2,12]),function(se,e,i,r,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let _=class extends C.Disposable{constructor(o,D){super(),this._logService=D,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new w.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=o===void 0?15e3:o,this._register((0,C.toDisposable)(()=>{for(const y of this._pendingRequestDisposables.values())(0,C.dispose)(y)}))}createRequest(o){return new Promise((D,y)=>{const d=++this._lastRequestId;this._pendingRequests.set(d,D),this._onCreateRequest.fire({requestId:d,...o});const E=new r.CancellationTokenSource;(0,i.timeout)(this._timeout,E.token).then(()=>y(`Request ${d} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(d,[(0,C.toDisposable)(()=>E.cancel())])})}acceptReply(o,D){const y=this._pendingRequests.get(o);y?(this._pendingRequests.delete(o),(0,C.dispose)(this._pendingRequestDisposables.get(o)||[]),this._pendingRequestDisposables.delete(o),y(D)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${o}`)}};e.RequestStore=_,e.RequestStore=_=ze([Me(1,R.ILogService)],_)}),define(ye[53],Ie([1,0,5,42,38]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new r.RawContextKey("terminalTabFocusMode",!1,!0);var C;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(C||(e.TerminalSettingPrefix=C={}));var R;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(R||(e.TerminalSettingId=R={}));var _;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(_||(e.PosixShellType=_={}));var b;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(b||(e.WindowsShellType=b={}));var o;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(o||(e.TitleEventSource=o={}));var D;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(D||(e.TerminalIpcChannels=D={}));var y;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.IPtyService=(0,i.createDecorator)("ptyService");var d;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(d||(e.HeartbeatConstants=d={}));var E;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(E||(e.TerminalLocation=E={}));var a;(function(t){t.TerminalView="view",t.Editor="editor"})(a||(e.TerminalLocationString=a={}));var f;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(f||(e.LocalReconnectConstants=f={}));var m;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(m||(e.FlowControlConstants=m={}));var p;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(p||(e.ProfileSource=p={}));var S;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(S||(e.ShellIntegrationStatus=S={}));var g;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(g||(e.TerminalExitReason=g={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class v{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(l){const n=this._sanitizeRemoteAuthority(l.remoteAuthority);if(this._backends.has(n))throw new Error(`A terminal backend with remote authority '${n}' was already registered.`);this._backends.set(n,l)}getTerminalBackend(l){return this._backends.get(this._sanitizeRemoteAuthority(l))}_sanitizeRemoteAuthority(l){return l?.toLowerCase()??""}}w.Registry.add(e.TerminalExtensions.Backend,new v),e.ILocalPtyService=(0,i.createDecorator)("localPtyService"),e.ITerminalLogService=(0,i.createDecorator)("terminalLogService")}),define(ye[136],Ie([1,0,3]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.escapeNonWindowsPath=r,e.collapseTildePath=w,e.sanitizeCwd=C,e.shouldUseEnvironmentVariableCollection=R;function r(_){let b=_;b.includes("\\")&&(b=b.replace(/\\/g,"\\\\"));const o=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return b=b.replace(o,""),`'${b}'`}function w(_,b,o){if(!_)return"";if(!b)return _;b.match(/[\/\\]$/)&&(b=b.slice(0,b.length-1));const D=_.replace(/\\/g,"/").toLowerCase(),y=b.replace(/\\/g,"/").toLowerCase();return D.includes(y)?`~${o}${_.slice(b.length+1)}`:_}function C(_){return _.match(/^['"].*['"]$/)&&(_=_.substring(1,_.length-1)),i.OS===i.OperatingSystem.Windows&&_&&_[1]===":"?_[0].toUpperCase()+_.substring(1):_}function R(_){return!_.strictEnv}}),define(ye[283],Ie([1,0,57,4,226,82]),function(se,e,i,r,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=R,e.terminalProfileArgsMatch=o,e.terminalIconsEqual=D,e.isUriComponents=y;function R(d,E){const a=[{name:null,description:(0,w.localize)(0,null)}];return a.push(...d.map(f=>({name:f.profileName,description:_(f)}))),E&&a.push(...E.map(f=>({name:f.title,description:b(f)}))),{values:a.map(f=>f.name),markdownDescriptions:a.map(f=>f.description)}}function _(d){let E=`$(${C.ThemeIcon.isThemeIcon(d.icon)?d.icon.id:d.icon?d.icon:i.Codicon.terminal.id}) ${d.profileName}
- path: ${d.path}`;return d.args&&(typeof d.args=="string"?E+=`
- args: "${d.args}"`:E+=`
- args: [${d.args.length===0?"":`'${d.args.join("','")}'`}]`),d.overrideName!==void 0&&(E+=`
- overrideName: ${d.overrideName}`),d.color&&(E+=`
- color: ${d.color}`),d.env&&(E+=`
- env: ${JSON.stringify(d.env)}`),E}function b(d){return`$(${C.ThemeIcon.isThemeIcon(d.icon)?d.icon.id:d.icon?d.icon:i.Codicon.terminal.id}) ${d.title}
- extensionIdentifier: ${d.extensionIdentifier}`}function o(d,E){if(!d&&!E)return!0;if(typeof d=="string"&&typeof E=="string")return d===E;if(Array.isArray(d)&&Array.isArray(E)){if(d.length!==E.length)return!1;for(let a=0;a<d.length;a++)if(d[a]!==E[a])return!1;return!0}return!1}function D(d,E){if(!d&&!E)return!0;if(!d||!E)return!1;if(C.ThemeIcon.isThemeIcon(d)&&C.ThemeIcon.isThemeIcon(E))return d.id===E.id&&d.color===E.color;if(typeof d=="object"&&"light"in d&&"dark"in d&&typeof E=="object"&&"light"in E&&"dark"in E){const a=d,f=E;if((r.URI.isUri(a.light)||y(a.light))&&(r.URI.isUri(a.dark)||y(a.dark))&&(r.URI.isUri(f.light)||y(f.light))&&(r.URI.isUri(f.dark)||y(f.dark)))return a.light.path===f.light.path&&a.dark.path===f.dark.path}if(r.URI.isUri(d)&&r.URI.isUri(E)||y(d)||y(E)){const a=d,f=E;return a.path===f.path&&a.scheme===f.scheme}return!1}function y(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}}),define(ye[284],Ie([1,0,57,3,225,46,38,53,283]),function(se,e,i,r,w,C,R,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.terminalIconSchema=e.terminalColorSchema=void 0,e.registerTerminalPlatformConfiguration=a,e.registerTerminalDefaultProfileConfiguration=m,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,i.getAllCodicons)(),p=>p.id),markdownEnumDescriptions:Array.from((0,i.getAllCodicons)(),p=>`$(${p.id})`)};const o={args:{description:(0,w.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,w.localize)(1,null),type:"boolean"},icon:{description:(0,w.localize)(2,null),...e.terminalIconSchema},color:{description:(0,w.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,w.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},D={type:"object",required:["path"],properties:{path:{description:(0,w.localize)(5,null),type:["string","array"],items:{type:"string"}},...o}},y={type:"object",required:["path"],properties:{path:{description:(0,w.localize)(6,null),type:["string"],items:{type:"string"}},...o}};function d(p){const S=p===r.Platform.Linux?"linux":p===r.Platform.Mac?"osx":"windows";return(0,w.localize)(7,null,(0,r.PlatformToString)(p),'```json\n"terminal.integrated.profile.'+S+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const E={id:"terminal",order:100,title:(0,w.localize)(8,null),type:"object",properties:{[_.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,w.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[_.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,w.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[_.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,w.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[_.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:d(r.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,w.localize)(12,null),enum:["PowerShell","Git Bash"]},...o}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,w.localize)(13,null),type:"string"},id:{description:(0,w.localize)(14,null),type:"string"},title:{description:(0,w.localize)(15,null),type:"string"},...o}},{type:"null"},D]}},[_.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:d(r.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,w.localize)(16,null),type:"string"},id:{description:(0,w.localize)(17,null),type:"string"},title:{description:(0,w.localize)(18,null),type:"string"},...o}},{type:"null"},D]}},[_.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:d(r.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,w.localize)(19,null),type:"string"},id:{description:(0,w.localize)(20,null),type:"string"},title:{description:(0,w.localize)(21,null),type:"string"},...o}},{type:"null"},D]}},[_.TerminalSettingId.UseWslProfiles]:{description:(0,w.localize)(22,null),type:"boolean",default:!0},[_.TerminalSettingId.InheritEnv]:{scope:C.ConfigurationScope.APPLICATION,description:(0,w.localize)(23,null),type:"boolean",default:!0},[_.TerminalSettingId.PersistentSessionScrollback]:{scope:C.ConfigurationScope.APPLICATION,markdownDescription:(0,w.localize)(24,null),type:"number",default:100},[_.TerminalSettingId.ShowLinkHover]:{scope:C.ConfigurationScope.APPLICATION,description:(0,w.localize)(25,null),type:"boolean",default:!0},[_.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,w.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function a(){R.Registry.as(C.Extensions.Configuration).registerConfiguration(E),m()}let f;function m(p,S){const g=R.Registry.as(C.Extensions.Configuration);let v;p&&(v=(0,b.createProfileSchemaEnums)(p?.profiles,S));const t=f;f={id:"terminal",order:100,title:(0,w.localize)(27,null),type:"object",properties:{[_.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,w.localize)(28,null),type:["string","null"],default:null,enum:p?.os===r.OperatingSystem.Linux?v?.values:void 0,markdownEnumDescriptions:p?.os===r.OperatingSystem.Linux?v?.markdownDescriptions:void 0},[_.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,w.localize)(29,null),type:["string","null"],default:null,enum:p?.os===r.OperatingSystem.Macintosh?v?.values:void 0,markdownEnumDescriptions:p?.os===r.OperatingSystem.Macintosh?v?.markdownDescriptions:void 0},[_.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,w.localize)(30,null),type:["string","null"],default:null,enum:p?.os===r.OperatingSystem.Windows?v?.values:void 0,markdownEnumDescriptions:p?.os===r.OperatingSystem.Windows?v?.markdownDescriptions:void 0}}},g.updateConfigurations({add:[f],remove:t?[t]:[]})}}),define(ye[285],Ie([1,0,2,13,117,28,118]),function(se,e,i,r,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodePtyHostStarter=void 0;let _=class extends i.Disposable{constructor(o,D){super(),this._reconnectConstants=o,this._environmentService=D}start(){const o={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsHome.with({scheme:r.Schemas.file}).fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},D=(0,R.parsePtyHostDebugPort)(this._environmentService.args,this._environmentService.isBuilt);D&&(D.break&&D.port?o.debugBrk=D.port:!D.break&&D.port&&(o.debug=D.port));const y=new w.Client(r.FileAccess.asFileUri("bootstrap-fork").fsPath,o),d=new i.DisposableStore;return d.add(y),{client:y,store:d,onDidProcessExit:y.onDidProcessExit}}};e.NodePtyHostStarter=_,e.NodePtyHostStarter=_=ze([Me(1,C.IEnvironmentService)],_)}),define(ye[286],Ie([1,0,32,13,21,9,3,33,17,11,25,134,97,135]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsBuildNumber=a,e.findExecutable=f,e.getShellIntegrationInjection=m,i=Be(i),C=Be(C),_=Be(_),D=Be(D);function a(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(i.release());let I=0;return u&&u.length===4&&(I=parseInt(u[3])),I}async function f(u,I,T,A=_.env,O=D.Promises.exists){if(C.isAbsolute(u))return await O(u)?u:void 0;if(I===void 0&&(I=_.cwd()),C.dirname(u)!=="."){const Y=C.join(I,u);return await O(Y)?Y:void 0}const P=(0,w.getCaseInsensitive)(A,"PATH");if(T===void 0&&(0,o.isString)(P)&&(T=P.split(C.delimiter)),T===void 0||T.length===0){const Y=C.join(I,u);return await O(Y)?Y:void 0}for(const Y of T){let X;if(C.isAbsolute(Y)?X=C.join(Y,u):X=C.join(I,Y,u),await O(X))return X;if(R.isWindows){let re=X+".com";if(await O(re)||(re=X+".exe",await O(re)))return re}}const B=C.join(I,u);return await O(B)?B:void 0}function m(u,I,T,A,O){const k=R.isWindows&&(!I.windowsEnableConpty||a()<18309);if(!I.shellIntegration.enabled||!u.executable||u.isFeatureTerminal&&!u.forceShellIntegration||u.ignoreShellIntegration||k)return;const P=u.args,B=_.platform==="win32"?C.basename(u.executable).toLowerCase():C.basename(u.executable),Y=C.dirname(r.FileAccess.asFileUri("").fsPath);let X;const re={VSCODE_INJECTION:"1"};if(I.shellIntegration.nonce&&(re.VSCODE_NONCE=I.shellIntegration.nonce),R.isWindows){if(B==="pwsh.exe"||B==="powershell.exe")return!P||s(P)?X=g.get(S.WindowsPwsh):h(P)&&(X=g.get(S.WindowsPwshLogin)),X?(X=[...X],X[X.length-1]=(0,b.format)(X[X.length-1],Y,""),re.VSCODE_STABLE=O.quality==="stable"?"1":"0",I.shellIntegration.suggestEnabled&&(re.VSCODE_SUGGEST="1"),{newArgs:X,envMixin:re}):void 0;if(B==="bash.exe")return!P||P.length===0?X=g.get(S.Bash):c(P)&&(re.VSCODE_SHELL_LOGIN="1",p(I,re),X=g.get(S.Bash)),X?(X=[...X],X[X.length-1]=(0,b.format)(X[X.length-1],Y),re.VSCODE_STABLE=O.quality==="stable"?"1":"0",{newArgs:X,envMixin:re}):void 0;A.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args);return}switch(B){case"bash":return!P||P.length===0?X=g.get(S.Bash):c(P)&&(re.VSCODE_SHELL_LOGIN="1",p(I,re),X=g.get(S.Bash)),X?(X=[...X],X[X.length-1]=(0,b.format)(X[X.length-1],Y),re.VSCODE_STABLE=O.quality==="stable"?"1":"0",{newArgs:X,envMixin:re}):void 0;case"fish":{const te=T?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",Z=C.join(Y,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return re.XDG_DATA_DIRS=`${te}:${Z}`,p(I,re),{newArgs:void 0,envMixin:re}}case"pwsh":return!P||s(P)?X=g.get(S.Pwsh):h(P)&&(X=g.get(S.PwshLogin)),X?(I.shellIntegration.suggestEnabled&&(re.VSCODE_SUGGEST="1"),X=[...X],X[X.length-1]=(0,b.format)(X[X.length-1],Y,""),re.VSCODE_STABLE=O.quality==="stable"?"1":"0",{newArgs:X,envMixin:re}):void 0;case"zsh":{if(!P||P.length===0?X=g.get(S.Zsh):c(P)?(X=g.get(S.ZshLogin),p(I,re)):(P===g.get(S.Zsh)||P===g.get(S.ZshLogin))&&(X=P),!X)return;X=[...X],X[X.length-1]=(0,b.format)(X[X.length-1],Y);let te;try{te=i.userInfo().username}catch{te="unknown"}const Z=C.join(i.tmpdir(),`${te}-${O.applicationName}-zsh`);re.ZDOTDIR=Z;const fe=T?.ZDOTDIR??i.homedir()??"~";re.USER_ZDOTDIR=fe;const K=[];return K.push({source:C.join(Y,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:C.join(Z,".zshrc")}),K.push({source:C.join(Y,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:C.join(Z,".zprofile")}),K.push({source:C.join(Y,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:C.join(Z,".zshenv")}),K.push({source:C.join(Y,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:C.join(Z,".zlogin")}),{newArgs:X,envMixin:re,filesToCopy:K}}}A.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args)}function p(u,I){if(R.isMacintosh&&u.environmentVariableCollections){const T=(0,d.deserializeEnvironmentVariableCollections)(u.environmentVariableCollections),O=new E.MergedEnvironmentVariableCollection(T).getVariableMap({workspaceFolder:u.workspaceFolder}).get("PATH"),k=[];if(O)for(const P of O)P.type===y.EnvironmentVariableMutatorType.Prepend&&k.push(P.value);k.length>0&&(I.VSCODE_PATH_PREFIX=k.join(""))}}var S;(function(u){u.WindowsPwsh="windows-pwsh",u.WindowsPwshLogin="windows-pwsh-login",u.Pwsh="pwsh",u.PwshLogin="pwsh-login",u.Zsh="zsh",u.ZshLogin="zsh-login",u.Bash="bash"})(S||(S={}));const g=new Map;g.set(S.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(S.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(S.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),g.set(S.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),g.set(S.Zsh,["-i"]),g.set(S.ZshLogin,["-il"]),g.set(S.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const v=["-login","-l"],t=["--login","-l"],l=["-i","--interactive"],n=["-nol","-nologo"];function h(u){return typeof u=="string"?v.includes(u.toLowerCase()):u.length===1&&v.includes(u[0].toLowerCase())||u.length===2&&(v.includes(u[0].toLowerCase())||v.includes(u[1].toLowerCase()))&&(n.includes(u[0].toLowerCase())||n.includes(u[1].toLowerCase()))}function s(u){return typeof u=="string"?n.includes(u.toLowerCase()):u.length===0||u?.length===1&&n.includes(u[0].toLowerCase())}function c(u){return typeof u!="string"&&(u=u.filter(I=>!l.includes(I.toLowerCase()))),u==="string"&&t.includes(u.toLowerCase())||typeof u!="string"&&u.length===1&&t.includes(u[0].toLowerCase())}}),define(ye[287],Ie([1,0,60,57,9,3,11,25,113,53,286,83]),function(se,e,i,r,w,C,R,_,b,o,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=f,i=Be(i),_=Be(_);var d;(function(I){I.UnixShellsPath="/etc/shells"})(d||(d={}));let E,a=!0;function f(I,T,A,O,k=process.env,P,B,Y,X){return P=P||{existsFile:_.SymlinkSupport.existsFile,readFile:_.Promises.readFile},C.isWindows?m(A,P,k,B,O.getValue(o.TerminalSettingId.UseWslProfiles)!==!1,I&&typeof I=="object"?{...I}:O.getValue(o.TerminalSettingId.ProfilesWindows),typeof T=="string"?T:O.getValue(o.TerminalSettingId.DefaultProfileWindows),X,Y):s(P,B,A,I&&typeof I=="object"?{...I}:O.getValue(C.isLinux?o.TerminalSettingId.ProfilesLinux:o.TerminalSettingId.ProfilesMacOs),typeof T=="string"?T:O.getValue(C.isLinux?o.TerminalSettingId.DefaultProfileLinux:o.TerminalSettingId.DefaultProfileMacOs),X,Y,k)}async function m(I,T,A,O,k,P,B,Y,X){const re=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),te=`${process.env.windir}\\${re?"Sysnative":"System32"}`;let Z=!1;(0,D.getWindowsBuildNumber)()>=16299&&(Z=!0),await v(Y);const fe=new Map;if(I){fe.set("PowerShell",{source:o.ProfileSource.Pwsh,icon:r.Codicon.terminalPowershell,isAutoDetected:!0}),fe.set("Windows PowerShell",{path:`${te}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:r.Codicon.terminalPowershell,isAutoDetected:!0}),fe.set("Git Bash",{source:o.ProfileSource.GitBash,isAutoDetected:!0}),fe.set("Command Prompt",{path:`${te}\\cmd.exe`,icon:r.Codicon.terminalCmd,isAutoDetected:!0}),fe.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),fe.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:r.Codicon.terminalBash,isAutoDetected:!0});const ae=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;fe.set("Cmder",{path:`${te}\\cmd.exe`,args:["/K",ae],requiresPath:process.env.CMDER_ROOT?ae:{path:ae,isUnsafe:!0},isAutoDetected:!0})}c(P,fe);const K=await p(fe.entries(),B,T,A,O,X);if(I&&k)try{const ae=await n(`${te}\\${Z?"wsl":"bash"}.exe`,B);for(const x of ae)(!P||!(x.profileName in P))&&K.push(x)}catch{a&&(O?.trace("WSL is not installed, so could not detect WSL profiles"),a=!1)}return K}async function p(I,T,A,O=process.env,k,P){const B=[];for(const[Y,X]of I)B.push(S(Y,X,T,A,O,k,P));return(await Promise.all(B)).filter(Y=>!!Y)}async function S(I,T,A,O,k=process.env,P,B){if(T===null)return;let Y,X,re;if("source"in T&&!("path"in T)){const K=E?.get(T.source);if(!K)return;Y=K.paths,X=T.args||K.args,T.icon?re=g(T.icon):K.icon&&(re=K.icon)}else Y=Array.isArray(T.path)?T.path:[T.path],X=C.isWindows||Array.isArray(T.args)?T.args:void 0,re=g(T.icon);let te;if(B){const K=Y.map(x=>typeof x=="string"?x:x.path),ae=await B(K);te=new Array(Y.length);for(let x=0;x<Y.length;x++)typeof Y[x]=="string"?te[x]=ae[x]:te[x]={path:ae[x],isUnsafe:!0}}else te=Y.slice();let Z;if(T.requiresPath){let K;if((0,R.isString)(T.requiresPath)?K=T.requiresPath:(K=T.requiresPath.path,T.requiresPath.isUnsafe&&(Z=K)),!await O.existsFile(K))return}const fe=await u(I,A,te,O,k,X,T.env,T.overrideName,T.isAutoDetected,Z);if(!fe){P?.debug("Terminal profile not validated",I,Y);return}return fe.isAutoDetected=T.isAutoDetected,fe.icon=re,fe.color=T.color,fe}function g(I){return typeof I=="string"?{id:I}:I}async function v(I){if(E&&!I)return;const[T,A]=await Promise.all([t(),I||l()]);E=new Map,E.set(o.ProfileSource.GitBash,{profileName:"Git Bash",paths:T,args:["--login","-i"]}),E.set(o.ProfileSource.Pwsh,{profileName:"PowerShell",paths:A,icon:r.Codicon.terminalPowershell})}async function t(){const I=new Set,T=await(0,D.findExecutable)("git.exe");if(T){const k=(0,y.dirname)(T);I.add((0,y.resolve)(k,"../.."))}function A(k,P){P&&k.add(P)}A(I,process.env.ProgramW6432),A(I,process.env.ProgramFiles),A(I,process.env["ProgramFiles(X86)"]),A(I,`${process.env.LocalAppData}\\Program`);const O=[];for(const k of I)O.push(`${k}\\Git\\bin\\bash.exe`,`${k}\\Git\\usr\\bin\\bash.exe`,`${k}\\usr\\bin\\bash.exe`);return O.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),O.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),O}async function l(){const I=[];for await(const T of(0,b.enumeratePowerShellInstallations)())I.push(T.exePath);return I}async function n(I,T){const A=[],O=await new Promise((B,Y)=>{i.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(X,re)=>{if(X)return Y("Problem occurred when getting wsl distros");B(re)})});if(!O)return[];const k=new RegExp(/[\r?\n]/),P=O.split(k).filter(B=>B.trim().length>0&&B!=="");for(const B of P){if(B===""||B.startsWith("docker-desktop"))continue;const Y=`${B} (WSL)`,X={profileName:Y,path:I,args:["-d",`${B}`],isDefault:Y===T,icon:h(B),isAutoDetected:!1};A.push(X)}return A}function h(I){return I.includes("Ubuntu")?r.Codicon.terminalUbuntu:I.includes("Debian")?r.Codicon.terminalDebian:r.Codicon.terminalLinux}async function s(I,T,A,O,k,P,B,Y){const X=new Map;if(A&&await I.existsFile(d.UnixShellsPath)){const re=(await I.readFile(d.UnixShellsPath)).toString(),te=(P||re.split(`
`)).map(fe=>{const K=fe.indexOf("#");return K===-1?fe:fe.substring(0,K)}).filter(fe=>fe.trim().length>0),Z=new Map;for(const fe of te){let K=(0,w.basename)(fe),ae=Z.get(K)||0;ae++,ae>1&&(K=`${K} (${ae})`),Z.set(K,ae),X.set(K,{path:fe,isAutoDetected:!0})}}return c(O,X),await p(X.entries(),k,I,Y,T,B)}function c(I,T){if(I)for(const[A,O]of Object.entries(I))O===null||typeof O!="object"||!("path"in O)&&!("source"in O)?T.delete(A):(O.icon=O.icon||T.get(A)?.icon,T.set(A,O))}async function u(I,T,A,O,k,P,B,Y,X,re){if(A.length===0)return Promise.resolve(void 0);const te=A.shift();if(te==="")return u(I,T,A,O,k,P,B,Y,X);const Z=typeof te!="string"&&te.isUnsafe,fe=typeof te=="string"?te:te.path,K={profileName:I,path:fe,args:P,env:B,overrideName:Y,isAutoDetected:X,isDefault:I===T,isUnsafePath:Z,requiresUnsafePath:re};if((0,w.basename)(fe)===fe){const x=k.PATH?k.PATH.split(w.delimiter):void 0,z=await(0,D.findExecutable)(fe,void 0,x,void 0,O.existsFile);return z?(K.path=z,K.isFromPath=!0,K):u(I,T,A,O,k,P)}return await O.existsFile((0,w.normalize)(fe))?K:u(I,T,A,O,k,P,B,Y,X)}}),define(ye[288],Ie([1,0,6,2,3,51,27,12,124,94,282,53,284,287,116,48]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var m;(function(S){S[S.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let p=class extends r.Disposable{get _connection(){return this._ensurePtyHost(),this.__connection}get _proxy(){return this._ensurePtyHost(),this.__proxy}get _optionalProxy(){return this.__proxy}_ensurePtyHost(){this.__connection||this._startPtyHost()}constructor(g,v,t,l){super(),this._ptyHostStarter=g,this._configurationService=v,this._logService=t,this._loggerService=l,this._wasQuitRequested=!1,this._restartCount=0,this._isResponsive=!0,this._onPtyHostExit=this._register(new i.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new i.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new i.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new i.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new i.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new i.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new i.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new i.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new i.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new i.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new i.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new i.Emitter),this.onProcessExit=this._onProcessExit.event,(0,d.registerTerminalPlatformConfiguration)(),this._register(this._ptyHostStarter),this._register((0,r.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new D.RequestStore(void 0,this._logService)),this._register(this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables)),this._ptyHostStarter.onRequestConnection&&this._register(i.Event.once(this._ptyHostStarter.onRequestConnection)(()=>this._ensurePtyHost())),this._ptyHostStarter.onWillShutdown&&this._register(this._ptyHostStarter.onWillShutdown(()=>this._wasQuitRequested=!0))}get _ignoreProcessNames(){return this._configurationService.getValue(y.TerminalSettingId.IgnoreProcessNames)}async _refreshIgnoreProcessNames(){return this._optionalProxy?.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(w.isWindows)return process.env;try{return await(0,o.getResolvedShellEnv)(this._configurationService,this._logService,{_:[]},process.env)}catch(g){return this._logService.error("ptyHost was unable to resolve shell environment",g),{}}}_startPtyHost(){const g=this._ptyHostStarter.start(),v=g.client;this._logService.getLevel()===_.LogLevel.Trace&&this._logService.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),C.ProxyChannel.toService(v.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(!0),this._register(g.onDidProcessExit(n=>{this._onPtyHostExit.fire(n.code),!this._wasQuitRequested&&!this._store.isDisposed&&(this._restartCount<=m.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${n.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${n.code}, giving up`))}));const l=C.ProxyChannel.toService(v.getChannel(y.TerminalIpcChannels.PtyHost));return this._register(l.onProcessData(n=>this._onProcessData.fire(n))),this._register(l.onProcessReady(n=>this._onProcessReady.fire(n))),this._register(l.onProcessExit(n=>this._onProcessExit.fire(n))),this._register(l.onDidChangeProperty(n=>this._onDidChangeProperty.fire(n))),this._register(l.onProcessReplay(n=>this._onProcessReplay.fire(n))),this._register(l.onProcessOrphanQuestion(n=>this._onProcessOrphanQuestion.fire(n))),this._register(l.onDidRequestDetach(n=>this._onDidRequestDetach.fire(n))),this._register(new b.RemoteLoggerChannelClient(this._loggerService,v.getChannel(y.TerminalIpcChannels.Logger))),this.__connection=g,this.__proxy=l,this._onPtyHostStart.fire(),this._register(this._configurationService.onDidChangeConfiguration(async n=>{n.affectsConfiguration(y.TerminalSettingId.IgnoreProcessNames)&&await this._refreshIgnoreProcessNames()})),this._refreshIgnoreProcessNames(),[g,l]}async createProcess(g,v,t,l,n,h,s,c,u,I,T){const A=setTimeout(()=>this._handleUnresponsiveCreateProcess(),y.HeartbeatConstants.CreateProcessTimeout),O=await this._proxy.createProcess(g,v,t,l,n,h,s,c,u,I,T);return clearTimeout(A),O}updateTitle(g,v,t){return this._proxy.updateTitle(g,v,t)}updateIcon(g,v,t,l){return this._proxy.updateIcon(g,v,t,l)}attachToProcess(g){return this._proxy.attachToProcess(g)}detachFromProcess(g,v){return this._proxy.detachFromProcess(g,v)}shutdownAll(){return this._proxy.shutdownAll()}listProcesses(){return this._proxy.listProcesses()}async getPerformanceMarks(){return this._optionalProxy?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this._optionalProxy?.reduceConnectionGraceTime()}start(g){return this._proxy.start(g)}shutdown(g,v){return this._proxy.shutdown(g,v)}input(g,v){return this._proxy.input(g,v)}processBinary(g,v){return this._proxy.processBinary(g,v)}resize(g,v,t){return this._proxy.resize(g,v,t)}clearBuffer(g){return this._proxy.clearBuffer(g)}acknowledgeDataEvent(g,v){return this._proxy.acknowledgeDataEvent(g,v)}setUnicodeVersion(g,v){return this._proxy.setUnicodeVersion(g,v)}getInitialCwd(g){return this._proxy.getInitialCwd(g)}getCwd(g){return this._proxy.getCwd(g)}async getLatency(){const g=new f.StopWatch,v=await this._proxy.getLatency();return g.stop(),[{label:"ptyhostservice<->ptyhost",latency:g.elapsed()},...v]}orphanQuestionReply(g){return this._proxy.orphanQuestionReply(g)}installAutoReply(g,v){return this._proxy.installAutoReply(g,v)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(g){return this._proxy.uninstallAutoReply(g)}getDefaultSystemShell(g){return this._optionalProxy?.getDefaultSystemShell(g)??(0,a.getSystemShell)(g??w.OS,process.env)}async getProfiles(g,v,t,l=!1){const n=await this._resolveShellEnv();return(0,E.detectAvailableProfiles)(v,t,l,this._configurationService,n,void 0,this._logService,this._resolveVariables.bind(this,g))}async getEnvironment(){return this.__proxy?this._proxy.getEnvironment():{...process.env}}getWslPath(g,v){return this._proxy.getWslPath(g,v)}getRevivedPtyNewId(g,v){return this._proxy.getRevivedPtyNewId(g,v)}setTerminalLayoutInfo(g){return this._proxy.setTerminalLayoutInfo(g)}async getTerminalLayoutInfo(g){return this._optionalProxy?.getTerminalLayoutInfo(g)}async requestDetachInstance(g,v){return this._proxy.requestDetachInstance(g,v)}async acceptDetachInstanceReply(g,v){return this._proxy.acceptDetachInstanceReply(g,v)}async freePortKillProcess(g){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(g)}async serializeTerminalState(g){return this._proxy.serializeTerminalState(g)}async reviveTerminalProcesses(g,v,t){return this._proxy.reviveTerminalProcesses(g,v,t)}async refreshProperty(g,v){return this._proxy.refreshProperty(g,v)}async updateProperty(g,v,t){return this._proxy.updateProperty(g,v,t)}async restartPtyHost(){this._disposePtyHost(),this._isResponsive=!0,this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll(),this._connection.store.dispose()}_handleHeartbeat(g){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),g?y.HeartbeatConstants.ConnectingBeatInterval:y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(g,v){return this._resolveVariablesRequestStore.createRequest({workspaceId:g,originalText:v})}async acceptPtyHostResolvedVariables(g,v){this._resolveVariablesRequestStore.acceptReply(g,v)}};e.PtyHostService=p,e.PtyHostService=p=ze([Me(1,R.IConfigurationService),Me(2,_.ILogService),Me(3,_.ILoggerService)],p)}),define(ye[36],Ie([1,0,5]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,i.createDecorator)("IUriIdentityService")}),define(ye[137],Ie([1,0,36,120,16,20,168,6,2]),function(se,e,i,r,w,C,R,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class o{static{this._clock=0}constructor(d){this.uri=d,this.time=o._clock++}touch(){return this.time=o._clock++,this}}let D=class{constructor(d){this._fileService=d,this._dispooables=new b.DisposableStore,this._limit=2**16;const E=new Map,a=f=>{let m=E.get(f.scheme);return m===void 0&&(m=d.hasProvider(f)&&!this._fileService.hasCapability(f,w.FileSystemProviderCapabilities.PathCaseSensitive),E.set(f.scheme,m)),m};this._dispooables.add(_.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(f=>{E.delete(f.scheme)})),this.extUri=new C.ExtUri(a),this._canonicalUris=new R.SkipList((f,m)=>this.extUri.compare(f,m,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(d){this._fileService.hasProvider(d)&&(d=(0,C.normalizePath)(d));const E=this._canonicalUris.get(d);return E?E.touch().uri.with({fragment:d.fragment}):(this._canonicalUris.set(d,new o(d)),this._checkTrim(),d)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const d=[...this._canonicalUris.entries()].sort((a,f)=>a[1].time<f[1].time?1:a[1].time>f[1].time?-1:0);o._clock=0,this._canonicalUris.clear();const E=this._limit*.5;for(let a=0;a<E;a++)this._canonicalUris.set(d[a][0],d[a][1].touch())}};e.UriIdentityService=D,e.UriIdentityService=D=ze([Me(0,w.IFileService)],D),(0,r.registerSingleton)(i.IUriIdentityService,D,r.InstantiationType.Delayed)}),define(ye[98],Ie([1,0,228,9,67,20,4,5,13]),function(se,e,i,r,w,C,R,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=o,e.isEmptyWorkspaceIdentifier=D,e.toWorkspaceIdentifier=y,e.isWorkspaceIdentifier=d,e.reviveIdentifier=E,e.isWorkspace=f,e.isWorkspaceFolder=m,e.toWorkspaceFolder=g,e.isUntitledWorkspace=v,e.isTemporaryWorkspace=t,e.isStandaloneEditorWorkspace=l,e.isSavedWorkspace=n,e.hasWorkspaceFileExtension=h,e.IWorkspaceContextService=(0,_.createDecorator)("contextService");function o(s){const c=s;return typeof c?.id=="string"&&R.URI.isUri(c.uri)}function D(s){return typeof s?.id=="string"&&!o(s)&&!d(s)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function y(s,c){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,r.basename)(s)}:c?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const u=s;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}function d(s){const c=s;return typeof c?.id=="string"&&R.URI.isUri(c.configPath)}function E(s){const c=s;if(c?.uri)return{id:c.id,uri:R.URI.revive(c.uri)};const u=s;if(u?.configPath)return{id:u.id,configPath:R.URI.revive(u.configPath)};if(s?.id)return{id:s.id}}var a;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(a||(e.WorkbenchState=a={}));function f(s){const c=s;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}function m(s){const c=s;return!!(c&&typeof c=="object"&&R.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}class p{constructor(c,u,I,T,A){this._id=c,this._transient=I,this._configuration=T,this._ignorePathCasing=A,this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=u}update(c){this._id=c.id,this._configuration=c.configuration,this._transient=c.transient,this._ignorePathCasing=c._ignorePathCasing,this.folders=c.folders}get folders(){return this._folders}set folders(c){this._folders=c,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(c){this._configuration=c}getFolder(c){return c&&this._foldersMap.findSubstr(c)||null}updateFoldersMap(){this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const c of this.folders)this._foldersMap.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=p;class S{constructor(c,u){this.raw=u,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,C.joinPath)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=S;function g(s){return new S({uri:s,index:0,name:(0,C.basenameOrAuthority)(s)},{uri:s.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,i.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(s,c){return C.extUriBiasedIgnorePathCase.isEqualOrParent(s,c.untitledWorkspacesHome)}function t(s){let c;return R.URI.isUri(s)?c=s:c=s.configuration,c?.scheme===b.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function l(s){return s.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function n(s,c){return!v(s,c)&&!t(s)}function h(s){return(typeof s=="string"?(0,r.extname)(s):(0,C.extname)(s))===e.WORKSPACE_SUFFIX}}),define(ye[34],Ie([1,0,66,6,2,20,4,227,28,16,5,12,98,26,36,14,23,17,11]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a,f,m,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=v,e.reviveProfile=t,e.toUserDataProfile=l;var g;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(g||(e.ProfileResourceType=g={}));function v(s){const c=s;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&R.URI.isUri(c.location)&&R.URI.isUri(c.globalStorageHome)&&R.URI.isUri(c.settingsResource)&&R.URI.isUri(c.keybindingsResource)&&R.URI.isUri(c.tasksResource)&&R.URI.isUri(c.snippetsHome)&&R.URI.isUri(c.extensionsResource))}e.IUserDataProfilesService=(0,D.createDecorator)("IUserDataProfilesService");function t(s,c){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:R.URI.revive(s.location).with({scheme:c}),globalStorageHome:R.URI.revive(s.globalStorageHome).with({scheme:c}),settingsResource:R.URI.revive(s.settingsResource).with({scheme:c}),keybindingsResource:R.URI.revive(s.keybindingsResource).with({scheme:c}),tasksResource:R.URI.revive(s.tasksResource).with({scheme:c}),snippetsHome:R.URI.revive(s.snippetsHome).with({scheme:c}),extensionsResource:R.URI.revive(s.extensionsResource).with({scheme:c}),cacheHome:R.URI.revive(s.cacheHome).with({scheme:c}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function l(s,c,u,I,T,A){return{id:s,name:c,location:u,isDefault:!1,shortName:T?.shortName,icon:T?.icon,globalStorageHome:A&&T?.useDefaultFlags?.globalState?A.globalStorageHome:(0,C.joinPath)(u,"globalStorage"),settingsResource:A&&T?.useDefaultFlags?.settings?A.settingsResource:(0,C.joinPath)(u,"settings.json"),keybindingsResource:A&&T?.useDefaultFlags?.keybindings?A.keybindingsResource:(0,C.joinPath)(u,"keybindings.json"),tasksResource:A&&T?.useDefaultFlags?.tasks?A.tasksResource:(0,C.joinPath)(u,"tasks.json"),snippetsHome:A&&T?.useDefaultFlags?.snippets?A.snippetsHome:(0,C.joinPath)(u,"snippets"),extensionsResource:A&&T?.useDefaultFlags?.extensions?A.extensionsResource:(0,C.joinPath)(u,"extensions.json"),cacheHome:(0,C.joinPath)(I,s),useDefaultFlags:T?.useDefaultFlags,isTransient:T?.transient}}let n=class extends w.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(c,u,I,T){super(),this.environmentService=c,this.fileService=u,this.uriIdentityService=I,this.logService=T,this.enabled=!0,this._onDidChangeProfiles=this._register(new r.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new r.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new r.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new r.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],folders:new E.ResourceMap,workspaces:new E.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,C.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,C.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(c){this.enabled!==c&&(this._profilesObject=void 0,this.enabled=c)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const c=this.createDefaultProfile(),u=[c];if(this.enabled)try{for(const A of this.getStoredProfiles()){if(!A.name||!(0,S.isString)(A.name)||!A.location){this.logService.warn("Skipping the invalid stored profile",A.location||A.name);continue}u.push(l((0,C.basename)(A.location),A.name,A.location,this.profilesCacheHome,{shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags},c))}}catch(A){this.logService.error(A)}const I=new E.ResourceMap,T=new Map;if(u.length)try{const A=this.getStoredProfileAssociations();if(A.workspaces)for(const[O,k]of Object.entries(A.workspaces)){const P=R.URI.parse(O),B=u.find(Y=>Y.id===k);B&&I.set(P,B)}if(A.emptyWindows)for(const[O,k]of Object.entries(A.emptyWindows)){const P=u.find(B=>B.id===k);P&&T.set(O,P)}}catch(A){this.logService.error(A)}this._profilesObject={profiles:u,workspaces:I,emptyWindows:T}}return this._profilesObject}createDefaultProfile(){const c=l("__default__profile__",(0,_.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...c,extensionsResource:this.getDefaultProfileExtensionsLocation()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const u="Temp",I=new RegExp(`${(0,p.escapeRegExpCharacters)(u)}\\s(\\d+)`);let T=0;for(const O of this.profiles){const k=I.exec(O.name),P=k?parseInt(k[1]):0;T=P>T?P:T}const A=`${u} ${T+1}`;return this.createProfile((0,i.hash)((0,m.generateUuid)()).toString(16),A,{transient:!0},c)}async createNamedProfile(c,u,I){return this.createProfile((0,i.hash)((0,m.generateUuid)()).toString(16),c,u,I)}async createProfile(c,u,I,T){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const A=await this.doCreateProfile(c,u,I);return T&&await this.setProfileForWorkspace(T,A),A}async doCreateProfile(c,u,I){if(!(0,S.isString)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let T=this.profileCreationPromises.get(u);return T||(T=(async()=>{try{if(this.profiles.find(P=>P.name===u||P.id===c))throw new Error(`Profile with ${u} name already exists`);const O=l(c,u,(0,C.joinPath)(this.profilesHome,c),this.profilesCacheHome,I,this.defaultProfile);await this.fileService.createFolder(O.location);const k=[];return this._onWillCreateProfile.fire({profile:O,join(P){k.push(P)}}),await f.Promises.settled(k),this.updateProfiles([O],[],[]),O}finally{this.profileCreationPromises.delete(u)}})(),this.profileCreationPromises.set(u,T)),T}async updateProfile(c,u){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let I=this.profiles.find(T=>T.id===c.id);if(!I)throw new Error(`Profile '${c.name}' does not exist`);return I=l(I.id,u.name??I.name,I.location,this.profilesCacheHome,{shortName:u.shortName??I.shortName,icon:u.icon===null?void 0:u.icon??I.icon,transient:u.transient??I.isTransient,useDefaultFlags:u.useDefaultFlags??I.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[I]),I}async removeProfile(c){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(T=>T.id===c.id);if(!u)throw new Error(`Profile '${c.name}' does not exist`);const I=[];this._onWillRemoveProfile.fire({profile:u,join(T){I.push(T)}});try{await Promise.allSettled(I)}catch(T){this.logService.error(T)}for(const T of[...this.profilesObject.emptyWindows.keys()])u.id===this.profilesObject.emptyWindows.get(T)?.id&&this.profilesObject.emptyWindows.delete(T);for(const T of[...this.profilesObject.workspaces.keys()])u.id===this.profilesObject.workspaces.get(T)?.id&&this.profilesObject.workspaces.delete(T);this.updateStoredProfileAssociations(),this.updateProfiles([],[u],[]);try{await this.fileService.del(u.cacheHome,{recursive:!0})}catch(T){(0,o.toFileOperationResult)(T)!==o.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(T)}}async setProfileForWorkspace(c,u){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const I=this.profiles.find(T=>T.id===u.id);if(!I)throw new Error(`Profile '${u.name}' does not exist`);this.updateWorkspaceAssociation(c,I)}unsetWorkspace(c,u){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(c,void 0,u)}async resetWorkspaces(){this.transientProfilesObject.folders.clear(),this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const c=await this.fileService.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(u=>u.isDirectory&&this.profiles.every(I=>!this.uriIdentityService.extUri.isEqual(I.location,u.resource))).map(u=>this.fileService.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const c=this.transientProfilesObject.profiles.filter(u=>!this.isProfileAssociatedToWorkspace(u));await Promise.allSettled(c.map(u=>this.removeProfile(u)))}getProfileForWorkspace(c){const u=this.getWorkspace(c),I=R.URI.isUri(u)?this.profilesObject.workspaces.get(u):this.profilesObject.emptyWindows.get(u);return I||((0,d.isSingleFolderWorkspaceIdentifier)(c)?this.transientProfilesObject.folders.get(c.uri):(0,d.isWorkspaceIdentifier)(c)?this.transientProfilesObject.workspaces.get(c.configPath):this.transientProfilesObject.emptyWindows.get(c.id))}getWorkspace(c){return(0,d.isSingleFolderWorkspaceIdentifier)(c)?c.uri:(0,d.isWorkspaceIdentifier)(c)?c.configPath:c.id}isProfileAssociatedToWorkspace(c){return!!([...this.profilesObject.emptyWindows.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,c.location))||[...this.profilesObject.workspaces.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,c.location))||[...this.transientProfilesObject.emptyWindows.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,c.location))||[...this.transientProfilesObject.workspaces.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,c.location))||[...this.transientProfilesObject.folders.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,c.location)))}updateProfiles(c,u,I){const T=[...this.profiles,...c],A=[],O=this.transientProfilesObject.profiles;this.transientProfilesObject.profiles=[];for(let k of T){if(k.isDefault||u.some(B=>k.id===B.id))continue;k=I.find(B=>k.id===B.id)??k;const P=O.find(B=>k.id===B.id);if(k.isTransient)this.transientProfilesObject.profiles.push(k);else{if(P){for(const[B,Y]of this.transientProfilesObject.emptyWindows.entries())if(k.id===Y.id){this.updateWorkspaceAssociation({id:B},k);break}for(const[B,Y]of this.transientProfilesObject.workspaces.entries())if(k.id===Y.id){this.updateWorkspaceAssociation({id:"",configPath:B},k);break}for(const[B,Y]of this.transientProfilesObject.folders.entries())if(k.id===Y.id){this.updateWorkspaceAssociation({id:"",uri:B},k);break}}A.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags})}}this.saveStoredProfiles(A),this._profilesObject=void 0,this.triggerProfilesChanges(c,u,I)}triggerProfilesChanges(c,u,I){this._onDidChangeProfiles.fire({added:c,removed:u,updated:I,all:this.profiles})}updateWorkspaceAssociation(c,u,I){if(I=u?.isTransient?!0:I,I)(0,d.isSingleFolderWorkspaceIdentifier)(c)?(this.transientProfilesObject.folders.delete(c.uri),u&&this.transientProfilesObject.folders.set(c.uri,u)):(0,d.isWorkspaceIdentifier)(c)?(this.transientProfilesObject.workspaces.delete(c.configPath),u&&this.transientProfilesObject.workspaces.set(c.configPath,u)):(this.transientProfilesObject.emptyWindows.delete(c.id),u&&this.transientProfilesObject.emptyWindows.set(c.id,u));else{this.updateWorkspaceAssociation(c,void 0,!0);const T=this.getWorkspace(c);R.URI.isUri(T)?(this.profilesObject.workspaces.delete(T),u&&this.profilesObject.workspaces.set(T,u)):(this.profilesObject.emptyWindows.delete(T),u&&this.profilesObject.emptyWindows.set(T,u)),this.updateStoredProfileAssociations()}}updateStoredProfileAssociations(){const c={};for(const[I,T]of this.profilesObject.workspaces.entries())c[I.toString()]=T.id;const u={};for(const[I,T]of this.profilesObject.emptyWindows.entries())u[I.toString()]=T.id;this.saveStoredProfileAssociations({workspaces:c,emptyWindows:u}),this._profilesObject=void 0}migrateStoredProfileAssociations(c){const u={},I=this.createDefaultProfile();if(c.workspaces)for(const[A,O]of Object.entries(c.workspaces)){const k=R.URI.parse(O);u[A]=this.uriIdentityService.extUri.isEqual(k,I.location)?I.id:this.uriIdentityService.extUri.basename(k)}const T={};if(c.emptyWindows)for(const[A,O]of Object.entries(c.emptyWindows)){const k=R.URI.parse(O);T[A]=this.uriIdentityService.extUri.isEqual(k,I.location)?I.id:this.uriIdentityService.extUri.basename(k)}return{workspaces:u,emptyWindows:T}}getStoredProfiles(){return[]}saveStoredProfiles(c){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(c){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=n,e.UserDataProfilesService=n=ze([Me(0,b.IEnvironmentService),Me(1,o.IFileService),Me(2,a.IUriIdentityService),Me(3,y.ILogService)],n);class h extends n{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(c){this.storedProfiles=c}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(c){this.storedProfileAssociations=c}}e.InMemoryUserDataProfilesService=h}),define(ye[99],Ie([1,0,18,14,19,10,6,2,3,11,4,207,30,39,22,74,12,29,24,36,34]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a,f,m,p,S,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.AbstractExtensionManagementService=void 0,e.toExtensionManagementError=l,y=Be(y);let t=class extends _.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(c,u,I,T,A,O){super(),this.galleryService=c,this.telemetryService=u,this.uriIdentityService=I,this.logService=T,this.productService=A,this.userDataProfilesService=O,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new R.Emitter),this._onDidInstallExtensions=this._register(new R.Emitter),this._onUninstallExtension=this._register(new R.Emitter),this._onDidUninstallExtension=this._register(new R.Emitter),this._onDidUpdateExtensionMetadata=this._register(new R.Emitter),this.participants=[],this._register((0,_.toDisposable)(()=>{this.installingExtensions.forEach(({task:k})=>k.cancel()),this.uninstallingExtensions.forEach(k=>k.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(c){const u=await this.getTargetPlatform();return c.allTargetPlatforms.some(I=>(0,d.isTargetPlatformCompatible)(I,c.allTargetPlatforms,u))}async installFromGallery(c,u={}){try{const T=(await this.installGalleryExtensions([{extension:c,options:u}])).find(({identifier:A})=>(0,E.areSameExtensions)(A,c.identifier));if(T?.local)return T?.local;throw T?.error?T.error:new d.ExtensionManagementError(`Unknown error while installing extension ${c.identifier.id}`,d.ExtensionManagementErrorCode.Unknown)}catch(I){throw l(I)}}async installGalleryExtensions(c){if(!this.galleryService.isEnabled())throw new d.ExtensionManagementError(y.localize(0,null),d.ExtensionManagementErrorCode.NotAllowed);const u=[],I=[];return await Promise.allSettled(c.map(async({extension:T,options:A})=>{try{const O=await this.checkAndGetCompatibleVersion(T,!!A?.installGivenVersion,!!A?.installPreReleaseVersion,A.productVersion??{version:this.productService.version,date:this.productService.date});I.push({...O,options:A})}catch(O){u.push({identifier:T.identifier,operation:d.InstallOperation.Install,source:T,error:O,profileLocation:A.profileLocation??this.getCurrentExtensionsManifestLocation()})}})),I.length&&u.push(...await this.installExtensions(I)),u}async uninstall(c,u={}){return this.logService.trace("ExtensionManagementService#uninstall",c.identifier.id),this.uninstallExtension(c,u)}async toggleAppliationScope(c,u){if((0,a.isApplicationScopedExtension)(c.manifest)||c.isBuiltin)return c;if(c.isApplicationScoped){let I=await this.updateMetadata(c,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(u,this.userDataProfilesService.defaultProfile.extensionsResource)||(I=await this.copyExtension(c,this.userDataProfilesService.defaultProfile.extensionsResource,u));for(const T of this.userDataProfilesService.profiles){const A=(await this.getInstalled(a.ExtensionType.User,T.extensionsResource)).find(O=>(0,E.areSameExtensions)(O.identifier,c.identifier));A?this._onDidUpdateExtensionMetadata.fire({local:A,profileLocation:T.extensionsResource}):this._onDidUninstallExtension.fire({identifier:c.identifier,profileLocation:T.extensionsResource})}return I}else{const I=this.uriIdentityService.extUri.isEqual(u,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(c,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(c,u,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:I.identifier,operation:d.InstallOperation.Install,local:I,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),I}}getExtensionsControlManifest(){const c=new Date().getTime();return(!this.extensionsControlManifest||c-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=c),this.extensionsControlManifest}registerParticipant(c){this.participants.push(c)}async installExtensions(c){const u=new Map,I=new Map,T=[],A=(k,P)=>`${E.ExtensionKey.create(k).toString()}-${P.toString()}`,O=(k,P,B,Y)=>{const X=this.createInstallExtensionTask(k,P,B),re=`${(0,E.getGalleryExtensionId)(k.publisher,k.name)}-${B.profileLocation.toString()}`;I.set(re,{task:X,root:Y}),this._onInstallExtension.fire({identifier:X.identifier,source:P,profileLocation:B.profileLocation}),this.logService.info("Installing extension:",X.identifier.id,B),D.URI.isUri(P)||this.installingExtensions.set(A(P,B.profileLocation),{task:X,waitingTasks:[]})};try{for(const{manifest:k,extension:P,options:B}of c){const Y=B.isApplicationScoped||B.isBuiltin||(0,a.isApplicationScopedExtension)(k),X={...B,installOnlyNewlyAddedFromExtensionPack:B.installOnlyNewlyAddedFromExtensionPack??!D.URI.isUri(P),isApplicationScoped:Y,profileLocation:Y?this.userDataProfilesService.defaultProfile.extensionsResource:B.profileLocation??this.getCurrentExtensionsManifestLocation(),productVersion:B.productVersion??{version:this.productService.version,date:this.productService.date}},re=D.URI.isUri(P)?void 0:this.installingExtensions.get(A(P,X.profileLocation));re?(this.logService.info("Extension is already requested to install",re.task.identifier.id,X.profileLocation.toString()),T.push(re.task.waitUntilTaskIsFinished())):O(k,P,X,void 0)}return await Promise.all([...I.values()].map(async({task:k})=>{if(k.options.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",k.identifier.id);else try{const P=await this.getAllDepsAndPackExtensions(k.identifier,k.manifest,!!k.options.installOnlyNewlyAddedFromExtensionPack,!!k.options.installPreReleaseVersion,k.options.profileLocation,k.options.productVersion),B=await this.getInstalled(void 0,k.options.profileLocation,k.options.productVersion),Y={...k.options,context:{...k.options.context,[d.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:X,manifest:re}of(0,i.distinct)(P,({gallery:te})=>te.identifier.id)){if(I.has(`${X.identifier.id.toLowerCase()}-${Y.profileLocation.toString()}`))continue;const te=this.installingExtensions.get(A(X,Y.profileLocation));if(te){if(this.canWaitForTask(k,te.task)){const Z=te.task.identifier;this.logService.info("Waiting for already requested installing extension",Z.id,k.identifier.id,Y.profileLocation.toString()),te.waitingTasks.push(k),T.push(R.Event.toPromise(R.Event.filter(this.onDidInstallExtensions,fe=>fe.some(K=>(0,E.areSameExtensions)(K.identifier,Z)))).then(fe=>{if(this.logService.info("Finished waiting for already requested installing extension",Z.id,k.identifier.id,Y.profileLocation.toString()),!fe.find(ae=>(0,E.areSameExtensions)(ae.identifier,Z))?.local)throw new Error(`Extension ${Z.id} is not installed`)}))}}else B.some(({identifier:Z})=>(0,E.areSameExtensions)(Z,X.identifier))||O(re,X,Y,k)}}catch(P){if(D.URI.isUri(k.source))(0,i.isNonEmptyArray)(k.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",k.identifier.id,P.message),(0,i.isNonEmptyArray)(k.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",k.identifier.id,P.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",k.identifier.id),P}})),await this.joinAllSettled([...I.entries()].map(async([k,{task:P}])=>{const B=new Date().getTime();let Y;try{Y=await P.run(),await this.joinAllSettled(this.participants.map(X=>X.postInstall(Y,P.source,P.options,w.CancellationToken.None)),d.ExtensionManagementErrorCode.PostInstall)}catch(X){const re=l(X);throw D.URI.isUri(P.source)||n(this.telemetryService,P.operation===d.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,E.getGalleryExtensionTelemetryData)(P.source),error:re,source:P.options.context?.[d.EXTENSION_INSTALL_SOURCE_CONTEXT]}),u.set(k,{error:re,identifier:P.identifier,operation:P.operation,source:P.source,context:P.options.context,profileLocation:P.options.profileLocation,applicationScoped:P.options.isApplicationScoped}),this.logService.error("Error while installing the extension",P.identifier.id,(0,C.getErrorMessage)(re),P.options.profileLocation.toString()),re}if(!D.URI.isUri(P.source)){const X=P.operation===d.InstallOperation.Update,re=X?void 0:(new Date().getTime()-P.source.lastUpdated)/1e3;if(n(this.telemetryService,X?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,E.getGalleryExtensionTelemetryData)(P.source),verificationStatus:P.verificationStatus,duration:new Date().getTime()-B,durationSinceUpdate:re,source:P.options.context?.[d.EXTENSION_INSTALL_SOURCE_CONTEXT]}),b.isWeb&&P.operation!==d.InstallOperation.Update)try{await this.galleryService.reportStatistic(Y.manifest.publisher,Y.manifest.name,Y.manifest.version,d.StatisticType.Install)}catch{}}u.set(k,{local:Y,identifier:P.identifier,operation:P.operation,source:P.source,context:P.options.context,profileLocation:P.options.profileLocation,applicationScoped:Y.isApplicationScoped})})),T.length&&await this.joinAllSettled(T),[...u.values()]}catch(k){const P=(X,re,te)=>{const Z=[];X.manifest.extensionDependencies?.length&&Z.push(...X.manifest.extensionDependencies),X.manifest.extensionPack?.length&&Z.push(...X.manifest.extensionPack);for(const fe of Z){if(te.includes(fe.toLowerCase()))continue;te.push(fe.toLowerCase());const K=u.get(`${fe.toLowerCase()}-${re.toString()}`);K?.local&&(te=P(K.local,re,te))}return te},B=X=>({identifier:X.identifier,operation:d.InstallOperation.Install,source:X.source,context:X.options.context,profileLocation:X.options.profileLocation,error:k}),Y=[];for(const[X,{task:re,root:te}]of I){const Z=u.get(X);Z?Z.local&&te&&!u.get(`${te.identifier.id.toLowerCase()}-${re.options.profileLocation.toString()}`)?.local&&(Y.push(this.createUninstallExtensionTask(Z.local,{versionOnly:!0,profileLocation:re.options.profileLocation})),u.set(X,B(re))):(re.cancel(),u.set(X,B(re)))}for(const[X,{task:re}]of I){const te=u.get(X);if(!te?.local||re.options.donotIncludePackAndDependencies)continue;P(te.local,re.options.profileLocation,[te.local.identifier.id.toLowerCase()]).slice(1).some(fe=>I.has(`${fe.toLowerCase()}-${re.options.profileLocation.toString()}`)&&!u.get(`${fe.toLowerCase()}-${re.options.profileLocation.toString()}`)?.local)&&(Y.push(this.createUninstallExtensionTask(te.local,{versionOnly:!0,profileLocation:re.options.profileLocation})),u.set(X,B(re)))}throw Y.length&&await Promise.allSettled(Y.map(async X=>{try{await X.run(),this.logService.info("Rollback: Uninstalled extension",X.extension.identifier.id)}catch(re){this.logService.warn("Rollback: Error while uninstalling extension",X.extension.identifier.id,(0,C.getErrorMessage)(re))}})),k}finally{for(const{task:k}of I.values())k.source&&!D.URI.isUri(k.source)&&this.installingExtensions.delete(A(k.source,k.options.profileLocation));if(u.size){const k=[...u.values()];for(const P of k)P.local&&this.logService.info("Extension installed successfully:",P.identifier.id,P.profileLocation.toString());this._onDidInstallExtensions.fire(k)}}}canWaitForTask(c,u){for(const[,{task:I,waitingTasks:T}]of this.installingExtensions.entries())if(I===c&&(T.includes(u)||T.some(A=>this.canWaitForTask(A,u)))||I===u&&T[0]&&!this.canWaitForTask(c,T[0]))return!1;return!0}async joinAllSettled(c,u){const I=[],T=[],A=await Promise.allSettled(c);for(const k of A)k.status==="fulfilled"?I.push(k.value):T.push(l(k.reason,u));if(!T.length)return I;if(T.length===1)throw T[0];let O=new d.ExtensionManagementError("",d.ExtensionManagementErrorCode.Unknown);for(const k of T)O=new d.ExtensionManagementError(O.message?`${O.message}, ${k.message}`:k.message,k.code!==d.ExtensionManagementErrorCode.Unknown&&k.code!==d.ExtensionManagementErrorCode.Internal?k.code:O.code);throw O}async getAllDepsAndPackExtensions(c,u,I,T,A,O){if(!this.galleryService.isEnabled())return[];const k=await this.getInstalled(void 0,A,O),P=[],B=[],Y=async(X,re)=>{P.push(X);const te=re.extensionDependencies||[],Z=[...te];if(re.extensionPack){const fe=I?k.find(K=>(0,E.areSameExtensions)(K.identifier,X)):void 0;for(const K of re.extensionPack)fe&&fe.manifest.extensionPack&&fe.manifest.extensionPack.some(ae=>(0,E.areSameExtensions)({id:ae},{id:K}))||Z.every(ae=>!(0,E.areSameExtensions)({id:ae},{id:K}))&&Z.push(K)}if(Z.length){const fe=Z.filter(K=>P.every(ae=>!(0,E.areSameExtensions)(ae,{id:K})));if(fe.length){const K=await this.galleryService.getExtensions(fe.map(ae=>({id:ae,preRelease:T})),w.CancellationToken.None);for(const ae of K){if(P.find(ne=>(0,E.areSameExtensions)(ne,ae.identifier)))continue;const x=te.some(ne=>(0,E.areSameExtensions)({id:ne},ae.identifier));let z;try{z=await this.checkAndGetCompatibleVersion(ae,!1,T,O)}catch(ne){if(x)throw ne;this.logService.info("Skipping the packed extension as it cannot be installed",ae.identifier.id,(0,C.getErrorMessage)(ne));continue}B.push({gallery:z.extension,manifest:z.manifest}),await Y(z.extension.identifier,z.manifest)}}}};return await Y(c,u),B}async checkAndGetCompatibleVersion(c,u,I,T){let A;const O=await this.getExtensionsControlManifest();if(O.malicious.some(B=>(0,E.areSameExtensions)(c.identifier,B)))throw new d.ExtensionManagementError(y.localize(1,null,c.identifier.id),d.ExtensionManagementErrorCode.Malicious);const k=O.deprecated[c.identifier.id.toLowerCase()];if(k?.extension?.autoMigrate){if(this.logService.info(`The '${c.identifier.id}' extension is deprecated, fetching the compatible '${k.extension.id}' extension instead.`),A=(await this.galleryService.getExtensions([{id:k.extension.id,preRelease:k.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:T},w.CancellationToken.None))[0],!A)throw new d.ExtensionManagementError(y.localize(2,null,c.identifier.id,k.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(c)){const B=await this.getTargetPlatform();throw new d.ExtensionManagementError(y.localize(3,null,c.identifier.id,this.productService.nameLong,(0,d.TargetPlatformToString)(B)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(A=await this.getCompatibleVersion(c,u,I,T),!A){const B=[];throw(0,f.areApiProposalsCompatible)(c.properties.enabledApiProposals??[],B)?!I&&c.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([c.identifier],w.CancellationToken.None))[0]?new d.ExtensionManagementError(y.localize(5,null,c.displayName??c.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.ExtensionManagementError(y.localize(6,null,c.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.Incompatible):new d.ExtensionManagementError(y.localize(4,null,c.displayName??c.identifier.id,B[0]),d.ExtensionManagementErrorCode.IncompatibleApi)}}this.logService.info("Getting Manifest...",A.identifier.id);const P=await this.galleryService.getManifest(A,w.CancellationToken.None);if(P===null)throw new d.ExtensionManagementError(`Missing manifest for extension ${A.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(P.version!==A.version)throw new d.ExtensionManagementError(`Cannot install '${A.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:A,manifest:P}}async getCompatibleVersion(c,u,I,T){const A=await this.getTargetPlatform();let O=null;return!u&&c.hasPreReleaseVersion&&c.properties.isPreReleaseVersion!==I&&(O=(await this.galleryService.getExtensions([{...c.identifier,preRelease:I}],{targetPlatform:A,compatible:!0,productVersion:T},w.CancellationToken.None))[0]||null),!O&&await this.galleryService.isExtensionCompatible(c,I,A,T)&&(O=c),O||(u?O=(await this.galleryService.getExtensions([{...c.identifier,version:c.version}],{targetPlatform:A,compatible:!0,productVersion:T},w.CancellationToken.None))[0]||null:O=await this.galleryService.getCompatibleExtension(c,I,A,T)),O}async uninstallExtension(c,u){const I={...u,profileLocation:c.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:u.profileLocation??this.getCurrentExtensionsManifestLocation()},T=Y=>`${Y.id.toLowerCase()}${I.versionOnly?`-${c.manifest.version}`:""}${I.profileLocation?`@${I.profileLocation.toString()}`:""}`,A=this.uninstallingExtensions.get(T(c.identifier));if(A)return this.logService.info("Extensions is already requested to uninstall",c.identifier.id),A.waitUntilTaskIsFinished();const O=Y=>{const X=this.createUninstallExtensionTask(Y,I);return this.uninstallingExtensions.set(T(X.extension.identifier),X),I.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,I.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${Y.identifier.id}@${Y.manifest.version}`),this._onUninstallExtension.fire({identifier:Y.identifier,profileLocation:I.profileLocation,applicationScoped:Y.isApplicationScoped}),X},k=(Y,X)=>{X?I.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,I.profileLocation.toString(),X.message):this.logService.error("Failed to uninstall extension:",`${Y.identifier.id}@${Y.manifest.version}`,X.message):I.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${Y.identifier.id}@${Y.manifest.version}`,I.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${Y.identifier.id}@${Y.manifest.version}`),n(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,E.getLocalExtensionTelemetryData)(Y),error:X}),this._onDidUninstallExtension.fire({identifier:Y.identifier,error:X?.code,profileLocation:I.profileLocation,applicationScoped:Y.isApplicationScoped})},P=[],B=[];try{P.push(O(c));const Y=await this.getInstalled(a.ExtensionType.User,I.profileLocation);if(I.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${c.identifier.id}@${c.manifest.version}`);else{const X=this.getAllPackExtensionsToUninstall(c,Y);for(const re of X)this.uninstallingExtensions.has(T(re.identifier))?this.logService.info("Extensions is already requested to uninstall",re.identifier.id):P.push(O(re))}I.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${c.identifier.id}@${c.manifest.version}`):this.checkForDependents(P.map(X=>X.extension),Y,c),await this.joinAllSettled(P.map(async X=>{try{if(await X.run(),await this.joinAllSettled(this.participants.map(re=>re.postUninstall(X.extension,I,w.CancellationToken.None))),X.extension.identifier.uuid)try{await this.galleryService.reportStatistic(X.extension.manifest.publisher,X.extension.manifest.name,X.extension.manifest.version,d.StatisticType.Uninstall)}catch{}k(X.extension)}catch(re){const te=l(re);throw k(X.extension,te),te}finally{B.push(X)}}))}catch(Y){const X=l(Y);for(const re of P){try{re.cancel()}catch{}B.includes(re)||k(re.extension,X)}throw X}finally{for(const Y of P)this.uninstallingExtensions.delete(T(Y.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",Y.extension.identifier.id)}}checkForDependents(c,u,I){for(const T of c){const A=this.getDependents(T,u);if(A.length){const O=A.filter(k=>!c.some(P=>(0,E.areSameExtensions)(P.identifier,k.identifier)));if(O.length)throw new Error(this.getDependentsErrorMessage(T,O,I))}}}getDependentsErrorMessage(c,u,I){return I===c?u.length===1?y.localize(7,null,I.manifest.displayName||I.manifest.name,u[0].manifest.displayName||u[0].manifest.name):u.length===2?y.localize(8,null,I.manifest.displayName||I.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):y.localize(9,null,I.manifest.displayName||I.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):u.length===1?y.localize(10,null,I.manifest.displayName||I.manifest.name,c.manifest.displayName||c.manifest.name,u[0].manifest.displayName||u[0].manifest.name):u.length===2?y.localize(11,null,I.manifest.displayName||I.manifest.name,c.manifest.displayName||c.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):y.localize(12,null,I.manifest.displayName||I.manifest.name,c.manifest.displayName||c.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name)}getAllPackExtensionsToUninstall(c,u,I=[]){if(I.indexOf(c)!==-1)return[];I.push(c);const T=c.manifest.extensionPack?c.manifest.extensionPack:[];if(T.length){const A=u.filter(k=>!k.isBuiltin&&T.some(P=>(0,E.areSameExtensions)({id:P},k.identifier))),O=[];for(const k of A)O.push(...this.getAllPackExtensionsToUninstall(k,u,I));return[...A,...O]}return[]}getDependents(c,u){return u.filter(I=>I.manifest.extensionDependencies&&I.manifest.extensionDependencies.some(T=>(0,E.areSameExtensions)({id:T},c.identifier)))}async updateControlCache(){try{return this.logService.trace("ExtensionManagementService.updateControlCache"),await this.galleryService.getExtensionsControlManifest()}catch(c){return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,C.getErrorMessage)(c)),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=t,e.AbstractExtensionManagementService=t=ze([Me(0,d.IExtensionGalleryService),Me(1,S.ITelemetryService),Me(2,g.IUriIdentityService),Me(3,m.ILogService),Me(4,p.IProductService),Me(5,v.IUserDataProfilesService)],t);function l(s,c){if(s instanceof d.ExtensionManagementError)return s;let u;return s instanceof d.ExtensionGalleryError?u=new d.ExtensionManagementError(s.message,s.code===d.ExtensionGalleryErrorCode.DownloadFailedWriting?d.ExtensionManagementErrorCode.DownloadFailedWriting:d.ExtensionManagementErrorCode.Gallery):u=new d.ExtensionManagementError(s.message,(0,C.isCancellationError)(s)?d.ExtensionManagementErrorCode.Cancelled:c??d.ExtensionManagementErrorCode.Internal),u.stack=s.stack,u}function n(s,c,{extensionData:u,verificationStatus:I,duration:T,error:A,source:O,durationSinceUpdate:k}){let P,B;(0,o.isDefined)(I)&&(I===!0?I="Verified":(I===!1||(P=d.ExtensionManagementErrorCode.Signature,B=I),I="Unverified")),A&&(P=A.code,A.code===d.ExtensionManagementErrorCode.Signature&&(B=A.message)),s.publicLog(c,{...u,verificationStatus:I,success:!A,duration:T,errorcode:P,errorcodeDetail:B,durationSinceUpdate:k,source:O})}class h{constructor(){this.barrier=new r.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}run(){return this.cancellablePromise||(this.cancellablePromise=(0,r.createCancelablePromise)(c=>this.doRun(c))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,r.createCancelablePromise)(c=>new Promise((u,I)=>{const T=c.onCancellationRequested(()=>{T.dispose(),I(new C.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=h}),define(ye[54],Ie([1,0,14,15,2,6,26,4,30,39,16,5,12,34,36,11,10,24]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a,f,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var S;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(S||(e.ExtensionsProfileScanningErrorCode=S={}));class g extends Error{constructor(h,s){super(h),this.code=s}}e.ExtensionsProfileScanningError=g,e.IExtensionsProfileScannerService=(0,y.createDecorator)("IExtensionsProfileScannerService");let v=class extends w.Disposable{constructor(h,s,c,u,I,T){super(),this.extensionsLocation=h,this.fileService=s,this.userDataProfilesService=c,this.uriIdentityService=u,this.telemetryService=I,this.logService=T,this._onAddExtensions=this._register(new C.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new C.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new C.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new C.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(h,s){return this.withProfileExtensions(h,void 0,s)}async addExtensionsToProfile(h,s,c){const u=[],I=[];try{return await this.withProfileExtensions(s,T=>{const A=[];if(c)A.push(...T);else for(const O of T)h.some(([k])=>(0,o.areSameExtensions)(k.identifier,O.identifier)&&k.manifest.version!==O.version)?u.push(O):A.push(O);for(const[O,k]of h){const P=A.findIndex(Y=>(0,o.areSameExtensions)(Y.identifier,O.identifier)&&Y.version===O.manifest.version),B={identifier:O.identifier,version:O.manifest.version,location:O.location,metadata:k};P===-1?(I.push(B),A.push(B)):A.splice(P,1,B)}return I.length&&this._onAddExtensions.fire({extensions:I,profileLocation:s}),u.length&&this._onRemoveExtensions.fire({extensions:u,profileLocation:s}),A}),I.length&&this._onDidAddExtensions.fire({extensions:I,profileLocation:s}),u.length&&this._onDidRemoveExtensions.fire({extensions:u,profileLocation:s}),I}catch(T){throw I.length&&this._onDidAddExtensions.fire({extensions:I,error:T,profileLocation:s}),u.length&&this._onDidRemoveExtensions.fire({extensions:u,error:T,profileLocation:s}),T}}async updateMetadata(h,s){const c=[];return await this.withProfileExtensions(s,u=>{const I=[];for(const T of u){const A=h.find(([O])=>(0,o.areSameExtensions)(O.identifier,T.identifier)&&O.manifest.version===T.version);A&&(T.metadata={...T.metadata,...A[1]},c.push(T)),I.push(T)}return I}),c}async removeExtensionFromProfile(h,s){const c=[];try{await this.withProfileExtensions(s,u=>{const I=[];for(const T of u)(0,o.areSameExtensions)(T.identifier,h.identifier)?c.push(T):I.push(T);return c.length&&this._onRemoveExtensions.fire({extensions:c,profileLocation:s}),I}),c.length&&this._onDidRemoveExtensions.fire({extensions:c,profileLocation:s})}catch(u){throw c.length&&this._onDidRemoveExtensions.fire({extensions:c,error:u,profileLocation:s}),u}}async withProfileExtensions(h,s,c){return this.getResourceAccessQueue(h).queue(async()=>{let u=[],I;try{const T=await this.fileService.readFile(h);I=JSON.parse(T.value.toString().trim()||"[]")}catch(T){if((0,D.toFileOperationResult)(T)!==D.FileOperationResult.FILE_NOT_FOUND)throw T;if(this.uriIdentityService.extUri.isEqual(h,this.userDataProfilesService.defaultProfile.extensionsResource)&&(I=await this.migrateFromOldDefaultProfileExtensionsLocation()),!I&&c?.bailOutWhenFileNotFound)throw new g((0,m.getErrorMessage)(T),S.ERROR_PROFILE_NOT_FOUND)}if(I){Array.isArray(I)||this.reportAndThrowInvalidConentError(h);let T=!1;for(const A of I){t(A)||this.reportAndThrowInvalidConentError(h);let O;if((0,f.isString)(A.relativeLocation)&&A.relativeLocation)O=this.resolveExtensionLocation(A.relativeLocation);else if((0,f.isString)(A.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${A.location}`);continue}else{O=_.URI.revive(A.location);const k=this.toRelativePath(O);k&&(T=!0,A.relativeLocation=k)}(0,f.isUndefined)(A.metadata?.hasPreReleaseVersion)&&A.metadata?.preRelease&&(T=!0,A.metadata.hasPreReleaseVersion=!0),u.push({identifier:A.identifier,location:O,version:A.version,metadata:A.metadata})}T&&await this.fileService.writeFile(h,r.VSBuffer.fromString(JSON.stringify(I)))}if(s){u=s(u);const T=u.map(A=>({identifier:A.identifier,version:A.version,location:A.location.toJSON(),relativeLocation:this.toRelativePath(A.location),metadata:A.metadata}));await this.fileService.writeFile(h,r.VSBuffer.fromString(JSON.stringify(T)))}return u})}reportAndThrowInvalidConentError(h){const s=new g(`Invalid extensions content in ${h.toString()}`,S.ERROR_INVALID_CONTENT);throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}toRelativePath(h){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(h),this.extensionsLocation)?this.uriIdentityService.extUri.basename(h):void 0}resolveExtensionLocation(h){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,h)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const h=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),s=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let c;try{c=(await this.fileService.readFile(h)).value.toString()}catch(I){if((0,D.toFileOperationResult)(I)===D.FileOperationResult.FILE_NOT_FOUND)return;throw I}this.logService.info("Migrating extensions from old default profile location",h.toString());let u;try{const I=JSON.parse(c);Array.isArray(I)&&I.every(T=>t(T))?u=I:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",I)}catch(I){this.logService.error(I)}if(u)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,r.VSBuffer.fromString(JSON.stringify(u)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",h.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(I){if((0,D.toFileOperationResult)(I)===D.FileOperationResult.FILE_MODIFIED_SINCE)this.logService.info("Migration from old default profile location to new location is done by another window",h.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw I}try{await this.fileService.del(h)}catch(I){(0,D.toFileOperationResult)(I)!==D.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(I)}try{await this.fileService.del(s)}catch(I){(0,D.toFileOperationResult)(I)!==D.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(I)}return u})()),this._migrationPromise}getResourceAccessQueue(h){let s=this.resourcesAccessQueueMap.get(h);return s||(s=new i.Queue,this.resourcesAccessQueueMap.set(h,s)),s}};e.AbstractExtensionsProfileScannerService=v,e.AbstractExtensionsProfileScannerService=v=ze([Me(1,D.IFileService),Me(2,E.IUserDataProfilesService),Me(3,a.IUriIdentityService),Me(4,p.ITelemetryService),Me(5,d.ILogService)],v);function t(n){return(0,f.isObject)(n)&&(0,b.isIExtensionIdentifier)(n.identifier)&&(l(n.location)||(0,f.isString)(n.location)&&n.location)&&((0,f.isUndefined)(n.relativeLocation)||(0,f.isString)(n.relativeLocation))&&n.version&&(0,f.isString)(n.version)}function l(n){return n?(0,f.isString)(n.path)&&(0,f.isString)(n.scheme):!1}});var gt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ye[64],Ie([1,0,18,14,21,15,10,43,190,2,13,9,3,20,63,58,11,4,211,28,39,22,74,16,5,12,29,6,50,54,34,36,246]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a,f,m,p,S,g,v,t,l,n,h,s,c,u,I,T,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0,e.toExtensionDescription=te,w=Be(w),y=Be(y),d=Be(d),a=Be(a),f=gt(f);var P;(function(fe){function K(ae,x){if(ae===x)return!0;const z=Object.keys(ae),ne=new Set;for(const le of Object.keys(x))ne.add(le);if(z.length!==ne.size)return!1;for(const le of z){if(ae[le]!==x[le])return!1;ne.delete(le)}return ne.size===0}fe.equals=K})(P||(e.Translations=P={})),e.IExtensionsScannerService=(0,h.createDecorator)("IExtensionsScannerService");let B=class extends o.Disposable{constructor(K,ae,x,z,ne,le,ve,H,ce,J,W,L){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=ae,this.extensionsControlLocation=x,this.currentProfile=z,this.userDataProfilesService=ne,this.extensionsProfileScannerService=le,this.fileService=ve,this.logService=H,this.environmentService=ce,this.productService=J,this.uriIdentityService=W,this.instantiationService=L,this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,E.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(re,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(re,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(X,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(t.ExtensionType.System))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(t.ExtensionType.User)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,v.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(K,ae,x){const[z,ne]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(ae)]),le=x?await this.scanExtensionsUnderDevelopment(K,[...z,...ne]):[];return this.dedupExtensions(z,ne,le,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const ae=[];ae.push(this.scanDefaultSystemExtensions(!!K.useCache,K.language)),ae.push(this.scanDevSystemExtensions(K.language,!!K.checkControlFile));const[x,z]=await Promise.all(ae);return this.applyScanOptions([...x,...z],t.ExtensionType.System,K,!1)}async scanUserExtensions(K){const ae=K.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",ae);const x=this.uriIdentityService.extUri.isEqual(K.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.createExtensionScannerInput(ae,!!K.profileLocation,t.ExtensionType.User,!K.includeUninstalled,K.language,!0,x,K.productVersion??this.getProductVersion()),ne=K.useCache&&!z.devMode&&z.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let le;try{le=await ne.scanExtensions(z)}catch(ve){if(ve instanceof T.ExtensionsProfileScanningError&&ve.code===T.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions(),le=await ne.scanExtensions(z);else throw ve}return le=await this.applyScanOptions(le,t.ExtensionType.User,K,!0),this.logService.trace("Scanned user extensions:",le.length),le}async scanExtensionsUnderDevelopment(K,ae){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const x=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(z=>z.scheme===D.Schemas.file).map(async z=>{const ne=await this.createExtensionScannerInput(z,!1,t.ExtensionType.User,!0,K.language,!1,void 0,K.productVersion??this.getProductVersion());return(await this.extensionsScanner.scanOneOrMultipleExtensions(ne)).map(ve=>(ve.type=ae.find(H=>(0,v.areSameExtensions)(H.identifier,ve.identifier))?.type??ve.type,this.extensionsScanner.validate(ve,ne)))}))).flat();return this.applyScanOptions(x,"development",K,!0)}return[]}async scanExistingExtension(K,ae,x){const z=await this.createExtensionScannerInput(K,!1,ae,!0,x.language,!0,void 0,x.productVersion??this.getProductVersion()),ne=await this.extensionsScanner.scanExtension(z);return!ne||!x.includeInvalid&&!ne.isValid?null:ne}async scanOneOrMultipleExtensions(K,ae,x){const z=await this.createExtensionScannerInput(K,!1,ae,!0,x.language,!0,void 0,x.productVersion??this.getProductVersion()),ne=await this.extensionsScanner.scanOneOrMultipleExtensions(z);return this.applyScanOptions(ne,ae,x,!0)}async scanMultipleExtensions(K,ae,x){const z=[];return await Promise.all(K.map(async ne=>{const le=await this.scanOneOrMultipleExtensions(ne,ae,x);z.push(...le)})),this.applyScanOptions(z,ae,x,!0)}async scanMetadata(K){const ae=(0,E.joinPath)(K,"package.json"),x=(await this.fileService.readFile(ae)).value.toString();return JSON.parse(x).__metadata}async updateMetadata(K,ae){const x=(0,E.joinPath)(K,"package.json"),z=(await this.fileService.readFile(x)).value.toString(),ne=JSON.parse(z);ae.isMachineScoped===!1&&delete ae.isMachineScoped,ae.isBuiltin===!1&&delete ae.isBuiltin,ne.__metadata={...ne.__metadata,...ae},await this.fileService.writeFile((0,E.joinPath)(K,"package.json"),C.VSBuffer.fromString(JSON.stringify(ne,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof T.ExtensionsProfileScanningError&&K.code===T.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.doInitializeDefaultProfileExtensions();else throw K}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.extensionsProfileScannerService.addExtensionsToProfile(K.map(ae=>[ae,ae.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,C.VSBuffer.fromString(JSON.stringify([])))}catch(ae){(0,n.toFileOperationResult)(ae)!==n.FileOperationResult.FILE_NOT_FOUND&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,R.getErrorMessage)(ae))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.logService.error(K)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(K,ae,x,z){return x.includeAllVersions||(K=this.dedupExtensions(ae===t.ExtensionType.System?K:void 0,ae===t.ExtensionType.User?K:void 0,ae==="development"?K:void 0,await this.getTargetPlatform(),z)),x.includeInvalid||(K=K.filter(ne=>ne.isValid)),K.sort((ne,le)=>{const ve=y.basename(ne.location.fsPath),H=y.basename(le.location.fsPath);return ve<H?-1:ve>H?1:0})}dedupExtensions(K,ae,x,z,ne){const le=(H,ce,J)=>{if(H.isValid&&!ce.isValid)return!1;if(H.isValid===ce.isValid){if(ne&&a.gt(H.manifest.version,ce.manifest.version))return this.logService.debug(`Skipping extension ${ce.location.path} with lower version ${ce.manifest.version} in favour of ${H.location.path} with version ${H.manifest.version}`),!1;if(a.eq(H.manifest.version,ce.manifest.version)){if(H.type===t.ExtensionType.System)return this.logService.debug(`Skipping extension ${ce.location.path} in favour of system extension ${H.location.path} with same version`),!1;if(H.targetPlatform===z)return this.logService.debug(`Skipping extension ${ce.location.path} from different target platform ${ce.targetPlatform}`),!1}}return J?this.logService.warn(`Overwriting user extension ${H.location.path} with ${ce.location.path}.`):this.logService.debug(`Overwriting user extension ${H.location.path} with ${ce.location.path}.`),!0},ve=new t.ExtensionIdentifierMap;return K?.forEach(H=>{const ce=ve.get(H.identifier.id);(!ce||le(ce,H,!1))&&ve.set(H.identifier.id,H)}),ae?.forEach(H=>{const ce=ve.get(H.identifier.id);if(!ce&&K&&H.type===t.ExtensionType.System){this.logService.debug(`Skipping obsolete system extension ${H.location.path}.`);return}(!ce||le(ce,H,!1))&&ve.set(H.identifier.id,H)}),x?.forEach(H=>{const ce=ve.get(H.identifier.id);(!ce||le(ce,H,!0))&&ve.set(H.identifier.id,H),ve.set(H.identifier.id,H)}),[...ve.values()]}async scanDefaultSystemExtensions(K,ae){this.logService.trace("Started scanning system extensions");const x=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,t.ExtensionType.System,!0,ae,!0,void 0,this.getProductVersion()),ne=await(K&&!x.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(x);return this.logService.trace("Scanned system extensions:",ne.length),ne}async scanDevSystemExtensions(K,ae){const x=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!x?.length)return[];this.logService.trace("Started scanning dev system extensions");const z=ae?await this.getBuiltInExtensionControl():{},ne=[],le=p.URI.file(y.normalize(y.join(D.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const H of x){const ce=z[H.name]||"marketplace";switch(ce){case"disabled":break;case"marketplace":ne.push((0,E.joinPath)(le,H.name));break;default:ne.push(p.URI.file(ce));break}}const ve=await Promise.all(ne.map(async H=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(H,!1,t.ExtensionType.System,!0,K,!0,void 0,this.getProductVersion()))));return this.logService.trace("Scanned dev system extensions:",ve.length),(0,i.coalesce)(ve)}async getBuiltInExtensionControl(){try{const K=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(K.value.toString())}catch{return{}}}async createExtensionScannerInput(K,ae,x,z,ne,le,ve,H){const ce=await this.getTranslations(ne??d.language),J=await this.getMtime(K),W=ae&&!this.uriIdentityService.extUri.isEqual(K,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,L=W?await this.getMtime(W):void 0;return new Y(K,J,W,L,ae,ve,x,z,le,H.version,H.date,this.productService.commit,!this.environmentService.isBuilt,ne,ce)}async getMtime(K){try{const ae=await this.fileService.stat(K);if(typeof ae.mtime=="number")return ae.mtime}catch{}}getProductVersion(){return{version:this.productService.version,date:this.productService.date}}};e.AbstractExtensionsScannerService=B,e.AbstractExtensionsScannerService=B=ze([Me(4,A.IUserDataProfilesService),Me(5,T.IExtensionsProfileScannerService),Me(6,n.IFileService),Me(7,s.ILogService),Me(8,g.IEnvironmentService),Me(9,c.IProductService),Me(10,O.IUriIdentityService),Me(11,h.IInstantiationService)],B);class Y{constructor(K,ae,x,z,ne,le,ve,H,ce,J,W,L,Q,$,U){this.location=K,this.mtime=ae,this.applicationExtensionslocation=x,this.applicationExtensionslocationMtime=z,this.profile=ne,this.profileScanOptions=le,this.type=ve,this.excludeObsolete=H,this.validate=ce,this.productVersion=J,this.productDate=W,this.productCommit=L,this.devMode=Q,this.language=$,this.translations=U}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,ae){return(0,E.isEqual)(K.location,ae.location)&&K.mtime===ae.mtime&&(0,E.isEqual)(K.applicationExtensionslocation,ae.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===ae.applicationExtensionslocationMtime&&K.profile===ae.profile&&w.equals(K.profileScanOptions,ae.profileScanOptions)&&K.type===ae.type&&K.excludeObsolete===ae.excludeObsolete&&K.validate===ae.validate&&K.productVersion===ae.productVersion&&K.productDate===ae.productDate&&K.productCommit===ae.productCommit&&K.devMode===ae.devMode&&K.language===ae.language&&P.equals(K.translations,ae.translations)}}e.ExtensionScannerInput=Y;let X=class extends o.Disposable{constructor(K,ae,x,z,ne,le){super(),this.obsoleteFile=K,this.extensionsProfileScannerService=ae,this.uriIdentityService=x,this.fileService=z,this.logService=le,this.extensionsEnabledWithApiProposalVersion=ne.extensionsEnabledWithApiProposalVersion?.map(ve=>ve.toLowerCase())??[]}async scanExtensions(K){const ae=K.profile?await this.scanExtensionsFromProfile(K):await this.scanExtensionsFromLocation(K);let x={};if(K.excludeObsolete&&K.type===t.ExtensionType.User)try{const z=(await this.fileService.readFile(this.obsoleteFile)).value.toString();x=JSON.parse(z)}catch{}return(0,m.isEmptyObject)(x)?ae:ae.filter(z=>!x[v.ExtensionKey.create(z).toString()])}async scanExtensionsFromLocation(K){const ae=await this.fileService.resolve(K.location);if(!ae.children?.length)return[];const x=await Promise.all(ae.children.map(async z=>{if(!z.isDirectory||K.type===t.ExtensionType.User&&(0,E.basename)(z.resource).indexOf(".")===0)return null;const ne=new Y(z.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(ne)}));return(0,i.coalesce)(x).sort((z,ne)=>z.location.path<ne.location.path?-1:1)}async scanExtensionsFromProfile(K){let ae=await this.scanExtensionsFromProfileResource(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(K.location,K.applicationExtensionslocation)){ae=ae.filter(z=>!z.metadata?.isApplicationScoped);const x=await this.scanExtensionsFromProfileResource(K.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,K);ae.push(...x)}return ae}async scanExtensionsFromProfileResource(K,ae,x){const z=await this.extensionsProfileScannerService.scanProfileExtensions(K,x.profileScanOptions);if(!z.length)return[];const ne=await Promise.all(z.map(async le=>{if(ae(le)){const ve=new Y(le.location,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(ve,le.metadata)}return null}));return(0,i.coalesce)(ne)}async scanOneOrMultipleExtensions(K){try{if(await this.fileService.exists((0,E.joinPath)(K.location,"package.json"))){const ae=await this.scanExtension(K);return ae?[ae]:[]}else return await this.scanExtensions(K)}catch(ae){return this.logService.error(`Error scanning extensions at ${K.location.path}:`,(0,R.getErrorMessage)(ae)),[]}}async scanExtension(K,ae){try{let x=await this.scanExtensionManifest(K.location);if(x){x.publisher||(x.publisher=t.UNDEFINED_PUBLISHER),ae=ae??x.__metadata,delete x.__metadata;const z=(0,v.getGalleryExtensionId)(x.publisher,x.name),ne=ae?.id?{id:z,uuid:ae.id}:{id:z},le=ae?.isSystem?t.ExtensionType.System:K.type,ve=le===t.ExtensionType.System||!!ae?.isBuiltin;x=await this.translateManifest(K.location,x,Y.createNlsConfiguration(K));let H={type:le,identifier:ne,manifest:x,location:K.location,isBuiltin:ve,targetPlatform:ae?.targetPlatform??t.TargetPlatform.UNDEFINED,publisherDisplayName:ae?.publisherDisplayName,metadata:ae,isValid:!0,validations:[]};return K.validate&&(H=this.validate(H,K)),x.enabledApiProposals&&this.extensionsEnabledWithApiProposalVersion.includes(z.toLowerCase())&&(x.enabledApiProposals=(0,t.parseEnabledApiProposalNames)([...x.enabledApiProposals])),H}}catch(x){K.type!==t.ExtensionType.System&&this.logService.error(x)}return null}validate(K,ae){let x=!0;const z=this.extensionsEnabledWithApiProposalVersion.includes(K.identifier.id.toLowerCase()),ne=(0,l.validateExtensionManifest)(ae.productVersion,ae.productDate,ae.location,K.manifest,K.isBuiltin,z);for(const[le,ve]of ne)le===f.default.Error&&(x=!1,this.logService.error(this.formatMessage(ae.location,ve)));return K.isValid=x,K.validations=ne,K}async scanExtensionManifest(K){const ae=(0,E.joinPath)(K,"package.json");let x;try{x=(await this.fileService.readFile(ae)).value.toString()}catch(ne){return(0,n.toFileOperationResult)(ne)!==n.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(this.formatMessage(K,(0,S.localize)(0,null,ae.path,ne.message))),null}let z;try{z=JSON.parse(x)}catch{const le=[];(0,_.parse)(x,le);for(const ve of le)this.logService.error(this.formatMessage(K,(0,S.localize)(1,null,ae.path,ve.offset,ve.length,(0,b.getParseErrorMessage)(ve.error))));return null}return(0,_.getNodeType)(z)!=="object"?(this.logService.error(this.formatMessage(K,(0,S.localize)(2,null,ae.path))),null):z}async translateManifest(K,ae,x){const z=await this.getLocalizedMessages(K,ae,x);if(z)try{const ne=[],le=await this.resolveOriginalMessageBundle(z.default,ne);if(ne.length>0)return ne.forEach(H=>{this.logService.error(this.formatMessage(K,(0,S.localize)(3,null,z.default?.path,(0,b.getParseErrorMessage)(H.error))))}),ae;if((0,_.getNodeType)(z)!=="object")return this.logService.error(this.formatMessage(K,(0,S.localize)(4,null,z.default?.path))),ae;const ve=z.values||Object.create(null);return(0,k.localizeManifest)(this.logService,ae,ve,le)}catch{}return ae}async getLocalizedMessages(K,ae,x){const z=(0,E.joinPath)(K,"package.nls.json"),ne=(ce,J)=>{J.forEach(W=>{this.logService.error(this.formatMessage(K,(0,S.localize)(5,null,ce?.path,(0,b.getParseErrorMessage)(W.error))))})},le=ce=>{this.logService.error(this.formatMessage(K,(0,S.localize)(6,null,ce?.path)))},ve=`${ae.publisher}.${ae.name}`,H=x.translations[ve];if(H)try{const ce=p.URI.file(H),J=(await this.fileService.readFile(ce)).value.toString(),W=[],L=(0,_.parse)(J,W);return W.length>0?(ne(ce,W),{values:void 0,default:z}):(0,_.getNodeType)(L)!=="object"?(le(ce),{values:void 0,default:z}):{values:L.contents?L.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.fileService.exists(z))return;let J;try{J=await this.findMessageBundles(K,x)}catch{return}if(!J.localized)return{values:void 0,default:J.original};try{const W=(await this.fileService.readFile(J.localized)).value.toString(),L=[],Q=(0,_.parse)(W,L);return L.length>0?(ne(J.localized,L),{values:void 0,default:J.original}):(0,_.getNodeType)(Q)!=="object"?(le(J.localized),{values:void 0,default:J.original}):{values:Q,default:J.original}}catch{return{values:void 0,default:J.original}}}}async resolveOriginalMessageBundle(K,ae){if(K)try{const x=(await this.fileService.readFile(K)).value.toString();return(0,_.parse)(x,ae)}catch{}}findMessageBundles(K,ae){return new Promise((x,z)=>{const ne=le=>{const ve=(0,E.joinPath)(K,`package.nls.${le}.json`);this.fileService.exists(ve).then(H=>{H&&x({localized:ve,original:(0,E.joinPath)(K,"package.nls.json")});const ce=le.lastIndexOf("-");ce===-1?x({localized:(0,E.joinPath)(K,"package.nls.json"),original:null}):(le=le.substring(0,ce),ne(le))})};if(ae.devMode||ae.pseudo||!ae.language)return x({localized:(0,E.joinPath)(K,"package.nls.json"),original:null});ne(ae.language)})}formatMessage(K,ae){return`[${K.path}]: ${ae}`}};X=ze([Me(1,T.IExtensionsProfileScannerService),Me(2,O.IUriIdentityService),Me(3,n.IFileService),Me(4,c.IProductService),Me(5,s.ILogService)],X);let re=class extends X{constructor(K,ae,x,z,ne,le,ve,H){super(ae,z,ne,le,ve,H),this.currentProfile=K,this.userDataProfilesService=x,this.cacheValidatorThrottler=this._register(new r.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(K){const ae=this.getCacheFile(K),x=await this.readExtensionCache(ae);if(this.input=K,x&&x.input&&Y.equals(x.input,this.input))return this.logService.debug("Using cached extensions scan result",K.type===t.ExtensionType.System?"system":"user",K.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),x.result.map(ne=>(ne.location=p.URI.revive(ne.location),ne));const z=await super.scanExtensions(K);return await this.writeExtensionCache(ae,{input:K,result:z}),z}async readExtensionCache(K){try{const ae=await this.fileService.readFile(K),x=JSON.parse(ae.value.toString());return{result:x.result,input:(0,I.revive)(x.input)}}catch(ae){this.logService.debug("Error while reading the extension cache file:",K.path,(0,R.getErrorMessage)(ae))}return null}async writeExtensionCache(K,ae){try{await this.fileService.writeFile(K,C.VSBuffer.fromString(JSON.stringify(ae)))}catch(x){this.logService.debug("Error while writing the extension cache file:",K.path,(0,R.getErrorMessage)(x))}}async validateCache(){if(!this.input)return;const K=this.getCacheFile(this.input),ae=await this.readExtensionCache(K);if(!ae)return;const x=ae.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!w.equals(z,x))try{this.logService.info("Invalidating Cache",x,z),await this.fileService.del(K),this._onDidChangeCache.fire()}catch(ne){this.logService.error(ne)}}getCacheFile(K){const ae=this.getProfile(K);return this.uriIdentityService.extUri.joinPath(ae.cacheHome,K.type===t.ExtensionType.System?t.BUILTIN_MANIFEST_CACHE_FILE:t.USER_MANIFEST_CACHE_FILE)}getProfile(K){return K.type===t.ExtensionType.System?this.userDataProfilesService.defaultProfile:K.profile?this.uriIdentityService.extUri.isEqual(K.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(ae=>this.uriIdentityService.extUri.isEqual(K.location,ae.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};re=ze([Me(2,A.IUserDataProfilesService),Me(3,T.IExtensionsProfileScannerService),Me(4,O.IUriIdentityService),Me(5,n.IFileService),Me(6,c.IProductService),Me(7,s.ILogService)],re);function te(fe,K){const ae=(0,v.getExtensionId)(fe.manifest.publisher,fe.manifest.name);return{id:ae,identifier:new t.ExtensionIdentifier(ae),isBuiltin:fe.type===t.ExtensionType.System,isUserBuiltin:fe.type===t.ExtensionType.User&&fe.isBuiltin,isUnderDevelopment:K,extensionLocation:fe.location,uuid:fe.identifier.uuid,targetPlatform:fe.targetPlatform,publisherDisplayName:fe.publisherDisplayName,...fe.manifest}}class Z extends B{constructor(K,ae,x,z,ne,le,ve,H,ce,J,W,L){super(K,ae,(0,E.joinPath)(x,".vscode-oss-dev","extensions","control.json"),z,ne,le,ve,H,ce,J,W,L),this.translationsPromise=(async()=>{if(d.translationsConfigFile)try{const Q=await this.fileService.readFile(p.URI.file(d.translationsConfigFile));return JSON.parse(Q.value.toString())}catch{}return Object.create(null)})()}getTranslations(K){return this.translationsPromise}}e.NativeExtensionsScannerService=Z}),define(ye[289],Ie([1,0,60,14,45,6,2,13,9,25,12,34]),function(se,e,i,r,w,C,R,_,b,o,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends R.Disposable{constructor(a,f){super(),this.userDataProfilesService=a,this.logService=f,this.processesLimiter=new r.Limiter(5)}async postUninstall(a){const f=this.parseScript(a,"uninstall");f&&(this.logService.info(a.identifier.id,a.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(f.script,"uninstall",f.args,!0,a),this.logService.info("Finished running post uninstall script",a.identifier.id,a.manifest.version)}catch(m){this.logService.error("Failed to run post uninstall script",a.identifier.id,a.manifest.version),this.logService.error(m)}}));try{await o.Promises.rm(this.getExtensionStoragePath(a))}catch(m){this.logService.error("Error while removing extension storage path",a.identifier.id),this.logService.error(m)}}parseScript(a,f){const m=`vscode:${f}`;if(a.location.scheme===_.Schemas.file&&a.manifest&&a.manifest.scripts&&typeof a.manifest.scripts[m]=="string"){const p=a.manifest.scripts[m].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(a.identifier.id,a.manifest.version,`${m} should be a node script`),null):{script:(0,b.join)(a.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(a,f,m,p,S){return new Promise((g,v)=>{const t=this.start(a,f,m,S);let l;const n=h=>{l&&(clearTimeout(l),l=null),h?v(h):g(void 0)};t.on("error",h=>{n((0,w.toErrorMessage)(h)||"Unknown")}),t.on("exit",(h,s)=>{n(h?`post-${f} process exited with code ${h}`:void 0)}),p&&(l=setTimeout(()=>{l=null,t.kill(),v("timed out")},5e3))})}start(a,f,m,p){const S={silent:!0,execArgv:void 0},g=(0,i.fork)(a,[`--type=extension-post-${f}`,...m],S);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const v=C.Event.fromNodeEventEmitter(g.stdout,"data"),t=C.Event.fromNodeEventEmitter(g.stderr,"data");this._register(v(h=>this.logService.info(p.identifier.id,p.manifest.version,`post-${f}`,h))),this._register(t(h=>this.logService.error(p.identifier.id,p.manifest.version,`post-${f}`,h)));const l=C.Event.any(C.Event.map(v,h=>({data:`%c${h}`,format:[""]}),this._store),C.Event.map(t,h=>({data:`%c${h}`,format:["color: red"]}),this._store));return C.Event.debounce(l,(h,s)=>h?{data:h.data+s.data,format:[...h.format,...s.format]}:{data:s.data,format:s.format},100,void 0,void 0,void 0,this._store)(h=>{console.group(p.identifier.id),console.log(h.data,...h.format),console.groupEnd()}),g}getExtensionStoragePath(a){return(0,b.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,a.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=d,e.ExtensionsLifecycle=d=ze([Me(0,y.IUserDataProfilesService),Me(1,D.ILogService)],d)}),define(ye[138],Ie([1,0,87,213,99,30]),function(se,e,i,r,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromExtractError=R,e.getManifest=_;function R(b){let o=C.ExtensionManagementErrorCode.Extract;return b instanceof i.ExtractError&&(b.type==="CorruptZip"?o=C.ExtensionManagementErrorCode.CorruptZip:b.type==="Incomplete"&&(o=C.ExtensionManagementErrorCode.IncompleteZip)),(0,w.toExtensionManagementError)(b,o)}async function _(b){let o;try{o=await(0,i.buffer)(b,"extension/package.json")}catch(D){throw R(D)}try{return JSON.parse(o.toString("utf8"))}catch{throw new C.ExtensionManagementError((0,r.localize)(0,null),C.ExtensionManagementErrorCode.Invalid)}}}),define(ye[290],Ie([1,0,14,10,2,13,20,63,23,25,87,27,28,99,30,39,138,95,16,12,24]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a,f,m,p,S,g,v){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0,_=Be(_);let l=class extends w.Disposable{static{t=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(h,s,c,u,I,T,A){super(),this.fileService=s,this.extensionGalleryService=c,this.configurationService=u,this.extensionSignatureVerificationService=I,this.telemetryService=T,this.logService=A,this.extensionsDownloadDir=h.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(h,s,c,u){await this.cleanUpPromise;const I=await this.downloadVSIX(h,s);let T=!1;if(c&&this.shouldVerifySignature(h)){let A;try{A=await this.downloadSignatureArchive(h)}catch(O){try{await this.delete(I)}catch(k){this.logService.error(k)}throw O}try{T=await this.extensionSignatureVerificationService.verify(h,I.fsPath,A.fsPath,u)}catch(O){if(T=O.code,T===p.ExtensionSignatureVerificationCode.PackageIsInvalidZip||T===p.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(I)}catch(k){this.logService.error(k)}throw new a.ExtensionManagementError(D.CorruptZipMessage,a.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(A)}catch(O){this.logService.error(O)}}}return{location:I,verificationStatus:T}}shouldVerifySignature(h){return h.isSigned||this.logService.info(`Extension is not signed: ${h.identifier.id}`),!1}async downloadVSIX(h,s){try{const c=(0,R.joinPath)(this.extensionsDownloadDir,this.getName(h)),u=await this.doDownload(h,"vsix",async()=>{await this.downloadFile(h,c,I=>this.extensionGalleryService.download(h,I,s));try{await this.validate(c.fsPath,"extension/package.json")}catch(I){try{await this.fileService.del(c)}catch(T){this.logService.warn(`Error while deleting: ${c.path}`,(0,r.getErrorMessage)(T))}throw I}},2);return u>1&&this.telemetryService.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:h.identifier.id,attempts:u}),c}catch(c){throw(0,E.toExtensionManagementError)(c,a.ExtensionManagementErrorCode.Download)}}async downloadSignatureArchive(h){try{const s=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`),c=await this.doDownload(h,"sigzip",async()=>{await this.extensionGalleryService.downloadSignatureArchive(h,s);try{await this.validate(s.fsPath,".signature.p7s")}catch(u){try{await this.fileService.del(s)}catch(I){this.logService.warn(`Error while deleting: ${s.path}`,(0,r.getErrorMessage)(I))}throw u}},2);return c>1&&this.telemetryService.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:h.identifier.id,attempts:c}),s}catch(s){throw(0,E.toExtensionManagementError)(s,a.ExtensionManagementErrorCode.DownloadSignature)}}async downloadFile(h,s,c){if(await this.fileService.exists(s))return;if(s.scheme!==C.Schemas.file){await c(s);return}const u=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);try{await c(u)}catch(I){try{await this.fileService.del(u)}catch{}throw I}try{await o.Promises.rename(u.fsPath,s.fsPath,2*60*1e3)}catch(I){try{await this.fileService.del(u)}catch{}let T=!1;try{T=await this.fileService.exists(s)}catch{}if(T)this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",h.identifier.id,s.path);else throw this.logService.info(`Rename failed because of ${(0,r.getErrorMessage)(I)}. Deleted the file from downloaded location`,u.path),I}}async doDownload(h,s,c,u){let I=1;for(;;)try{return await c(),I}catch(T){if(I++>u)throw T;this.logService.warn(`Failed downloading ${s}. ${(0,r.getErrorMessage)(T)}. Retry again...`,h.identifier.id)}}async validate(h,s){try{await(0,D.buffer)(h,s)}catch(c){throw(0,m.fromExtractError)(c)}}async delete(h){await this.cleanUpPromise,await this.fileService.del(h)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const h=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(h.children){const s=[],c=[],u=[];for(const A of h.children)if(A.name.endsWith(t.SignatureArchiveExtension))u.push(A.resource);else{const O=f.ExtensionKey.parse(A.name);O&&c.push([O,A])}const I=(0,f.groupByExtension)(c,([A])=>A),T=[];for(const A of I)A.sort((O,k)=>_.rcompare(O[0].version,k[0].version)),s.push(...A.slice(1).map(O=>O[1].resource)),T.push(A[0][1]);T.sort((A,O)=>A.mtime-O.mtime),s.push(...T.slice(0,Math.max(0,T.length-this.cache)).map(A=>A.resource)),s.push(...u),await i.Promises.settled(s.map(A=>(this.logService.trace("Deleting from cache",A.path),this.fileService.del(A))))}}catch(h){this.logService.error(h)}}getName(h){return this.cache?f.ExtensionKey.create(h).toString().toLowerCase():(0,b.generateUuid)()}};e.ExtensionsDownloader=l,e.ExtensionsDownloader=l=t=ze([Me(0,d.INativeEnvironmentService),Me(1,S.IFileService),Me(2,a.IExtensionGalleryService),Me(3,y.IConfigurationService),Me(4,p.IExtensionSignatureVerificationService),Me(5,v.ITelemetryService),Me(6,g.ILogService)],l)}),define(ye[139],Ie([1,0,14,15,19,45,10,6,66,2,26,13,9,20,63,11,4,23,25,87,212,88,28,99,30,39,54,64,290,289,138,267,276,22,74,16,5,12,29,24,36,34]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a,f,m,p,S,g,v,t,l,n,h,s,c,u,I,T,A,O,k,P,B,Y,X,re,te,Z,fe,K){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,d=Be(d),a=Be(a),S=Be(S),v=Be(v),e.INativeServerExtensionManagementService=(0,X.refineServiceDecorator)(h.IExtensionManagementService);const ae=".vsctmp";let x=class extends n.AbstractExtensionManagementService{constructor(H,ce,J,W,L,Q,$,U,q,G,F,V){super(H,ce,F,J,G,V),this.extensionsScannerService=L,this.extensionsProfileScannerService=Q,this.downloadService=$,this.instantiationService=U,this.fileService=q,this.extractingGalleryExtensions=new Map,this.knownDirectories=new D.ResourceSet;const oe=this._register(U.createInstance(T.ExtensionsLifecycle));this.extensionsScanner=this._register(U.createInstance(z,Ce=>oe.postUninstall(Ce))),this.manifestCache=this._register(new O.ExtensionsManifestCache(V,q,F,this,this.logService)),this.extensionsDownloader=this._register(U.createInstance(I.ExtensionsDownloader));const de=this._register(new k.ExtensionsWatcher(this,this.extensionsScannerService,V,Q,F,q,J));this._register(de.onDidChangeExtensionsByAnotherSource(Ce=>this.onDidChangeExtensionsFromAnotherSource(Ce))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(H){this.logService.trace("ExtensionManagementService#zip",H.identifier.id);const ce=await this.collectFiles(H),J=await(0,g.zip)((0,E.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,p.generateUuid)()).fsPath,ce);return m.URI.file(J)}async unzip(H){return this.logService.trace("ExtensionManagementService#unzip",H.toString()),(await this.install(H)).identifier}async getManifest(H){const{location:ce,cleanup:J}=await this.downloadVsix(H),W=d.resolve(ce.fsPath);try{return await(0,A.getManifest)(W)}finally{await J()}}getInstalled(H,ce=this.userDataProfilesService.defaultProfile.extensionsResource,J={version:this.productService.version,date:this.productService.date}){return this.extensionsScanner.scanExtensions(H??null,ce,J)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(H){return this.extensionsScanner.scanUserExtensionAtLocation(H)}async install(H,ce={}){this.logService.trace("ExtensionManagementService#install",H.toString());const{location:J,cleanup:W}=await this.downloadVsix(H);try{const L=await(0,A.getManifest)(d.resolve(J.fsPath)),Q=(0,s.getGalleryExtensionId)(L.publisher,L.name);if(L.engines&&L.engines.vscode&&!(0,B.isEngineValid)(L.engines.vscode,this.productService.version,this.productService.date))throw new Error(v.localize(0,null,Q,this.productService.version));const U=(await this.installExtensions([{manifest:L,extension:J,options:ce}])).find(({identifier:q})=>(0,s.areSameExtensions)(q,{id:Q}));if(U?.local)return U.local;throw U?.error?U.error:(0,n.toExtensionManagementError)(new Error(`Unknown error while installing extension ${Q}`))}finally{await W()}}async installFromLocation(H,ce){this.logService.trace("ExtensionManagementService#installFromLocation",H.toString());const J=await this.extensionsScanner.scanUserExtensionAtLocation(H);if(!J||!J.manifest.name||!J.manifest.version)throw new Error(`Cannot find a valid extension from the location ${H.toString()}`);return await this.addExtensionsToProfile([[J,{source:"resource"}]],ce),this.logService.info("Successfully installed extension",J.identifier.id,ce.toString()),J}async installExtensionsFromProfile(H,ce,J){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",H,ce.toString(),J.toString());const W=(await this.getInstalled(P.ExtensionType.User,ce)).filter(L=>H.some(Q=>(0,s.areSameExtensions)(Q,L.identifier)));if(W.length){const L=await Promise.all(W.map(Q=>this.extensionsScanner.scanMetadata(Q,ce)));await this.addExtensionsToProfile(W.map((Q,$)=>[Q,L[$]]),J),this.logService.info("Successfully installed extensions",W.map(Q=>Q.identifier.id),J.toString())}return W}async updateMetadata(H,ce,J){return this.logService.trace("ExtensionManagementService#updateMetadata",H.identifier.id),ce.isPreReleaseVersion&&(ce.preRelease=!0,ce.hasPreReleaseVersion=!0),ce.isMachineScoped===!1&&(ce.isMachineScoped=void 0),ce.isBuiltin===!1&&(ce.isBuiltin=void 0),ce.pinned===!1&&(ce.pinned=void 0),H=await this.extensionsScanner.updateMetadata(H,ce,J),this.manifestCache.invalidate(J),this._onDidUpdateExtensionMetadata.fire({local:H,profileLocation:J}),H}async reinstallFromGallery(H){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",H.identifier.id),!this.galleryService.isEnabled())throw new Error(v.localize(1,null));const ce=await this.getTargetPlatform(),[J]=await this.galleryService.getExtensions([{...H.identifier,preRelease:H.preRelease}],{targetPlatform:ce,compatible:!0},w.CancellationToken.None);if(!J)throw new Error(v.localize(2,null));await this.extensionsScanner.setUninstalled(H);try{await this.extensionsScanner.removeUninstalledExtension(H)}catch(W){throw new Error(v.localize(3,null,(0,C.toErrorMessage)(W)))}return this.installFromGallery(J)}copyExtension(H,ce,J,W){return this.extensionsScanner.copyExtension(H,ce,J,W)}copyExtensions(H,ce){return this.extensionsScanner.copyExtensions(H,ce,{version:this.productService.version,date:this.productService.date})}markAsUninstalled(...H){return this.extensionsScanner.setUninstalled(...H)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(H){this.logService.error(H)}}async download(H,ce,J){const{location:W}=await this.extensionsDownloader.download(H,ce,!J);return W}async downloadVsix(H){if(H.scheme===y.Schemas.file)return{location:H,async cleanup(){}};this.logService.trace("Downloading extension from",H.toString());const ce=(0,E.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,p.generateUuid)());return await this.downloadService.download(H,ce),this.logService.info("Downloaded extension to",ce.toString()),{location:ce,cleanup:async()=>{try{await this.fileService.del(ce)}catch(W){this.logService.error(W)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(H,ce,J){const W=ce instanceof m.URI?new s.ExtensionKey({id:(0,s.getGalleryExtensionId)(H.publisher,H.name)},H.version):s.ExtensionKey.create(ce);return this.instantiationService.createInstance(ne,W,H,ce,J,(L,Q)=>{if(ce instanceof m.URI)return this.extractVSIX(W,ce,J,Q);let $=this.extractingGalleryExtensions.get(W.toString());return $||(this.extractingGalleryExtensions.set(W.toString(),$=this.downloadAndExtractGalleryExtension(W,ce,L,J,Q)),$.finally(()=>this.extractingGalleryExtensions.delete(W.toString()))),$},this.extensionsScanner)}createUninstallExtensionTask(H,ce){return new le(H,ce.profileLocation,this.extensionsProfileScannerService)}async downloadAndExtractGalleryExtension(H,ce,J,W,L){const{verificationStatus:Q,location:$}=await this.extensionsDownloader.download(ce,J,!W.donotVerifySignature,W.context?.[h.EXTENSION_INSTALL_CLIENT_TARGET_PLATFORM_CONTEXT]);try{if(L.isCancellationRequested)throw new R.CancellationError;return await(0,A.getManifest)($.fsPath),{local:await this.extensionsScanner.extractUserExtension(H,$.fsPath,{id:ce.identifier.uuid,publisherId:ce.publisherId,publisherDisplayName:ce.publisherDisplayName,targetPlatform:ce.properties.targetPlatform,isApplicationScoped:W.isApplicationScoped,isMachineScoped:W.isMachineScoped,isBuiltin:W.isBuiltin,isPreReleaseVersion:ce.properties.isPreReleaseVersion,hasPreReleaseVersion:ce.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:W.installGivenVersion?!0:!!W.pinned,preRelease:(0,f.isBoolean)(W.preRelease)?W.preRelease:W.installPreReleaseVersion||ce.properties.isPreReleaseVersion,source:"gallery"},!1,L),verificationStatus:Q}}catch(U){try{await this.extensionsDownloader.delete($)}catch(q){this.logService.warn("Error while deleting the downloaded file",$.toString(),(0,R.getErrorMessage)(q))}throw(0,n.toExtensionManagementError)(U)}}async extractVSIX(H,ce,J,W){return{local:await this.extensionsScanner.extractUserExtension(H,d.resolve(ce.fsPath),{isApplicationScoped:J.isApplicationScoped,isMachineScoped:J.isMachineScoped,isBuiltin:J.isBuiltin,installedTimestamp:Date.now(),pinned:J.installGivenVersion?!0:!!J.pinned,source:"vsix"},!0,W)}}async collectFiles(H){const ce=async W=>{let L=await S.Promises.readdir(W);L=L.map(U=>d.join(W,U));const Q=await Promise.all(L.map(U=>S.Promises.stat(U)));let $=Promise.resolve([]);return Q.forEach((U,q)=>{const G=L[q];U.isFile()&&($=$.then(F=>[...F,G])),U.isDirectory()&&($=$.then(F=>ce(G).then(V=>[...F,...V])))}),$};return(await ce(H.location.fsPath)).map(W=>({path:`extension/${d.relative(H.location.fsPath,W)}`,localPath:W}))}async onDidChangeExtensionsFromAnotherSource({added:H,removed:ce}){if(ce){const J=H&&this.uriIdentityService.extUri.isEqual(ce.profileLocation,H.profileLocation)?ce.extensions.filter(W=>H.extensions.every(L=>!(0,s.areSameExtensions)(L,W))):ce.extensions;for(const W of J)this.logService.info("Extensions removed from another source",W.id,ce.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:W,profileLocation:ce.profileLocation})}if(H){const W=(await this.getInstalled(P.ExtensionType.User,H.profileLocation)).filter(L=>H.extensions.some(Q=>(0,s.areSameExtensions)(Q,L.identifier)));this._onDidInstallExtensions.fire(W.map(L=>(this.logService.info("Extensions added from another source",L.identifier.id,H.profileLocation.toString()),{identifier:L.identifier,local:L,profileLocation:H.profileLocation,operation:h.InstallOperation.None})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(ce=>this.knownDirectories.add(ce)));const H=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const ce of H.children??[])ce.isDirectory&&this.knownDirectories.add(ce.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(ce=>this.onDidFilesChange(ce)))}async onDidFilesChange(H){if(!H.affects(this.extensionsScannerService.userExtensionsLocation,Y.FileChangeType.ADDED))return;const ce=[];for(const J of H.rawAdded){if(this.knownDirectories.has(J)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(J),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(J,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(J).startsWith(".")||!(await this.fileService.stat(J)).isDirectory)continue;const W=await this.extensionsScanner.scanUserExtensionAtLocation(J);W&&W.installedTimestamp===void 0&&(this.knownDirectories.add(J),ce.push(W))}ce.length&&(await this.addExtensionsToProfile(ce.map(J=>[J,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",ce.map(J=>J.identifier.id)))}async addExtensionsToProfile(H,ce){const J=H.map(W=>W[0]);await this.setInstalled(J),await this.extensionsProfileScannerService.addExtensionsToProfile(H,ce),this._onDidInstallExtensions.fire(J.map(W=>({local:W,identifier:W.identifier,operation:h.InstallOperation.None,profileLocation:ce})))}async setInstalled(H){const ce=await this.extensionsScanner.getUninstalledExtensions();for(const J of H){const W=s.ExtensionKey.create(J);ce[W.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",W.id),await this.extensionsScanner.setInstalled(W),this.logService.info("Removed the extension from uninstalled list:",W.id))}}};e.ExtensionManagementService=x,e.ExtensionManagementService=x=ze([Me(0,h.IExtensionGalleryService),Me(1,Z.ITelemetryService),Me(2,re.ILogService),Me(3,l.INativeEnvironmentService),Me(4,u.IExtensionsScannerService),Me(5,c.IExtensionsProfileScannerService),Me(6,t.IDownloadService),Me(7,X.IInstantiationService),Me(8,Y.IFileService),Me(9,te.IProductService),Me(10,fe.IUriIdentityService),Me(11,K.IUserDataProfilesService)],x);let z=class extends o.Disposable{constructor(H,ce,J,W,L,Q,$){super(),this.beforeRemovingExtension=H,this.fileService=ce,this.extensionsScannerService=J,this.extensionsProfileScannerService=W,this.uriIdentityService=L,this.telemetryService=Q,this.logService=$,this._onExtract=this._register(new _.Emitter),this.onExtract=this._onExtract.event,this.scanAllExtensionPromise=new D.ResourceMap,this.scanUserExtensionsPromise=new D.ResourceMap,this.uninstalledResource=(0,E.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new i.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(H,ce,J){try{const W={includeInvalid:!0,profileLocation:ce,productVersion:J};let L=[];if(H===null||H===P.ExtensionType.System){let Q=this.scanAllExtensionPromise.get(ce);Q||(Q=this.extensionsScannerService.scanAllExtensions({includeInvalid:!0,useCache:!0},W,!1).finally(()=>this.scanAllExtensionPromise.delete(ce)),this.scanAllExtensionPromise.set(ce,Q)),L.push(...await Q)}else if(H===P.ExtensionType.User){let Q=this.scanUserExtensionsPromise.get(ce);Q||(Q=this.extensionsScannerService.scanUserExtensions(W).finally(()=>this.scanUserExtensionsPromise.delete(ce)),this.scanUserExtensionsPromise.set(ce,Q)),L.push(...await Q)}return L=H!==null?L.filter(Q=>Q.type===H):L,await Promise.all(L.map(Q=>this.toLocalExtension(Q)))}catch(W){throw(0,n.toExtensionManagementError)(W,h.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(H){try{const ce=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!H,includeInvalid:!0});return await Promise.all(ce.map(J=>this.toLocalExtension(J)))}catch(ce){throw(0,n.toExtensionManagementError)(ce,h.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(H){try{const ce=await this.extensionsScannerService.scanExistingExtension(H,P.ExtensionType.User,{includeInvalid:!0});if(ce)return await this.toLocalExtension(ce)}catch(ce){this.logService.error(ce)}return null}async extractUserExtension(H,ce,J,W,L){const Q=H.toString(),$=m.URI.file(d.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,p.generateUuid)()}`)),U=m.URI.file(d.join(this.extensionsScannerService.userExtensionsLocation.fsPath,Q));let q=await this.fileService.exists(U);if(q&&W){try{await this.deleteExtensionFromLocation(H.id,U,"removeExisting")}catch{throw new h.ExtensionManagementError(v.localize(4,null,U.fsPath,H.id),h.ExtensionManagementErrorCode.Delete)}q=!1}if(q)try{await this.extensionsScannerService.updateMetadata(U,J)}catch(G){throw this.telemetryService.publicLog2("extension:extract",{extensionId:H.id,code:`${(0,Y.toFileOperationResult)(G)}`}),(0,n.toExtensionManagementError)(G,h.ExtensionManagementErrorCode.UpdateExistingMetadata)}else try{if(L.isCancellationRequested)throw new R.CancellationError;try{this.logService.trace(`Started extracting the extension from ${ce} to ${U.fsPath}`),await(0,g.extract)(ce,$.fsPath,{sourcePath:"extension",overwrite:!0},L),this.logService.info(`Extracted extension to ${U}:`,H.id)}catch(G){throw(0,A.fromExtractError)(G)}try{await this.extensionsScannerService.updateMetadata($,J)}catch(G){throw this.telemetryService.publicLog2("extension:extract",{extensionId:H.id,code:`${(0,Y.toFileOperationResult)(G)}`}),(0,n.toExtensionManagementError)(G,h.ExtensionManagementErrorCode.UpdateMetadata)}if(L.isCancellationRequested)throw new R.CancellationError;try{this.logService.trace(`Started renaming the extension from ${$.fsPath} to ${U.fsPath}`),await this.rename($.fsPath,U.fsPath),this.logService.info("Renamed to",U.fsPath)}catch(G){if(G.code==="ENOTEMPTY"){this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",H.id);try{await this.fileService.del($,{recursive:!0})}catch{}}else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(G)}. Deleted from extracted location`,$),G}this._onExtract.fire(U)}catch(G){try{await this.fileService.del($,{recursive:!0})}catch{}throw G}return this.scanLocalExtension(U,P.ExtensionType.User)}async scanMetadata(H,ce){return ce?(await this.getScannedExtension(H,ce))?.metadata:this.extensionsScannerService.scanMetadata(H.location)}async getScannedExtension(H,ce){return(await this.extensionsProfileScannerService.scanProfileExtensions(ce)).find(W=>(0,s.areSameExtensions)(W.identifier,H.identifier))}async updateMetadata(H,ce,J){try{J?await this.extensionsProfileScannerService.updateMetadata([[H,ce]],J):await this.extensionsScannerService.updateMetadata(H.location,ce)}catch(W){throw this.telemetryService.publicLog2("extension:extract",{extensionId:H.identifier.id,code:`${(0,Y.toFileOperationResult)(W)}`}),(0,n.toExtensionManagementError)(W,h.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(H.location,H.type,J)}async getUninstalledExtensions(){try{return await this.withUninstalledExtensions()}catch(H){throw(0,n.toExtensionManagementError)(H,h.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...H){const ce=H.map(J=>s.ExtensionKey.create(J));await this.withUninstalledExtensions(J=>ce.forEach(W=>{J[W.toString()]=!0,this.logService.info("Marked extension as uninstalled",W.toString())}))}async setInstalled(H){try{await this.withUninstalledExtensions(ce=>delete ce[H.toString()])}catch(ce){throw(0,n.toExtensionManagementError)(ce,h.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(H,ce){if(this.uriIdentityService.extUri.isEqualOrParent(H.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(H.identifier.id,H.location,ce)}async removeUninstalledExtension(H){await this.removeExtension(H,"uninstalled"),await this.withUninstalledExtensions(ce=>delete ce[s.ExtensionKey.create(H).toString()])}async copyExtension(H,ce,J,W){const L=await this.getScannedExtension(H,ce),Q=await this.getScannedExtension(H,J);if(W={...L?.metadata,...W},Q)if(this.uriIdentityService.extUri.isEqual(Q.location,H.location))await this.extensionsProfileScannerService.updateMetadata([[H,{...Q.metadata,...W}]],J);else{const $=await this.scanLocalExtension(Q.location,H.type,J);await this.extensionsProfileScannerService.removeExtensionFromProfile($,J),await this.extensionsProfileScannerService.addExtensionsToProfile([[H,{...Q.metadata,...W}]],J)}else await this.extensionsProfileScannerService.addExtensionsToProfile([[H,W]],J);return this.scanLocalExtension(H.location,H.type,J)}async copyExtensions(H,ce,J){const W=await this.scanExtensions(P.ExtensionType.User,H,J),L=await Promise.all(W.filter(Q=>!Q.isApplicationScoped).map(async Q=>[Q,await this.scanMetadata(Q,H)]));await this.extensionsProfileScannerService.addExtensionsToProfile(L,ce)}async deleteExtensionFromLocation(H,ce,J){this.logService.trace(`Deleting ${J} extension from disk`,H,ce.fsPath);const W=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(ce),`${this.uriIdentityService.extUri.basename(ce)}.${(0,b.hash)((0,p.generateUuid)()).toString(16)}${ae}`);await this.rename(ce.fsPath,W.fsPath),await this.fileService.del(W,{recursive:!0}),this.logService.info(`Deleted ${J} extension from disk`,H,ce.fsPath)}withUninstalledExtensions(H){return this.uninstalledFileLimiter.queue(async()=>{let ce;try{ce=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(W){if((0,Y.toFileOperationResult)(W)!==Y.FileOperationResult.FILE_NOT_FOUND)throw W}let J={};if(ce)try{J=JSON.parse(ce)}catch{}return H&&(H(J),Object.keys(J).length?await this.fileService.writeFile(this.uninstalledResource,r.VSBuffer.fromString(JSON.stringify(J))):await this.fileService.del(this.uninstalledResource)),J})}async rename(H,ce){try{await S.Promises.rename(H,ce,2*60*1e3)}catch(J){throw(0,n.toExtensionManagementError)(J,h.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(H,ce,J){try{if(J){const L=(await this.extensionsScannerService.scanUserExtensions({profileLocation:J})).find(Q=>this.uriIdentityService.extUri.isEqual(Q.location,H));if(L)return await this.toLocalExtension(L)}else{const W=await this.extensionsScannerService.scanExistingExtension(H,ce,{includeInvalid:!0});if(W)return await this.toLocalExtension(W)}throw new h.ExtensionManagementError(v.localize(5,null,H.path),h.ExtensionManagementErrorCode.ScanningExtension)}catch(W){throw(0,n.toExtensionManagementError)(W,h.ExtensionManagementErrorCode.ScanningExtension)}}async toLocalExtension(H){const ce=await this.fileService.resolve(H.location);let J,W;return ce.children&&(J=ce.children.find(({name:L})=>/^readme(\.txt|\.md|)$/i.test(L))?.resource,W=ce.children.find(({name:L})=>/^changelog(\.txt|\.md|)$/i.test(L))?.resource),{identifier:H.identifier,type:H.type,isBuiltin:H.isBuiltin||!!H.metadata?.isBuiltin,location:H.location,manifest:H.manifest,targetPlatform:H.targetPlatform,validations:H.validations,isValid:H.isValid,readmeUrl:J,changelogUrl:W,publisherDisplayName:H.metadata?.publisherDisplayName,publisherId:H.metadata?.publisherId||null,isApplicationScoped:!!H.metadata?.isApplicationScoped,isMachineScoped:!!H.metadata?.isMachineScoped,isPreReleaseVersion:!!H.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!H.metadata?.hasPreReleaseVersion,preRelease:!!H.metadata?.preRelease,installedTimestamp:H.metadata?.installedTimestamp,updated:!!H.metadata?.updated,pinned:!!H.metadata?.pinned,isWorkspaceScoped:!1,source:H.metadata?.source??(H.identifier.uuid?"gallery":"vsix")}}async removeUninstalledExtensions(){const H=await this.getUninstalledExtensions();if(Object.keys(H).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(H));const ce=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),J=new Set;for(const L of ce)H[s.ExtensionKey.create(L).toString()]||J.add(L.identifier.id.toLowerCase());try{const L=(0,s.groupByExtension)(ce,Q=>Q.identifier);await i.Promises.settled(L.map(async Q=>{const $=Q.sort((U,q)=>a.rcompare(U.manifest.version,q.manifest.version))[0];J.has($.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension($))}))}catch(L){this.logService.error(L)}const W=ce.filter(L=>L.metadata&&H[s.ExtensionKey.create(L).toString()]);await Promise.allSettled(W.map(L=>this.removeUninstalledExtension(L)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let H;try{H=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(ce){(0,Y.toFileOperationResult)(ce)!==Y.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(ce);return}if(H?.children)try{await Promise.allSettled(H.children.map(async ce=>{if(!(!ce.isDirectory||!ce.name.endsWith(ae))){this.logService.trace("Deleting the temporarily deleted folder",ce.resource.toString());try{await this.fileService.del(ce.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",ce.resource.toString())}catch(J){(0,Y.toFileOperationResult)(J)!==Y.FileOperationResult.FILE_NOT_FOUND&&this.logService.error(J)}}}))}catch{}}};e.ExtensionsScanner=z,e.ExtensionsScanner=z=ze([Me(1,Y.IFileService),Me(2,u.IExtensionsScannerService),Me(3,c.IExtensionsProfileScannerService),Me(4,fe.IUriIdentityService),Me(5,Z.ITelemetryService),Me(6,re.ILogService)],z);let ne=class extends n.AbstractExtensionTask{get operation(){return this.options.operation??this._operation}get verificationStatus(){return this._verificationStatus}constructor(H,ce,J,W,L,Q,$,U,q,G,F,V){super(),this.extensionKey=H,this.manifest=ce,this.source=J,this.options=W,this.extractExtensionFn=L,this.extensionsScanner=Q,this.uriIdentityService=$,this.galleryService=U,this.userDataProfilesService=q,this.extensionsScannerService=G,this.extensionsProfileScannerService=F,this.logService=V,this._operation=h.InstallOperation.Install,this.identifier=this.extensionKey.identifier}async doRun(H){const J=(await this.extensionsScanner.scanExtensions(P.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find($=>(0,s.areSameExtensions)($.identifier,this.identifier));J&&(this._operation=h.InstallOperation.Update);const W={isApplicationScoped:this.options.isApplicationScoped||J?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||J?.isMachineScoped,isBuiltin:this.options.isBuiltin||J?.isBuiltin,isSystem:J?.type===P.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??J?.pinned,source:this.source instanceof m.URI?"vsix":"gallery"};let L;if(this.source instanceof m.URI){if(J&&this.extensionKey.equals(new s.ExtensionKey(J.identifier,J.manifest.version)))try{await this.extensionsScanner.removeExtension(J,"existing")}catch{throw new Error(v.localize(6,null,this.manifest.displayName||this.manifest.name))}const $=await this.unsetIfUninstalled(this.extensionKey);if($)try{await this.extensionsScanner.removeExtension($,"existing")}catch{throw new Error(v.localize(7,null,this.manifest.displayName||this.manifest.name))}}else{if(W.id=this.source.identifier.uuid,W.publisherId=this.source.publisherId,W.publisherDisplayName=this.source.publisherDisplayName,W.targetPlatform=this.source.properties.targetPlatform,W.updated=!!J,W.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,W.hasPreReleaseVersion=J?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,W.preRelease=(0,f.isBoolean)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||J?.preRelease,J&&J.type!==P.ExtensionType.System&&J.manifest.version===this.source.version)return this.extensionsScanner.updateMetadata(J,W,this.options.profileLocation);L=await this.unsetIfUninstalled(this.extensionKey)}if(H.isCancellationRequested)throw(0,n.toExtensionManagementError)(new R.CancellationError);if(!L){const $=await this.extractExtensionFn(this.operation,H);L=$.local,this._verificationStatus=$.verificationStatus}if(this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.extensionsScannerService.initializeDefaultProfileExtensions()}catch($){throw(0,n.toExtensionManagementError)($,h.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(H.isCancellationRequested)throw(0,n.toExtensionManagementError)(new R.CancellationError);try{await this.extensionsProfileScannerService.addExtensionsToProfile([[L,W]],this.options.profileLocation,!L.isValid)}catch($){throw(0,n.toExtensionManagementError)($,h.ExtensionManagementErrorCode.AddToProfile)}const Q=await this.extensionsScanner.scanLocalExtension(L.location,P.ExtensionType.User,this.options.profileLocation);if(!Q)throw new h.ExtensionManagementError("Cannot find the installed extension",h.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof m.URI&&this.updateMetadata(L,H),Q}async unsetIfUninstalled(H){return(await this.extensionsScanner.getUninstalledExtensions())[H.toString()]?(this.logService.trace("Removing the extension from uninstalled list:",H.id),await this.extensionsScanner.setInstalled(H),this.logService.info("Removed the extension from uninstalled list:",H.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(W=>s.ExtensionKey.create(W).equals(H))):void 0}async updateMetadata(H,ce){try{let[J]=await this.galleryService.getExtensions([{id:H.identifier.id,version:H.manifest.version}],ce);if(J||([J]=await this.galleryService.getExtensions([{id:H.identifier.id}],ce)),J){const W={id:J.identifier.uuid,publisherDisplayName:J.publisherDisplayName,publisherId:J.publisherId,isPreReleaseVersion:J.properties.isPreReleaseVersion,hasPreReleaseVersion:H.hasPreReleaseVersion||J.properties.isPreReleaseVersion,preRelease:J.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(H,W,this.options.profileLocation)}}catch{}}};ne=ze([Me(6,fe.IUriIdentityService),Me(7,h.IExtensionGalleryService),Me(8,K.IUserDataProfilesService),Me(9,u.IExtensionsScannerService),Me(10,c.IExtensionsProfileScannerService),Me(11,re.ILogService)],ne);class le extends n.AbstractExtensionTask{constructor(H,ce,J){super(),this.extension=H,this.profileLocation=ce,this.extensionsProfileScannerService=J}async doRun(H){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(ye[140],Ie([1,0,12,34,36,24,54,16,28,4]),function(se,e,i,r,w,C,R,_,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let D=class extends R.AbstractExtensionsProfileScannerService{constructor(d,E,a,f,m,p){super(o.URI.file(d.extensionsPath),E,a,f,m,p)}};e.ExtensionsProfileScannerService=D,e.ExtensionsProfileScannerService=D=ze([Me(0,b.INativeEnvironmentService),Me(1,_.IFileService),Me(2,r.IUserDataProfilesService),Me(3,w.IUriIdentityService),Me(4,C.ITelemetryService),Me(5,i.ILogService)],D)}),define(ye[100],Ie([1,0,14,6,2,44,11,197,5,34]),function(se,e,i,r,w,C,R,_,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=E,e.isProfileUsingDefaultStorage=f,e.logStorage=p,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,b.createDecorator)("storageService");var D;(function(S){S[S.NONE=0]="NONE",S[S.SHUTDOWN=1]="SHUTDOWN"})(D||(e.WillSaveStateReason=D={}));var y;(function(S){S[S.APPLICATION=-1]="APPLICATION",S[S.PROFILE=0]="PROFILE",S[S.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var d;(function(S){S[S.USER=0]="USER",S[S.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function E(S){const g=S.get(e.TARGET_KEY);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}class a extends w.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(g={flushInterval:a.DEFAULT_FLUSH_INTERVAL}){super(),this.options=g,this._onDidChangeValue=this._register(new r.PauseableEmitter),this._onDidChangeTarget=this._register(new r.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new r.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new i.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new w.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(g,v,t){return r.Event.filter(this._onDidChangeValue.event,l=>l.scope===g&&(v===void 0||l.key===v),t)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,i.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,w.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,C.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,v){const{key:t,external:l}=v;if(t===e.TARGET_KEY){switch(g){case y.APPLICATION:this._applicationKeyTargets=void 0;break;case y.PROFILE:this._profileKeyTargets=void 0;break;case y.WORKSPACE:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:g})}else this._onDidChangeValue.fire({scope:g,key:t,target:this.getKeyTargets(g)[t],external:l})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,v,t){return this.getStorage(v)?.get(g,t)}getBoolean(g,v,t){return this.getStorage(v)?.getBoolean(g,t)}getNumber(g,v,t){return this.getStorage(v)?.getNumber(g,t)}getObject(g,v,t){return this.getStorage(v)?.getObject(g,t)}storeAll(g,v){this.withPausedEmitters(()=>{for(const t of g)this.store(t.key,t.value,t.scope,t.target,v)})}store(g,v,t,l,n=!1){if((0,R.isUndefinedOrNull)(v)){this.remove(g,t,n);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,t,l),this.getStorage(t)?.set(g,v,n)})}remove(g,v,t=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(g,v,void 0),this.getStorage(v)?.delete(g,t)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,v){const t=[],l=this.getKeyTargets(g);for(const n of Object.keys(l))l[n]===v&&t.push(n);return t}updateKeyTarget(g,v,t,l=!1){const n=this.getKeyTargets(v);typeof t=="number"?n[g]!==t&&(n[g]=t,this.getStorage(v)?.set(e.TARGET_KEY,JSON.stringify(n),l)):typeof n[g]=="number"&&(delete n[g],this.getStorage(v)?.set(e.TARGET_KEY,JSON.stringify(n),l))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(y.WORKSPACE)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(y.PROFILE)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(y.APPLICATION)),this._applicationKeyTargets}getKeyTargets(g){switch(g){case y.APPLICATION:return this.applicationKeyTargets;case y.PROFILE:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(g){const v=this.getStorage(g);return v?E(v):Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=D.NONE){this._onWillSaveState.fire({reason:g});const v=this.getStorage(y.APPLICATION),t=this.getStorage(y.PROFILE),l=this.getStorage(y.WORKSPACE);switch(g){case D.NONE:await i.Promises.settled([v?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve()]);break;case D.SHUTDOWN:await i.Promises.settled([v?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.getStorage(y.APPLICATION)?.items??new Map,v=this.getStorage(y.PROFILE)?.items??new Map,t=this.getStorage(y.WORKSPACE)?.items??new Map;return p(g,v,t,this.getLogDetails(y.APPLICATION)??"",this.getLogDetails(y.PROFILE)??"",this.getLogDetails(y.WORKSPACE)??"")}async optimize(g){return await this.flush(),this.getStorage(g)?.optimize()}async switch(g,v){return this.emitWillSaveState(D.NONE),(0,o.isUserDataProfile)(g)?this.switchToProfile(g,v):this.switchToWorkspace(g,v)}canSwitchProfile(g,v){return!(g.id===v.id||f(v)&&f(g))}switchData(g,v,t){this.withPausedEmitters(()=>{const l=new Set;for(const[n,h]of g)l.add(n),v.get(n)!==h&&this.emitDidChangeValue(t,{key:n,external:!0});for(const[n]of v.items)l.has(n)||this.emitDidChangeValue(t,{key:n,external:!0})})}}e.AbstractStorageService=a;function f(S){return S.isDefault||!!S.useDefaultFlags?.globalState}class m extends a{constructor(){super(),this.applicationStorage=this._register(new _.Storage(new _.InMemoryStorageDatabase,{hint:_.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new _.Storage(new _.InMemoryStorageDatabase,{hint:_.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new _.Storage(new _.InMemoryStorageDatabase,{hint:_.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(y.WORKSPACE,g))),this._register(this.profileStorage.onDidChangeStorage(g=>this.emitDidChangeValue(y.PROFILE,g))),this._register(this.applicationStorage.onDidChangeStorage(g=>this.emitDidChangeValue(y.APPLICATION,g)))}getStorage(g){switch(g){case y.APPLICATION:return this.applicationStorage;case y.PROFILE:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(g){switch(g){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(g){return!1}}e.InMemoryStorageService=m;async function p(S,g,v,t,l,n){const h=P=>{try{return JSON.parse(P)}catch{return P}},s=new Map,c=new Map;S.forEach((P,B)=>{s.set(B,P),c.set(B,h(P))});const u=new Map,I=new Map;g.forEach((P,B)=>{u.set(B,P),I.set(B,h(P))});const T=new Map,A=new Map;v.forEach((P,B)=>{T.set(B,P),A.set(B,h(P))}),console.group(t!==l?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const O=[];if(s.forEach((P,B)=>{O.push({key:B,value:P})}),console.table(O),console.groupEnd(),console.log(c),t!==l){console.group(`Storage: Profile (path: ${l}, profile specific)`);const P=[];u.forEach((B,Y)=>{P.push({key:Y,value:B})}),console.table(P),console.groupEnd(),console.log(I)}console.group(`Storage: Workspace (path: ${n})`);const k=[];T.forEach((P,B)=>{k.push({key:B,value:P})}),console.table(k),console.groupEnd(),console.log(A)}}),define(ye[291],Ie([1,0,15,23,100]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=C;async function C(R,_,b){let o=b&&b.get("storage.serviceMachineId",w.StorageScope.APPLICATION)||null;if(o)return o;try{const y=(await _.readFile(R.serviceMachineIdResource)).value.toString();o=(0,r.isUUID)(y)?y:null}catch{o=null}if(!o){o=(0,r.generateUuid)();try{await _.writeFile(R.serviceMachineIdResource,i.VSBuffer.fromString(o))}catch{}}return b?.store("storage.serviceMachineId",o,w.StorageScope.APPLICATION,w.StorageTarget.MACHINE),o}}),define(ye[292],Ie([1,0,291,24,41]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=C;async function C(R,_,b,o,D,y,d){const E={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${_.nameShort})`};if((0,w.supportsTelemetry)(_,b)&&(0,w.getTelemetryLevel)(o)===r.TelemetryLevel.USAGE){const a=await(0,i.getServiceMachineId)(b,D,y);E["X-Market-User-Id"]=a,E["VSCode-SessionId"]=d.machineId||a}return E}}),define(ye[141],Ie([1,0,18,19,10,3,33,11,4,27,28,30,39,22,74,16,12,29,47,292,100,24,48]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a,f,m,p,S,g,v,t,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=void 0,e.sortExtensionVersions=H;const n=C.isWeb?E.TargetPlatform.WEB:(0,y.getTargetPlatform)(C.platform,R.arch),h="X-Market-Search-Activity-Id";var s;(function($){$[$.None=0]="None",$[$.IncludeVersions=1]="IncludeVersions",$[$.IncludeFiles=2]="IncludeFiles",$[$.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",$[$.IncludeSharedAccounts=8]="IncludeSharedAccounts",$[$.IncludeVersionProperties=16]="IncludeVersionProperties",$[$.ExcludeNonValidated=32]="ExcludeNonValidated",$[$.IncludeInstallationTargets=64]="IncludeInstallationTargets",$[$.IncludeAssetUri=128]="IncludeAssetUri",$[$.IncludeStatistics=256]="IncludeStatistics",$[$.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",$[$.Unpublished=4096]="Unpublished",$[$.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function c(...$){return String($.reduce((U,q)=>U|q,0))}var u;(function($){$[$.Tag=1]="Tag",$[$.ExtensionId=4]="ExtensionId",$[$.Category=5]="Category",$[$.ExtensionName=7]="ExtensionName",$[$.Target=8]="Target",$[$.Featured=9]="Featured",$[$.SearchText=10]="SearchText",$[$.ExcludeWithFlags=12]="ExcludeWithFlags"})(u||(u={}));const I={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},T={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},O={pageNumber:1,pageSize:10,sortBy:y.SortBy.NoneOrRelevance,sortOrder:y.SortOrder.Default,flags:s.None,criteria:[],assetTypes:[]};class k{constructor(U=O){this.state=U}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(U,q=this.state.pageSize){return new k({...this.state,pageNumber:U,pageSize:q})}withFilter(U,...q){const G=[...this.state.criteria,...q.length?q.map(F=>({filterType:U,value:F})):[{filterType:U}]];return new k({...this.state,criteria:G})}withSortBy(U){return new k({...this.state,sortBy:U})}withSortOrder(U){return new k({...this.state,sortOrder:U})}withFlags(...U){return new k({...this.state,flags:U.reduce((q,G)=>q|G,0)})}withAssetTypes(...U){return new k({...this.state,assetTypes:U})}withSource(U){return new k({...this.state,source:U})}get raw(){const{criteria:U,pageNumber:q,pageSize:G,sortBy:F,sortOrder:V,flags:oe,assetTypes:de}=this.state;return{filters:[{criteria:U,pageNumber:q,pageSize:G,sortBy:F,sortOrder:V}],assetTypes:de,flags:oe}}get searchText(){const U=this.state.criteria.filter(q=>q.filterType===u.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(U=>String(U.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function P($,U){const q=($||[]).filter(G=>G.statisticName===U)[0];return q?q.value:0}function B($){const U="Microsoft.VisualStudio.Code.Translation.";return $.files.filter(G=>G.assetType.indexOf(U)===0).reduce((G,F)=>{const V=re($,F.assetType);return V&&G.push([F.assetType.substring(U.length),V]),G},[])}function Y($){if($.properties){const U=$.properties.filter(F=>F.key===I.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),G=U.filter(F=>q.test(F.value))[0];return G?{uri:G.value,fallbackUri:G.value}:null}return re($,I.Repository)}function X($){return{uri:`${$.fallbackAssetUri}/${I.VSIX}?redirect=true${$.targetPlatform?`&targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${I.VSIX}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}}function re($,U){return $.files.filter(G=>G.assetType===U)[0]?{uri:`${$.assetUri}/${U}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${U}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}:null}function te($,U){const q=$.properties?$.properties.filter(F=>F.key===U):[],G=q.length>0&&q[0].value;return G?G.split(",").map(F=>(0,d.adoptToGalleryExtensionId)(F)):[]}function Z($){const U=$.properties?$.properties.filter(q=>q.key===T.Engine):[];return U.length>0&&U[0].value||""}function fe($){const U=$.properties?$.properties.filter(q=>q.key===T.PreRelease):[];return U.length>0&&U[0].value==="true"}function K($){const U=$.properties?$.properties.filter(G=>G.key===T.EnabledApiProposals):[],q=U.length>0&&U[0].value||"";return q?q.split(","):[]}function ae($){const U=$.properties?$.properties.filter(G=>G.key===T.LocalizedLanguages):[],q=U.length>0&&U[0].value||"";return q?q.split(","):[]}function x($){return $.properties?.find(U=>U.key===T.SponsorLink)?.value}function z($){return $.properties?.find(U=>U.key===T.SupportLink)?.value}function ne($){return $.indexOf("preview")!==-1}function le($){return $.targetPlatform?(0,y.toTargetPlatform)($.targetPlatform):E.TargetPlatform.UNDEFINED}function ve($){const U=(0,i.distinct)($.versions.map(le)),q=!!$.tags?.includes(y.WEB_EXTENSION_TAG),G=U.indexOf(E.TargetPlatform.WEB);return q?G===-1&&U.push(E.TargetPlatform.WEB):G!==-1&&U.splice(G,1),U}function H($,U){for(let q=0;q<$.length;q++){const G=$[q];if(G.version===$[q-1]?.version){let F=q;if(le(G)===U)for(;F>0&&$[F-1].version===G.version;)F--;F!==q&&($.splice(q,1),$.splice(F,0,G))}}return $}function ce($,U,q){$.telemetryData={index:U,querySource:q,queryActivityId:$.queryContext?.[h]}}function J($,U,q,G){const F=$.versions[0],V={manifest:re(U,I.Manifest),readme:re(U,I.Details),changelog:re(U,I.Changelog),license:re(U,I.License),repository:Y(U),download:X(U),icon:re(U,I.Icon),signature:re(U,I.Signature),coreTranslations:B(U)};return{type:"gallery",identifier:{id:(0,d.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},name:$.extensionName,version:U.version,displayName:$.displayName,publisherId:$.publisher.publisherId,publisher:$.publisher.publisherName,publisherDisplayName:$.publisher.displayName,publisherDomain:$.publisher.domain?{link:$.publisher.domain,verified:!!$.publisher.isDomainVerified}:void 0,publisherSponsorLink:x(F),description:$.shortDescription??"",installCount:P($.statistics,"install"),rating:P($.statistics,"averagerating"),ratingCount:P($.statistics,"ratingcount"),categories:$.categories||[],tags:$.tags||[],releaseDate:Date.parse($.releaseDate),lastUpdated:Date.parse($.lastUpdated),allTargetPlatforms:q,assets:V,properties:{dependencies:te(U,T.Dependency),extensionPack:te(U,T.ExtensionPack),engine:Z(U),enabledApiProposals:K(U),localizedLanguages:ae(U),targetPlatform:le(U),isPreReleaseVersion:fe(U)},hasPreReleaseVersion:fe(F),hasReleaseVersion:!0,preview:ne($.flags),isSigned:!!V.signature,queryContext:G,supportLink:z(F)}}let W=class{constructor(U,q,G,F,V,oe,de,Ce){this.requestService=q,this.logService=G,this.environmentService=F,this.telemetryService=V,this.fileService=oe,this.productService=de,this.configurationService=Ce;const Ne=de.extensionsGallery,ge=Ne?.servicePPEUrl&&Ce.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=ge?Ne.servicePPEUrl:Ne?.serviceUrl,this.extensionsGallerySearchUrl=ge?void 0:Ne?.searchUrl,this.extensionsControlUrl=Ne?.controlUrl,this.extensionsEnabledWithApiProposalVersion=de.extensionsEnabledWithApiProposalVersion?.map(pe=>pe.toLowerCase())??[],this.commonHeadersPromise=(0,g.resolveMarketplaceHeaders)(de.version,de,this.environmentService,this.configurationService,this.fileService,U,this.telemetryService)}api(U=""){return`${this.extensionsGalleryUrl}${U}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(U,q,G){const F=r.CancellationToken.isCancellationToken(q)?{}:q,V=r.CancellationToken.isCancellationToken(q)?q:G,oe=[],de=[],Ce=[],Ne=[];let ge=!0;for(const Le of U){Le.uuid?de.push(Le.uuid):oe.push(Le.id);const he=!!(Le.version||Le.preRelease);Ce.push({id:Le.id,uuid:Le.uuid,includePreRelease:he}),Le.version&&Ne.push({id:Le.id,uuid:Le.uuid,version:Le.version}),ge=ge&&!!Le.hasPreRelease&&!he}if(!de.length&&!oe.length)return[];let pe=new k().withPage(1,U.length);de.length&&(pe=pe.withFilter(u.ExtensionId,...de)),oe.length&&(pe=pe.withFilter(u.ExtensionName,...oe)),(F.queryAllVersions||ge)&&(pe=pe.withFlags(pe.flags,s.IncludeVersions)),F.source&&(pe=pe.withSource(F.source));const{extensions:Te}=await this.queryGalleryExtensions(pe,{targetPlatform:F.targetPlatform??n,includePreRelease:Ce,versions:Ne,compatible:!!F.compatible,productVersion:F.productVersion??{version:this.productService.version,date:this.productService.date}},V);return F.source&&Te.forEach((Le,he)=>ce(Le,he,F.source)),Te}async getCompatibleExtension(U,q,G,F={version:this.productService.version,date:this.productService.date}){if((0,y.isNotWebExtensionInWebTargetPlatform)(U.allTargetPlatforms,G))return null;if(await this.isExtensionCompatible(U,q,G))return U;const V=new k().withFlags(s.IncludeVersions).withPage(1,1).withFilter(u.ExtensionId,U.identifier.uuid),{extensions:oe}=await this.queryGalleryExtensions(V,{targetPlatform:G,compatible:!0,includePreRelease:q,productVersion:F},r.CancellationToken.None);return oe[0]||null}async isExtensionCompatible(U,q,G,F={version:this.productService.version,date:this.productService.date}){if(!(0,y.isTargetPlatformCompatible)(U.properties.targetPlatform,U.allTargetPlatforms,G)||!q&&U.properties.isPreReleaseVersion)return!1;let V=U.properties.engine;if(!V){const oe=await this.getManifest(U,r.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");V=oe.engines.vscode}return!(!(0,a.isEngineValid)(V,F.version,F.date)||!this.areApiProposalsCompatible(U.identifier,U.properties.enabledApiProposals))}areApiProposalsCompatible(U,q){return!q||!this.extensionsEnabledWithApiProposalVersion.includes(U.id.toLowerCase())?!0:(0,a.areApiProposalsCompatible)(q)}async isValidVersion(U,q,G,F,V,oe,de={version:this.productService.version,date:this.productService.date}){if(!(0,y.isTargetPlatformCompatible)(le(q),V,oe)||G!=="any"&&fe(q)!==(G==="prerelease"))return!1;if(F)try{const Ce=await this.getEngine(U,q);if(!(0,a.isEngineValid)(Ce,de.version,de.date))return!1}catch(Ce){return this.logService.error(`Error while getting the engine for the version ${q.version}.`,(0,w.getErrorMessage)(Ce)),!1}return!0}async query(U,q){let G=U.text||"";const F=U.pageSize??50;let V=new k().withPage(1,F);G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,pe,Te)=>(V=V.withFilter(u.Category,Te||pe),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,pe,Te)=>(V=V.withFilter(u.Tag,Te||pe),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(V=V.withFilter(u.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),V=V.withFilter(u.SearchText,G)),V=V.withSortBy(y.SortBy.NoneOrRelevance)):U.ids?V=V.withFilter(u.ExtensionId,...U.ids):U.names?V=V.withFilter(u.ExtensionName,...U.names):V=V.withSortBy(y.SortBy.InstallCount),typeof U.sortBy=="number"&&(V=V.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(V=V.withSortOrder(U.sortOrder)),U.source&&(V=V.withSource(U.source));const oe=async(ge,pe)=>{const{extensions:Te,total:Le}=await this.queryGalleryExtensions(ge,{targetPlatform:n,compatible:!1,includePreRelease:!!U.includePreRelease,productVersion:U.productVersion??{version:this.productService.version,date:this.productService.date}},pe);return Te.forEach((he,De)=>ce(he,(ge.pageNumber-1)*ge.pageSize+De,U.source)),{extensions:Te,total:Le}},{extensions:de,total:Ce}=await oe(V,q),Ne=async(ge,pe)=>{if(pe.isCancellationRequested)throw new w.CancellationError;const{extensions:Te}=await oe(V.withPage(ge+1),pe);return Te};return{firstPage:de,total:Ce,pageSize:V.pageSize,getPage:Ne}}async queryGalleryExtensions(U,q,G){const F=U.flags;U.flags&s.IncludeLatestVersionOnly&&U.flags&s.IncludeVersions&&(U=U.withFlags(U.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(U.flags&s.IncludeLatestVersionOnly)&&!(U.flags&s.IncludeVersions)&&(U=U.withFlags(U.flags,s.IncludeLatestVersionOnly)),q.versions?.length&&(U=U.withFlags(U.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),U=U.withFlags(U.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:V,total:oe,context:de}=await this.queryRawGalleryExtensions(U,G);if(!(U.flags&s.IncludeLatestVersionOnly)){const pe=[];for(const Te of V){const Le=await this.toGalleryExtensionWithCriteria(Te,q,de);Le&&pe.push(Le)}return{extensions:pe,total:oe}}const Ne=[],ge=new Map;for(let pe=0;pe<V.length;pe++){const Te=V[pe],Le={id:(0,d.getGalleryExtensionId)(Te.publisher.publisherName,Te.extensionName),uuid:Te.extensionId},he=(0,_.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(Re=>(0,d.areSameExtensions)(Re,Le))?.includePreRelease;if(q.compatible&&(0,y.isNotWebExtensionInWebTargetPlatform)(ve(Te),q.targetPlatform))continue;const De=await this.toGalleryExtensionWithCriteria(Te,q,de);!De||De.properties.isPreReleaseVersion&&(!he||!De.hasReleaseVersion)||!De.properties.isPreReleaseVersion&&De.properties.targetPlatform!==q.targetPlatform&&De.hasPreReleaseVersion?ge.set(Te.extensionId,pe):Ne.push([pe,De])}if(ge.size){const pe=new l.StopWatch,Te=new k().withFlags(F&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,ge.size).withFilter(u.ExtensionId,...ge.keys()),{extensions:Le}=await this.queryGalleryExtensions(Te,q,G);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:pe.elapsed(),count:ge.size});for(const he of Le){const De=ge.get(he.identifier.uuid);Ne.push([De,he])}}return{extensions:Ne.sort((pe,Te)=>pe[0]-Te[0]).map(([,pe])=>pe),total:oe}}async toGalleryExtensionWithCriteria(U,q,G){const F={id:(0,d.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},V=q.versions?.find(Ne=>(0,d.areSameExtensions)(Ne,F))?.version,oe=(0,_.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(Ne=>(0,d.areSameExtensions)(Ne,F))?.includePreRelease,de=ve(U),Ce=H(U.versions,q.targetPlatform);if(q.compatible&&(0,y.isNotWebExtensionInWebTargetPlatform)(de,q.targetPlatform))return null;for(let Ne=0;Ne<Ce.length;Ne++){const ge=Ce[Ne];if(!(V&&ge.version!==V)){if(await this.isValidVersion(F.id,ge,oe?"any":"release",q.compatible,de,q.targetPlatform,q.productVersion))return q.compatible&&!this.areApiProposalsCompatible(F,K(ge))?null:J(U,ge,de,G);if(V&&ge.version===V)return null}}return V||q.compatible?null:J(U,U.versions[0],de)}async queryRawGalleryExtensions(U,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,s.ExcludeNonValidated).withFilter(u.Target,"Microsoft.VisualStudio.Code").withFilter(u.ExcludeWithFlags,c(s.Unpublished));const G=await this.commonHeadersPromise,F=JSON.stringify(U.raw),V={...G,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(F.length)},oe=new l.StopWatch;let de,Ce,Ne=0;try{if(de=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&U.criteria.some(pe=>pe.filterType===u.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:F,headers:V},q),de.res.statusCode&&de.res.statusCode>=400&&de.res.statusCode<500)return{galleryExtensions:[],total:Ne};const ge=await(0,S.asJson)(de);if(ge){const pe=ge.results[0],Te=pe.extensions,Le=pe.resultMetadata&&pe.resultMetadata.filter(he=>he.metadataType==="ResultCount")[0];return Ne=Le&&Le.metadataItems.filter(he=>he.name==="TotalCount")[0].count||0,{galleryExtensions:Te,total:Ne,context:{[h]:de.res.headers.activityid}}}return{galleryExtensions:[],total:Ne}}catch(ge){if((0,w.isCancellationError)(ge))throw Ce=y.ExtensionGalleryErrorCode.Cancelled,ge;{const pe=(0,w.getErrorMessage)(ge);throw Ce=pe.startsWith("XHR timeout")?y.ExtensionGalleryErrorCode.Timeout:y.ExtensionGalleryErrorCode.Failed,new y.ExtensionGalleryError(pe,Ce)}}finally{this.telemetryService.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(F.length),duration:oe.elapsed(),success:!!de&&(0,S.isSuccess)(de),responseBodySize:de?.res.headers["Content-Length"],statusCode:de?String(de.res.statusCode):void 0,errorCode:Ce,count:String(Ne)})}}async reportStatistic(U,q,G,F){if(!this.isEnabled())return;const V=C.isWeb?this.api(`/itemName/${U}.${q}/version/${G}/statType/${F===y.StatisticType.Install?"1":"3"}/vscodewebextension`):this.api(`/publishers/${U}/extensions/${q}/${G}/stats?statType=${F}`),oe=C.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ce={...await this.commonHeadersPromise,Accept:oe};try{await this.requestService.request({type:"POST",url:V,headers:Ce},r.CancellationToken.None)}catch{}}async download(U,q,G){this.logService.trace("ExtensionGalleryService#download",U.identifier.id);const F=(0,d.getGalleryExtensionTelemetryData)(U),V=new Date().getTime(),oe=G===y.InstallOperation.Install?"install":G===y.InstallOperation.Update?"update":"",de=oe?{uri:`${U.assets.download.uri}${b.URI.parse(U.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${U.assets.download.fallbackUri}${b.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:U.assets.download,Ce=U.queryContext?.[h]?{[h]:U.queryContext[h]}:void 0,Ne=await this.getAsset(U.identifier.id,de,I.VSIX,Ce?{headers:Ce}:void 0);try{await this.fileService.writeFile(q,Ne.stream)}catch(ge){try{await this.fileService.del(q)}catch(pe){this.logService.warn(`Error while deleting the file ${q.toString()}`,(0,w.getErrorMessage)(pe))}throw new y.ExtensionGalleryError((0,w.getErrorMessage)(ge),y.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.telemetryService.publicLog("galleryService:downloadVSIX",{...F,duration:new Date().getTime()-V})}async downloadSignatureArchive(U,q){if(!U.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",U.identifier.id);const G=await this.getAsset(U.identifier.id,U.assets.signature,I.Signature);try{await this.fileService.writeFile(q,G.stream)}catch(F){try{await this.fileService.del(q)}catch(V){this.logService.warn(`Error while deleting the file ${q.toString()}`,(0,w.getErrorMessage)(V))}throw new y.ExtensionGalleryError((0,w.getErrorMessage)(F),y.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(U,q){if(U.assets.readme){const G=await this.getAsset(U.identifier.id,U.assets.readme,I.Details,{},q);return await(0,S.asTextOrError)(G)||""}return""}async getManifest(U,q){if(U.assets.manifest){const G=await this.getAsset(U.identifier.id,U.assets.manifest,I.Manifest,{},q),F=await(0,S.asTextOrError)(G);return F?JSON.parse(F):null}return null}async getManifestFromRawExtensionVersion(U,q,G){const F=re(q,I.Manifest);if(!F)throw new Error("Manifest was not found");const V={"Accept-Encoding":"gzip"},oe=await this.getAsset(U,F,I.Manifest,{headers:V});return await(0,S.asJson)(oe)}async getCoreTranslation(U,q){const G=U.assets.coreTranslations.filter(F=>F[0]===q.toUpperCase())[0];if(G){const F=await this.getAsset(U.identifier.id,G[1],G[0]),V=await(0,S.asTextOrError)(F);return V?JSON.parse(V):null}return null}async getChangelog(U,q){if(U.assets.changelog){const G=await this.getAsset(U.identifier.id,U.assets.changelog,I.Changelog,{},q);return await(0,S.asTextOrError)(G)||""}return""}async getAllCompatibleVersions(U,q,G){let F=new k().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);U.uuid?F=F.withFilter(u.ExtensionId,U.uuid):F=F.withFilter(u.ExtensionName,U.id);const{galleryExtensions:V}=await this.queryRawGalleryExtensions(F,r.CancellationToken.None);if(!V.length)return[];const oe=ve(V[0]);if((0,y.isNotWebExtensionInWebTargetPlatform)(oe,G))return[];const de=[];await Promise.all(V[0].versions.map(async ge=>{try{await this.isValidVersion(U.id,ge,q?"any":"release",!0,oe,G)&&this.areApiProposalsCompatible(U,K(ge))&&de.push(ge)}catch{}}));const Ce=[],Ne=new Set;for(const ge of H(de,G))Ne.has(ge.version)||(Ne.add(ge.version),Ce.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:fe(ge)}));return Ce}async getAsset(U,q,G,F={},V=r.CancellationToken.None){const oe=await this.commonHeadersPromise,de={type:"GET"},Ce={...oe,...F.headers||{}};F={...F,...de,headers:Ce};const Ne=q.uri,ge=q.fallbackUri,pe={...F,url:Ne};try{const Te=await this.requestService.request(pe,V);if(Te.res.statusCode===200)return Te;const Le=await(0,S.asTextOrError)(Te);throw new Error(`Expected 200, got back ${Te.res.statusCode} instead.

${Le}`)}catch(Te){if((0,w.isCancellationError)(Te))throw Te;const Le=(0,w.getErrorMessage)(Te);this.telemetryService.publicLog2("galleryService:cdnFallback",{extension:U,assetType:G,message:Le});const he={...F,url:ge};return this.requestService.request(he,V)}}async getEngine(U,q){let G=Z(q);if(!G){this.telemetryService.publicLog2("galleryService:engineFallback",{extension:U,version:q.version});const F=await this.getManifestFromRawExtensionVersion(U,q,r.CancellationToken.None);if(!F)throw new Error("Manifest was not found");G=F.engines.vscode}return G}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const U=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},r.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,S.asJson)(U),G=[],F={},V=[],oe=[];if(q){for(const de of q.malicious)G.push({id:de});if(q.migrateToPreRelease)for(const[de,Ce]of Object.entries(q.migrateToPreRelease))(!Ce.engine||(0,a.isEngineValid)(Ce.engine,this.productService.version,this.productService.date))&&(F[de.toLowerCase()]={disallowInstall:!0,extension:{id:Ce.id,displayName:Ce.displayName,autoMigrate:{storage:!!Ce.migrateStorage},preRelease:!0}});if(q.deprecated)for(const[de,Ce]of Object.entries(q.deprecated))Ce&&(F[de.toLowerCase()]=(0,_.isBoolean)(Ce)?{}:Ce);if(q.search)for(const de of q.search)V.push(de);if(Array.isArray(q.extensionsEnabledWithPreRelease))for(const de of q.extensionsEnabledWithPreRelease)oe.push(de.toLowerCase())}return{malicious:G,deprecated:F,search:V,extensionsEnabledWithPreRelease:oe}}};W=ze([Me(1,S.IRequestService),Me(2,m.ILogService),Me(3,D.IEnvironmentService),Me(4,t.ITelemetryService),Me(5,f.IFileService),Me(6,p.IProductService),Me(7,o.IConfigurationService)],W);let L=class extends W{constructor(U,q,G,F,V,oe,de,Ce){super(U,q,G,F,V,oe,de,Ce)}};e.ExtensionGalleryService=L,e.ExtensionGalleryService=L=ze([Me(0,v.IStorageService),Me(1,S.IRequestService),Me(2,m.ILogService),Me(3,D.IEnvironmentService),Me(4,t.ITelemetryService),Me(5,f.IFileService),Me(6,p.IProductService),Me(7,o.IConfigurationService)],L);let Q=class extends W{constructor(U,q,G,F,V,oe,de){super(void 0,U,q,G,F,V,oe,de)}};e.ExtensionGalleryServiceWithNoStorageService=Q,e.ExtensionGalleryServiceWithNoStorageService=Q=ze([Me(0,S.IRequestService),Me(1,m.ILogService),Me(2,D.IEnvironmentService),Me(3,t.ITelemetryService),Me(4,f.IFileService),Me(5,p.IProductService),Me(6,o.IConfigurationService)],Q)}),define(ye[293],Ie([1,0,6,2,34,59]),function(se,e,i,r,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class R{constructor(o,D){this.service=o,this.getUriTransformer=D}listen(o,D){const y=this.getUriTransformer(o);switch(D){case"onDidChangeProfiles":return i.Event.map(this.service.onDidChangeProfiles,d=>({all:d.all.map(E=>(0,C.transformOutgoingURIs)({...E},y)),added:d.added.map(E=>(0,C.transformOutgoingURIs)({...E},y)),removed:d.removed.map(E=>(0,C.transformOutgoingURIs)({...E},y)),updated:d.updated.map(E=>(0,C.transformOutgoingURIs)({...E},y))}))}throw new Error(`Invalid listen ${D}`)}async call(o,D,y){const d=this.getUriTransformer(o);switch(D){case"createProfile":{const E=await this.service.createProfile(y[0],y[1],y[2]);return(0,C.transformOutgoingURIs)({...E},d)}case"updateProfile":{let E=(0,w.reviveProfile)((0,C.transformIncomingURIs)(y[0],d),this.service.profilesHome.scheme);return E=await this.service.updateProfile(E,y[1]),(0,C.transformOutgoingURIs)({...E},d)}case"removeProfile":{const E=(0,w.reviveProfile)((0,C.transformIncomingURIs)(y[0],d),this.service.profilesHome.scheme);return this.service.removeProfile(E)}}throw new Error(`Invalid call ${D}`)}}e.RemoteUserDataProfilesServiceChannel=R;class _ extends r.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(o,D,y){super(),this.profilesHome=D,this.channel=y,this._profiles=[],this._onDidChangeProfiles=this._register(new i.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this._profiles=o.map(d=>(0,w.reviveProfile)(d,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(d=>{const E=d.added.map(m=>(0,w.reviveProfile)(m,this.profilesHome.scheme)),a=d.removed.map(m=>(0,w.reviveProfile)(m,this.profilesHome.scheme)),f=d.updated.map(m=>(0,w.reviveProfile)(m,this.profilesHome.scheme));this._profiles=d.all.map(m=>(0,w.reviveProfile)(m,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:E,removed:a,updated:f,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(o){this.enabled=o}isEnabled(){return this.enabled}async createNamedProfile(o,D,y){const d=await this.channel.call("createNamedProfile",[o,D,y]);return(0,w.reviveProfile)(d,this.profilesHome.scheme)}async createProfile(o,D,y,d){const E=await this.channel.call("createProfile",[o,D,y,d]);return(0,w.reviveProfile)(E,this.profilesHome.scheme)}async createTransientProfile(o){const D=await this.channel.call("createTransientProfile",[o]);return(0,w.reviveProfile)(D,this.profilesHome.scheme)}async setProfileForWorkspace(o,D){await this.channel.call("setProfileForWorkspace",[o,D])}removeProfile(o){return this.channel.call("removeProfile",[o])}async updateProfile(o,D){const y=await this.channel.call("updateProfile",[o,D]);return(0,w.reviveProfile)(y,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=_}),define(ye[142],Ie([1,0,4,28,16,12,271,36,34,11,272]),function(se,e,i,r,w,C,R,_,b,o,D){"use strict";var y,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let E=class extends b.UserDataProfilesService{static{y=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(p,S,g,v,t){super(g,v,S,t),this.stateReadonlyService=p,this.nativeEnvironmentService=g}getStoredProfiles(){return this.stateReadonlyService.getItem(y.PROFILES_KEY,[]).map(S=>({...S,location:(0,o.isString)(S.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,S.location):i.URI.revive(S.location)}))}getStoredProfileAssociations(){const p=this.stateReadonlyService.getItem(y.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(y.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?p:this.migrateStoredProfileAssociations(p)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(i.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=E,e.UserDataProfilesReadonlyService=E=y=ze([Me(0,R.IStateReadService),Me(1,_.IUriIdentityService),Me(2,r.INativeEnvironmentService),Me(3,w.IFileService),Me(4,C.ILogService)],E);let a=d=class extends E{constructor(p,S,g,v,t){super(p,S,g,v,t),this.stateService=p}saveStoredProfiles(p){p.length?this.stateService.setItem(d.PROFILES_KEY,p.map(S=>({...S,location:this.uriIdentityService.extUri.basename(S.location)}))):this.stateService.removeItem(d.PROFILES_KEY)}getStoredProfiles(){const p=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(p),this.stateService.setItem("userDataProfilesMigration",!0)),p}saveStoredProfileAssociations(p){p.emptyWindows||p.workspaces?this.stateService.setItem(d.PROFILE_ASSOCIATIONS_KEY,p):this.stateService.removeItem(d.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const p="workspaceAndProfileInfo",S=this.stateService.getItem(p,void 0);if(S){this.stateService.removeItem(p);const v=S.reduce((t,{workspace:l,profile:n})=>(t[i.URI.revive(l).toString()]=i.URI.revive(n).toString(),t),{});this.stateService.setItem(d.PROFILE_ASSOCIATIONS_KEY,{workspaces:v})}const g=super.getStoredProfileAssociations();return this.stateService.getItem(d.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(g),this.stateService.setItem(d.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),g}};e.UserDataProfilesService=a,e.UserDataProfilesService=a=d=ze([Me(0,R.IStateService),Me(1,_.IUriIdentityService),Me(2,r.INativeEnvironmentService),Me(3,w.IFileService),Me(4,C.ILogService)],a);let f=class extends a{constructor(p,S,g,v){super(new D.StateService(D.SaveStrategy.IMMEDIATE,S,v,g),p,S,g,v)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=f,e.ServerUserDataProfilesService=f=ze([Me(0,_.IUriIdentityService),Me(1,r.INativeEnvironmentService),Me(2,w.IFileService),Me(3,C.ILogService)],f)}),define(ye[143],Ie([1,0,5]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,i.createDecorator)("extensionHostStatusService");class r{constructor(){this._exitInfo=new Map}setExitInfo(C,R){this._exitInfo.set(C,R)}getExitInfo(C){return this._exitInfo.get(C)||null}}e.ExtensionHostStatusService=r}),define(ye[294],Ie([1,0,61,6,14]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=void 0;function C(_){let b=0,o=0,D=0;_>=1e3&&(D=Math.floor(_/1e3),_-=D*1e3),D>=60&&(o=Math.floor(D/60),D-=o*60),o>=60&&(b=Math.floor(o/60),o-=b*60);const y=b?`${b}h`:"",d=o?`${o}m`:"",E=D?`${D}s`:"",a=_?`${_}ms`:"";return`${y}${d}${E}${a}`}class R{constructor(b,o,D,y){this._logService=b,this._reconnectionToken=o,this._onClose=new r.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=i.ProtocolConstants.ReconnectionGraceTime,this._reconnectionShortGraceTime=i.ProtocolConstants.ReconnectionShortGraceTime,this._remoteAddress=D,this.protocol=y,this._disposed=!1,this._disconnectRunner1=new w.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection grace time of ${C(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new w.ProcessTimeRunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${C(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${C(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(b){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${b}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${C(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(this._disposed)return;this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const b=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),b.end(),this._onClose.fire(void 0)}acceptReconnection(b,o,D){this._remoteAddress=b,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(o,D),this.protocol.endAcceptReconnection()}}e.ManagementConnection=R});var gt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ye[144],Ie([1,0,31,13,9,176,62]),function(se,e,i,r,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=void 0,e.getNLSConfiguration=D,i=Be(i),w=Be(w),C=Be(C),R=gt(R);const _=w.join(r.FileAccess.asFileUri("").fsPath,"nls.metadata.json"),b=new Map;function o(d){return new Promise(E=>i.exists(d,E))}function D(d,E){return o(_).then(a=>{if(!a||!R.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const f=`${d}||${E}`;let m=b.get(f);return m||(m=C.getNLSConfiguration(R.default.commit,E,_,d,d).then(p=>(y.is(p)&&(p._languagePackSupport=!0),p)),b.set(f,m)),m})}var y;(function(d){function E(a){const f=a;return f&&typeof f._languagePackId=="string"}d.is=E})(y||(e.InternalNLSConfiguration=y={}))}),define(ye[145],Ie([1,0,20,4,28,54,64,16,5,12,29,36,34,144]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let a=class extends R.AbstractExtensionsScannerService{constructor(m,p,S,g,v,t,l,n){super(r.URI.file(v.builtinExtensionsPath),r.URI.file(v.extensionsPath),(0,i.joinPath)(v.userHome,".vscode-oss-dev","extensions","control.json"),m.defaultProfile,m,p,S,g,v,t,l,n),this.nativeEnvironmentService=v}async getTranslations(m){const p=await(0,E.getNLSConfiguration)(m,this.nativeEnvironmentService.userDataPath);if(E.InternalNLSConfiguration.is(p))try{const S=await this.fileService.readFile(r.URI.file(p._translationsConfigFile));return JSON.parse(S.value.toString())}catch{}return Object.create(null)}};e.ExtensionsScannerService=a,e.ExtensionsScannerService=a=ze([Me(0,d.IUserDataProfilesService),Me(1,C.IExtensionsProfileScannerService),Me(2,_.IFileService),Me(3,o.ILogService),Me(4,w.INativeEnvironmentService),Me(5,D.IProductService),Me(6,y.IUriIdentityService),Me(7,b.IInstantiationService)],a)}),define(ye[101],Ie([1,0,295,31,9,23,13,25]),function(se,e,i,r,w,C,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0,e.parseServerConnectionToken=E,e.determineServerConnectionToken=a,e.requestHasValidConnectionToken=f,i=Be(i),r=Be(r),w=Be(w);const b=/^[0-9A-Za-z_-]+$/;var o;(function(m){m[m.None=0]="None",m[m.Optional=1]="Optional",m[m.Mandatory=2]="Mandatory"})(o||(e.ServerConnectionTokenType=o={}));class D{constructor(){this.type=o.None}validate(p){return!0}}e.NoneServerConnectionToken=D;class y{constructor(p){this.value=p,this.type=o.Mandatory}validate(p){return p===this.value}}e.MandatoryServerConnectionToken=y;class d{constructor(p){this.message=p}}e.ServerConnectionTokenParseError=d;async function E(m,p){const S=m["without-connection-token"],g=m["connection-token"],v=m["connection-token-file"];if(S)return typeof g<"u"||typeof v<"u"?new d("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new D;if(typeof v<"u"){if(typeof g<"u")return new d("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let t;try{t=r.readFileSync(v).toString().replace(/\r?\n$/,"")}catch{return new d(`Unable to read the connection token file at '${v}'.`)}return b.test(t)?new y(t):new d(`The connection token defined in '${v} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof g<"u"?b.test(g)?new y(g):new d(`The connection token '${g} does not adhere to the characters 0-9, a-z, A-Z or -.`):new y(await p())}async function a(m){return E(m,async()=>{if(!m["user-data-dir"])return(0,C.generateUuid)();const S=w.join(m["user-data-dir"],"token");try{const t=(await _.Promises.readFile(S)).toString().replace(/\r?\n$/,"");if(b.test(t))return t}catch{}const g=(0,C.generateUuid)();try{await _.Promises.writeFile(S,g,{mode:384})}catch{}return g})}function f(m,p,S){if(m.validate(S.query[R.connectionTokenQueryName]))return!0;const g=i.parse(p.headers.cookie||"");return m.validate(g[R.connectionTokenCookieName])}}),define(ye[55],Ie([1,0,230,118,70,5,28,78]),function(se,e,i,r,w,C,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,i=Be(i),e.serverOptions={host:{type:"string",cat:"o",args:"ip-address",description:i.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:i.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:i.localize(2,null)},"server-base-path":{type:"string",cat:"o",args:"path",description:i.localize(3,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:i.localize(4,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:i.localize(5,null)},"without-connection-token":{type:"boolean",cat:"o",description:i.localize(6,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:i.localize(7,null)},"server-data-dir":{type:"string",cat:"o",description:i.localize(8,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:i.localize(9,null)},"user-data-dir":w.OPTIONS["user-data-dir"],"enable-smoke-test-driver":w.OPTIONS["enable-smoke-test-driver"],"disable-telemetry":w.OPTIONS["disable-telemetry"],"disable-workspace-trust":w.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:w.OPTIONS.log,logsPath:w.OPTIONS.logsPath,"force-disable-user-env":w.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:i.localize(10,null)},"default-workspace":{type:"string",description:i.localize(11,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":w.OPTIONS["extensions-dir"],"extensions-download-dir":w.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":w.OPTIONS["builtin-extensions-dir"],"install-extension":w.OPTIONS["install-extension"],"install-builtin-extension":w.OPTIONS["install-builtin-extension"],"update-extensions":w.OPTIONS["update-extensions"],"uninstall-extension":w.OPTIONS["uninstall-extension"],"list-extensions":w.OPTIONS["list-extensions"],"locate-extension":w.OPTIONS["locate-extension"],"show-versions":w.OPTIONS["show-versions"],category:w.OPTIONS.category,force:w.OPTIONS.force,"do-not-sync":w.OPTIONS["do-not-sync"],"pre-release":w.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:i.localize(12,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:w.OPTIONS.help,version:w.OPTIONS.version,"locate-shell-integration-path":w.OPTIONS["locate-shell-integration-path"],compatibility:{type:"string"},_:w.OPTIONS._},e.IServerEnvironmentService=(0,C.refineServiceDecorator)(R.IEnvironmentService);class b extends r.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.ServerEnvironmentService=b,ze([_.memoize],b.prototype,"userRoamingDataHome",null)}),define(ye[296],Ie([1,0,31,25,83,93,295,96,37,68,3,12,55,9,13,23,29,101,47,19,4,15,11,35]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a,f,m,p,S,g,v,t,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebClientServer=e.CacheControl=void 0,e.serveError=s,e.serveFile=u,w=Be(w),C=Be(C),R=Be(R),_=Be(_);const h={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function s(A,O,k,P){O.writeHead(k,{"Content-Type":"text/plain"}),O.end(P)}var c;(function(A){A[A.NO_CACHING=0]="NO_CACHING",A[A.ETAG=1]="ETAG",A[A.NO_EXPIRY=2]="NO_EXPIRY"})(c||(e.CacheControl=c={}));async function u(A,O,k,P,B,Y){try{const X=await r.Promises.stat(A);if(O===c.ETAG){const re=`W/"${[X.ino,X.size,X.mtime.getTime()].join("-")}"`;if(P.headers["if-none-match"]===re)return B.writeHead(304),void B.end();Y.Etag=re}else O===c.NO_EXPIRY?Y["Cache-Control"]="public, max-age=31536000":O===c.NO_CACHING&&(Y["Cache-Control"]="no-store");Y["Content-Type"]=h[(0,E.extname)(A)]||(0,o.getMediaMime)(A)||"text/plain",B.writeHead(200,Y),(0,i.createReadStream)(A).pipe(B)}catch(X){return X.code!=="ENOENT"?(k.error(X),console.error(X.toString())):console.error(`File not found: ${A}`),B.writeHead(404,{"Content-Type":"text/plain"}),void B.end("Not found")}}const I=(0,E.dirname)(a.FileAccess.asFileUri("").fsPath);let T=class{constructor(O,k,P,B,Y,X,re){this._connectionToken=O,this._basePath=k,this.serverRootPath=P,this._environmentService=B,this._logService=Y,this._requestService=X,this._productService=re,this._webExtensionResourceUrlTemplate=this._productService.extensionsGallery?.resourceUrlTemplate?v.URI.parse(this._productService.extensionsGallery.resourceUrlTemplate):void 0,this._staticRoute=`${P}/static`,this._callbackRoute=`${P}/callback`,this._webExtensionRoute=`${P}/web-extension-resource`}async handle(O,k,P){try{const B=P.pathname;return B.startsWith(this._staticRoute)&&B.charCodeAt(this._staticRoute.length)===n.CharCode.Slash?this._handleStatic(O,k,P):B===this._basePath?this._handleRoot(O,k,P):B===this._callbackRoute?this._handleCallback(k):B.startsWith(this._webExtensionRoute)&&B.charCodeAt(this._webExtensionRoute.length)===n.CharCode.Slash?this._handleWebExtensionResource(O,k,P):s(O,k,404,"Not found.")}catch(B){return this._logService.error(B),console.error(B.toString()),s(O,k,500,"Internal Server Error.")}}async _handleStatic(O,k,P){const B=Object.create(null),X=decodeURIComponent(P.pathname).substring(this._staticRoute.length+1),re=(0,E.join)(I,X);return(0,b.isEqualOrParent)(re,I,!D.isLinux)?u(re,this._environmentService.isBuilt?c.NO_EXPIRY:c.ETAG,this._logService,O,k,B):s(O,k,400,"Bad request.")}_getResourceURLTemplateAuthority(O){const k=O.authority.indexOf(".");return k!==-1?O.authority.substring(k+1):void 0}async _handleWebExtensionResource(O,k,P){if(!this._webExtensionResourceUrlTemplate)return s(O,k,500,"No extension gallery service configured.");const B=decodeURIComponent(P.pathname),Y=(0,E.normalize)(B.substring(this._webExtensionRoute.length+1)),X=v.URI.parse(Y).with({scheme:this._webExtensionResourceUrlTemplate.scheme,authority:Y.substring(0,Y.indexOf("/")),path:Y.substring(Y.indexOf("/")+1)});if(this._getResourceURLTemplateAuthority(this._webExtensionResourceUrlTemplate)!==this._getResourceURLTemplateAuthority(X))return s(O,k,403,"Request Forbidden");const re={},te=z=>{const ne=O.headers[z];ne&&((0,l.isString)(ne)||ne[0])?re[z]=(0,l.isString)(ne)?ne:ne[0]:z!==z.toLowerCase()&&te(z.toLowerCase())};te("X-Client-Name"),te("X-Client-Version"),te("X-Machine-Id"),te("X-Client-Commit");const Z=await this._requestService.request({type:"GET",url:X.toString(!0),headers:re},g.CancellationToken.None),fe=Z.res.statusCode||500;if(fe!==200){let z=null;try{z=await(0,S.asTextOrError)(Z)}catch{}return s(O,k,fe,z||`Request failed with status ${fe}`)}const K=Object.create(null),ae=z=>{const ne=Z.res.headers[z];ne?K[z]=ne:z!==z.toLowerCase()&&ae(z.toLowerCase())};ae("Cache-Control"),ae("Content-Type"),k.writeHead(200,K);const x=await(0,t.streamToBuffer)(Z.stream);return void k.end(x.buffer)}async _handleRoot(O,k,P){const B=P.query[a.connectionTokenQueryName];if(typeof B=="string"){const W=Object.create(null);W["Set-Cookie"]=R.serialize(a.connectionTokenCookieName,B,{sameSite:"lax",maxAge:60*60*24*7});const L=Object.create(null);for(const $ in P.query)$!==a.connectionTokenQueryName&&(L[$]=P.query[$]);const Q=C.format({pathname:P.pathname,query:L});return W.Location=Q,k.writeHead(302,W),void k.end()}const Y=W=>{const L=O.headers[W];return Array.isArray(L)?L[0]:L},X=!this._environmentService.isBuilt&&this._environmentService.args["use-test-resolver"],re=X?"test+test":Y("x-original-host")||Y("x-forwarded-host")||O.headers.host;if(!re)return s(O,k,400,"Bad request.");function te(W){return JSON.stringify(W).replace(/"/g,"&quot;")}let Z;this._environmentService.args["enable-smoke-test-driver"]&&(Z=!1);const fe=W=>W&&v.URI.file(w.resolve(W)).with({scheme:a.Schemas.vscodeRemote,authority:re}),K=a.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,ae=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:(0,f.generateUuid)(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,x={embedderIdentifier:"server-distro",extensionsGallery:this._webExtensionResourceUrlTemplate&&this._productService.extensionsGallery?{...this._productService.extensionsGallery,resourceUrlTemplate:this._webExtensionResourceUrlTemplate.with({scheme:"http",authority:re,path:`${this._webExtensionRoute}/${this._webExtensionResourceUrlTemplate.authority}${this._webExtensionResourceUrlTemplate.path}`}).toString(!0)}:void 0};if(!this._environmentService.isBuilt)try{const W=JSON.parse((await r.Promises.readFile((0,E.join)(I,"product.overrides.json"))).toString());Object.assign(x,W)}catch{}const z={remoteAuthority:re,serverBasePath:this._basePath,_wrapWebWorkerExtHostInIframe:Z,developmentOptions:{enableSmokeTestDriver:this._environmentService.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this._logService.getLevel()},settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this._environmentService.args["disable-workspace-trust"],folderUri:fe(this._environmentService.args["default-folder"]),workspaceUri:fe(this._environmentService.args["default-workspace"]),productConfiguration:x,callbackRoute:this._callbackRoute},ne=this._productService.extensionsGallery?.nlsBaseUrl,le={WORKBENCH_WEB_CONFIGURATION:te(z),WORKBENCH_AUTH_SESSION:ae?te(ae):"",WORKBENCH_WEB_BASE_URL:this._staticRoute,WORKBENCH_NLS_BASE_URL:ne?`${ne}${ne.endsWith("/")?"":"/"}${this._productService.commit}/${this._productService.version}/`:""};if(X){const W=[];for(const L of["vscode-test-resolver","github-authentication"]){const Q=JSON.parse((await r.Promises.readFile(a.FileAccess.asFileUri(`${a.builtinExtensionsPath}/${L}/package.json`).fsPath)).toString());W.push({extensionPath:L,packageJSON:Q})}le.WORKBENCH_BUILTIN_EXTENSIONS=te(W)}let ve;try{ve=(await r.Promises.readFile(K)).toString().replace(/\{\{([^}]+)\}\}/g,(L,Q)=>le[Q]??"undefined")}catch{return k.writeHead(404,{"Content-Type":"text/plain"}),void k.end("Not found")}const J={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this._getScriptCspHashes(ve).join(" ")} 'sha256-75NYUUvf+5++1WbfCZOV3PSWxBhONpaxwx+mkOFRv/Y=' ${X?"":`http://${re}`};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this._connectionToken.type!==p.ServerConnectionTokenType.None&&(J["Set-Cookie"]=R.serialize(a.connectionTokenCookieName,this._connectionToken.value,{sameSite:"lax",maxAge:60*60*24*7})),k.writeHead(200,J),void k.end(ve)}_getScriptCspHashes(O){const k=/<script>([\s\S]+?)<\/script>/img,P=[];let B;for(;B=k.exec(O);){const Y=_.createHash("sha256"),X=B[1].replace(/\r\n/g,`
`),re=Y.update(Buffer.from(X)).digest().toString("base64");P.push(`'sha256-${re}'`)}return P}async _handleCallback(O){const k=a.FileAccess.asFileUri("vs/code/browser/workbench/callback.html").fsPath,P=(await r.Promises.readFile(k)).toString(),B=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this._getScriptCspHashes(P).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return O.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":B}),void O.end(P)}};e.WebClientServer=T,e.WebClientServer=T=ze([Me(3,d.IServerEnvironmentService),Me(4,y.ILogService),Me(5,S.IRequestService),Me(6,m.IProductService)],T)}),define(ye[297],Ie([1,0,5]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,i.createDecorator)("IExtHostInitDataService")}),define(ye[298],Ie([1,0,5]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,i.createDecorator)("IExtHostRpcService");class r{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.dispose=C.dispose.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=r}),define(ye[75],Ie([1,0,59]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=w;function r(C){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:C,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function w(C){return new i.URITransformer(r(C))}}),define(ye[299],Ie([1,0,3,44,4,75,59,115,274,9,101,20]),function(se,e,i,r,w,C,R,_,b,o,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0,i=Be(i),r=Be(r);class d{static{this._namePool=1}constructor(a,f,m,p){this._connectionToken=a,this._environmentService=f,this._userDataProfilesService=m,this._extensionHostStatusService=p}async call(a,f,m){switch(f){case"getEnvironmentData":{const p=m,S=(0,C.createURITransformer)(p.remoteAuthority);let g=await this._getEnvironmentData(p.profile);return g=(0,R.transformOutgoingURIs)(g,S),g}case"getExtensionHostExitInfo":{const p=m;return this._extensionHostStatusService.getExitInfo(p.reconnectionToken)}case"getDiagnosticInfo":{const p=m,S={machineInfo:(0,b.getMachineInfo)()},g=p.includeProcesses?(0,_.listProcesses)(process.pid):Promise.resolve();let v=[];const t={};if(p.folders){const l=(0,C.createURITransformer)("");v=p.folders.map(h=>w.URI.revive(l.transformIncoming(h))).filter(h=>h.scheme==="file").map(h=>(0,b.collectWorkspaceStats)(h.fsPath,["node_modules",".git"]).then(s=>{t[(0,o.basename)(h.fsPath)]=s}))}return Promise.all([g,...v]).then(([l,n])=>(S.processes=l||void 0,S.workspaceMetadata=p.folders?t:void 0,S))}}throw new Error(`IPC Command ${f} not found`)}listen(a,f,m){throw new Error("Not supported")}async _getEnvironmentData(a){a&&!this._userDataProfilesService.profiles.some(m=>m.id===a)&&await this._userDataProfilesService.createProfile(a,a);let f=!1;if(process.platform==="linux"){const m=process.glibcVersion;f=(m?parseInt(m.split(".")[1]):28)<=27}return{pid:process.pid,connectionToken:this._connectionToken.type!==D.ServerConnectionTokenType.None?this._connectionToken.value:"",appRoot:w.URI.file(this._environmentService.appRoot),settingsPath:this._environmentService.machineSettingsResource,logsPath:this._environmentService.logsHome,extensionHostLogsPath:(0,y.joinPath)(this._environmentService.logsHome,`exthost${d._namePool++}`),globalStorageHome:this._userDataProfilesService.defaultProfile.globalStorageHome,workspaceStorageHome:this._environmentService.workspaceStorageHome,localHistoryHome:this._environmentService.localHistoryHome,userHome:this._environmentService.userHome,os:i.OS,arch:process.arch,marks:r.getMarks(),useHostProxy:!!this._environmentService.args["use-host-proxy"],profiles:{home:this._userDataProfilesService.profilesHome,all:[...this._userDataProfilesService.profiles].map(m=>({...m}))},isUnsupportedGlibc:f}}}e.RemoteAgentEnvironmentChannel=d}),define(ye[300],Ie([1,0,4,75,72,9,259]),function(se,e,i,r,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class _ extends R.AbstractDiskFileSystemProviderChannel{constructor(D,y){super(new w.DiskFileSystemProvider(D),D),this.environmentService=y,this.uriTransformerCache=new Map,this._register(this.provider)}getUriTransformer(D){let y=this.uriTransformerCache.get(D.remoteAuthority);return y||(y=(0,r.createURITransformer)(D.remoteAuthority),this.uriTransformerCache.set(D.remoteAuthority,y)),y}transformIncoming(D,y,d=!1){if(d&&y.path==="/vscode-resource"&&y.query){const E=JSON.parse(y.query).requestResourcePath;return i.URI.from({scheme:"file",path:E})}return i.URI.revive(D.transformIncoming(y))}createSessionFileWatcher(D,y){return new b(D,y,this.logService,this.environmentService)}}e.RemoteAgentFileSystemProviderChannel=_;class b extends R.AbstractSessionFileWatcher{constructor(D,y,d,E){super(D,y,d,E)}getRecursiveWatcherOptions(D){const y=D.args["file-watcher-polling"];if(y){const d=y.split(C.delimiter),E=Number(d[0]);if(E>0)return{usePolling:d.length>1?d.slice(1):!0,pollingInterval:E}}}getExtraExcludes(D){if(D.extensionsPath)return[C.posix.join(D.extensionsPath,"**")]}}});var gt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ye[102],Ie([1,0,233,11,4,2,5,38,16,13,45,185,58]),function(se,e,i,r,w,C,R,_,b,o,D,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.EditorResourceAccessor=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.isEditorPaneWithSelection=f,e.isEditorPaneWithScrolling=m,e.findViewStateForEditor=p,e.isResourceEditorInput=S,e.isResourceDiffEditorInput=g,e.isResourceMultiDiffEditorInput=v,e.isResourceSideBySideEditorInput=t,e.isUntitledResourceEditorInput=l,e.isResourceMergeEditorInput=n,e.isEditorInput=T,e.isSideBySideEditorInput=O,e.isDiffEditorInput=k,e.createTooLargeFileError=P,e.isEditorInputWithOptions=B,e.isEditorInputWithOptionsAndGroup=Y,e.isEditorIdentifier=X,e.isEditorCommandsContext=re,e.preventEditorClose=x,e.pathsToEditors=le,e.isTextEditorViewState=H,e.isEditorOpenError=ce,e.createEditorOpenError=J,d=gt(d),e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,i.localize)(0,null),providerDisplayName:(0,i.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var E;(function(W){W[W.PROGRAMMATIC=1]="PROGRAMMATIC",W[W.USER=2]="USER",W[W.EDIT=3]="EDIT",W[W.NAVIGATION=4]="NAVIGATION",W[W.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var a;(function(W){W[W.IDENTICAL=1]="IDENTICAL",W[W.SIMILAR=2]="SIMILAR",W[W.DIFFERENT=3]="DIFFERENT"})(a||(e.EditorPaneSelectionCompareResult=a={}));function f(W){const L=W;return!!L&&typeof L.getSelection=="function"&&!!L.onDidChangeSelection}function m(W){const L=W;return!!L&&typeof L.getScrollPosition=="function"&&typeof L.setScrollPosition=="function"&&!!L.onDidChangeScroll}function p(W,L,Q){for(const $ of Q.visibleEditorPanes)if($.group.id===L&&W.matches($.input))return $.getViewState()}function S(W){if(T(W))return!1;const L=W;return w.URI.isUri(L?.resource)}function g(W){if(T(W))return!1;const L=W;return L?.original!==void 0&&L.modified!==void 0}function v(W){if(T(W))return!1;const L=W;return!L||L.resources&&!Array.isArray(L.resources)?!1:!!L.resources||!!L.multiDiffSource}function t(W){if(T(W)||g(W))return!1;const L=W;return L?.primary!==void 0&&L.secondary!==void 0}function l(W){if(T(W))return!1;const L=W;return L?L.resource===void 0||L.resource.scheme===o.Schemas.untitled||L.forceUntitled===!0:!1}function n(W){if(T(W))return!1;const L=W;return w.URI.isUri(L?.base?.resource)&&w.URI.isUri(L?.input1?.resource)&&w.URI.isUri(L?.input2?.resource)&&w.URI.isUri(L?.result?.resource)}var h;(function(W){W[W.SHORT=0]="SHORT",W[W.MEDIUM=1]="MEDIUM",W[W.LONG=2]="LONG"})(h||(e.Verbosity=h={}));var s;(function(W){W[W.EXPLICIT=1]="EXPLICIT",W[W.AUTO=2]="AUTO",W[W.FOCUS_CHANGE=3]="FOCUS_CHANGE",W[W.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class c{constructor(){this.mapIdToSaveSource=new Map}registerSource(L,Q){let $=this.mapIdToSaveSource.get(L);return $||($={source:L,label:Q},this.mapIdToSaveSource.set(L,$)),$.source}getSourceLabel(L){return this.mapIdToSaveSource.get(L)?.label??L}}e.SaveSourceRegistry=new c;var u;(function(W){W[W.None=0]="None",W[W.Readonly=2]="Readonly",W[W.Untitled=4]="Untitled",W[W.Singleton=8]="Singleton",W[W.RequiresTrust=16]="RequiresTrust",W[W.CanSplitInGroup=32]="CanSplitInGroup",W[W.ForceDescription=64]="ForceDescription",W[W.CanDropIntoEditor=128]="CanDropIntoEditor",W[W.MultipleEditors=256]="MultipleEditors",W[W.Scratchpad=512]="Scratchpad"})(u||(e.EditorInputCapabilities=u={}));class I extends C.Disposable{}e.AbstractEditorInput=I;function T(W){return W instanceof I}function A(W){const L=W;return w.URI.isUri(L?.preferredResource)}function O(W){const L=W;return T(L?.primary)&&T(L?.secondary)}function k(W){const L=W;return T(L?.modified)&&T(L?.original)}function P(W,L,Q,$,U){return J($,[(0,y.toAction)({id:"workbench.action.openLargeFile",label:(0,i.localize)(2,null),run:()=>{const q={...Q,limits:{size:Number.MAX_VALUE}};W.openEditor(L,q)}}),(0,y.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,i.localize)(3,null),run:()=>U.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:d.default.Warning})}function B(W){return T(W?.editor)}function Y(W){const L=W;return B(W)&&L?.group!==void 0}function X(W){const L=W;return typeof L?.groupId=="number"&&T(L.editor)}function re(W){return typeof W?.groupId=="number"}var te;(function(W){W[W.UNKNOWN=0]="UNKNOWN",W[W.REPLACE=1]="REPLACE",W[W.MOVE=2]="MOVE",W[W.UNPIN=3]="UNPIN"})(te||(e.EditorCloseContext=te={}));var Z;(function(W){W[W.GROUP_ACTIVE=0]="GROUP_ACTIVE",W[W.GROUP_INDEX=1]="GROUP_INDEX",W[W.GROUP_LABEL=2]="GROUP_LABEL",W[W.GROUP_LOCKED=3]="GROUP_LOCKED",W[W.EDITORS_SELECTION=4]="EDITORS_SELECTION",W[W.EDITOR_OPEN=5]="EDITOR_OPEN",W[W.EDITOR_CLOSE=6]="EDITOR_CLOSE",W[W.EDITOR_MOVE=7]="EDITOR_MOVE",W[W.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",W[W.EDITOR_LABEL=9]="EDITOR_LABEL",W[W.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",W[W.EDITOR_PIN=11]="EDITOR_PIN",W[W.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",W[W.EDITOR_STICKY=13]="EDITOR_STICKY",W[W.EDITOR_DIRTY=14]="EDITOR_DIRTY",W[W.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(Z||(e.GroupModelChangeKind=Z={}));var fe;(function(W){W[W.PRIMARY=1]="PRIMARY",W[W.SECONDARY=2]="SECONDARY",W[W.BOTH=3]="BOTH",W[W.ANY=4]="ANY"})(fe||(e.SideBySideEditor=fe={}));class K{getOriginalUri(L,Q){if(!L)return;if(n(L))return e.EditorResourceAccessor.getOriginalUri(L.result,Q);if(Q?.supportSideBySide){const{primary:U,secondary:q}=this.getSideEditors(L);if(U&&q){if(Q?.supportSideBySide===fe.BOTH)return{primary:this.getOriginalUri(U,{filterByScheme:Q.filterByScheme}),secondary:this.getOriginalUri(q,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===fe.ANY)return this.getOriginalUri(U,{filterByScheme:Q.filterByScheme})??this.getOriginalUri(q,{filterByScheme:Q.filterByScheme});L=Q.supportSideBySide===fe.PRIMARY?U:q}}if(g(L)||v(L)||t(L)||n(L))return;const $=A(L)?L.preferredResource:L.resource;return!$||!Q||!Q.filterByScheme?$:this.filterUri($,Q.filterByScheme)}getSideEditors(L){return O(L)||t(L)?{primary:L.primary,secondary:L.secondary}:k(L)||g(L)?{primary:L.modified,secondary:L.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(L,Q){if(!L)return;if(n(L))return e.EditorResourceAccessor.getCanonicalUri(L.result,Q);if(Q?.supportSideBySide){const{primary:U,secondary:q}=this.getSideEditors(L);if(U&&q){if(Q?.supportSideBySide===fe.BOTH)return{primary:this.getCanonicalUri(U,{filterByScheme:Q.filterByScheme}),secondary:this.getCanonicalUri(q,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===fe.ANY)return this.getCanonicalUri(U,{filterByScheme:Q.filterByScheme})??this.getCanonicalUri(q,{filterByScheme:Q.filterByScheme});L=Q.supportSideBySide===fe.PRIMARY?U:q}}if(g(L)||v(L)||t(L)||n(L))return;const $=L.resource;return!$||!Q||!Q.filterByScheme?$:this.filterUri($,Q.filterByScheme)}filterUri(L,Q){if(Array.isArray(Q)){if(Q.some($=>L.scheme===$))return L}else if(Q===L.scheme)return L}}var ae;(function(W){W[W.UNKNOWN=0]="UNKNOWN",W[W.KEYBOARD=1]="KEYBOARD",W[W.MOUSE=2]="MOUSE"})(ae||(e.EditorCloseMethod=ae={}));function x(W,L,Q,$){if(!W.isSticky(L))return!1;switch($.preventPinnedEditorClose){case"keyboardAndMouse":return Q===ae.MOUSE||Q===ae.KEYBOARD;case"mouse":return Q===ae.MOUSE;case"keyboard":return Q===ae.KEYBOARD}return!1}e.EditorResourceAccessor=new K;var z;(function(W){W[W.LEFT=0]="LEFT",W[W.RIGHT=1]="RIGHT"})(z||(e.CloseDirection=z={}));class ne{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(L){const Q=this.instantiationService=L.get(R.IInstantiationService);for(const[$,U]of this.editorSerializerConstructors)this.createEditorSerializer($,U,Q);this.editorSerializerConstructors.clear()}createEditorSerializer(L,Q,$){const U=$.createInstance(Q);this.editorSerializerInstances.set(L,U)}registerFileEditorFactory(L){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=L}getFileEditorFactory(){return(0,r.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(L,Q){if(this.editorSerializerConstructors.has(L)||this.editorSerializerInstances.has(L))throw new Error(`A editor serializer with type ID '${L}' was already registered.`);return this.instantiationService?this.createEditorSerializer(L,Q,this.instantiationService):this.editorSerializerConstructors.set(L,Q),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(L),this.editorSerializerInstances.delete(L)})}getEditorSerializer(L){return this.editorSerializerInstances.get(typeof L=="string"?L:L.typeId)}}_.Registry.add(e.EditorExtensions.EditorFactory,new ne);async function le(W,L,Q){return!W||!W.length?[]:await Promise.all(W.map(async $=>{const U=w.URI.revive($.fileUri);if(!U){Q.info("Cannot resolve the path because it is not valid.",$);return}if(!await L.canHandleResource(U)){Q.info("Cannot resolve the path because it cannot be handled",$);return}let G=$.exists,F=$.type;if(typeof G!="boolean"||typeof F!="number")try{F=(await L.stat(U)).isDirectory?b.FileType.Directory:b.FileType.Unknown,G=!0}catch(oe){Q.error(oe),G=!1}if(!G&&$.openOnlyIfExists){Q.info("Cannot resolve the path because it does not exist",$);return}if(F===b.FileType.Directory){Q.info("Cannot resolve the path because it is a directory",$);return}const V={...$.options,pinned:!0};return G?{resource:U,options:V}:{resource:U,options:V,forceUntitled:!0}}))}var ve;(function(W){W[W.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",W[W.SEQUENTIAL=1]="SEQUENTIAL"})(ve||(e.EditorsOrder=ve={}));function H(W){const L=W;if(!L)return!1;const Q=L;if(Q.modified)return H(Q.modified);const $=L;return!!($.contributionsState&&$.viewState&&Array.isArray($.cursorState))}function ce(W){return(0,D.isErrorWithActions)(W)}function J(W,L,Q){const $=(0,D.createErrorWithActions)(W,L);return $.forceMessage=Q?.forceMessage,$.forceSeverity=Q?.forceSeverity,$.allowDialog=Q?.allowDialog,$}}),define(ye[301],Ie([1,0,234,42]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_IN_QUICK_CHAT=e.CONTEXT_CHAT_LOCATION=e.CONTEXT_CHAT_INPUT_HAS_AGENT=e.CONTEXT_CHAT_INPUT_CURSOR_AT_TOP=e.CONTEXT_CHAT_ENABLED=e.CONTEXT_IN_CHAT_SESSION=e.CONTEXT_IN_CHAT_INPUT=e.CONTEXT_CHAT_INPUT_HAS_FOCUS=e.CONTEXT_CHAT_INPUT_HAS_TEXT=e.CONTEXT_CHAT_EDIT_APPLIED=e.CONTEXT_REQUEST=e.CONTEXT_RESPONSE=e.CONTEXT_CHAT_REQUEST_IN_PROGRESS=e.CONTEXT_RESPONSE_FILTERED=e.CONTEXT_CHAT_RESPONSE_SUPPORT_ISSUE_REPORTING=e.CONTEXT_RESPONSE_DETECTED_AGENT_COMMAND=e.CONTEXT_RESPONSE_VOTE=void 0,e.CONTEXT_RESPONSE_VOTE=new r.RawContextKey("chatSessionResponseVote","",{type:"string",description:(0,i.localize)(0,null)}),e.CONTEXT_RESPONSE_DETECTED_AGENT_COMMAND=new r.RawContextKey("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,i.localize)(1,null)}),e.CONTEXT_CHAT_RESPONSE_SUPPORT_ISSUE_REPORTING=new r.RawContextKey("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,i.localize)(2,null)}),e.CONTEXT_RESPONSE_FILTERED=new r.RawContextKey("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,i.localize)(3,null)}),e.CONTEXT_CHAT_REQUEST_IN_PROGRESS=new r.RawContextKey("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,i.localize)(4,null)}),e.CONTEXT_RESPONSE=new r.RawContextKey("chatResponse",!1,{type:"boolean",description:(0,i.localize)(5,null)}),e.CONTEXT_REQUEST=new r.RawContextKey("chatRequest",!1,{type:"boolean",description:(0,i.localize)(6,null)}),e.CONTEXT_CHAT_EDIT_APPLIED=new r.RawContextKey("chatEditApplied",!1,{type:"boolean",description:(0,i.localize)(7,null)}),e.CONTEXT_CHAT_INPUT_HAS_TEXT=new r.RawContextKey("chatInputHasText",!1,{type:"boolean",description:(0,i.localize)(8,null)}),e.CONTEXT_CHAT_INPUT_HAS_FOCUS=new r.RawContextKey("chatInputHasFocus",!1,{type:"boolean",description:(0,i.localize)(9,null)}),e.CONTEXT_IN_CHAT_INPUT=new r.RawContextKey("inChatInput",!1,{type:"boolean",description:(0,i.localize)(10,null)}),e.CONTEXT_IN_CHAT_SESSION=new r.RawContextKey("inChat",!1,{type:"boolean",description:(0,i.localize)(11,null)}),e.CONTEXT_CHAT_ENABLED=new r.RawContextKey("chatIsEnabled",!1,{type:"boolean",description:(0,i.localize)(12,null)}),e.CONTEXT_CHAT_INPUT_CURSOR_AT_TOP=new r.RawContextKey("chatCursorAtTop",!1),e.CONTEXT_CHAT_INPUT_HAS_AGENT=new r.RawContextKey("chatInputHasAgent",!1),e.CONTEXT_CHAT_LOCATION=new r.RawContextKey("chatLocation",void 0),e.CONTEXT_IN_QUICK_CHAT=new r.RawContextKey("quickChatHasFocus",!1,{type:"boolean",description:(0,i.localize)(13,null)})}),define(ye[302],Ie([1,0,105,14,19,6,40,2,50,166,17,42,22,5,12,29,47,100,301]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a,f,m,p,S){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.ChatAgentNameService=e.IChatAgentNameService=e.MergedChatAgent=e.ChatAgentService=e.IChatAgentService=e.ChatAgentLocation=void 0,e.getFullyQualifiedId=h,e.reviveSerializedAgent=s;var v;(function(c){c.Panel="panel",c.Terminal="terminal",c.Notebook="notebook",c.Editor="editor"})(v||(e.ChatAgentLocation=v={})),function(c){function u(I){switch(I){case"panel":return c.Panel;case"terminal":return c.Terminal;case"notebook":return c.Notebook;case"editor":return c.Editor}return c.Panel}c.fromRaw=u}(v||(e.ChatAgentLocation=v={})),e.IChatAgentService=(0,E.createDecorator)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(u){this.contextKeyService=u,this._agents=new Map,this._onDidChangeAgents=new C.Emitter,this.onDidChangeAgents=this._onDidChangeAgents.event,this._agentCompletionProviders=new Map,this._hasDefaultAgent=S.CONTEXT_CHAT_ENABLED.bindTo(this.contextKeyService)}registerAgent(u,I){if(this.getAgent(u))throw new Error(`Agent already registered: ${JSON.stringify(u)}`);const A=this,O=I.slashCommands;I={...I,get slashCommands(){return O.filter(P=>!P.when||A.contextKeyService.contextMatchesRules(y.ContextKeyExpr.deserialize(P.when)))}};const k={data:I};return this._agents.set(u,k),(0,_.toDisposable)(()=>{this._agents.delete(u),this._onDidChangeAgents.fire(void 0)})}registerAgentImplementation(u,I){const T=this._agents.get(u);if(!T)throw new Error(`Unknown agent: ${JSON.stringify(u)}`);if(T.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(u)}`);return T.data.isDefault&&this._hasDefaultAgent.set(!0),T.impl=I,this._onDidChangeAgents.fire(new l(T.data,I)),(0,_.toDisposable)(()=>{T.impl=void 0,this._onDidChangeAgents.fire(void 0),T.data.isDefault&&this._hasDefaultAgent.set(!1)})}registerDynamicAgent(u,I){u.isDynamic=!0;const T={data:u,impl:I};return this._agents.set(u.id,T),this._onDidChangeAgents.fire(new l(u,I)),(0,_.toDisposable)(()=>{this._agents.delete(u.id),this._onDidChangeAgents.fire(void 0)})}registerAgentCompletionProvider(u,I){return this._agentCompletionProviders.set(u,I),{dispose:()=>{this._agentCompletionProviders.delete(u)}}}async getAgentCompletionItems(u,I,T){return await this._agentCompletionProviders.get(u)?.(I,T)??[]}updateAgent(u,I){const T=this._agents.get(u);if(!T?.impl)throw new Error(`No activated agent with id ${JSON.stringify(u)} registered`);T.data.metadata={...T.data.metadata,...I},this._onDidChangeAgents.fire(new l(T.data,T.impl))}getDefaultAgent(u){return(0,i.findLast)(this.getActivatedAgents(),I=>!!I.isDefault&&I.locations.includes(u))}getContributedDefaultAgent(u){return this.getAgents().find(I=>!!I.isDefault&&I.locations.includes(u))}getSecondaryAgent(){return R.Iterable.find(this._agents.values(),u=>!!u.data.metadata.isSecondary)?.data}getAgent(u){if(this._agentIsEnabled(u))return this._agents.get(u)?.data}_agentIsEnabled(u){const I=this._agents.get(u);return!I?.data.when||this.contextKeyService.contextMatchesRules(y.ContextKeyExpr.deserialize(I.data.when))}getAgentByFullyQualifiedId(u){const I=R.Iterable.find(this._agents.values(),T=>h(T.data)===u)?.data;if(!(I&&!this._agentIsEnabled(I.id)))return I}getAgents(){return Array.from(this._agents.values()).map(u=>u.data).filter(u=>this._agentIsEnabled(u.id))}getActivatedAgents(){return Array.from(this._agents.values()).filter(u=>!!u.impl).filter(u=>this._agentIsEnabled(u.data.id)).map(u=>new l(u.data,u.impl))}getAgentsByName(u){return this.getAgents().filter(I=>I.name===u)}agentHasDupeName(u){const I=this.getAgent(u);return I?this.getAgentsByName(I.name).filter(T=>T.extensionId.value!==I.extensionId.value).length>0:!1}async invokeAgent(u,I,T,A,O){const k=this._agents.get(u);if(!k?.impl)throw new Error(`No activated agent with id "${u}"`);return await k.impl.invoke(I,T,A,O)}async getFollowups(u,I,T,A,O){const k=this._agents.get(u);if(!k?.impl)throw new Error(`No activated agent with id "${u}"`);return k.impl?.provideFollowups?k.impl.provideFollowups(I,T,A,O):[]}};e.ChatAgentService=t,e.ChatAgentService=t=ze([Me(0,y.IContextKeyService)],t);class l{constructor(u,I){this.data=u,this.impl=I}get id(){return this.data.id}get name(){return this.data.name??""}get fullName(){return this.data.fullName??""}get description(){return this.data.description??""}get extensionId(){return this.data.extensionId}get extensionPublisherId(){return this.data.extensionPublisherId}get extensionPublisherDisplayName(){return this.data.publisherDisplayName}get extensionDisplayName(){return this.data.extensionDisplayName}get isDefault(){return this.data.isDefault}get metadata(){return this.data.metadata}get slashCommands(){return this.data.slashCommands}get defaultImplicitVariables(){return this.data.defaultImplicitVariables}get locations(){return this.data.locations}async invoke(u,I,T,A){return this.impl.invoke(u,I,T,A)}async provideFollowups(u,I,T,A){return this.impl.provideFollowups?this.impl.provideFollowups(u,I,T,A):[]}provideWelcomeMessage(u,I){if(this.impl.provideWelcomeMessage)return this.impl.provideWelcomeMessage(u,I)}provideSampleQuestions(u,I){if(this.impl.provideSampleQuestions)return this.impl.provideSampleQuestions(u,I)}}e.MergedChatAgent=l,e.IChatAgentNameService=(0,E.createDecorator)("chatAgentNameService");let n=class{static{g=this}static{this.StorageKey="chat.participantNameRegistry"}constructor(u,I,T,A){if(this.requestService=I,this.logService=T,this.storageService=A,this.registry=(0,o.observableValue)(this,Object.create(null)),this.disposed=!1,!u.chatParticipantRegistry)return;this.url=u.chatParticipantRegistry;const O=A.get(g.StorageKey,p.StorageScope.APPLICATION);try{this.registry.set(JSON.parse(O??"{}"),void 0)}catch{A.remove(g.StorageKey,p.StorageScope.APPLICATION)}this.refresh()}refresh(){this.disposed||this.update().catch(u=>this.logService.warn("Failed to fetch chat participant registry",u)).then(()=>(0,r.timeout)(5*60*1e3)).then(()=>this.refresh())}async update(){const u=await this.requestService.request({type:"GET",url:this.url},w.CancellationToken.None);if(u.res.statusCode!==200)throw new Error("Could not get extensions report.");const I=await(0,m.asJson)(u);if(!I||I.version!==1)throw new Error("Unexpected chat participant registry response.");const T=I.restrictedChatParticipants;this.registry.set(T,void 0),this.storageService.store(g.StorageKey,JSON.stringify(T),p.StorageScope.APPLICATION,p.StorageTarget.MACHINE)}getAgentNameRestriction(u){const I=this.checkAgentNameRestriction(u.name,u).get(),T=!u.fullName||this.checkAgentNameRestriction(u.fullName.replace(/\s/g,""),u).get();return I&&T}checkAgentNameRestriction(u,I){return this.registry.map(A=>A[u.toLowerCase()]).map(A=>A?A.some(O=>(0,D.equalsIgnoreCase)(O,O.includes(".")?I.extensionId.value:I.extensionPublisherId)):!0)}dispose(){this.disposed=!0}};e.ChatAgentNameService=n,e.ChatAgentNameService=n=g=ze([Me(0,f.IProductService),Me(1,m.IRequestService),Me(2,a.ILogService),Me(3,p.IStorageService)],n);function h(c){return`${c.extensionId.value}.${c.id}`}function s(c){const u="name"in c?c:{...c,name:c.id};return"extensionPublisherId"in u||(u.extensionPublisherId=u.extensionPublisher??""),"extensionDisplayName"in u||(u.extensionDisplayName=""),"extensionId"in u||(u.extensionId=new d.ExtensionIdentifier("")),(0,b.revive)(u)}}),define(ye[303],Ie([1,0,4,236,42,5]),function(se,e,i,r,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_EXTENSIONID=e.CONTEXT_VARIABLE_LANGUAGE=e.CONTEXT_VARIABLE_NAME=e.CONTEXT_VARIABLE_INTERFACES=e.CONTEXT_VARIABLE_TYPE=e.CONTEXT_VARIABLE_VALUE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_HAS_MODES=e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.getStateLabel=b,e.isFrameDeemphasized=D,r=Be(r),e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new w.RawContextKey("debugType",void 0,{type:"string",description:r.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new w.RawContextKey("debugConfigurationType",void 0,{type:"string",description:r.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new w.RawContextKey("debugState","inactive",{type:"string",description:r.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new w.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:r.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new w.RawContextKey("hasDebugged",!1,{type:"boolean",description:r.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new w.RawContextKey("inDebugMode",!1,{type:"boolean",description:r.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new w.RawContextKey("inDebugRepl",!1,{type:"boolean",description:r.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new w.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:r.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new w.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:r.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new w.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:r.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new w.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:r.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new w.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:r.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new w.RawContextKey("variablesFocused",!0,{type:"boolean",description:r.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new w.RawContextKey("expressionSelected",!1,{type:"boolean",description:r.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new w.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:r.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new w.RawContextKey("callStackItemType",void 0,{type:"string",description:r.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new w.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:r.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new w.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:r.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new w.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:r.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new w.RawContextKey("watchItemType",void 0,{type:"string",description:r.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new w.RawContextKey("canViewMemory",void 0,{type:"boolean",description:r.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new w.RawContextKey("breakpointItemType",void 0,{type:"string",description:r.localize(21,null)}),e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=new w.RawContextKey("breakpointItemBytes",void 0,{type:"boolean",description:r.localize(22,null)}),e.CONTEXT_BREAKPOINT_HAS_MODES=new w.RawContextKey("breakpointHasModes",!1,{type:"boolean",description:r.localize(23,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new w.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:r.localize(24,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new w.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:r.localize(25,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new w.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:r.localize(26,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new w.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:r.localize(27,null)}),e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=new w.RawContextKey("focusedSessionIsNoDebug",!1,{type:"boolean",description:r.localize(28,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new w.RawContextKey("stepBackSupported",!1,{type:"boolean",description:r.localize(29,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new w.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:r.localize(30,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new w.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:r.localize(31,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new w.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:r.localize(32,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new w.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:r.localize(33,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new w.RawContextKey("breakpointsExist",!1,{type:"boolean",description:r.localize(34,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new w.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:r.localize(35,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new w.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:r.localize(36,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new w.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:r.localize(37,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new w.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:r.localize(38,null)}),e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=new w.RawContextKey("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:r.localize(39,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new w.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:r.localize(40,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new w.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:r.localize(41,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new w.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:r.localize(42,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new w.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:r.localize(43,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new w.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:r.localize(44,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new w.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:r.localize(45,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new w.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:r.localize(46,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new w.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:r.localize(47,null)}),e.CONTEXT_VARIABLE_VALUE=new w.RawContextKey("variableValue",!1,{type:"string",description:r.localize(48,null)}),e.CONTEXT_VARIABLE_TYPE=new w.RawContextKey("variableType",!1,{type:"string",description:r.localize(49,null)}),e.CONTEXT_VARIABLE_INTERFACES=new w.RawContextKey("variableInterfaces",!1,{type:"array",description:r.localize(50,null)}),e.CONTEXT_VARIABLE_NAME=new w.RawContextKey("variableName",!1,{type:"string",description:r.localize(51,null)}),e.CONTEXT_VARIABLE_LANGUAGE=new w.RawContextKey("variableLanguage",!1,{type:"string",description:r.localize(52,null)}),e.CONTEXT_VARIABLE_EXTENSIONID=new w.RawContextKey("variableExtensionId",!1,{type:"string",description:r.localize(53,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new w.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:r.localize(54,null)}),e.CONTEXT_MULTI_SESSION_REPL=new w.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:r.localize(55,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new w.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:r.localize(56,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new w.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:r.localize(57,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new w.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:r.localize(58,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new w.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:r.localize(59,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new w.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:r.localize(60,null)});const R=g=>r.localize(61,null,g);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:r.localize(62,null)};var _;(function(g){g[g.Inactive=0]="Inactive",g[g.Initializing=1]="Initializing",g[g.Stopped=2]="Stopped",g[g.Running=3]="Running"})(_||(e.State=_={}));function b(g){switch(g){case _.Initializing:return"initializing";case _.Stopped:return"stopped";case _.Running:return"running";default:return"inactive"}}var o;(function(g){g[g.Valid=0]="Valid",g[g.Unreadable=1]="Unreadable",g[g.Error=2]="Error"})(o||(e.MemoryRangeType=o={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";function D(g){const v=g.presentationHint??g.source.presentationHint;return v==="deemphasize"||v==="subtle"}var y;(function(g){g[g.Variable=0]="Variable",g[g.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var d;(function(g){g[g.Initial=1]="Initial",g[g.Dynamic=2]="Dynamic"})(d||(e.DebugConfigurationProviderTriggerKind=d={}));var E;(function(g){g.UnverifiedBreakpoints="unverifiedBreakpoints"})(E||(e.DebuggerString=E={})),e.IDebugService=(0,C.createDecorator)("debugService");var a;(function(g){g[g.CONDITION=0]="CONDITION",g[g.HIT_COUNT=1]="HIT_COUNT",g[g.LOG_MESSAGE=2]="LOG_MESSAGE",g[g.TRIGGER_POINT=3]="TRIGGER_POINT"})(a||(e.BreakpointWidgetContext=a={}));var f;(function(g){g[g.Command=0]="Command",g[g.Tree=1]="Tree"})(f||(e.DebugVisualizationType=f={}));var m;(function(g){g[g.None=0]="None",g[g.Collapsed=1]="Collapsed",g[g.Expanded=2]="Expanded"})(m||(e.DebugTreeItemCollapsibleState=m={}));var p;(function(g){g.deserialize=v=>v,g.serialize=v=>v})(p||(e.IDebugVisualizationTreeItem=p={}));var S;(function(g){g.deserialize=v=>({id:v.id,name:v.name,iconPath:v.iconPath&&{light:i.URI.revive(v.iconPath.light),dark:i.URI.revive(v.iconPath.dark)},iconClass:v.iconClass,visualization:v.visualization}),g.serialize=v=>v})(S||(e.IDebugVisualization=S={}))}),define(ye[304],Ie([1,0,5]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,i.createDecorator)("environmentVariableService")}),define(ye[146],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelRequest=e.RemoteTerminalChannelEvent=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";var i;(function(w){w.OnPtyHostExitEvent="$onPtyHostExitEvent",w.OnPtyHostStartEvent="$onPtyHostStartEvent",w.OnPtyHostUnresponsiveEvent="$onPtyHostUnresponsiveEvent",w.OnPtyHostResponsiveEvent="$onPtyHostResponsiveEvent",w.OnPtyHostRequestResolveVariablesEvent="$onPtyHostRequestResolveVariablesEvent",w.OnProcessDataEvent="$onProcessDataEvent",w.OnProcessReadyEvent="$onProcessReadyEvent",w.OnProcessExitEvent="$onProcessExitEvent",w.OnProcessReplayEvent="$onProcessReplayEvent",w.OnProcessOrphanQuestion="$onProcessOrphanQuestion",w.OnExecuteCommand="$onExecuteCommand",w.OnDidRequestDetach="$onDidRequestDetach",w.OnDidChangeProperty="$onDidChangeProperty"})(i||(e.RemoteTerminalChannelEvent=i={}));var r;(function(w){w.RestartPtyHost="$restartPtyHost",w.CreateProcess="$createProcess",w.AttachToProcess="$attachToProcess",w.DetachFromProcess="$detachFromProcess",w.ListProcesses="$listProcesses",w.GetLatency="$getLatency",w.GetPerformanceMarks="$getPerformanceMarks",w.OrphanQuestionReply="$orphanQuestionReply",w.AcceptPtyHostResolvedVariables="$acceptPtyHostResolvedVariables",w.Start="$start",w.Input="$input",w.AcknowledgeDataEvent="$acknowledgeDataEvent",w.Shutdown="$shutdown",w.Resize="$resize",w.ClearBuffer="$clearBuffer",w.GetInitialCwd="$getInitialCwd",w.GetCwd="$getCwd",w.ProcessBinary="$processBinary",w.SendCommandResult="$sendCommandResult",w.InstallAutoReply="$installAutoReply",w.UninstallAllAutoReplies="$uninstallAllAutoReplies",w.GetDefaultSystemShell="$getDefaultSystemShell",w.GetProfiles="$getProfiles",w.GetEnvironment="$getEnvironment",w.GetWslPath="$getWslPath",w.GetTerminalLayoutInfo="$getTerminalLayoutInfo",w.SetTerminalLayoutInfo="$setTerminalLayoutInfo",w.SerializeTerminalState="$serializeTerminalState",w.ReviveTerminalProcesses="$reviveTerminalProcesses",w.GetRevivedPtyNewId="$getRevivedPtyNewId",w.SetUnicodeVersion="$setUnicodeVersion",w.ReduceConnectionGraceTime="$reduceConnectionGraceTime",w.UpdateIcon="$updateIcon",w.UpdateTitle="$updateTitle",w.UpdateProperty="$updateProperty",w.RefreshProperty="$refreshProperty",w.RequestDetachInstance="$requestDetachInstance",w.AcceptDetachInstanceReply="$acceptDetachInstanceReply",w.AcceptDetachedInstance="$acceptDetachedInstance",w.FreePortKillProcess="$freePortKillProcess"})(r||(e.RemoteTerminalChannelRequest=r={}))}),define(ye[305],Ie([1,0,9,4,69,53,3,136,11]),function(se,e,i,r,w,C,R,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mergeEnvironments=o,e.addTerminalEnvironmentKeys=y,e.shouldSetLangEnvVariable=a,e.getLangEnvVariable=f,e.getCwd=m,e.createVariableResolver=S,e.createTerminalEnvironment=g,e.preparePathForShell=v,e.getWorkspaceForTerminal=t,i=Be(i);function o(l,n){if(n)if(R.isWindows)for(const h in n){let s=h;for(const u in l)if(h.toLowerCase()===u.toLowerCase()){s=u;break}const c=n[h];c!==void 0&&D(l,s,c)}else Object.keys(n).forEach(h=>{const s=n[h];s!==void 0&&D(l,h,s)})}function D(l,n,h){typeof h=="string"?l[n]=h:delete l[n]}function y(l,n,h,s){l.TERM_PROGRAM="vscode",n&&(l.TERM_PROGRAM_VERSION=n),a(l,s)&&(l.LANG=f(h)),l.COLORTERM="truecolor"}function d(l,n){if(n)for(const h of Object.keys(n)){const s=n[h];s!=null&&(l[h]=s)}}async function E(l,n){return await Promise.all(Object.entries(n).map(async([h,s])=>{if(typeof s=="string")try{n[h]=await l(s)}catch{n[h]=s}})),n}function a(l,n){if(n==="on")return!0;if(n==="auto"){const h=l.LANG;return!h||h.search(/\.UTF\-8$/)===-1&&h.search(/\.utf8$/)===-1&&h.search(/\.euc.+/)===-1}return!1}function f(l){const n=l?l.split("-"):[],h=n.length;if(h===0)return"en_US.UTF-8";if(h===1){const s={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};n[0]in s&&n.push(s[n[0]])}else n[1]=n[1].toUpperCase();return n.join("_")+".UTF-8"}async function m(l,n,h,s,c,u){if(l.cwd){const T=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,A=await p(T,h);return(0,_.sanitizeCwd)(A||T)}let I;return!l.ignoreConfigurationCwd&&c&&(h&&(c=await p(c,h,u)),c&&(i.isAbsolute(c)?I=c:s&&(I=i.join(s.fsPath,c)))),I||(I=s?s.fsPath:n||""),(0,_.sanitizeCwd)(I)}async function p(l,n,h){if(n)try{return await n(l)}catch(s){h?.error("Could not resolve terminal cwd",s);return}return l}function S(l,n,h){if(h)return s=>h.resolveWithEnvironment(n,l,s)}async function g(l,n,h,s,c,u){const I={};if(l.strictEnv)d(I,l.env);else{d(I,u);const T={...n};h&&(T&&await E(h,T),l.env&&await E(h,l.env)),R.isMacintosh&&(I.VSCODE_NODE_OPTIONS&&(I.NODE_OPTIONS=I.VSCODE_NODE_OPTIONS,delete I.VSCODE_NODE_OPTIONS),I.VSCODE_NODE_REPL_EXTERNAL_MODULE&&(I.NODE_REPL_EXTERNAL_MODULE=I.VSCODE_NODE_REPL_EXTERNAL_MODULE,delete I.VSCODE_NODE_REPL_EXTERNAL_MODULE)),(0,w.sanitizeProcessEnvironment)(I,"VSCODE_IPC_HOOK_CLI"),o(I,T),o(I,l.env),y(I,s,R.language,c)}return I}async function v(l,n,h,s,c,u,I=R.isWindows){let T;if((0,b.isString)(l)?T=l:(T=l.fsPath,I&&u!==R.OperatingSystem.Windows?T=T.replace(/\\/g,"/"):!I&&u===R.OperatingSystem.Windows&&(T=T.replace(/\//g,"\\"))),!n)return T;const A=T.includes(" "),O=T.includes("(")||T.includes(")"),k=i.basename(n,".exe"),P=k==="pwsh"||h==="pwsh"||k==="powershell"||h==="powershell";if(P&&(A||T.includes("'")))return`& '${T.replace(/'/g,"''")}'`;if(O&&P)return`& '${T}'`;if(u===R.OperatingSystem.Windows){if(s!==void 0)return s===C.WindowsShellType.GitBash?(0,_.escapeNonWindowsPath)(T.replace(/\\/g,"/")):s===C.WindowsShellType.Wsl?c?.getWslPath(T,"win-to-unix")||T:A?`"${T}"`:T;const B=n.toLowerCase();return B.includes("wsl")||B.includes("bash.exe")&&!B.toLowerCase().includes("git")?c?.getWslPath(T,"win-to-unix")||T:A?`"${T}"`:T}return(0,_.escapeNonWindowsPath)(T)}function t(l,n,h){const s=typeof l=="string"?r.URI.parse(l):l;let c=s?n.getWorkspaceFolder(s)??void 0:void 0;if(!c){const u=h.getLastActiveWorkspaceRoot();c=u?n.getWorkspaceFolder(u)??void 0:void 0}return c}}),define(ye[76],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var i;(function(C){C.Delimiter="\0"})(i||(e.TestIdPathParts=i={}));var r;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(r||(e.TestPosition=r={}));class w{static fromExtHostTestItem(R,_,b=R.parent){if(R._isRoot)return new w([_]);const o=[R.id];for(let D=b;D&&D.id!==_;D=D.parent)o.push(D.id);return o.push(_),new w(o.reverse())}static isRoot(R){return!R.includes(i.Delimiter)}static root(R){const _=R.indexOf(i.Delimiter);return _===-1?R:R.slice(0,_)}static fromString(R){return new w(R.split(i.Delimiter))}static join(R,_){return new w([...R.path,_])}static joinToString(R,_){return R.toString()+i.Delimiter+_}static parentId(R){const _=R.lastIndexOf(i.Delimiter);return _===-1?void 0:R.slice(0,_)}static localId(R){const _=R.lastIndexOf(i.Delimiter);return _===-1?R:R.slice(_+i.Delimiter.length)}static isChild(R,_){return _.startsWith(R)&&_[R.length]===i.Delimiter}static compare(R,_){return R===_?r.IsSame:w.isChild(R,_)?r.IsChild:w.isChild(_,R)?r.IsParent:r.Disconnected}static getLengthOfCommonPrefix(R,_){if(R===0)return 0;let b=0;for(;b<R-1;){for(let o=1;o<R;o++){const D=_(o-1),y=_(o);if(D.path[b]!==y.path[b])return b}b++}return b}constructor(R,_=R.length){if(this.path=R,this.viewEnd=_,R.length===0||_<1)throw new Error("cannot create test with empty path")}get rootId(){return new w(this.path,1)}get parentId(){return this.viewEnd>1?new w(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let R=1;R<=this.viewEnd;R++)yield new w(this.path,R)}*idsToRoot(){for(let R=this.viewEnd;R>0;R--)yield new w(this.path,R)}compare(R){if(typeof R=="string")return w.compare(this.toString(),R);for(let _=0;_<R.viewEnd&&_<this.viewEnd;_++)if(R.path[_]!==this.path[_])return r.Disconnected;return R.viewEnd>this.viewEnd?r.IsChild:R.viewEnd<this.viewEnd?r.IsParent:r.IsSame}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let R=1;R<this.viewEnd;R++)this.stringifed+=i.Delimiter,this.stringifed+=this.path[R]}return this.stringifed}}e.TestId=w}),define(ye[103],Ie([1,0,4,85,49,76]),function(se,e,i,r,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.KEEP_N_LAST_COVERAGE_REPORTS=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.testResultStateToContextValues=e.TestResultState=void 0;var R;(function(te){te[te.Unset=0]="Unset",te[te.Queued=1]="Queued",te[te.Running=2]="Running",te[te.Passed=3]="Passed",te[te.Failed=4]="Failed",te[te.Skipped=5]="Skipped",te[te.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.testResultStateToContextValues={[R.Unset]:"unset",[R.Queued]:"queued",[R.Running]:"running",[R.Passed]:"passed",[R.Failed]:"failed",[R.Skipped]:"skipped",[R.Errored]:"errored"};var _;(function(te){te[te.Run=1]="Run",te[te.Debug=2]="Debug",te[te.Coverage=3]="Coverage"})(_||(e.ExtTestRunProfileKind=_={}));var b;(function(te){te[te.Run=2]="Run",te[te.Debug=4]="Debug",te[te.Coverage=8]="Coverage",te[te.HasNonDefaultProfile=16]="HasNonDefaultProfile",te[te.HasConfigurable=32]="HasConfigurable",te[te.SupportsContinuousRun=64]="SupportsContinuousRun"})(b||(e.TestRunProfileBitset=b={})),e.testRunProfileBitsetList=[b.Run,b.Debug,b.Coverage,b.HasNonDefaultProfile,b.HasConfigurable,b.SupportsContinuousRun];const o=te=>"runId"in te;e.isStartControllerTests=o;var D;(function(te){te.serialize=Z=>({range:Z.range.toJSON(),uri:Z.uri.toJSON()}),te.deserialize=(Z,fe)=>({range:w.Range.lift(fe.range),uri:Z.asCanonicalUri(i.URI.revive(fe.uri))})})(D||(e.IRichLocation=D={}));var y;(function(te){te[te.Error=0]="Error",te[te.Output=1]="Output"})(y||(e.TestMessageType=y={}));var d;(function(te){te.serialize=Z=>({message:Z.message,type:y.Error,expected:Z.expected,actual:Z.actual,contextValue:Z.contextValue,location:Z.location&&D.serialize(Z.location)}),te.deserialize=(Z,fe)=>({message:fe.message,type:y.Error,expected:fe.expected,actual:fe.actual,contextValue:fe.contextValue,location:fe.location&&D.deserialize(Z,fe.location)})})(d||(e.ITestErrorMessage=d={}));const E=(te,Z)=>`${Z?"s":"e"}${te}`;e.getMarkId=E;var a;(function(te){te.serialize=Z=>({message:Z.message,type:y.Output,offset:Z.offset,length:Z.length,location:Z.location&&D.serialize(Z.location)}),te.deserialize=(Z,fe)=>({message:fe.message,type:y.Output,offset:fe.offset,length:fe.length,location:fe.location&&D.deserialize(Z,fe.location)})})(a||(e.ITestOutputMessage=a={}));var f;(function(te){te.serialize=Z=>Z.type===y.Error?d.serialize(Z):a.serialize(Z),te.deserialize=(Z,fe)=>fe.type===y.Error?d.deserialize(Z,fe):a.deserialize(Z,fe)})(f||(e.ITestMessage=f={}));var m;(function(te){te.serializeWithoutMessages=Z=>({state:Z.state,duration:Z.duration,messages:[]}),te.serialize=Z=>({state:Z.state,duration:Z.duration,messages:Z.messages.map(f.serialize)}),te.deserialize=(Z,fe)=>({state:fe.state,duration:fe.duration,messages:fe.messages.map(K=>f.deserialize(Z,K))})})(m||(e.ITestTaskState=m={}));const p="\0",S=(te,Z)=>te+p+Z;e.namespaceTestTag=S;const g=te=>{const Z=te.indexOf(p);return{ctrlId:te.slice(0,Z),tagId:te.slice(Z+1)}};e.denamespaceTestTag=g;var v;(function(te){te.serialize=Z=>({extId:Z.extId,label:Z.label,tags:Z.tags,busy:Z.busy,children:void 0,uri:Z.uri?.toJSON(),range:Z.range?.toJSON()||null,description:Z.description,error:Z.error,sortText:Z.sortText}),te.deserialize=(Z,fe)=>({extId:fe.extId,label:fe.label,tags:fe.tags,busy:fe.busy,children:void 0,uri:fe.uri?Z.asCanonicalUri(i.URI.revive(fe.uri)):void 0,range:fe.range?w.Range.lift(fe.range):null,description:fe.description,error:fe.error,sortText:fe.sortText})})(v||(e.ITestItem=v={}));var t;(function(te){te[te.NotExpandable=0]="NotExpandable",te[te.Expandable=1]="Expandable",te[te.BusyExpanding=2]="BusyExpanding",te[te.Expanded=3]="Expanded"})(t||(e.TestItemExpandState=t={}));var l;(function(te){te.serialize=Z=>({expand:Z.expand,item:v.serialize(Z.item)}),te.deserialize=(Z,fe)=>({controllerId:C.TestId.root(fe.item.extId),expand:fe.expand,item:v.deserialize(Z,fe.item)})})(l||(e.InternalTestItem=l={}));var n;(function(te){te.serialize=Z=>{let fe;return Z.item&&(fe={},Z.item.label!==void 0&&(fe.label=Z.item.label),Z.item.tags!==void 0&&(fe.tags=Z.item.tags),Z.item.busy!==void 0&&(fe.busy=Z.item.busy),Z.item.uri!==void 0&&(fe.uri=Z.item.uri?.toJSON()),Z.item.range!==void 0&&(fe.range=Z.item.range?.toJSON()),Z.item.description!==void 0&&(fe.description=Z.item.description),Z.item.error!==void 0&&(fe.error=Z.item.error),Z.item.sortText!==void 0&&(fe.sortText=Z.item.sortText)),{extId:Z.extId,expand:Z.expand,item:fe}},te.deserialize=Z=>{let fe;return Z.item&&(fe={},Z.item.label!==void 0&&(fe.label=Z.item.label),Z.item.tags!==void 0&&(fe.tags=Z.item.tags),Z.item.busy!==void 0&&(fe.busy=Z.item.busy),Z.item.range!==void 0&&(fe.range=Z.item.range?w.Range.lift(Z.item.range):null),Z.item.description!==void 0&&(fe.description=Z.item.description),Z.item.error!==void 0&&(fe.error=Z.item.error),Z.item.sortText!==void 0&&(fe.sortText=Z.item.sortText)),{extId:Z.extId,expand:Z.expand,item:fe}}})(n||(e.ITestItemUpdate=n={}));const h=(te,Z)=>{Z.expand!==void 0&&(te.expand=Z.expand),Z.item!==void 0&&(te.item=te.item?Object.assign(te.item,Z.item):Z.item)};e.applyTestItemUpdate=h;var s;(function(te){te.serializeWithoutMessages=Z=>({...l.serialize(Z),ownComputedState:Z.ownComputedState,computedState:Z.computedState,tasks:Z.tasks.map(m.serializeWithoutMessages)}),te.serialize=Z=>({...l.serialize(Z),ownComputedState:Z.ownComputedState,computedState:Z.computedState,tasks:Z.tasks.map(m.serialize)}),te.deserialize=(Z,fe)=>({...l.deserialize(Z,fe),ownComputedState:fe.ownComputedState,computedState:fe.computedState,tasks:fe.tasks.map(K=>m.deserialize(Z,K)),retired:!0})})(s||(e.TestResultItem=s={}));var c;(function(te){te.empty=()=>({covered:0,total:0}),te.sum=(Z,fe)=>{Z.covered+=fe.covered,Z.total+=fe.total}})(c||(e.ICoverageCount=c={}));var u;(function(te){te.serialize=Z=>({id:Z.id,statement:Z.statement,branch:Z.branch,declaration:Z.declaration,testIds:Z.testIds,uri:Z.uri.toJSON()}),te.deserialize=(Z,fe)=>({id:fe.id,statement:fe.statement,branch:fe.branch,declaration:fe.declaration,testIds:fe.testIds,uri:Z.asCanonicalUri(i.URI.revive(fe.uri))}),te.empty=(Z,fe)=>({id:Z,uri:fe,statement:c.empty()})})(u||(e.IFileCoverage=u={}));function I(te){return{...te,location:te.location?.toJSON()}}function T(te){return te.location=te.location?r.Position.isIPosition(te.location)?r.Position.lift(te.location):w.Range.lift(te.location):void 0,te}e.KEEP_N_LAST_COVERAGE_REPORTS=3;var A;(function(te){te[te.Declaration=0]="Declaration",te[te.Statement=1]="Statement",te[te.Branch=2]="Branch"})(A||(e.DetailType=A={}));var O;(function(te){te.serialize=Z=>Z.type===A.Declaration?P.serialize(Z):B.serialize(Z),te.deserialize=Z=>Z.type===A.Declaration?P.deserialize(Z):B.deserialize(Z)})(O||(e.CoverageDetails=O={}));var k;(function(te){te.serialize=I,te.deserialize=T})(k||(e.IBranchCoverage=k={}));var P;(function(te){te.serialize=I,te.deserialize=T})(P||(e.IDeclarationCoverage=P={}));var B;(function(te){te.serialize=Z=>({...I(Z),branches:Z.branches?.map(k.serialize)}),te.deserialize=Z=>({...T(Z),branches:Z.branches?.map(k.deserialize)})})(B||(e.IStatementCoverage=B={}));var Y;(function(te){te[te.Add=0]="Add",te[te.Update=1]="Update",te[te.DocumentSynced=2]="DocumentSynced",te[te.Remove=3]="Remove",te[te.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",te[te.Retire=5]="Retire",te[te.AddTag=6]="AddTag",te[te.RemoveTag=7]="RemoveTag"})(Y||(e.TestDiffOpType=Y={}));var X;(function(te){te.deserialize=(Z,fe)=>fe.op===Y.Add?{op:fe.op,item:l.deserialize(Z,fe.item)}:fe.op===Y.Update?{op:fe.op,item:n.deserialize(fe.item)}:fe.op===Y.DocumentSynced?{op:fe.op,uri:Z.asCanonicalUri(i.URI.revive(fe.uri)),docv:fe.docv}:fe,te.serialize=Z=>Z.op===Y.Add?{op:Z.op,item:l.serialize(Z.item)}:Z.op===Y.Update?{op:Z.op,item:n.serialize(Z.item)}:Z})(X||(e.TestsDiffOp=X={}));class re{constructor(Z){this.uriIdentity=Z,this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(Z){const fe=this.createChangeCollector();for(const K of Z)switch(K.op){case Y.Add:this.add(l.deserialize(this.uriIdentity,K.item),fe);break;case Y.Update:this.update(n.deserialize(K.item),fe);break;case Y.Remove:this.remove(K.itemId,fe);break;case Y.Retire:this.retireTest(K.itemId);break;case Y.IncrementPendingExtHosts:this.updatePendingRoots(K.amount);break;case Y.AddTag:this._tags.set(K.tag.id,K.tag);break;case Y.RemoveTag:this._tags.delete(K.id);break}fe.complete?.()}add(Z,fe){const K=C.TestId.parentId(Z.item.extId)?.toString();let ae;if(!K)ae=this.createItem(Z),this.roots.add(ae),this.items.set(Z.item.extId,ae);else if(this.items.has(K)){const x=this.items.get(K);x.children.add(Z.item.extId),ae=this.createItem(Z,x),this.items.set(Z.item.extId,ae)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(Z)}`);return}return fe.add?.(ae),Z.expand===t.BusyExpanding&&this.busyControllerCount++,ae}update(Z,fe){const K=this.items.get(Z.extId);if(K)return Z.expand!==void 0&&(K.expand===t.BusyExpanding&&this.busyControllerCount--,Z.expand===t.BusyExpanding&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(K,Z),fe.update?.(K),K}remove(Z,fe){const K=this.items.get(Z);if(!K)return;const ae=C.TestId.parentId(K.item.extId)?.toString();ae?this.items.get(ae).children.delete(K.item.extId):this.roots.delete(K);const x=[[Z]];for(;x.length;)for(const z of x.pop()){const ne=this.items.get(z);ne&&(x.push(ne.children),this.items.delete(z),fe.remove?.(ne,ne!==K),ne.expand===t.BusyExpanding&&this.busyControllerCount--)}}retireTest(Z){}updatePendingRoots(Z){this.pendingRootCount+=Z}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=re}),define(ye[147],Ie([1,0,14,6,2,106,103,76]),function(se,e,i,r,w,C,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var b;(function(S){S[S.Upsert=0]="Upsert",S[S.SetTags=1]="SetTags",S[S.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",S[S.RemoveChild=3]="RemoveChild",S[S.SetProp=4]="SetProp",S[S.Bulk=5]="Bulk",S[S.DocumentSynced=6]="DocumentSynced"})(b||(e.TestItemEventOp=b={}));const o=(S,g)=>S===g,y=Object.entries({range:(S,g)=>S===g?!0:!S||!g?!1:S.equalsRange(g),busy:o,label:o,description:o,error:o,sortText:o,tags:(S,g)=>!(S.length!==g.length||S.some(v=>!g.includes(v)))}),d=(S,g)=>{let v;for(const[t,l]of y)l(S[t],g[t])||(v?v[t]=g[t]:v={[t]:g[t]});return v};class E extends w.Disposable{get root(){return this.options.root}constructor(g){super(),this.options=g,this.debounceSendDiff=this._register(new i.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new r.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(g){this._resolveHandler=g;for(const v of this.tree.values())this.updateExpandability(v)}get resolveHandler(){return this._resolveHandler}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){switch(g.op){case R.TestDiffOpType.DocumentSynced:{for(const v of this.diff)if(v.op===R.TestDiffOpType.DocumentSynced&&v.uri===g.uri){v.docv=g.docv;return}break}case R.TestDiffOpType.Update:{const v=this.diff[this.diff.length-1];if(v){if(v.op===R.TestDiffOpType.Update&&v.item.extId===g.item.extId){(0,R.applyTestItemUpdate)(v.item,g.item);return}if(v.op===R.TestDiffOpType.Add&&v.item.item.extId===g.item.extId){(0,R.applyTestItemUpdate)(v.item,g.item);return}}break}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,v){const t=this.tree.get(g);if(t){if((t.expandLevels===void 0||v>t.expandLevels)&&(t.expandLevels=v),t.expand===R.TestItemExpandState.Expandable){const l=this.resolveChildren(t);return l.isOpen()?this.expandChildren(t,v-1):l.wait().then(()=>this.expandChildren(t,v-1))}else if(t.expand===R.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.expandChildren(t,v-1)):this.expandChildren(t,v-1)}}dispose(){for(const g of this.tree.values())this.options.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(g,v){switch(v.op){case b.RemoveChild:this.removeItem(_.TestId.joinToString(g.fullId,v.id));break;case b.Upsert:this.upsertItem(v.item,g);break;case b.Bulk:for(const t of v.ops)this.onTestItemEvent(g,t);break;case b.SetTags:this.diffTagRefs(v.new,v.old,g.fullId.toString());break;case b.UpdateCanResolveChildren:this.updateExpandability(g);break;case b.SetProp:this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:g.fullId.toString(),item:v.update}});break;case b.DocumentSynced:this.documentSynced(g.actual.uri);break;default:(0,C.assertNever)(v)}}documentSynced(g){g&&this.pushDiff({op:R.TestDiffOpType.DocumentSynced,uri:g,docv:this.options.getDocumentVersion(g)})}upsertItem(g,v){const t=_.TestId.fromExtHostTestItem(g,this.root.id,v?.actual),l=this.options.getApiFor(g);l.parent&&l.parent!==v?.actual&&this.options.getChildren(l.parent).delete(g.id);let n=this.tree.get(t.toString());if(!n){n={fullId:t,actual:g,expandLevels:v?.expandLevels?v.expandLevels-1:void 0,expand:R.TestItemExpandState.NotExpandable},g.tags.forEach(this.incrementTagRefs,this),this.tree.set(n.fullId.toString(),n),this.setItemParent(g,v),this.pushDiff({op:R.TestDiffOpType.Add,item:{controllerId:this.options.controllerId,expand:n.expand,item:this.options.toITestItem(g)}}),this.connectItemAndChildren(g,n,v);return}if(n.actual===g){this.connectItem(g,n,v);return}if(n.actual.uri?.toString()!==g.uri?.toString())return this.removeItem(t.toString()),this.upsertItem(g,v);const h=this.options.getChildren(n.actual),s=n.actual,c=d(this.options.toITestItem(s),this.options.toITestItem(g));this.options.getApiFor(s).listener=void 0,n.actual=g,n.resolveBarrier=void 0,n.expand=R.TestItemExpandState.NotExpandable,c&&(c.hasOwnProperty("tags")&&(this.diffTagRefs(g.tags,s.tags,t.toString()),delete c.tags),this.onTestItemEvent(n,{op:b.SetProp,update:c})),this.connectItemAndChildren(g,n,v);for(const[I,T]of h)this.options.getChildren(g).get(T.id)||this.removeItem(_.TestId.joinToString(t,T.id));const u=n.expandLevels;u!==void 0&&queueMicrotask(()=>{n.expand===R.TestItemExpandState.Expandable&&(n.expandLevels=void 0,this.expand(t.toString(),u))}),this.documentSynced(n.actual.uri)}diffTagRefs(g,v,t){const l=new Set(v.map(n=>n.id));for(const n of g)l.delete(n.id)||this.incrementTagRefs(n);this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:t,item:{tags:g.map(n=>(0,R.namespaceTestTag)(this.options.controllerId,n.id))}}}),l.forEach(this.decrementTagRefs,this)}incrementTagRefs(g){const v=this.tags.get(g.id);v?v.refCount++:(this.tags.set(g.id,{refCount:1}),this.pushDiff({op:R.TestDiffOpType.AddTag,tag:{id:(0,R.namespaceTestTag)(this.options.controllerId,g.id)}}))}decrementTagRefs(g){const v=this.tags.get(g);v&&!--v.refCount&&(this.tags.delete(g),this.pushDiff({op:R.TestDiffOpType.RemoveTag,id:(0,R.namespaceTestTag)(this.options.controllerId,g)}))}setItemParent(g,v){this.options.getApiFor(g).parent=v&&v.actual!==this.root?v.actual:void 0}connectItem(g,v,t){this.setItemParent(g,t);const l=this.options.getApiFor(g);l.parent=t?.actual,l.listener=n=>this.onTestItemEvent(v,n),this.updateExpandability(v)}connectItemAndChildren(g,v,t){this.connectItem(g,v,t);for(const[l,n]of this.options.getChildren(g))this.upsertItem(n,v)}updateExpandability(g){let v;this._resolveHandler?g.resolveBarrier?v=g.resolveBarrier.isOpen()?R.TestItemExpandState.Expanded:R.TestItemExpandState.BusyExpanding:v=g.actual.canResolveChildren?R.TestItemExpandState.Expandable:R.TestItemExpandState.NotExpandable:v=R.TestItemExpandState.NotExpandable,v!==g.expand&&(g.expand=v,this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:g.fullId.toString(),expand:v}}),v===R.TestItemExpandState.Expandable&&g.expandLevels!==void 0&&this.resolveChildren(g))}expandChildren(g,v){if(v<0)return;const t=[];for(const[l,n]of this.options.getChildren(g.actual)){const h=this.expand(_.TestId.joinToString(g.fullId,n.id),v);(0,i.isThenable)(h)&&t.push(h)}if(t.length)return Promise.all(t).then(()=>{})}resolveChildren(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this._resolveHandler){const n=new i.Barrier;return n.open(),n}g.expand=R.TestItemExpandState.BusyExpanding,this.pushExpandStateUpdate(g);const v=g.resolveBarrier=new i.Barrier,t=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,n)};let l;try{l=this._resolveHandler(g.actual===this.root?void 0:g.actual)}catch(n){t(n)}return(0,i.isThenable)(l)?l.catch(t).then(()=>{v.open(),this.updateExpandability(g)}):(v.open(),this.updateExpandability(g)),g.resolveBarrier}pushExpandStateUpdate(g){this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:g.fullId.toString(),expand:g.expand}})}removeItem(g){const v=this.tree.get(g);if(!v)throw new Error("attempting to remove non-existent child");this.pushDiff({op:R.TestDiffOpType.Remove,itemId:g});const t=[v];for(;t.length;){const l=t.pop();if(l){this.options.getApiFor(l.actual).listener=void 0;for(const n of l.actual.tags)this.decrementTagRefs(n.id);this.tree.delete(l.fullId.toString());for(const[n,h]of this.options.getChildren(l.actual))t.push(this.tree.get(_.TestId.joinToString(l.fullId,h.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.diffOpEmitter.fire(g)}}e.TestItemCollection=E;class a extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.DuplicateTestItemError=a;class f extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class m extends Error{constructor(g,v,t){super(`TestItem with ID "${g}" is from controller "${v}" and cannot be added as a child of an item from controller "${t}".`)}}e.MixedTestItemController=m;const p=(S,g,v)=>{let t=new Map;return{get size(){return t.size},forEach(l,n){for(const h of t.values())l.call(n,h,this)},[Symbol.iterator](){return t.entries()},replace(l){const n=new Map,h=new Set(t.keys()),s={op:b.Bulk,ops:[]};for(const c of l){if(!(c instanceof v))throw new f(c.id);const u=g(c).controllerId;if(u!==S.controllerId)throw new m(c.id,u,S.controllerId);if(n.has(c.id))throw new a(c.id);n.set(c.id,c),h.delete(c.id),s.ops.push({op:b.Upsert,item:c})}for(const c of h.keys())s.ops.push({op:b.RemoveChild,id:c});S.listener?.(s),t=n},add(l){if(!(l instanceof v))throw new f(l.id);t.set(l.id,l),S.listener?.({op:b.Upsert,item:l})},delete(l){t.delete(l)&&S.listener?.({op:b.RemoveChild,id:l})},get(l){return t.get(l)},toJSON(){return Array.from(t.values())}}};e.createTestItemChildren=p}),define(ye[148],Ie([1,0,147]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const r=new WeakMap,w=(R,_)=>{const b={controllerId:_};return r.set(R,b),b};e.createPrivateApiFor=w;const C=R=>{const _=r.get(R);if(!_)throw new i.InvalidTestItemError(R?.id||"<unknown>");return _};e.getPrivateApiFor=C}),define(ye[306],Ie([1,0,46,27,5]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.APPLY_ALL_PROFILES_SETTING=e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.LOCAL_MACHINE_PROFILE_SCOPES=e.PROFILE_SCOPES=e.APPLICATION_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.profileSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.profileSettingsSchemaId="vscode://schemas/settings/profile",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.APPLICATION_SCOPES=[i.ConfigurationScope.APPLICATION],e.PROFILE_SCOPES=[i.ConfigurationScope.MACHINE,i.ConfigurationScope.WINDOW,i.ConfigurationScope.RESOURCE,i.ConfigurationScope.LANGUAGE_OVERRIDABLE,i.ConfigurationScope.MACHINE_OVERRIDABLE],e.LOCAL_MACHINE_PROFILE_SCOPES=[i.ConfigurationScope.WINDOW,i.ConfigurationScope.RESOURCE,i.ConfigurationScope.LANGUAGE_OVERRIDABLE],e.LOCAL_MACHINE_SCOPES=[i.ConfigurationScope.APPLICATION,...e.LOCAL_MACHINE_PROFILE_SCOPES],e.REMOTE_MACHINE_SCOPES=[i.ConfigurationScope.MACHINE,i.ConfigurationScope.WINDOW,i.ConfigurationScope.RESOURCE,i.ConfigurationScope.LANGUAGE_OVERRIDABLE,i.ConfigurationScope.MACHINE_OVERRIDABLE],e.WORKSPACE_SCOPES=[i.ConfigurationScope.WINDOW,i.ConfigurationScope.RESOURCE,i.ConfigurationScope.LANGUAGE_OVERRIDABLE,i.ConfigurationScope.MACHINE_OVERRIDABLE],e.FOLDER_SCOPES=[i.ConfigurationScope.RESOURCE,i.ConfigurationScope.LANGUAGE_OVERRIDABLE,i.ConfigurationScope.MACHINE_OVERRIDABLE],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,w.refineServiceDecorator)(r.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`,e.APPLY_ALL_PROFILES_SETTING="workbench.settings.applyToAllProfiles"}),define(ye[149],Ie([1,0,5]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,i.createDecorator)("configurationResolverService");var r;(function(C){C.Unknown="unknown",C.Env="env",C.Config="config",C.Command="command",C.Input="input",C.ExtensionInstallFolder="extensionInstallFolder",C.WorkspaceFolder="workspaceFolder",C.Cwd="cwd",C.WorkspaceFolderBasename="workspaceFolderBasename",C.UserHome="userHome",C.LineNumber="lineNumber",C.SelectedText="selectedText",C.File="file",C.FileWorkspaceFolder="fileWorkspaceFolder",C.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",C.RelativeFile="relativeFile",C.RelativeFileDirname="relativeFileDirname",C.FileDirname="fileDirname",C.FileExtname="fileExtname",C.FileBasename="fileBasename",C.FileBasenameNoExtension="fileBasenameNoExtension",C.FileDirnameBasename="fileDirnameBasename",C.ExecPath="execPath",C.ExecInstallFolder="execInstallFolder",C.PathSeparator="pathSeparator",C.PathSeparatorAlias="/"})(r||(e.VariableKind=r={}));class w extends Error{constructor(R,_){super(_),this.variable=R}}e.VariableError=w}),define(ye[307],Ie([1,0,9,33,11,21,3,194,237,149,17]),function(se,e,i,r,w,C,R,_,b,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0,i=Be(i),r=Be(r),w=Be(w),C=Be(C);class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,a,f,m){this._contributedVariables=new Map,this._context=E,this._labelService=a,this._userHomePromise=f,m&&(this._envVariablesPromise=m.then(p=>this.prepareEnv(p)))}prepareEnv(E){if(R.isWindows){const a=Object.create(null);return Object.keys(E).forEach(f=>{a[f.toLowerCase()]=E[f]}),a}return E}resolveWithEnvironment(E,a,f){return this.recursiveResolve({env:this.prepareEnv(E),userHome:void 0},a?a.uri:void 0,f)}async resolveAsync(E,a){const f={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(f,E?E.uri:void 0,a)}async resolveAnyBase(E,a,f,m){const p=C.deepClone(a);R.isWindows&&p.windows?Object.keys(p.windows).forEach(g=>p[g]=p.windows[g]):R.isMacintosh&&p.osx?Object.keys(p.osx).forEach(g=>p[g]=p.osx[g]):R.isLinux&&p.linux&&Object.keys(p.linux).forEach(g=>p[g]=p.linux[g]),delete p.windows,delete p.osx,delete p.linux;const S={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(S,E?E.uri:void 0,p,f,m)}async resolveAnyAsync(E,a,f){return this.resolveAnyBase(E,a,f)}async resolveAnyMap(E,a,f){const m=new Map;return{newConfig:await this.resolveAnyBase(E,a,f,m),resolvedVariables:m}}resolveWithInteractionReplace(E,a,f,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,a,f,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,a){if(this._contributedVariables.has(E))throw new Error("Variable "+E+" is contributed twice.");this._contributedVariables.set(E,a)}async recursiveResolve(E,a,f,m,p){if(w.isString(f))return this.resolveString(E,a,f,m,p);if(Array.isArray(f))return Promise.all(f.map(S=>this.recursiveResolve(E,a,S,m,p)));if(w.isObject(f)){const S=Object.create(null),g=await Promise.all(Object.keys(f).map(async v=>[await this.resolveString(E,a,v,m,p),await this.recursiveResolve(E,a,f[v],m,p)]));for(const[v,t]of g)S[v]=t;return S}return f}resolveString(E,a,f,m,p){return(0,D.replaceAsync)(f,y.VARIABLE_REGEXP,async(S,g)=>{if(g.includes(y.VARIABLE_LHS))return S;let v=await this.evaluateSingleVariable(E,S,g,a,m);return p?.set(g,v),v!==S&&w.isString(v)&&v.match(y.VARIABLE_REGEXP)&&(v=await this.resolveString(E,a,v,m,p)),v})}fsPath(E){return this._labelService?this._labelService.getUriLabel(E,{noPrefix:!0}):E.fsPath}async evaluateSingleVariable(E,a,f,m,p){let S;const g=f.split(":");g.length>1&&(f=g[0],S=g[1]);const v=n=>{const h=this._context.getFilePath();if(h)return(0,_.normalizeDriveLetter)(h);throw new o.VariableError(n,(0,b.localize)(0,null,a))},t=n=>{const h=v(n);if(this._context.getWorkspaceFolderPathForFile){const s=this._context.getWorkspaceFolderPathForFile();if(s)return(0,_.normalizeDriveLetter)(s)}throw new o.VariableError(n,(0,b.localize)(1,null,a,i.basename(h)))},l=n=>{if(S){const h=this._context.getFolderUri(S);if(h)return h;throw new o.VariableError(n,(0,b.localize)(2,null,a,S))}if(m)return m;throw this._context.getWorkspaceFolderCount()>1?new o.VariableError(n,(0,b.localize)(3,null,a)):new o.VariableError(n,(0,b.localize)(4,null,a))};switch(f){case"env":if(S){if(E.env){const n=E.env[R.isWindows?S.toLowerCase():S];if(w.isString(n))return n}return""}throw new o.VariableError(o.VariableKind.Env,(0,b.localize)(5,null,a));case"config":if(S){const n=this._context.getConfigurationValue(m,S);if(w.isUndefinedOrNull(n))throw new o.VariableError(o.VariableKind.Config,(0,b.localize)(6,null,a,S));if(w.isObject(n))throw new o.VariableError(o.VariableKind.Config,(0,b.localize)(7,null,a,S));return n}throw new o.VariableError(o.VariableKind.Config,(0,b.localize)(8,null,a));case"command":return this.resolveFromMap(o.VariableKind.Command,a,S,p,"command");case"input":return this.resolveFromMap(o.VariableKind.Input,a,S,p,"input");case"extensionInstallFolder":if(S){const n=await this._context.getExtension(S);if(!n)throw new o.VariableError(o.VariableKind.ExtensionInstallFolder,(0,b.localize)(9,null,a,S));return this.fsPath(n.extensionLocation)}throw new o.VariableError(o.VariableKind.ExtensionInstallFolder,(0,b.localize)(10,null,a));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,_.normalizeDriveLetter)(this.fsPath(l(o.VariableKind.WorkspaceFolder)));case"cwd":return m||S?(0,_.normalizeDriveLetter)(this.fsPath(l(o.VariableKind.Cwd))):r.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,_.normalizeDriveLetter)(i.basename(this.fsPath(l(o.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new o.VariableError(o.VariableKind.UserHome,(0,b.localize)(11,null,a))}case"lineNumber":{const n=this._context.getLineNumber();if(n)return n;throw new o.VariableError(o.VariableKind.LineNumber,(0,b.localize)(12,null,a))}case"selectedText":{const n=this._context.getSelectedText();if(n)return n;throw new o.VariableError(o.VariableKind.SelectedText,(0,b.localize)(13,null,a))}case"file":return v(o.VariableKind.File);case"fileWorkspaceFolder":return t(o.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return i.basename(t(o.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||S?i.relative(this.fsPath(l(o.VariableKind.RelativeFile)),v(o.VariableKind.RelativeFile)):v(o.VariableKind.RelativeFile);case"relativeFileDirname":{const n=i.dirname(v(o.VariableKind.RelativeFileDirname));if(m||S){const h=i.relative(this.fsPath(l(o.VariableKind.RelativeFileDirname)),n);return h.length===0?".":h}return n}case"fileDirname":return i.dirname(v(o.VariableKind.FileDirname));case"fileExtname":return i.extname(v(o.VariableKind.FileExtname));case"fileBasename":return i.basename(v(o.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=i.basename(v(o.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-i.extname(n).length)}case"fileDirnameBasename":return i.basename(i.dirname(v(o.VariableKind.FileDirnameBasename)));case"execPath":{const n=this._context.getExecPath();return n||a}case"execInstallFolder":{const n=this._context.getAppRoot();return n||a}case"pathSeparator":case"/":return i.sep;default:try{const n=S?`${f}:${S}`:f;return this.resolveFromMap(o.VariableKind.Unknown,a,n,p,void 0)}catch{return a}}}}resolveFromMap(E,a,f,m,p){if(f&&m){const S=p===void 0?m[f]:m[p+":"+f];if(typeof S=="string")return S;throw new o.VariableError(E,(0,b.localize)(14,null,a))}return a}}e.AbstractVariableResolverService=y}),define(ye[308],Ie([1,0,5,102]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.isEditorReplacement=o,e.isEditorGroup=d,e.preferredSideBySideGroupDirection=E,e.IEditorGroupsService=(0,i.createDecorator)("editorGroupsService");var w;(function(a){a[a.UP=0]="UP",a[a.DOWN=1]="DOWN",a[a.LEFT=2]="LEFT",a[a.RIGHT=3]="RIGHT"})(w||(e.GroupDirection=w={}));var C;(function(a){a[a.HORIZONTAL=0]="HORIZONTAL",a[a.VERTICAL=1]="VERTICAL"})(C||(e.GroupOrientation=C={}));var R;(function(a){a[a.FIRST=0]="FIRST",a[a.LAST=1]="LAST",a[a.NEXT=2]="NEXT",a[a.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var _;(function(a){a[a.MAXIMIZE=0]="MAXIMIZE",a[a.EXPAND=1]="EXPAND",a[a.EVEN=2]="EVEN"})(_||(e.GroupsArrangement=_={}));var b;(function(a){a[a.COPY_EDITORS=0]="COPY_EDITORS",a[a.MOVE_EDITORS=1]="MOVE_EDITORS"})(b||(e.MergeGroupMode=b={}));function o(a){const f=a;return(0,r.isEditorInput)(f?.editor)&&(0,r.isEditorInput)(f?.replacement)}var D;(function(a){a[a.CREATION_TIME=0]="CREATION_TIME",a[a.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",a[a.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D||(e.GroupsOrder=D={}));var y;(function(a){a[a.NEW_EDITOR=1]="NEW_EDITOR",a[a.MOVE_EDITOR=2]="MOVE_EDITOR",a[a.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function d(a){const f=a;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}function E(a){return a.getValue("workbench.editor.openSideBySideDirection")==="down"?w.DOWN:w.RIGHT}}),define(ye[150],Ie([1,0,5,308]),function(se,e,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AUX_WINDOW_GROUP=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.isPreferredGroup=w,e.IEditorService=(0,i.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2,e.AUX_WINDOW_GROUP=-3;function w(C){const R=C;return typeof C=="number"||(0,r.isEditorGroup)(R)}}),define(ye[309],Ie([1,0,306,90,98,97,149,102,150,13,257,304,53,146]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let a=class{get onPtyHostExit(){return this._channel.listen(E.RemoteTerminalChannelEvent.OnPtyHostExitEvent)}get onPtyHostStart(){return this._channel.listen(E.RemoteTerminalChannelEvent.OnPtyHostStartEvent)}get onPtyHostUnresponsive(){return this._channel.listen(E.RemoteTerminalChannelEvent.OnPtyHostUnresponsiveEvent)}get onPtyHostResponsive(){return this._channel.listen(E.RemoteTerminalChannelEvent.OnPtyHostResponsiveEvent)}get onPtyHostRequestResolveVariables(){return this._channel.listen(E.RemoteTerminalChannelEvent.OnPtyHostRequestResolveVariablesEvent)}get onProcessData(){return this._channel.listen(E.RemoteTerminalChannelEvent.OnProcessDataEvent)}get onProcessExit(){return this._channel.listen(E.RemoteTerminalChannelEvent.OnProcessExitEvent)}get onProcessReady(){return this._channel.listen(E.RemoteTerminalChannelEvent.OnProcessReadyEvent)}get onProcessReplay(){return this._channel.listen(E.RemoteTerminalChannelEvent.OnProcessReplayEvent)}get onProcessOrphanQuestion(){return this._channel.listen(E.RemoteTerminalChannelEvent.OnProcessOrphanQuestion)}get onExecuteCommand(){return this._channel.listen(E.RemoteTerminalChannelEvent.OnExecuteCommand)}get onDidRequestDetach(){return this._channel.listen(E.RemoteTerminalChannelEvent.OnDidRequestDetach)}get onDidChangeProperty(){return this._channel.listen(E.RemoteTerminalChannelEvent.OnDidChangeProperty)}constructor(m,p,S,g,v,t,l,n,h,s){this._remoteAuthority=m,this._channel=p,this._configurationService=S,this._workspaceContextService=g,this._resolverService=v,this._environmentVariableService=t,this._remoteAuthorityResolverService=l,this._logService=n,this._editorService=h,this._labelService=s}restartPtyHost(){return this._channel.call(E.RemoteTerminalChannelRequest.RestartPtyHost,[])}async createProcess(m,p,S,g,v,t,l,n){await this._configurationService.whenRemoteConfigurationLoaded();const h=Object.create(null),s=S?this._workspaceContextService.getWorkspaceFolder(S)??void 0:void 0;let c;try{c=(await this._resolverService.resolveAnyMap(s,{shellLaunchConfig:m,configuration:p})).resolvedVariables}catch(Y){this._logService.error(Y)}if(c)for(const[Y,X]of c.entries())(/^config:/.test(Y)||Y==="selectedText"||Y==="lineNumber")&&(h[Y]=X);const u=[];for(const[Y,X]of this._environmentVariableService.collections.entries())u.push([Y,(0,C.serializeEnvironmentVariableCollection)(X.map),(0,C.serializeEnvironmentDescriptionMap)(X.descriptionMap)]);const I=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),T=I.options&&I.options.extensionHostEnv,A=this._workspaceContextService.getWorkspace(),O=A.folders,k=S?this._workspaceContextService.getWorkspaceFolder(S):null,P=_.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:_.SideBySideEditor.PRIMARY,filterByScheme:[o.Schemas.file,o.Schemas.vscodeUserData,o.Schemas.vscodeRemote]}),B={configuration:p,resolvedVariables:h,envVariableCollections:u,shellLaunchConfig:m,workspaceId:A.id,workspaceName:this._labelService.getWorkspaceLabel(A),workspaceFolders:O,activeWorkspaceFolder:k,activeFileResource:P,shouldPersistTerminal:v,options:g,cols:t,rows:l,unicodeVersion:n,resolverEnv:T};return await this._channel.call(E.RemoteTerminalChannelRequest.CreateProcess,B)}requestDetachInstance(m,p){return this._channel.call(E.RemoteTerminalChannelRequest.RequestDetachInstance,[m,p])}acceptDetachInstanceReply(m,p){return this._channel.call(E.RemoteTerminalChannelRequest.AcceptDetachInstanceReply,[m,p])}attachToProcess(m){return this._channel.call(E.RemoteTerminalChannelRequest.AttachToProcess,[m])}detachFromProcess(m,p){return this._channel.call(E.RemoteTerminalChannelRequest.DetachFromProcess,[m,p])}listProcesses(){return this._channel.call(E.RemoteTerminalChannelRequest.ListProcesses)}getLatency(){return this._channel.call(E.RemoteTerminalChannelRequest.GetLatency)}getPerformanceMarks(){return this._channel.call(E.RemoteTerminalChannelRequest.GetPerformanceMarks)}reduceConnectionGraceTime(){return this._channel.call(E.RemoteTerminalChannelRequest.ReduceConnectionGraceTime)}processBinary(m,p){return this._channel.call(E.RemoteTerminalChannelRequest.ProcessBinary,[m,p])}start(m){return this._channel.call(E.RemoteTerminalChannelRequest.Start,[m])}input(m,p){return this._channel.call(E.RemoteTerminalChannelRequest.Input,[m,p])}acknowledgeDataEvent(m,p){return this._channel.call(E.RemoteTerminalChannelRequest.AcknowledgeDataEvent,[m,p])}setUnicodeVersion(m,p){return this._channel.call(E.RemoteTerminalChannelRequest.SetUnicodeVersion,[m,p])}shutdown(m,p){return this._channel.call(E.RemoteTerminalChannelRequest.Shutdown,[m,p])}resize(m,p,S){return this._channel.call(E.RemoteTerminalChannelRequest.Resize,[m,p,S])}clearBuffer(m){return this._channel.call(E.RemoteTerminalChannelRequest.ClearBuffer,[m])}getInitialCwd(m){return this._channel.call(E.RemoteTerminalChannelRequest.GetInitialCwd,[m])}getCwd(m){return this._channel.call(E.RemoteTerminalChannelRequest.GetCwd,[m])}orphanQuestionReply(m){return this._channel.call(E.RemoteTerminalChannelRequest.OrphanQuestionReply,[m])}sendCommandResult(m,p,S){return this._channel.call(E.RemoteTerminalChannelRequest.SendCommandResult,[m,p,S])}freePortKillProcess(m){return this._channel.call(E.RemoteTerminalChannelRequest.FreePortKillProcess,[m])}installAutoReply(m,p){return this._channel.call(E.RemoteTerminalChannelRequest.InstallAutoReply,[m,p])}uninstallAllAutoReplies(){return this._channel.call(E.RemoteTerminalChannelRequest.UninstallAllAutoReplies,[])}getDefaultSystemShell(m){return this._channel.call(E.RemoteTerminalChannelRequest.GetDefaultSystemShell,[m])}getProfiles(m,p,S){return this._channel.call(E.RemoteTerminalChannelRequest.GetProfiles,[this._workspaceContextService.getWorkspace().id,m,p,S])}acceptPtyHostResolvedVariables(m,p){return this._channel.call(E.RemoteTerminalChannelRequest.AcceptPtyHostResolvedVariables,[m,p])}getEnvironment(){return this._channel.call(E.RemoteTerminalChannelRequest.GetEnvironment)}getWslPath(m,p){return this._channel.call(E.RemoteTerminalChannelRequest.GetWslPath,[m,p])}setTerminalLayoutInfo(m){const S={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:m?m.tabs:[]};return this._channel.call(E.RemoteTerminalChannelRequest.SetTerminalLayoutInfo,S)}updateTitle(m,p,S){return this._channel.call(E.RemoteTerminalChannelRequest.UpdateTitle,[m,p,S])}updateIcon(m,p,S,g){return this._channel.call(E.RemoteTerminalChannelRequest.UpdateIcon,[m,p,S,g])}refreshProperty(m,p){return this._channel.call(E.RemoteTerminalChannelRequest.RefreshProperty,[m,p])}updateProperty(m,p,S){return this._channel.call(E.RemoteTerminalChannelRequest.UpdateProperty,[m,p,S])}getTerminalLayoutInfo(){const p={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call(E.RemoteTerminalChannelRequest.GetTerminalLayoutInfo,p)}reviveTerminalProcesses(m,p,S){return this._channel.call(E.RemoteTerminalChannelRequest.ReviveTerminalProcesses,[m,p,S])}getRevivedPtyNewId(m){return this._channel.call(E.RemoteTerminalChannelRequest.GetRevivedPtyNewId,[m])}serializeTerminalState(m){return this._channel.call(E.RemoteTerminalChannelRequest.SerializeTerminalState,[m])}};e.RemoteTerminalChannelClient=a,e.RemoteTerminalChannelClient=a=ze([Me(2,i.IWorkbenchConfigurationService),Me(3,w.IWorkspaceContextService),Me(4,R.IConfigurationResolverService),Me(5,y.IEnvironmentVariableService),Me(6,r.IRemoteAuthorityResolverService),Me(7,d.ITerminalLogService),Me(8,b.IEditorService),Me(9,D.ILabelService)],a)}),define(ye[310],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0,e.writeExtHostConnection=_,e.readExtHostConnection=b;var i;(function(D){D[D.IPC=1]="IPC",D[D.Socket=2]="Socket",D[D.MessagePort=3]="MessagePort"})(i||(e.ExtHostConnectionType=i={}));class r{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(y){this.pipeName=y,this.type=i.IPC}serialize(y){y[r.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=r;class w{constructor(){this.type=i.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(y){y[w.ENV_KEY]="1"}}e.SocketExtHostConnection=w;class C{constructor(){this.type=i.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(y){y[C.ENV_KEY]="1"}}e.MessagePortExtHostConnection=C;function R(D){delete D[r.ENV_KEY],delete D[w.ENV_KEY],delete D[C.ENV_KEY]}function _(D,y){R(y),D.serialize(y)}function b(D){if(D[r.ENV_KEY])return o(D,new r(D[r.ENV_KEY]));if(D[w.ENV_KEY])return o(D,new w);if(D[C.ENV_KEY])return o(D,new C);throw new Error("No connection information defined in environment!")}function o(D,y){return R(D),y}}),define(ye[311],Ie([1,0,15]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.createMessageOfType=R,e.isMessageOfType=_;var r;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(r||(e.UIKind=r={}));var w;(function(o){o[o.VersionMismatch=55]="VersionMismatch",o[o.UnexpectedError=81]="UnexpectedError"})(w||(e.ExtensionHostExitCode=w={}));var C;(function(o){o[o.Initialized=0]="Initialized",o[o.Ready=1]="Ready",o[o.Terminate=2]="Terminate"})(C||(e.MessageType=C={}));function R(o){const D=i.VSBuffer.alloc(1);switch(o){case C.Initialized:D.writeUInt8(1,0);break;case C.Ready:D.writeUInt8(2,0);break;case C.Terminate:D.writeUInt8(3,0);break}return D}function _(o,D){if(o.byteLength!==1)return!1;switch(o.readUInt8(0)){case 1:return D===C.Initialized;case 2:return D===C.Ready;case 3:return D===C.Terminate;default:return!1}}var b;(function(o){o.Start="START_NATIVE_LOG",o.End="END_NATIVE_LOG"})(b||(e.NativeLogMarkers=b={}))}),define(ye[312],Ie([1,0,5,6,24,12,297,311,91,41,21,4,2,232]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0,e.isNewAppInstall=m;let a=class extends d.Disposable{constructor(S,g){super(),this.initData=S,this.loggerService=g,this._onDidChangeTelemetryEnabled=this._register(new r.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new r.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=w.TelemetryLevel.NONE,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=y.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=g.createLogger(this.extHostTelemetryLogFile,{id:o.extensionTelemetryLogChannelId,name:(0,E.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(this._outputLogger),this._register(g.onDidChangeLogLevel(v=>{(0,C.isLogLevel)(v)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===w.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this._level>=w.TelemetryLevel.CRASH,isErrorsEnabled:this._productConfig.error?this._level>=w.TelemetryLevel.ERROR:!1,isUsageEnabled:this._productConfig.usage?this._level>=w.TelemetryLevel.USAGE:!1}}instantiateLogger(S,g,v){const t=this.getTelemetryDetails(),l=new f(g,v,S,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(S),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),n=this._telemetryLoggers.get(S.identifier.value)??[];return this._telemetryLoggers.set(S.identifier.value,[...n,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(S,g,v){this._level=S,this._telemetryIsSupported=g,this._productConfig=v??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(S){const g=Object.create(null);switch(g["common.extname"]=`${S.publisher}.${S.name}`,g["common.extversion"]=S.version,g["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,g["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,g["common.sqmid"]=this.initData.telemetryInfo.sqmId,g["common.devDeviceId"]=this.initData.telemetryInfo.devDeviceId,g["common.vscodeversion"]=this.initData.version,g["common.isnewappinstall"]=m(this.initData.telemetryInfo.firstSessionDate),g["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case _.UIKind.Web:g["common.uikind"]="web";break;case _.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,b.getRemoteName)((0,o.cleanRemoteAuthority)(this.initData.remote.authority)),g}$onDidChangeTelemetryLevel(S){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=S;const g=this.getTelemetryDetails();this._telemetryLoggers.forEach((v,t)=>{const l=v.filter(n=>!n.isDisposed);l.length===0?this._telemetryLoggers.delete(t):this._telemetryLoggers.set(t,l)}),this._telemetryLoggers.forEach(v=>{for(const t of v)t.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(S,g){const t=this._telemetryLoggers.get(S.value)?.filter(n=>!n.isDisposed);if(!t)return this._telemetryLoggers.delete(S.value),!1;let l=!1;for(const n of t)n.ignoreUnhandledExtHostErrors||(n.logError(g),l=!0);return l}};e.ExtHostTelemetry=a,e.ExtHostTelemetry=a=ze([Me(0,R.IExtHostInitDataService),Me(1,C.ILoggerService)],a);class f{static validateSender(S){if(typeof S!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof S.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof S.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof S.flush<"u"&&typeof S.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(S,g,v,t,l,n,h){this._extension=v,this._logger=t,this._inLoggingOnlyMode=l,this._commonProperties=n,this._onDidChangeEnableStates=new r.Emitter,this.ignoreUnhandledExtHostErrors=g?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=g?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=g?.additionalCommonProperties,this._sender=S,this._telemetryEnablements={isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled}}updateTelemetryEnablements(S,g){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:S,isErrorsEnabled:g},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(S){let g="properties"in S?S.properties??{}:S;return g=(0,o.cleanData)(g,[]),this._additionalCommonProperties&&(g=(0,D.mixin)(g,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(g=(0,D.mixin)(g,this._commonProperties)),"properties"in S?S.properties=g:S=g,S}logEvent(S,g){this._sender&&(this._extension.publisher==="vscode"?S=this._extension.name+"/"+S:S=this._extension.identifier.value+"/"+S,g=this.mixInCommonPropsAndCleanData(g||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(S,g),this._logger.trace(S,g))}logUsage(S,g){this._telemetryEnablements.isUsageEnabled&&this.logEvent(S,g)}logError(S,g){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof S=="string")this.logEvent(S,g);else{const v={name:S.name,message:S.message,stack:S.stack,cause:S.cause},t=(0,o.cleanData)(v,[]),l=new Error(t.message,{cause:t.cause});l.stack=t.stack,l.name=t.name,g=this.mixInCommonPropsAndCleanData(g||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(l,g),this._logger.trace("exception",g)}}get apiTelemetryLogger(){if(!this._apiObject){const S=this,g={logUsage:S.logUsage.bind(S),get isUsageEnabled(){return S._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return S._telemetryEnablements.isErrorsEnabled},logError:S.logError.bind(S),dispose:S.dispose.bind(S),onDidChangeEnableStates:S._onDidChangeEnableStates.event.bind(S)};this._apiObject=Object.freeze(g)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let S=this._sender;this._sender=void 0,Promise.resolve(S.flush()).then(S=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=f;function m(p){const S=Date.now()-new Date(p).getTime();return isNaN(S)?!1:S<1e3*60*60*24}e.IExtHostTelemetry=(0,i.createDecorator)("IExtHostTelemetry")}),define(ye[313],Ie([1,0,6,4,39,130,22,5]),function(se,e,i,r,w,C,R,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.isProposedApiEnabled=d,e.checkProposedApiEnabled=E,e.toExtension=p,e.toExtensionDescription=S,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:r.URI.parse("void:location"),isBuiltin:!1,targetPlatform:R.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,_.createDecorator)("extensionService");class b{constructor(t){this.dependency=t}}e.MissingExtensionDependency=b;var o;(function(v){v[v.EagerAutoStart=1]="EagerAutoStart",v[v.EagerManualStart=2]="EagerManualStart",v[v.Lazy=3]="Lazy"})(o||(e.ExtensionHostStartup=o={}));class D{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(t,l,n){this._versionId=t,this._allExtensions=l.slice(0),this._myExtensions=n.slice(0),this._myActivationEvents=null}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:C.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(t,l,n){if(this._versionId>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this._versionId})`);const h=[],s=[],c=[],u=[],I=y(this._allExtensions),T=y(l),A=(Y,X)=>Y.extensionLocation.toString()===X.extensionLocation.toString()||Y.isBuiltin===X.isBuiltin||Y.isUserBuiltin===X.isUserBuiltin||Y.isUnderDevelopment===X.isUnderDevelopment;for(const Y of this._allExtensions){const X=T.get(Y.identifier);if(!X){h.push(Y.identifier),I.delete(Y.identifier);continue}if(!A(Y,X)){h.push(Y.identifier),I.delete(Y.identifier);continue}}for(const Y of l){const X=I.get(Y.identifier);if(!X){s.push(Y);continue}if(!A(X,Y)){h.push(X.identifier),I.delete(X.identifier);continue}}const O=new R.ExtensionIdentifierSet(this._myExtensions),k=new R.ExtensionIdentifierSet(n);for(const Y of this._myExtensions)k.has(Y)||c.push(Y);for(const Y of n)O.has(Y)||u.push(Y);const P=C.ImplicitActivationEvents.createActivationEventsMap(s),B={versionId:t,toRemove:h,toAdd:s,addActivationEvents:P,myToRemove:c,myToAdd:u};return this.delta(B),B}delta(t){if(this._versionId>=t.versionId)return null;const{toRemove:l,toAdd:n,myToRemove:h,myToAdd:s}=t,c=new R.ExtensionIdentifierSet(l),u=new R.ExtensionIdentifierSet(h);for(let I=0;I<this._allExtensions.length;I++)c.has(this._allExtensions[I].identifier)&&(this._allExtensions.splice(I,1),I--);for(let I=0;I<this._myExtensions.length;I++)u.has(this._myExtensions[I])&&(this._myExtensions.splice(I,1),I--);for(const I of n)this._allExtensions.push(I);for(const I of s)this._myExtensions.push(I);return this._myActivationEvents=null,t}containsExtension(t){for(const l of this._myExtensions)if(R.ExtensionIdentifier.equals(l,t))return!0;return!1}containsActivationEvent(t){return this._myActivationEvents||(this._myActivationEvents=this._readMyActivationEvents()),this._myActivationEvents.has(t)}_readMyActivationEvents(){const t=new Set;for(const l of this._allExtensions){if(!this.containsExtension(l.identifier))continue;const n=C.ImplicitActivationEvents.readActivationEvents(l);for(const h of n)t.add(h)}return t}}e.ExtensionHostExtensions=D;function y(v){const t=new R.ExtensionIdentifierMap;for(const l of v)t.set(l.identifier,l);return t}function d(v,t){return v.enabledApiProposals?v.enabledApiProposals.includes(t):!1}function E(v,t){if(!d(v,t))throw new Error(`Extension '${v.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${v.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${v.identifier.value}`)}class a{constructor(t,l,n,h){this.codeLoadingTime=t,this.activateCallTime=l,this.activateResolvedTime=n,this.activationReason=h}}e.ActivationTimes=a;class f{constructor(t,l){this.description=t,this.value=l}}e.ExtensionPointContribution=f;var m;(function(v){v[v.Normal=0]="Normal",v[v.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function p(v){return{type:v.isBuiltin?R.ExtensionType.System:R.ExtensionType.User,isBuiltin:v.isBuiltin||v.isUserBuiltin,identifier:{id:(0,w.getGalleryExtensionId)(v.publisher,v.name),uuid:v.uuid},manifest:v,location:v.extensionLocation,targetPlatform:v.targetPlatform,validations:[],isValid:!0}}function S(v,t){const l=(0,w.getExtensionId)(v.manifest.publisher,v.manifest.name);return{id:l,identifier:new R.ExtensionIdentifier(l),isBuiltin:v.type===R.ExtensionType.System,isUserBuiltin:v.type===R.ExtensionType.User&&v.isBuiltin,isUnderDevelopment:!!t,extensionLocation:v.location,uuid:v.identifier.uuid,targetPlatform:v.targetPlatform,publisherDisplayName:v.publisherDisplayName,...v.manifest}}class g{constructor(){this.onDidRegisterExtensions=i.Event.None,this.onDidChangeExtensionsStatus=i.Event.None,this.onDidChangeExtensions=i.Event.None,this.onWillActivateByEvent=i.Event.None,this.onDidChangeResponsiveChange=i.Event.None,this.onWillStop=i.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,l){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,l){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=g});var gt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ye[314],Ie([1,0,238,10,58,30,127,38,22,29,130,119]),function(se,e,i,r,w,C,R,_,b,o,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0,i=Be(i),w=gt(w);const d=_.Registry.as(R.Extensions.JSONContribution);class E{constructor(t,l,n){this._messageHandler=t,this._extension=l,this._extensionPointId=n}_msg(t,l){this._messageHandler({type:t,message:l,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(t){this._msg(w.default.Error,t)}warn(t){this._msg(w.default.Warning,t)}info(t){this._msg(w.default.Info,t)}}e.ExtensionMessageCollector=E;class a{static _toSet(t){const l=new b.ExtensionIdentifierSet;for(let n=0,h=t.length;n<h;n++)l.add(t[n].description.identifier);return l}static compute(t,l){if(!t||!t.length)return new a(l,[]);if(!l||!l.length)return new a([],t);const n=this._toSet(t),h=this._toSet(l),s=l.filter(u=>!n.has(u.description.identifier)),c=t.filter(u=>!h.has(u.description.identifier));return new a(s,c)}constructor(t,l){this.added=t,this.removed=l}}e.ExtensionPointUserDelta=a;class f{constructor(t,l){this.name=t,this.defaultExtensionKind=l,this._handler=null,this._users=null,this._delta=null}setHandler(t){if(this._handler!==null)throw new Error("Handler already set!");return this._handler=t,this._handle(),{dispose:()=>{this._handler=null}}}acceptUsers(t){this._delta=a.compute(this._users,t),this._users=t,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(t){(0,r.onUnexpectedError)(t)}}}e.ExtensionPoint=f;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[i.localize(0,null),i.localize(1,null)]},p="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:i.localize(2,null),properties:{vscode:{type:"string",description:i.localize(3,null),default:"^1.22.0"}}},publisher:{description:i.localize(4,null),type:"string"},displayName:{description:i.localize(5,null),type:"string"},categories:{description:i.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:b.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:i.localize(7,null)}]}},galleryBanner:{type:"object",description:i.localize(8,null),properties:{color:{description:i.localize(9,null),type:"string"},theme:{description:i.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:i.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:i.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:i.localize(13,null)},enabledApiProposals:{markdownDescription:i.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals).map(v=>v),markdownEnumDescriptions:Object.values(y.allApiProposals).map(v=>v.proposal)}},api:{markdownDescription:i.localize(15,null),type:"string",enum:["none"],enumDescriptions:[i.localize(16,null)]},activationEvents:{description:i.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:i.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:i.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:i.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:i.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:i.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:i.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:i.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:i.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:i.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:i.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:i.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:i.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:i.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:i.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:i.localize(32,null)},{label:"onUri",body:"onUri",description:i.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:i.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:i.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:i.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:i.localize(37,null)},{label:"onRenderer",description:i.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:i.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:i.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:i.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:i.localize(42,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:i.localize(43,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:i.localize(44,null)},{label:"*",description:i.localize(45,null),body:"*"}]}},badges:{type:"array",description:i.localize(46,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:i.localize(47,null)},href:{type:"string",description:i.localize(48,null)},description:{type:"string",description:i.localize(49,null)}}}},markdown:{type:"string",description:i.localize(50,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:i.localize(51,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:i.localize(52,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:C.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:i.localize(53,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:C.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:i.localize(54,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:i.localize(55,null)},{body:["workspace"],description:i.localize(56,null)},{body:["ui","workspace"],description:i.localize(57,null)},{body:["workspace","ui"],description:i.localize(58,null)},{body:[],description:i.localize(59,null)}]},capabilities:{description:i.localize(60,null),type:"object",properties:{virtualWorkspaces:{description:i.localize(61,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:i.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(63,null),i.localize(64,null),i.localize(65,null)]},description:{type:"string",markdownDescription:i.localize(66,null)}}},untrustedWorkspaces:{description:i.localize(67,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:i.localize(68,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(69,null),i.localize(70,null),i.localize(71,null)]},restrictedConfigurations:{description:i.localize(72,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:i.localize(73,null)}}}}},sponsor:{description:i.localize(74,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:i.localize(75,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:i.localize(76,null),type:"string"},"vscode:uninstall":{description:i.localize(77,null),type:"string"}}},icon:{type:"string",description:i.localize(78,null)},l10n:{type:"string",description:i.localize(79,null)},pricing:{type:"string",markdownDescription:i.localize(80,null),enum:["Free","Trial"],default:"Free"}}};class S{constructor(){this._extensionPoints=new Map}registerExtensionPoint(t){if(this._extensionPoints.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const l=new f(t.extensionPoint,t.defaultExtensionKind);return this._extensionPoints.set(t.extensionPoint,l),t.activationEventsGenerator&&D.ImplicitActivationEvents.register(t.extensionPoint,t.activationEventsGenerator),e.schema.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,d.registerSchema(p,e.schema),l}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=S;const g={ExtensionsRegistry:"ExtensionsRegistry"};_.Registry.add(g.ExtensionsRegistry,new S),e.ExtensionsRegistry=_.Registry.as(g.ExtensionsRegistry),d.registerSchema(p,e.schema),d.registerSchema(o.productSchemaId,{properties:{extensionEnabledApiProposals:{description:i.localize(81,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals).map(v=>v.proposal)}}]}}}})}),define(ye[315],Ie([1,0,6,40,2,17,235,22,5,12,313,314]),function(se,e,i,r,w,C,R,_,b,o,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelsService=e.languageModelExtensionPoint=e.ILanguageModelsService=e.ChatMessageRole=void 0;var d;(function(f){f[f.System=0]="System",f[f.User=1]="User",f[f.Assistant=2]="Assistant"})(d||(e.ChatMessageRole=d={})),e.ILanguageModelsService=(0,b.createDecorator)("ILanguageModelsService");const E={type:"object",properties:{vendor:{type:"string",description:(0,R.localize)(0,null)}}};e.languageModelExtensionPoint=y.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,R.localize)(1,null),oneOf:[E,{type:"array",items:E}]},activationEventsGenerator:(f,m)=>{for(const p of f)m.push(`onLanguageModelChat:${p.vendor}`)}});let a=class{constructor(m,p){this._extensionService=m,this._logService=p,this._store=new w.DisposableStore,this._providers=new Map,this._vendors=new Set,this._onDidChangeProviders=this._store.add(new i.Emitter),this.onDidChangeLanguageModels=this._onDidChangeProviders.event,this._store.add(e.languageModelExtensionPoint.setHandler(S=>{this._vendors.clear();for(const v of S){if(!(0,D.isProposedApiEnabled)(v.description,"chatProvider")){v.collector.error((0,R.localize)(2,null));continue}for(const t of r.Iterable.wrap(v.value)){if(this._vendors.has(t.vendor)){v.collector.error((0,R.localize)(3,null,t.vendor));continue}if((0,C.isFalsyOrWhitespace)(t.vendor)){v.collector.error((0,R.localize)(4,null));continue}if(t.vendor.trim()!==t.vendor){v.collector.error((0,R.localize)(5,null));continue}this._vendors.add(t.vendor)}}const g=[];for(const[v,t]of this._providers)this._vendors.has(t.metadata.vendor)||(this._providers.delete(v),g.push(v));g.length>0&&this._onDidChangeProviders.fire({removed:g})}))}dispose(){this._store.dispose(),this._providers.clear()}getLanguageModelIds(){return Array.from(this._providers.keys())}lookupLanguageModel(m){return this._providers.get(m)?.metadata}async selectLanguageModels(m){if(m.vendor)await this._extensionService.activateByEvent(`onLanguageModelChat:${m.vendor}}`);else{const S=Array.from(this._vendors).map(g=>this._extensionService.activateByEvent(`onLanguageModelChat:${g}`));await Promise.all(S)}const p=[];for(const[S,g]of this._providers)(m.vendor===void 0||g.metadata.vendor===m.vendor)&&(m.family===void 0||g.metadata.family===m.family)&&(m.version===void 0||g.metadata.version===m.version)&&(m.identifier===void 0||g.metadata.id===m.identifier)&&(!g.metadata.targetExtensions||g.metadata.targetExtensions.some(v=>_.ExtensionIdentifier.equals(v,m.extension)))&&p.push(S);return this._logService.trace("[LM] selected language models",m,p),p}registerLanguageModelChat(m,p){if(this._logService.trace("[LM] registering language model chat",m,p.metadata),!this._vendors.has(p.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${p.metadata.vendor}.`);if(this._providers.has(m))throw new Error(`Chat response provider with identifier ${m} is already registered.`);return this._providers.set(m,p),this._onDidChangeProviders.fire({added:[{identifier:m,metadata:p.metadata}]}),(0,w.toDisposable)(()=>{this._providers.delete(m)&&(this._onDidChangeProviders.fire({removed:[m]}),this._logService.trace("[LM] UNregistered language model chat",m,p.metadata))})}async sendChatRequest(m,p,S,g,v){const t=this._providers.get(m);if(!t)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return t.sendChatRequest(S,p,g,v)}computeTokenLength(m,p,S){const g=this._providers.get(m);if(!g)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return g.provideTokenCount(p,S)}};e.LanguageModelsService=a,e.LanguageModelsService=a=ze([Me(0,D.IExtensionService),Me(1,o.ILogService)],a)}),define(ye[316],Ie([1,0,22,239,63]),function(se,e,i,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.dedupExtensions=C,w=Be(w);function C(R,_,b,o,D){const y=new i.ExtensionIdentifierMap;return R.forEach(d=>{const E=y.get(d.identifier);E&&D.warn((0,r.localize)(0,null,E.extensionLocation.fsPath,d.extensionLocation.fsPath)),y.set(d.identifier,d)}),_.forEach(d=>{const E=y.get(d.identifier);if(E)if(E.isBuiltin){if(w.gte(E.version,d.version)){D.warn(`Skipping extension ${d.extensionLocation.path} in favour of the builtin extension ${E.extensionLocation.path}.`);return}d.isBuiltin=!0}else D.warn((0,r.localize)(1,null,E.extensionLocation.fsPath,d.extensionLocation.fsPath));else if(d.isBuiltin){D.warn(`Skipping obsolete builtin extension ${d.extensionLocation.path}`);return}y.set(d.identifier,d)}),b.forEach(d=>{const E=y.get(d.identifier);E&&D.warn((0,r.localize)(2,null,E.extensionLocation.fsPath,d.extensionLocation.fsPath)),y.set(d.identifier,d)}),o.forEach(d=>{D.info((0,r.localize)(3,null,d.extensionLocation.fsPath));const E=y.get(d.identifier);E&&E.isBuiltin&&(d.isBuiltin=!0),y.set(d.identifier,d)}),Array.from(y.values())}}),define(ye[317],Ie([1,0,9,3,33,4,44,59,42,64,22,316,13]),function(se,e,i,r,w,C,R,_,b,o,D,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteExtensionsScannerChannel=e.RemoteExtensionsScannerService=void 0,r=Be(r),R=Be(R);class E{constructor(m,p,S,g,v,t,l){this._extensionManagementCLI=m,this._userDataProfilesService=S,this._extensionsScannerService=g,this._logService=v,this._extensionGalleryService=t,this._languagePackService=l,this._whenBuiltinExtensionsReady=Promise.resolve(),this._whenExtensionsReady=Promise.resolve();const n=p.args["install-builtin-extension"];if(n){v.trace("Installing builtin extensions passed via args...");const s={isMachineScoped:!!p.args["do-not-sync"],installPreReleaseVersion:!!p.args["pre-release"]};R.mark("code/server/willInstallBuiltinExtensions"),this._whenExtensionsReady=this._whenBuiltinExtensionsReady=m.installExtensions([],this._asExtensionIdOrVSIX(n),s,!!p.args.force).then(()=>{R.mark("code/server/didInstallBuiltinExtensions"),v.trace("Finished installing builtin extensions")},c=>{v.error(c)})}const h=p.args["install-extension"];h&&(v.trace("Installing extensions passed via args..."),this._whenExtensionsReady=this._whenBuiltinExtensionsReady.then(()=>m.installExtensions(this._asExtensionIdOrVSIX(h),[],{isMachineScoped:!!p.args["do-not-sync"],installPreReleaseVersion:!!p.args["pre-release"],isApplicationScoped:!0},!!p.args.force)).then(()=>{v.trace("Finished installing extensions")},s=>{v.error(s)}))}_asExtensionIdOrVSIX(m){return m.map(p=>/\.vsix$/i.test(p)?C.URI.file((0,i.isAbsolute)(p)?p:(0,i.join)((0,w.cwd)(),p)):p)}whenExtensionsReady(){return this._whenExtensionsReady}async scanExtensions(m,p,S,g,v){R.mark("code/server/willScanExtensions"),this._logService.trace(`Scanning extensions using UI language: ${m}`),await this._whenBuiltinExtensionsReady;const t=g?g.filter(n=>n.scheme===d.Schemas.file).map(n=>n.fsPath):void 0;p=p??this._userDataProfilesService.defaultProfile.extensionsResource;const l=await this._scanExtensions(p,m??r.language,S,t,v);return this._logService.trace("Scanned Extensions",l),this._massageWhenConditions(l),R.mark("code/server/didScanExtensions"),l}async _scanExtensions(m,p,S,g,v){await this._ensureLanguagePackIsInstalled(p,v);const[t,l,n,h]=await Promise.all([this._scanBuiltinExtensions(p),this._scanInstalledExtensions(m,p),this._scanWorkspaceInstalledExtensions(p,S),this._scanDevelopedExtensions(p,g)]);return(0,y.dedupExtensions)(t,l,n,h,this._logService)}async _scanDevelopedExtensions(m,p){return p?(await Promise.all(p.map(S=>this._extensionsScannerService.scanOneOrMultipleExtensions(C.URI.file((0,i.resolve)(S)),D.ExtensionType.User,{language:m})))).flat().map(S=>(0,o.toExtensionDescription)(S,!0)):[]}async _scanWorkspaceInstalledExtensions(m,p){const S=[];if(p?.length){const g=await Promise.all(p.map(v=>this._extensionsScannerService.scanExistingExtension(v,D.ExtensionType.User,{language:m})));for(const v of g)v&&S.push((0,o.toExtensionDescription)(v,!1))}return S}async _scanBuiltinExtensions(m){return(await this._extensionsScannerService.scanSystemExtensions({language:m,useCache:!0})).map(S=>(0,o.toExtensionDescription)(S,!1))}async _scanInstalledExtensions(m,p){return(await this._extensionsScannerService.scanUserExtensions({profileLocation:m,language:p,useCache:!0})).map(g=>(0,o.toExtensionDescription)(g,!1))}async _ensureLanguagePackIsInstalled(m,p){if(!(m===r.LANGUAGE_DEFAULT||!this._extensionGalleryService.isEnabled())){try{if((await this._languagePackService.getInstalledLanguages()).find(g=>g.id===m)){this._logService.trace(`Language Pack ${m} is already installed. Skipping language pack installation.`);return}}catch(S){this._logService.error(S)}if(!p){this._logService.trace(`No language pack id provided for language ${m}. Skipping language pack installation.`);return}this._logService.trace(`Language Pack ${p} for language ${m} is not installed. It will be installed now.`);try{await this._extensionManagementCLI.installExtensions([p],[],{isMachineScoped:!0},!0)}catch(S){this._logService.error(S)}}}_massageWhenConditions(m){const p=(n,h)=>n.replace(/file/g,"vscode-remote"),S=n=>{let h="";return h+=n.global?"g":"",h+=n.ignoreCase?"i":"",h+=n.multiline?"m":"",new RegExp(p(n.source,!0),h)},g=new class{mapDefined(n){return b.ContextKeyDefinedExpr.create(n)}mapNot(n){return b.ContextKeyNotExpr.create(n)}mapEquals(n,h){return n==="resourceScheme"&&typeof h=="string"?b.ContextKeyEqualsExpr.create(n,p(h,!1)):b.ContextKeyEqualsExpr.create(n,h)}mapNotEquals(n,h){return n==="resourceScheme"&&typeof h=="string"?b.ContextKeyNotEqualsExpr.create(n,p(h,!1)):b.ContextKeyNotEqualsExpr.create(n,h)}mapGreater(n,h){return b.ContextKeyGreaterExpr.create(n,h)}mapGreaterEquals(n,h){return b.ContextKeyGreaterEqualsExpr.create(n,h)}mapSmaller(n,h){return b.ContextKeySmallerExpr.create(n,h)}mapSmallerEquals(n,h){return b.ContextKeySmallerEqualsExpr.create(n,h)}mapRegex(n,h){return n==="resourceScheme"&&h?b.ContextKeyRegexExpr.create(n,S(h)):b.ContextKeyRegexExpr.create(n,h)}mapIn(n,h){return b.ContextKeyInExpr.create(n,h)}mapNotIn(n,h){return b.ContextKeyNotInExpr.create(n,h)}},v=n=>{if(!n||!n.when||!/resourceScheme/.test(n.when))return;const h=b.ContextKeyExpr.deserialize(n.when);if(!h)return;const s=h.map(g);n.when=s.serialize()},t=n=>{if(Array.isArray(n))for(const h of n)v(h);else v(n)},l=n=>{for(const h in n)t(n[h])};m.forEach(n=>{n.contributes&&(n.contributes.menus&&l(n.contributes.menus),n.contributes.keybindings&&t(n.contributes.keybindings),n.contributes.views&&l(n.contributes.views))})}}e.RemoteExtensionsScannerService=E;class a{constructor(m,p){this.service=m,this.getUriTransformer=p}listen(m,p){throw new Error("Invalid listen")}async call(m,p,S){const g=this.getUriTransformer(m);switch(p){case"whenExtensionsReady":return this.service.whenExtensionsReady();case"scanExtensions":{const v=S[0],t=S[1]?C.URI.revive(g.transformIncoming(S[1])):void 0,l=Array.isArray(S[2])?S[2].map(c=>C.URI.revive(g.transformIncoming(c))):void 0,n=Array.isArray(S[3])?S[3].map(c=>C.URI.revive(g.transformIncoming(c))):void 0,h=S[4];return(await this.service.scanExtensions(v,t,l,n,h)).map(c=>(0,_.transformOutgoingURIs)(c,g))}}throw new Error("Invalid call")}}e.RemoteExtensionsScannerChannel=a}),define(ye[151],Ie([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.ProxyIdentifier=void 0,e.createProxyIdentifier=w,e.getStringIdentifierForProxy=C;class i{static{this.count=0}constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++i.count}}e.ProxyIdentifier=i;const r=[];function w(_){const b=new i(_);return r[b.nid]=b,b}function C(_){return r[_].sid}class R{constructor(b){this.value=b}}e.SerializableObjectWithBuffers=R}),define(ye[318],Ie([1,0,151]),function(se,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var r;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(r||(e.TextEditorRevealType=r={}));var w;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput",f[f.ChatEditorInput=10]="ChatEditorInput",f[f.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(w||(e.TabInputKind=w={}));var C;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(C||(e.TabModelOperationKind=C={}));var R;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var _;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(_||(e.WebviewMessageArrayBufferViewType=_={}));var b;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(b||(e.CellOutputKind=b={}));var o;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(o||(e.NotebookEditorRevealType=o={}));var D;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output",f[f.Hybrid=3]="Hybrid"})(D||(e.CandidatePortSource=D={}));class y{static{this._n=0}static mixin(m){return m._id=y._n++,m}}e.IdObject=y;var d;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(d||(e.ISuggestDataDtoField=d={}));var E;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var a;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(a||(e.ExtHostTestingResource=a={})),e.MainContext={MainThreadAuthentication:(0,i.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,i.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,i.createProxyIdentifier)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,i.createProxyIdentifier)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,i.createProxyIdentifier)("MainThreadChatAgents2"),MainThreadChatVariables:(0,i.createProxyIdentifier)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,i.createProxyIdentifier)("MainThreadChatSkills"),MainThreadClipboard:(0,i.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,i.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,i.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,i.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,i.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,i.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,i.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,i.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,i.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,i.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,i.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,i.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,i.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,i.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,i.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,i.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,i.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,i.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,i.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,i.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,i.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,i.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,i.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,i.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,i.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,i.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,i.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,i.createProxyIdentifier)("MainThreadStorage"),MainThreadSpeech:(0,i.createProxyIdentifier)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,i.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,i.createProxyIdentifier)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,i.createProxyIdentifier)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,i.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,i.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,i.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,i.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,i.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,i.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,i.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,i.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,i.createProxyIdentifier)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,i.createProxyIdentifier)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,i.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,i.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,i.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,i.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,i.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,i.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,i.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,i.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,i.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,i.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,i.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,i.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,i.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,i.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,i.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,i.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,i.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,i.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,i.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,i.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,i.createProxyIdentifier)("MainThreadAiEmbeddingVector")},e.ExtHostContext={ExtHostCommands:(0,i.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,i.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,i.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,i.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,i.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,i.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,i.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,i.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,i.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,i.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,i.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,i.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,i.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,i.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,i.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,i.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,i.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,i.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,i.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,i.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,i.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,i.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,i.createProxyIdentifier)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,i.createProxyIdentifier)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,i.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,i.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,i.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,i.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,i.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,i.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,i.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,i.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,i.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,i.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,i.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,i.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,i.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,i.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,i.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,i.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,i.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,i.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,i.createProxyIdentifier)("ExtHostOutputService"),ExtHostLabelService:(0,i.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,i.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,i.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,i.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,i.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,i.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,i.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,i.createProxyIdentifier)("ExtHostInteractive"),ExtHostChatAgents2:(0,i.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,i.createProxyIdentifier)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,i.createProxyIdentifier)("ExtHostChatSkills"),ExtHostChatProvider:(0,i.createProxyIdentifier)("ExtHostChatProvider"),ExtHostSpeech:(0,i.createProxyIdentifier)("ExtHostSpeech"),ExtHostEmbeddings:(0,i.createProxyIdentifier)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,i.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,i.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,i.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,i.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,i.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,i.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,i.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,i.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,i.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,i.createProxyIdentifier)("ExtHostLocalization")}}),define(ye[319],Ie([1,0,15,26,13,120,5]),function(se,e,i,r,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookDocumentWorkbenchService=e.INotebookDocumentService=void 0,e.parse=D,e.generate=y,e.INotebookDocumentService=(0,R.createDecorator)("notebookDocumentService");const _=["W","X","Y","Z","a","b","c","d","e","f"],b=new RegExp(`^[${_.join("")}]+`),o=7;function D(E){if(E.scheme!==w.Schemas.vscodeNotebookCell)return;const a=E.fragment.indexOf("s");if(a<0)return;const f=parseInt(E.fragment.substring(0,a).replace(b,""),o),m=(0,i.decodeBase64)(E.fragment.substring(a+1)).toString();if(!isNaN(f))return{handle:f,notebook:E.with({scheme:m,fragment:null})}}function y(E,a){const f=a.toString(o),p=`${f.length<_.length?_[f.length-1]:"z"}${f}s${(0,i.encodeBase64)(i.VSBuffer.fromString(E.scheme),!0,!0)}`;return E.with({scheme:w.Schemas.vscodeNotebookCell,fragment:p})}class d{constructor(){this._documents=new r.ResourceMap}getNotebook(a){if(a.scheme===w.Schemas.vscodeNotebookCell){const f=D(a);if(f){const m=this._documents.get(f.notebook);if(m)return m}}return this._documents.get(a)}addNotebookDocument(a){this._documents.set(a.uri,a)}removeNotebookDocument(a){this._documents.delete(a.uri)}}e.NotebookDocumentWorkbenchService=d,(0,C.registerSingleton)(e.INotebookDocumentService,d,C.InstantiationType.Delayed)}),define(ye[152],Ie([1,0,15,86,40,68,13,9,3,42,319]),function(se,e,i,r,w,C,R,_,b,o,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.NotebookFindScopeType=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.EXECUTE_REPL_COMMAND_ID=e.REPL_EDITOR_ID=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.diff=n,e.isDocumentExcludePattern=c,e.notebookDocumentFilterMatch=u,e.isTextStreamMime=A,e.compressOutputItemStreams=k,r=Be(r),e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive",e.REPL_EDITOR_ID="workbench.editor.repl",e.EXECUTE_REPL_COMMAND_ID="replNotebook.input.execute";var y;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(y||(e.CellKind=y={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",C.Mimes.latex,C.Mimes.markdown,"image/png","image/jpeg",C.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[C.Mimes.latex,C.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",C.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var d;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(d||(e.NotebookRunState=d={}));var E;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var a;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(a||(e.NotebookExecutionState=a={}));var f;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(f||(e.NotebookRendererMatch=f={}));var m;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var p;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(p||(e.NotebookCellsChangeType=p={}));var S;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(S||(e.SelectionStateType=S={}));var g;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(g||(e.CellEditType=g={}));var v;(function(K){K.scheme=R.Schemas.vscodeNotebookCell;function ae(H,ce){return(0,D.generate)(H,ce)}K.generate=ae;function x(H){return(0,D.parse)(H)}K.parse=x;function z(H,ce){return H.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${ce??""},${H.scheme!==R.Schemas.file?H.scheme:""}`})}K.generateCellOutputUri=z;function ne(H){if(H.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const ce=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(H.fragment);if(!ce)return;const J=ce[1]&&ce[1]!==""?ce[1]:void 0,W=ce[2];return{outputId:J,notebook:H.with({scheme:W||R.Schemas.file,fragment:null})}}K.parseCellOutputUri=ne;function le(H,ce,J){return K.generate(H,ce).with({scheme:J})}K.generateCellPropertyUri=le;function ve(H,ce){if(H.scheme===ce)return K.parse(H.with({scheme:K.scheme}))}K.parseCellPropertyUri=ve})(v||(e.CellUri=v={}));const t=K=>b.isWindows?K.replace(/\//g,"\\"):K;class l{constructor(ae=[],x=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=x,this.order=[...new Set(ae)].map(z=>({pattern:z,matches:r.parse(t(z))}))}sort(ae){const x=new Map(w.Iterable.map(ae,ne=>[ne,t(ne)]));let z=[];for(const{matches:ne}of this.order)for(const[le,ve]of x)if(ne(ve)){z.push(le),x.delete(le);break}return x.size&&(z=z.concat([...x.keys()].sort((ne,le)=>this.defaultOrder.indexOf(ne)-this.defaultOrder.indexOf(le)))),z}prioritize(ae,x){const z=this.findIndex(ae);if(z===-1){this.order.unshift({pattern:ae,matches:r.parse(t(ae))});return}const ne=new Set(x.map(ve=>this.findIndex(ve,z)));ne.delete(-1);const le=Array.from(ne).sort();this.order.splice(z+1,0,...le.map(ve=>this.order[ve]));for(let ve=le.length-1;ve>=0;ve--)this.order.splice(le[ve],1)}toArray(){return this.order.map(ae=>ae.pattern)}findIndex(ae,x=this.order.length){const z=t(ae);for(let ne=0;ne<x;ne++)if(this.order[ne].matches(z))return ne;return-1}}e.MimeTypeDisplayOrder=l;function n(K,ae,x,z=(ne,le)=>ne===le){const ne=[];function le(ce,J,W){if(J===0&&W.length===0)return;const L=ne[ne.length-1];L&&L.start+L.deleteCount===ce?(L.deleteCount+=J,L.toInsert.push(...W)):ne.push({start:ce,deleteCount:J,toInsert:W})}let ve=0,H=0;for(;;){if(ve===K.length){le(ve,0,ae.slice(H));break}if(H===ae.length){le(ve,K.length-ve,[]);break}const ce=K[ve],J=ae[H];if(z(ce,J)){ve+=1,H+=1;continue}x(J)?(le(ve,1,[]),ve+=1):(le(ve,0,[J]),H+=1)}return ne}e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new o.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new o.RawContextKey("notebookEditorCursorAtLineBoundary","none");var h;(function(K){K.default="default",K.option="option"})(h||(e.NotebookEditorPriority=h={}));var s;(function(K){K.Cells="cells",K.Text="text",K.None="none"})(s||(e.NotebookFindScopeType=s={}));function c(K){const ae=K;return!!((typeof ae.include=="string"||r.isRelativePattern(ae.include))&&(typeof ae.exclude=="string"||r.isRelativePattern(ae.exclude)))}function u(K,ae,x){if(Array.isArray(K.viewType)&&K.viewType.indexOf(ae)>=0||K.viewType===ae)return!0;if(K.filenamePattern){const z=c(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,ne=c(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(r.match(z,(0,_.basename)(x.fsPath).toLowerCase()))return!(ne&&r.match(ne,(0,_.basename)(x.fsPath).toLowerCase()))}return!1}e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var I;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(I||(e.CellStatusbarAlignment=I={}));class T{static{this._prefix="notebook/"}static create(ae){return`${T._prefix}${ae}`}static parse(ae){if(ae.startsWith(T._prefix))return ae.substring(T._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=T;function A(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const O=new TextDecoder;function k(K){const ae=[];let x=!1;for(const ve of K)(ae.length===0||x)&&(ae.push(ve),x=!0);let z=Y(ae);const ne=i.VSBuffer.concat(ae.map(ve=>i.VSBuffer.wrap(ve))),le=fe(ne);return z=z||le.byteLength!==ne.byteLength,{data:le,didCompression:z}}e.MOVE_CURSOR_1_LINE_COMMAND="\x1B[A";const P=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(K=>K.charCodeAt(0)),B=10;function Y(K){let ae=!1;return K.forEach((x,z)=>{if(z===0||x.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const ne=K[z-1],le=x.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(le[0]===P[0]&&le[1]===P[1]&&le[2]===P[2]){const ve=ne.lastIndexOf(B);if(ve===-1)return;ae=!0,K[z-1]=ne.subarray(0,ve),K[z]=x.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),ae}function X(K){let ae=K;do K=ae,ae=K.replace(/[^\n]\x08/gm,"");while(ae.length<K.length);return K}function re(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const ae=K.match(/^(.*)\r+/m)[1];let x=K.match(/\r+(.*)$/m)[1];x=x+ae.slice(x.length,ae.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,x)}return K}const te=8,Z=13;function fe(K){return!K.buffer.includes(te)&&!K.buffer.includes(Z)?K:i.VSBuffer.fromString(re(X(O.decode(K.buffer))))}}),define(ye[153],Ie([1,0,18,10,111,26,68,17,11,4,23,22,16,90,152]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a){"use strict";var f,m,p,S,g,v,t,l,n,h,s,c,u,I,T,A,O;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.InlineEdit=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.LanguageModelError=e.LanguageModelChatAssistantMessage=e.LanguageModelChatUserMessage=e.LanguageModelChatSystemMessage=e.LanguageModelTextPart=e.LanguageModelFunctionUsePart=e.LanguageModelChatMessage=e.LanguageModelFunctionResultPart=e.LanguageModelChatMessageRole=e.ChatLocation=e.ChatResponseTurn=e.ChatRequestTurn=e.ChatResponseTextEditPart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseWarningPart=e.ChatResponseProgressPart2=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFileTreePart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.ChatCompletionItem=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.TextMultiDiffTabInput=e.ChatEditorTabInput=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.DeclarationCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.TestCoverageCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookVariablesRequestKind=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugVisualization=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.NewSymbolName=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugThread=e.DebugStackFrame=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropOrPasteEditKind=e.DocumentPasteTriggerKind=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.DocumentHighlightKind=e.HoverVerbosityAction=e.VerboseHover=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.asStatusBarItemIdentifier=Ge,e.setBreakpointId=wi,e.validateTestCoverageCount=dn;function k(M){return Object.assign(M,{apply:function(...ue){if(ue.length===0)return Reflect.construct(M,[]);{const Pe=ue.length===1?[]:ue[1];return Reflect.construct(M,Pe,ue[0].constructor)}},call:function(...ue){if(ue.length===0)return Reflect.construct(M,[]);{const[Pe,...$e]=ue;return Reflect.construct(M,$e,Pe.constructor)}}})}var P;(function(M){M[M.Top=0]="Top",M[M.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var B;(function(M){M[M.TerminalCommand=0]="TerminalCommand",M[M.Opener=1]="Opener",M[M.Command=3]="Command"})(B||(e.TerminalQuickFixType=B={}));let Y=f=class{static from(...N){let ue=N;return new f(function(){if(ue){for(const Pe of ue)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();ue=void 0}})}#e;constructor(N){this.#e=N}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=Y,e.Disposable=Y=f=ze([k],Y);let X=m=class{static Min(...N){if(N.length===0)throw new TypeError;let ue=N[0];for(let Pe=1;Pe<N.length;Pe++){const $e=N[Pe];$e.isBefore(ue)&&(ue=$e)}return ue}static Max(...N){if(N.length===0)throw new TypeError;let ue=N[0];for(let Pe=1;Pe<N.length;Pe++){const $e=N[Pe];$e.isAfter(ue)&&(ue=$e)}return ue}static isPosition(N){if(!N)return!1;if(N instanceof m)return!0;const{line:ue,character:Pe}=N;return typeof ue=="number"&&typeof Pe=="number"}static of(N){if(N instanceof m)return N;if(this.isPosition(N))return new m(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(N,ue){if(N<0)throw(0,r.illegalArgument)("line must be non-negative");if(ue<0)throw(0,r.illegalArgument)("character must be non-negative");this._line=N,this._character=ue}isBefore(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<N._character}isBeforeOrEqual(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<=N._character}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this._line===N._line&&this._character===N._character}compareTo(N){return this._line<N._line?-1:this._line>N.line?1:this._character<N._character?-1:this._character>N._character?1:0}translate(N,ue=0){if(N===null||ue===null)throw(0,r.illegalArgument)();let Pe;return typeof N>"u"?Pe=0:typeof N=="number"?Pe=N:(Pe=typeof N.lineDelta=="number"?N.lineDelta:0,ue=typeof N.characterDelta=="number"?N.characterDelta:0),Pe===0&&ue===0?this:new m(this.line+Pe,this.character+ue)}with(N,ue=this.character){if(N===null||ue===null)throw(0,r.illegalArgument)();let Pe;return typeof N>"u"?Pe=this.line:typeof N=="number"?Pe=N:(Pe=typeof N.line=="number"?N.line:this.line,ue=typeof N.character=="number"?N.character:this.character),Pe===this.line&&ue===this.character?this:new m(Pe,ue)}toJSON(){return{line:this.line,character:this.character}}};e.Position=X,e.Position=X=m=ze([k],X);let re=p=class{static isRange(N){return N instanceof p?!0:N?X.isPosition(N.start)&&X.isPosition(N.end):!1}static of(N){if(N instanceof p)return N;if(this.isRange(N))return new p(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(N,ue,Pe,$e){let Ye,at;if(typeof N=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof $e=="number"?(Ye=new X(N,ue),at=new X(Pe,$e)):X.isPosition(N)&&X.isPosition(ue)&&(Ye=X.of(N),at=X.of(ue)),!Ye||!at)throw new Error("Invalid arguments");Ye.isBefore(at)?(this._start=Ye,this._end=at):(this._start=at,this._end=Ye)}contains(N){return p.isRange(N)?this.contains(N.start)&&this.contains(N.end):X.isPosition(N)?!(X.of(N).isBefore(this._start)||this._end.isBefore(N)):!1}isEqual(N){return this._start.isEqual(N._start)&&this._end.isEqual(N._end)}intersection(N){const ue=X.Max(N.start,this._start),Pe=X.Min(N.end,this._end);if(!ue.isAfter(Pe))return new p(ue,Pe)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const ue=X.Min(N.start,this._start),Pe=X.Max(N.end,this.end);return new p(ue,Pe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(N,ue=this.end){if(N===null||ue===null)throw(0,r.illegalArgument)();let Pe;return N?X.isPosition(N)?Pe=N:(Pe=N.start||this.start,ue=N.end||this.end):Pe=this.start,Pe.isEqual(this._start)&&ue.isEqual(this.end)?this:new p(Pe,ue)}toJSON(){return[this.start,this.end]}};e.Range=re,e.Range=re=p=ze([k],re);let te=S=class extends re{static isSelection(N){return N instanceof S?!0:N?re.isRange(N)&&X.isPosition(N.anchor)&&X.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(N,ue,Pe,$e){let Ye,at;if(typeof N=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof $e=="number"?(Ye=new X(N,ue),at=new X(Pe,$e)):X.isPosition(N)&&X.isPosition(ue)&&(Ye=X.of(N),at=X.of(ue)),!Ye||!at)throw new Error("Invalid arguments");super(Ye,at),this._anchor=Ye,this._active=at}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=te,e.Selection=te=S=ze([k],te);const Z=M=>{if(typeof M!="string"||M.length===0||!/^[0-9A-Za-z_\-]+$/.test(M))throw(0,r.illegalArgument)("connectionToken")};class fe{static isResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.host=="string"&&typeof N.port=="number"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,ue,Pe){if(typeof N!="string"||N.length===0)throw(0,r.illegalArgument)("host");if(typeof ue!="number"||ue===0||Math.round(ue)!==ue)throw(0,r.illegalArgument)("port");typeof Pe<"u"&&Z(Pe),this.host=N,this.port=Math.round(ue),this.connectionToken=Pe}}e.ResolvedAuthority=fe;class K{static isManagedResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.makeConnection=="function"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,ue){this.makeConnection=N,this.connectionToken=ue,typeof ue<"u"&&Z(ue)}}e.ManagedResolvedAuthority=K;class ae extends Error{static NotAvailable(N,ue){return new ae(N,E.RemoteAuthorityResolverErrorCode.NotAvailable,ue)}static TemporarilyNotAvailable(N){return new ae(N,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,ue=E.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(N),this._message=N,this._code=ue,this._detail=Pe,Object.setPrototypeOf(this,ae.prototype)}}e.RemoteAuthorityResolverError=ae;var x;(function(M){M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(x||(e.EndOfLine=x={}));var z;(function(M){M[M.Replace=1]="Replace",M[M.Append=2]="Append",M[M.Prepend=3]="Prepend"})(z||(e.EnvironmentVariableMutatorType=z={}));let ne=g=class{static isTextEdit(N){return N instanceof g?!0:N?re.isRange(N)&&typeof N.newText=="string":!1}static replace(N,ue){return new g(N,ue)}static insert(N,ue){return g.replace(new re(N,N),ue)}static delete(N){return g.replace(N,"")}static setEndOfLine(N){const ue=new g(new re(new X(0,0),new X(0,0)),"");return ue.newEol=N,ue}get range(){return this._range}set range(N){if(N&&!re.isRange(N))throw(0,r.illegalArgument)("range");this._range=N}get newText(){return this._newText||""}set newText(N){if(N&&typeof N!="string")throw(0,r.illegalArgument)("newText");this._newText=N}get newEol(){return this._newEol}set newEol(N){if(N&&typeof N!="number")throw(0,r.illegalArgument)("newEol");this._newEol=N}constructor(N,ue){this._range=N,this._newText=ue}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=ne,e.TextEdit=ne=g=ze([k],ne);let le=v=class{static isNotebookCellEdit(N){return N instanceof v?!0:N?ui.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,ue){return new v(N,ue)}static insertCells(N,ue){return new v(new ui(N,N),ue)}static deleteCells(N){return new v(N,[])}static updateCellMetadata(N,ue){const Pe=new v(new ui(N,N),[]);return Pe.newCellMetadata=ue,Pe}static updateNotebookMetadata(N){const ue=new v(new ui(0,0),[]);return ue.newNotebookMetadata=N,ue}constructor(N,ue){this.range=N,this.newCells=ue}};e.NotebookEdit=le,e.NotebookEdit=le=v=ze([k],le);class ve{static isSnippetTextEdit(N){return N instanceof ve?!0:N?re.isRange(N.range)&&J.isSnippetString(N.snippet):!1}static replace(N,ue){return new ve(N,ue)}static insert(N,ue){return ve.replace(new re(N,N),ue)}constructor(N,ue){this.range=N,this.snippet=ue}}e.SnippetTextEdit=ve;var H;(function(M){M[M.File=1]="File",M[M.Text=2]="Text",M[M.Cell=3]="Cell",M[M.CellReplace=5]="CellReplace",M[M.Snippet=6]="Snippet"})(H||(e.FileEditType=H={}));let ce=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(N,ue,Pe,$e){this._edits.push({_type:H.File,from:N,to:ue,options:Pe,metadata:$e})}createFile(N,ue,Pe){this._edits.push({_type:H.File,from:void 0,to:N,options:ue,metadata:Pe})}deleteFile(N,ue,Pe){this._edits.push({_type:H.File,from:N,to:void 0,options:ue,metadata:Pe})}replaceNotebookMetadata(N,ue,Pe){this._edits.push({_type:H.Cell,metadata:Pe,uri:N,edit:{editType:a.CellEditType.DocumentMetadata,metadata:ue},notebookMetadata:ue})}replaceNotebookCells(N,ue,Pe,$e){const Ye=ue.start,at=ue.end;(Ye!==at||Pe.length>0)&&this._edits.push({_type:H.CellReplace,uri:N,index:Ye,count:at-Ye,cells:Pe,metadata:$e})}replaceNotebookCellMetadata(N,ue,Pe,$e){this._edits.push({_type:H.Cell,metadata:$e,uri:N,edit:{editType:a.CellEditType.Metadata,index:ue,metadata:Pe}})}replace(N,ue,Pe,$e){this._edits.push({_type:H.Text,uri:N,edit:new ne(ue,Pe),metadata:$e})}insert(N,ue,Pe,$e){this.replace(N,new re(ue,ue),Pe,$e)}delete(N,ue,Pe){this.replace(N,ue,"",Pe)}has(N){return this._edits.some(ue=>ue._type===H.Text&&ue.uri.toString()===N.toString())}set(N,ue){if(ue)for(const Pe of ue){if(!Pe)continue;let $e,Ye;Array.isArray(Pe)?($e=Pe[0],Ye=Pe[1]):$e=Pe,le.isNotebookCellEdit($e)?$e.newCellMetadata?this.replaceNotebookCellMetadata(N,$e.range.start,$e.newCellMetadata,Ye):$e.newNotebookMetadata?this.replaceNotebookMetadata(N,$e.newNotebookMetadata,Ye):this.replaceNotebookCells(N,$e.range,$e.newCells,Ye):ve.isSnippetTextEdit($e)?this._edits.push({_type:H.Snippet,uri:N,range:$e.range,edit:$e.snippet,metadata:Ye}):this._edits.push({_type:H.Text,uri:N,edit:$e,metadata:Ye})}else{for(let Pe=0;Pe<this._edits.length;Pe++){const $e=this._edits[Pe];switch($e._type){case H.Text:case H.Snippet:case H.Cell:case H.CellReplace:$e.uri.toString()===N.toString()&&(this._edits[Pe]=void 0);break}}(0,i.coalesceInPlace)(this._edits)}}get(N){const ue=[];for(const Pe of this._edits)Pe._type===H.Text&&Pe.uri.toString()===N.toString()&&ue.push(Pe.edit);return ue}entries(){const N=new C.ResourceMap;for(const ue of this._edits)if(ue._type===H.Text){let Pe=N.get(ue.uri);Pe||(Pe=[ue.uri,[]],N.set(ue.uri,Pe)),Pe[1].push(ue.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=ce,e.WorkspaceEdit=ce=ze([k],ce);let J=t=class{static isSnippetString(N){return N instanceof t?!0:N?typeof N.value=="string":!1}static _escape(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this._tabstop=1,this.value=N||""}appendText(N){return this.value+=t._escape(N),this}appendTabstop(N=this._tabstop++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,ue=this._tabstop++){if(typeof N=="function"){const Pe=new t;Pe._tabstop=this._tabstop,N(Pe),this._tabstop=Pe._tabstop,N=Pe.value}else N=t._escape(N);return this.value+="${",this.value+=ue,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,ue=this._tabstop++){const Pe=N.map($e=>$e.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ue,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(N,ue){if(typeof ue=="function"){const Pe=new t;Pe._tabstop=this._tabstop,ue(Pe),this._tabstop=Pe._tabstop,ue=Pe.value}else typeof ue=="string"&&(ue=ue.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,ue&&(this.value+=":",this.value+=ue),this.value+="}",this}};e.SnippetString=J,e.SnippetString=J=t=ze([k],J);var W;(function(M){M[M.Unnecessary=1]="Unnecessary",M[M.Deprecated=2]="Deprecated"})(W||(e.DiagnosticTag=W={}));var L;(function(M){M[M.Hint=3]="Hint",M[M.Information=2]="Information",M[M.Warning=1]="Warning",M[M.Error=0]="Error"})(L||(e.DiagnosticSeverity=L={}));let Q=l=class{static isLocation(N){return N instanceof l?!0:N?re.isRange(N.range)&&o.URI.isUri(N.uri):!1}constructor(N,ue){if(this.uri=N,ue)if(re.isRange(ue))this.range=re.of(ue);else if(X.isPosition(ue))this.range=new re(ue,ue);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=Q,e.Location=Q=l=ze([k],Q);let $=class{static is(N){return N?typeof N.message=="string"&&N.location&&re.isRange(N.location.range)&&o.URI.isUri(N.location.uri):!1}constructor(N,ue){this.location=N,this.message=ue}static isEqual(N,ue){return N===ue?!0:!N||!ue?!1:N.message===ue.message&&N.location.range.isEqual(ue.location.range)&&N.location.uri.toString()===ue.location.uri.toString()}};e.DiagnosticRelatedInformation=$,e.DiagnosticRelatedInformation=$=ze([k],$);let U=class{constructor(N,ue,Pe=L.Error){if(!re.isRange(N))throw new TypeError("range must be set");if(!ue)throw new TypeError("message must be set");this.range=N,this.message=ue,this.severity=Pe}toJSON(){return{severity:L[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,ue){return N===ue?!0:!N||!ue?!1:N.message===ue.message&&N.severity===ue.severity&&N.code===ue.code&&N.severity===ue.severity&&N.source===ue.source&&N.range.isEqual(ue.range)&&(0,i.equals)(N.tags,ue.tags)&&(0,i.equals)(N.relatedInformation,ue.relatedInformation,$.isEqual)}};e.Diagnostic=U,e.Diagnostic=U=ze([k],U);let q=class{constructor(N,ue){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=ue}};e.Hover=q,e.Hover=q=ze([k],q);let G=class extends q{constructor(N,ue,Pe,$e){super(N,ue),this.canIncreaseHover=Pe,this.canDecreaseHover=$e}};e.VerboseHover=G,e.VerboseHover=G=ze([k],G);var F;(function(M){M[M.Increase=0]="Increase",M[M.Decrease=1]="Decrease"})(F||(e.HoverVerbosityAction=F={}));var V;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(V||(e.DocumentHighlightKind=V={}));let oe=class{constructor(N,ue=V.Text){this.range=N,this.kind=ue}toJSON(){return{range:this.range,kind:V[this.kind]}}};e.DocumentHighlight=oe,e.DocumentHighlight=oe=ze([k],oe);let de=class{constructor(N,ue){this.uri=N,this.highlights=ue}toJSON(){return{uri:this.uri,highlights:this.highlights.map(N=>N.toJSON())}}};e.MultiDocumentHighlight=de,e.MultiDocumentHighlight=de=ze([k],de);var Ce;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(Ce||(e.SymbolKind=Ce={}));var Ne;(function(M){M[M.Deprecated=1]="Deprecated"})(Ne||(e.SymbolTag=Ne={}));let ge=n=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,ue,Pe,$e,Ye){this.name=N,this.kind=ue,this.containerName=Ye,typeof Pe=="string"&&(this.containerName=Pe),$e instanceof Q?this.location=$e:Pe instanceof re&&(this.location=new Q($e,Pe)),n.validate(this)}toJSON(){return{name:this.name,kind:Ce[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=ge,e.SymbolInformation=ge=n=ze([k],ge);let pe=h=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(h.validate)}constructor(N,ue,Pe,$e,Ye){this.name=N,this.detail=ue,this.kind=Pe,this.range=$e,this.selectionRange=Ye,this.children=[],h.validate(this)}};e.DocumentSymbol=pe,e.DocumentSymbol=pe=h=ze([k],pe);var Te;(function(M){M[M.Invoke=1]="Invoke",M[M.Automatic=2]="Automatic"})(Te||(e.CodeActionTriggerKind=Te={}));let Le=class{constructor(N,ue){this.title=N,this.kind=ue}};e.CodeAction=Le,e.CodeAction=Le=ze([k],Le);let he=class{static{s=this}static{this.sep="."}constructor(N){this.value=N}append(N){return new s(this.value?this.value+s.sep+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+s.sep)}};e.CodeActionKind=he,e.CodeActionKind=he=s=ze([k],he),he.Empty=new he(""),he.QuickFix=he.Empty.append("quickfix"),he.Refactor=he.Empty.append("refactor"),he.RefactorExtract=he.Refactor.append("extract"),he.RefactorInline=he.Refactor.append("inline"),he.RefactorMove=he.Refactor.append("move"),he.RefactorRewrite=he.Refactor.append("rewrite"),he.Source=he.Empty.append("source"),he.SourceOrganizeImports=he.Source.append("organizeImports"),he.SourceFixAll=he.Source.append("fixAll"),he.Notebook=he.Empty.append("notebook");let De=class{constructor(N,ue){if(this.range=N,this.parent=ue,ue&&!ue.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=De,e.SelectionRange=De=ze([k],De);class Re{constructor(N,ue,Pe,$e,Ye,at){this.kind=N,this.name=ue,this.detail=Pe,this.uri=$e,this.range=Ye,this.selectionRange=at}}e.CallHierarchyItem=Re;class xe{constructor(N,ue){this.fromRanges=ue,this.from=N}}e.CallHierarchyIncomingCall=xe;class Ve{constructor(N,ue){this.fromRanges=ue,this.to=N}}e.CallHierarchyOutgoingCall=Ve;var Xe;(function(M){M[M.Information=0]="Information",M[M.Warning=1]="Warning",M[M.Error=2]="Error"})(Xe||(e.LanguageStatusSeverity=Xe={}));let je=class{constructor(N,ue){this.range=N,this.command=ue}get isResolved(){return!!this.command}};e.CodeLens=je,e.CodeLens=je=ze([k],je);let qe=c=class{#e;static isMarkdownString(N){return N instanceof c?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,ue=!1){this.#e=new w.MarkdownString(N,{supportThemeIcons:ue})}get value(){return this.#e.value}set value(N){this.#e.value=N}get isTrusted(){return this.#e.isTrusted}set isTrusted(N){this.#e.isTrusted=N}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(N){this.#e.supportThemeIcons=N}get supportHtml(){return this.#e.supportHtml}set supportHtml(N){this.#e.supportHtml=N}get baseUri(){return this.#e.baseUri}set baseUri(N){this.#e.baseUri=N}appendText(N){return this.#e.appendText(N),this}appendMarkdown(N){return this.#e.appendMarkdown(N),this}appendCodeblock(N,ue){return this.#e.appendCodeblock(ue??"",N),this}};e.MarkdownString=qe,e.MarkdownString=qe=c=ze([k],qe);let Je=class{constructor(N,ue){this.label=N,this.documentation=ue}};e.ParameterInformation=Je,e.ParameterInformation=Je=ze([k],Je);let st=class{constructor(N,ue){this.label=N,this.documentation=ue,this.parameters=[]}};e.SignatureInformation=st,e.SignatureInformation=st=ze([k],st);let lt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=lt,e.SignatureHelp=lt=ze([k],lt);var rt;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(rt||(e.SignatureHelpTriggerKind=rt={}));var it;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let tt=class{constructor(N){this.value=N}};e.InlayHintLabelPart=tt,e.InlayHintLabelPart=tt=ze([k],tt);let et=class{constructor(N,ue,Pe){this.position=N,this.label=ue,this.kind=Pe}};e.InlayHint=et,e.InlayHint=et=ze([k],et);var Qe;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Qe||(e.CompletionTriggerKind=Qe={}));var Ee;(function(M){M[M.Text=0]="Text",M[M.Method=1]="Method",M[M.Function=2]="Function",M[M.Constructor=3]="Constructor",M[M.Field=4]="Field",M[M.Variable=5]="Variable",M[M.Class=6]="Class",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Unit=10]="Unit",M[M.Value=11]="Value",M[M.Enum=12]="Enum",M[M.Keyword=13]="Keyword",M[M.Snippet=14]="Snippet",M[M.Color=15]="Color",M[M.File=16]="File",M[M.Reference=17]="Reference",M[M.Folder=18]="Folder",M[M.EnumMember=19]="EnumMember",M[M.Constant=20]="Constant",M[M.Struct=21]="Struct",M[M.Event=22]="Event",M[M.Operator=23]="Operator",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue"})(Ee||(e.CompletionItemKind=Ee={}));var Oe;(function(M){M[M.Deprecated=1]="Deprecated"})(Oe||(e.CompletionItemTag=Oe={}));let Fe=class{constructor(N,ue){this.label=N,this.kind=ue}toJSON(){return{label:this.label,kind:this.kind&&Ee[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=Fe,e.CompletionItem=Fe=ze([k],Fe);let be=class{constructor(N=[],ue=!1){this.items=N,this.isIncomplete=ue}};e.CompletionList=be,e.CompletionList=be=ze([k],be);let Ae=class{constructor(N,ue,Pe){this.insertText=N,this.range=ue,this.command=Pe}};e.InlineSuggestion=Ae,e.InlineSuggestion=Ae=ze([k],Ae);let ie=class{constructor(N){this.commands=void 0,this.suppressSuggestions=void 0,this.items=N}};e.InlineSuggestionList=ie,e.InlineSuggestionList=ie=ze([k],ie);var ee;(function(M){M[M.Unknown=0]="Unknown",M[M.Word=1]="Word",M[M.Line=2]="Line",M[M.Suggest=3]="Suggest"})(ee||(e.PartialAcceptTriggerKind=ee={}));var Se;(function(M){M[M.Active=-1]="Active",M[M.Beside=-2]="Beside",M[M.One=1]="One",M[M.Two=2]="Two",M[M.Three=3]="Three",M[M.Four=4]="Four",M[M.Five=5]="Five",M[M.Six=6]="Six",M[M.Seven=7]="Seven",M[M.Eight=8]="Eight",M[M.Nine=9]="Nine"})(Se||(e.ViewColumn=Se={}));var He;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(He||(e.StatusBarAlignment=He={}));function Ge(M,N){return`${y.ExtensionIdentifier.toKey(M)}.${N}`}var Ze;(function(M){M[M.Off=0]="Off",M[M.On=1]="On",M[M.Relative=2]="Relative",M[M.Interval=3]="Interval"})(Ze||(e.TextEditorLineNumbersStyle=Ze={}));var nt;(function(M){M[M.Manual=1]="Manual",M[M.AfterDelay=2]="AfterDelay",M[M.FocusOut=3]="FocusOut"})(nt||(e.TextDocumentSaveReason=nt={}));var ut;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(ut||(e.TextEditorRevealType=ut={}));var mt;(function(M){M[M.Keyboard=1]="Keyboard",M[M.Mouse=2]="Mouse",M[M.Command=3]="Command"})(mt||(e.TextEditorSelectionChangeKind=mt={}));var Et;(function(M){M[M.Undo=1]="Undo",M[M.Redo=2]="Redo"})(Et||(e.TextDocumentChangeReason=Et={}));var Ut;(function(M){M[M.OpenOpen=0]="OpenOpen",M[M.ClosedClosed=1]="ClosedClosed",M[M.OpenClosed=2]="OpenClosed",M[M.ClosedOpen=3]="ClosedOpen"})(Ut||(e.DecorationRangeBehavior=Ut={})),function(M){function N(ue){switch(ue){case"keyboard":return M.Keyboard;case"mouse":return M.Mouse;case"api":return M.Command}}M.fromValue=N}(mt||(e.TextEditorSelectionChangeKind=mt={}));var _t;(function(M){M[M.Other=0]="Other",M[M.Comment=1]="Comment",M[M.String=2]="String",M[M.RegEx=3]="RegEx"})(_t||(e.SyntaxTokenType=_t={})),function(M){function N(ue){switch(ue){case M.Other:return"other";case M.Comment:return"comment";case M.String:return"string";case M.RegEx:return"regex"}return"other"}M.toString=N}(_t||(e.SyntaxTokenType=_t={}));let ht=class{constructor(N,ue){if(ue&&!o.URI.isUri(ue))throw(0,r.illegalArgument)("target");if(!re.isRange(N)||N.isEmpty)throw(0,r.illegalArgument)("range");this.range=N,this.target=ue}};e.DocumentLink=ht,e.DocumentLink=ht=ze([k],ht);let St=class{constructor(N,ue,Pe,$e){this.red=N,this.green=ue,this.blue=Pe,this.alpha=$e}};e.Color=St,e.Color=St=ze([k],St);let wt=class{constructor(N,ue){if(ue&&!(ue instanceof St))throw(0,r.illegalArgument)("color");if(!re.isRange(N)||N.isEmpty)throw(0,r.illegalArgument)("range");this.range=N,this.color=ue}};e.ColorInformation=wt,e.ColorInformation=wt=ze([k],wt);let Ct=class{constructor(N){if(!N||typeof N!="string")throw(0,r.illegalArgument)("label");this.label=N}};e.ColorPresentation=Ct,e.ColorPresentation=Ct=ze([k],Ct);var Kt;(function(M){M[M.RGB=0]="RGB",M[M.HEX=1]="HEX",M[M.HSL=2]="HSL"})(Kt||(e.ColorFormat=Kt={}));var Lt;(function(M){M[M.Error=0]="Error",M[M.Warning=1]="Warning",M[M.Information=2]="Information"})(Lt||(e.SourceControlInputBoxValidationType=Lt={}));var dt;(function(M){M[M.Unknown=0]="Unknown",M[M.Shutdown=1]="Shutdown",M[M.Process=2]="Process",M[M.User=3]="User",M[M.Extension=4]="Extension"})(dt||(e.TerminalExitReason=dt={}));var vt;(function(M){M[M.Low=0]="Low",M[M.Medium=1]="Medium",M[M.High=2]="High"})(vt||(e.TerminalShellExecutionCommandLineConfidence=vt={}));class yt{constructor(N,ue,Pe){if(this.startIndex=N,this.length=ue,this.tooltip=Pe,typeof N!="number"||N<0)throw(0,r.illegalArgument)("startIndex");if(typeof ue!="number"||ue<1)throw(0,r.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,r.illegalArgument)("tooltip")}}e.TerminalLink=yt;class Pt{constructor(N){this.uri=N}}e.TerminalQuickFixOpener=Pt;class xt{constructor(N){this.terminalCommand=N}}e.TerminalQuickFixCommand=xt;var At;(function(M){M[M.Panel=1]="Panel",M[M.Editor=2]="Editor"})(At||(e.TerminalLocation=At={}));class Zt{constructor(N){if(this.options=N,typeof N!="object")throw(0,r.illegalArgument)("options")}}e.TerminalProfile=Zt;var Tt;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(Tt||(e.TaskRevealKind=Tt={}));var Ot;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(Ot||(e.TaskPanelKind=Ot={}));let zt=class{static{u=this}static{this.Clean=new u("clean","Clean")}static{this.Build=new u("build","Build")}static{this.Rebuild=new u("rebuild","Rebuild")}static{this.Test=new u("test","Test")}static from(N){switch(N){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}constructor(N,ue){if(this.label=ue,typeof N!="string"||typeof ue!="string")throw(0,r.illegalArgument)("name");this._id=N}get id(){return this._id}};e.TaskGroup=zt,e.TaskGroup=zt=u=ze([k],zt);function Nt(M){let N="";for(let ue=0;ue<M.length;ue++)N+=M[ue].replace(/,/g,",,")+",";return N}let kt=class{constructor(N,ue,Pe){if(typeof N!="string")throw(0,r.illegalArgument)("process");this._args=[],this._process=N,ue!==void 0&&(Array.isArray(ue)?(this._args=ue,this._options=Pe):this._options=ue)}get process(){return this._process}set process(N){if(typeof N!="string")throw(0,r.illegalArgument)("process");this._process=N}get args(){return this._args}set args(N){Array.isArray(N)||(N=[]),this._args=N}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("process"),this._process!==void 0&&N.push(this._process),this._args&&this._args.length>0)for(const ue of this._args)N.push(ue);return Nt(N)}};e.ProcessExecution=kt,e.ProcessExecution=kt=ze([k],kt);let It=class{constructor(N,ue,Pe){if(this._args=[],Array.isArray(ue)){if(!N)throw(0,r.illegalArgument)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,r.illegalArgument)("command");this._command=N,this._args=ue,this._options=Pe}else{if(typeof N!="string")throw(0,r.illegalArgument)("commandLine");this._commandLine=N,this._options=ue}}get commandLine(){return this._commandLine}set commandLine(N){if(typeof N!="string")throw(0,r.illegalArgument)("commandLine");this._commandLine=N}get command(){return this._command?this._command:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,r.illegalArgument)("command");this._command=N}get args(){return this._args}set args(N){this._args=N||[]}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("shell"),this._commandLine!==void 0&&N.push(this._commandLine),this._command!==void 0&&N.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ue of this._args)N.push(typeof ue=="string"?ue:ue.value);return Nt(N)}};e.ShellExecution=It,e.ShellExecution=It=ze([k],It);var Wt;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(Wt||(e.ShellQuoting=Wt={}));var Bt;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace"})(Bt||(e.TaskScope=Bt={}));class Ht{constructor(N){this._callback=N}computeId(){return"customExecution"+(0,D.generateUuid)()}set callback(N){this._callback=N}get callback(){return this._callback}}e.CustomExecution=Ht;let Vt=class{static{I=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(N,ue,Pe,$e,Ye,at){this.__deprecated=!1,this._definition=this.definition=N;let ct;typeof ue=="string"?(this._name=this.name=ue,this._source=this.source=Pe,this.execution=$e,ct=Ye,this.__deprecated=!0):ue===Bt.Global||ue===Bt.Workspace?(this.target=ue,this._name=this.name=Pe,this._source=this.source=$e,this.execution=Ye,ct=at):(this.target=ue,this._name=this.name=Pe,this._source=this.source=$e,this.execution=Ye,ct=at),typeof ct=="string"?(this._problemMatchers=[ct],this._hasDefinedMatchers=!0):Array.isArray(ct)?(this._problemMatchers=ct,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(N){this.__id=N}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof kt?this._definition={type:I.ProcessType,id:this._execution.computeId()}:this._execution instanceof It?this._definition={type:I.ShellType,id:this._execution.computeId()}:this._execution instanceof Ht?this._definition={type:I.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:I.EmptyType,id:(0,D.generateUuid)()}}get definition(){return this._definition}set definition(N){if(N==null)throw(0,r.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=N}get scope(){return this._scope}set target(N){this.clear(),this._scope=N}get name(){return this._name}set name(N){if(typeof N!="string")throw(0,r.illegalArgument)("name");this.clear(),this._name=N}get execution(){return this._execution}set execution(N){N===null&&(N=void 0),this.clear(),this._execution=N;const ue=this._definition.type;(I.EmptyType===ue||I.ProcessType===ue||I.ShellType===ue||I.ExtensionCallbackType===ue)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(N){if(Array.isArray(N))this.clear(),this._problemMatchers=N,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.clear(),this._isBackground=N}get source(){return this._source}set source(N){if(typeof N!="string"||N.length===0)throw(0,r.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=N}get group(){return this._group}set group(N){N===null&&(N=void 0),this.clear(),this._group=N}get detail(){return this._detail}set detail(N){N===null&&(N=void 0),this._detail=N}get presentationOptions(){return this._presentationOptions}set presentationOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._presentationOptions=N}get runOptions(){return this._runOptions}set runOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._runOptions=N}};e.Task=Vt,e.Task=Vt=I=ze([k],Vt);var Xt;(function(M){M[M.SourceControl=1]="SourceControl",M[M.Window=10]="Window",M[M.Notification=15]="Notification"})(Xt||(e.ProgressLocation=Xt={}));var ei;(function(M){function N(ue){const Pe=ue;return(0,b.isNumber)(Pe.value)?Pe.tooltip&&!(0,b.isString)(Pe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Pe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Pe.value),!1)}M.isViewBadge=N})(ei||(e.ViewBadge=ei={}));let $t=T=class{static isTreeItem(N,ue){const Pe=N;if(Pe.checkboxState!==void 0){const $e=(0,b.isNumber)(Pe.checkboxState)?Pe.checkboxState:(0,b.isObject)(Pe.checkboxState)&&(0,b.isNumber)(Pe.checkboxState.state)?Pe.checkboxState.state:void 0,Ye=!(0,b.isNumber)(Pe.checkboxState)&&(0,b.isObject)(Pe.checkboxState)?Pe.checkboxState.tooltip:void 0;if($e===void 0||$e!==Ft.Checked&&$e!==Ft.Unchecked||Ye!==void 0&&!(0,b.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",Pe.checkboxState),!1}if(N instanceof T)return!0;if(Pe.label!==void 0&&!(0,b.isString)(Pe.label)&&!Pe.label?.label)return console.log("INVALID tree item, invalid label",Pe.label),!1;if(Pe.id!==void 0&&!(0,b.isString)(Pe.id))return console.log("INVALID tree item, invalid id",Pe.id),!1;if(Pe.iconPath!==void 0&&!(0,b.isString)(Pe.iconPath)&&!o.URI.isUri(Pe.iconPath)&&(!Pe.iconPath||!(0,b.isString)(Pe.iconPath.id))){const $e=Pe.iconPath;if(!$e||!(0,b.isString)($e.light)&&!o.URI.isUri($e.light)&&!(0,b.isString)($e.dark)&&!o.URI.isUri($e.dark))return console.log("INVALID tree item, invalid iconPath",Pe.iconPath),!1}return Pe.description!==void 0&&!(0,b.isString)(Pe.description)&&typeof Pe.description!="boolean"?(console.log("INVALID tree item, invalid description",Pe.description),!1):Pe.resourceUri!==void 0&&!o.URI.isUri(Pe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Pe.resourceUri),!1):Pe.tooltip!==void 0&&!(0,b.isString)(Pe.tooltip)&&!(Pe.tooltip instanceof qe)?(console.log("INVALID tree item, invalid tooltip",Pe.tooltip),!1):Pe.command!==void 0&&!Pe.command.command?(console.log("INVALID tree item, invalid command",Pe.command),!1):Pe.collapsibleState!==void 0&&Pe.collapsibleState<Dt.None&&Pe.collapsibleState>Dt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Pe.collapsibleState),!1):Pe.contextValue!==void 0&&!(0,b.isString)(Pe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Pe.contextValue),!1):Pe.accessibilityInformation!==void 0&&!Pe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Pe.accessibilityInformation),!1):!0}constructor(N,ue=Dt.None){this.collapsibleState=ue,o.URI.isUri(N)?this.resourceUri=N:this.label=N}};e.TreeItem=$t,e.TreeItem=$t=T=ze([k],$t);var Dt;(function(M){M[M.None=0]="None",M[M.Collapsed=1]="Collapsed",M[M.Expanded=2]="Expanded"})(Dt||(e.TreeItemCollapsibleState=Dt={}));var Ft;(function(M){M[M.Unchecked=0]="Unchecked",M[M.Checked=1]="Checked"})(Ft||(e.TreeItemCheckboxState=Ft={}));let pt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N){this.value=N}};e.DataTransferItem=pt,e.DataTransferItem=pt=ze([k],pt);class Yt extends pt{}e.InternalDataTransferItem=Yt;class Qt extends Yt{#e;constructor(N){super(""),this.#e=N}asFile(){return this.#e}}e.InternalFileDataTransferItem=Qt;class oi{constructor(N,ue,Pe,$e){this.name=N,this.uri=ue,this._itemId=Pe,this._getData=$e}data(){return this._getData()}}e.DataTransferFile=oi;let ai=class{#e=new Map;constructor(N){for(const[ue,Pe]of N??[]){const $e=this.#e.get(this.#t(ue));$e?$e.push(Pe):this.#e.set(this.#t(ue),[Pe])}}get(N){return this.#e.get(this.#t(N))?.[0]}set(N,ue){this.#e.set(this.#t(N),[ue])}forEach(N,ue){for(const[Pe,$e]of this.#e)for(const Ye of $e)N.call(ue,Ye,Pe,this)}*[Symbol.iterator](){for(const[N,ue]of this.#e)for(const Pe of ue)yield[N,Pe]}#t(N){return N.toLowerCase()}};e.DataTransfer=ai,e.DataTransfer=ai=ze([k],ai);let ci=class{constructor(N,ue,Pe){this.insertText=N,this.title=ue,this.kind=Pe}};e.DocumentDropEdit=ci,e.DocumentDropEdit=ci=ze([k],ci);var vi;(function(M){M[M.Automatic=0]="Automatic",M[M.PasteAs=1]="PasteAs"})(vi||(e.DocumentPasteTriggerKind=vi={}));class ii{static{this.sep="."}constructor(N){this.value=N}append(...N){return new ii((this.value?[this.value,...N]:N).join(ii.sep))}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+ii.sep)}}e.DocumentDropOrPasteEditKind=ii,ii.Empty=new ii("");class Ei{constructor(N,ue,Pe){this.title=ue,this.insertText=N,this.kind=Pe}}e.DocumentPasteEdit=Ei;let qt=class{constructor(N,ue){this.id=N,this.color=ue}static isThemeIcon(N){return typeof N.id!="string"?(console.log("INVALID ThemeIcon, invalid id",N.id),!1):!0}};e.ThemeIcon=qt,e.ThemeIcon=qt=ze([k],qt),qt.File=new qt("file"),qt.Folder=new qt("folder");let hi=class{constructor(N){this.id=N}};e.ThemeColor=hi,e.ThemeColor=hi=ze([k],hi);var fi;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.WorkspaceFolder=3]="WorkspaceFolder"})(fi||(e.ConfigurationTarget=fi={}));let gi=class{get base(){return this._base}set base(N){this._base=N,this._baseUri=o.URI.file(N)}get baseUri(){return this._baseUri}set baseUri(N){this._baseUri=N,this._base=N.fsPath}constructor(N,ue){if(typeof N!="string"&&(!N||!o.URI.isUri(N)&&!o.URI.isUri(N.uri)))throw(0,r.illegalArgument)("base");if(typeof ue!="string")throw(0,r.illegalArgument)("pattern");typeof N=="string"?this.baseUri=o.URI.file(N):o.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=ue}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=gi,e.RelativePattern=gi=ze([k],gi);const Si=new WeakMap;function wi(M,N){Si.set(M,N)}let ni=class{constructor(N,ue,Pe,$e,Ye){this.enabled=typeof N=="boolean"?N:!0,typeof ue=="string"&&(this.condition=ue),typeof Pe=="string"&&(this.hitCondition=Pe),typeof $e=="string"&&(this.logMessage=$e),typeof Ye=="string"&&(this.mode=Ye)}get id(){return this._id||(this._id=Si.get(this)??(0,D.generateUuid)()),this._id}};e.Breakpoint=ni,e.Breakpoint=ni=ze([k],ni);let mi=class extends ni{constructor(N,ue,Pe,$e,Ye,at){if(super(ue,Pe,$e,Ye,at),N===null)throw(0,r.illegalArgument)("location");this.location=N}};e.SourceBreakpoint=mi,e.SourceBreakpoint=mi=ze([k],mi);let pi=class extends ni{constructor(N,ue,Pe,$e,Ye,at){super(ue,Pe,$e,Ye,at),this.functionName=N}};e.FunctionBreakpoint=pi,e.FunctionBreakpoint=pi=ze([k],pi);let we=class extends ni{constructor(N,ue,Pe,$e,Ye,at,ct,Rt){if(super($e,Ye,at,ct,Rt),!ue)throw(0,r.illegalArgument)("dataId");this.label=N,this.dataId=ue,this.canPersist=Pe}};e.DataBreakpoint=we,e.DataBreakpoint=we=ze([k],we);let ke=class{constructor(N,ue,Pe){this.command=N,this.args=ue||[],this.options=Pe}};e.DebugAdapterExecutable=ke,e.DebugAdapterExecutable=ke=ze([k],ke);let me=class{constructor(N,ue){this.port=N,this.host=ue}};e.DebugAdapterServer=me,e.DebugAdapterServer=me=ze([k],me);let j=class{constructor(N){this.path=N}};e.DebugAdapterNamedPipeServer=j,e.DebugAdapterNamedPipeServer=j=ze([k],j);let _e=class{constructor(N){this.implementation=N}};e.DebugAdapterInlineImplementation=_e,e.DebugAdapterInlineImplementation=_e=ze([k],_e);class Ue{constructor(N,ue,Pe){this.session=N,this.threadId=ue,this.frameId=Pe}}e.DebugStackFrame=Ue;class Ke{constructor(N,ue){this.session=N,this.threadId=ue}}e.DebugThread=Ke;let We=class{constructor(N,ue){this.range=N,this.expression=ue}};e.EvaluatableExpression=We,e.EvaluatableExpression=We=ze([k],We);var ot;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(ot||(e.InlineCompletionTriggerKind=ot={}));let ft=class{constructor(N,ue){this.range=N,this.text=ue}};e.InlineValueText=ft,e.InlineValueText=ft=ze([k],ft);let Mt=class{constructor(N,ue,Pe=!0){this.range=N,this.variableName=ue,this.caseSensitiveLookup=Pe}};e.InlineValueVariableLookup=Mt,e.InlineValueVariableLookup=Mt=ze([k],Mt);let jt=class{constructor(N,ue){this.range=N,this.expression=ue}};e.InlineValueEvaluatableExpression=jt,e.InlineValueEvaluatableExpression=jt=ze([k],jt);let bt=class{constructor(N,ue){this.frameId=N,this.stoppedLocation=ue}};e.InlineValueContext=bt,e.InlineValueContext=bt=ze([k],bt);var Gt;(function(M){M[M.AIGenerated=1]="AIGenerated"})(Gt||(e.NewSymbolNameTag=Gt={}));var zi;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(zi||(e.NewSymbolNameTriggerKind=zi={}));class _n{constructor(N,ue){this.newSymbolName=N,this.tags=ue}}e.NewSymbolName=_n;var Wi;(function(M){M[M.Changed=1]="Changed",M[M.Created=2]="Created",M[M.Deleted=3]="Deleted"})(Wi||(e.FileChangeType=Wi={}));let Ri=A=class extends Error{static FileExists(N){return new A(N,d.FileSystemProviderErrorCode.FileExists,A.FileExists)}static FileNotFound(N){return new A(N,d.FileSystemProviderErrorCode.FileNotFound,A.FileNotFound)}static FileNotADirectory(N){return new A(N,d.FileSystemProviderErrorCode.FileNotADirectory,A.FileNotADirectory)}static FileIsADirectory(N){return new A(N,d.FileSystemProviderErrorCode.FileIsADirectory,A.FileIsADirectory)}static NoPermissions(N){return new A(N,d.FileSystemProviderErrorCode.NoPermissions,A.NoPermissions)}static Unavailable(N){return new A(N,d.FileSystemProviderErrorCode.Unavailable,A.Unavailable)}constructor(N,ue=d.FileSystemProviderErrorCode.Unknown,Pe){super(o.URI.isUri(N)?N.toString(!0):N),this.code=Pe?.name??"Unknown",(0,d.markAsFileSystemProviderError)(this,ue),Object.setPrototypeOf(this,A.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}};e.FileSystemError=Ri,e.FileSystemError=Ri=A=ze([k],Ri);let _i=class{constructor(N,ue,Pe){this.start=N,this.end=ue,this.kind=Pe}};e.FoldingRange=_i,e.FoldingRange=_i=ze([k],_i);var Bi;(function(M){M[M.Comment=1]="Comment",M[M.Imports=2]="Imports",M[M.Region=3]="Region"})(Bi||(e.FoldingRangeKind=Bi={}));var Hi;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(Hi||(e.CommentThreadCollapsibleState=Hi={}));var Vi;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(Vi||(e.CommentMode=Vi={}));var $i;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})($i||(e.CommentState=$i={}));var qi;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(qi||(e.CommentThreadState=qi={}));var ji;(function(M){M[M.Current=0]="Current",M[M.Outdated=1]="Outdated"})(ji||(e.CommentThreadApplicability=ji={}));class An{constructor(N,ue=[]){this.tokenTypes=N,this.tokenModifiers=ue}}e.SemanticTokensLegend=An;function kn(M){return typeof M>"u"||(0,b.isStringArray)(M)}class Ai{constructor(N){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,N){this._hasLegend=!0;for(let ue=0,Pe=N.tokenTypes.length;ue<Pe;ue++)this._tokenTypeStrToInt.set(N.tokenTypes[ue],ue);for(let ue=0,Pe=N.tokenModifiers.length;ue<Pe;ue++)this._tokenModifierStrToInt.set(N.tokenModifiers[ue],ue)}}push(N,ue,Pe,$e,Ye){if(typeof N=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof $e=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this._pushEncoded(N,ue,Pe,$e,Ye);if(re.isRange(N)&&typeof ue=="string"&&kn(Pe))return this._push(N,ue,Pe);throw(0,r.illegalArgument)()}_push(N,ue,Pe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ue))throw new Error("`tokenType` is not in the provided legend");const $e=N.start.line,Ye=N.start.character,at=N.end.character-N.start.character,ct=this._tokenTypeStrToInt.get(ue);let Rt=0;if(Pe)for(const Jt of Pe){if(!this._tokenModifierStrToInt.has(Jt))throw new Error("`tokenModifier` is not in the provided legend");const ti=this._tokenModifierStrToInt.get(Jt);Rt|=1<<ti>>>0}this._pushEncoded($e,Ye,at,ct,Rt)}_pushEncoded(N,ue,Pe,$e,Ye){if(this._dataIsSortedAndDeltaEncoded&&(N<this._prevLine||N===this._prevLine&&ue<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Rt=this._data.length/5|0;let Jt=0,ti=0;for(let si=0;si<Rt;si++){let li=this._data[5*si],yi=this._data[5*si+1];li===0?(li=Jt,yi+=ti):li+=Jt,this._data[5*si]=li,this._data[5*si+1]=yi,Jt=li,ti=yi}}let at=N,ct=ue;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ct-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ct,this._data[this._dataLen++]=Pe,this._data[this._dataLen++]=$e,this._data[this._dataLen++]=Ye,this._prevLine=N,this._prevChar=ue}static _sortAndDeltaEncode(N){const ue=[],Pe=N.length/5|0;for(let ct=0;ct<Pe;ct++)ue[ct]=ct;ue.sort((ct,Rt)=>{const Jt=N[5*ct],ti=N[5*Rt];if(Jt===ti){const si=N[5*ct+1],li=N[5*Rt+1];return si-li}return Jt-ti});const $e=new Uint32Array(N.length);let Ye=0,at=0;for(let ct=0;ct<Pe;ct++){const Rt=5*ue[ct],Jt=N[Rt+0],ti=N[Rt+1],si=N[Rt+2],li=N[Rt+3],yi=N[Rt+4],Pn=Jt-Ye,Cr=Pn===0?ti-at:ti,bi=5*ct;$e[bi+0]=Pn,$e[bi+1]=Cr,$e[bi+2]=si,$e[bi+3]=li,$e[bi+4]=yi,Ye=Jt,at=ti}return $e}build(N){return this._dataIsSortedAndDeltaEncoded?new ki(new Uint32Array(this._data),N):new ki(Ai._sortAndDeltaEncode(this._data),N)}}e.SemanticTokensBuilder=Ai;class ki{constructor(N,ue){this.resultId=ue,this.data=N}}e.SemanticTokens=ki;class Ln{constructor(N,ue,Pe){this.start=N,this.deleteCount=ue,this.data=Pe}}e.SemanticTokensEdit=Ln;class On{constructor(N,ue){this.resultId=ue,this.edits=N}}e.SemanticTokensEdits=On;var Gi;(function(M){M[M.Separate=0]="Separate",M[M.MergeWithParent=1]="MergeWithParent"})(Gi||(e.DebugConsoleMode=Gi={}));class Nn{constructor(N){this.name=N}}e.DebugVisualization=Nn;let Li=class{static{this.Back={iconPath:new qt("arrow-left")}}constructor(){}};e.QuickInputButtons=Li,e.QuickInputButtons=Li=ze([k],Li);var Ki;(function(M){M[M.Separator=-1]="Separator",M[M.Default=0]="Default"})(Ki||(e.QuickPickItemKind=Ki={}));var Xi;(function(M){M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(Xi||(e.InputBoxValidationSeverity=Xi={}));var Yi;(function(M){M[M.UI=1]="UI",M[M.Workspace=2]="Workspace"})(Yi||(e.ExtensionKind=Yi={}));class Fn{static validate(N){if(typeof N.badge=="string"){let ue=(0,_.nextCharLength)(N.badge,0);if(ue<N.badge.length&&(ue+=(0,_.nextCharLength)(N.badge,ue)),N.badge.length>ue)throw new Error("The 'badge'-property must be undefined or a short character")}else if(N.badge&&!qt.isThemeIcon(N.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,ue,Pe){this.badge=N,this.tooltip=ue,this.color=Pe}}e.FileDecoration=Fn;let Oi=class{constructor(N){this.kind=N}};e.ColorTheme=Oi,e.ColorTheme=Oi=ze([k],Oi);var Qi;(function(M){M[M.Light=1]="Light",M[M.Dark=2]="Dark",M[M.HighContrast=3]="HighContrast",M[M.HighContrastLight=4]="HighContrastLight"})(Qi||(e.ColorThemeKind=Qi={}));class ui{static isNotebookRange(N){return N instanceof ui?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(N,ue){if(N<0)throw(0,r.illegalArgument)("start must be positive");if(ue<0)throw(0,r.illegalArgument)("end must be positive");N<=ue?(this._start=N,this._end=ue):(this._start=ue,this._end=N)}with(N){let ue=this._start,Pe=this._end;return N.start!==void 0&&(ue=N.start),N.end!==void 0&&(Pe=N.end),ue===this._start&&Pe===this._end?this:new ui(ue,Pe)}}e.NotebookRange=ui;class Ii{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(ue=>Ii.isNotebookCellData(ue))}static isNotebookCellData(N){return!0}constructor(N,ue,Pe,$e,Ye,at,ct){this.kind=N,this.value=ue,this.languageId=Pe,this.mime=$e,this.outputs=Ye??[],this.metadata=at,this.executionSummary=ct,Ii.validate(this)}}e.NotebookCellData=Ii;class Mn{constructor(N){this.cells=N}}e.NotebookData=Mn;class ri{static isNotebookCellOutputItem(N){return N instanceof ri?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const ue={name:N.name,message:N.message,stack:N.stack};return ri.json(ue,"application/vnd.code.notebook.error")}static stdout(N){return ri.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return ri.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,ue="application/octet-stream"){return new ri(N,ue)}static#e=new TextEncoder;static text(N,ue=R.Mimes.text){const Pe=ri.#e.encode(String(N));return new ri(Pe,ue)}static json(N,ue="text/x-json"){const Pe=JSON.stringify(N,void 0,"	");return ri.text(Pe,ue)}constructor(N,ue){this.data=N,this.mime=ue;const Pe=(0,R.normalizeMimeType)(ue,!0);if(!Pe)throw new Error(`INVALID mime type: ${ue}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}}e.NotebookCellOutputItem=ri;class Di{static isNotebookCellOutput(N){return N instanceof Di?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,ue=!1){const Pe=new Set,$e=new Set;for(let Ye=0;Ye<N.length;Ye++){const at=N[Ye],ct=(0,R.normalizeMimeType)(at.mime);if(!Pe.has(ct)||(0,a.isTextStreamMime)(ct)){Pe.add(ct);continue}$e.add(Ye),ue&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return $e.size===0?N:N.filter((Ye,at)=>!$e.has(at))}constructor(N,ue,Pe){this.items=Di.ensureUniqueMimeTypes(N,!0),typeof ue=="string"?(this.id=ue,this.metadata=Pe):(this.id=(0,D.generateUuid)(),this.metadata=ue??Pe)}}e.NotebookCellOutput=Di;var Ji;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(Ji||(e.NotebookCellKind=Ji={}));var Zi;(function(M){M[M.Idle=1]="Idle",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(Zi||(e.NotebookCellExecutionState=Zi={}));var en;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(en||(e.NotebookCellStatusBarAlignment=en={}));var tn;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(tn||(e.NotebookEditorRevealType=tn={}));class Un{constructor(N,ue){this.text=N,this.alignment=ue}}e.NotebookCellStatusBarItem=Un;var nn;(function(M){M[M.Default=1]="Default",M[M.Preferred=2]="Preferred"})(nn||(e.NotebookControllerAffinity=nn={}));var rn;(function(M){M[M.Default=1]="Default",M[M.Preferred=2]="Preferred",M[M.Hidden=-1]="Hidden"})(rn||(e.NotebookControllerAffinity2=rn={}));class xn{constructor(N,ue=[]){this.uri=N,this.provides=(0,i.asArray)(ue)}}e.NotebookRendererScript=xn;class zn{constructor(N){this.label=N}}e.NotebookKernelSourceAction=zn;var sn;(function(M){M[M.Named=1]="Named",M[M.Indexed=2]="Indexed"})(sn||(e.NotebookVariablesRequestKind=sn={}));let Ni=class{constructor(N,ue){this.label=N,this.timestamp=ue}};e.TimelineItem=Ni,e.TimelineItem=Ni=ze([k],Ni);var on;(function(M){M[M.Production=1]="Production",M[M.Development=2]="Development",M[M.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var an;(function(M){M[M.Node=1]="Node",M[M.Webworker=2]="Webworker"})(an||(e.ExtensionRuntime=an={}));var ln;(function(M){M[M.Other=0]="Other",M[M.Comment=1]="Comment",M[M.String=2]="String",M[M.RegEx=3]="RegEx"})(ln||(e.StandardTokenType=ln={}));class Wn{constructor(N,ue){this.ranges=N,this.wordPattern=ue}}e.LinkedEditingRanges=Wn;class Bn{constructor(N){this._autoForwardAction=N}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Bn;var cn;(function(M){M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let Fi=class{constructor(N=void 0,ue=void 0,Pe=void 0,$e=!1,Ye=!0){this.include=N,this.exclude=ue,this.profile=Pe,this.continuous=$e,this.preserveFocus=Ye}};e.TestRunRequest=Fi,e.TestRunRequest=Fi=ze([k],Fi);let Mi=O=class{static diff(N,ue,Pe){const $e=new O(N);return $e.expectedOutput=ue,$e.actualOutput=Pe,$e}constructor(N){this.message=N}};e.TestMessage=Mi,e.TestMessage=Mi=O=ze([k],Mi);let Ui=class{constructor(N){this.id=N}};e.TestTag=Ui,e.TestTag=Ui=ze([k],Ui);class Ci{constructor(N,ue){this.covered=N,this.total=ue,dn(this)}}e.TestCoverageCount=Ci;function dn(M){if(M){if(M.covered>M.total)throw new Error(`The total number of covered items (${M.covered}) cannot be greater than the total (${M.total})`);if(M.total<0)throw new Error(`The number of covered items (${M.total}) cannot be negative`)}}class xi{static fromDetails(N,ue){const Pe=new Ci(0,0),$e=new Ci(0,0),Ye=new Ci(0,0);for(const ct of ue)if("branches"in ct){Pe.total+=1,Pe.covered+=ct.executed?1:0;for(const Rt of ct.branches)$e.total+=1,$e.covered+=Rt.executed?1:0}else Ye.total+=1,Ye.covered+=ct.executed?1:0;const at=new xi(N,Pe,$e.total>0?$e:void 0,Ye.total>0?Ye:void 0);return at.detailedCoverage=ue,at}constructor(N,ue,Pe,$e,Ye=[]){this.uri=N,this.statementCoverage=ue,this.branchCoverage=Pe,this.declarationCoverage=$e,this.fromTests=Ye}}e.FileCoverage=xi;class Hn{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,ue,Pe=[]){this.executed=N,this.location=ue,this.branches=Pe}}e.StatementCoverage=Hn;class Vn{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,ue,Pe){this.executed=N,this.location=ue,this.label=Pe}}e.BranchCoverage=Vn;class $n{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,ue,Pe){this.name=N,this.executed=ue,this.location=Pe}}e.DeclarationCoverage=$n;var hn;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(hn||(e.ExternalUriOpenerPriority=hn={}));var fn;(function(M){M[M.Untrusted=0]="Untrusted",M[M.Trusted=1]="Trusted",M[M.Unspecified=2]="Unspecified"})(fn||(e.WorkspaceTrustState=fn={}));var gn;(function(M){M[M.Notify=1]="Notify",M[M.OpenBrowser=2]="OpenBrowser",M[M.OpenPreview=3]="OpenPreview",M[M.Silent=4]="Silent",M[M.Ignore=5]="Ignore",M[M.OpenBrowserOnce=6]="OpenBrowserOnce"})(gn||(e.PortAutoForwardAction=gn={}));class qn{constructor(N,ue,Pe,$e,Ye,at){this.kind=N,this.name=ue,this.detail=Pe,this.uri=$e,this.range=Ye,this.selectionRange=at}}e.TypeHierarchyItem=qn;class jn{constructor(N){this.uri=N}}e.TextTabInput=jn;class Gn{constructor(N,ue){this.original=N,this.modified=ue}}e.TextDiffTabInput=Gn;class Kn{constructor(N,ue,Pe,$e){this.base=N,this.input1=ue,this.input2=Pe,this.result=$e}}e.TextMergeTabInput=Kn;class Xn{constructor(N,ue){this.uri=N,this.viewType=ue}}e.CustomEditorTabInput=Xn;class Yn{constructor(N){this.viewType=N}}e.WebviewEditorTabInput=Yn;class Qn{constructor(N,ue){this.uri=N,this.notebookType=ue}}e.NotebookEditorTabInput=Qn;class Jn{constructor(N,ue,Pe){this.original=N,this.modified=ue,this.notebookType=Pe}}e.NotebookDiffEditorTabInput=Jn;class Zn{constructor(){}}e.TerminalEditorTabInput=Zn;class er{constructor(N,ue){this.uri=N,this.inputBoxUri=ue}}e.InteractiveWindowInput=er;class tr{constructor(){}}e.ChatEditorTabInput=tr;class ir{constructor(N){this.textDiffs=N}}e.TextMultiDiffTabInput=ir;var mn;(function(M){M[M.Down=0]="Down",M[M.Up=1]="Up"})(mn||(e.InteractiveSessionVoteDirection=mn={}));var pn;(function(M){M[M.Action=1]="Action",M[M.Toolbar=2]="Toolbar"})(pn||(e.ChatCopyKind=pn={}));var vn;(function(M){M[M.Short=1]="Short",M[M.Medium=2]="Medium",M[M.Full=3]="Full"})(vn||(e.ChatVariableLevel=vn={}));class nr{constructor(N,ue,Pe){this.id=N,this.label=ue,this.values=Pe}}e.ChatCompletionItem=nr;var En;(function(M){M[M.Unhelpful=0]="Unhelpful",M[M.Helpful=1]="Helpful",M[M.Undone=2]="Undone",M[M.Accepted=3]="Accepted",M[M.Bug=4]="Bug"})(En||(e.InteractiveEditorResponseFeedbackKind=En={}));var Sn;(function(M){M[M.Unhelpful=0]="Unhelpful",M[M.Helpful=1]="Helpful"})(Sn||(e.ChatResultFeedbackKind=Sn={}));class rr{constructor(N){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new qe(N):N}}e.ChatResponseMarkdownPart=rr;class sr{constructor(N,ue){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new qe(N):N,this.vulnerabilities=ue}}e.ChatResponseMarkdownWithVulnerabilitiesPart=sr;class or{constructor(N,ue){this.participant=N,this.command=ue}}e.ChatResponseDetectedParticipantPart=or;class ar{constructor(N,ue,Pe){this.title=N,this.message=ue,this.data=Pe}}e.ChatResponseConfirmationPart=ar;class lr{constructor(N,ue){this.value=N,this.baseUri=ue}}e.ChatResponseFileTreePart=lr;class cr{constructor(N,ue){this.value=N,this.title=ue}}e.ChatResponseAnchorPart=cr;class ur{constructor(N){this.value=N}}e.ChatResponseProgressPart=ur;class dr{constructor(N,ue){this.value=N,this.task=ue}}e.ChatResponseProgressPart2=dr;class hr{constructor(N){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new qe(N):N}}e.ChatResponseWarningPart=hr;class fr{constructor(N){this.value=N}}e.ChatResponseCommandButtonPart=fr;class gr{constructor(N,ue){this.value=N,this.iconPath=ue}}e.ChatResponseReferencePart=gr;class mr{constructor(N,ue){this.uri=N,this.edits=Array.isArray(ue)?ue:[ue]}}e.ChatResponseTextEditPart=mr;class pr{constructor(N,ue,Pe,$e){this.prompt=N,this.command=ue,this.references=Pe,this.participant=$e}}e.ChatRequestTurn=pr;class vr{constructor(N,ue,Pe,$e){this.response=N,this.result=ue,this.participant=Pe,this.command=$e}}e.ChatResponseTurn=vr;var yn;(function(M){M[M.Panel=1]="Panel",M[M.Terminal=2]="Terminal",M[M.Notebook=3]="Notebook",M[M.Editor=4]="Editor"})(yn||(e.ChatLocation=yn={}));var Pi;(function(M){M[M.User=1]="User",M[M.Assistant=2]="Assistant",M[M.System=3]="System"})(Pi||(e.LanguageModelChatMessageRole=Pi={}));class Er{constructor(N,ue,Pe){this.name=N,this.content=ue,this.isError=Pe??!1}}e.LanguageModelFunctionResultPart=Er;class Ti{static User(N,ue){const Pe=new Ti(Pi.User,typeof N=="string"?N:"",ue);return Pe.content2=N,Pe}static Assistant(N,ue){return new Ti(Pi.Assistant,N,ue)}constructor(N,ue,Pe){this.role=N,this.content=ue,this.content2=ue,this.name=Pe}}e.LanguageModelChatMessage=Ti;class Sr{constructor(N,ue){this.name=N,this.parameters=ue}}e.LanguageModelFunctionUsePart=Sr;class yr{constructor(N){this.value=N}}e.LanguageModelTextPart=yr;class br{constructor(N){this.content=N}}e.LanguageModelChatSystemMessage=br;class wr{constructor(N,ue){this.content=N,this.name=ue}}e.LanguageModelChatUserMessage=wr;class Ir{constructor(N,ue){this.content=N,this.name=ue}}e.LanguageModelChatAssistantMessage=Ir;class di extends Error{static NotFound(N){return new di(N,di.NotFound.name)}static NoPermissions(N){return new di(N,di.NoPermissions.name)}static Blocked(N){return new di(N,di.Blocked.name)}constructor(N,ue,Pe){super(N,{cause:Pe}),this.name="LanguageModelError",this.code=ue??""}}e.LanguageModelError=di;var bn;(function(M){M[M.SymbolInformation=1]="SymbolInformation",M[M.CommandInformation=2]="CommandInformation",M[M.SearchInformation=3]="SearchInformation",M[M.SettingInformation=4]="SettingInformation"})(bn||(e.RelatedInformationType=bn={}));var wn;(function(M){M[M.Started=1]="Started",M[M.Recognizing=2]="Recognizing",M[M.Recognized=3]="Recognized",M[M.Stopped=4]="Stopped",M[M.Error=5]="Error"})(wn||(e.SpeechToTextStatus=wn={}));var In;(function(M){M[M.Started=1]="Started",M[M.Stopped=2]="Stopped",M[M.Error=3]="Error"})(In||(e.TextToSpeechStatus=In={}));var Dn;(function(M){M[M.Recognized=1]="Recognized",M[M.Stopped=2]="Stopped"})(Dn||(e.KeywordRecognitionStatus=Dn={}));class Dr{constructor(N,ue){this.text=N,this.range=ue}}e.InlineEdit=Dr;var Cn;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(Cn||(e.InlineEditTriggerKind=Cn={}))}),define(ye[154],Ie([1,0,18,15,175,79,111,26,161,50,68,21,167,20,82,11,4,249,49,110,201,182,261,262,148,102,302,315,303,152,76,103,150,153]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a,f,m,p,S,g,v,t,l,n,h,s,c,u,I,T,A,O,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.isDecorationOptionsArr=le,e.fromRangeOrRangeWithMessage=H,e.pathOrURIToURI=ce,R=Be(R),S=Be(S),g=Be(g),v=Be(v),u=Be(u),T=Be(T),P=Be(P);var B;(function(we){function ke(j){const{selectionStartLineNumber:_e,selectionStartColumn:Ue,positionLineNumber:Ke,positionColumn:We}=j,ot=new P.Position(_e-1,Ue-1),ft=new P.Position(Ke-1,We-1);return new P.Selection(ot,ft)}we.to=ke;function me(j){const{anchor:_e,active:Ue}=j;return{selectionStartLineNumber:_e.line+1,selectionStartColumn:_e.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}we.from=me})(B||(e.Selection=B={}));var Y;(function(we){function ke(j){if(!j)return;const{start:_e,end:Ue}=j;return{startLineNumber:_e.line+1,startColumn:_e.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}we.from=ke;function me(j){if(!j)return;const{startLineNumber:_e,startColumn:Ue,endLineNumber:Ke,endColumn:We}=j;return new P.Range(_e-1,Ue-1,Ke-1,We-1)}we.to=me})(Y||(e.Range=Y={}));var X;(function(we){function ke(j){return{uri:j.uri,range:Y.from(j.range)}}we.from=ke;function me(j){return new P.Location(m.URI.revive(j.uri),Y.to(j.range))}we.to=me})(X||(e.Location=X={}));var re;(function(we){function ke(me){switch(me){case g.StandardTokenType.Comment:return P.StandardTokenType.Comment;case g.StandardTokenType.Other:return P.StandardTokenType.Other;case g.StandardTokenType.RegEx:return P.StandardTokenType.RegEx;case g.StandardTokenType.String:return P.StandardTokenType.String}}we.to=ke})(re||(e.TokenType=re={}));var te;(function(we){function ke(j){return new P.Position(j.lineNumber-1,j.column-1)}we.to=ke;function me(j){return{lineNumber:j.line+1,column:j.character+1}}we.from=me})(te||(e.Position=te={}));var Z;(function(we){function ke(_e,Ue,Ke){return(0,i.coalesce)((0,i.asArray)(_e).map(We=>me(We,Ue,Ke)))}we.from=ke;function me(_e,Ue,Ke){if(typeof _e=="string")return{$serialized:!0,language:_e,isBuiltin:Ke?.isBuiltin};if(_e)return{$serialized:!0,language:_e.language,scheme:j(_e.scheme,Ue),pattern:Ge.from(_e.pattern)??void 0,exclusive:_e.exclusive,notebookType:_e.notebookType,isBuiltin:Ke?.isBuiltin}}function j(_e,Ue){return Ue&&typeof _e=="string"?Ue.transformOutgoingScheme(_e):_e}})(Z||(e.DocumentSelector=Z={}));var fe;(function(we){function ke(j){switch(j){case P.DiagnosticTag.Unnecessary:return l.MarkerTag.Unnecessary;case P.DiagnosticTag.Deprecated:return l.MarkerTag.Deprecated}}we.from=ke;function me(j){switch(j){case l.MarkerTag.Unnecessary:return P.DiagnosticTag.Unnecessary;case l.MarkerTag.Deprecated:return P.DiagnosticTag.Deprecated;default:return}}we.to=me})(fe||(e.DiagnosticTag=fe={}));var K;(function(we){function ke(j){let _e;return j.code&&((0,f.isString)(j.code)||(0,f.isNumber)(j.code)?_e=String(j.code):_e={value:String(j.code.value),target:j.code.target}),{...Y.from(j.range),message:j.message,source:j.source,code:_e,severity:x.from(j.severity),relatedInformation:j.relatedInformation&&j.relatedInformation.map(ae.from),tags:Array.isArray(j.tags)?(0,i.coalesce)(j.tags.map(fe.from)):void 0}}we.from=ke;function me(j){const _e=new P.Diagnostic(Y.to(j),j.message,x.to(j.severity));return _e.source=j.source,_e.code=(0,f.isString)(j.code)?j.code:j.code?.value,_e.relatedInformation=j.relatedInformation&&j.relatedInformation.map(ae.to),_e.tags=j.tags&&(0,i.coalesce)(j.tags.map(fe.to)),_e}we.to=me})(K||(e.Diagnostic=K={}));var ae;(function(we){function ke(j){return{...Y.from(j.location.range),message:j.message,resource:j.location.uri}}we.from=ke;function me(j){return new P.DiagnosticRelatedInformation(new P.Location(j.resource,Y.to(j)),j.message)}we.to=me})(ae||(e.DiagnosticRelatedInformation=ae={}));var x;(function(we){function ke(j){switch(j){case P.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case P.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case P.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case P.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}we.from=ke;function me(j){switch(j){case l.MarkerSeverity.Info:return P.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return P.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return P.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return P.DiagnosticSeverity.Hint;default:return P.DiagnosticSeverity.Error}}we.to=me})(x||(e.DiagnosticSeverity=x={}));var z;(function(we){function ke(j){return typeof j=="number"&&j>=P.ViewColumn.One?j-1:j===P.ViewColumn.Beside?k.SIDE_GROUP:k.ACTIVE_GROUP}we.from=ke;function me(j){if(typeof j=="number"&&j>=0)return j+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=me})(z||(e.ViewColumn=z={}));function ne(we){return typeof we.range<"u"}function le(we){return we.length===0?!0:!!ne(we[0])}var ve;(function(we){function ke(We){return We.map(we.from)}we.fromMany=ke;function me(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function j(We){let ot;if(me(We)){const{language:bt,value:Gt}=We;ot={value:"```"+bt+`
`+Gt+"\n```\n"}}else P.MarkdownString.isMarkdownString(We)?ot={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?ot={value:We}:ot={value:""};const ft=Object.create(null);ot.uris=ft;const Mt=bt=>{try{let Gt=m.URI.parse(bt,!0);Gt=Gt.with({query:_e(Gt.query,ft)}),ft[bt]=Gt}catch{}return""},jt=new b.marked.Renderer;return jt.link=Mt,jt.image=bt=>typeof bt=="string"?Mt(R.parseHrefAndDimensions(bt).href):"",(0,b.marked)(ot.value,{renderer:jt}),ot}we.from=j;function _e(We,ot){if(!We)return We;let ft;try{ft=(0,o.parse)(We)}catch{}if(!ft)return We;let Mt=!1;return ft=(0,y.cloneAndChange)(ft,jt=>{if(m.URI.isUri(jt)){const bt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[bt]=jt,Mt=!0,bt}else return}),Mt?JSON.stringify(ft):We}function Ue(We){const ot=new P.MarkdownString(We.value,We.supportThemeIcons);return ot.isTrusted=We.isTrusted,ot.supportHtml=We.supportHtml,ot.baseUri=We.baseUri?m.URI.from(We.baseUri):void 0,ot}we.to=Ue;function Ke(We){if(We)return typeof We=="string"?We:we.from(We)}we.fromStrict=Ke})(ve||(e.MarkdownString=ve={}));function H(we){return le(we)?we.map(ke=>({range:Y.from(ke.range),hoverMessage:Array.isArray(ke.hoverMessage)?ve.fromMany(ke.hoverMessage):ke.hoverMessage?ve.from(ke.hoverMessage):void 0,renderOptions:ke.renderOptions})):we.map(ke=>({range:Y.from(ke)}))}function ce(we){return typeof we>"u"?we:typeof we=="string"?m.URI.file(we):we}var J;(function(we){function ke(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?ce(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}we.from=ke})(J||(e.ThemableDecorationAttachmentRenderOptions=J={}));var W;(function(we){function ke(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?ce(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?J.from(me.before):void 0,after:me.after?J.from(me.after):void 0}}we.from=ke})(W||(e.ThemableDecorationRenderOptions=W={}));var L;(function(we){function ke(me){if(typeof me>"u")return me;switch(me){case P.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case P.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case P.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case P.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}we.from=ke})(L||(e.DecorationRangeBehavior=L={}));var Q;(function(we){function ke(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?L.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?W.from(me.light):void 0,dark:me.dark?W.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?ce(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?J.from(me.before):void 0,after:me.after?J.from(me.after):void 0}}we.from=ke})(Q||(e.DecorationRenderOptions=Q={}));var $;(function(we){function ke(j){return{text:j.newText,eol:j.newEol&&Ae.from(j.newEol),range:Y.from(j.range)}}we.from=ke;function me(j){const _e=new P.TextEdit(Y.to(j.range),j.text);return _e.newEol=typeof j.eol>"u"?void 0:Ae.to(j.eol),_e}we.to=me})($||(e.TextEdit=$={}));var U;(function(we){function ke(j,_e){const Ue={edits:[]};if(j instanceof P.WorkspaceEdit){const Ke=new _.ResourceSet;for(const We of j._allEntries())We._type===P.FileEditType.File&&m.URI.isUri(We.to)&&We.from===void 0&&Ke.add(We.to);for(const We of j._allEntries())if(We._type===P.FileEditType.File){let ot;We.options?.contents&&(ArrayBuffer.isView(We.options.contents)?ot={type:"base64",value:(0,r.encodeBase64)(r.VSBuffer.wrap(We.options.contents))}:ot={type:"dataTransferItem",id:We.options.contents._itemId}),Ue.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contents:ot},metadata:We.metadata})}else We._type===P.FileEditType.Text?Ue.edits.push({resource:We.uri,textEdit:$.from(We.edit),versionId:Ke.has(We.uri)?void 0:_e?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===P.FileEditType.Snippet?Ue.edits.push({resource:We.uri,textEdit:{range:Y.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Ke.has(We.uri)?void 0:_e?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===P.FileEditType.Cell?Ue.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:_e?.getNotebookDocumentVersion(We.uri)}):We._type===P.FileEditType.CellReplace&&Ue.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:_e?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:T.CellEditType.Replace,index:We.index,count:We.count,cells:We.cells.map(ht.from)}})}return Ue}we.from=ke;function me(j){const _e=new P.WorkspaceEdit,Ue=new _.ResourceMap;for(const Ke of j.edits)if(Ke.textEdit){const We=Ke,ot=m.URI.revive(We.resource),ft=Y.to(We.textEdit.range),Mt=We.textEdit.text,jt=We.textEdit.insertAsSnippet;let bt;jt?bt=P.SnippetTextEdit.replace(ft,new P.SnippetString(Mt)):bt=P.TextEdit.replace(ft,Mt);const Gt=Ue.get(ot);Gt?Gt.push(bt):Ue.set(ot,[bt])}else _e.renameFile(m.URI.revive(Ke.oldResource),m.URI.revive(Ke.newResource),Ke.options);for(const[Ke,We]of Ue)_e.set(Ke,We);return _e}we.to=me})(U||(e.WorkspaceEdit=U={}));var q;(function(we){const ke=Object.create(null);ke[P.SymbolKind.File]=v.SymbolKind.File,ke[P.SymbolKind.Module]=v.SymbolKind.Module,ke[P.SymbolKind.Namespace]=v.SymbolKind.Namespace,ke[P.SymbolKind.Package]=v.SymbolKind.Package,ke[P.SymbolKind.Class]=v.SymbolKind.Class,ke[P.SymbolKind.Method]=v.SymbolKind.Method,ke[P.SymbolKind.Property]=v.SymbolKind.Property,ke[P.SymbolKind.Field]=v.SymbolKind.Field,ke[P.SymbolKind.Constructor]=v.SymbolKind.Constructor,ke[P.SymbolKind.Enum]=v.SymbolKind.Enum,ke[P.SymbolKind.Interface]=v.SymbolKind.Interface,ke[P.SymbolKind.Function]=v.SymbolKind.Function,ke[P.SymbolKind.Variable]=v.SymbolKind.Variable,ke[P.SymbolKind.Constant]=v.SymbolKind.Constant,ke[P.SymbolKind.String]=v.SymbolKind.String,ke[P.SymbolKind.Number]=v.SymbolKind.Number,ke[P.SymbolKind.Boolean]=v.SymbolKind.Boolean,ke[P.SymbolKind.Array]=v.SymbolKind.Array,ke[P.SymbolKind.Object]=v.SymbolKind.Object,ke[P.SymbolKind.Key]=v.SymbolKind.Key,ke[P.SymbolKind.Null]=v.SymbolKind.Null,ke[P.SymbolKind.EnumMember]=v.SymbolKind.EnumMember,ke[P.SymbolKind.Struct]=v.SymbolKind.Struct,ke[P.SymbolKind.Event]=v.SymbolKind.Event,ke[P.SymbolKind.Operator]=v.SymbolKind.Operator,ke[P.SymbolKind.TypeParameter]=v.SymbolKind.TypeParameter;function me(_e){return typeof ke[_e]=="number"?ke[_e]:v.SymbolKind.Property}we.from=me;function j(_e){for(const Ue in ke)if(ke[Ue]===_e)return Number(Ue);return P.SymbolKind.Property}we.to=j})(q||(e.SymbolKind=q={}));var G;(function(we){function ke(j){switch(j){case P.SymbolTag.Deprecated:return v.SymbolTag.Deprecated}}we.from=ke;function me(j){switch(j){case v.SymbolTag.Deprecated:return P.SymbolTag.Deprecated}}we.to=me})(G||(e.SymbolTag=G={}));var F;(function(we){function ke(j){return{name:j.name,kind:q.from(j.kind),tags:j.tags&&j.tags.map(G.from),containerName:j.containerName,location:Ne.from(j.location)}}we.from=ke;function me(j){const _e=new P.SymbolInformation(j.name,q.to(j.kind),j.containerName,Ne.to(j.location));return _e.tags=j.tags&&j.tags.map(G.to),_e}we.to=me})(F||(e.WorkspaceSymbol=F={}));var V;(function(we){function ke(j){const _e={name:j.name||"!!MISSING: name!!",detail:j.detail,range:Y.from(j.range),selectionRange:Y.from(j.selectionRange),kind:q.from(j.kind),tags:j.tags?.map(G.from)??[]};return j.children&&(_e.children=j.children.map(ke)),_e}we.from=ke;function me(j){const _e=new P.DocumentSymbol(j.name,j.detail,q.to(j.kind),Y.to(j.range),Y.to(j.selectionRange));return(0,i.isNonEmptyArray)(j.tags)&&(_e.tags=j.tags.map(G.to)),j.children&&(_e.children=j.children.map(me)),_e}we.to=me})(V||(e.DocumentSymbol=V={}));var oe;(function(we){function ke(j){const _e=new P.CallHierarchyItem(q.to(j.kind),j.name,j.detail||"",m.URI.revive(j.uri),Y.to(j.range),Y.to(j.selectionRange));return _e._sessionId=j._sessionId,_e._itemId=j._itemId,_e}we.to=ke;function me(j,_e,Ue){if(_e=_e??j._sessionId,Ue=Ue??j._itemId,_e===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:_e,_itemId:Ue,name:j.name,detail:j.detail,kind:q.from(j.kind),uri:j.uri,range:Y.from(j.range),selectionRange:Y.from(j.selectionRange),tags:j.tags?.map(G.from)}}we.from=me})(oe||(e.CallHierarchyItem=oe={}));var de;(function(we){function ke(me){return new P.CallHierarchyIncomingCall(oe.to(me.from),me.fromRanges.map(j=>Y.to(j)))}we.to=ke})(de||(e.CallHierarchyIncomingCall=de={}));var Ce;(function(we){function ke(me){return new P.CallHierarchyOutgoingCall(oe.to(me.to),me.fromRanges.map(j=>Y.to(j)))}we.to=ke})(Ce||(e.CallHierarchyOutgoingCall=Ce={}));var Ne;(function(we){function ke(j){return{range:j.range&&Y.from(j.range),uri:j.uri}}we.from=ke;function me(j){return new P.Location(m.URI.revive(j.uri),Y.to(j.range))}we.to=me})(Ne||(e.location=Ne={}));var ge;(function(we){function ke(j){const _e=j,Ue=j;return{originSelectionRange:_e.originSelectionRange?Y.from(_e.originSelectionRange):void 0,uri:_e.targetUri?_e.targetUri:Ue.uri,range:Y.from(_e.targetRange?_e.targetRange:Ue.range),targetSelectionRange:_e.targetSelectionRange?Y.from(_e.targetSelectionRange):void 0}}we.from=ke;function me(j){return{targetUri:m.URI.revive(j.uri),targetRange:Y.to(j.range),targetSelectionRange:j.targetSelectionRange?Y.to(j.targetSelectionRange):void 0,originSelectionRange:j.originSelectionRange?Y.to(j.originSelectionRange):void 0}}we.to=me})(ge||(e.DefinitionLink=ge={}));var pe;(function(we){function ke(j){return{range:Y.from(j.range),contents:ve.fromMany(j.contents),canIncreaseVerbosity:j.canIncreaseVerbosity,canDecreaseVerbosity:j.canDecreaseVerbosity}}we.from=ke;function me(j){const _e=j.contents.map(ve.to),Ue=Y.to(j.range),Ke=j.canIncreaseVerbosity,We=j.canDecreaseVerbosity;return new P.VerboseHover(_e,Ue,Ke,We)}we.to=me})(pe||(e.Hover=pe={}));var Te;(function(we){function ke(j){return{range:Y.from(j.range),expression:j.expression}}we.from=ke;function me(j){return new P.EvaluatableExpression(Y.to(j.range),j.expression)}we.to=me})(Te||(e.EvaluatableExpression=Te={}));var Le;(function(we){function ke(j){if(j instanceof P.InlineValueText)return{type:"text",range:Y.from(j.range),text:j.text};if(j instanceof P.InlineValueVariableLookup)return{type:"variable",range:Y.from(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};if(j instanceof P.InlineValueEvaluatableExpression)return{type:"expression",range:Y.from(j.range),expression:j.expression};throw new Error("Unknown 'InlineValue' type")}we.from=ke;function me(j){switch(j.type){case"text":return{range:Y.to(j.range),text:j.text};case"variable":return{range:Y.to(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};case"expression":return{range:Y.to(j.range),expression:j.expression}}}we.to=me})(Le||(e.InlineValue=Le={}));var he;(function(we){function ke(j){return{frameId:j.frameId,stoppedLocation:Y.from(j.stoppedLocation)}}we.from=ke;function me(j){return new P.InlineValueContext(j.frameId,Y.to(j.stoppedLocation))}we.to=me})(he||(e.InlineValueContext=he={}));var De;(function(we){function ke(j){return{range:Y.from(j.range),kind:j.kind}}we.from=ke;function me(j){return new P.DocumentHighlight(Y.to(j.range),j.kind)}we.to=me})(De||(e.DocumentHighlight=De={}));var Re;(function(we){function ke(j){return{uri:j.uri,highlights:j.highlights.map(De.from)}}we.from=ke;function me(j){return new P.MultiDocumentHighlight(m.URI.revive(j.uri),j.highlights.map(De.to))}we.to=me})(Re||(e.MultiDocumentHighlight=Re={}));var xe;(function(we){function ke(me){switch(me){case v.CompletionTriggerKind.TriggerCharacter:return P.CompletionTriggerKind.TriggerCharacter;case v.CompletionTriggerKind.TriggerForIncompleteCompletions:return P.CompletionTriggerKind.TriggerForIncompleteCompletions;case v.CompletionTriggerKind.Invoke:default:return P.CompletionTriggerKind.Invoke}}we.to=ke})(xe||(e.CompletionTriggerKind=xe={}));var Ve;(function(we){function ke(me){return{triggerKind:xe.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}we.to=ke})(Ve||(e.CompletionContext=Ve={}));var Xe;(function(we){function ke(j){switch(j){case P.CompletionItemTag.Deprecated:return v.CompletionItemTag.Deprecated}}we.from=ke;function me(j){switch(j){case v.CompletionItemTag.Deprecated:return P.CompletionItemTag.Deprecated}}we.to=me})(Xe||(e.CompletionItemTag=Xe={}));var je;(function(we){const ke=new Map([[P.CompletionItemKind.Method,v.CompletionItemKind.Method],[P.CompletionItemKind.Function,v.CompletionItemKind.Function],[P.CompletionItemKind.Constructor,v.CompletionItemKind.Constructor],[P.CompletionItemKind.Field,v.CompletionItemKind.Field],[P.CompletionItemKind.Variable,v.CompletionItemKind.Variable],[P.CompletionItemKind.Class,v.CompletionItemKind.Class],[P.CompletionItemKind.Interface,v.CompletionItemKind.Interface],[P.CompletionItemKind.Struct,v.CompletionItemKind.Struct],[P.CompletionItemKind.Module,v.CompletionItemKind.Module],[P.CompletionItemKind.Property,v.CompletionItemKind.Property],[P.CompletionItemKind.Unit,v.CompletionItemKind.Unit],[P.CompletionItemKind.Value,v.CompletionItemKind.Value],[P.CompletionItemKind.Constant,v.CompletionItemKind.Constant],[P.CompletionItemKind.Enum,v.CompletionItemKind.Enum],[P.CompletionItemKind.EnumMember,v.CompletionItemKind.EnumMember],[P.CompletionItemKind.Keyword,v.CompletionItemKind.Keyword],[P.CompletionItemKind.Snippet,v.CompletionItemKind.Snippet],[P.CompletionItemKind.Text,v.CompletionItemKind.Text],[P.CompletionItemKind.Color,v.CompletionItemKind.Color],[P.CompletionItemKind.File,v.CompletionItemKind.File],[P.CompletionItemKind.Reference,v.CompletionItemKind.Reference],[P.CompletionItemKind.Folder,v.CompletionItemKind.Folder],[P.CompletionItemKind.Event,v.CompletionItemKind.Event],[P.CompletionItemKind.Operator,v.CompletionItemKind.Operator],[P.CompletionItemKind.TypeParameter,v.CompletionItemKind.TypeParameter],[P.CompletionItemKind.Issue,v.CompletionItemKind.Issue],[P.CompletionItemKind.User,v.CompletionItemKind.User]]);function me(Ue){return ke.get(Ue)??v.CompletionItemKind.Property}we.from=me;const j=new Map([[v.CompletionItemKind.Method,P.CompletionItemKind.Method],[v.CompletionItemKind.Function,P.CompletionItemKind.Function],[v.CompletionItemKind.Constructor,P.CompletionItemKind.Constructor],[v.CompletionItemKind.Field,P.CompletionItemKind.Field],[v.CompletionItemKind.Variable,P.CompletionItemKind.Variable],[v.CompletionItemKind.Class,P.CompletionItemKind.Class],[v.CompletionItemKind.Interface,P.CompletionItemKind.Interface],[v.CompletionItemKind.Struct,P.CompletionItemKind.Struct],[v.CompletionItemKind.Module,P.CompletionItemKind.Module],[v.CompletionItemKind.Property,P.CompletionItemKind.Property],[v.CompletionItemKind.Unit,P.CompletionItemKind.Unit],[v.CompletionItemKind.Value,P.CompletionItemKind.Value],[v.CompletionItemKind.Constant,P.CompletionItemKind.Constant],[v.CompletionItemKind.Enum,P.CompletionItemKind.Enum],[v.CompletionItemKind.EnumMember,P.CompletionItemKind.EnumMember],[v.CompletionItemKind.Keyword,P.CompletionItemKind.Keyword],[v.CompletionItemKind.Snippet,P.CompletionItemKind.Snippet],[v.CompletionItemKind.Text,P.CompletionItemKind.Text],[v.CompletionItemKind.Color,P.CompletionItemKind.Color],[v.CompletionItemKind.File,P.CompletionItemKind.File],[v.CompletionItemKind.Reference,P.CompletionItemKind.Reference],[v.CompletionItemKind.Folder,P.CompletionItemKind.Folder],[v.CompletionItemKind.Event,P.CompletionItemKind.Event],[v.CompletionItemKind.Operator,P.CompletionItemKind.Operator],[v.CompletionItemKind.TypeParameter,P.CompletionItemKind.TypeParameter],[v.CompletionItemKind.User,P.CompletionItemKind.User],[v.CompletionItemKind.Issue,P.CompletionItemKind.Issue]]);function _e(Ue){return j.get(Ue)??P.CompletionItemKind.Property}we.to=_e})(je||(e.CompletionItemKind=je={}));var qe;(function(we){function ke(me,j){const _e=new P.CompletionItem(me.label);return _e.insertText=me.insertText,_e.kind=je.to(me.kind),_e.tags=me.tags?.map(Xe.to),_e.detail=me.detail,_e.documentation=R.isMarkdownString(me.documentation)?ve.to(me.documentation):me.documentation,_e.sortText=me.sortText,_e.filterText=me.filterText,_e.preselect=me.preselect,_e.commitCharacters=me.commitCharacters,S.Range.isIRange(me.range)?_e.range=Y.to(me.range):typeof me.range=="object"&&(_e.range={inserting:Y.to(me.range.insert),replacing:Y.to(me.range.replace)}),_e.keepWhitespace=typeof me.insertTextRules>"u"?!1:!!(me.insertTextRules&v.CompletionItemInsertTextRule.KeepWhitespace),typeof me.insertTextRules<"u"&&me.insertTextRules&v.CompletionItemInsertTextRule.InsertAsSnippet?_e.insertText=new P.SnippetString(me.insertText):(_e.insertText=me.insertText,_e.textEdit=_e.range instanceof P.Range?new P.TextEdit(_e.range,_e.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(_e.additionalTextEdits=me.additionalTextEdits.map(Ue=>$.to(Ue))),_e.command=j&&me.command?j.fromInternal(me.command):void 0,_e}we.to=ke})(qe||(e.CompletionItem=qe={}));var Je;(function(we){function ke(j){if(typeof j.label!="string"&&!Array.isArray(j.label))throw new TypeError("Invalid label");return{label:j.label,documentation:ve.fromStrict(j.documentation)}}we.from=ke;function me(j){return{label:j.label,documentation:R.isMarkdownString(j.documentation)?ve.to(j.documentation):j.documentation}}we.to=me})(Je||(e.ParameterInformation=Je={}));var st;(function(we){function ke(j){return{label:j.label,documentation:ve.fromStrict(j.documentation),parameters:Array.isArray(j.parameters)?j.parameters.map(Je.from):[],activeParameter:j.activeParameter}}we.from=ke;function me(j){return{label:j.label,documentation:R.isMarkdownString(j.documentation)?ve.to(j.documentation):j.documentation,parameters:Array.isArray(j.parameters)?j.parameters.map(Je.to):[],activeParameter:j.activeParameter}}we.to=me})(st||(e.SignatureInformation=st={}));var lt;(function(we){function ke(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(st.from):[]}}we.from=ke;function me(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(st.to):[]}}we.to=me})(lt||(e.SignatureHelp=lt={}));var rt;(function(we){function ke(me,j){const _e=new P.InlayHint(te.to(j.position),typeof j.label=="string"?j.label:j.label.map(it.to.bind(void 0,me)),j.kind&&tt.to(j.kind));return _e.textEdits=j.textEdits&&j.textEdits.map($.to),_e.tooltip=R.isMarkdownString(j.tooltip)?ve.to(j.tooltip):j.tooltip,_e.paddingLeft=j.paddingLeft,_e.paddingRight=j.paddingRight,_e}we.to=ke})(rt||(e.InlayHint=rt={}));var it;(function(we){function ke(me,j){const _e=new P.InlayHintLabelPart(j.label);return _e.tooltip=R.isMarkdownString(j.tooltip)?ve.to(j.tooltip):j.tooltip,v.Command.is(j.command)&&(_e.command=me.fromInternal(j.command)),j.location&&(_e.location=Ne.to(j.location)),_e}we.to=ke})(it||(e.InlayHintLabelPart=it={}));var tt;(function(we){function ke(j){return j}we.from=ke;function me(j){return j}we.to=me})(tt||(e.InlayHintKind=tt={}));var et;(function(we){function ke(j){return{range:Y.from(j.range),url:j.target,tooltip:j.tooltip}}we.from=ke;function me(j){let _e;if(j.url)try{_e=typeof j.url=="string"?m.URI.parse(j.url,!0):m.URI.revive(j.url)}catch{}const Ue=new P.DocumentLink(Y.to(j.range),_e);return Ue.tooltip=j.tooltip,Ue}we.to=me})(et||(e.DocumentLink=et={}));var Qe;(function(we){function ke(j){const _e=new P.ColorPresentation(j.label);return j.textEdit&&(_e.textEdit=$.to(j.textEdit)),j.additionalTextEdits&&(_e.additionalTextEdits=j.additionalTextEdits.map(Ue=>$.to(Ue))),_e}we.to=ke;function me(j){return{label:j.label,textEdit:j.textEdit?$.from(j.textEdit):void 0,additionalTextEdits:j.additionalTextEdits?j.additionalTextEdits.map(_e=>$.from(_e)):void 0}}we.from=me})(Qe||(e.ColorPresentation=Qe={}));var Ee;(function(we){function ke(j){return new P.Color(j[0],j[1],j[2],j[3])}we.to=ke;function me(j){return[j.red,j.green,j.blue,j.alpha]}we.from=me})(Ee||(e.Color=Ee={}));var Oe;(function(we){function ke(j){return{range:Y.from(j.range)}}we.from=ke;function me(j){return new P.SelectionRange(Y.to(j.range))}we.to=me})(Oe||(e.SelectionRange=Oe={}));var Fe;(function(we){function ke(me){switch(me){case s.SaveReason.AUTO:return P.TextDocumentSaveReason.AfterDelay;case s.SaveReason.EXPLICIT:return P.TextDocumentSaveReason.Manual;case s.SaveReason.FOCUS_CHANGE:case s.SaveReason.WINDOW_CHANGE:return P.TextDocumentSaveReason.FocusOut}}we.to=ke})(Fe||(e.TextDocumentSaveReason=Fe={}));var be;(function(we){function ke(j){switch(j){case P.TextEditorLineNumbersStyle.Off:return p.RenderLineNumbersType.Off;case P.TextEditorLineNumbersStyle.Relative:return p.RenderLineNumbersType.Relative;case P.TextEditorLineNumbersStyle.Interval:return p.RenderLineNumbersType.Interval;case P.TextEditorLineNumbersStyle.On:default:return p.RenderLineNumbersType.On}}we.from=ke;function me(j){switch(j){case p.RenderLineNumbersType.Off:return P.TextEditorLineNumbersStyle.Off;case p.RenderLineNumbersType.Relative:return P.TextEditorLineNumbersStyle.Relative;case p.RenderLineNumbersType.Interval:return P.TextEditorLineNumbersStyle.Interval;case p.RenderLineNumbersType.On:default:return P.TextEditorLineNumbersStyle.On}}we.to=me})(be||(e.TextEditorLineNumbersStyle=be={}));var Ae;(function(we){function ke(j){if(j===P.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(j===P.EndOfLine.LF)return t.EndOfLineSequence.LF}we.from=ke;function me(j){if(j===t.EndOfLineSequence.CRLF)return P.EndOfLine.CRLF;if(j===t.EndOfLineSequence.LF)return P.EndOfLine.LF}we.to=me})(Ae||(e.EndOfLine=Ae={}));var ie;(function(we){function ke(me){if(typeof me=="object")return me.viewId;switch(me){case P.ProgressLocation.SourceControl:return n.ProgressLocation.Scm;case P.ProgressLocation.Window:return n.ProgressLocation.Window;case P.ProgressLocation.Notification:return n.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}we.from=ke})(ie||(e.ProgressLocation=ie={}));var ee;(function(we){function ke(j){const _e={start:j.start+1,end:j.end+1};return j.kind&&(_e.kind=Se.from(j.kind)),_e}we.from=ke;function me(j){const _e={start:j.start-1,end:j.end-1};return j.kind&&(_e.kind=Se.to(j.kind)),_e}we.to=me})(ee||(e.FoldingRange=ee={}));var Se;(function(we){function ke(j){if(j)switch(j){case P.FoldingRangeKind.Comment:return v.FoldingRangeKind.Comment;case P.FoldingRangeKind.Imports:return v.FoldingRangeKind.Imports;case P.FoldingRangeKind.Region:return v.FoldingRangeKind.Region}}we.from=ke;function me(j){if(j)switch(j.value){case v.FoldingRangeKind.Comment.value:return P.FoldingRangeKind.Comment;case v.FoldingRangeKind.Imports.value:return P.FoldingRangeKind.Imports;case v.FoldingRangeKind.Region.value:return P.FoldingRangeKind.Region}}we.to=me})(Se||(e.FoldingRangeKind=Se={}));var He;(function(we){function ke(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?Y.from(me.selection):void 0,override:typeof me.override=="boolean"?s.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}we.from=ke})(He||(e.TextEditorOpenOptions=He={}));var Ge;(function(we){function ke(Ue){return Ue instanceof P.RelativePattern?Ue.toJSON():typeof Ue=="string"?Ue:me(Ue)||j(Ue)?new P.RelativePattern(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}we.from=ke;function me(Ue){const Ke=Ue;return Ke?m.URI.isUri(Ke.baseUri)&&typeof Ke.pattern=="string":!1}function j(Ue){const Ke=Ue;return Ke?typeof Ke.base=="string"&&typeof Ke.pattern=="string":!1}function _e(Ue){return typeof Ue=="string"?Ue:new P.RelativePattern(m.URI.revive(Ue.baseUri),Ue.pattern)}we.to=_e})(Ge||(e.GlobPattern=Ge={}));var Ze;(function(we){function ke(me){if(me){if(Array.isArray(me))return me.map(ke);if(typeof me=="string")return me;{const j=me;return{language:j.language,scheme:j.scheme,pattern:Ge.from(j.pattern),exclusive:j.exclusive,notebookType:j.notebookType}}}else return}we.from=ke})(Ze||(e.LanguageSelector=Ze={}));var nt;(function(we){function ke(j){return!!j&&typeof j=="object"&&"documents"in j&&Array.isArray(j.documents)&&j.documents.every(_e=>Array.isArray(_e)&&_e.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&m.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Ke=>Ke instanceof P.Range)))}we.is=ke;function me(j){return{documents:j.documents.map(_e=>_e.map(Ue=>({uri:m.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Ke=>Y.from(Ke))})))}}we.from=me})(nt||(e.MappedEditsContext=nt={}));var ut;(function(we){function ke(j){return{start:j.start,end:j.end}}we.from=ke;function me(j){return new P.NotebookRange(j.start,j.end)}we.to=me})(ut||(e.NotebookRange=ut={}));var mt;(function(we){function ke(j){return{timing:typeof j.runStartTime=="number"&&typeof j.runEndTime=="number"?{startTime:j.runStartTime,endTime:j.runEndTime}:void 0,executionOrder:j.executionOrder,success:j.lastRunSuccess}}we.to=ke;function me(j){return{lastRunSuccess:j.success,runStartTime:j.timing?.startTime,runEndTime:j.timing?.endTime,executionOrder:j.executionOrder}}we.from=me})(mt||(e.NotebookCellExecutionSummary=mt={}));var Et;(function(we){function ke(me){if(me===T.NotebookCellExecutionState.Unconfirmed)return P.NotebookCellExecutionState.Pending;if(me===T.NotebookCellExecutionState.Pending)return;if(me===T.NotebookCellExecutionState.Executing)return P.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}we.to=ke})(Et||(e.NotebookCellExecutionState=Et={}));var Ut;(function(we){function ke(j){switch(j){case P.NotebookCellKind.Markup:return T.CellKind.Markup;case P.NotebookCellKind.Code:default:return T.CellKind.Code}}we.from=ke;function me(j){switch(j){case T.CellKind.Markup:return P.NotebookCellKind.Markup;case T.CellKind.Code:default:return P.NotebookCellKind.Code}}we.to=me})(Ut||(e.NotebookCellKind=Ut={}));var _t;(function(we){function ke(j){const _e={metadata:j.metadata??Object.create(null),cells:[]};for(const Ue of j.cells)P.NotebookCellData.validate(Ue),_e.cells.push(ht.from(Ue));return _e}we.from=ke;function me(j){const _e=new P.NotebookData(j.cells.map(ht.to));return(0,f.isEmptyObject)(j.metadata)||(_e.metadata=j.metadata),_e}we.to=me})(_t||(e.NotebookData=_t={}));var ht;(function(we){function ke(j){return{cellKind:Ut.from(j.kind),language:j.languageId,mime:j.mime,source:j.value,metadata:j.metadata,internalMetadata:mt.from(j.executionSummary??{}),outputs:j.outputs?j.outputs.map(wt.from):[]}}we.from=ke;function me(j){return new P.NotebookCellData(Ut.to(j.cellKind),j.source,j.language,j.mime,j.outputs?j.outputs.map(wt.to):void 0,j.metadata,j.internalMetadata?mt.to(j.internalMetadata):void 0)}we.to=me})(ht||(e.NotebookCellData=ht={}));var St;(function(we){function ke(j){return{mime:j.mime,valueBytes:r.VSBuffer.wrap(j.data)}}we.from=ke;function me(j){return new P.NotebookCellOutputItem(j.valueBytes.buffer,j.mime)}we.to=me})(St||(e.NotebookCellOutputItem=St={}));var wt;(function(we){function ke(j){return{outputId:j.id,items:j.items.map(St.from),metadata:j.metadata}}we.from=ke;function me(j){const _e=j.items.map(St.to);return new P.NotebookCellOutput(_e,j.outputId,j.metadata)}we.to=me})(wt||(e.NotebookCellOutput=wt={}));var Ct;(function(we){function ke(_e){return j(_e)?{include:Ge.from(_e.include)??void 0,exclude:Ge.from(_e.exclude)??void 0}:Ge.from(_e)??void 0}we.from=ke;function me(_e){return j(_e)?{include:Ge.to(_e.include),exclude:Ge.to(_e.exclude)}:Ge.to(_e)}we.to=me;function j(_e){const Ue=_e;return Ue?!(0,f.isUndefinedOrNull)(Ue.include)&&!(0,f.isUndefinedOrNull)(Ue.exclude):!1}})(Ct||(e.NotebookExclusiveDocumentPattern=Ct={}));var Kt;(function(we){function ke(me,j,_e){const Ue=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===P.NotebookCellStatusBarAlignment.Left?T.CellStatusbarAlignment.Left:T.CellStatusbarAlignment.Right,command:j.toInternal(Ue,_e),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}we.from=ke})(Kt||(e.NotebookStatusBarItem=Kt={}));var Lt;(function(we){function ke(me,j,_e){const Ue=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{command:j.toInternal(Ue,_e),label:me.label,description:me.description,detail:me.detail,documentation:me.documentation}}we.from=ke})(Lt||(e.NotebookKernelSourceAction=Lt={}));var dt;(function(we){function ke(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{},cellContentMetadata:me?.cellContentMetadata??{}}}we.from=ke})(dt||(e.NotebookDocumentContentOptions=dt={}));var vt;(function(we){function ke(j){return{uri:j.uri,provides:j.provides}}we.from=ke;function me(j){return new P.NotebookRendererScript(m.URI.revive(j.uri),j.provides)}we.to=me})(vt||(e.NotebookRendererScript=vt={}));var yt;(function(we){function ke(j){return{message:ve.fromStrict(j.message)||"",type:O.TestMessageType.Error,expected:j.expectedOutput,actual:j.actualOutput,contextValue:j.contextValue,location:j.location&&{range:Y.from(j.location.range),uri:j.location.uri}}}we.from=ke;function me(j){const _e=new P.TestMessage(typeof j.message=="string"?j.message:ve.to(j.message));return _e.actualOutput=j.actual,_e.expectedOutput=j.expected,_e.contextValue=j.contextValue,_e.location=j.location?Ne.to(j.location):void 0,_e}we.to=me})(yt||(e.TestMessage=yt={}));var Pt;(function(we){we.namespace=O.namespaceTestTag,we.denamespace=O.denamespaceTestTag})(Pt||(e.TestTag=Pt={}));var xt;(function(we){function ke(j){const _e=(0,h.getPrivateApiFor)(j).controllerId;return{extId:A.TestId.fromExtHostTestItem(j,_e).toString(),label:j.label,uri:m.URI.revive(j.uri),busy:j.busy,tags:j.tags.map(Ue=>Pt.namespace(_e,Ue.id)),range:S.Range.lift(Y.from(j.range)),description:j.description||null,sortText:j.sortText||null,error:j.error&&ve.fromStrict(j.error)||null}}we.from=ke;function me(j){return{parent:void 0,error:void 0,id:A.TestId.fromString(j.extId).localId,label:j.label,uri:m.URI.revive(j.uri),tags:(j.tags||[]).map(_e=>{const{tagId:Ue}=Pt.denamespace(_e);return new P.TestTag(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:Y.to(j.range||void 0),canResolveChildren:!1,busy:j.busy,description:j.description||void 0,sortText:j.sortText||void 0}}we.toPlain=me})(xt||(e.TestItem=xt={})),function(we){function ke(j){return{id:j.id}}we.from=ke;function me(j){return new P.TestTag(j.id)}we.to=me}(Pt||(e.TestTag=Pt={}));var At;(function(we){const ke=(j,_e)=>{const Ue=j.value;if(!Ue)return;const Ke={...xt.toPlain(Ue.item),parent:_e,taskStates:Ue.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(ot=>ot.type===O.TestMessageType.Error).map(yt.to)})),children:[]};if(j.children)for(const We of j.children.values()){const ot=ke(We,Ke);ot&&Ke.children.push(ot)}return Ke};function me(j){const _e=new d.WellDefinedPrefixTree;for(const We of j.items)_e.insert(A.TestId.fromString(We.item.extId).path,We);const Ue=[_e.nodes],Ke=[];for(;Ue.length;)for(const We of Ue.pop())We.value?Ke.push(We):We.children&&Ue.push(We.children.values());return{completedAt:j.completedAt,results:Ke.map(We=>ke(We)).filter(f.isDefined)}}we.to=me})(At||(e.TestResults=At={}));var Zt;(function(we){function ke(Ue){return{covered:Ue.covered,total:Ue.total}}function me(Ue){return"line"in Ue?te.from(Ue):Y.from(Ue)}function j(Ue){if(typeof Ue.executed=="number"&&Ue.executed<0)throw new Error(`Invalid coverage count ${Ue.executed}`);return"branches"in Ue?{count:Ue.executed,location:me(Ue.location),type:O.DetailType.Statement,branches:Ue.branches.length?Ue.branches.map(Ke=>({count:Ke.executed,location:Ke.location&&me(Ke.location),label:Ke.label})):void 0}:{type:O.DetailType.Declaration,name:Ue.name,count:Ue.executed,location:me(Ue.location)}}we.fromDetails=j;function _e(Ue,Ke,We){return P.validateTestCoverageCount(We.statementCoverage),P.validateTestCoverageCount(We.branchCoverage),P.validateTestCoverageCount(We.declarationCoverage),{id:Ke,uri:We.uri,statement:ke(We.statementCoverage),branch:We.branchCoverage&&ke(We.branchCoverage),declaration:We.declarationCoverage&&ke(We.declarationCoverage),testIds:We instanceof P.FileCoverage&&We.fromTests.length?We.fromTests.map(ot=>A.TestId.fromExtHostTestItem(ot,Ue).toString()):void 0}}we.fromFile=_e})(Zt||(e.TestCoverage=Zt={}));var Tt;(function(we){function ke(me){switch(me){case v.CodeActionTriggerType.Invoke:return P.CodeActionTriggerKind.Invoke;case v.CodeActionTriggerType.Auto:return P.CodeActionTriggerKind.Automatic}}we.to=ke})(Tt||(e.CodeActionTriggerKind=Tt={}));var Ot;(function(we){function ke(j){const _e=new P.TypeHierarchyItem(q.to(j.kind),j.name,j.detail||"",m.URI.revive(j.uri),Y.to(j.range),Y.to(j.selectionRange));return _e._sessionId=j._sessionId,_e._itemId=j._itemId,_e}we.to=ke;function me(j,_e,Ue){if(_e=_e??j._sessionId,Ue=Ue??j._itemId,_e===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:_e,_itemId:Ue,kind:q.from(j.kind),name:j.name,detail:j.detail??"",uri:j.uri,range:Y.from(j.range),selectionRange:Y.from(j.selectionRange),tags:j.tags?.map(G.from)}}we.from=me})(Ot||(e.TypeHierarchyItem=Ot={}));var zt;(function(we){function ke(me){if(me)return{value:me.value,tooltip:me.tooltip}}we.from=ke})(zt||(e.ViewBadge=zt={}));var Nt;(function(we){function ke(Ue,Ke,We){const ot=Ke.fileData;return ot?new P.InternalFileDataTransferItem(new P.DataTransferFile(ot.name,m.URI.revive(ot.uri),ot.id,(0,C.createSingleCallFunction)(()=>We(ot.id)))):Ue===D.Mimes.uriList&&Ke.uriListData?new P.InternalDataTransferItem(_e(Ke.uriListData)):new P.InternalDataTransferItem(Ke.asString)}we.to=ke;async function me(Ue,Ke){const We=await Ke.asString();if(Ue===D.Mimes.uriList)return{asString:We,fileData:void 0,uriListData:j(We)};const ot=Ke.asFile();return{asString:We,fileData:ot?{name:ot.name,uri:ot.uri,id:ot._itemId??ot.id}:void 0}}we.from=me;function j(Ue){return w.UriList.split(Ue).map(Ke=>{if(Ke.startsWith("#"))return Ke;try{return m.URI.parse(Ke)}catch{}return Ke})}function _e(Ue){return w.UriList.create(Ue.map(Ke=>typeof Ke=="string"?Ke:m.URI.revive(Ke)))}})(Nt||(e.DataTransferItem=Nt={}));var kt;(function(we){function ke(j,_e){const Ue=j.items.map(([Ke,We])=>[Ke,Nt.to(Ke,We,_e)]);return new P.DataTransfer(Ue)}we.toDataTransfer=ke;async function me(j){const _e={items:[]},Ue=[];for(const[Ke,We]of j)Ue.push((async()=>{_e.items.push([Ke,await Nt.from(Ke,We)])})());return await Promise.all(Ue),_e}we.from=me})(kt||(e.DataTransfer=kt={}));var It;(function(we){function ke(j,_e){return{kind:"reply",agentId:j.participant??_e?.agentId??"",subCommand:j.command??_e?.command,message:j.prompt,title:j.label}}we.from=ke;function me(j){return{prompt:j.message,label:j.title,participant:j.agentId,command:j.subCommand}}we.to=me})(It||(e.ChatFollowup=It={}));var Wt;(function(we){function ke(j){switch(j){case u.ChatMessageRole.System:return P.LanguageModelChatMessageRole.System;case u.ChatMessageRole.User:return P.LanguageModelChatMessageRole.User;case u.ChatMessageRole.Assistant:return P.LanguageModelChatMessageRole.Assistant}}we.to=ke;function me(j){switch(j){case P.LanguageModelChatMessageRole.System:return u.ChatMessageRole.System;case P.LanguageModelChatMessageRole.User:return u.ChatMessageRole.User;case P.LanguageModelChatMessageRole.Assistant:return u.ChatMessageRole.Assistant}return u.ChatMessageRole.User}we.from=me})(Wt||(e.LanguageModelChatMessageRole=Wt={}));var Bt;(function(we){function ke(j){let _e="",Ue;j.content.type==="text"?_e=j.content.value:Ue=new P.LanguageModelFunctionResultPart(j.content.name,j.content.value,j.content.isError);const Ke=Wt.to(j.role),We=new P.LanguageModelChatMessage(Ke,_e,j.name);return Ue!==void 0&&(We.content2=Ue),We}we.to=ke;function me(j){const _e=Wt.from(j.role),Ue=j.name;let Ke;return j.content2 instanceof P.LanguageModelFunctionResultPart?Ke={type:"function_result",name:j.content2.name,value:j.content2.content,isError:j.content2.isError}:Ke={type:"text",value:j.content},{role:_e,name:Ue,content:Ke}}we.from=me})(Bt||(e.LanguageModelChatMessage=Bt={}));var Ht;(function(we){function ke(j){return{kind:"markdownContent",content:ve.from(j.value)}}we.from=ke;function me(j){return new P.ChatResponseMarkdownPart(ve.to(j.content))}we.to=me})(Ht||(e.ChatResponseMarkdownPart=Ht={}));var Vt;(function(we){function ke(j){return{kind:"markdownVuln",content:ve.from(j.value),vulnerabilities:j.vulnerabilities}}we.from=ke;function me(j){return new P.ChatResponseMarkdownWithVulnerabilitiesPart(ve.to(j.content),j.vulnerabilities)}we.to=me})(Vt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Vt={}));var Xt;(function(we){function ke(j){return{kind:"agentDetection",agentId:j.participant,command:j.command}}we.from=ke;function me(j){return new P.ChatResponseDetectedParticipantPart(j.agentId,j.command)}we.to=me})(Xt||(e.ChatResponseDetectedParticipantPart=Xt={}));var ei;(function(we){function ke(me){return{kind:"confirmation",title:me.title,message:me.message,data:me.data}}we.from=ke})(ei||(e.ChatResponseConfirmationPart=ei={}));var $t;(function(we){function ke(j){const{value:_e,baseUri:Ue}=j;function Ke(We,ot){return We.map(ft=>{const Mt=m.URI.joinPath(ot,ft.name);return{label:ft.name,uri:Mt,children:ft.children&&Ke(ft.children,Mt)}})}return{kind:"treeData",treeData:{label:(0,E.basename)(Ue),uri:Ue,children:Ke(_e,Ue)}}}we.from=ke;function me(j){const _e=(0,o.revive)(j.treeData);function Ue(ot){return ot.map(ft=>({name:ft.label,children:ft.children&&Ue(ft.children)}))}const Ke=_e.uri,We=_e.children?Ue(_e.children):[];return new P.ChatResponseFileTreePart(We,Ke)}we.to=me})($t||(e.ChatResponseFilesPart=$t={}));var Dt;(function(we){function ke(j){const _e=Ue=>m.URI.isUri(Ue);return{kind:"inlineReference",name:j.title,inlineReference:_e(j.value)?j.value:X.from(j.value)}}we.from=ke;function me(j){const _e=(0,o.revive)(j);return new P.ChatResponseAnchorPart(m.URI.isUri(_e.inlineReference)?_e.inlineReference:X.to(_e.inlineReference),j.name)}we.to=me})(Dt||(e.ChatResponseAnchorPart=Dt={}));var Ft;(function(we){function ke(j){return{kind:"progressMessage",content:ve.from(j.value)}}we.from=ke;function me(j){return new P.ChatResponseProgressPart(j.content.value)}we.to=me})(Ft||(e.ChatResponseProgressPart=Ft={}));var pt;(function(we){function ke(j){return{kind:"warning",content:ve.from(j.value)}}we.from=ke;function me(j){return new P.ChatResponseWarningPart(j.content.value)}we.to=me})(pt||(e.ChatResponseWarningPart=pt={}));var Yt;(function(we){function ke(me){return{kind:"progressTask",content:ve.from(me.value)}}we.from=ke})(Yt||(e.ChatTask=Yt={}));var Qt;(function(we){function ke(me){return{kind:"progressTaskResult",content:typeof me=="string"?ve.from(me):void 0}}we.from=ke})(Qt||(e.ChatTaskResult=Qt={}));var oi;(function(we){function ke(j,_e,Ue){return{kind:"command",command:_e.toInternal(j.value,Ue)??{command:j.value.command,title:j.value.title}}}we.from=ke;function me(j,_e){return new P.ChatResponseCommandButtonPart(_e.fromInternal(j.command)??{command:j.command.id,title:j.command.title})}we.to=me})(oi||(e.ChatResponseCommandButtonPart=oi={}));var ai;(function(we){function ke(j){return{kind:"textEdit",uri:j.uri,edits:j.edits.map(_e=>$.from(_e))}}we.from=ke;function me(j){return new P.ChatResponseTextEditPart(m.URI.revive(j.uri),j.edits.map(_e=>$.to(_e)))}we.to=me})(ai||(e.ChatResponseTextEditPart=ai={}));var ci;(function(we){function ke(j){const _e=a.ThemeIcon.isThemeIcon(j.iconPath)?j.iconPath:m.URI.isUri(j.iconPath)?{light:m.URI.revive(j.iconPath)}:j.iconPath&&"light"in j.iconPath&&"dark"in j.iconPath&&m.URI.isUri(j.iconPath.light)&&m.URI.isUri(j.iconPath.dark)?{light:m.URI.revive(j.iconPath.light),dark:m.URI.revive(j.iconPath.dark)}:void 0;return"variableName"in j.value?{kind:"reference",reference:{variableName:j.value.variableName,value:m.URI.isUri(j.value.value)||!j.value.value?j.value.value:X.from(j.value.value)},iconPath:_e}:{kind:"reference",reference:m.URI.isUri(j.value)?j.value:X.from(j.value),iconPath:_e}}we.from=ke;function me(j){const _e=(0,o.revive)(j),Ue=Ke=>m.URI.isUri(Ke)?Ke:X.to(Ke);return new P.ChatResponseReferencePart("variableName"in _e.reference?{variableName:_e.reference.variableName,value:_e.reference.value&&Ue(_e.reference.value)}:Ue(_e.reference))}we.to=me})(ci||(e.ChatResponseReferencePart=ci={}));var vi;(function(we){function ke(_e,Ue,Ke){return _e instanceof P.ChatResponseMarkdownPart?Ht.from(_e):_e instanceof P.ChatResponseAnchorPart?Dt.from(_e):_e instanceof P.ChatResponseReferencePart?ci.from(_e):_e instanceof P.ChatResponseProgressPart?Ft.from(_e):_e instanceof P.ChatResponseFileTreePart?$t.from(_e):_e instanceof P.ChatResponseCommandButtonPart?oi.from(_e,Ue,Ke):_e instanceof P.ChatResponseTextEditPart?ai.from(_e):_e instanceof P.ChatResponseMarkdownWithVulnerabilitiesPart?Vt.from(_e):_e instanceof P.ChatResponseDetectedParticipantPart?Xt.from(_e):_e instanceof P.ChatResponseWarningPart?pt.from(_e):{kind:"markdownContent",content:ve.from("")}}we.from=ke;function me(_e,Ue){switch(_e.kind){case"reference":return ci.to(_e);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return j(_e,Ue)}}we.to=me;function j(_e,Ue){switch(_e.kind){case"markdownContent":return Ht.to(_e);case"inlineReference":return Dt.to(_e);case"progressMessage":return;case"treeData":return $t.to(_e);case"command":return oi.to(_e,Ue)}}we.toContent=j})(vi||(e.ChatResponsePart=vi={}));var ii;(function(we){function ke(me){return{prompt:me.message,command:me.command,attempt:me.attempt??0,enableCommandDetection:me.enableCommandDetection??!0,references:me.variables.variables.map(qt.to),location:Ei.to(me.location),acceptedConfirmationData:me.acceptedConfirmationData,rejectedConfirmationData:me.rejectedConfirmationData}}we.to=ke})(ii||(e.ChatAgentRequest=ii={}));var Ei;(function(we){function ke(j){switch(j){case c.ChatAgentLocation.Notebook:return P.ChatLocation.Notebook;case c.ChatAgentLocation.Terminal:return P.ChatLocation.Terminal;case c.ChatAgentLocation.Panel:return P.ChatLocation.Panel;case c.ChatAgentLocation.Editor:return P.ChatLocation.Editor}}we.to=ke;function me(j){switch(j){case P.ChatLocation.Notebook:return c.ChatAgentLocation.Notebook;case P.ChatLocation.Terminal:return c.ChatAgentLocation.Terminal;case P.ChatLocation.Panel:return c.ChatAgentLocation.Panel;case P.ChatLocation.Editor:return c.ChatAgentLocation.Editor}}we.from=me})(Ei||(e.ChatLocation=Ei={}));var qt;(function(we){function ke(me){const j=me.value;if(!j)throw new Error("Invalid value reference");return{id:me.id,name:me.name,range:me.range&&[me.range.start,me.range.endExclusive],value:(0,m.isUriComponents)(j)?m.URI.revive(j):j&&typeof j=="object"&&"uri"in j&&"range"in j&&(0,m.isUriComponents)(j.uri)?X.to((0,o.revive)(j)):j,modelDescription:me.modelDescription}}we.to=ke})(qt||(e.ChatAgentValueReference=qt={}));var hi;(function(we){function ke(me,j,_e){return{id:me.id,label:me.label,fullName:me.fullName,icon:me.icon?.id,value:me.values[0].value,insertText:me.insertText,detail:me.detail,documentation:me.documentation,command:j.toInternal(me.command,_e)}}we.from=ke})(hi||(e.ChatAgentCompletionItem=hi={}));var fi;(function(we){function ke(me){return{errorDetails:me.errorDetails,metadata:me.metadata}}we.to=ke})(fi||(e.ChatAgentResult=fi={}));var gi;(function(we){function ke(me,j,_e){if(j.action.kind==="vote")return;const Ue=fi.to(me);if(j.action.kind==="command"){const Ke=j.action.commandButton.command;return{action:{kind:"command",commandButton:{command:_e.fromInternal(Ke)??{command:Ke.id,title:Ke.title}}},result:Ue}}else return j.action.kind==="followUp"?{action:{kind:"followUp",followup:It.to(j.action.followup)},result:Ue}:j.action.kind==="inlineChat"?{action:{kind:"editor",accepted:j.action.action==="accepted"},result:Ue}:{action:j.action,result:Ue}}we.to=ke})(gi||(e.ChatAgentUserActionEvent=gi={}));var Si;(function(we){function ke(me,j,_e){return"terminalCommand"in me?{terminalCommand:me.terminalCommand,shouldExecute:me.shouldExecute}:"uri"in me?{uri:me.uri}:j.toInternal(me,_e)}we.from=ke})(Si||(e.TerminalQuickFix=Si={}));var wi;(function(we){function ke(me){return{kind:ni.to(me.kind)}}we.to=ke})(wi||(e.PartialAcceptInfo=wi={}));var ni;(function(we){function ke(me){switch(me){case v.PartialAcceptTriggerKind.Word:return P.PartialAcceptTriggerKind.Word;case v.PartialAcceptTriggerKind.Line:return P.PartialAcceptTriggerKind.Line;case v.PartialAcceptTriggerKind.Suggest:return P.PartialAcceptTriggerKind.Suggest;default:return P.PartialAcceptTriggerKind.Unknown}}we.to=ke})(ni||(e.PartialAcceptTriggerKind=ni={}));var mi;(function(we){function ke(me,j){return{id:j,label:me.label,description:me.description,canEdit:me.canEdit,collapsibleState:me.collapsibleState||I.DebugTreeItemCollapsibleState.None,contextValue:me.contextValue}}we.from=ke})(mi||(e.DebugTreeItem=mi={}));var pi;(function(we){function ke(me){return{name:me.name,description:me.description,parametersSchema:me.parametersSchema}}we.to=ke})(pi||(e.LanguageModelToolDescription=pi={}))}),define(ye[320],Ie([1,0,49,148,76,147,103,154,4]),function(se,e,i,r,w,C,R,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0,i=Be(i),_=Be(_);const o=(g,v,t,l)=>{let n=v;return{enumerable:!0,configurable:!1,get(){return n},set(h){if(!t(n,h)){const s=n;n=h,g.listener?.(l(h,s))}}}},D=(g,v)=>g===v,y={range:(g,v)=>g===v?!0:!g||!v?!1:g.isEqual(v),label:D,description:D,sortText:D,busy:D,error:D,canResolveChildren:D,tags:(g,v)=>!(g.length!==v.length||g.some(t=>!v.find(l=>t.id===l.id)))},d=g=>v=>({op:C.TestItemEventOp.SetProp,update:g(v)}),E=(g,v)=>({range:(()=>{let t;const l=d(n=>({range:i.Range.lift(_.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return t},set(n){g.listener?.({op:C.TestItemEventOp.DocumentSynced}),y.range(t,n)||(t=n,g.listener?.(l(n)))}}})(),label:o(g,v,y.label,d(t=>({label:t}))),description:o(g,void 0,y.description,d(t=>({description:t}))),sortText:o(g,void 0,y.sortText,d(t=>({sortText:t}))),canResolveChildren:o(g,!1,y.canResolveChildren,t=>({op:C.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:o(g,!1,y.busy,d(t=>({busy:t}))),error:o(g,void 0,y.error,d(t=>({error:_.MarkdownString.fromStrict(t)||null}))),tags:o(g,[],y.tags,(t,l)=>({op:C.TestItemEventOp.SetTags,new:t.map(_.TestTag.from),old:l.map(_.TestTag.from)}))}),a=g=>{const v=w.TestId.fromString(g.extId),t=new m(v.controllerId,v.localId,g.label,b.URI.revive(g.uri)||void 0);return t.range=_.Range.to(g.range||void 0),t.description=g.description||void 0,t.sortText=g.sortText||void 0,t.tags=g.tags.map(l=>_.TestTag.to({id:(0,R.denamespaceTestTag)(l).tagId})),t},f=g=>{let v;for(const t of g.tests){const l=a(t.item);(0,r.getPrivateApiFor)(l).parent=v,v=l}return v};e.toItemFromContext=f;class m{constructor(v,t,l,n){if(t.includes(w.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const h=(0,r.createPrivateApiFor)(this,v);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return h.parent instanceof p?void 0:h.parent}},children:{value:(0,C.createTestItemChildren)(h,r.getPrivateApiFor,m),enumerable:!0,writable:!1},...E(h,l)})}}e.TestItemImpl=m;class p extends m{constructor(v,t){super(v,v,t,void 0),this._isRoot=!0}}e.TestItemRootImpl=p;class S extends C.TestItemCollection{constructor(v,t,l){super({controllerId:v,getDocumentVersion:n=>n&&l.getDocument(n)?.version,getApiFor:r.getPrivateApiFor,getChildren:n=>n.children,root:new p(v,t),toITestItem:_.TestItem.from})}}e.ExtHostTestItemCollection=S}),define(ye[321],Ie([1,0,11,153,154,21,318,18,12,50,49,85,4,2,5,298,320,15,151,45,48,41,312,23]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a,f,m,p,S,g,v,t,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0,r=Be(r),w=Be(w);let h=class{#e;#t;#i;constructor(A,O,k){this._commands=new Map,this._apiCommands=new Map,this.#e=A.getProxy(R.MainContext.MainThreadCommands),this._logService=O,this.#i=k,this.#t=A.getProxy(R.MainContext.MainThreadTelemetry),this.converter=new s(this,P=>{const B=this._apiCommands.get(P);return B?.result===u.Void?B:void 0},O),this._argumentProcessors=[{processArgument(P){return(0,o.revive)(P)}},{processArgument(P){return(0,C.cloneAndChange)(P,function(B){if(D.Range.isIRange(B))return w.Range.to(B);if(y.Position.isIPosition(B))return w.Position.to(B);if(D.Range.isIRange(B.range)&&d.URI.isUri(B.uri))return w.location.to(B);if(B instanceof p.VSBuffer)return B.buffer.buffer;if(!Array.isArray(B))return B})}}]}registerArgumentProcessor(A){this._argumentProcessors.push(A)}registerApiCommand(A){const O=this.registerCommand(!1,A.id,async(...k)=>{const P=A.args.map((Y,X)=>{if(!Y.validate(k[X]))throw new Error(`Invalid argument '${Y.name}' when running '${A.id}', received: ${typeof k[X]=="object"?JSON.stringify(k[X],null,"	"):k[X]} `);return Y.convert(k[X])}),B=await this.executeCommand(A.internalId,...P);return A.result.convert(B,k,this.converter)},void 0,{description:A.description,args:A.args,returns:A.result.description});return this._apiCommands.set(A.id,A),new r.Disposable(()=>{O.dispose(),this._apiCommands.delete(A.id)})}registerCommand(A,O,k,P,B,Y){if(this._logService.trace("ExtHostCommands#registerCommand",O),!O.trim().length)throw new Error("invalid id");if(this._commands.has(O))throw new Error(`command '${O}' already exists`);return this._commands.set(O,{callback:k,thisArg:P,metadata:B,extension:Y}),A&&this.#e.$registerCommand(O),new r.Disposable(()=>{this._commands.delete(O)&&A&&this.#e.$unregisterCommand(O)})}executeCommand(A,...O){return this._logService.trace("ExtHostCommands#executeCommand",A),this._doExecuteCommand(A,O,!0)}async _doExecuteCommand(A,O,k){if(this._commands.has(A))return this.#e.$fireCommandActivationEvent(A),this._executeContributedCommand(A,O,!1);{let P=!1;const B=(0,C.cloneAndChange)(O,function(Y){if(Y instanceof r.Position)return w.Position.from(Y);if(Y instanceof r.Range)return w.Range.from(Y);if(Y instanceof r.Location)return w.location.from(Y);if(r.NotebookRange.isNotebookRange(Y))return w.NotebookRange.from(Y);if(Y instanceof ArrayBuffer)return P=!0,p.VSBuffer.wrap(new Uint8Array(Y));if(Y instanceof Uint8Array)return P=!0,p.VSBuffer.wrap(Y);if(Y instanceof p.VSBuffer)return P=!0,Y;if(!Array.isArray(Y))return Y});try{const Y=await this.#e.$executeCommand(A,P?new S.SerializableObjectWithBuffers(B):B,k);return(0,o.revive)(Y)}catch(Y){if(Y instanceof Error&&Y.message==="$executeCommand:retry")return this._doExecuteCommand(A,O,!1);throw Y}}}async _executeContributedCommand(A,O,k){const P=this._commands.get(A);if(!P)throw new Error("Unknown command");const{callback:B,thisArg:Y,metadata:X}=P;if(X?.args)for(let te=0;te<X.args.length;te++)try{(0,i.validateConstraint)(O[te],X.args[te].constraint)}catch{throw new Error(`Running the contributed command: '${A}' failed. Illegal argument '${X.args[te].name}' - ${X.args[te].description}`)}const re=v.StopWatch.create();try{return await B.apply(Y,O)}catch(te){if(A===this.converter.delegatingCommandId){const Z=this.converter.getActualCommand(...O);Z&&(A=Z.command)}if(this._logService.error(te,A,P.extension?.identifier),!k)throw te;if(P.extension?.identifier){const Z=this.#i.onExtensionError(P.extension.identifier,te);this._logService.trace("forwarded error to extension?",Z,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,g.toErrorMessage)(te)),this.id=A,this.source=P.extension?.displayName??P.extension?.name}}}finally{this._reportTelemetry(P,A,re.elapsed())}}_reportTelemetry(A,O,k){A.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:A.extension.identifier.value,id:new t.TelemetryTrustedValue(O),duration:k})}$executeContributedCommand(A,...O){this._logService.trace("ExtHostCommands#$executeContributedCommand",A);const k=this._commands.get(A);return k?(O=O.map(P=>this._argumentProcessors.reduce((B,Y)=>Y.processArgument(B,k.extension?.identifier),P)),this._executeContributedCommand(A,O,!0)):Promise.reject(new Error(`Contributed command '${A}' does not exist.`))}getCommands(A=!1){return this._logService.trace("ExtHostCommands#getCommands",A),this.#e.$getCommands().then(O=>(A&&(O=O.filter(k=>k[0]!=="_")),O))}$getContributedCommandMetadata(){const A=Object.create(null);for(const[O,k]of this._commands){const{metadata:P}=k;P&&(A[O]=P)}return Promise.resolve(A)}};e.ExtHostCommands=h,e.ExtHostCommands=h=ze([Me(0,f.IExtHostRpcService),Me(1,b.ILogService),Me(2,l.IExtHostTelemetry)],h),e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class s{constructor(A,O,k){this._commands=A,this._lookupApiCommand=O,this._logService=k,this.delegatingCommandId=`__vsc${(0,n.generateUuid)()}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(A,O){if(!A)return;const k={$ident:void 0,id:A.command,title:A.title,tooltip:A.tooltip};if(!A.command)return k;const P=this._lookupApiCommand(A.command);if(P)k.id=P.internalId,k.arguments=P.args.map((B,Y)=>B.convert(A.arguments&&A.arguments[Y]));else if((0,_.isNonEmptyArray)(A.arguments)){const B=`${A.command} /${++this._cachIdPool}`;this._cache.set(B,A),O.add((0,E.toDisposable)(()=>{this._cache.delete(B),this._logService.trace("CommandsConverter#DISPOSE",B)})),k.$ident=B,k.id=this.delegatingCommandId,k.arguments=[B],this._logService.trace("CommandsConverter#CREATE",A.command,B)}return k}fromInternal(A){return typeof A.$ident=="string"?this._cache.get(A.$ident):{command:A.id,title:A.title,arguments:A.arguments}}getActualCommand(...A){return this._cache.get(A[0])}_executeConvertedCommand(...A){const O=this.getActualCommand(...A);return this._logService.trace("CommandsConverter#EXECUTE",A[0],O?O.command:"MISSING"),O?this._commands.executeCommand(O.command,...O.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${A[0]}`)}}e.CommandsConverter=s;class c{static{this.Uri=new c("uri","Uri of a text document",A=>d.URI.isUri(A),A=>A)}static{this.Position=new c("position","A position in a text document",A=>r.Position.isPosition(A),w.Position.from)}static{this.Range=new c("range","A range in a text document",A=>r.Range.isRange(A),w.Range.from)}static{this.Selection=new c("selection","A selection in a text document",A=>r.Selection.isSelection(A),w.Selection.from)}static{this.Number=new c("number","",A=>typeof A=="number",A=>A)}static{this.String=new c("string","",A=>typeof A=="string",A=>A)}static{this.StringArray=c.Arr(c.String)}static Arr(A){return new c(`${A.name}_array`,`Array of ${A.name}, ${A.description}`,O=>Array.isArray(O)&&O.every(k=>A.validate(k)),O=>O.map(k=>A.convert(k)))}static{this.CallHierarchyItem=new c("item","A call hierarchy item",A=>A instanceof r.CallHierarchyItem,w.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new c("item","A type hierarchy item",A=>A instanceof r.TypeHierarchyItem,w.TypeHierarchyItem.from)}static{this.TestItem=new c("testItem","A VSCodium TestItem",A=>A instanceof m.TestItemImpl,w.TestItem.from)}constructor(A,O,k,P){this.name=A,this.description=O,this.validate=k,this.convert=P}optional(){return new c(this.name,`(optional) ${this.description}`,A=>A==null||this.validate(A),A=>A===void 0?void 0:A===null?null:this.convert(A))}with(A,O){return new c(A??this.name,O??this.description,this.validate,this.convert)}}e.ApiCommandArgument=c;class u{static{this.Void=new u("no result",A=>A)}constructor(A,O){this.description=A,this.convert=O}}e.ApiCommandResult=u;class I{constructor(A,O,k,P,B){this.id=A,this.internalId=O,this.description=k,this.args=P,this.result=B}}e.ApiCommand=I}),define(ye[322],Ie([1,0,10,2,13,3,251]),function(se,e,i,r,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class _ extends R.DiskFileSystemProviderClient{static register(o,D,y){const d=o.getConnection();if(!d)return r.Disposable.None;const E=new r.DisposableStore,a=(async()=>{try{const f=await o.getRawEnvironment();f?D.registerProvider(w.Schemas.vscodeRemote,E.add(new _(f,d))):y.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(f){y.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,i.getErrorMessage)(f))}})();return E.add(D.onWillActivateFileSystemProvider(f=>{f.scheme===w.Schemas.vscodeRemote&&f.join(a)})),E}constructor(o,D){super(D.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:o.os===C.OperatingSystem.Linux})}}e.RemoteFileSystemProviderClient=_}),define(ye[77],Ie([1,0,96,84,32,323,15,10,6,2,9,3,23,51,61]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0,e.createRandomIPCHandle=s,e.createStaticIPCHandle=c,e.serve=T,e.connect=A;const f=3e4;class m{traceSocketEvent(k,P){a.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,P)}constructor(k,P=""){this._canWrite=!0,this.debugLabel=P,this.socket=k,this.traceSocketEvent(a.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this._errorListener=Y=>{if(this.traceSocketEvent(a.SocketDiagnosticsEventType.Error,{code:Y?.code,message:Y?.message}),Y){if(Y.code==="EPIPE")return;(0,_.onUnexpectedError)(Y)}},this.socket.on("error",this._errorListener);let B;this._closeListener=Y=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.Close,{hadError:Y}),this._canWrite=!1,B&&clearTimeout(B)},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeEndReceived),this._canWrite=!1,B=setTimeout(()=>k.destroy(),f)},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(k){const P=B=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.Read,B),k(R.VSBuffer.wrap(B))};return this.socket.on("data",P),{dispose:()=>this.socket.off("data",P)}}onClose(k){const P=B=>{k({type:a.SocketCloseEventType.NodeSocketCloseEvent,hadError:B,error:void 0})};return this.socket.on("close",P),{dispose:()=>this.socket.off("close",P)}}onEnd(k){const P=()=>{k()};return this.socket.on("end",P),{dispose:()=>this.socket.off("end",P)}}write(k){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent(a.SocketDiagnosticsEventType.Write,k),this.socket.write(k.buffer,P=>{if(P){if(P.code==="EPIPE")return;(0,_.onUnexpectedError)(P)}})}catch(P){if(P.code==="EPIPE")return;(0,_.onUnexpectedError)(P)}}end(){this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((k,P)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainEnd),k();return}const B=()=>{this.socket.off("close",B),this.socket.off("end",B),this.socket.off("error",B),this.socket.off("timeout",B),this.socket.off("drain",B),this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainEnd),k()};this.socket.on("close",B),this.socket.on("end",B),this.socket.on("error",B),this.socket.on("timeout",B),this.socket.on("drain",B)})}}e.NodeSocket=m;var p;(function(O){O[O.MinHeaderByteSize=2]="MinHeaderByteSize",O[O.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(p||(p={}));var S;(function(O){O[O.PeekHeader=1]="PeekHeader",O[O.ReadHeader=2]="ReadHeader",O[O.ReadBody=3]="ReadBody",O[O.Fin=4]="Fin"})(S||(S={}));class g extends o.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(k,P){this.socket.traceSocketEvent(k,P)}constructor(k,P,B,Y){super(),this._onData=this._register(new b.Emitter),this._onClose=this._register(new b.Emitter),this._isEnded=!1,this._state={state:S.PeekHeader,readLen:p.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=k,this.traceSocketEvent(a.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:P,inflateBytesLength:B?.byteLength||0,recordInflateBytes:Y}),this._flowManager=this._register(new v(this,P,B,Y,this._onData,(X,re)=>this._write(X,re))),this._register(this._flowManager.onError(X=>{console.error(X),(0,_.onUnexpectedError)(X),this._onClose.fire({type:a.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:X})})),this._incomingData=new a.ChunkStream,this._register(this.socket.onData(X=>this._acceptChunk(X))),this._register(this.socket.onClose(async X=>{this._flowManager.isProcessingReadQueue()&&await b.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(X)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this._onData.event(k)}onClose(k){return this._onClose.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let P=0;for(;P<k.byteLength;)this._flowManager.writeMessage(k.slice(P,Math.min(P+p.MaxWebSocketMessageLength,k.byteLength)),{compressed:!0,opcode:2}),P+=p.MaxWebSocketMessageLength}_write(k,{compressed:P,opcode:B}){if(this._isEnded)return;this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,k);let Y=p.MinHeaderByteSize;k.byteLength<126?Y+=0:k.byteLength<2**16?Y+=2:Y+=8;const X=R.VSBuffer.alloc(Y),re=P?64:0,te=B&15;if(X.writeUInt8(128|re|te,0),k.byteLength<126)X.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){X.writeUInt8(126,1);let Z=1;X.writeUInt8(k.byteLength>>>8&255,++Z),X.writeUInt8(k.byteLength>>>0&255,++Z)}else{X.writeUInt8(127,1);let Z=1;X.writeUInt8(0,++Z),X.writeUInt8(0,++Z),X.writeUInt8(0,++Z),X.writeUInt8(0,++Z),X.writeUInt8(k.byteLength>>>24&255,++Z),X.writeUInt8(k.byteLength>>>16&255,++Z),X.writeUInt8(k.byteLength>>>8&255,++Z),X.writeUInt8(k.byteLength>>>0&255,++Z)}this.socket.write(R.VSBuffer.concat([X,k]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(k){if(k.byteLength!==0){for(this._incomingData.acceptChunk(k);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===S.PeekHeader){const P=this._incomingData.peek(this._state.readLen),B=P.readUInt8(0),Y=(B&128)>>>7,X=(B&64)>>>6,re=B&15,te=P.readUInt8(1),Z=(te&128)>>>7,fe=te&127;this._state.state=S.ReadHeader,this._state.readLen=p.MinHeaderByteSize+(Z?4:0)+(fe===126?2:0)+(fe===127?8:0),this._state.fin=Y,this._state.firstFrameOfMessage&&(this._state.compressed=!!X),this._state.firstFrameOfMessage=!!Y,this._state.mask=0,this._state.opcode=re,this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===S.ReadHeader){const P=this._incomingData.read(this._state.readLen),B=P.readUInt8(1),Y=(B&128)>>>7;let X=B&127,re=1;X===126?X=P.readUInt8(++re)*2**8+P.readUInt8(++re):X===127&&(X=P.readUInt8(++re)*0+P.readUInt8(++re)*0+P.readUInt8(++re)*0+P.readUInt8(++re)*0+P.readUInt8(++re)*2**24+P.readUInt8(++re)*2**16+P.readUInt8(++re)*2**8+P.readUInt8(++re));let te=0;Y&&(te=P.readUInt8(++re)*2**24+P.readUInt8(++re)*2**16+P.readUInt8(++re)*2**8+P.readUInt8(++re)),this._state.state=S.ReadBody,this._state.readLen=X,this._state.mask=te,this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===S.ReadBody){const P=this._incomingData.read(this._state.readLen);this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,P),n(P,this._state.mask),this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,P),this._state.state=S.PeekHeader,this._state.readLen=p.MinHeaderByteSize,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(P,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(P,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this._flowManager.isProcessingWriteQueue()&&await b.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.WebSocketNodeSocket=g;class v extends o.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:R.VSBuffer.alloc(0)}constructor(k,P,B,Y,X,re){super(),this._tracer=k,this._onData=X,this._writeFn=re,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new b.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new b.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,P?(this._zlibInflateStream=this._register(new t(this._tracer,Y,B,{windowBits:15})),this._zlibDeflateStream=this._register(new l(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(te=>this._onError.fire(te))),this._register(this._zlibDeflateStream.onError(te=>this._onError.fire(te)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(k,P){this._writeQueue.push({data:k,options:P}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:k,options:P}=this._writeQueue.shift();if(this._zlibDeflateStream&&P.compressed){const B=await this._deflateMessage(this._zlibDeflateStream,k);this._writeFn(B,P)}else this._writeFn(k,{...P,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(k,P){return new Promise((B,Y)=>{k.write(P),k.flush(X=>B(X))})}acceptFrame(k,P,B){this._readQueue.push({data:k,isCompressed:P,isLastFrameOfMessage:B}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const k=this._readQueue.shift();if(this._zlibInflateStream&&k.isCompressed){const P=await this._inflateFrame(this._zlibInflateStream,k.data,k.isLastFrameOfMessage);this._onData.fire(P)}else this._onData.fire(k.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(k,P,B){return new Promise((Y,X)=>{k.write(P),B&&k.write(R.VSBuffer.fromByteArray([0,0,255,255])),k.flush(re=>Y(re))})}}class t extends o.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?R.VSBuffer.concat(this._recordedInflateBytes):R.VSBuffer.alloc(0)}constructor(k,P,B,Y){super(),this._tracer=k,this._recordInflateBytes=P,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,C.createInflateRaw)(Y),this._zlibInflate.on("error",X=>{this._tracer.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateError,{message:X?.message,code:X?.code}),this._onError.fire(X)}),this._zlibInflate.on("data",X=>{this._tracer.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateData,X),this._pendingInflateData.push(R.VSBuffer.wrap(X))}),B&&(this._tracer.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateInitialWrite,B.buffer),this._zlibInflate.write(B.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this._pendingInflateData.length=0}))}write(k){this._recordInflateBytes&&this._recordedInflateBytes.push(k.clone()),this._tracer.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateWrite,k),this._zlibInflate.write(k.buffer)}flush(k){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateFlushFired);const P=R.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,k(P)})}}class l extends o.Disposable{constructor(k,P){super(),this._tracer=k,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,C.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",B=>{this._tracer.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateError,{message:B?.message,code:B?.code}),this._onError.fire(B)}),this._zlibDeflate.on("data",B=>{this._tracer.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateData,B),this._pendingDeflateData.push(R.VSBuffer.wrap(B))})}write(k){this._tracer.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateWrite,k.buffer),this._zlibDeflate.write(k.buffer)}flush(k){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateFlushFired);let P=R.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,P=P.slice(0,P.byteLength-4),k(P)})}}function n(O,k){if(k===0)return;const P=O.byteLength>>>2;for(let Z=0;Z<P;Z++){const fe=O.readUInt32BE(Z*4);O.writeUInt32BE(fe^k,Z*4)}const B=P*4,Y=O.byteLength-B,X=k>>>24&255,re=k>>>16&255,te=k>>>8&255;Y>=1&&O.writeUInt8(O.readUInt8(B)^X,B),Y>=2&&O.writeUInt8(O.readUInt8(B+1)^re,B+1),Y>=3&&O.writeUInt8(O.readUInt8(B+2)^te,B+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const h={[y.Platform.Linux]:107,[y.Platform.Mac]:103};function s(){const O=(0,d.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${O}-sock`;const k=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,w.tmpdir)(),P=(0,D.join)(k,`vscode-ipc-${O}.sock`);return u(P),P}function c(O,k,P){const Y=(0,i.createHash)("sha256").update(O).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${Y}-${P}-${k}-sock`;const X=P.substr(0,4),re=k.substr(0,6);let te;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?te=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${Y}-${X}-${re}.sock`):te=(0,D.join)(O,`${X}-${re}.sock`),u(te),te}function u(O){const k=h[y.platform];typeof k=="number"&&O.length>=k&&console.warn(`WARNING: IPC handle "${O}" is longer than ${k} chars, try a shorter --user-data-dir`)}class I extends E.IPCServer{static toClientConnectionEvent(k){const P=b.Event.fromNodeEventEmitter(k,"connection");return b.Event.map(P,B=>({protocol:new a.Protocol(new m(B,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(B,"close"))}))}constructor(k){super(I.toClientConnectionEvent(k)),this.server=k}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=I;function T(O){return new Promise((k,P)=>{const B=(0,r.createServer)();B.on("error",P),B.listen(O,()=>{B.removeListener("error",P),k(new I(B))})})}function A(O,k){return new Promise((P,B)=>{const Y=(0,r.createConnection)(O,()=>{Y.removeListener("error",B),P(a.Client.fromSocket(new m(Y,`ipc-client${k}`),k))});Y.once("error",B)})}}),define(ye[155],Ie([1,0,93,14,15,10,11,27,28,94,12,47,270,323]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0,e.nodeRequest=m;let a=class extends y.AbstractRequestService{constructor(S,g,v,t){super(t),this.configurationService=S,this.environmentService=g,this.logService=v,this.configure(),this._register(S.onDidChangeConfiguration(l=>{l.affectsConfiguration("http")&&this.configure()}))}configure(){const S=this.configurationService.getValue("http");this.proxyUrl=S?.proxy,this.strictSSL=!!S?.proxyStrictSSL,this.authorization=S?.proxyAuthorization}async request(S,g){const{proxyUrl:v,strictSSL:t}=this;let l;try{l=await(0,o.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(s){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,C.getErrorMessage)(s)))}const n={...process.env,...l},h=S.agent?S.agent:await(0,d.getProxyAgent)(S.url||"",n,{proxyUrl:v,strictSSL:t});return S.agent=h,S.strictSSL=t,this.authorization&&(S.headers={...S.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(S.isChromiumNetwork?"electron":"node",S,()=>m(S,g))}async resolveProxy(S){}async loadCertificates(){return(await new Promise((g,v)=>{se(["@vscode/proxy-agent"],g,v)}).then(Be)).loadSystemCertificates({log:this.logService})}};e.RequestService=a,e.RequestService=a=ze([Me(0,_.IConfigurationService),Me(1,b.INativeEnvironmentService),Me(2,D.ILogService),Me(3,D.ILoggerService)],a);async function f(p){return((0,i.parse)(p.url).protocol==="https:"?await new Promise((v,t)=>{se(["https"],v,t)}).then(Be):await new Promise((v,t)=>{se(["http"],v,t)}).then(Be)).request}async function m(p,S){return r.Promises.withAsyncBody(async(g,v)=>{const t=(0,i.parse)(p.url),l=p.getRawRequest?p.getRawRequest(p):await f(p),n={hostname:t.hostname,port:t.port?parseInt(t.port):t.protocol==="https:"?443:80,protocol:t.protocol,path:t.path,method:p.type||"GET",headers:p.headers,agent:p.agent,rejectUnauthorized:(0,R.isBoolean)(p.strictSSL)?p.strictSSL:!0};p.user&&p.password&&(n.auth=p.user+":"+p.password);const h=l(n,s=>{const c=(0,R.isNumber)(p.followRedirects)?p.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&c>0&&s.headers.location)m({...p,url:s.headers.location,followRedirects:c-1},S).then(g,v);else{let u=s;!p.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(u=s.pipe((0,E.createGunzip)())),g({res:s,stream:(0,w.streamToBufferReadableStream)(u)})}});h.on("error",v),p.timeout&&h.setTimeout(p.timeout),p.isChromiumNetwork&&h.removeHeader("Content-Length"),p.data&&typeof p.data=="string"&&h.write(p.data),h.end(),S.onCancellationRequested(()=>{h.abort(),v(new C.CancellationError)})})}}),define(ye[156],Ie([1,0,60,84,15,6,2,13,9,3,69,77,27,12,94,143,144,55,310]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a,f,m,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=void 0,e.buildUserEnvironment=g,i=Be(i),r=Be(r);async function g(s={},c,u,I,T,A){const O=await(0,m.getNLSConfiguration)(u,I.userDataPath);let k={};if(c)try{k=await(0,a.getResolvedShellEnv)(A,T,I.args,process.env)}catch(te){T.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",te)}const B={...process.env,...k,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(O,void 0,0),...s},Y=I.isBuilt?(0,b.join)(I.appRoot,"bin"):(0,b.join)(I.appRoot,"resources","server","bin-dev"),X=(0,b.join)(Y,"remote-cli");let re=l(B,"PATH");return re?re=X+b.delimiter+re:re=X,n(B,"PATH",re),I.args["without-browser-env-var"]||(B.BROWSER=(0,b.join)(Y,"helpers",o.isWindows?"browser.cmd":"browser.sh")),h(B),B}class v{constructor(c,u){this.socket=c,this.initialDataChunk=u}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let c,u,I;return this.socket instanceof y.NodeSocket?(c=!0,u=!1,I=w.VSBuffer.alloc(0)):(c=!1,u=this.socket.permessageDeflate,I=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:c,permessageDeflate:u,inflateBytes:I.buffer.toString("base64")}}}let t=class extends R.Disposable{constructor(c,u,I,T,A,O,k,P){super(),this._reconnectionToken=c,this._environmentService=A,this._logService=O,this._extensionHostStatusService=k,this._configurationService=P,this._onClose=new C.Emitter,this.onClose=this._onClose.event,this._canSendSocket=!o.isWindows||!this._environmentService.args["socket-path"],this._disposed=!1,this._remoteAddress=u,this._extensionHostProcess=null,this._connectionData=new v(I,T),this._log("New connection established.")}dispose(){this._cleanResources(),super.dispose()}get _logPrefix(){return`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] `}_log(c){this._logService.info(`${this._logPrefix}${c}`)}_logError(c){this._logService.error(`${this._logPrefix}${c}`)}async _pipeSockets(c,u){const I=new R.DisposableStore;I.add(u.socket),I.add((0,R.toDisposable)(()=>{c.destroy()}));const T=()=>{I.dispose()};I.add(u.socket.onEnd(T)),I.add(u.socket.onClose(T)),I.add(C.Event.fromNodeEventEmitter(c,"end")(T)),I.add(C.Event.fromNodeEventEmitter(c,"close")(T)),I.add(C.Event.fromNodeEventEmitter(c,"error")(T)),I.add(u.socket.onData(A=>c.write(A.buffer))),I.add(C.Event.fromNodeEventEmitter(c,"data")(A=>{u.socket.write(w.VSBuffer.wrap(A))})),u.initialDataChunk.byteLength>0&&c.write(u.initialDataChunk.buffer)}async _sendSocketToExtensionHost(c,u){await u.socketDrain();const I=u.toIExtHostSocketMessage();let T;u.socket instanceof y.NodeSocket?T=u.socket.socket:T=u.socket.socket.socket,c.send(I,T)}shortenReconnectionGraceTimeIfNecessary(){if(!this._extensionHostProcess)return;const c={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(c)}acceptReconnection(c,u,I){this._remoteAddress=c,this._log("The client has reconnected.");const T=new v(u,I);if(!this._extensionHostProcess){this._connectionData=T;return}this._sendSocketToExtensionHost(this._extensionHostProcess,T)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(c){try{let u=process.execArgv?process.execArgv.filter(X=>!/^--inspect(-brk)?=/.test(X)):[];c.port&&!process.pkg&&(u=[`--inspect${c.break?"-brk":""}=${c.port}`]);const I=await g(c.env,!0,c.language,this._environmentService,this._logService,this._configurationService);(0,D.removeDangerousEnvVariables)(I);let T;if(this._canSendSocket)(0,S.writeExtHostConnection)(new S.SocketExtHostConnection,I),T=null;else{const{namedPipeServer:X,pipeName:re}=await this._listenOnPipe();(0,S.writeExtHostConnection)(new S.IPCExtHostConnection(re),I),T=X}const A={env:I,execArgv:u,silent:!0};A.execArgv.unshift("--dns-result-order=ipv4first");const O=["--type=extensionHost","--transformURIs"],k=this._environmentService.args["use-host-proxy"];O.push(`--useHostProxy=${k?"true":"false"}`),this._extensionHostProcess=i.fork(_.FileAccess.asFileUri("bootstrap-fork").fsPath,O,A);const P=this._extensionHostProcess.pid;this._log(`<${P}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const B=C.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),Y=C.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");if(this._register(B(X=>this._log(`<${P}> ${X}`))),this._register(Y(X=>this._log(`<${P}><stderr> ${X}`))),this._extensionHostProcess.on("error",X=>{this._logError(`<${P}> Extension Host Process had an error`),this._logService.error(X),this._cleanResources()}),this._extensionHostProcess.on("exit",(X,re)=>{this._extensionHostStatusService.setExitInfo(this._reconnectionToken,{code:X,signal:re}),this._log(`<${P}> Extension Host Process exited with code: ${X}, signal: ${re}.`),this._cleanResources()}),T)T.on("connection",X=>{T.close(),this._pipeSockets(X,this._connectionData)});else{const X=re=>{re.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",X),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",X)}}catch(u){console.error("ExtensionHostConnection errored"),u&&console.error(u)}}_listenOnPipe(){return new Promise((c,u)=>{const I=(0,y.createRandomIPCHandle)(),T=r.createServer();T.on("error",u),T.listen(I,()=>{T?.removeListener("error",u),c({pipeName:I,namedPipeServer:T})})})}};e.ExtensionHostConnection=t,e.ExtensionHostConnection=t=ze([Me(4,p.IServerEnvironmentService),Me(5,E.ILogService),Me(6,f.IExtensionHostStatusService),Me(7,d.IConfigurationService)],t);function l(s,c){const u=Object.keys(s).filter(T=>T.toLowerCase()===c.toLowerCase()),I=u.length>0?u[0]:c;return s[I]}function n(s,c,u){const I=Object.keys(s).filter(A=>A.toLowerCase()===c.toLowerCase()),T=I.length>0?I[0]:c;s[T]=u}function h(s){for(const c of Object.keys(s))s[c]===null&&delete s[c]}});var gt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ye[324],Ie([1,0,89,12,71,129,27,47,155,41,24,30,141,139,95,122,62,2,123,72,13,16,29,55,132,92,133,10,4,9,33,268,88,36,137,70,3,64,145,34,54,73,142,140,125,126,229,325]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a,f,m,p,S,g,v,t,l,n,h,s,c,u,I,T,A,O,k,P,B,Y,X,re,te,Z,fe,K,ae,x,z,ne,le,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=J,m=gt(m);class H extends p.Disposable{constructor(L,Q){super(),this.args=L,this.remoteDataFolder=Q,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const L=await this.initServices();await L.invokeFunction(async Q=>{const $=Q.get(R.IConfigurationService),U=Q.get(r.ILogService);X.isWindows&&($.getValue("security.restrictUNCAccess")===!1?(0,ve.disableUNCAccessRestrictions)():(0,ve.addUNCHostToAllowlist)($.getValue("security.allowedUNCHosts")));try{await this.doRun(L.createInstance(h.ExtensionManagementCLI,new r.ConsoleLogger(U.getLevel(),!1)))}catch(q){throw U.error(q),console.error((0,u.getErrorMessage)(q)),q}})}async initServices(){const L=new i.ServiceCollection,Q={_serviceBrand:void 0,...m.default};L.set(l.IProductService,Q);const $=new n.ServerEnvironmentService(this.args,Q);L.set(n.IServerEnvironmentService,$);const U=new ne.LoggerService((0,r.getLogLevel)($),$.logsHome);L.set(r.ILoggerService,U);const q=new z.LogService(this._register(U.createLogger("remoteCLI",{name:(0,le.localize)(0,null)})));L.set(r.ILogService,q),q.trace(`Remote configuration data at ${this.remoteDataFolder}`),q.trace("process arguments:",this.args);const G=this._register(new S.FileService(q));L.set(t.IFileService,G),G.registerProvider(v.Schemas.file,this._register(new g.DiskFileSystemProvider(q)));const F=new B.UriIdentityService(G);L.set(P.IUriIdentityService,F);const V=this._register(new ae.ServerUserDataProfilesService(F,$,G,q));L.set(Z.IUserDataProfilesService,V);const oe=this._register(new C.ConfigurationService(V.defaultProfile.settingsResource,G,new K.NullPolicyService,q));return L.set(R.IConfigurationService,oe),await Promise.all([oe.initialize(),V.init()]),L.set(_.IRequestService,new w.SyncDescriptor(b.RequestService)),L.set(k.IDownloadService,new w.SyncDescriptor(O.DownloadService)),L.set(D.ITelemetryService,o.NullTelemetryService),L.set(y.IExtensionGalleryService,new w.SyncDescriptor(d.ExtensionGalleryServiceWithNoStorageService)),L.set(fe.IExtensionsProfileScannerService,new w.SyncDescriptor(x.ExtensionsProfileScannerService)),L.set(re.IExtensionsScannerService,new w.SyncDescriptor(te.ExtensionsScannerService)),L.set(a.IExtensionSignatureVerificationService,new w.SyncDescriptor(a.ExtensionSignatureVerificationService)),L.set(E.INativeServerExtensionManagementService,new w.SyncDescriptor(E.ExtensionManagementService)),L.set(s.ILanguagePackService,new w.SyncDescriptor(c.NativeLanguagePackService)),new f.InstantiationService(L)}async doRun(L){if(this.args["list-extensions"])return L.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"]){const Q={isMachineScoped:!!this.args["do-not-sync"],installPreReleaseVersion:!!this.args["pre-release"]};return L.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.asExtensionIdOrVSIX(this.args["install-builtin-extension"]||[]),Q,!!this.args.force)}else{if(this.args["uninstall-extension"])return L.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["update-extensions"])return L.updateExtensions();if(this.args["locate-extension"])return L.locateExtension(this.args["locate-extension"])}}asExtensionIdOrVSIX(L){return L.map(Q=>/\.vsix$/i.test(Q)?I.URI.file((0,T.isAbsolute)(Q)?Q:(0,T.join)((0,A.cwd)(),Q)):Q)}}function ce(W){setTimeout(()=>process.exit(W),0)}async function J(W,L,Q){if(W.help){const U=m.default.serverApplicationName+(X.isWindows?".cmd":"");console.log((0,Y.buildHelpMessage)(m.default.nameLong,U,m.default.version,Q,{noInputFiles:!0,noPipe:!0}));return}if(W.version){console.log((0,Y.buildVersionMessage)(m.default.version,m.default.commit));return}const $=new H(W,L);try{await $.run(),ce(0)}catch{ce(1)}finally{$.dispose()}}}),define(ye[326],Ie([1,0,77,337,31,321,4,12,98]),function(se,e,i,r,w,C,R,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0,r=Be(r),w=Be(w);class o{constructor(d,E,a){this._commands=d,this.logService=E,this._ipcHandlePath=a,this._server=r.createServer((f,m)=>this.onRequest(f,m)),this.setup().catch(f=>(E.error(f),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",d=>this.logService.error(d))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(d,E){const a=(m,p)=>{E.writeHead(m,{"content-type":"application/json"}),E.end(JSON.stringify(p||null),S=>S&&this.logService.error(S))},f=[];d.setEncoding("utf8"),d.on("data",m=>f.push(m)),d.on("end",async()=>{try{const m=JSON.parse(f.join(""));let p;switch(m.type){case"open":p=await this.open(m);break;case"openExternal":p=await this.openExternal(m);break;case"status":p=await this.getStatus(m);break;case"extensionManagement":p=await this.manageExtensions(m);break;default:a(404,`Unknown message type: ${m.type}`);break}a(200,p)}catch(m){const p=m instanceof Error?m.message:JSON.stringify(m);a(500,p),this.logService.error("Error while processing pipe request",m)}})}async open(d){const{fileURIs:E,folderURIs:a,forceNewWindow:f,diffMode:m,mergeMode:p,addMode:S,forceReuseWindow:g,gotoLineMode:v,waitMarkerFilePath:t,remoteAuthority:l}=d,n=[];if(Array.isArray(a))for(const u of a)try{n.push({folderUri:R.URI.parse(u)})}catch{}if(Array.isArray(E))for(const u of E)try{(0,b.hasWorkspaceFileExtension)(u)?n.push({workspaceUri:R.URI.parse(u)}):n.push({fileUri:R.URI.parse(u)})}catch{}const h=t?R.URI.file(t):void 0,c={forceNewWindow:f,diffMode:m,mergeMode:p,addMode:S,gotoLineMode:v,forceReuseWindow:g,preferNewWindow:!g&&!h&&!S,waitMarkerFileURI:h,remoteAuthority:l};this._commands.executeCommand("_remoteCLI.windowOpen",n,c)}async openExternal(d){for(const E of d.uris){const a=R.URI.parse(E),f=a.scheme==="file"?a:E;await this._commands.executeCommand("_remoteCLI.openExternal",f)}}async manageExtensions(d){const E=f=>f?.map(m=>/\.vsix$/i.test(m)?R.URI.parse(m):m),a={list:d.list,install:E(d.install),uninstall:E(d.uninstall),force:d.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",a)}async getStatus(d){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&w.existsSync(this._ipcHandlePath)&&w.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=o;let D=class extends o{constructor(d,E){super(d,E,(0,i.createRandomIPCHandle)())}};e.CLIServer=D,e.CLIServer=D=ze([Me(0,C.IExtHostCommands),Me(1,_.ILogService)],D)}),define(ye[327],Ie([1,0,32,6,21,2,9,3,4,77,75,326,135,97,146,305,307,156,14,136]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a,f,m,p,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0,i=Be(i),R=Be(R),_=Be(_),f=Be(f);class v extends m.AbstractVariableResolverService{constructor(n,h,s,c,u){super({getFolderUri:I=>{const T=h.filter(A=>A.name===I);if(T&&T.length>0)return T[0].uri},getWorkspaceFolderCount:()=>h.length,getConfigurationValue:(I,T)=>c[`config:${T}`],getExecPath:()=>n.VSCODE_EXEC_PATH,getAppRoot:()=>n.VSCODE_CWD,getFilePath:()=>{if(s)return R.normalize(s.fsPath)},getSelectedText:()=>c.selectedText,getLineNumber:()=>c.lineNumber,getExtension:async I=>{const A=(await u.getInstalled()).find(O=>O.identifier.id===I);return A&&{extensionLocation:A.location}}},void 0,Promise.resolve(i.homedir()),Promise.resolve(n))}}class t extends C.Disposable{constructor(n,h,s,c,u,I){super(),this._environmentService=n,this._logService=h,this._ptyHostService=s,this._productService=c,this._extensionManagementService=u,this._configurationService=I,this._lastReqId=0,this._pendingCommands=new Map,this._onExecuteCommand=this._register(new r.Emitter),this.onExecuteCommand=this._onExecuteCommand.event}async call(n,h,s){switch(h){case a.RemoteTerminalChannelRequest.RestartPtyHost:return this._ptyHostService.restartPtyHost.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.CreateProcess:{const c=(0,D.createURITransformer)(n.remoteAuthority);return this._createProcess(c,s)}case a.RemoteTerminalChannelRequest.AttachToProcess:return this._ptyHostService.attachToProcess.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.DetachFromProcess:return this._ptyHostService.detachFromProcess.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.ListProcesses:return this._ptyHostService.listProcesses.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.GetLatency:return this._ptyHostService.getLatency.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.GetPerformanceMarks:return this._ptyHostService.getPerformanceMarks.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.OrphanQuestionReply:return this._ptyHostService.orphanQuestionReply.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.AcceptPtyHostResolvedVariables:return this._ptyHostService.acceptPtyHostResolvedVariables.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.Start:return this._ptyHostService.start.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.Input:return this._ptyHostService.input.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.AcknowledgeDataEvent:return this._ptyHostService.acknowledgeDataEvent.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.Shutdown:return this._ptyHostService.shutdown.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.Resize:return this._ptyHostService.resize.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.ClearBuffer:return this._ptyHostService.clearBuffer.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.GetInitialCwd:return this._ptyHostService.getInitialCwd.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.GetCwd:return this._ptyHostService.getCwd.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.ProcessBinary:return this._ptyHostService.processBinary.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.SendCommandResult:return this._sendCommandResult(s[0],s[1],s[2]);case a.RemoteTerminalChannelRequest.InstallAutoReply:return this._ptyHostService.installAutoReply.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.UninstallAllAutoReplies:return this._ptyHostService.uninstallAllAutoReplies.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.GetDefaultSystemShell:return this._getDefaultSystemShell.apply(this,s);case a.RemoteTerminalChannelRequest.GetProfiles:return this._getProfiles.apply(this,s);case a.RemoteTerminalChannelRequest.GetEnvironment:return this._getEnvironment();case a.RemoteTerminalChannelRequest.GetWslPath:return this._getWslPath(s[0],s[1]);case a.RemoteTerminalChannelRequest.GetTerminalLayoutInfo:return this._ptyHostService.getTerminalLayoutInfo(s);case a.RemoteTerminalChannelRequest.SetTerminalLayoutInfo:return this._ptyHostService.setTerminalLayoutInfo(s);case a.RemoteTerminalChannelRequest.SerializeTerminalState:return this._ptyHostService.serializeTerminalState.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.ReviveTerminalProcesses:return this._ptyHostService.reviveTerminalProcesses.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.GetRevivedPtyNewId:return this._ptyHostService.getRevivedPtyNewId.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.SetUnicodeVersion:return this._ptyHostService.setUnicodeVersion.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.ReduceConnectionGraceTime:return this._reduceConnectionGraceTime();case a.RemoteTerminalChannelRequest.UpdateIcon:return this._ptyHostService.updateIcon.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.UpdateTitle:return this._ptyHostService.updateTitle.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.UpdateProperty:return this._ptyHostService.updateProperty.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.RefreshProperty:return this._ptyHostService.refreshProperty.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.RequestDetachInstance:return this._ptyHostService.requestDetachInstance(s[0],s[1]);case a.RemoteTerminalChannelRequest.AcceptDetachedInstance:return this._ptyHostService.acceptDetachInstanceReply(s[0],s[1]);case a.RemoteTerminalChannelRequest.FreePortKillProcess:return this._ptyHostService.freePortKillProcess.apply(this._ptyHostService,s);case a.RemoteTerminalChannelRequest.AcceptDetachInstanceReply:return this._ptyHostService.acceptDetachInstanceReply.apply(this._ptyHostService,s)}throw new Error(`IPC Command ${h} not found`)}listen(n,h,s){switch(h){case a.RemoteTerminalChannelEvent.OnPtyHostExitEvent:return this._ptyHostService.onPtyHostExit||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostStartEvent:return this._ptyHostService.onPtyHostStart||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostUnresponsiveEvent:return this._ptyHostService.onPtyHostUnresponsive||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostResponsiveEvent:return this._ptyHostService.onPtyHostResponsive||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostRequestResolveVariablesEvent:return this._ptyHostService.onPtyHostRequestResolveVariables||r.Event.None;case a.RemoteTerminalChannelEvent.OnProcessDataEvent:return this._ptyHostService.onProcessData;case a.RemoteTerminalChannelEvent.OnProcessReadyEvent:return this._ptyHostService.onProcessReady;case a.RemoteTerminalChannelEvent.OnProcessExitEvent:return this._ptyHostService.onProcessExit;case a.RemoteTerminalChannelEvent.OnProcessReplayEvent:return this._ptyHostService.onProcessReplay;case a.RemoteTerminalChannelEvent.OnProcessOrphanQuestion:return this._ptyHostService.onProcessOrphanQuestion;case a.RemoteTerminalChannelEvent.OnExecuteCommand:return this.onExecuteCommand;case a.RemoteTerminalChannelEvent.OnDidRequestDetach:return this._ptyHostService.onDidRequestDetach||r.Event.None;case a.RemoteTerminalChannelEvent.OnDidChangeProperty:return this._ptyHostService.onDidChangeProperty}throw new Error(`IPC Command ${h} not found`)}async _createProcess(n,h){const s={name:h.shellLaunchConfig.name,executable:h.shellLaunchConfig.executable,args:h.shellLaunchConfig.args,cwd:typeof h.shellLaunchConfig.cwd=="string"||typeof h.shellLaunchConfig.cwd>"u"?h.shellLaunchConfig.cwd:b.URI.revive(n.transformIncoming(h.shellLaunchConfig.cwd)),env:h.shellLaunchConfig.env,useShellEnvironment:h.shellLaunchConfig.useShellEnvironment,reconnectionProperties:h.shellLaunchConfig.reconnectionProperties,type:h.shellLaunchConfig.type,isFeatureTerminal:h.shellLaunchConfig.isFeatureTerminal},c=await(0,p.buildUserEnvironment)(h.resolverEnv,!!h.shellLaunchConfig.useShellEnvironment,_.language,this._environmentService,this._logService,this._configurationService);this._logService.trace("baseEnv",c);const u=K=>({uri:b.URI.revive(n.transformIncoming(K.uri)),name:K.name,index:K.index,toResource:()=>{throw new Error("Not implemented")}}),I=h.workspaceFolders.map(u),T=h.activeWorkspaceFolder?u(h.activeWorkspaceFolder):void 0,A=h.activeFileResource?b.URI.revive(n.transformIncoming(h.activeFileResource)):void 0,O=new v(c,I,A,h.resolvedVariables,this._extensionManagementService),k=f.createVariableResolver(T,process.env,O),P=await f.getCwd(s,i.homedir(),k,T?.uri,h.configuration["terminal.integrated.cwd"],this._logService);s.cwd=P;const B=_.isWindows?"terminal.integrated.env.windows":_.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",Y=h.configuration[B],X=await f.createTerminalEnvironment(s,Y,k,this._productService.version,h.configuration["terminal.integrated.detectLocale"],c);if((0,g.shouldUseEnvironmentVariableCollection)(s)){const K=[];for(const[ne,le,ve]of h.envVariableCollections)K.push([ne,{map:(0,E.deserializeEnvironmentVariableCollection)(le),descriptionMap:(0,E.deserializeEnvironmentDescriptionMap)(ve)}]);const ae=new Map(K),x=new d.MergedEnvironmentVariableCollection(ae),z=T?T??void 0:void 0;await x.applyToProcessEnvironment(X,{workspaceFolder:z},k)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:s,initialCwd:P,cols:h.cols,rows:h.rows,env:X});const re=(0,o.createRandomIPCHandle)();X.VSCODE_IPC_HOOK_CLI=re;const te=await this._ptyHostService.createProcess(s,P,h.cols,h.rows,h.unicodeVersion,X,c,h.options,h.shouldPersistTerminal,h.workspaceId,h.workspaceName),Z={executeCommand:(K,...ae)=>this._executeCommand(te,K,ae,n)},fe=new y.CLIServerBase(Z,this._logService,re);return this._ptyHostService.onProcessExit(K=>K.id===te&&fe.dispose()),{persistentTerminalId:te,resolvedShellLaunchConfig:s}}_executeCommand(n,h,s,c){const{resolve:u,reject:I,promise:T}=(0,S.promiseWithResolvers)(),A=++this._lastReqId;this._pendingCommands.set(A,{resolve:u,reject:I,uriTransformer:c});const O=(0,w.cloneAndChange)(s,k=>{if(k&&k.$mid===1)return c.transformOutgoing(k);if(k&&k instanceof b.URI)return c.transformOutgoingURI(k)});return this._onExecuteCommand.fire({reqId:A,persistentProcessId:n,commandId:h,commandArgs:O}),T}_sendCommandResult(n,h,s){const c=this._pendingCommands.get(n);if(!c)return;this._pendingCommands.delete(n);const u=(0,w.cloneAndChange)(s,I=>{if(I&&I.$mid===1)return c.uriTransformer.transformIncoming(I)});h?c.reject(u):c.resolve(u)}_getDefaultSystemShell(n){return this._ptyHostService.getDefaultSystemShell(n)}async _getProfiles(n,h,s,c){return this._ptyHostService.getProfiles(n,h,s,c)||[]}_getEnvironment(){return{...process.env}}_getWslPath(n,h){return this._ptyHostService.getWslPath(n,h)}_reduceConnectionGraceTime(){return this._ptyHostService.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=t});var gt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ye[328],Ie([1,0,32,6,2,13,9,112,25,51,61,27,129,241,88,242,28,141,30,95,132,266,139,16,123,72,71,122,89,92,133,12,62,29,47,269,155,131,24,41,281,53,288,36,137,299,300,275,279,327,75,55,309,322,143,64,145,54,34,73,280,126,142,140,125,124,231,317,265,293,285]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a,f,m,p,S,g,v,t,l,n,h,s,c,u,I,T,A,O,k,P,B,Y,X,re,te,Z,fe,K,ae,x,z,ne,le,ve,H,ce,J,W,L,Q,$,U,q,G,F,V,oe,de,Ce,Ne,ge,pe,Te,Le,he,De,Re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=void 0,e.setupServerServices=Ve,R=Be(R),k=gt(k),fe=gt(fe);const xe="monacoworkbench";async function Ve(it,tt,et,Qe){const Ee=new I.ServiceCollection,Oe=new qe,Fe={_serviceBrand:void 0,...k.default};Ee.set(P.IProductService,Fe);const be=new W.ServerEnvironmentService(tt,Fe);Ee.set(m.IEnvironmentService,be),Ee.set(m.INativeEnvironmentService,be);const Ae=new de.LoggerService((0,O.getLogLevel)(be),be.logsHome);Ee.set(O.ILoggerService,Ae),Oe.registerChannel("logger",new pe.LoggerChannel(Ae,dt=>je(dt.remoteAuthority)));const ie=Ae.createLogger("remoteagent",{name:(0,Te.localize)(0,null)}),ee=new ge.LogService(ie,[new Je((0,O.getLogLevel)(be))]);Ee.set(O.ILogService,ee),setTimeout(()=>rt(be.logsHome.with({scheme:C.Schemas.file}).fsPath).then(null,dt=>ee.error(dt)),1e4),ee.onDidChangeLogLevel(dt=>(0,O.log)(ee,dt,`Log level changed to ${(0,O.LogLevelToString)(ee.getLevel())}`)),ee.trace(`Remote configuration data at ${et}`),ee.trace("process arguments:",be.args),Array.isArray(Fe.serverGreeting)&&ee.info(`

${Fe.serverGreeting.join(`
`)}

`),Oe.registerChannel(E.ExtensionHostDebugBroadcastChannel.ChannelName,new E.ExtensionHostDebugBroadcastChannel);const Se=new o.StaticRouter(dt=>dt.clientId==="renderer"),He=Qe.add(new h.FileService(ee));Ee.set(n.IFileService,He),He.registerProvider(C.Schemas.file,Qe.add(new s.DiskFileSystemProvider(ee)));const Ge=new z.UriIdentityService(He);Ee.set(x.IUriIdentityService,Ge);const Ze=new d.ConfigurationService(be.machineSettingsResource,He,new V.NullPolicyService,ee);Ee.set(y.IConfigurationService,Ze);const nt=new Ce.ServerUserDataProfilesService(Ge,be,He,ee);Ee.set(F.IUserDataProfilesService,nt),Oe.registerChannel("userDataProfiles",new De.RemoteUserDataProfilesServiceChannel(nt,dt=>je(dt.remoteAuthority)));const[,,ut,mt,Et]=await Promise.all([Ze.initialize(),nt.init(),(0,_.getMachineId)(ee.error.bind(ee)),(0,_.getSqmMachineId)(ee.error.bind(ee)),(0,_.getdevDeviceId)(ee.error.bind(ee))]),Ut=new $.ExtensionHostStatusService;Ee.set($.IExtensionHostStatusService,Ut);const _t=new X.RequestService(Ze,be,ee,Ae);Ee.set(B.IRequestService,_t);let ht=Z.NullAppender;const St=(0,Z.isInternalTelemetry)(Fe,Ze);if((0,Z.supportsTelemetry)(Fe,be)){!(0,Z.isLoggingOnly)(Fe,be)&&Fe.aiConfig?.ariaKey&&(ht=new oe.OneDataSystemAppender(_t,St,xe,null,Fe.aiConfig.ariaKey),Qe.add((0,w.toDisposable)(()=>ht?.flush())));const dt={appenders:[ht],commonProperties:(0,re.resolveCommonProperties)((0,i.release)(),(0,i.hostname)(),process.arch,Fe.commit,Fe.version+"-remote",ut,mt,Et,St,"remoteAgent"),piiPaths:(0,Z.getPiiPathsFromEnvironment)(be)},vt=be.args["telemetry-level"];let yt=te.TelemetryLevel.USAGE;vt==="all"?yt=te.TelemetryLevel.USAGE:vt==="error"?yt=te.TelemetryLevel.ERROR:vt==="crash"?yt=te.TelemetryLevel.CRASH:vt!==void 0&&(yt=te.TelemetryLevel.NONE),Ee.set(H.IServerTelemetryService,new c.SyncDescriptor(H.ServerTelemetryService,[dt,yt]))}else Ee.set(H.IServerTelemetryService,H.ServerNullTelemetryService);Ee.set(S.IExtensionGalleryService,new c.SyncDescriptor(p.ExtensionGalleryServiceWithNoStorageService));const wt=Oe.getChannel("download",Se);Ee.set(a.IDownloadService,new f.DownloadServiceChannelClient(wt,()=>je("renderer"))),Ee.set(G.IExtensionsProfileScannerService,new c.SyncDescriptor(Ne.ExtensionsProfileScannerService)),Ee.set(U.IExtensionsScannerService,new c.SyncDescriptor(q.ExtensionsScannerService)),Ee.set(g.IExtensionSignatureVerificationService,new c.SyncDescriptor(g.ExtensionSignatureVerificationService)),Ee.set(l.INativeServerExtensionManagementService,new c.SyncDescriptor(l.ExtensionManagementService));const Ct=new u.InstantiationService(Ee);Ee.set(T.ILanguagePackService,Ct.createInstance(A.NativeLanguagePackService));const Kt=Ct.createInstance(Re.NodePtyHostStarter,{graceTime:D.ProtocolConstants.ReconnectionGraceTime,shortGraceTime:D.ProtocolConstants.ReconnectionShortGraceTime,scrollback:Ze.getValue(K.TerminalSettingId.PersistentSessionScrollback)??100}),Lt=Ct.createInstance(ae.PtyHostService,Kt);return Ee.set(K.IPtyService,Lt),Ct.invokeFunction(dt=>{const vt=dt.get(l.INativeServerExtensionManagementService),yt=dt.get(U.IExtensionsScannerService),Pt=dt.get(S.IExtensionGalleryService),xt=dt.get(T.ILanguagePackService),At=new ne.RemoteAgentEnvironmentChannel(it,be,nt,Ut);Oe.registerChannel("remoteextensionsenvironment",At);const Zt=new ve.ServerTelemetryChannel(dt.get(H.IServerTelemetryService),ht);Oe.registerChannel("telemetry",Zt),Oe.registerChannel(L.REMOTE_TERMINAL_CHANNEL_NAME,new ce.RemoteTerminalChannel(be,ee,Lt,Fe,vt,Ze));const Tt=new Le.RemoteExtensionsScannerService(Ct.createInstance(v.ExtensionManagementCLI,ee),be,nt,yt,ee,Pt,xt);Oe.registerChannel(he.RemoteExtensionsScannerChannelName,new Le.RemoteExtensionsScannerChannel(Tt,Nt=>je(Nt.remoteAuthority)));const Ot=Qe.add(new le.RemoteAgentFileSystemProviderChannel(ee,be));Oe.registerChannel(Q.REMOTE_FILE_SYSTEM_CHANNEL_NAME,Ot),Oe.registerChannel("request",new Y.RequestChannel(dt.get(B.IRequestService)));const zt=new t.ExtensionManagementChannel(vt,Nt=>je(Nt.remoteAuthority));return Oe.registerChannel("extensions",zt),Tt.whenExtensionsReady().then(()=>vt.cleanUp()),Qe.add(new fe.default(dt.get(te.ITelemetryService))),{telemetryService:dt.get(te.ITelemetryService)}}),{socketServer:Oe,instantiationService:Ct}}const Xe=Object.create(null);function je(it){return Xe[it]||(Xe[it]=(0,J.createURITransformer)(it)),Xe[it]}class qe extends o.IPCServer{constructor(){const tt=new r.Emitter;super(tt.event),this._onDidConnectEmitter=tt}acceptConnection(tt,et){this._onDidConnectEmitter.fire({protocol:tt,onDidClientDisconnect:et})}}e.SocketServer=qe;class Je extends O.AbstractLogger{constructor(tt=O.DEFAULT_LOG_LEVEL){super(),this.setLevel(tt),this.useColors=!!process.stdout.isTTY}trace(tt,...et){this.checkLogLevel(O.LogLevel.Trace)&&(this.useColors?console.log(`\x1B[90m[${st()}]\x1B[0m`,tt,...et):console.log(`[${st()}]`,tt,...et))}debug(tt,...et){this.checkLogLevel(O.LogLevel.Debug)&&(this.useColors?console.log(`\x1B[90m[${st()}]\x1B[0m`,tt,...et):console.log(`[${st()}]`,tt,...et))}info(tt,...et){this.checkLogLevel(O.LogLevel.Info)&&(this.useColors?console.log(`\x1B[90m[${st()}]\x1B[0m`,tt,...et):console.log(`[${st()}]`,tt,...et))}warn(tt,...et){this.checkLogLevel(O.LogLevel.Warning)&&(this.useColors?console.warn(`\x1B[93m[${st()}]\x1B[0m`,tt,...et):console.warn(`[${st()}]`,tt,...et))}error(tt,...et){this.checkLogLevel(O.LogLevel.Error)&&(this.useColors?console.error(`\x1B[91m[${st()}]\x1B[0m`,tt,...et):console.error(`[${st()}]`,tt,...et))}flush(){}}function st(){const it=new Date;return`${lt(it.getHours())}:${lt(it.getMinutes())}:${lt(it.getSeconds())}`}function lt(it){return it<10?`0${it}`:String(it)}async function rt(it){const tt=R.basename(it),et=R.dirname(it),Oe=(await b.Promises.readdir(et)).filter(be=>/^\d{8}T\d{6}$/.test(be)).sort().filter(be=>be!==tt),Fe=Oe.slice(0,Math.max(0,Oe.length-9));await Promise.all(Fe.map(be=>b.Promises.rm(R.join(et,be))))}}),define(ye[329],Ie([1,0,96,31,84,330,93,104,15,35,10,37,2,13,9,44,3,17,4,23,195,178,325,61,77,27,5,12,29,264,24,156,294,101,55,328,296]),function(se,e,i,r,w,C,R,_,b,o,D,y,d,E,a,f,m,p,S,g,v,t,l,n,h,s,c,u,I,T,A,O,k,P,B,Y,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=Z,i=Be(i),r=Be(r),w=Be(w),R=Be(R),f=Be(f),m=Be(m);const re=5*60*1e3;let te=class extends d.Disposable{constructor(ae,x,z,ne,le,ve,H,ce,J){super(),this._socketServer=ae,this._connectionToken=x,this._vsdaMod=z,this._environmentService=ve,this._productService=H,this._logService=ce,this._instantiationService=J,this._webEndpointOriginChecker=fe.create(this._productService),this._serverRootPath=(0,E.getServerRootPath)(H,le),this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),this._allReconnectionTokens=new Set,this._webClientServer=ne?this._instantiationService.createInstance(X.WebClientServer,this._connectionToken,le??"/",this._serverRootPath):null,this._logService.info("Extension host agent started."),this._waitThenShutdown(!0)}async handleRequest(ae,x){if(ae.method!=="GET")return(0,X.serveError)(ae,x,405,`Unsupported method ${ae.method}`);if(!ae.url)return(0,X.serveError)(ae,x,400,"Bad request.");const z=R.parse(ae.url,!0);let ne=z.pathname;if(!ne)return(0,X.serveError)(ae,x,400,"Bad request.");if(ne.startsWith(this._serverRootPath)&&ne.charCodeAt(this._serverRootPath.length)===o.CharCode.Slash&&(ne=ne.substring(this._serverRootPath.length)),ne==="/version")return x.writeHead(200,{"Content-Type":"text/plain"}),void x.end(this._productService.commit||"");if(ne==="/delay-shutdown")return this._delayShutdown(),x.writeHead(200),void x.end("OK");if(!(0,P.requestHasValidConnectionToken)(this._connectionToken,ae,z))return(0,X.serveError)(ae,x,403,"Forbidden.");if(ne==="/vscode-remote-resource"){const le=z.query.path;if(typeof le!="string")return(0,X.serveError)(ae,x,400,"Bad request.");let ve;try{ve=S.URI.from({scheme:E.Schemas.file,path:le}).fsPath}catch{return(0,X.serveError)(ae,x,400,"Bad request.")}const H=Object.create(null);this._environmentService.isBuilt&&((0,y.isEqualOrParent)(ve,this._environmentService.builtinExtensionsPath,!m.isLinux)||(0,y.isEqualOrParent)(ve,this._environmentService.extensionsPath,!m.isLinux))&&(H["Cache-Control"]="public, max-age=31536000"),H.Vary="Origin";const ce=ae.headers.origin;return ce&&this._webEndpointOriginChecker.matches(ce)&&(H["Access-Control-Allow-Origin"]=ce),(0,X.serveFile)(ve,X.CacheControl.ETAG,this._logService,ae,x,H)}if(this._webClientServer){this._webClientServer.handle(ae,x,z);return}return x.writeHead(404,{"Content-Type":"text/plain"}),void x.end("Not found")}handleUpgrade(ae,x){let z=(0,g.generateUuid)(),ne=!1,le=!1;if(ae.url){const L=R.parse(ae.url,!0).query;typeof L.reconnectionToken=="string"&&(z=L.reconnectionToken),L.reconnection==="true"&&(ne=!0),L.skipWebSocketFrames==="true"&&(le=!0)}if(ae.headers.upgrade===void 0||ae.headers.upgrade.toLowerCase()!=="websocket"){x.end("HTTP/1.1 400 Bad Request");return}const ve=ae.headers["sec-websocket-key"],H=i.createHash("sha1");H.update(ve+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const J=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${H.digest("base64")}`];let W=!1;if(!le&&!this._environmentService.args["disable-websocket-compression"]&&ae.headers["sec-websocket-extensions"]){const L=Array.isArray(ae.headers["sec-websocket-extensions"])?ae.headers["sec-websocket-extensions"]:[ae.headers["sec-websocket-extensions"]];for(const Q of L)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(Q)){if(/\b(permessage-deflate)\b/.test(Q)){W=!0,J.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(Q)){W=!0,J.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}x.write(J.join(`\r
`)+`\r
\r
`),x.setTimeout(0),x.setNoDelay(!0),le?this._handleWebSocketConnection(new h.NodeSocket(x,`server-connection-${z}`),ne,z):this._handleWebSocketConnection(new h.WebSocketNodeSocket(new h.NodeSocket(x,`server-connection-${z}`),W,null,!0),ne,z)}handleServerError(ae){this._logService.error("Error occurred in server"),this._logService.error(ae)}_getRemoteAddress(ae){let x;return ae instanceof h.NodeSocket?x=ae.socket:x=ae.socket.socket,x.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(ae,x,z){const ne=x.getSocket();this._logService.error(`${ae} ${z}.`);const le={type:"error",reason:z};x.sendControl(b.VSBuffer.fromString(JSON.stringify(le))),x.dispose(),await ne.drain(),ne.dispose()}_handleWebSocketConnection(ae,x,z){const ne=this._getRemoteAddress(ae),le=`[${ne}][${z.substr(0,8)}]`,ve=new n.PersistentProtocol({socket:ae}),H=this._vsdaMod?new this._vsdaMod.validator:null,ce=this._vsdaMod?new this._vsdaMod.signer:null;let J;(function($){$[$.WaitingForAuth=0]="WaitingForAuth",$[$.WaitingForConnectionType=1]="WaitingForConnectionType",$[$.Done=2]="Done",$[$.Error=3]="Error"})(J||(J={}));let W=J.WaitingForAuth;const L=$=>{W=J.Error,Q.dispose(),this._rejectWebSocketConnection(le,ve,$)},Q=ve.onControlMessage($=>{if(W===J.WaitingForAuth){let U;try{U=JSON.parse($.toString())}catch{return L("Malformed first message")}if(U.type!=="auth")return L("Invalid first message");if(this._connectionToken.type===P.ServerConnectionTokenType.Mandatory&&!this._connectionToken.validate(U.auth))return L("Unauthorized client refused: auth mismatch");let q=(0,g.generateUuid)();if(ce)try{q=ce.sign(U.data)}catch{}let G=(0,g.generateUuid)();if(H)try{G=H.createNewMessage(G)}catch{}const F={type:"sign",data:G,signedData:q};ve.sendControl(b.VSBuffer.fromString(JSON.stringify(F))),W=J.WaitingForConnectionType}else if(W===J.WaitingForConnectionType){let U;try{U=JSON.parse($.toString())}catch{return L("Malformed second message")}if(U.type!=="connectionType")return L("Invalid second message");if(typeof U.signedData!="string")return L("Invalid second message field type");const q=U.commit,G=this._productService.commit;if(q&&G&&q!==G)return L("Client refused: version mismatch");let F=!1;if(!H)F=!0;else if(this._connectionToken.validate(U.signedData))F=!0;else try{F=H.validate(U.signedData)==="ok"}catch{}if(!F){if(this._environmentService.isBuilt)return L("Unauthorized client refused");this._logService.error(`${le} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const V in this._managementConnections)this._managementConnections[V].shortenReconnectionGraceTimeIfNecessary();for(const V in this._extHostConnections)this._extHostConnections[V].shortenReconnectionGraceTimeIfNecessary();W=J.Done,Q.dispose(),this._handleConnectionType(ne,le,ve,ae,x,z,U)}})}async _handleConnectionType(ae,x,z,ne,le,ve,H){const ce=H.desiredConnectionType===T.ConnectionType.Management?`${x}[ManagementConnection]`:H.desiredConnectionType===T.ConnectionType.ExtensionHost?`${x}[ExtensionHostConnection]`:x;if(H.desiredConnectionType===T.ConnectionType.Management)if(le){if(!this._managementConnections[ve])return this._allReconnectionTokens.has(ve)?this._rejectWebSocketConnection(ce,z,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(ce,z,"Unknown reconnection token (never seen)");z.sendControl(b.VSBuffer.fromString(JSON.stringify({type:"ok"})));const J=z.readEntireBuffer();z.dispose(),this._managementConnections[ve].acceptReconnection(ae,ne,J)}else{if(this._managementConnections[ve])return this._rejectWebSocketConnection(ce,z,"Duplicate reconnection token");z.sendControl(b.VSBuffer.fromString(JSON.stringify({type:"ok"})));const J=new k.ManagementConnection(this._logService,ve,ae,z);this._socketServer.acceptConnection(J.protocol,J.onClose),this._managementConnections[ve]=J,this._allReconnectionTokens.add(ve),J.onClose(()=>{delete this._managementConnections[ve]})}else if(H.desiredConnectionType===T.ConnectionType.ExtensionHost){const J=H.args||{language:"en"},W=await this._updateWithFreeDebugPort(J);if(W.port&&this._logService.trace(`${ce} - startParams debug port ${W.port}`),this._logService.trace(`${ce} - startParams language: ${W.language}`),this._logService.trace(`${ce} - startParams env: ${JSON.stringify(W.env)}`),le){if(!this._extHostConnections[ve])return this._allReconnectionTokens.has(ve)?this._rejectWebSocketConnection(ce,z,"Unknown reconnection token (seen before)"):this._rejectWebSocketConnection(ce,z,"Unknown reconnection token (never seen)");z.sendPause(),z.sendControl(b.VSBuffer.fromString(JSON.stringify(W.port?{debugPort:W.port}:{})));const L=z.readEntireBuffer();z.dispose(),this._extHostConnections[ve].acceptReconnection(ae,ne,L)}else{if(this._extHostConnections[ve])return this._rejectWebSocketConnection(ce,z,"Duplicate reconnection token");z.sendPause(),z.sendControl(b.VSBuffer.fromString(JSON.stringify(W.port?{debugPort:W.port}:{})));const L=z.readEntireBuffer();z.dispose();const Q=this._instantiationService.createInstance(O.ExtensionHostConnection,ve,ae,ne,L);this._extHostConnections[ve]=Q,this._allReconnectionTokens.add(ve),Q.onClose(()=>{Q.dispose(),delete this._extHostConnections[ve],this._onDidCloseExtHostConnection()}),Q.start(W)}}else if(H.desiredConnectionType===T.ConnectionType.Tunnel){const J=H.args;this._createTunnel(z,J)}else return this._rejectWebSocketConnection(ce,z,"Unknown initial data received")}async _createTunnel(ae,x){const z=ae.getSocket().socket,ne=ae.readEntireBuffer();ae.dispose(),z.pause();const le=await this._connectTunnelSocket(x.host,x.port);ne.byteLength>0&&le.write(ne.buffer),le.on("end",()=>z.end()),le.on("close",()=>z.end()),le.on("error",()=>z.destroy()),z.on("end",()=>le.end()),z.on("close",()=>le.end()),z.on("error",()=>le.destroy()),le.pipe(z),z.pipe(le)}_connectTunnelSocket(ae,x){return new Promise((z,ne)=>{const le=w.createConnection({host:ae,port:x,autoSelectFamily:!0},()=>{le.removeListener("error",ne),le.pause(),z(le)});le.once("error",ne)})}_updateWithFreeDebugPort(ae){return typeof ae.port=="number"?(0,t.findFreePort)(ae.port,10,5e3).then(x=>(ae.port=x,ae)):(ae.debugId=void 0,ae.port=void 0,ae.break=void 0,Promise.resolve(ae))}async _onDidCloseExtHostConnection(){if(!this._environmentService.args["enable-remote-auto-shutdown"])return;this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown())}_waitThenShutdown(ae=!1){this._environmentService.args["enable-remote-auto-shutdown"]&&(this._environmentService.args["remote-auto-shutdown-without-delay"]&&!ae?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},re))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}};te=ze([Me(5,B.IServerEnvironmentService),Me(6,I.IProductService),Me(7,u.ILogService),Me(8,c.IInstantiationService)],te);async function Z(K,ae,x){const z=await(0,P.determineServerConnectionToken)(ae);z instanceof P.ServerConnectionTokenParseError&&(console.warn(z.message),process.exit(1));function ne(V){(0,D.setUnexpectedErrorHandler)(oe=>{(0,D.isSigPipeError)(oe)&&oe.stack&&/unexpectedErrorHandler/.test(oe.stack)||V(oe)})}const le=[];ne(V=>{le.push(V),console.error(V)});let ve=!1;process.on("SIGPIPE",()=>{ve||(ve=!0,(0,D.onUnexpectedError)(new Error("Unexpected SIGPIPE")))});const H=new d.DisposableStore,{socketServer:ce,instantiationService:J}=await(0,Y.setupServerServices)(z,ae,x,H);J.invokeFunction(V=>{const oe=V.get(u.ILogService);le.forEach(de=>oe.error(de)),le.length=0,ne(de=>oe.error(de))}),J.invokeFunction(V=>{const oe=V.get(s.IConfigurationService);m.isWindows&&(oe.getValue("security.restrictUNCAccess")===!1?(0,l.disableUNCAccessRestrictions)():(0,l.addUNCHostToAllowlist)(oe.getValue("security.allowedUNCHosts")))}),J.invokeFunction(V=>{const oe=V.get(u.ILogService);if(m.isWindows&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const de=(0,a.join)(process.env.HOMEDRIVE,"node_modules"),Ce=(0,a.dirname)((0,a.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),Ne=(0,a.join)(Ce,"node_modules");if(r.existsSync(de)||r.existsSync(Ne)){const ge=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${de}
* ${Ne}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;oe.warn(ge),console.warn(ge),process.exit(0)}}});const W=J.invokeFunction(V=>{const oe=V.get(u.ILogService);if(r.existsSync((0,a.join)(E.FileAccess.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(Ce){oe.error(Ce)}return null});let L=ae["server-base-path"];L&&!L.startsWith("/")&&(L=`/${L}`);const Q=r.existsSync(E.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(Q&&K&&typeof K!="string"){const V=z.type!==P.ServerConnectionTokenType.None?`?${E.connectionTokenQueryName}=${z.value}`:"";console.log(`Web UI available at http://localhost${K.port===80?"":`:${K.port}`}${L??""}${V}`)}const $=J.createInstance(te,ce,z,W,Q,L);f.mark("code/server/ready");const U=C.performance.now(),q=global.vscodeServerStartTime,G=global.vscodeServerListenTime,F=global.vscodeServerCodeLoadedTime;if(J.invokeFunction(async V=>{const oe=V.get(A.ITelemetryService);if(oe.publicLog2("serverStart",{startTime:q,startedTime:G,codeLoadedTime:F,readyTime:U}),m.isLinux){const de=V.get(u.ILogService),Ce=await(0,v.getOSReleaseInfo)(de.error.bind(de));Ce&&oe.publicLog2("serverPlatformInfo",{platformId:Ce.id,platformVersionId:Ce.version_id,platformIdLike:Ce.id_like})}}),ae["print-startup-performance"]){const V=_.LoaderStats.get();let oe="";oe+=`

### Load AMD-module
`,oe+=_.LoaderStats.toMarkdownTable(["Module","Duration"],V.amdLoad),oe+=`

### Load commonjs-module
`,oe+=_.LoaderStats.toMarkdownTable(["Module","Duration"],V.nodeRequire),oe+=`

### Invoke AMD-module factory
`,oe+=_.LoaderStats.toMarkdownTable(["Module","Duration"],V.amdInvoke),oe+=`

### Invoke commonjs-module
`,oe+=_.LoaderStats.toMarkdownTable(["Module","Duration"],V.nodeEval),oe+=`Start-up time: ${G-q}
`,oe+=`Code loading time: ${F-q}
`,oe+=`Initialized time: ${U-q}
`,oe+=`
`,console.log(oe)}return $}class fe{static create(ae){const x=ae.webEndpointUrlTemplate,z=ae.commit,ne=ae.quality;if(!x||!z||!ne)return new fe(null);const le=(0,g.generateUuid)(),H=new URL(x.replace("{{uuid}}",le).replace("{{commit}}",z).replace("{{quality}}",ne)).origin,ce=(0,p.escapeRegExpCharacters)(H).replace(le,"[a-zA-Z0-9\\-]+");try{const J=(0,p.createRegExp)(`^${ce}$`,!0,{matchCase:!1});return new fe(J)}catch{return new fe(null)}}constructor(ae){this._originRegExp=ae}matches(ae){return this._originRegExp?this._originRegExp.test(ae):!1}}});var gt=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(ye[338],Ie([1,0,32,31,13,324,329,70,9,330,55,62,44]),function(se,e,i,r,w,C,R,_,b,o,D,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spawnCli=n,e.createServer=h,i=Be(i),r=Be(r),y=gt(y),d=Be(d),d.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=o.performance.now();const E={onMultipleValues:(s,c)=>{console.error(`Option '${s}' can only be defined once. Using value ${c}.`)},onEmptyValue:s=>{console.error(`Ignoring option '${s}': Value must not be empty.`)},onUnknownOption:s=>{console.error(`Ignoring option '${s}': not supported for server.`)},onDeprecatedOption:(s,c)=>{console.warn(`Option '${s}' is deprecated: ${c}`)}},a=(0,_.parseArgs)(process.argv.slice(2),D.serverOptions,E),f=a["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,b.join)(i.homedir(),y.default.serverDataFolderName||".vscode-remote"),m=(0,b.join)(f,"data"),p=(0,b.join)(m,"User"),S=(0,b.join)(p,"globalStorage"),g=(0,b.join)(p,"History"),v=(0,b.join)(m,"Machine");a["user-data-dir"]=m;const t=(0,b.dirname)(w.FileAccess.asFileUri("").fsPath),l=(0,b.join)(t,"extensions");a["builtin-extensions-dir"]=l,a["extensions-dir"]=a["extensions-dir"]||(0,b.join)(f,"extensions"),[f,a["extensions-dir"],m,p,v,S,g].forEach(s=>{try{r.existsSync(s)||r.mkdirSync(s,{mode:448})}catch(c){console.error(c)}});function n(){(0,C.run)(a,f,D.serverOptions)}function h(s){return(0,R.createServer)(s,a,f)}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/8512cb3341b26a5dba985a9a17eed8d7c3362886/core/vs/server/node/server.main.js.map
